<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.ShipmentLine.inc.php');

	class IncomingShipmentLine extends ShipmentLine {

		
		/**
		*	Set the quantity on this shipment
		*
		*	Overriden from the parent to allow more precision than our stock allows.
		*
		*	@param quantity Quantity ship
		*
		*	@return true
		*/
		public function set_quantity_shipped($quantity) {
			if($this->shippable_item && method_exists($this->shippable_item, 'get_supplier_stock_code') &&  
					method_exists($this->shippable_item, 'get_stock_id') && $this->shippable_item->get_stock_id()) {

				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $this->shippable_item->get_stock_id());
				$supplier_item = ExecMethod2('perp_ap.bo_perp_catalog.get_catalog_item', $this->shipment->get_supplier_id(), $this->shippable_item->get_supplier_stock_code());
				$quantity = round($quantity, $stock['decimal_places'] + strlen(ceil($supplier_item['conversion_factor'])));
			}
			$this->quantity_shipped = $quantity;
			return true;
		}
	}
?>
