<?php
	/**
	*	@brief A single entry on an invoice
	*	
	*	InvoiceLine encapsulates a single line or amount on an Invoice.  It is
	*	used for charges, discounts and taxes.
	*	@note Every InvoiceLine must have a quantity.  If the line is for something like
	*	a discount or tax, the quantity is probably 1.
	*	@note Every InvoiceLine needs a General Ledger account.  
	*	@author Nathan Gray
	*/

	require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.InvoiceLine.inc.php');

	class PayableInvoiceLine extends InvoiceLine {
		
		/**
		*	Get the entire amount of this line.  Line price is calculated
		*	as unit_price * quantity.
		*	@return float Line price
		*/
		public function get_line_price() {
			return bcmul($this->unit_price, $this->quantity, 2);
		}
	}
?>
