<?php
	/**
	*	Hooks for eGroupWare
	*	The hooks allow pERP to participate closely in most of eGroupWare's wonderful functions
	*	@ingroup perp_ap
	*/
	class hook_perp_ap {
		/**
		*	List of public functions that phpgwapi allows to be
		*	called from the browser.  All other functions are denied.
		*/
		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
		);

		/**
		*	Name of this application
		*/
		var $appname = 'perp_ap';

		/**
		*	eTemplate object for display
		*/
		var $template;

		/**
		*	Accounts Payable logic object, bo_perp_ap
		*/
		var $bo;

		/**
		*	perp_api::ui_perp_api
		*/
		var $erp;

		/**
		*	Constructor
		*/
		public function hook_perp_ap() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_ap.bo_perp_ap');
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file = array(
				'Site configuration'	=> $GLOBALS['phpgw']->link('/index.php', array(
					'menuaction'	=> 'perp_ap.hook_perp_ap.config',
				))
			);
			if($GLOBALS['egw']->acl->check('acl', EGW_ACL_READ, 'perp_ap')) {
				$file['Configure Access Permissions']	=	$GLOBALS['phpgw']->link('/index.php', array(
					'menuaction'	=> 'perp_ap.hook_perp_ap.acl',
				));
			}

			display_section($this->appname, $file);
		}

		/**
		*	Add an entry in preferences list for Accounts Payable
		*/
		public function preference_menu() {
			$file = array(
				'Preferences'	=>	 $GLOBALS['egw']->link(
					'/index.php',
					'menuaction=preferences.uisettings.index&appname='.$this->appname
				)
			);

			//Do not modify below this line
			display_section($this->appname,$file);
		}

		public function user_preferences() {
		}

		/**
		*	Add sidebox links
		*/
		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			if($GLOBALS['egw']->acl->check('supplier', EGW_ACL_READ, 'perp_ap')) {
				$menu['Suppliers']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_supplier.supplier_list');
			}
			if($GLOBALS['egw']->acl->check('order', EGW_ACL_READ, 'perp_ap')) {
				$menu['Purchase Orders'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_purchase_order.order_list');
			}
			if($GLOBALS['egw']->acl->check('shipment', EGW_ACL_READ, 'perp_ap')) {
				$menu['Shipments'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_incoming_shipment.shipment_list');
			}
			if($GLOBALS['egw']->acl->check('invoice', EGW_ACL_READ, 'perp_ap')) {
				$menu['Invoices'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_payable_invoice.invoice_list');
			}
			if($GLOBALS['egw']->acl->check('payment', EGW_ACL_READ, 'perp_ap')) {
				$menu['Payments'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_payment.payment_list');
			}

			display_sidebox($this->appname, $menu_title, $menu);

			$menu_title = lang('Actions');
			$menu = array();
						
			if($GLOBALS['egw']->acl->check('order', EGW_ACL_ADD, 'perp_ap')) {
				$menu['New Purchase Order'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_purchase_order.new_order');
			}
			if($GLOBALS['egw']->acl->check('shipment', EGW_ACL_ADD, 'perp_ap')) {
				$menu['New Shipment'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_incoming_shipment.new_shipment');
			}
			if($GLOBALS['egw']->acl->check('receive', EGW_ACL_CUSTOM_1, 'perp_ap')) {
				$menu['Resolve Shipment'] = $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=>	'perp_ap.ui_perp_receive.resolve'
				));
			}
			if($GLOBALS['egw']->acl->check('invoice', EGW_ACL_ADD, 'perp_ap')) {
				$menu['New Invoice'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_payable_invoice.new_invoice');
			}
			if($GLOBALS['egw']->acl->check('payment', EGW_ACL_ADD, 'perp_ap')) {
				$menu['New Payment'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_payment.payment_new');
			}
			if($GLOBALS['egw']->acl->check('receive', EGW_ACL_EDIT, 'perp_ap')) {
				$menu['Receive'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ap.ui_perp_receive.receive_new');
			}
			
			display_sidebox($this->appname, $menu_title, $menu);
		}

		/**
		*	Side wide Accounts Payable configuration
		*	@param  content - The returned content of the form or empty array
		*/
		public function config($content = array()) {
			$config = config::read($this->appname);
		
			if(isset($content['save'])) {
				if(is_array($_POST['exec']['settings']['set_payment_data'])) {
					$same_as = array();
					foreach($_POST['exec']['settings']['set_payment_data'] as $key => &$row) {
						if($row['same_as']) {
							$same_as[$row['payment_method_id']] = $row['same_as'];
						}
						if($row['payment_method_id']) {
							$payments[$row['payment_method_id']] = $row;
						}
					}
					unset($content['settings']['set_payment_data']);
				}
				if(is_array($same_as)) {
					foreach($same_as as $key => $value) {
						$payments[$key] = $payments[$value];
						$payments[$key]['payment_method_id'] = $key;
						$payments[$key]['same_as'] = $value;
					}
				}
				config::save_value('payments', $payments, 'perp_ap');
				$config = config::read($this->appname);
			}

			// Check bill to address permission
			if($config['default_bill_to']) {
				if(is_null($config['default_bill_to'])) {
					$data['message'] .= lang('Default Bill To address is not set.');
				} else {
					$address = ExecMethod('addressbook.addressbook_so.read', $config['default_bill_to']);
					if(is_array($address) && $address['owner'] > 0) {
						$data['message'] .= lang('The default Bill To address is owned by %1.  It should be owned by a group, not an individual.  You should get %1 to edit the address, and change the Addressbook field.',
							$GLOBALS['egw']->common->display_fullname(
							$GLOBALS['egw']->accounts->id2name($address['owner'], 'account_lid'),
							$GLOBALS['egw']->accounts->id2name($address['owner'], 'account_firstname'),
							$GLOBALS['egw']->accounts->id2name($address['owner'], 'account_lastname')
						));
					}
				}
			}

			// Make sure payments are there
			$payment_methods = ExecMethod('perp_api.bo_perp_api.get_payment_methods');
			$config_methods = $config['payments'];

			foreach($payment_methods as $method_id => $method_name) {
				if(!isset($config_methods[$method_id])) {
					$next_num = 1;
					$same_as = null;
				} else {
					$next_num	=	$config_methods[$method_id]['next_payment_number'];
					$same_as	=	$config_methods[$method_id]['same_as'];
					$narrative	=	$config_methods[$method_id]['payment_narrative_format'];
				}
				$config_methods[$method_id] = array(
					'payment_method_id'	=>	$method_id,
					'payment_method_name'	=>	$method_name,
					'next_payment_number'	=>	$next_num,
					'same_as'		=>	$same_as,
					'payment_narrative_format'	=>	$narrative
				);	
			}
			config::save_value('payments', $config_methods, 'perp_ap');

			if(isset($content['cancel'])) {
				config::save_value('set_payment_data', null, 'perp_ap');
			} else {
				// 0 row to allow for row header
				$display = array(
					0	=>	'for display only'
				);

				foreach ($config_methods as $method_id => &$payment_data) {
					if($payment_data['payment_method_id']) {
						$display[] = $payment_data;
					}
				}
			}
			config::save_value('set_payment_data', $display, 'perp_ap');


			// Translation for options
			$data['settings']['order_number_params'] = array(
				lang('%1 is replaced with %2', '&#37;1$s', lang('supplier number')),
				lang('%1 is replaced with %2', '&#37;2$d', lang('Next order ID number')),
				lang('%1 is replaced with %2', '&#37;3$d', lang('Next number per supplier')),
				lang('%1 is replaced with %2', '&#37;4$d', lang('Next number today')),
				lang('%1 is replaced with %2', 'date(Ymd)', lang('Current date'))
			);
			$data['settings']['shipment_number_params'] = array(
				lang('%1 is replaced with %2', '&#37;1$s', lang('supplier number')),
				lang('%1 is replaced with %2', '&#37;3$s', lang('next shipment ID number')),
				lang('%1 is replaced with %2', 'date(Ymd)', lang('Current date'))
			);
			$data['settings']['invoice_number_params'] = array(
				lang('%1 is replaced with %2', '&#37;1$s', lang('supplier number')),
				lang('%1 is replaced with %2', '&#37;3$s', lang('next number per supplier')),
				lang('%1 is replaced with %2', '&#37;4$s', lang('time in 24 hour format')),
				lang('%1 is replaced with %2', 'date(Ymd)', lang('Current date'))
			);
			$data['settings']['invoice_narrative_params'] = array(
				lang('%1 is replaced with %2', '&#37;1$s', lang('supplier number')),
				lang('%1 is replaced with %2', '&#37;2$s', lang('our reference number'))
			);
			$data['settings']['payment_narrative_params'] = array(
				lang('%1 is replaced with %2', '&#37;1$s', lang('supplier number')),
				lang('%1 is replaced with %2', '&#37;2$s', lang('payment number')),
				lang('%1 is replaced with %2', '&#37;3$s', lang('our reference number'))
			);
			$data['settings']['discount_narrative_params'] = $data['settings']['payment_narrative_params'];
		
			$selects['goods_received_transaction_type'] = ExecMethod('perp_ledger.bo_perp_ledger.get_transaction_types');
			$selects['invoice_transaction_type'] = $selects['goods_received_transaction_type'];
			$selects['payment_transaction_type'] = $selects['goods_received_transaction_type'];
			$selects['same_as'] = array(null => lang('None')) + $payment_methods;

			$this->erp->config($content, $this->appname, 'perp_ap.hook_perp_ap.config',$selects, '', $data);
		}

		/**
		*	Set ACLs for Accounts Payable
		*	@param  content - The returned content of the form or empty array
		*/
		public function acl($content = array()) {
			$data = $this->erp->acl($content, 'perp_ap', 'acl', 'acl', $selects, $filters);
		}

		public function home($args = null) {
_debug_array($args);
		}

		/**
		*	Participate in eGroupWare linking
		*	search_link and account_group are for linking (link widget)
		*/
		public function search_link() {
			return array(
				'query'	=>	'perp_ap.bo_perp_ap.link_query',
				'title'	=>	'perp_ap.bo_perp_ap.link_title',
				'view'	=>	array('menuaction'=>'perp_ap.ui_perp_ap.link_view'),
				'view_id'	=>	'link_id',
				'add'	=>	array('menuaction' => 'perp_ap.ui_perp_ap.link_add'),
				'add_id'	=>	'supplier_id',
				'add_app'	=>	'perp_ap',
				'add_popup'	=>	'750x550',
			);
		}
	}
?>
