<?php
	/**
	*	@brief Data Storage layer object
	*	@author Nathan Gray
	*	@ingroup perp_ap
	*/
	class so_perp_ap {
		/**
		*	Reference to database access object
		*/
		private $db;
	
		/**
		*	Constructor
		*/
		public function so_perp_ap() {
			$this->db = clone($GLOBALS['egw']->db);
			$this->db->set_app('perp_ap');
		}

		/**
		*	Query for suppliers matching the given pattern, used
		*	to participate in eGroupWare's linking system
		*	@param pattern string to search for
		*	@return array of matching suppliers
		*/
		public function link_query($pattern) {
			$query_str = 'SELECT supplier_id, supplier_num, supplier_name
				FROM perp_supplier
				WHERE supplier_num LIKE '.$this->db->quote('%'.$pattern.'%').' OR
					supplier_name LIKE '.$this->db->quote('%'.$pattern.'%');

			$this->db->query($query_str);
			$list = array();
			while($row = $this->db->row(True)) {
				$list[] = $row;
			}
			return $list;
		}
	}
?>
