<?php

	class ui_perp_supplier {
		protected $bo;
		protected $template;
		protected $api;

		protected $messages = array();	// Array for messages to the user

		public $public_functions = array(
			'supplier_list'	=>	True,
			'supplier_new'	=>	true,
			'edit_supplier'	=>	True,
		);

		protected $debug = false;

		// List of tabs
		protected $tabs = 'perp_ap.edit_supplier.address|perp_ap.edit_supplier.finance|perp_ap.edit_supplier.contacts|perp_ap.edit_supplier.catalogue|perp_ap.edit_supplier.purchase_order|perp_ap.edit_supplier.shipment|invoices|perp_ap.edit_supplier.ledger';

		function ui_perp_supplier() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_ap.bo_perp_supplier');
			$this->api = CreateObject('perp_api.ui_perp_api');
		}

		function supplier_list($content = array()) {
			$new = $GLOBALS['egw']->acl->check('supplier', EGW_ACL_ADD, 'perp_ap');
			if(isset($content['new']) && $new) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ap.ui_perp_supplier.supplier_new'));
			} elseif(isset($content['nm']['rows']['edit'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ap.ui_perp_supplier.edit_supplier', 'supplier_id'=> key($content['nm']['rows']['edit'])));
			} elseif(isset($content['nm']['rows']['delete'])) {
				$this->bo->delete_supplier(key($content['nm']['rows']['delete']));
			} elseif(isset($content['nm']['rows']['action'])) {
				if($content['action']) {
					ExecMethod($content['action'], array('supplier_id' => key($content['nm']['rows']['action'])));
					return;
				}
			}

			// What to do with the supplier
			if(isset($content['action'])) {
				$preserve['action'] = $content['action'];
				$data['action'] = $content['action'];
			} 

			// Get nextmatch preferences from session
			$data['nm'] = $GLOBALS['egw']->session->appsession('supplier_list', 'perp_ap');
			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'no_cat'        =>      True,
					'no_filter'	=>	false,
					'filter_label'  =>      'Status',
					'filter'        =>      1, 						//Set default to active Status
			//		'filter_no_lang'        =>      True,
					'no_filter2'	=>	True,
			//		'filter2_label' =>      'Show %s transactions',
			//		'filter2_no_lang'       =>      True,
			//		'filter2'       =>      current($select_box_options['filter2']),
					'lettersearch'	=>	true,
					'get_rows'      =>      'perp_ap.ui_perp_supplier.get_supplier_list',
					'template'      =>      'perp_ap.supplier_list.row',
			//		'header_left'   =>      'ledger.reconcile.start_date',
			//		'header_right'  =>      'ledger.reconcile.end_date',
				);
			}
			$select_box_options['filter'] = array('' => lang('All')) + $this->bo->get_status_list();
			$readonly['new'] = !$new;

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Supplier List');
			$this->template->read('perp_ap.supplier_list');
			$this->template->exec('perp_ap.ui_perp_supplier.supplier_list', $data, $select_box_options, $readonly, $preserve);
		}

		public function supplier_new($content = array()) {
			return $this->edit_supplier($content);
		}

		public function edit_supplier($content = array()) {
			if($this->debug) {
				echo 'ui_perp_supplier.edit_supplier Incoming data:';
				_debug_array($content);
			}

			$supplier_id = $content['supplier_id'] ? $content['supplier_id'] : $_GET['supplier_id'];
			$preserve['return'] = $_GET['return'] ? $_GET['return'] : ($content['return'] ? $content['return'] : '/index.php?menuaction=perp_ap.ui_perp_supplier.supplier_list');

			// Check if the current user is a supplier
			$supplier_ids = ExecMethod('perp_ap.bo_perp_supplier.get_supplier_by_user_account');
			if(is_array($supplier_ids) && count($supplier_ids) > 0 && !in_array($supplier_id, $supplier_ids)) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ap.ui_perp_supplier.supplier_list'));
			}

			$current_tab = $content[$this->tabs] ? $content[$this->tabs] : $_GET['tab'];
			$readonly = array();

			// Buttons - redirects if required
			$this->handle_buttons($supplier_id, $content);

			// Load supplier
			$data = $this->get_supplier($supplier_id);

			// Get data for display
			$data = array_merge($data, $content);
			$this->get_edit_data($data);

			$select_box_options = $this->get_edit_selectbox_options($supplier_id);

			$data[$this->tabs] = $current_tab;

			$this->setup_catalog($supplier_id, $data, $readonly);

			// NOTE: Purchase Orders, shipments and Invoices should use the nextmatch widget, but you're not allowed more than one nextmatch widget.
			// At least, having more than one nextmatch widget causes the extra ones not to work (eGroupWare 1.2)

			$this->setup_purchase_orders($supplier_id, $data, $readonly);
			$this->setup_shipments($supplier_id, $data, $readonly);
			$this->setup_invoices($supplier_id, $data, $readonly);
			$this->setup_ledger($supplier_id, $data, $readonly);


			// Permissions
			if(!$GLOBALS['egw']->acl->check('supplier', EGW_ACL_EDIT, 'perp_ap')) {
				$this->edit_readonly($readonly);
			}

			$preserve['supplier_id'] = $supplier_id;

			if(count($this->messages)) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// JavaScript
			if(!is_object($GLOBALS['egw']->js)) {
				$GLOBALS['egw']->js =& CreateObject('phpgwapi.javascript');
			}

			$GLOBALS['egw']->js->set_onload('supplier_edit_setup();');
			$GLOBALS['egw']->js->validate_file('supplier', 'edit', 'perp_ap');
	
			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = ($data['supplier_id']) ? lang('Edit Supplier') : lang('New Supplier');
			$this->template->read('perp_ap.edit_supplier');
			$this->template->exec('perp_ap.ui_perp_supplier.edit_supplier', $data, $select_box_options, $readonly, $preserve);
		}

		protected function handle_buttons($supplier_id, array &$content) {
			if(isset($content['save']) && !isset($content['cancel'])) {
				unset($content['save']);
				$result = $this->bo->set_supplier($content['supplier_id'], $content);
				if(is_numeric($result)) {
					$supplier_id = $result;
					if(!$this->debug) {
						$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ap.ui_perp_supplier.edit_supplier', 'supplier_id'=> $supplier_id));
					} else {
						$this->messages[] = array(lang('saved'), 'success');
					}
				} else {
					$this->messages[] = array($result, 'error');
				}
			} elseif (isset($content['new_contact']) && $supplier_id) {
				// Look for an existing contact with the same name
				$contacts = ExecMethod('addressbook.addressbook_bo.link_query', $content['supplier_name']);
				if(count($contacts) > 0) {
					foreach($contacts as $contact_id => $name) {
						ExecMethod2('phpgwapi.bolink.link', 'perp_ap', 'SUPPLIER-' . $supplier_id, 'addressbook', $contact_id);
					}
				} else {
					// Create new contact
					$contact = array(
						'cat_id'	=>	'',
						'org_name'	=>	$content['supplier_name'],
						'fileas'	=>	$content['supplier_name'],
					);
					$contact_id = ExecMethod('addressbook.addressbook_bo.save', $contact);
					$link = ExecMethod2('phpgwapi.bolink.link', 'perp_ap', 'SUPPLIER-' . $supplier_id, 'addressbook', $contact_id);
	
					// Open contact for editing
					if(!is_object($GLOBALS['egw']->js)) {
						$GLOBALS['egw']->js =& CreateObject('phpgwapi.javascript');
					}
					
					$href = $GLOBALS['egw']->link('/index.php',array(
						'menuaction'	=>	'addressbook.addressbook_ui.edit', 
						'contact_id'	=> 	$contact_id
					));
					$GLOBALS['egw']->js->set_onload("window.open('$href','_blank','dependent=yes,width=850x440,height=450,scrollbars=yes,status=yes'); ");
				}

			// Catalog tab
			} elseif (isset($content['new_stock'])) {
				// Redirect and add the tab variable so when the popup tells the main window to reload, the catalogue tab is selected
				unset($content['catalogue']['new_stock']);
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_ap.ui_perp_supplier.edit_supplier', 
					'supplier_id'	=>	$supplier_id,
					'tab'		=>	'perp_ap.edit_supplier.catalogue'
				));
			} elseif (isset($content['catalogue']['rows']['add'])) {
				$stock_code =  key($content['catalogue']['rows']['add']);
				$result = ExecMethod2('perp_ap.ui_perp_ap.add_to_po', $supplier_id, urldecode($stock_code), $content['catalogue']['rows']['add'][$stock_code]);
				$this->messages[] = array( $result, 'success');
			} elseif (isset($content['catalogue']['rows']['delete'])) {
				ExecMethod2('perp_ap.bo_perp_catalog.delete', $supplier_id, urldecode(key($content['catalogue']['rows']['delete'])));
				$content[$this->tabs] = 'perp_ap.edit_supplier.catalogue';

			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link($content['return'] ? $content['return'] : '/index.php?menuaction=perp_ap.ui_perp_supplier.supplier_list');
			}

			// Tab actions
			foreach($content as $tab_name => $tab_data) {
				if(!is_array($tab_data) || !is_array($tab_data['rows'])) {
					continue;
				}
				foreach($tab_data['rows'] as $action => $id) {
					if(!is_numeric($action)) {
						if(is_array($id)) {
							$id = key($id);
						}
						if($action == 'new') {
							$id = $supplier_id;
						}
						$this->handle_action($tab_name . '.' .  $action, $id);
					}
				}
			}

		}

		protected function get_supplier($supplier_id) {
			if($supplier_id) {
				// Editing existing supplier
				$data = $this->bo->get_supplier($supplier_id);
				$data['supplier_since'] = date('U', strtotime($data['supplier_since']));
				$readonly['supplier_id'] = True;
				if(!$data['supplier_address']) {
					$this->messages[] = array(lang('Supplier address is not set'), 'warning');
				}
			} else {
				// New supplier
				$data = array();
				$data['supplier_since'] = date('U');
			}
			return $data;
		}

		protected function get_edit_data(array &$data) {
			$data['contacts']['app'] = 'addressbook';
			$data['contacts']['to_app'] = 'perp_ap';
			$data['contacts']['to_id'] = 'SUPPLIER-' .$data['supplier_id'];

			$config = config::read('perp_ap');
			if($config['supplier_user_accounts']) {
				$data['supplier_user_accounts'] = true;
			}

			// Check the owner of the supplier address, it'll cause problems if one user owns it
			if($data['supplier_address']) {
				$address = ExecMethod('addressbook.addressbook_bo.read', $data['supplier_address']);
				if($address['owner'] > 0) {
					$this->messages[] = array(lang('The address is owned by %1.  It should be owned by a group, not an individual.  You should get %1 to edit the address, and change the Addressbook field.',
						$GLOBALS['egw']->common->display_fullname(
							$GLOBALS['egw']->accounts->id2name($address['owner'], 'account_lid'),
							$GLOBALS['egw']->accounts->id2name($address['owner'], 'account_firstname'),
							$GLOBALS['egw']->accounts->id2name($address['owner'], 'account_lastname')
						)
					), 'warning');
				}
			}

		}

		protected function get_edit_selectbox_options($supplier_id) {
			// Addresses
			$contacts = array();
			$contacts = ExecMethod2('phpgwapi.bolink.get_links', 'perp_ap', 'SUPPLIER-'.$supplier_id, 'addressbook');
			if($supplier_id && count($contacts) == 0) {
				$this->messages[] = array(lang('Please link an address for this supplier'), 'info');
			}

			foreach($contacts as $id => $contact_id) {
				$select_box_options['supplier_address'][$contact_id] = ExecMethod2('phpgwapi.bolink.title', 'addressbook', $contact_id);
			}
			$select_box_options['supplier_currency'] = ExecMethod('perp_api.bo_perp_api.get_currencies');
			$select_box_options['payment_terms'] = ExecMethod('perp_api.bo_perp_api.get_payment_terms');
			$select_box_options['tax_group'] = ExecMethod('perp_api.bo_perp_api.get_tax_groups');
			$select_box_options['supplier_status'] = $this->bo->get_status_list();
			
			// Catalog tab
			$select_box_options['inventory'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');

			// Purchase order tab
			$select_box_options['po_filter'] = ExecMethod('perp_ap.bo_perp_purchase_order.get_status_list');

			// Shipments tab
			$select_box_options['status'] = ExecMethod('perp_ap.bo_perp_incoming_shipment.get_status_list');
			$select_box_options['shipper'] = ExecMethod('perp_api.bo_perp_api.get_shippers');

			return $select_box_options;
		}

		protected function setup_catalog($supplier_id, &$data, &$readonly) {
			// Catalogue
			if($GLOBALS['egw']->acl->check('catalog', EGW_ACL_READ, 'perp_ap')) {
				$data['catalogue'] = $GLOBALS['egw']->session->appsession('supplier_catalog_list', 'perp_ap');
				if(!is_array($data['catalogue'])) {
					$data['catalogue'] = array();
				}
				$data['catalogue'] += array(
					'cat_app'	=>	'perp_inventory',
					'no_filter'	=>	True,
					'no_filter2'	=>	True,
					'get_rows'	=>	'perp_ap.ui_perp_catalog.get_supplier_catalog_list',
					'template'	=>	'perp_ap.edit_supplier.catalogue.row',
					'default_cols'	=>	'supplier_code,perp_supplier_stock.stock_id,perp_stock.stock_num,description,price'
	                        );
				$data['catalogue']['supplier_id'] = $supplier_id;
		
				if($GLOBALS['egw']->acl->check('catalog', EGW_ACL_ADD, 'perp_ap')) {
					$data['catalogue_add'] = True;
				}
			} else {
				$readonly[$this->tabs]['perp_ap.edit_supplier.catalogue'] = True;
			}
		}

		protected function setup_purchase_orders($supplier_id, array &$data, array &$readonly) {
			// Purchase Orders
			$po = array();
			if($GLOBALS['egw']->acl->check('order', EGW_ACL_READ, 'perp_ap')) {
				$data['purchase_orders'] = array(
					'no_cat'	=>	true,
					'filter_label'	=>	'Status',
					'no_filter'	=>	false,
					'filter'	=>	$GLOBALS['egw_info']['user']['preferences'][$GLOBALS['egw_info']['flags']['currentapp']]['order_filter'],
					'supplier_id'	=>	$supplier_id,
					'get_rows'	=>	'perp_ap.bo_perp_purchase_order.get_order_list',
					'template'	=>	'perp_ap.purchase_order_list.row',
					'default_cols'	=>	'!supplier_num',
					'order'		=>	'issue_date',
					'sort'		=>	'DESC'
				);
				$data['purchase_orders']['options-filter'] = ExecMethod('perp_ap.bo_perp_purchase_order.get_status_list');
			} else {
				$readonly[$this->tabs]['perp_ap.edit_supplier.purchase_order'] = True;
			}
			$readonly['purchase_orders[rows][new]'] = !$GLOBALS['egw']->acl->check('order', EGW_ACL_ADD, 'perp_ap');
		}

		protected function setup_shipments($supplier_id, array &$data, array &$readonly) {
			// Shipments
			if($GLOBALS['egw']->acl->check('shipment', EGW_ACL_READ, 'perp_ap')) {
				$data['shipment'] = array(
					'supplier_id'	=>	$data[supplier_id],
					'hide_supplier'	=>	True,
					'no_cat'	=>	true,
					'filter_label'	=>	'Status',
					'no_filter'	=>	false,
					'get_rows'	=>	'perp_ap.bo_perp_incoming_shipment.get_shipment_list',
					'template'	=>	'perp_ap.incoming_shipment_list.row',
					'order'		=>	'actual_delivery_date',
					'sort'		=>	'DESC'
				);
				$data['shipment']['options-filter'] = ExecMethod('perp_ap.bo_perp_incoming_shipment.get_status_list');
			} else {
				$readonly[$this->tabs]['perp_ap.edit_supplier.shipment']= True;
			}
		}

		protected function setup_invoices($supplier_id, array &$data, array &$readonly) {
			// Shipments
			if($GLOBALS['egw']->acl->check('invoice', EGW_ACL_READ, 'perp_ap')) {
				$data['invoices'] = array(
					'supplier_id'	=>	$data[supplier_id],
					'hide_supplier'	=>	True,
					'no_cat'	=>	true,
					'filter_label'	=>	'Status',
					'no_filter'	=>	false,
					'get_rows'	=>	'perp_ap.bo_perp_payable_invoice.get_invoice_list',
					'template'	=>	'perp_ap.payable_invoice_list.row',
					'order'		=>	'due_date',
					'sort'		=>	'DESC',
					'no_supplier_number'	=>	true,
					'no_supplier_name'	=>	true,
				);
				$data['invoices']['options-filter'] = ExecMethod('perp_ap.bo_perp_payable_invoice.get_status_list');
			} else {
				$readonly[$this->tabs]['perp_ap.edit_supplier.invoices']= True;
			}
		}

		protected function setup_ledger($supplier_id, array &$data, array &$readonly) {
			// Ledger
			if($GLOBALS['egw']->acl->check('ledger', EGW_ACL_READ, 'perp_ap')) {
				$data['ledger'] = array(
					'supplier_id'	=>	$supplier_id,
					'get_rows'	=>	'perp_ap.bo_perp_supplier.get_supplier_ledger',
					'template'	=>	'perp_ap.edit_supplier.ledger.row',
					'order'		=>	'trans_date',
					'sort'		=>	'DESC'
				);
				$data['ledger']['total'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', $data['supplier_currency'], $this->bo->get_account_balance($data['supplier_id']));
			} else {
				$readonly[$this->tabs]['perp_ap.edit_supplier.ledger']= True;
			}
		}

		protected function edit_readonly(array &$readonly) {
			$readonly['supplier_num']	=	True;
			$readonly['supplier_name']	=	True;
			$readonly['supplier_address']	=	True;
			$readonly['supplier_currency']	=	True;
			$readonly['supplier_since']	=	True;
			$readonly['payment_terms']	=	True;
			$readonly['bank_account']	=	True;
			$readonly['bank_reference']	=	True;
			$readonly['bank_particulars']	=	True;
			$readonly['remittance']		=	True;
			$readonly['tax_group']		=	True;
			$readonly['user_account']	=	True;

			//Links
			$readonly['contacts']		=	True;
			
			// Ledger
			$readonly['credit_note']	=	True;

			$readonly['save']	=	True;
		}

		/**
		*	Get supplier list for index, above.
		*	This function (in the UI layer) is used in order to use user preferences for search and sort
		*
		*	@see perp_ap.bo_perp_supplier.get_supplers
		*/
		public function get_supplier_list(&$query, &$rows = array(), &$readonlys = array()) {
			$GLOBALS['egw']->session->appsession('supplier_list', 'perp_ap', $query);

			// The following is used if there are filters
			/*
			if($query['filter'] != $GLOBALS['egw_info']['user']['preferences']['perp_ap']['stock_category']) {
				$GLOBALS['egw']->preferences->add('perp_inventory', 'stock_category', $query['filter']);
				$GLOBALS['egw']->preferences->save_repository(true);
			}

			if($query['filter2'] != $GLOBALS['egw_info']['user']['preferences']['perp_inventory']['stock_status']) {
				$GLOBALS['egw']->preferences->add('perp_inventory', 'stock_status', $query['filter2']);
				$GLOBALS['egw']->preferences->save_repository(true);
			}
			*/
			return $this->bo->get_suppliers($query, $rows, $readonlys);
		}

		/**
		*	Handle actions from edit supplier screen
		*	Actions are one of:
		*		- order.
		*/
		protected function handle_action($action, $document_id) {
			list($tab, $action) = explode('.', $action);
			switch ($tab) {
				case 'purchase_orders':
					if($action == 'new') {
						$GLOBALS['egw']->redirect_link('/index.php', array(
							'menuaction'	=>	'perp_ap.ui_perp_purchase_order.new_order',
							'supplier_id'	=>	$document_id
						));
					} else {
						ExecMethod2('perp_ap.ui_perp_purchase_order.handle_order_action', $action, $document_id);
					}
					break;
				case 'shipment':
					ExecMethod2('perp_ap.ui_perp_incoming_shipment.handle_shipment_action', $action, $document_id);
					break;
				case 'invoices':
					ExecMethod2('perp_ap.ui_perp_payable_invoice.handle_action', $action, $document_id);
					break;
			} 
			return false;
		}

	}
?>
