<?php
	require_once('class.PurchaseOrder.inc.php');
	require_once('class.bo_perp_purchase_order.inc.php');
	require_once('class.bo_perp_incoming_shipment.inc.php');

	$GLOBALS['egw']->translation->add_app('perp_ap');

	$select_box_options['supplier'] = ExecMethod('perp_ap.bo_perp_supplier.get_suppliers');
	$span = array(
		'1'	=>	'Today',
		'7'	=>	'This week',
		'mine'	=>	'For my stuff',
	);

	$app_id = $GLOBALS['egw']->applications->name2id('perp_ap');
	$GLOBALS['portal_order'][] = $app_id;
	$portalbox =& CreateObject('phpgwapi.listbox', array(
		'title'		=>	lang('perp_ap'),
		'primary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'secondary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'tertiary'	=>	$GLOBALS['egw_info']['theme']['navbar_bg'],
		'width'		=>	'100%',
		'outerborderwidth' => '0',
		'header_background_image' => $GLOBALS['egw']->common->image('phpgwapi/templates/default','bg_filler')
	));

	$old_app = $GLOBALS['egw_info']['flags']['currentapp'];
	$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_ap';

	$portalbox->data = $data;
	foreach(array('up','down','close','question','edit') as $key) {
		$portalbox->set_controls($key,Array('url' => '/set_box.php', 'app' => $app_id));
	}
	$html = '<table width="100%"><tbody><tr style="vertical-align: top;">';

	if (($showevents = (int) $GLOBALS['egw_info']['user']['preferences']['perp_ap']['homepage_display_po_approval']) > 0) {
		$data = array();
		$readonlys = array();
		$query = array(
			'filter'	=>	'request',
			'template'	=>	false
		);
		$bopo = new bo_perp_purchase_order();
		$bopo->get_order_list($query, $data, $readonlys);

		// Filter only the ones current user is approver for
		foreach ($data as $key => $row) {
			if(is_integer($key) && is_array($row)) {
				$po = new PurchaseOrder($row['order_id']);
				if($po->is_approver($GLOBALS['egw_info']['user']['account_id']) !== True) {
					unset($data[$key]);
				}
			}
		}

		if(count($data) > 0) {
			array_unshift($data, 'title');

			// Move data to match a nextmatch widget, so data is where it needs to be to re-use the template
			$data['nextmatch']['rows'] = $data;
			$readonlys['nextmatch']['rows'] = $readonlys;

			$html .= '</tr><tr><td colspan="2">';
			$template = CreateObject('etemplate.etemplate');
			$template->read('perp_ap.home.purchase_orders');
			$html .= $template->exec('perp_ap.ui_perp_purchase_order.order_list', $data, $select_box_options, $readonlys, null, -1);
			$html .= '</td>';
		}
	}
	if(($show_unshipped = $GLOBALS['egw_info']['user']['preferences']['perp_ap']['homepage_display_unshipped_purchase_orders'])) {
		if($show_unshipped == 'mine') {
			$owner = $GLOBALS['egw_info']['user']['account_id'];
		}
		$data = ExecMethod('perp_ap.bo_perp_purchase_order.get_unshipped', $owner);
		if(is_array($data) && count($data) > 0) {
			array_unshift($data, false);

			// Move data to match a nextmatch widget, so data is where it needs to be to re-use the template
			$data['nextmatch']['rows'] = $data;
			$readonlys['nextmatch']['rows'] = $readonlys;

			$html .= '</tr><tr><td colspan="2">';
			$template = CreateObject('etemplate.etemplate');
			$template->read('perp_ap.home.unshipped_purchase_orders');
			$html .= $template->exec('perp_ap.ui_perp_purchase_order.order_list', $data, $select_box_options, $readonlys, null, -1);
			$html .= '</td>';
		}
	}
	if(($show_shipment = $GLOBALS['egw_info']['user']['preferences']['perp_ap']['homepage_display_incoming_shipments'])) {
		$query = array();
		$data = array();
		$readonly = array();
		$boshipment = new bo_perp_incoming_shipment();
		$query['status'] = 'in-transit';
		$shipment_count = $boshipment->get_shipment_list($query, $data['nextmatch']['rows'], $readonly['nextmatch']['rows']);

		foreach($data['nextmatch']['rows'] as $key => $row) {
			if(is_integer($show_shipment)) {
				if($row['requested_delivery_date'] > mktime(0,0,0, date('m'), date('d') + $show_shipment, date('Y'))) {
					unset($data['nextmatch']['rows'][$key]);
					$shipment_count--;
				}
			} elseif ($show_shipment == 'mine') {
				$mine = True;
				$shipment = new IncomingShipment($row['shipment_id']);
				$lines =& $shipment->get_lines();
				foreach($lines as $no => $line) {
					if(!is_null($line->get_shippable_item()) && $line->get_shippable_item() instanceof OrderLine) {
						$po = $line->get_shippable_item()->get_owner();
						$mine = $mine && ($po->get_originating_user() == $GLOBALS['egw_info']['user']['account_id']);
					}
				}
				if(!$mine) {
					unset($data['nextmatch']['rows'][$key]);
					$shipment_count--;
				}
			}
		}

		if($shipment_count > 0) {
			array_unshift($data, 'title');
			$html .= '</tr><tr><td colspan="2">';
			$data['span'] = $span[$show_shipment];

			// Move data to match a nextmatch widget, so data is where it needs to be to re-use the template

			$select_box_options['shipper'] = ExecMethod('perp_api.bo_perp_api.get_shippers');
			$select_box_options['location'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$s_template = CreateObject('etemplate.etemplate');
			$s_template->read('perp_ap.home.shipments');
			$html .= $s_template->exec('perp_ap.ui_perp_incoming_shipment.shipment_list', $data, $select_box_options, $readonly, null, -1);
			$html .= '</td>';
		}
	}


	if(($show_invoices = (int)$GLOBALS['egw_info']['user']['preferences']['perp_ap']['homepage_display_upcoming_payments']) > 0) {
		$due = array();
		$overdue = array();
		$boinvoice = CreateObject('perp_ap.bo_perp_payable_invoice');
		$boinvoice->get_invoice_list(array('filter' => 'due'), $due, $readonlys);
		foreach($due as $key => $row) {
			if(is_numeric($key) && $row['due_date'] > mktime(0,0,0, date('m'), date('d') + $show_invoices, date('Y'))) {
				unset($due[$key]);
			}
		}

		$count = 1;
		$data = array();
		foreach($due as $key => $value) {
			if(!is_numeric($key)) {
				continue;
			}
			$line = $value;
			if(is_object($line['invoice'])) {
				unset($line['invoice']);
				$line += array(
					'invoice_id'	=>	$value['invoice_id'],
					'supplier'	=>	$value['invoice']->get_supplier(),
					'our_reference'	=>	$value['invoice']->get_our_reference(),
					'their_reference'	=>	$value['invoice']->get_their_reference(),
					'total'		=>	$value['invoice']->get_total(),
					'due_date'	=>	$value['due_date'],
				);
			}
			$data[$count++] = $line;
		}

		if(count($data) > 0) {
			$data['span'] = $span[$show_invoices];
			$html .= '</tr><tr><td colspan="2">';
			$i_template = CreateObject('etemplate.etemplate');
			$i_template->read('perp_ap.home.invoices');
			$html .= $i_template->exec('perp_ap.ui_perp_payable_invoice.invoice_list', $data, $select_box_options, $readonlys, null, -1);
			$html .= '</td>';
		}
	}

	$html .= '</tr></tbody></table>';

	$GLOBALS['egw_info']['flags']['currentapp'] = $old_app;
	if (!file_exists(EGW_SERVER_ROOT.($css_file ='/perp_ap/templates/'.$GLOBALS['egw_info']['user']['preferences']['common']['template_set'].'/app.css'))) {
		$css_file = '/perp_ap/templates/default/app.css';
	}
        echo '
<style type="text/css">
<!--
        @import url('.$GLOBALS['egw_info']['server']['webserver_url'].$css_file.');
-->
</style>';
	echo $portalbox->draw($html);
	
?>
