<?php
/* This is one part that, due to API constraints, still needs its own hook file */

	$temp = $GLOBALS['egw']->acl->get_ids_for_location('order', EGW_ACL_CUSTOM_1, 'perp_ap');
	if($temp) {
		foreach($temp as $id) {
			if($id) {
				$expand = $GLOBALS['egw']->accounts->member($id);
				if(is_array($expand)) {
					foreach($expand as $acct) {
						$temp[] = $acct['account_id'];
					}
				}
			}
		}
		foreach($temp as $id) {
			$po_admins[$id] = $GLOBALS['egw']->accounts->id2name($id);
		}

		$settings = array(
			'supervisors' => array(
				'type'	=>	'select',
				'label'	=>	'Who approves your purchase orders',
				'name'	=>	'supervisors',
				'values'	=>	$po_admins,
				'help'	=>	'',
			),
		);
	}
	// We NEED a preference called homepage_display to get the API to display our app on the homepage
	$settings['homepage_display'] = array(
		'type'	=>	'check',
		'label'	=>	'Show Accounts Payable information on home page',
		'name'	=>	'homepage_display',
	);

	if(is_array($po_admins) && in_array($GLOBALS['egw_info']['user']['account_id'], array_keys($po_admins))) {
		$settings['homepage_display_po_approval'] = array(
			'type'	=>	'select',
			'label'	=>	'Show Purchase Orders for you to approve on home page',
			'name'	=>	'homepage_display_po_approval',
			'values'	=>	array('0' => 'No', '2' => 'Yes'),
		);
	}
	if($GLOBALS['egw']->acl->check('order', EGW_ACL_READ, 'perp_ap')) {
		$values = array(
			'0'	=>	'No',
			'mine'	=>	'Mine',
			1	=>	'Yes'
		);

		$settings['homepage_display_unshipped_purchase_orders'] = array(
			'type'	=>	'select',
			'label'	=>	'Show purchase orders not on a shipment on home page',
			'name'	=>	'homepage_display_unshipped_purchase_orders',
			'values'	=>	$values,
			'help'	=>	'',
		);
	}
	if($GLOBALS['egw']->acl->check('shipment', EGW_ACL_READ, 'perp_ap')) {
		$values = array(
			'0'	=>	'No',
			'mine'	=>	'Mine',
		);
		if($GLOBALS['egw']->acl->check('shipment', EGW_ACL_EDIT, 'perp_ap')) {
			$values += array(
				'1'	=>	'Today',
				'7'	=>	'This week',
			);
		}

		$settings['homepage_display_incoming_shipments'] = array(
			'type'	=>	'select',
			'label'	=>	'Show incoming shipments on home page',
			'name'	=>	'homepage_display_incoming_shipments',
			'values'	=>	$values,
			'help'	=>	'',
		);
	}

	if($GLOBALS['egw']->acl->check('invoice', EGW_ACL_READ, 'perp_ap')) {
		$settings['homepage_display_upcoming_payments'] = array(
			'type'	=>	'select',
			'label'	=>	'Show invoices coming due on home page',
			'name'	=>	'homepage_display_upcoming_payments',
			'values'=>	array(
				'0'	=>	'No',
				'1'	=>	'Today',
				'7'	=>	'This week',
			),
			'help'	=>	'',
		);
	}

	if($GLOBALS['egw']->acl->check('order', EGW_ACL_READ, 'perp_ap')) {
		$settings['order_filter'] = array(
			'type'	=>	'select',
			'label'	=>	'Default order status to filter list by',
			'name'	=>	'order_filter',
			'values'	=>	ExecMethod('perp_ap.bo_perp_purchase_order.get_status_list'),
			'help'	=>	'When you first go to the Purchase Order list, what should the status filter be?'
		);
		$settings['order_print_prompt'] = array(
			'type'	=>	'select',
			'label'	=>	'Prompt to print Purchase Order',
			'name'	=>	'order_print_prompt',
			'values'	=>	array(
				false	=>	'No',
				true	=>	'Yes'
			),
			'help'	=>	'Would you like to be reminded to print the Purchase Order when leaving the screen?'
		);
	}

	if($GLOBALS['egw']->acl->check('receive', EGW_ACL_READ, 'perp_ap')) {
		$settings['receive_print_prompt'] = array(
			'type'	=>	'select',
			'label'	=>	'Prompt to print Receiving screen',
			'name'	=>	'receive_print_prompt',
			'values'	=>	array(
				false	=>	'No',
				true	=>	'Yes'
			),
			'help'	=>	'Would you like to be reminded to print receiving when leaving the screen?'
		);
		$settings['receiving_location'] = array(
			'type'	=>	'select',
			'label'	=>	'Where do you usually receive?',
			'name'	=>	'receiving_location',
			'values'	=>	ExecMethod('perp_inventory.bo_perp_location.get_location_list',
				array('filter2' => 'shippable')
			),
			'help'	=>	'Speeds receiving up so you don\'t always have to select the location'
		);
	}

	if($GLOBALS['egw']->acl->check('payment', EGW_ACL_READ, 'perp_ap')) {
		$settings['autofill_payment'] = array(
			'type'	=>	'select',
			'label'	=>	'Double click fills in payment fields',
			'name'	=>	'autofill_payment',
			'values'=>	array(
				'0'	=>	'Double click',
				'1'	=>	'Automatically',
			),
			'help'	=>	'Should the correct value be filled in automatically, or when you double click on Discount Taken or Payment Amount fields.',
		);
	}		

	$settings['link_add'] = array(
		'type'	=>	'select',
		'label'	=>	'When I add a new Accounts Payable link, I want a new',
		'name'	=>	'link_add',
		'values'	=>	array(
			'0'	=>	'Ask me each time',
			'SUPPLIER'	=>	'Supplier',
			'PO'		=>	'Purchase Order',
			'SHIPMENT'	=>	'Incoming Shipment',
			'INVOICE'	=>	'Invoice',
			'PAYMENT'	=>	'Payment'
		),
		'help'	=>	'In the top right corner there should be a little box that says "Add...".  What would you like to add when you choose "Accounts Payable" from the list?'
	);

	$GLOBALS['settings'] = $settings;
	unset($temp);
	unset($po_admins);

	return $settings;
?>
