<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_ap/inc/class.bo_perp_receive.inc.php');

	/**
	*	A report that lists goods received on a certain day
	*	Grouped by purchase order
	*/
	class goods_received extends perp_report {
		
		private $bo_receive;

		public function goods_received(array $parameters = array()) {
			parent::perp_report($parameters);

			$this->template = 'goods_received_landscape.odt';
			
			$this->bo_receive = new bo_perp_receive();			

			// Default parameters
			if(!$parameters['start_date']) {
				$this->parameters['start_date'] = date('U');
				$this->parameters['end_date'] = date('U');
			}
			
		}

		public function get_data($query = array()) {
			// Make sure we get the start of the day
			$start_date = date('U', mktime(0,0,0, date('m', $query['start_date']), date('d', $query['start_date']), date('Y', $query['start_date']) ));
			// Make sure we get the end of the day
			$end_date = date('U', mktime(23,59,59, date('m', $query['end_date']), date('d', $query['end_date']), date('Y', $query['end_date']) ));
						
			$get_data_goods_received_report = $this->bo_receive->get_data_goods_received_report($start_date, $end_date, $goods_received);
			
			 $data = array(
				'received_date'	=>	date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $start_date) . ' - ' .
							date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $end_date),
				'goods_received'	=>	$goods_received
			);
			
			// Logo
			$config = config::read('perp_api');
			$data['images'] = array();
			$data['images'][] = array(
				'name'	=>	'company_logo',
			) + $config['company_logo'];

			return $data;
		}
	}
?>
