<!--
/** 
*	Javascript for creating / editing a payment
*
*	Actually, you can't edit a payment once posted...
*
*	@param auto_fill	boolean	Automatically enter the correct amount when you double-click the field
*				if false, it will enter when double clicked.  If true, it will be filled out automatically
*/
-->

function payment_new_setup(auto_fill) {

	var inputs = document.getElementsByTagName('input');
	for(i = 0; i < inputs.length; i++) {
		inputs[i].style.textAlign = 'right';
		if(inputs[i].id.indexOf('discount_taken') > 0) {
			if(inputs[i].addEventListener) {
				inputs[i].addEventListener('dblclick', set_discount, true);
				inputs[i].addEventListener('blur', update_total, false);
				inputs[i].addEventListener('change', update_total, false);
				inputs[i].addEventListener('keyup', update_total, false);
			} else {
				inputs[i].ondblclick = set_discount;
				if(auto_fill) {
					// TODO: make this work in non-compliant browsers
				}
				inputs[i].onchange = update_total;
			}
		} else if (inputs[i].id.indexOf('payment_amount') > 0) {
			if(inputs[i].addEventListener) {
				inputs[i].addEventListener('dblclick', set_payment_amount, true);
				inputs[i].addEventListener('blur', update_total, false);
				inputs[i].addEventListener('change', update_total, false);
				inputs[i].addEventListener('keyup', update_total, false);
			} else {
				inputs[i].ondblclick = set_payment_amount;
				if (auto_fill) {
				}
				inputs[i].change = update_total;
			}
		}
	}

	if(auto_fill) {
		for(i = 0; i < inputs.length; i++) {
			if(inputs[i].id.indexOf('discount_taken') > 0 || inputs[i].id.indexOf('payment_amount') > 0) {
				var event = document.createEvent('MouseEvents');
				event.initEvent( 'dblclick', true, false );
				inputs[i].dispatchEvent(event);
			}
		}
	}

	var pre_payment = document.getElementById('exec[pre_payment]');
	if(pre_payment.addEventListener) {
		pre_payment.addEventListener('change', update_total, false);
	} else  {
		pre_payment.onchange = update_total;
	}

	update_total();
}

/**
*	Fill in the discount taken column
*/
function set_discount(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}
	var base_id = target.id.replace(/\[discount_taken\]/gi, '');
	var discount_available = document.getElementById(base_id + '[discount_available]');
	if(discount_available) {
		target.value = discount_available.value;
	}
}

/** 
*	Fill in the payment amount column
*/
function set_payment_amount (e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}
	var base_id = target.id.replace(/\[payment_amount\]/gi, '');
	var amount_owing = document.getElementById(base_id + '[amount_owing]');
	var discount_taken = document.getElementById(base_id + '[discount_taken]');
	if(amount_owing) {
		var amount = parseFloat(amount_owing.value) * 100;

		if(discount_taken && discount_taken.value == parseFloat(discount_taken.value)) {
			amount -= parseFloat(discount_taken.value) * 100;
		}

		target.value = (amount / 100).toFixed(2);
	}
}

/**
*	Update payment total field
*/
function update_total() {
	var inputs = document.getElementsByTagName('input');
	var total = 0;
	for(i = 0; i < inputs.length; i++) {
		if(inputs[i].id.indexOf('payment_amount') > 0 && inputs[i].value == parseFloat(inputs[i].value)) {
			total += parseFloat(inputs[i].value) * 100;
		}
	}

	var prepayment = document.getElementById('exec[pre_payment]');
	if(prepayment && prepayment.value == parseFloat(prepayment.value)) {
		total += parseFloat(prepayment.value) * 100;
	}

	var payment_total = document.getElementById('exec[payment_total]');
	if(payment_total && total == parseFloat(total)) {
		payment_total.value = (total / 100).toFixed(2);
	}
}
