/**
 * Javascript for receiving a single item from an incoming shipment
 */

function receive_setup() {
	
	var supplier = document.getElementById('exec[supplier_id][value]');
	if(!supplier) {
		// Send focus to Stock Code field
		var stock_code = document.getElementById('exec[stock_code][search]');
		if(stock_code) {
			stock_code.select();
		}
	}

	var serials = document.getElementById('exec[serial_numbers]');
	if(serials) {
		serials.parentNode.parentNode.style.visibility = "collapse";
	}
}

function change_supplier(e) {
	var supplier = document.getElementById('exec[supplier_id][value]').value;
	var order = document.getElementById('exec[order_id][results]');
	var stock_code = document.getElementById('exec[stock_code][results]');
	order.options.supplier_id = supplier;
	stock_code.options.supplier_id = supplier;
}

/**
 * When they change the Purchase Order, we have to check the new order's ship to location
 * against the selected shipping location, and warn if they don't match
 */
function change_order() {
	var location_id = document.getElementById('exec[location_id]').value;
	var order_id = document.getElementById('exec[order_id][value]').value;
	xajax_doXMLHTTP( "perp_ap.ajax_perp_receive.check_order_location", location_id, order_id);
}

/**
 * When they change the stock code, we want to have our unit of measure
 * displayed, so the receiver doesn't enter boxes or something when we
 * deal with each.
 */
function change_stock_code() {
	var stock_code = document.getElementById('exec[stock_code][search]').value;
	var supplier_id = document.getElementById('exec[supplier_id][value]');
	if(supplier_id) {
		supplier_id = supplier_id.value;
	} else {
		supplier_id = document.getElementById('exec[stock_code][results]').options.supplier_id;
	}
	xajax_doXMLHTTP( "perp_ap.ajax_perp_receive.change_stock_code", supplier_id, stock_code);
}
