<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


$phpgw_baseline = array(
	'perp_supplier' => array(
		'fd' => array(
			'supplier_id' => array('type' => 'auto','nullable' => False),
			'supplier_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
			'supplier_address' => array('type' => 'int','precision' => '4','nullable' => False),
			'supplier_currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'supplier_since' => array('type' => 'date','nullable' => False),
			'payment_terms' => array('type' => 'int','precision' => '4','nullable' => False),
			'bank_account' => array('type' => 'varchar','precision' => '30'),
			'bank_reference' => array('type' => 'varchar','precision' => '12'),
			'bank_particulars' => array('type' => 'varchar','precision' => '12'),
			'remittance' => array('type' => 'int','precision' => '4'),
			'tax_group' => array('type' => 'int','precision' => '4','nullable' => False),
			'supplier_num' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'user_account' => array('type' => 'int','precision' => '4'),
			'supplier_status' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '1'),
			'credit_limit' => array('type' => 'decimal','precision' => '20','scale' => '2')
		),
		'pk' => array('supplier_id'),
		'fk' => array('supplier_address' => 'perp_address.address_id','supplier_currency' => 'perp_currency.currency_id','payment_terms' => 'perp_payment_term.payment_term_id','tax_group' => 'perp_tax_group.tax_group_id','user_account' => 'egw_accounts.account_id'),
		'ix' => array('supplier_id'),
		'uc' => array('supplier_id','supplier_name','supplier_num')
	),
	'perp_supplier_ledger' => array(
		'fd' => array(
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'supplier_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'due_date' => array('type' => 'date'),
			'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False,'default' => '0'),
			'supplier_reference' => array('type' => 'varchar','precision' => '20'),
			'comment' => array('type' => 'text'),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'link' => array('type' => 'text')
		),
		'pk' => array('trans_id','line_no'),
		'fk' => array('trans_id' => 'perp_general_ledger.trans_no','supplier_id' => 'perp_supplier.supplier_id','line_no' => 'perp_general_ledger.line_no','link_id' => 'egw_links.link_id'),
		'ix' => array('trans_id','line_no'),
		'uc' => array(array('trans_id','line_no'))
	),
	'perp_purchase_order' => array(
		'fd' => array(
			'purchase_order_id' => array('type' => 'auto','nullable' => False),
			'purchase_order_number' => array('type' => 'varchar','precision' => '20'),
			'supplier' => array('type' => 'int','precision' => '4'),
			'comments' => array('type' => 'text'),
			'created_date' => array('type' => 'date','nullable' => False),
			'order_date' => array('type' => 'date'),
			'initiator' => array('type' => 'int','precision' => '4','nullable' => False),
			'into_stock_location' => array('type' => 'varchar','precision' => '5','nullable' => False),
			'contact' => array('type' => 'int','precision' => '4'),
			'requisition_number' => array('type' => 'int','precision' => '4'),
			'approver' => array('type' => 'int','precision' => '4','nullable' => False),
			'approved_date' => array('type' => 'date'),
			'currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'received_date' => array('type' => 'date'),
			'invoiced_date' => array('type' => 'date'),
			'terms' => array('type' => 'varchar','precision' => '2','nullable' => False),
			'arrival_date' => array('type' => 'date')
		),
		'pk' => array('purchase_order_id'),
		'fk' => array('supplier' => 'perp_supplier.supplier_id','initiator' => 'egw_accounts.account_id','into_stock_location' => 'perp_location.location_id','contact' => 'egw_addressbook.id','approver' => 'egw_accounts.account_id','currency' => 'perp_currency.currency_id','terms' => 'perp_payment_term.payment_term_id'),
		'ix' => array('purchase_order_id','purchase_order_number','initiator','requisition_number','approver'),
		'uc' => array('purchase_order_id','purchase_order_number','requisition_number')
	),
	'perp_purchase_order_detail' => array(
		'fd' => array(
			'purchase_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'received_date' => array('type' => 'date'),
			'item_code' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'item_description' => array('type' => 'varchar','precision' => '255'),
			'gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_invoiced' => array('type' => 'decimal','precision' => '20','scale' => '3'),
			'unit_price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'line_price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'standard_cost_per_unit' => array('type' => 'decimal','precision' => '20','scale' => '3'),
			'quantity_ordered' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'quantity_received' => array('type' => 'varchar','precision' => '20','scale' => '3'),
			'completed' => array('type' => 'bool'),
			'invoiced_date' => array('type' => 'date')
		),
		'pk' => array('purchase_order_id','line_no'),
		'fk' => array('purchase_order_id' => 'perp_purchase_order.purchase_order_id','gl_account' => 'perp_account.account_id'),
		'ix' => array('purchase_order_id'),
		'uc' => array()
	),
	'perp_supplier_stock' => array(
		'fd' => array(
			'supplier_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'supplier_code' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'supplier_uom' => array('type' => 'int','precision' => '4','nullable' => False),
			'conversion_factor' => array('type' => 'decimal','precision' => '20','scale' => '4','nullable' => False,'default' => '1'),
			'lead_time' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '7'),
			'preferred' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
			'average_indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '4','nullable' => False,'default' => '0')
		),
		'pk' => array('supplier_id','supplier_code'),
		'fk' => array('supplier_id' => 'perp_supplier.supplier_id','stock_id' => 'perp_stock.stock_id','supplier_uom' => 'perp_unit_of_measure.uom_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_goods_received' => array(
		'fd' => array(
			'goods_received_id' => array('type' => 'auto','nullable' => False),
			'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'receive_date' => array('type' => 'timestamp','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_units' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'purchase_order_id' => array('type' => 'int','precision' => '4'),
			'stock_cost_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'received_by' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('goods_received_id'),
		'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_purchase_order_detail.line_no','purchase_order_id' => 'perp_purchase_order_detail.purchase_order_id','stock_cost_id' => 'perp_stock_cost.stock_cost_id','received_by' => 'egw_accounts.account_id'),
		'ix' => array('goods_received_id','shipment_id','line_no'),
		'uc' => array('goods_received_id')
	),
	'perp_payable_invoice' => array(
		'fd' => array(
			'invoice_id' => array('type' => 'auto','nullable' => False),
			'supplier' => array('type' => 'int','precision' => '4','nullable' => False),
			'customer' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '-1'),
			'invoice' => array('type' => 'blob'),
			'closed' => array('type' => 'bool','nullable' => False,'default' => '0'),
			'due_date' => array('type' => 'date','nullable' => False)
		),
		'pk' => array('invoice_id'),
		'fk' => array(),
		'ix' => array('invoice_id','supplier','customer','closed','due_date'),
		'uc' => array('invoice_id')
	),
	'perp_supplier_payment' => array(
		'fd' => array(
			'payment_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'invoice_id' => array('type' => 'int','precision' => '4'),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'allocation_date' => array('type' => 'date'),
			'allocated_from' => array('type' => 'int','precision' => '4'),
			'payment_number' => array('type' => 'varchar','precision' => '20','nullable' => False)
		),
		'pk' => array('payment_id','trans_id','invoice_id','allocated_from'),
		'fk' => array('trans_id' => 'perp_supplier_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_supplier_payment.payment_id'),
		'ix' => array('payment_id','trans_id','invoice_id','payment_number'),
		'uc' => array()
	),
	'perp_supplier_ship_package' => array(
		'fd' => array(
			'supplier_id' => array('type' => 'int','precision' => '4'),
			'supplier_code' => array('type' => 'varchar','precision' => '20'),
			'unit_of_measure' => array('type' => 'int','precision' => '4'),
			'length' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'width' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'height' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'mass' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0.1')
		),
		'pk' => array(),
		'fk' => array('supplier_id' => 'perp_supplier.supplier_id','supplier_code' => 'perp_supplier_stock.supplier_code','unit_of_measure' => 'perp_unit_of_measure.uom_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_receiving_not_ordered' => array(
		'fd' => array(
			'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'supplier_stock_code' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '4','nullable' => False),
			'unit_price' => array('type' => 'float','precision' => '4','nullable' => False),
			'received_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'received_date' => array('type' => 'timestamp','nullable' => False),
			'id' => array('type' => 'auto','nullable' => False)
		),
		'pk' => array('id'),
		'fk' => array('shipment_id' => 'perp_shipment.shipment_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array('shipment_id'),
		'uc' => array()
	),
	'perp_payment_reversal' => array(
		'fd' => array(
			'original_id' => array('type' => 'int','precision' => '4'),
			'reversal_id' => array('type' => 'int','precision' => '4'),
			'account_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'timestamp' => array('type' => 'timestamp','nullable' => False),
			'reason' => array('type' => 'varchar','precision' => '255','nullable' => False)
		),
		'pk' => array('original_id','reversal_id'),
		'fk' => array('original_id' => 'perp_supplier_payment.payment_id','reversal_id' => 'perp_supplier_payment.payment_id','account_id' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	)
);
