<?php

// Required to force tables to InnoDB
require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.so_perp_api.inc.php');

	$test[] = '0.1.069';
	function perp_upgrade0_1_069() {
		$GLOBALS['egw_setup']->db->insert('egw_acl',array(
		        'acl_appname'  => 'perp_ap',
			'acl_location' => 'payment',
			'acl_rights'   => 3,
			'acl_account'  => 0,
			),false,__LINE__,__FILE__
		);
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.070';
	}


	$test[] = '0.1.070';
	function perp_ap_upgrade0_1_070()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_supplier_payment','payment_number',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_supplier_payment',array(
			'fd' => array(
				'payment_id' => array('type' => 'auto','precision' => '4','nullable' => False),
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'invoice_id' => array('type' => 'int','precision' => '4'),
				'amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'allocation_date' => array('type' => 'date'),
				'allocated_from' => array('type' => 'int','precision' => '4'),
				'payment_number' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('payment_id','trans_id','invoice_id'),
			'fk' => array('trans_id' => 'perp_supplier_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_supplier_payment.payment_id'),
			'ix' => array('payment_id','trans_id','invoice_id','payment_number'),
			'uc' => array(array('payment_id','invoice_id'))
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.071';
	}


	$test[] = '0.1.071';
	function perp_ap_upgrade0_1_071()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_shipment_detail','item_code',array(
			'type' => 'varchar',
			'precision' => '20',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.072';
	}


	$test[] = '0.1.072';
	function perp_ap_upgrade0_1_072()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_shipment_detail','item_code','line_no');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_shipment_detail','line_no',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_shipment_detail',array(
			'fd' => array(
				'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'purchase_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'float','precision' => '4','nullable' => False),
				'received' => array('type' => 'bool'),
				'invoiced' => array('type' => 'bool')
			),
			'pk' => array('shipment_id','purchase_order_id','line_no'),
			'fk' => array('shipment_id' => 'perp_shipment.shipment_id','purchase_order_id' => 'perp_purchase_order_detail.purchase_order_id','line_no' => 'perp_purchase_order_detail.line_no'),
			'ix' => array('shipment_id','purchase_order_id','line_no'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.073';
	}


	$test[] = '0.1.073';
	function perp_ap_upgrade0_1_073()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_goods_received','item_code','line_no');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_goods_received','line_no',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_goods_received',array(
			'fd' => array(
				'goods_received_id' => array('type' => 'auto','nullable' => False),
				'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'receive_date' => array('type' => 'timestamp','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_units' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'purchase_order_id' => array('type' => 'int','precision' => '4'),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'quantity_our_uom' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('goods_received_id'),
			'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_purchase_order_detail.line_no','purchase_order_id' => 'perp_purchase_order_detail.purchase_order_id','stock_id' => 'perp_stock_id.stock_id'),
			'ix' => array('goods_received_id','shipment_id','line_no','stock_id'),
			'uc' => array('goods_received_id')
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.074';
	}


	$test[] = '0.1.074';
	function perp_ap_upgrade0_1_074()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_goods_received','stock_id','stock_cost_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_goods_received',array(
			'fd' => array(
				'goods_received_id' => array('type' => 'auto','nullable' => False),
				'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'receive_date' => array('type' => 'timestamp','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_units' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'purchase_order_id' => array('type' => 'int','precision' => '4'),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'quantity_our_uom' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('goods_received_id'),
			'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_purchase_order_detail.line_no','purchase_order_id' => 'perp_purchase_order_detail.purchase_order_id','stock_id' => 'perp_stock_id.stock_id'),
			'ix' => array('goods_received_id','shipment_id','line_no','stock_id'),
			'uc' => array('goods_received_id')
		),'direct_cost');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_goods_received',array(
			'fd' => array(
				'goods_received_id' => array('type' => 'auto','nullable' => False),
				'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'receive_date' => array('type' => 'timestamp','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_units' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'purchase_order_id' => array('type' => 'int','precision' => '4'),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'quantity_our_uom' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('goods_received_id'),
			'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_purchase_order_detail.line_no','purchase_order_id' => 'perp_purchase_order_detail.purchase_order_id','stock_id' => 'perp_stock_id.stock_id'),
			'ix' => array('goods_received_id','shipment_id','line_no','stock_id'),
			'uc' => array('goods_received_id')
		),'indirect_cost');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_goods_received',array(
			'fd' => array(
				'goods_received_id' => array('type' => 'auto','nullable' => False),
				'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'receive_date' => array('type' => 'timestamp','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_units' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'purchase_order_id' => array('type' => 'int','precision' => '4'),
				'stock_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('goods_received_id'),
			'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_purchase_order_detail.line_no','purchase_order_id' => 'perp_purchase_order_detail.purchase_order_id','stock_id' => 'perp_stock_id.stock_id'),
			'ix' => array('goods_received_id','shipment_id','line_no','stock_id'),
			'uc' => array('goods_received_id')
		),'quantity_our_uom');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_goods_received','stock_cost_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_goods_received',array(
			'fd' => array(
				'goods_received_id' => array('type' => 'auto','nullable' => False),
				'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'receive_date' => array('type' => 'timestamp','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_units' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'purchase_order_id' => array('type' => 'int','precision' => '4'),
				'stock_cost_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('goods_received_id'),
			'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_purchase_order_detail.line_no','purchase_order_id' => 'perp_purchase_order_detail.purchase_order_id','stock_cost_id' => 'perp_stock_cost.stock_cost_id'),
			'ix' => array('goods_received_id','shipment_id','line_no'),
			'uc' => array('goods_received_id')
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.075';
	}


	$test[] = '0.1.075';
	function perp_ap_upgrade0_1_075()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_supplier_stock',array(
			'fd' => array(
				'supplier_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'supplier_code' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'supplier_uom' => array('type' => 'int','precision' => '4','nullable' => False),
				'conversion_factor' => array('type' => 'decimal','precision' => '6','scale' => '4','nullable' => False,'default' => '1'),
				'lead_time' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '7'),
				'preferred' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1')
			),
			'pk' => array('supplier_id','supplier_code'),
			'fk' => array('supplier_id' => 'perp_supplier.supplier_id','stock_id' => 'perp_stock.stock_id','supplier_uom' => 'perp_unit_of_measure.uom_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.076';
	}


	$test[] = '0.1.076';
	function perp_ap_upgrade0_1_076()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_supplier_ledger','supplier','supplier_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_supplier_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'supplier' => array('type' => 'int','precision' => '4','nullable' => False),
				'due_date' => array('type' => 'date'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False,'default' => '0'),
				'purchase_order_id' => array('type' => 'int','precision' => '4'),
				'reference' => array('type' => 'text'),
				'supplier_reference' => array('type' => 'varchar','precision' => '20'),
				'comment' => array('type' => 'text'),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','supplier' => 'perp_supplier.supplier_id','purchase_order_id' => 'perp_purchase_order.purchase_order_id','line_no' => 'perp_general_ledger.line_no'),
			'ix' => array('trans_id','line_no'),
			'uc' => array(array('trans_id','line_no'))
		),'paid');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_supplier_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'supplier' => array('type' => 'int','precision' => '4','nullable' => False),
				'due_date' => array('type' => 'date'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False,'default' => '0'),
				'reference' => array('type' => 'text'),
				'supplier_reference' => array('type' => 'varchar','precision' => '20'),
				'comment' => array('type' => 'text'),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','supplier' => 'perp_supplier.supplier_id','purchase_order_id' => 'perp_purchase_order.purchase_order_id','line_no' => 'perp_general_ledger.line_no'),
			'ix' => array('trans_id','line_no'),
			'uc' => array(array('trans_id','line_no'))
		),'purchase_order_id');
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.077';
	}


	$test[] = '0.1.077';
	function perp_ap_upgrade0_1_077()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_supplier_ledger','reference','link');
		/*
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_supplier_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'supplier_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'due_date' => array('type' => 'date'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False,'default' => '0'),
				'supplier_reference' => array('type' => 'varchar','precision' => '20'),
				'comment' => array('type' => 'text'),
				'link' => array('type' => 'text'),
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','supplier_id' => 'perp_supplier.supplier_id','line_no' => 'perp_general_ledger.line_no'),
			'ix' => array('trans_id','line_no'),
			'uc' => array(array('trans_id','line_no'))
		));
		*/
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.078';
	}

	$test[] = '0.1.078';
	function perp_ap_upgrade0_1_078()
	{
		$sql = "UPDATE egw_acl SET acl_location = 'order' WHERE acl_appname = 'perp_ap' AND acl_location = 'purchase_order'";
		$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.079';
	}

	$test[] = '0.1.079';
	function perp_ap_upgrade0_1_079() {
		$GLOBALS['egw_setup']->oProc->RenameTable('perp_invoice', 'perp_payable_invoice');
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.080';
	}

	$test[] = '0.1.080';
	function perp_ap_upgrade0_1_080() {
		$GLOBALS['egw_setup']->oProc->DropTable('perp_shipment_detail');
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.081';
	}


	$test[] = '0.1.081';
	function perp_ap_upgrade0_1_081()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_supplier_stock','conversion_factor',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '4',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.082';
	}


	$test[] = '0.1.082';
	function perp_ap_upgrade0_1_082()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_supplier_ship_package',array(
			'fd' => array(
				'supplier_id' => array('type' => 'int','precision' => '4'),
				'supplier_code' => array('type' => 'varchar','precision' => '20'),
				'unit_of_measure' => array('type' => 'int','precision' => '4'),
				'length' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'width' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'height' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'mass' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0.1')
			),
			'pk' => array(),
			'fk' => array('supplier_id' => 'perp_supplier.supplier_id','supplier_code' => 'perp_supplier_stock.supplier_code','unit_of_measure' => 'perp_unit_of_measure.uom_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.083';
	}


	$test[] = '0.1.083';
	function perp_ap_upgrade0_1_083()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_supplier_stock','average_indirect_cost',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '4',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.084';
	}


	$test[] = '0.1.084';
	function perp_ap_upgrade0_1_084()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_supplier','user_account',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_supplier',array(
			'fd' => array(
				'supplier_id' => array('type' => 'auto','nullable' => False),
				'supplier_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'supplier_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'supplier_currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
				'supplier_since' => array('type' => 'date','nullable' => False),
				'payment_terms' => array('type' => 'int','precision' => '4','nullable' => False),
				'bank_account' => array('type' => 'varchar','precision' => '30'),
				'bank_reference' => array('type' => 'varchar','precision' => '12'),
				'bank_particulars' => array('type' => 'varchar','precision' => '12'),
				'remittance' => array('type' => 'int','precision' => '4'),
				'tax_group' => array('type' => 'int','precision' => '4','nullable' => False),
				'supplier_num' => array('type' => 'varchar','precision' => '10','nullable' => False),
				'user_account' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('supplier_id'),
			'fk' => array('supplier_address' => 'perp_address.address_id','supplier_currency' => 'perp_currency.currency_id','payment_terms' => 'perp_payment_term.payment_term_id','tax_group' => 'perp_tax_group.tax_group_id','user_account' => 'egw_accounts.account_id'),
			'ix' => array('supplier_id'),
			'uc' => array('supplier_id','supplier_name','supplier_num')
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.085';
	}


	$test[] = '0.1.085';
	function perp_ap_upgrade0_1_085()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_supplier','status',array(
			'type' => 'int',
			'precision' => '1',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.086';
	}


	$test[] = '0.1.086';
	function perp_ap_upgrade0_1_086()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_supplier','status','supplier_status');

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.087';
	}


	$test[] = '0.1.087';
	function perp_ap_upgrade0_1_087()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_supplier','supplier_status',array(
			'type' => 'int',
			'precision' => '1',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.088';
	}


	$test[] = '0.1.088';
	function perp_ap_upgrade0_1_088()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_supplier_stock','supplier_code',array(
			'type' => 'varchar',
			'precision' => '50',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.089';
	}

	$test[] = '0.1.089';
	function perp_ap_upgrade0_1_089()
	{
		// Add forgotten shipment admin rights
		$GLOBALS['egw_setup']->oProc->query("UPDATE egw_acl SET acl_rights = 79 WHERE acl_appname = 'perp_ap' AND acl_location = 'shipment' AND acl_account = 0");
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.090';
	}


	$test[] = '0.1.090';
	function perp_ap_upgrade0_1_090()
	{
		// Add invoice admin (post) rights
		$GLOBALS['egw_setup']->oProc->query("UPDATE egw_acl SET acl_rights = 79 WHERE acl_appname = 'perp_ap' AND acl_location = 'invoice' AND acl_account = 0");

		// Make sure everyone who can post now can still post
		$GLOBALS['egw_setup']->oProc->query("UPDATE egw_acl SET acl_rights = acl_rights + 64 WHERE acl_appname = 'perp_ap' AND acl_location = 'invoice' AND acl_rights > 4");
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.1.091';
	}

	$test[] = '0.1.091';
	function perp_ap_upgrade0_1_091()
	{
		if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
			// These tables need to be InnoDB
			$transaction_tables = array(
				'perp_supplier_ledger',
				'perp_goods_received',
				'perp_supplier_payment',
			);
			$so_perp_api = CreateObject('perp_api.so_perp_api');
			$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_ap', $transaction_tables);
		}
		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2';
	}


function perp_ap_upgrade0_2()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_supplier','credit_limit',array(
		'type' => 'decimal',
		'precision' => '20',
		'scale' => '2'
	));

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.001';
}

	function perp_ap_upgrade0_2_001()
	{
		echo "Warning:<br />
			This update changes all POs, and all associated documents, from
			using the supplier's unit of measure to using OUR unit of measure.
			The other associated documents include:<br />
			- Shipments<br />
			- Invoices<br />
			- Received goods<br />
			You should verify your data after this update.";

		$sql = 'UPDATE 
			perp_order_line
		JOIN perp_order ON
			perp_order.order_id = perp_order_line.order_id
		JOIN perp_supplier_stock ON
			perp_supplier_stock.supplier_id = perp_order.supplier_id AND
			perp_supplier_stock.supplier_code = perp_order_line.supplier_stock_code AND
			perp_supplier_stock.stock_id != 0
		LEFT JOIN perp_shipment_line ON
			perp_shipment_line.shippable_id = perp_order_line.order_id AND
			perp_shipment_line.shippable_item_line = perp_order_line.line_no
		LEFT JOIN perp_invoice_line ON
			perp_invoice_line.invoicable_id = perp_order_line.order_id AND
			perp_invoice_line.invoicable_item_line = perp_order_line.line_no
		LEFT JOIN perp_goods_received ON
			perp_goods_received.shipment_id = perp_shipment_line.shipment_id AND
			perp_goods_received.line_no = perp_shipment_line.line_no
		SET
			perp_order_line.unit_price = round(perp_order_line.unit_price / (perp_supplier_stock.quantity * perp_supplier_stock.conversion_factor),2),
			perp_order_line.quantity_ordered = quantity_ordered * (perp_supplier_stock.quantity * perp_supplier_stock.conversion_factor),
			perp_shipment_line.quantity_shipped = quantity_shipped * (perp_supplier_stock.quantity * perp_supplier_stock.conversion_factor),
			perp_invoice_line.quantity = perp_invoice_line.quantity * (perp_supplier_stock.quantity * perp_supplier_stock.conversion_factor),
			perp_invoice_line.unit_price = round(perp_order_line.unit_price / (perp_supplier_stock.quantity * perp_supplier_stock.conversion_factor),2),
			perp_goods_received.quantity_units = perp_goods_received.quantity_units * (perp_supplier_stock.quantity * perp_supplier_stock.conversion_factor)
		WHERE 
			perp_order.supplier_id != 0 AND
			quantity_ordered * (perp_supplier_stock.quantity * perp_supplier_stock.conversion_factor) != 0 AND
			perp_order_line.quantity_ordered != quantity_ordered * (perp_supplier_stock.quantity * perp_supplier_stock.conversion_factor)';

		$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);

		return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.002';
	}

function perp_ap_upgrade0_2_002() {
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_receiving_not_ordered',array(
		'fd' => array(
			'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'supplier_stock_code' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '4','nullable' => False),
			'unit_price' => array('type' => 'float','precision' => '4','nullable' => False),
			'received_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'received_date'	=> array('type' => 'timestamp','nullable' => False)
		),
		'pk' => array(),
		'fk' => array('shipment_id' => 'perp_shipment.shipment_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array('shipment_id'),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.003';
}


function perp_ap_upgrade0_2_003()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_receiving_not_ordered','id',array(
		'type' => 'auto',
		'nullable' => False
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_receiving_not_ordered',array(
		'fd' => array(
			'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'supplier_stock_code' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '4','nullable' => False),
			'unit_price' => array('type' => 'float','precision' => '4','nullable' => False),
			'received_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'received_date' => array('type' => 'timestamp','nullable' => False),
			'id' => array('type' => 'auto','nullable' => False)
		),
		'pk' => array('id'),
		'fk' => array('shipment_id' => 'perp_shipment.shipment_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array('shipment_id'),
		'uc' => array()
	));

	$GLOBALS['egw_setup']->oProc->query("UPDATE egw_acl SET acl_rights = 69 WHERE acl_appname = 'perp_ap' AND acl_location = 'receive' AND acl_account = 0");

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.004';
}


function perp_ap_upgrade0_2_004()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_goods_received','received_by',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_goods_received',array(
		'fd' => array(
			'goods_received_id' => array('type' => 'auto','nullable' => False),
			'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'receive_date' => array('type' => 'timestamp','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_units' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'purchase_order_id' => array('type' => 'int','precision' => '4'),
			'stock_cost_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'received_by' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('goods_received_id'),
		'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_purchase_order_detail.line_no','purchase_order_id' => 'perp_purchase_order_detail.purchase_order_id','stock_cost_id' => 'perp_stock_cost.stock_cost_id','received_by' => 'egw_accounts.account_id'),
		'ix' => array('goods_received_id','shipment_id','line_no'),
		'uc' => array('goods_received_id')
	));

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.005';
}


function perp_ap_upgrade0_2_005()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_supplier_payment','payment_number',array(
		'type' => 'varchar',
		'precision' => '20',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.006';
}


function perp_ap_upgrade0_2_006()
{
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_supplier_payment',array(
		'fd' => array(
			'payment_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'invoice_id' => array('type' => 'int','precision' => '4'),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'allocation_date' => array('type' => 'date'),
			'allocated_from' => array('type' => 'int','precision' => '4'),
			'payment_number' => array('type' => 'varchar','precision' => '20','nullable' => False)
		),
		'pk' => array('payment_id','trans_id','invoice_id','allocated_from'),
		'fk' => array('trans_id' => 'perp_supplier_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_supplier_payment.payment_id'),
		'ix' => array('payment_id','trans_id','invoice_id','payment_number'),
		'uc' => array(array('payment_id','invoice_id'))
	));

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.007';
}


function perp_ap_upgrade0_2_007()
{
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_supplier_payment',array(
		'fd' => array(
			'payment_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'invoice_id' => array('type' => 'int','precision' => '4'),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'allocation_date' => array('type' => 'date'),
			'allocated_from' => array('type' => 'int','precision' => '4'),
			'payment_number' => array('type' => 'varchar','precision' => '20','nullable' => False)
		),
		'pk' => array('payment_id','trans_id','invoice_id','allocated_from'),
		'fk' => array('trans_id' => 'perp_supplier_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_supplier_payment.payment_id'),
		'ix' => array('payment_id','trans_id','invoice_id','payment_number'),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.008';
}

function perp_ap_upgrade0_2_008()
{
	$GLOBALS['egw_setup']->oProc->query("
		UPDATE egw_acl SET acl_rights = 11 
		WHERE acl_appname = 'perp_ap' AND acl_location = 'payment' AND acl_account = 0
	");
	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.009';
}

function perp_ap_upgrade0_2_009()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_payment_reversal',array(
		'fd' => array(
			'original_id' => array('type' => 'int','precision' => '4'),
			'reversal_id' => array('type' => 'int','precision' => '4'),
			'account_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'timestamp' => array('type' => 'timestamp','nullable' => False),
			'reason' => array('type' => 'varchar','precision' => '255','nullable' => False)
		),
		'pk' => array('original_id','reversal_id'),
		'fk' => array('original_id' => 'perp_supplier_payment.payment_id','reversal_id' => 'perp_supplier_payment.payment_id','account_id' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.010';
}


// Force tables to InnoDB
so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_ap');

function perp_ap_upgrade0_2_010()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_supplier','supplier_num',array(
		'type' => 'varchar',
		'precision' => '20',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_ap']['currentver'] = '0.2.011';
}

