<?php
	/**
	*	Utility stuff for working with barcodes
	*/

	class perp_barcode {

		/**
		*	Cache the check to see if the barcode generator is available,
		*	so we don't have to actually check every time.
		*/
		private static $enabled = null;

		/**
		*	Get a list of encodings we know how to create
		*
		*	@return array of ID => Human name
		*/
		public static function get_encoding_list() {
			$list = array(
				'ean13'		=>	'EAN-13',
				'upca'		=>	'UPC-A',
				'code128'	=>	'Code 128',
				'Code39'	=>	'Code 39',
				'int25'		=>	'Int 25',
				'postnet'	=>	'US Post POSTNET'
			);
			
			return $list;
		}

		/**
		*	Check to see if the barcode generation system is 
		*	installed
		*/
		public static function is_enabled() {
			if(is_null(self::$enabled)) {
self::$enabled = true;
			}
			return self::$enabled;
		}
	}
?>
