<?php
	/**
	*	Hooks for eGroupWare 
	*	The hooks allow pERP to participate closely in most of eGroupWare's wonderful functions
	*	@ingroup perp_api
	*/
	class hook_perp_api {
		
		var $public_functions = array(
			'config'	=>	True,
			'admin_hook'	=>	True,
			'acl'	=>	True,
			'currency'	=>	True,
			'shipper'	=>	True,
			'unit_of_measure'	=>	True,
			'payment_term'	=>	True,
			'payment_method'	=>	True,
			'taxes'		=>	True,
			'tax_location'	=>	True,
			'tax_category'	=>	True,
			'tax_authority'	=>	True,
			'tax_group'	=>	True,
			'tax_auth_rate'	=>	True,
			'tax_group_tax'	=>	True,
			'register_reports'	=>	True,
			'clear_report_lock'	=>	true,
		);

		var $appname = 'perp_api';
		var $ui;
		var $template;

		public function hook_perp_api() {
			$this->ui = CreateObject('perp_api.ui_perp_api');
			$this->template = CreateObject('etemplate.etemplate');
		}

		public function admin_hook() {
			$file = array(
				'Site Configuration'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_api.hook_perp_api.config',
					'appname'	=> 'perp_api',
				))
			);
			if($GLOBALS['egw']->acl->check('acl', EGW_ACL_READ, 'perp_api')) {
				$file['Configure Access Permissions']	=	$GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_api.hook_perp_api.acl',
				));
			}

			if($GLOBALS['egw']->acl->check('unit_of_measure', EGW_ACL_READ, 'perp_api')) {
				$file['Units of Measure']    =	$GLOBALS['egw']->link('/index.php', array(
					'menuaction'    => 'perp_api.hook_perp_api.unit_of_measure',
				));
			}
			if($GLOBALS['egw']->acl->check('shipper', EGW_ACL_READ, 'perp_api')) {
				$file['Shippers']    =	$GLOBALS['egw']->link('/index.php', array(
					'menuaction'    => 'perp_api.hook_perp_api.shipper',
				));
			}
			if($GLOBALS['egw']->acl->check('currency', EGW_ACL_READ, 'perp_api')) {
				$file['Currencies']    =	$GLOBALS['egw']->link('/index.php', array(
					'menuaction'    => 'perp_api.hook_perp_api.currency',
				));
			}
			if($GLOBALS['egw']->acl->check('payment_term', EGW_ACL_READ, 'perp_api')) {
				$file['Payment Terms']    =	$GLOBALS['egw']->link('/index.php', array(
					'menuaction'    => 'perp_api.hook_perp_api.payment_term',
				));
			}
			if($GLOBALS['egw']->acl->check('payment_method', EGW_ACL_READ, 'perp_api')) {
				$file['Payment Type']    =	$GLOBALS['egw']->link('/index.php', array(
					'menuaction'    => 'perp_api.hook_perp_api.payment_method',
				));
			}
			if($GLOBALS['egw']->acl->check('tax_authority', EGW_ACL_READ, 'perp_api') ||
					$GLOBALS['egw']->acl->check('tax_auth_rate', EGW_ACL_READ, 'perp_api') ||
					$GLOBALS['egw']->acl->check('tax_category', EGW_ACL_READ, 'perp_api') ||
					$GLOBALS['egw']->acl->check('tax_group', EGW_ACL_READ, 'perp_api') ||
					$GLOBALS['egw']->acl->check('tax_group_tax', EGW_ACL_READ, 'perp_api') ||
					$GLOBALS['egw']->acl->check('tax_location', EGW_ACL_READ, 'perp_api')) {
				$file['Taxes']    =	$GLOBALS['egw']->link('/index.php', array(
					'menuaction'    => 'perp_api.hook_perp_api.taxes',
				));
			}
			$file['Find and register all pERP reports']    =	$GLOBALS['egw']->link('/index.php', array(
				'menuaction'    => 'perp_api.hook_perp_api.register_reports',
			));
			$config = config::read($this->appname);
			if($GLOBALS['egw']->acl->check('run', EGW_ACL_READ, 'admin') && ExecMethod('perp_api.bo_perp_report.is_locked')) {
				$count = count(ExecMethod('phpgwapi.asyncservice.read', '%.LOCKED-RESCHEDULE'));
				$label = lang('Clear Report Lock (%1 waiting)', $count);
				$file[$label]	=	$GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=>	'perp_api.hook_perp_api.clear_report_lock',
				));
			}
			
			display_section($this->appname, $file);
		}
		
		public function config($content = array()) {
			$selects['exchange_rate_datasource'] = ExecMethod('perp_api.bo_perp_exchange_update.get_datasource_list');

			ExecMethod('phpgwapi.asyncservice.cancel_timer', 'perp_api.bo_perp_exchange_update.update_all');
			if($content['settings']['cancel_exchange_update']) {
				ExecMethod('phpgwapi.asyncservice.cancel_timer', 'perp_api.bo_perp_exchange_update.update_all');
				unset($content['settings']['cancel_exchange_update']);
				$content['settings']['async'] = array();
				$content['save'] = true;
				$this->ui->messages[] = array(lang('Exchange rate will not be automatically updated'), 'success');
			} elseif(isset($content['settings']['update_exchange_rate'])) {
				$result = ExecMethod('perp_api.bo_perp_exchange_update.update_all');
				if(is_array($result)) {
					foreach($result as $currency => $rate) {
						if($rate === false) {
							$this->ui->messages[] = array(lang('Could not update %1', $currency), 'warning');
						} else {
							$this->ui->messages[] = array("$currency = $rate", 'info');
						}
					}
				}
			} elseif($content['settings']['async']) {
				$result = ExecMethod2(
					'phpgwapi.asyncservice.set_timer', 
					$content['settings']['async'], 
					'perp_api.bo_perp_exchange_update.update_all',
					'perp_api.bo_perp_exchange_update.update_all',
					null
				);
				if($result == true && ExecMethod('phpgwapi.asyncservice.installed')) {
					$next_run = ExecMethod('phpgwapi.asyncservice.next_run', $content['settings']['async']);
					$next_run = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'] . ' H:i', $next_run);
					$this->ui->messages[] = array(
						lang('Exchange rate will be automatically updated from %2.  (Next update on %1)', 
							$next_run,
							$content['settings']['exchange_rate_datasource']
						), 
						'success'
					);
				} else {
					$this->ui->messages[] = array(lang('Exchange rate will not be automatically updated'), 'warning');
				}
					
			}

			// validation & correction
			//...

			$this->ui->config($content, $this->appname, 'perp_api.hook_perp_api.config',$selects);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences'] = $GLOBALS['egw']->link(
				'/preferences/preferences.php',
				'appname=' . $this->appname
			);
			display_section($this->appname, $this->appname, $file);
		}

		public function acl($content = array()) {
			$this->ui->acl($content, 'perp_api', 'acl', 'acl');
		}

		public function unit_of_measure($content = array()) {
			$this->ui->change_lookup($content, 'perp_api', 'unit_of_measure', 'uom', $selects);
		}

		public function shipper($content = array()) {
			$this->ui->change_lookup($content, 'perp_api', 'shipper', 'shipper', $selects);
		}

		public function currency($content = array()) {
			if(isset($content['nm']['rows']['new']) && is_numeric($content['nm']['rows']['new']['currency_id'])) {
				$this->ui->messages[] = array(lang('Currency Code should be the three letter international currency code'), 'warning');
			}
			if(is_array($content['nm']['rows'])) {
				foreach($content['nm']['rows'] as $key => &$row) {
					if((is_numeric($key) || ($key == 'new' && $row['currency_name'])) && $row['exchange_rate'] == 0) {
						$this->ui->messages[] = array(lang('%1 has an exchange rate of 0.  This will zero out any transactions in this currency.', $row['currency_name']), 'warning');
					}
				}
			}
			$this->ui->change_lookup($content, 'perp_api', 'currency', 'currency', $selects);
		}

		public function payment_term($content = array()) {
			$selects['due_date_type'] = array(
				0	=>	lang('number of days'),
				1	=>	lang('day of next month')
			);
			$selects['discount_date_type'] = $selects['due_date_type'];

			$this->ui->change_lookup($content, 'perp_api', 'payment_term', 'payment_term', $selects);
		}

		public function payment_method($content = array()) {
			$this->ui->change_lookup($content, 'perp_api', 'payment_method', 'payment_method', $selects);
		}

		public function taxes($content = array()) {
			if($content['cancel']) {
				unset($content['cancel']);
				$GLOBALS['egw']->redirect_link('/admin/index.php'); 
			}
			$GLOBALS['egw_info']['flags']['app_header'] = lang('perp_api') .' - ' .lang('Admin').' - '. lang('Taxes');
			$this->template->read('perp_api.admin.taxes');
			$this->template->exec('perp_api.hook_perp_api.taxes', $data, $select_box, $read_only);
		}

		public function tax_category($content = array()) {
			$this->ui->change_lookup($content, 'perp_api', 'tax_category', 'tax_category', $selects);
		}

		public function tax_location($content = array()) {
			$this->ui->change_lookup($content, 'perp_api', 'tax_location', 'tax_location', $selects);
		}

		public function tax_group($content = array()) {
			$this->ui->change_lookup($content, 'perp_api', 'tax_group', 'tax_group', $selects);
		}

		public function tax_group_tax($content = array()) {
			$bo = CreateObject('perp_api.bo_perp_api');

			// This one needs special handling because of the multi-part key
			if(isset($content['save'])) {
				foreach($content['nm']['rows'] as $key => $row) {
					$id = array('tax_group_id' => $row['tax_group_id'],
						'tax_authority_id' => $row['tax_authority_id']);
					if($id['tax_group_id'] && $id['tax_authority_id']) {
						$bo->change_lookup('perp_tax_group_tax', 'perp_api', $id, $row);
					}
				}
				unset($content['save']);
			} elseif (isset($content['nm']['rows']['delete'])) {
				$key = key($content['nm']['rows']['delete']);
				$key = explode(',', $key);
				$id['tax_group_id']=$key[0];
				$id['tax_authority_id'] = $key[1];
				$bo->change_lookup('perp_tax_group_tax', 'perp_api', $id, null);
				unset($content['nm']);
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', 
					array('menuaction' => 'perp_api.hook_perp_api.taxes'));
				unset($content['cancel']);
			}
			$selects['tax_group_id'] = $bo->get_tax_groups();
			$selects['tax_authority_id'] = $bo->get_tax_authorities();
			$this->ui->change_lookup($content, 'perp_api', 'tax_group_tax', 'tax_group_tax', $selects);
		}

		public function tax_authority($content = array()) {
			$bo = CreateObject('perp_ledger.bo_perp_ledger');
			$selects['tax_authority_in_account'] = $bo->get_accounts();
			$selects['tax_authority_out_account'] = $selects['tax_authority_in_account'];
			$this->ui->change_lookup($content, 'perp_api', 'tax_authority', 'tax_authority', $selects);
		}

		public function tax_auth_rate($content = array()) {
			$bo = CreateObject('perp_api.bo_perp_api');
			$selects['tax_authority'] = $bo->get_tax_authorities();
			$selects['tax_source_location'] = $bo->get_tax_locations();
			$selects['tax_category'] = $bo->get_tax_categories();

			// This one needs special handling because of the multi-part key
			if(isset($content['save'])) {
				foreach($content['nm']['rows'] as $key => $row) {
					$id = array('tax_authority' => $row['tax_authority'],
						'tax_source_location' => $row['tax_source_location'],
						'tax_category' => $row['tax_category']);
					if($id['tax_authority'] && $id['tax_source_location'] && $id['tax_category']) {
						$bo->change_lookup('perp_tax_auth_rate', 'perp_api', $id, $row);
					}
				}
				unset($content['save']);
			} elseif (isset($content['nm']['rows']['delete'])) {
				$key = key($content['nm']['rows']['delete']);
				$key = explode(',', $key);
				$id['tax_authority'] = $key[0];
				$id['tax_source_location'] = $key[1];
				$id['tax_category'] = $key[2];
				$bo->change_lookup('perp_tax_auth_rate', 'perp', $id, null);
				unset($content['nm']['rows']['delete']);
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', 
					array('menuaction' => 'perp_api.hook_perp_api.taxes'));
				unset($content['cancel']);
			}

			$this->ui->change_lookup($content, 'perp_api', 'tax_auth_rate', '', $selects);
		}

		/**
		*	Look in perp_* /inc/report for reports
		*	For each report <report_name>, add report_<report_name> to the ACL table (account 0)
		*
		*	Remove any reports not found from the ACL table
		*/
		public function register_reports() {

			// Get perp directories
			$perp_directories = array();
			if($egw_dir = opendir(EGW_INCLUDE_ROOT)) {
				while ( false !== ($file = readdir($egw_dir))) {
					if(is_dir($file) && strpos($file, 'perp_') === 0) {
						$perp_directories[] = $file;
					}
				}
			}
			closedir($egw_dir);

			// Look for reports in each perp directory
			foreach($perp_directories as $dir) {
				$reports = array();
				if($report_dir = @opendir(EGW_INCLUDE_ROOT . '/' . $dir . '/inc/report/')) {
					while( false !== ($file = readdir($report_dir))) {
						if(!is_dir($file)) {
							// Get the extension, only .odt and .php are allowed
							$name_parts = explode('.', $file);
							$ext = $name_parts[count($name_parts) - 1];

							if($ext == 'php') {
								$reports[] = $name_parts[1];
							}
						}
					}
				} else {
					continue;
				}

				$config = config::read($dir);

				// Add reports to ACLs
				foreach($reports as $report_name) {
					$GLOBALS['egw']->db->insert('egw_acl',
						array(
							'acl_appname'	=>	$dir,
							'acl_location'	=>	'report_' . $report_name,
							'acl_account'	=>	0,
							'acl_rights'	=>	EGW_ACL_READ
						),
						array(
							'acl_appname'	=>	$dir,
							'acl_location'	=>	'report_' . $report_name,
							'acl_account'	=>	0,
						),
						__LINE__, __FILE__
					);
					echo "Added $dir / $report_name <br />";

					// Allow report to be adhoc & scheduled
					if(!array_key_exists($report_name, $config)) {
						$config['report_' . $report_name]['can_adhoc'] = true;
						$config['report_' . $report_name]['can_schedule'] = true;
						config::save_value('report_' . $report_name, $config['report_' . $report_name], $dir);
					}
				}

				// Find reports that have been removed
				if(count($reports) > 0) {
					$sql = "DELETE FROM egw_acl 
						WHERE acl_appname='$dir' AND (
							acl_location LIKE 'report_%' AND 
							acl_location NOT IN ('report_" . implode("','report_", $reports) . "')
						)";
					$GLOBALS['egw']->db->query($sql, __LINE__, __FILE__);
					echo $GLOBALS['egw']->db->affected_rows() . ' deleted<br />';
				}
			}
//			$GLOBALS['egw']->redirect_link('/admin/index.php');
		}

		public function clear_report_lock() {
			if($GLOBALS['egw']->acl->check('run', EGW_ACL_READ, 'admin')) {
				ExecMethod('perp_api.bo_perp_report.unlock');
			}
			$GLOBALS['egw']->redirect_link('/admin/index.php');
		}
	}
?>
