<?php
	require_once('class.exchange_datasource.inc.php');

	/**
	*	Google currency exchange rate datasource
	*
	*	Google has an unofficial currency exchanger
	*	if you search for 1 <Currency> in <GL_Currency>.  
	*	We'll scrape the response from the results page
	*
	*	@ingroup exchange_update
	*/
	class google extends exchange_datasource {
	
		protected $query_string = 'http://www.google.com/search?&q=1+%1$s+in+%2$s';
		
		public function google() {
			parent::__construct();
		}

		public function update_all() {
			$currencies = ExecMethod('perp_api.bo_perp_api.get_currencies');
			$results = array();
			foreach($currencies as $currency_id => $currency_name) {
				$results[$currency_id] = $this->update($currency_id);
			}
			return $results;
		}

		/**
		*	@param currency_id string Three letter currency ID
		*	@return float New exchange rate
		*/
		public function update($currency_id) {
			if($currency_id == $this->gl_currency) {
				return 1;
			}

			$query_string = sprintf($this->query_string, $currency_id, $this->gl_currency);
			$start = '<h2 class=r><font size=+1><b>';

			$page = fopen ($query_string, 'rb');
			if(!$page) {
				return false;
			} else {
				stream_set_timeout($page, 5);
			}
			while (!feof($page)) {
				$buffer = fgets($page, 4096);
				if(stripos($buffer, $start) !== false) {
					$buffer = substr($buffer, stripos($buffer, $start));
					break;
				}
			}
			fclose($page);

			// Extract rate
			$matches = array();
			if( preg_match('/[0-9]+\.[0-9]+/', $buffer, $matches) == 1) {
				// Update currency
				return $this->update_currency($currency_id, $matches[0]);
			}
			return false;
		}
	}
?>
