<?php
	require_once('class.exchange_datasource.inc.php');

	/**
	*	Yahoo currency exchange rate datasource
	*
	*	Yahoo will return a conversion rate as a search result
	*	if you search for "convert 1 <Currency> to <GL_Currency>"
	*	We'll scrape the response from the results page
	*
	*	@ingroup exchange_update
	*/
	class yahoo extends exchange_datasource {
	
		protected $query_string = 'http://finance.yahoo.com/currency/convert?amt=1&from=%1$s&to=%2$s';
		
		public function yahoo() {
			parent::__construct();
		}

		public function update_all() {
			$currencies = ExecMethod('perp_api.bo_perp_api.get_currencies');
			$results = array();
			foreach($currencies as $currency_id => $currency_name) {
				$results[$currency_id] = $this->update($currency_id);
			}
			return $results;
		}

		/**
		*
		*	@param currency_id string Three letter currency ID
		*	@return float New exchange rate
		*/
		public function update($currency_id) {
			if($currency_id == $this->gl_currency) {
				return 1;
			}

			$query_string = sprintf($this->query_string, $currency_id, $this->gl_currency);
			$start = 'Currency Conversion Results';

			$page = fopen ($query_string, 'rb');
			if(!$page) {
				return false;
			} else {
				stream_set_timeout($page, 5);
			}
			while (!feof($page)) {
				$buffer = fgets($page, 4096);
				if(stripos($buffer, $start) !== false) {
					$buffer = substr($buffer, stripos($buffer, $start));
					break;
				}
			}
			fclose($page);

			// Extract rate
			$matches = array();
			if( preg_match('/[0-9]+\.[0-9]+/', $buffer, $matches) == 1) {
				$new_rate = $matches[0];

				// Update currency
				return $this->update_currency($currency_id, $new_rate);
			}
			return false;
		}
	}
?>
