<!--
/** Javascript for handling enter keypresses
*	If you're on a nextmatch search text field and press enter, it will search
*	Otherwise, it will execute the next submit button on the form (hopefully save)
*
*	Optionally, you can provide an array in the form
*	array(
*		keycode => [ function | array( id => function) ]
*	)
*
*	to get more control over what happens
*/
-->
var id_map = null;

// Add handler to ... everything
function keyHandlerSetup(id_key_map) {
	id_map = id_key_map;

	if(document.addEventListener) {
		document.addEventListener('keypress', keyHandler, true);
	} else {
		var old = (document.onkeypress) ? document.onkeypress : function () {};
		document.onkeypress = function() {
			old();
			keyHandler();
		}
	}
}

function keyHandler(e) {
	// Get the event
	if(!e) {
		var e = window.event;
	}

	// Get the target
	var target;
	if(e.target) {
		target = e.target;
	} else if (e.srcElement) {
		target = e.srcElement;
	}
	if(e.nodeType == 3) { // Defeat Safari bug
		target = target.parentNode;
	}

	// Get key code
	var keycode;
	if(e.keyCode) {
		keycode = e.keyCode;
	} else if (e.which) {
		keycode = e.which
	}

	if(id_map && id_map[keycode]) {
		if(typeof(id_map[keycode]) == 'string') {
			eval(id_map[keycode] + '(' + e + ')');
		} else if (typeof(id_map[keycode]) == 'object' && id_map[keycode][target.id]) {
			eval(id_map[keycode][target.id] + '(' + e + ')');
		}
		e.cancelBubble = true;
		if (e.stopPropagation) {
			e.stopPropagation();
		}
		return false;
	} else if (keycode == 13) {
		if(target.id.substring(-8,8) == '[search]') {
			// Currently in the search field, so we submit the search
			var submit_button = target.id.substring(0, target.id.length - 8) + '[start_search]';
			submitit(eTemplate, submit_button);
		} else {
			var inputs = document.getElementsByTagName('input');
			for(var i = 0; i < inputs.length; i++) {
				if(inputs[i].type == 'submit' && inputs[i].id.substring(inputs[i].id.length-14) != '[start_search]') {
					submitit(inputs[i].form, inputs[i].id);
					break;
				}
			}
		}
		e.cancelBubble = true;
		if (e.stopPropagation) {
			e.stopPropagation();
		}
		return false;
	}
}
