
// Ajax callback object
var ajax_perp_callback = null;

function invoice_edit_setup() {
	// Register event handlers on quantity and unit price fields to recalculate totals
	var inputs = document.getElementsByTagName('input');
	for(i = 0; i < inputs.length; i++) {
		if(inputs[i].id.indexOf('quantity') > 1 || inputs[i].id.indexOf('unit_price') > 1) {
			if(inputs[i].addEventListener) {
				inputs[i].addEventListener('change', change_quantity, true);
			} else {
				inputs[i].onchange = change_quantity;
			}
			if(inputs[i].value) {
				change_quantity(inputs[i]);
			}
		} else if(inputs[i].id.indexOf('line_price') > 1) {
			inputs[i].disabled = "disabled";
			if(inputs[i].id.indexOf('new') < 0) {
				if(inputs[i].addEventListener) {
					inputs[i].addEventListener('change', calc_total, true);
				} else {
					inputs[i].onchange = calc_total;
				}
			}
		}
	}
	calc_total();
}

/** 
*	Change the supplier, and all associated data
*/
function change_supplier(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}

	if(target.value) {
		supplier_id = target.value;
		xajax_doXMLHTTP(ajax_perp_callback + ".change_supplier", supplier_id);
	}
}

/** 
*	Change the client, and all associated data
*/
function change_client(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}

	if(target.value) {
		client_id = target.value;
		xajax_doXMLHTTP(ajax_perp_callback + ".change_client", client_id);
	}
}

/**
*	Change the bill date or payment terms, we should recalculate the due date
*/
function update_due_date() {
	if(document.getElementById('exec[issue_date][str]')) {
		var issue_date = document.getElementById('exec[issue_date][str]').value;
	}
	if(document.getElementById('exec[payment_terms]')) {
		var payment_terms = document.getElementById('exec[payment_terms]').value;
	}
	xajax_doXMLHTTP(ajax_perp_callback + '.update_due_date', issue_date, payment_terms);
}

/**
*	Remove options from a select box
*	@param id - The id of the select
*/
function removeOptions(id) {
	if(document.getElementById(id)) {
		var element = document.getElementById(id);
		if(element.options) {
			while(element.options.length > 0) {
				element.remove(0);
			}
		}
	}
}

/**
*	Add an option to a select box
*	@param id - The id of the select box
*	@param key - The key of the option
*	@param value - The value of the option
*/
function addOption(id, key, value) {
	var objOption = new Option(value, key);
	var select = document.getElementById(id);
	if(select) {
		try {
			select.options.add(objOption); // standards compliant
		} catch (ex) {
			select.add(objOption); // IE
		}
	}
}

/**
*	Recalculate the invoice total
*/
function calc_total(e) {
	var inputs = document.getElementsByTagName('input');
	var total = 0;
	for(i = 0; i < inputs.length; i++) {
		if(inputs[i].id.indexOf('line_price') > 1 && inputs[i].id.indexOf('new') < 0) {
			total += parseFloat(inputs[i].value);
		}
	}
	var total_box = document.getElementById("exec[total]");
	if(total_box) {
		total_box.value = total.toFixed(2);
	}
}

/**
*	Change the all the other fields of an InvoiceLine when
*	the quantity changes.
*/
function change_quantity(e) {
	var recalc = true;
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.id) {
		var target = e;
		recalc = false;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}

	var regexp = /[0-9]+/;
	var line = regexp.exec(target.id);
	if(line == null && target.id.indexOf('new') >= 0) {
		line = '[new]';
	} else {
		line = "[nextmatch][rows][" + line + "]";
	}

	var quantity = document.getElementById("exec" + line + "[quantity]");
	var unit_price = document.getElementById("exec" + line + "[unit_price]");
	var line_price = document.getElementById("exec" + line + "[line_price]");
	if(line_price && unit_price && quantity) {
		line_price.value = (quantity.value * unit_price.value).toFixed(2);
	}
	
	if(recalc) {
		calc_total();
	}
}

/**
*	Change the link to addressbook when they change their contact person
*/
function change_contact(id, name) {
	tags = document.getElementsByTagName("td"); 
	var contact_div = null;
	// Find the div
	for( var i = 0; i < tags.length; i++ ) { 
		if( tags[i].className == 'contact_box' ) {
			contact_div = tags[i]; 
		}
	}
	var anchor = contact_div.getElementsByTagName("a");
	anchor = anchor[0];
	anchor.href = anchor.href.replace(/contact_id=[0-9]*/, "contact_id=" + id);
	anchor.innerHTML = name;
}
