/**
*	xajax callback object.  Passed from perp_api.ui_perp_order.get_javascript.
*	Function to call should be appended.
*/
var ajax_perp_order = null;
var supplier_id = null;

function order_edit_setup() {
	var supplier_select = document.getElementById('exec[supplier_id][value]');
	if(supplier_select) {
		supplier_id = supplier_select.value;
	} else {
		supplier_select = document.getElementById('exec[supplier]');
		if(supplier_select) {
			supplier_id = supplier_select.value;
		}
	}
}

/** 
*	Change the supplier, and all associated data
*/
function change_supplier(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}

	removeOptions('exec[supplier_code]');
	removeOptions('exec[stock_id]');

	if(target.value) {
		supplier_id = target.value;
		xajax_doXMLHTTP(ajax_perp_order + ".change_supplier", 
			document.forms[0].etemplate_exec_id.value,
			target.value
		);
	}
}

/* Remove options from a select box
*  @param id - The id of the select
*/
function removeOptions(id) {
	if(document.getElementById(id)) {
		var element = document.getElementById(id);
		if(element.options) {
			while(element.options.length > 0) {
				element.remove(0);
			}
		}
	}
}

/* Add an option to a select box
*  @param id - The id of the select box
*  @param key - The key of the option
*  @param value - The value of the option
*/
function addOption(id, key, value) {
	var objOption = new Option(value, key);
	var select = document.getElementById(id);
	if(select) {
		try {
			select.options.add(objOption); // standards compliant
		} catch (ex) {
			select.add(objOption); // IE
		}
	}
}

/* Called (as a callback) when the user selects an item from the item
*  List.  Sets the description and unit cost.
*/
function select_item(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}

	// Set quantity, description & cost lines
	var address = document.getElementById('exec[ship_to_address]');
	if(address) {
		address = address.value;
	}
	xajax_doXMLHTTP( ajax_perp_order + ".get_line_details", supplier_id, target.value, address);
}

function getElementsByClass(searchClass,node,tag) {
	var classElements = new Array();
	if ( node == null )
		node = document;
	if ( tag == null )
		tag = '*';
	var els = node.getElementsByTagName(tag);
	var elsLen = els.length;
	var pattern = new RegExp("(^|\\s)"+searchClass+"(\\s|$)");
	for (i = 0, j = 0; i < elsLen; i++) {
		if ( pattern.test(els[i].className) ) {
			classElements[j] = els[i];
			j++;
		}
	}
	return classElements;
}

function toggleLines(toggle) {
	var items = getElementsByClass("add_line");
	for(i = 0; i < items.length; i++) {
		items[i].style.visibility = (toggle ? 'visible' : 'hidden');
	}
}
