<?php
	// Set up ACLs
	$locations = array(
		'acl'		=>	5, 
		'currency'	=>	15, 
		'shipper'	=>	15, 
		'payment_term'	=>	15, 
		'payment_method'=>	15,
		'tax_authority'	=>	15, 
		'tax_auth_rate'	=>	15, 
		'tax_category'	=>	15, 
		'tax_group'	=>	15, 
		'tax_group_tax'	=>	15, 
		'tax_location'	=>	15, 
		'unit_of_measure'	=>	15,

		// Reports (must start with report_)
		'report_no_report'	=>	1,
	);
	// We assume that Admins group is group #2
	$admin = -2;

	foreach ($locations as $location => $access) {
		$sql = "INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) 
			VALUES ('perp_api', '$location', 0,$access)";
		$GLOBALS['egw_setup']->oProc->query($sql);

		// Give admin rights to everything
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_api', '$location', $admin, $access)");
	}

	// Give admin run rights
	$GLOBALS['egw_setup']->add_acl($application, 'run', $admin);
	

	// Default UoMs
	$uom = array (
		'Kilograms',
		'Liters',
		'Meters',
		'Grams'
		'Milliliters'
		'Centimeters',
		'Pounds',
		'Gallons',
		'Feet',

		'each',
		'bags',
		'boxes',
		'bundles',
		'cans',
		'cartons',
		'lengths',
		'lifts',
		'packages',
		'pallets',
		'rolls',
		'totes',
		
	);
	foreach($uom as $id => $name) {
		$sql = "INSERT INTO perp_unit_of_measure (uom_id, uom_name)
			VALUES($id + 1, '$name')";
		$GLOBALS['egw_setup']->oProc->query($sql);
	}

	// Default Shippers
	$shippers = array(
		'Pickup',
		'UPS Ground',
		'UPS Next Day Air'
		'UPS Express Critical',
		'Canada Post',
		'USPS',
		'FedEx Ground'
	);
	foreach($shippers as $id => $name) {
		$sql = "INSERT INTO perp_shipper (shipper_id, shipper_name)
			VALUES($id + 1, '$name')";
		$GLOBALS['egw_setup']->oProc->query($sql);
	}
	
	// Default Currencies
	$currencies = array (
		1	=>	array('currency_id' => 'EUR', 'currency_name' => 'Euro', 'country' => 'GB', 'hundreds_name' => '', 'exchange_rate' => 0),
		2	=>	array('currency_id' => 'USD', 'currency_name' => 'US Dollar', 'country' => 'US', 'hundreds_name' => 'cents', 'exchange_rate' => 0),
		3	=>	array('currency_id' => 'GBP', 'currency_name' => 'Pound Sterling', 'country' => 'GB', 'hundreds_name' => '', 'exchange_rate' => 0),
		4	=>	array('currency_id' => 'CAN', 'currency_name' => 'Canadian Dollar', 'country' => 'CA', 'hundreds_name' => 'cents', 'exchange_rate' => 0),
		5	=>	array('currency_id' => 'JPY', 'currency_name' => 'Japanese Yen', 'country' => 'JP', 'hundreds_name' => '', 'exchange_rate' => 0),
		6	=>	array('currency_id' => 'RUB', 'currency_name' => 'Russian Rouble', 'country' => 'RU', 'hundreds_name' => '', 'exchange_rate' => 0),
		7	=>	array('currency_id' => 'AUD', 'currency_name' => 'Australian Dollar', 'country' => 'AU', 'hundreds_name' => 'cents', 'exchange_rate' => 0)
	);
	foreach($currencies as $id => $currency) {
				
		$sql = 'INSERT INTO perp_currency ( currency_id, currency_name, country, hundreds_name, exchange_rate, currency_order )	VALUES("'.$currency['currency_id'].'","'.$currency['currency_name'].'","'.$currency['country'].'","'.$currency['hundreds_name'].'",'.$currency['exchange_rate'].','.$id.')';
		$GLOBALS['egw_setup']->oProc->query($sql);
	}
	
	// Default Payment Types
	$payment_types = array (
		1	=>	'Cheque',
		2	=>	'VISA',
		3	=>	'MasterCard',
		4	=>	'Cash',
		5	=>	'Wire Transfer',
		6	=>	'Payroll Reimbursement',
	);
	foreach($payment_types as $id => $type) {
		$sql = "INSERT INTO perp_payment_method (payment_method_id, payment_method_name)
			VALUES($id, '$type')";
		$GLOBALS['egw_setup']->oProc->query($sql);
	}
	
	// Default Payment Terms
	$payment_terms = array (
		1	=>	array('term' => 'Net 7', 'due_days' => 7, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 1),
		2	=>	array('term' => 'Net 10', 'due_days' => 10, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 2),
		3	=>	array('term' => 'Net 15', 'due_days' => 15, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 3),
		4	=>	array('term' => 'Net 20', 'due_days' => 20, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 4),
		5	=>	array('term' => 'Net 30', 'due_days' => 30, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 5),
		6	=>	array('term' => 'Net 60', 'due_days' => 60, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 6),
		7	=>	array('term' => 'Net 120', 'due_days' => 120, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 7),
		8	=>	array('term' => '1% 10 Net 30', 'due_days' => 30, 'due_date_type' => 0, 'discount_days' => 10, 'discount_date_type' => 1, 'discount_percent' => 0, 'sort_order' => 8),
		9	=>	array('term' => '1.5% 15 Net 30', 'due_days' => 30, 'due_date_type' => 0, 'discount_days' => 15, 'discount_date_type' => 1.5, 'discount_percent' => 0, 'sort_order' => 9),
		10	=>	array('term' => '2% 10 Net 30', 'due_days' => 30, 'due_date_type' => 0, 'discount_days' => 10, 'discount_date_type' => 2, 'discount_percent' => 0, 'sort_order' => 10),
		11	=>	array('term' => '2.5% 15 Net 30', 'due_days' => 30, 'due_date_type' => 0, 'discount_days' => 15, 'discount_date_type' => 2.5, 'discount_percent' => 0, 'sort_order' => 11),
		12	=>	array('term' => 'Prepaid', 'due_days' => 0, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 12),
		13	=>	array('term' => 'COD', 'due_days' => 2, 'due_date_type' => 0, 'discount_days' => 0, 'discount_date_type' => 0, 'discount_percent' => 0, 'sort_order' => 13),
	);
	foreach($payment_terms as $id => $term_row) {
				
		$sql = 'INSERT INTO perp_payment_term (payment_term_id, payment_term_name, due_days, due_date_type, discount_days, discount_date_type, discount_percent, payment_term_order)	VALUES('.$id.',"'.$term_row['term'].'",'.$term_row['due_days'].','.$term_row['due_date_type'].','.$term_row['discount_days'].','.$term_row['discount_date_type'].','.$term_row['discount_percent'].','.$term_row['sort_order'].')';
		$GLOBALS['egw_setup']->oProc->query($sql);
	}

	// Default paths for reports
	$report_vars = array(
		'report_zip_binary'	=>	'/usr/bin/zip',
		'report_unzip_binary'	=>	'/usr/bin/unzip',
		'report_work_directory'	=>	'/tmp',
		'report_java_binary'	=>	''
	);
	foreach($report_vars as $key => $value) {
		$sql = "INSERT INTO egw_config (config_app, config_name, config_value)
			VALUES('perp_api', '$key', '$value')";
		$GLOBALS['egw_setup']->oProc->query($sql);
	}

	if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
		// These tables need to be InnoDB
		$transaction_tables = array(
			'perp_order',
			'perp_order_line',
			'perp_order_detail',
			'perp_invoice',
			'perp_invoice_line',
			'perp_shipment',
			'perp_shipment_line',
			'perp_shipment_detail'
		);
		$so_perp_api = CreateObject('perp_api.so_perp_api');
		$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, $transaction_tables);
	}

?>
