<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


$phpgw_baseline = array(
	'perp_currency' => array(
		'fd' => array(
			'currency_id' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'currency_name' => array('type' => 'varchar','precision' => '20'),
			'country' => array('type' => 'varchar','precision' => '3'),
			'hundreds_name' => array('type' => 'varchar','precision' => '50'),
			'exchange_rate' => array('type' => 'decimal','precision' => '7','scale' => '3'),
			'currency_order' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('currency_id'),
		'fk' => array(),
		'ix' => array('currency_id'),
		'uc' => array('currency_id')
	),
	'perp_unit_of_measure' => array(
		'fd' => array(
			'uom_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'uom_name' => array('type' => 'varchar','precision' => '20','nullable' => False)
		),
		'pk' => array('uom_id'),
		'fk' => array(),
		'ix' => array('uom_id'),
		'uc' => array('uom_id')
	),
	'perp_tax_authority' => array(
		'fd' => array(
			'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'tax_authority_name' => array('type' => 'varchar','precision' => '20'),
			'tax_authority_in_account' => array('type' => 'int','precision' => '4'),
			'tax_authority_out_account' => array('type' => 'int','precision' => '4'),
			'registration_number' => array('type' => 'varchar','precision' => '50')
		),
		'pk' => array('tax_authority_id'),
		'fk' => array('tax_authority_in_account' => 'perp_account.account_id','tax_authority_out_account' => 'perp_account.account_id'),
		'ix' => array('tax_authority_id'),
		'uc' => array('tax_authority_id')
	),
	'perp_tax_group' => array(
		'fd' => array(
			'tax_group_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'tax_group_name' => array('type' => 'varchar','precision' => '20')
		),
		'pk' => array('tax_group_id'),
		'fk' => array(),
		'ix' => array('tax_group_id'),
		'uc' => array('tax_group_id')
	),
	'perp_tax_category' => array(
		'fd' => array(
			'tax_category_id' => array('type' => 'auto','nullable' => False),
			'tax_category_name' => array('type' => 'varchar','precision' => '20')
		),
		'pk' => array('tax_category_id'),
		'fk' => array(),
		'ix' => array('tax_category_id'),
		'uc' => array('tax_category_id')
	),
	'perp_tax_location' => array(
		'fd' => array(
			'tax_location_id' => array('type' => 'auto','nullable' => False),
			'tax_location_name' => array('type' => 'varchar','precision' => '20')
		),
		'pk' => array('tax_location_id'),
		'fk' => array(),
		'ix' => array('tax_location_id'),
		'uc' => array('tax_location_id')
	),
	'perp_tax_group_tax' => array(
		'fd' => array(
			'tax_group_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'calc_order' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
			'tax_on_tax' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0')
		),
		'pk' => array('tax_group_id','tax_authority_id'),
		'fk' => array('tax_group_id' => 'perp_tax_group.tax_group_id','tax_authority_id' => 'perp_tax_authority.tax_authority_id'),
		'ix' => array('tax_group_id','tax_authority_id'),
		'uc' => array()
	),
	'perp_tax_auth_rate' => array(
		'fd' => array(
			'tax_authority' => array('type' => 'int','precision' => '4','nullable' => False),
			'tax_source_location' => array('type' => 'int','precision' => '4','nullable' => False),
			'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
			'tax_rate' => array('type' => 'decimal','precision' => '6','scale' => '4')
		),
		'pk' => array('tax_authority','tax_source_location','tax_category'),
		'fk' => array('tax_authority' => 'perp_tax_authority.tax_authority_id','tax_source_location' => 'perp_tax_location.location_id','tax_category' => 'perp_tax_category.tax_category_id'),
		'ix' => array('tax_authority','tax_source_location'),
		'uc' => array()
	),
	'perp_payment_term' => array(
		'fd' => array(
			'payment_term_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'payment_term_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
			'due_days' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '0'),
			'due_date_type' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '0'),
			'discount_days' => array('type' => 'int','precision' => '2'),
			'discount_date_type' => array('type' => 'int','precision' => '2'),
			'discount_percent' => array('type' => 'decimal','precision' => '3','scale' => '2'),
			'payment_term_order' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('payment_term_id'),
		'fk' => array(),
		'ix' => array('payment_term_id','payment_term_order'),
		'uc' => array('payment_term_id')
	),
	'perp_payment_method' => array(
		'fd' => array(
			'payment_method_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'payment_method_name' => array('type' => 'varchar','precision' => '40','nullable' => False)
		),
		'pk' => array('payment_method_id'),
		'fk' => array(),
		'ix' => array('payment_method_id'),
		'uc' => array('payment_method_id')
	),
	'perp_shipper' => array(
		'fd' => array(
			'shipper_id' => array('type' => 'auto','nullable' => False),
			'shipper_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
			'account_number' => array('type' => 'text','nullable' => False,'default' => '0')
		),
		'pk' => array('shipper_id'),
		'fk' => array(),
		'ix' => array('shipper_id'),
		'uc' => array('shipper_id')
	),
	'perp_shipper_cost' => array(
		'fd' => array(
			'shipper_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'our_location' => array('type' => 'varchar','precision' => '5','nullable' => False),
			'their_id' => array('type' => 'varchar','precision' => '10','nullable' => False),
			'volume_rate' => array('type' => 'decimal','precision' => '20','scale' => '2'),
			'mass_rate' => array('type' => 'decimal','precision' => '20','scale' => '2'),
			'max_volume' => array('type' => 'decimal','precision' => '20','scale' => '2'),
			'max_mass' => array('type' => 'decimal','precision' => '20','scale' => '2'),
			'fixed_rate' => array('type' => 'decimal','precision' => '20','scale' => '2'),
			'minimum_charge' => array('type' => 'decimal','precision' => '20','scale' => '2')
		),
		'pk' => array('shipper_id','our_location','their_id'),
		'fk' => array('shipper_id' => 'perp_shipper.shipper_id','our_location' => 'perp_location.location_id'),
		'ix' => array('shipper_id','our_location','their_id'),
		'uc' => array()
	),
	'perp_order' => array(
		'fd' => array(
			'order_id' => array('type' => 'auto','precision' => '8','nullable' => False),
			'our_reference_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'their_reference_number' => array('type' => 'varchar','precision' => '20'),
			'originating_user' => array('type' => 'int','precision' => '4','nullable' => False),
			'approving_user' => array('type' => 'int','precision' => '4'),
			'our_contact_person' => array('type' => 'int','precision' => '4','nullable' => False),
			'their_contact_person' => array('type' => 'int','precision' => '4'),
			'supplier_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'originating_date' => array('type' => 'timestamp','nullable' => False),
			'issue_date' => array('type' => 'timestamp'),
			'approval_date' => array('type' => 'timestamp'),
			'requested_delivery_date' => array('type' => 'timestamp'),
			'actual_delivery_date' => array('type' => 'timestamp'),
			'ship_from_address' => array('type' => 'int','precision' => '4','nullable' => False),
			'ship_to_address' => array('type' => 'int','precision' => '4','nullable' => False),
			'requires_approval' => array('type' => 'bool','default' => 'true'),
			'order_currency' => array('type' => 'char','precision' => '3','nullable' => False),
			'payment_terms' => array('type' => 'int','precision' => '4'),
			'comments' => array('type' => 'text'),
			'bill_to_address' => array('type' => 'int','precision' => '4','nullable' => False),
			'closed_date' => array('type' => 'timestamp'),
			'class' => array('type' => 'varchar','precision' => '32','nullable' => False,'default' => 'Order')
		),
		'pk' => array('order_id'),
		'fk' => array('originating_user' => 'egw_accounts.account_id','approving_user' => 'egw_accounts.account_id','our_contact_person' => 'egw_addressbook.contact_id','their_contact_person' => 'egw_addressbook.contact_id','supplier_id' => 'perp_supplier.supplier_id','client_id' => 'perp_client.client_id','ship_from_address' => 'egw_addressbook.contact_id','ship_to_address' => 'egw_addressbook.contact_id','order_currency' => 'perp_currency.currency_id','payment_terms' => 'perp_payment_term.payment_term_id','bill_to_address' => 'egw_addressbook.contact_id'),
		'ix' => array('our_reference_number','supplier_id','client_id'),
		'uc' => array('order_id')
	),
	'perp_order_line' => array(
		'fd' => array(
			'order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'supplier_stock_code' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'our_stock_code' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'quantity_ordered' => array('type' => 'float','precision' => '4','nullable' => False),
			'unit_price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'ship_location' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('order_id','line_no'),
		'fk' => array('order_id' => 'perp_order.order_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_invoice' => array(
		'fd' => array(
			'invoice_id' => array('type' => 'auto','precision' => '8','nullable' => False),
			'our_reference_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'their_reference_number' => array('type' => 'varchar','precision' => '20'),
			'originating_user' => array('type' => 'int','precision' => '4','nullable' => False),
			'approving_user' => array('type' => 'int','precision' => '4'),
			'our_contact_person' => array('type' => 'int','precision' => '4'),
			'their_contact_person' => array('type' => 'int','precision' => '4'),
			'supplier_id' => array('type' => 'int','precision' => '4'),
			'client_id' => array('type' => 'int','precision' => '4'),
			'originating_date' => array('type' => 'timestamp','nullable' => False),
			'issue_date' => array('type' => 'timestamp'),
			'approval_date' => array('type' => 'timestamp'),
			'due_date' => array('type' => 'date','nullable' => False),
			'discount_date' => array('type' => 'date'),
			'bill_from_address' => array('type' => 'int','precision' => '4'),
			'bill_to_address' => array('type' => 'int','precision' => '4'),
			'requires_approval' => array('type' => 'bool','nullable' => False,'default' => 'true'),
			'invoice_currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'exchange_rate' => array('type' => 'decimal','precision' => '8','scale' => '3','nullable' => False,'default' => '1'),
			'payment_terms' => array('type' => 'int','precision' => '4','nullable' => False),
			'invoice_paid' => array('type' => 'bool','nullable' => False,'default' => 'false'),
			'comments' => array('type' => 'text'),
			'invoice_transaction_id' => array('type' => 'int','precision' => '4'),
			'discount_taken' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'class' => array('type' => 'varchar','precision' => '32','nullable' => False,'default' => 'Invoice')
		),
		'pk' => array('invoice_id'),
		'fk' => array('originating_user' => 'perp_account.account_id','approving_user' => 'perp_account.account_id','our_contact_person' => 'egw_addressbook.contact_id','their_contact_person' => 'egw_addressbook.contact_id','supplier_id' => 'perp_supplier.supplier_id','client_id' => 'perp_client.client_id','bill_from_address' => 'egw_addressbook.contact_id','bill_to_address' => 'egw_addressbook.contact_id','invoice_currency' => 'perp_currency.currency_id','payment_terms' => 'perp_payment_term.payment_term_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_invoice_line' => array(
		'fd' => array(
			'invoice_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'float','precision' => '20','scale' => '3','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'unit_price' => array('type' => 'float','precision' => '20','scale' => '3','nullable' => False),
			'general_ledger_account' => array('type' => 'int','precision' => '4','nullable' => False),
			'gl_transaction_line' => array('type' => 'int','precision' => '4'),
			'invoicable_class' => array('type' => 'varchar','precision' => '50'),
			'invoicable_id' => array('type' => 'int','precision' => '4'),
			'invoicable_item_line' => array('type' => 'int','precision' => '4'),
			'line_type' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '0')
		),
		'pk' => array('invoice_id','line_no'),
		'fk' => array('invoice_id' => 'perp_invoice.invoice_id','general_ledger_account' => 'perp_account.account_id','gl_transaction_line' => 'perp_general_ledger.line_no'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_shipment' => array(
		'fd' => array(
			'shipment_id' => array('type' => 'auto','nullable' => False),
			'our_reference_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'their_reference_number' => array('type' => 'varchar','precision' => '20'),
			'originating_user' => array('type' => 'int','precision' => '4','nullable' => False),
			'approving_user' => array('type' => 'int','precision' => '4'),
			'our_contact_person' => array('type' => 'int','precision' => '4'),
			'their_contact_person' => array('type' => 'int','precision' => '4'),
			'supplier_id' => array('type' => 'int','precision' => '4'),
			'client_id' => array('type' => 'int','precision' => '4'),
			'originating_date' => array('type' => 'timestamp','nullable' => False),
			'issue_date' => array('type' => 'timestamp'),
			'approval_date' => array('type' => 'timestamp'),
			'requested_delivery_date' => array('type' => 'timestamp'),
			'actual_delivery_date' => array('type' => 'timestamp'),
			'ship_from_address' => array('type' => 'int','precision' => '4'),
			'ship_to_address' => array('type' => 'int','precision' => '4'),
			'requires_approval' => array('type' => 'bool'),
			'shipper' => array('type' => 'int','precision' => '4'),
			'vessel' => array('type' => 'varchar','precision' => '20'),
			'comments' => array('type' => 'text'),
			'class' => array('type' => 'varchar','precision' => '32','nullable' => False,'default' => 'Shipment')
		),
		'pk' => array('shipment_id'),
		'fk' => array('originating_user' => 'egw_accounts.account_id','approving_user' => 'egw_accounts.account_id','our_contact_person' => 'egw_addressbook.contact_id','their_contact_person' => 'egw_addressbook.contact_id','supplier_id' => 'perp_supplier.supplier_id','client_id' => 'perp_client.client_id','ship_from_address' => 'egw_addressbook.contact_id','ship_to_address' => 'egw_addressbook.contact_id','shipper' => 'perp_shippers.shipper_id'),
		'ix' => array(),
		'uc' => array('our_reference_number')
	),
	'perp_shipment_line' => array(
		'fd' => array(
			'shipment_id' => array('type' => 'int','precision' => '4'),
			'line_no' => array('type' => 'int','precision' => '4'),
			'quantity_shipped' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'shippable_class' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'shippable_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'shippable_item_line' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('shipment_id','line_no'),
		'fk' => array('shipment_id' => 'perp_shipment.shipment_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_order_detail' => array(
		'fd' => array(
			'order_id' => array('type' => 'int','precision' => '4'),
			'line_no' => array('type' => 'int','precision' => '4'),
			'detail_no' => array('type' => 'int','precision' => '4'),
			'detail_class' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'detail_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'detail_value' => array('type' => 'varchar','precision' => '255'),
			'display' => array('type' => 'bool','nullable' => False,'default' => 'true')
		),
		'pk' => array('order_id','line_no','detail_no'),
		'fk' => array('order_id' => 'perp_order_line.order_id','line_no' => 'perp_order_line.line_no'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_shipment_detail' => array(
		'fd' => array(
			'shipment_id' => array('type' => 'int','precision' => '4'),
			'line_no' => array('type' => 'int','precision' => '4'),
			'detail_id' => array('type' => 'int','precision' => '4'),
			'detail_class' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'detail_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'detail_value' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'display' => array('type' => 'bool','nullable' => False,'default' => '1')
		),
		'pk' => array('shipment_id','line_no','detail_id'),
		'fk' => array('shipment_id' => 'perp_shipment_line.shipment_id','line_no' => 'perp_shipment_line.line_no'),
		'ix' => array(),
		'uc' => array()
	)
);
