<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


// Required to force tables to InnoDB
require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.so_perp_api.inc.php');

	$test[] = '0.1.0';
	function perp_upgrade0_1_0()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_currency','currency_country',array(
			'type' => 'varchar',
			'precision' => '3'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_currency','currency_hundreds',array(
			'type' => 'varchar',
			'precision' => '50'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_currency','rate',array(
			'type' => 'decimal'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.001';
	}


	$test[] = '0.1.001';
	function perp_upgrade0_1_001()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_unit_of_measure',array(
			'fd' => array(
				'uom_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'uom_name' => array('type' => 'varchar','precision' => '20','nullable' => False)
			),
			'pk' => array('uom_id'),
			'fk' => array(),
			'ix' => array('uom_id'),
			'uc' => array('uom_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.002';
	}


	$test[] = '0.1.002';
	function perp_upgrade0_1_002()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_currency','currency_country','country');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_currency','currency_hundreds','hundreds_name');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_currency','rate','exchange_rate');

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.003';
	}


	$test[] = '0.1.003';
	function perp_upgrade0_1_003()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_tax_authority',array(
			'fd' => array(
				'tax_auth_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_auth_name' => array('type' => 'varchar','precision' => '20'),
				'tax_auth_in_account' => array('type' => 'int','precision' => '4'),
				'tax_auth_out_account' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('tax_auth_id'),
			'fk' => array(),
			'ix' => array('tax_auth_id'),
			'uc' => array('tax_auth_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.004';
	}


	$test[] = '0.1.004';
	function perp_upgrade0_1_004()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_tax_group',array(
			'fd' => array(
				'tax_group_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_group_name' => array('type' => 'varchar','precision' => '20')
			),
			'pk' => array('tax_group_id'),
			'fk' => array(),
			'ix' => array('tax_group_id'),
			'uc' => array('tax_group_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.005';
	}


	$test[] = '0.1.005';
	function perp_upgrade0_1_005()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_tax_category',array(
			'fd' => array(
				'tax_category_id' => array('type' => 'auto','nullable' => False),
				'tax_category_name' => array('type' => 'varchar','precision' => '20')
			),
			'pk' => array('tax_category_id'),
			'fk' => array(),
			'ix' => array('tax_category_id'),
			'uc' => array('tax_category_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.006';
	}


	$test[] = '0.1.006';
	function perp_upgrade0_1_006()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_tax_location',array(
			'fd' => array(
				'tax_location_id' => array('type' => 'auto','nullable' => False),
				'tax_location_name' => array('type' => 'varchar','precision' => '20')
			),
			'pk' => array('tax_location_id'),
			'fk' => array(),
			'ix' => array('tax_location_id'),
			'uc' => array('tax_location_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.007';
	}


	$test[] = '0.1.007';
	function perp_upgrade0_1_007()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_tax_group_tax',array(
			'fd' => array(
				'tax_group_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_auth_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'calc_order' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'tax_on_tax' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0')
			),
			'pk' => array('tax_group_id','tax_auth_id'),
			'fk' => array(),
			'ix' => array('tax_group_id','tax_auth_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.008';
	}


	$test[] = '0.1.008';
	function perp_upgrade0_1_008()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_tax_auth_rate',array(
			'fd' => array(
				'tax_authority' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_source_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_rate' => array('type' => 'decimal','nullable' => False)
			),
			'pk' => array('tax_authority','tax_source_location','tax_category'),
			'fk' => array(),
			'ix' => array('tax_authority','tax_source_location'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.009';
	}


	$test[] = '0.1.009';
	function perp_upgrade0_1_009()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_payment_term',array(
			'fd' => array(
				'payment_term_id' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'payment_term_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'days_before_due' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'day_in_following_month' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0')
			),
			'pk' => array('payment_term_id'),
			'fk' => array(),
			'ix' => array('payment_term_id'),
			'uc' => array('payment_term_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.010';
	}


	$test[] = '0.1.010';
	function perp_upgrade0_1_010()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_tax_authority','tax_auth_id','tax_authority_id');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_tax_authority','tax_auth_name','tax_authority_name');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_tax_authority','tax_auth_in_account','tax_authority_in_account');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_tax_authority','tax_auth_out_account','tax_authority_out_account');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_tax_authority',array(
			'fd' => array(
				'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_authority_name' => array('type' => 'varchar','precision' => '20'),
				'tax_authority_in_account' => array('type' => 'int','precision' => '4'),
				'tax_authority_out_account' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('tax_authority_id'),
			'fk' => array(),
			'ix' => array('tax_authority_id'),
			'uc' => array('tax_authority_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.011';
	}


	$test[] = '0.1.011';
	function perp_upgrade0_1_011()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_tax_group_tax','tax_auth_id','tax_authority_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_tax_group_tax',array(
			'fd' => array(
				'tax_group_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'calc_order' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'tax_on_tax' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0')
			),
			'pk' => array('tax_group_id','tax_authority_id'),
			'fk' => array(),
			'ix' => array('tax_group_id','tax_authority_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.012';
	}


	$test[] = '0.1.012';
	function perp_upgrade0_1_012()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_tax_auth_rate','tax_rate',array(
			'type' => 'decimal'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.013';
	}


	$test[] = '0.1.013';
	function perp_upgrade0_1_013()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_tax_auth_rate','tax_rate',array(
			'type' => 'decimal',
			'precision' => '4',
			'scale' => '2'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.014';
	}


	$test[] = '0.1.014';
	function perp_upgrade0_1_014()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_payment_method',array(
			'fd' => array(
				'payment_method_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'payment_method_name' => array('type' => 'varchar','precision' => '20','nullable' => False)
			),
			'pk' => array('payment_method_id'),
			'fk' => array(),
			'ix' => array('payment_method_id'),
			'uc' => array('payment_method_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.015';
	}


	$test[] = '0.1.015';
	function perp_upgrade0_1_015()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_currency','exchange_rate',array(
			'type' => 'decimal',
			'precision' => '3'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.016';
	}


	$test[] = '0.1.016';
	function perp_upgrade0_1_016()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_currency','exchange_rate',array(
			'type' => 'decimal',
			'precision' => '4',
			'scale' => '3'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.017';
	}


	$test[] = '0.1.017';
	function perp_upgrade0_1_017()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_currency','exchange_rate',array(
			'type' => 'decimal',
			'precision' => '7',
			'scale' => '3'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.018';
	}


	$test[] = '0.1.018';
	function perp_upgrade0_1_018()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_tax_authority',array(
			'fd' => array(
				'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_authority_name' => array('type' => 'varchar','precision' => '20'),
				'tax_authority_in_account' => array('type' => 'int','precision' => '4'),
				'tax_authority_out_account' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('tax_authority_id'),
			'fk' => array('tax_authority_in_account' => 'perp_account.account_id','tax_authority_out_account' => 'perp_account.account_id'),
			'ix' => array('tax_authority_id'),
			'uc' => array('tax_authority_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.019';
	}


	$test[] = '0.1.019';
	function perp_upgrade0_1_019()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_tax_group_tax',array(
			'fd' => array(
				'tax_group_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'calc_order' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'tax_on_tax' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0')
			),
			'pk' => array('tax_group_id','tax_authority_id'),
			'fk' => array('tax_group_id' => 'perp_tax_group.tax_group_id','tax_authority_id' => 'perp_tax_authority.tax_authority_id'),
			'ix' => array('tax_group_id','tax_authority_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.020';
	}


	$test[] = '0.1.020';
	function perp_upgrade0_1_020()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_tax_auth_rate',array(
			'fd' => array(
				'tax_authority' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_source_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_rate' => array('type' => 'decimal','precision' => '4','scale' => '2')
			),
			'pk' => array('tax_authority','tax_source_location','tax_category'),
			'fk' => array('tax_authority' => 'perp_tax_authority.tax_authority_id','tax_source_location' => 'perp_tax_location.location_id','tax_category' => 'perp_tax_category.tax_category_id'),
			'ix' => array('tax_authority','tax_source_location'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.021';
	}


	$test[] = '0.1.021';
	function perp_upgrade0_1_021()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_address',array(
			'fd' => array(
				'address_id' => array('type' => 'auto','nullable' => False),
				'line_1' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'line_2' => array('type' => 'varchar','precision' => '255'),
				'city' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'province' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'country' => array('type' => 'varchar','precision' => '2','nullable' => False)
			),
			'pk' => array('address_id'),
			'fk' => array(),
			'ix' => array('address_id'),
			'uc' => array('address_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.022';
	}


	$test[] = '0.1.022';
	function perp_upgrade0_1_022()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_country',array(
			'fd' => array(
				'country_id' => array('type' => 'varchar','precision' => '3','nullable' => False),
				'fips_code' => array('type' => 'varchar','precision' => '3'),
				'country_name' => array('type' => 'varchar','precision' => '50')
			),
			'pk' => array('country_id'),
			'fk' => array(),
			'ix' => array('country_id','fips_code'),
			'uc' => array('country_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.023';
	}


	$test[] = '0.1.023';
	function perp_upgrade0_1_023()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_country_region',array(
			'fd' => array(
				'country_id' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'region_id' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'fips_region' => array('type' => 'varchar','precision' => '2'),
				'region_name' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('country_id','region_id'),
			'fk' => array('country_id' => 'perp_country.country_id'),
			'ix' => array('country_id','region_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.024';
	}


	$test[] = '0.1.024';
	function perp_upgrade0_1_024()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_country_region','region_id',array(
			'type' => 'varchar',
			'precision' => '2'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_country_region',array(
			'fd' => array(
				'country_id' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'region_id' => array('type' => 'varchar','precision' => '2'),
				'fips_region' => array('type' => 'varchar','precision' => '2'),
				'region_name' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('country_id','region_id','fips_region'),
			'fk' => array('country_id' => 'perp_country.country_id'),
			'ix' => array('country_id','region_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.025';
	}


	$test[] = '0.1.025';
	function perp_upgrade0_1_025()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_address','postal_code',array(
			'type' => 'varchar',
			'precision' => '8',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_address',array(
			'fd' => array(
				'address_id' => array('type' => 'auto','nullable' => False),
				'line_1' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'line_2' => array('type' => 'varchar','precision' => '255'),
				'city' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'province' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'country' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'postal_code' => array('type' => 'varchar','precision' => '8','nullable' => False)
			),
			'pk' => array('address_id'),
			'fk' => array(),
			'ix' => array('address_id','country','postal_code'),
			'uc' => array('address_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.026';
	}


	$test[] = '0.1.026';
	function perp_upgrade0_1_026()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_shipper',array(
			'fd' => array(
				'shipper_id' => array('type' => 'auto','nullable' => False),
				'shipper_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'minimum_charge' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False,'default' => '0')
			),
			'pk' => array('shipper_id'),
			'fk' => array(),
			'ix' => array('shipper_id'),
			'uc' => array('shipper_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.027';
	}


	$test[] = '0.1.027';
	function perp_upgrade0_1_027()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_shipper_cost',array(
			'fd' => array(
				'shipper_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'our_location' => array('type' => 'varchar','precision' => '5','nullable' => False),
				'their_id' => array('type' => 'varchar','precision' => '10','nullable' => False),
				'volume_rate' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'mass_rate' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'max_volume' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'max_mass' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'fixed_rate' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'minimum_charge' => array('type' => 'decimal','precision' => '20','scale' => '2')
			),
			'pk' => array('shipper_id','our_location','their_id'),
			'fk' => array('shipper_id' => 'perp_shipper.shipper_id','our_location' => 'perp_location.location_id'),
			'ix' => array('shipper_id','our_location','their_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.028';
	}


	$test[] = '0.1.028';
	function perp_upgrade0_1_028()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_country','fips_code','country_name');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_country','country_name',array(
			'type' => 'varchar',
			'precision' => '50',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_country','postal_code_regex',array(
			'type' => 'varchar',
			'precision' => '10',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_country',array(
			'fd' => array(
				'country_id' => array('type' => 'varchar','precision' => '3','nullable' => False),
				'country_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'postal_code_regex' => array('type' => 'varchar','precision' => '10','nullable' => False)
			),
			'pk' => array('country_id'),
			'fk' => array(),
			'ix' => array('country_id'),
			'uc' => array('country_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.029';
	}


	$test[] = '0.1.029';
	function perp_upgrade0_1_029()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_country_region',array(
			'fd' => array(
				'country_id' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'region_id' => array('type' => 'varchar','precision' => '2'),
				'region_name' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('country_id','region_id'),
			'fk' => array('country_id' => 'perp_country.country_id'),
			'ix' => array('country_id','region_id'),
			'uc' => array()
		),'fips_region');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_country_region',array(
			'fd' => array(
				'country_id' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'region_id' => array('type' => 'varchar','precision' => '2'),
				'region_name' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('country_id','region_id'),
			'fk' => array('country_id' => 'perp_country.country_id'),
			'ix' => array('country_id','region_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.030';
	}


	$test[] = '0.1.030';
	function perp_upgrade0_1_030()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_country','postal_code_regex',array(
			'type' => 'varchar',
			'precision' => '50',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.031';
	}


	$test[] = '0.1.031';
	function perp_upgrade0_1_031()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_country_region','postal_code_regex',array(
			'type' => 'varchar',
			'precision' => '255'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_country_region',array(
			'fd' => array(
				'country_id' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'region_id' => array('type' => 'varchar','precision' => '2'),
				'region_name' => array('type' => 'varchar','precision' => '255'),
				'postal_code_regex' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('country_id','region_id'),
			'fk' => array('country_id' => 'perp_country.country_id'),
			'ix' => array('country_id','region_id','postal_code_regex'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.032';
	}


	$test[] = '0.1.032';
	function perp_upgrade0_1_032()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_country','postal_code_seperator',array(
			'type' => 'varchar',
			'precision' => '50',
			'nullable' => False,
			'default' => ' '
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.033';
	}

	$test[] = '0.1.033';
	function perp_upgrade0_1_033()
	{
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.034';
	}

	$test[] = '0.1.034';
	function perp_upgrade0_1_034()
	{
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.035';
	}

	$test[] = '0.1.035';
	function perp_upgrade0_1_035()
	{
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.036';
	}

	$test[] = '0.1.036';
	function perp_upgrade0_1_036()
	{
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.037';
	}

	$test[] = '0.1.037';
	function perp_upgrade0_1_037()
	{
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.038';
	}

	$test[] = '0.1.038';
	function perp_api_upgrade0_1_038()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_currency','currency_order',array(
			'type' => 'int',
			'precision' => '5'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.039';
	}


	$test[] = '0.1.039';
	function perp_api_upgrade0_1_039()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_currency','currency_order',array(
			'type' => 'int',
			'precision' => '4'
        	));
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.040';
	}


	$test[] = '0.1.040';
	function perp_api_upgrade0_1_040()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_currency','currency_format',array(
			'type' => 'varchar',
			'precision' => '40'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.041';
	}


	$test[] = '0.1.041';
	function perp_api_upgrade0_1_041()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_currency','currency_format',array(
			'type' => 'varchar',
			'precision' => '50'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.042';
	}


	$test[] = '0.1.042';
	function perp_api_upgrade0_1_042()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_currency',array(
			'fd' => array(
				'currency_id' => array('type' => 'varchar','precision' => '3','nullable' => False),
				'currency_name' => array('type' => 'varchar','precision' => '20'),
				'country' => array('type' => 'varchar','precision' => '3'),
				'hundreds_name' => array('type' => 'varchar','precision' => '50'),
				'exchange_rate' => array('type' => 'decimal','precision' => '7','scale' => '3'),
				'currency_order' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('currency_id'),
			'fk' => array(),
			'ix' => array('currency_id'),
			'uc' => array('currency_id')
		),'currency_format');

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.043';
	}


	$test[] = '0.1.043';
	function perp_api_upgrade0_1_043()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_payment_term','days_before_due','due_days');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_payment_term','day_in_following_month','due_date_type');
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payment_term','due_days',array(
			'type' => 'int',
			'precision' => '2',
			'nullable' => False,
			'default' => '0'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payment_term','due_date_type',array(
			'type' => 'int',
			'precision' => '2',
			'nullable' => False,
			'default' => '0'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_payment_term','discount_days',array(
			'type' => 'int',
			'precision' => '2'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_payment_term','discount_date_type',array(
			'type' => 'int',
			'precision' => '2'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_payment_term','discount_percent',array(
			'type' => 'decimal',
			'precision' => '3',
			'scale' => '2'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.044';
	}


	$test[] = '0.1.044';
	function perp_api_upgrade0_1_044()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payment_term','payment_term_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.045';
	}


	$test[] = '0.1.045';
	function perp_api_upgrade0_1_045()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_payment_term','payment_term_order',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_payment_term',array(
			'fd' => array(
				'payment_term_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'payment_term_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'due_days' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '0'),
				'due_date_type' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '0'),
				'discount_days' => array('type' => 'int','precision' => '2'),
				'discount_date_type' => array('type' => 'int','precision' => '2'),
				'discount_percent' => array('type' => 'decimal','precision' => '3','scale' => '2'),
				'payment_term_order' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('payment_term_id'),
			'fk' => array(),
			'ix' => array('payment_term_id','payment_term_order'),
			'uc' => array('payment_term_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.046';
	}


	$test[] = '0.1.046';
	function perp_api_upgrade0_1_046()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_tax_authority','registration_number',array(
			'type' => 'varchar',
			'precision' => '50'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.047';
	}


	$test[] = '0.1.047';
	function perp_api_upgrade0_1_047()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_shipper','minimum_charge','account_number');
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_shipper','account_number',array(
			'type' => 'text',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.048';
	}

	$test[] = '0.1.048';
	function perp_api_upgrade0_1_048() {
		// Add in reports
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl(acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_api', 'report_no_report', 0,1)");
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.049';
	}
	
	$test[] = '0.1.049';
	function perp_api_upgrade0_1_049() {
		$GLOBALS['egw_setup']->oProc->DropTable('perp_address');
		$GLOBALS['egw_setup']->oProc->DropTable('perp_country');
		$GLOBALS['egw_setup']->oProc->DropTable('perp_country_region');

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.050';
	}

	$test[] = '0.1.050';
	function perp_api_upgrade0_1_050() {
		// Default paths for reports
		$report_vars = array(
			'report_zip_binary'	=>	'/usr/bin/zip',
			'report_unzip_binary'	=>	'/usr/bin/unzip',
			'report_work_directory'	=>	'/tmp',
			'report_java_binary'	=>	''
		);
		foreach($report_vars as $key => $value) {
			$sql = "INSERT INTO egw_config (config_app, config_name, config_value)
				VALUES('perp_api', '$key', '$value')";
			$GLOBALS['egw_setup']->oProc->query($sql);
		}
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.051';
	}


	$test[] = '0.1.051';
	function perp_api_upgrade0_1_051()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_order',array(
			'fd' => array(
				'order_id' => array('type' => 'int','precision' => '8','nullable' => False),
				'our_reference_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'their_reference_number' => array('type' => 'varchar','precision' => '20'),
				'originating_user' => array('type' => 'int','precision' => '4','nullable' => False),
				'approving_user' => array('type' => 'int','precision' => '4'),
				'our_contact_person' => array('type' => 'int','precision' => '4','nullable' => False),
				'their_contact_person' => array('type' => 'int','precision' => '4'),
				'supplier_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'originating_date' => array('type' => 'timestamp','nullable' => False),
				'issue_date' => array('type' => 'timestamp'),
				'approval_date' => array('type' => 'timestamp'),
				'requested_delivery_date' => array('type' => 'timestamp'),
				'actual_delivery_date' => array('type' => 'timestamp'),
				'ship_from_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'requires_approval' => array('type' => 'bool','default' => 'true'),
				'order_currency' => array('type' => 'char','precision' => '3','nullable' => False),
				'payment_terms' => array('type' => 'int','precision' => '4'),
				'comments' => array('type' => 'text')
			),
			'pk' => array('order_id'),
			'fk' => array('originating_user' => 'egw_accounts.account_id','approving_user' => 'egw_accounts.account_id','our_contact_person' => 'egw_addressbook.contact_id','their_contact_person' => 'egw_addressbook.contact_id','supplier_id' => 'perp_supplier.supplier_id','client_id' => 'perp_client.client_id','ship_from_address' => 'egw_addressbook.contact_id','ship_to_address' => 'egw_addressbook.contact_id','order_currency' => 'perp_currency.currency_id','payment_terms' => 'perp_payment_term.payment_term_id'),
			'ix' => array('our_reference_number','supplier_id','client_id'),
			'uc' => array('order_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.052';
	}


	$test[] = '0.1.052';
	function perp_api_upgrade0_1_052()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_order_line',array(
			'fd' => array(
				'order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'supplier_stock_code' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'our_stock_code' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'quantity_ordered' => array('type' => 'float','precision' => '4','nullable' => False),
				'unit_price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array('order_id','line_no'),
			'fk' => array('order_id' => 'perp_order.order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.053';
	}


	$test[] = '0.1.053';
	function perp_api_upgrade0_1_053()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_order','order_id',array(
			'type' => 'auto',
			'precision' => '8',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.054';
	}


	$test[] = '0.1.054';
	function perp_api_upgrade0_1_054()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_invoice',array(
			'fd' => array(
				'invoice_id' => array('type' => 'auto','precision' => '8','nullable' => False),
				'our_reference_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'their_reference_number' => array('type' => 'varchar','precision' => '20'),
				'originating_user' => array('type' => 'int','precision' => '4','nullable' => False),
				'approving_user' => array('type' => 'int','precision' => '4'),
				'our_contact_person' => array('type' => 'int','precision' => '4'),
				'their_contact_person' => array('type' => 'int','precision' => '4'),
				'supplier_id' => array('type' => 'int','precision' => '4'),
				'client_id' => array('type' => 'int','precision' => '4'),
				'originating_date' => array('type' => 'timestamp','nullable' => False),
				'issue_date' => array('type' => 'timestamp'),
				'approval_date' => array('type' => 'timestamp'),
				'due_date' => array('type' => 'date','nullable' => False),
				'discount_date' => array('type' => 'date'),
				'bill_from_address' => array('type' => 'int','precision' => '4'),
				'bill_to_address' => array('type' => 'int','precision' => '4'),
				'requires_approval' => array('type' => 'bool','nullable' => False,'default' => 'true'),
				'invoice_currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
				'exchange_rate' => array('type' => 'decimal','precision' => '8','scale' => '3','nullable' => False,'default' => '1'),
				'payment_terms' => array('type' => 'int','precision' => '4','nullable' => False),
				'invoice_paid' => array('type' => 'bool','nullable' => False,'default' => 'false'),
				'comments' => array('type' => 'text'),
				'invoice_transaction_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('invoice_id'),
			'fk' => array('originating_user' => 'perp_account.account_id','approving_user' => 'perp_account.account_id','our_contact_person' => 'egw_addressbook.contact_id','their_contact_person' => 'egw_addressbook.contact_id','supplier_id' => 'perp_supplier.supplier_id','client_id' => 'perp_client.client_id','bill_from_address' => 'egw_addressbook.contact_id','bill_to_address' => 'egw_addressbook.contact_id','invoice_currency' => 'perp_currency.currency_id','payment_terms' => 'perp_payment_term.payment_term_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.055';
	}


	$test[] = '0.1.055';
	function perp_api_upgrade0_1_055()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_invoice_line',array(
			'fd' => array(
				'invoice_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'float','precision' => '20','scale' => '3','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'unit_price' => array('type' => 'float','precision' => '20','scale' => '3','nullable' => False),
				'general_ledger_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'gl_transaction_line' => array('type' => 'int','precision' => '4'),
				'invoicable_item_class' => array('type' => 'varchar','precision' => '50'),
				'invoicable_item_id' => array('type' => 'int','precision' => '4'),
				'invoicable_item_line' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('invoice_id','line_no'),
			'fk' => array('invoice_id' => 'perp_invoice.invoice_id','general_ledger_account' => 'perp_account.account_id','gl_transaction_line' => 'perp_general_ledger.line_no'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.056';
	}


	$test[] = '0.1.056';
	function perp_api_upgrade0_1_056()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_invoice_line','invoicable_item_class','invoicable_class');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_invoice_line','invoicable_item_id','invoicable_id');

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.057';
	}


	$test[] = '0.1.057';
	function perp_api_upgrade0_1_057()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_order_line','invoices',array(
			'type' => 'text'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.058';
	}


	$test[] = '0.1.058';
	function perp_api_upgrade0_1_058()
	{
		$GLOBALS['egw_setup']->oProc->DropTable('perp_shipment');
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_shipment',array(
			'fd' => array(
				'shipment_id' => array('type' => 'auto'),
				'our_reference_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'their_reference_number' => array('type' => 'varchar','precision' => '20'),
				'originating_user' => array('type' => 'int','precision' => '4','nullable' => False),
				'approving_user' => array('type' => 'int','precision' => '4'),
				'our_contact_person' => array('type' => 'int','precision' => '4'),
				'their_contact_person' => array('type' => 'int','precision' => '4'),
				'supplier_id' => array('type' => 'int','precision' => '4'),
				'client_id' => array('type' => 'int','precision' => '4'),
				'originating_date' => array('type' => 'timestamp','nullable' => False),
				'issue_date' => array('type' => 'timestamp'),
				'approval_date' => array('type' => 'timestamp'),
				'requested_delivery_date' => array('type' => 'timestamp'),
				'actual_delivery_date' => array('type' => 'timestamp'),
				'ship_from_address' => array('type' => 'int','precision' => '4'),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'requires_approval' => array('type' => 'bool'),
				'shipper' => array('type' => 'int','precision' => '4'),
				'vessel' => array('type' => 'varchar','precision' => '20'),
				'comments' => array('type' => 'text')
			),
			'pk' => array('shipment_id'),
			'fk' => array('originating_user' => 'egw_accounts.account_id','approving_user' => 'egw_accounts.account_id','our_contact_person' => 'egw_addressbook.contact_id','their_contact_person' => 'egw_addressbook.contact_id','supplier_id' => 'perp_supplier.supplier_id','client_id' => 'perp_client.client_id','ship_from_address' => 'egw_addressbook.contact_id','ship_to_address' => 'egw_addressbook.contact_id','shipper' => 'perp_shippers.shipper_id'),
			'ix' => array(),
			'uc' => array('our_reference_number')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.059';
	}


	$test[] = '0.1.059';
	function perp_api_upgrade0_1_059()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_shipment_line',array(
			'fd' => array(
				'shipment_id' => array('type' => 'int','precision' => '4'),
				'line_no' => array('type' => 'int','precision' => '4'),
				'quantity_shipped' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'shippable_class' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'shippable_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'shippable_item_line' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('shipment_id','line_no'),
			'fk' => array('shipment_id' => 'perp_shipment.shipment_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.060';
	}


	$test[] = '0.1.060';
	function perp_api_upgrade0_1_060()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_order_detail',array(
			'fd' => array(
				'order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_class' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'detail_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'detail_value' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('order_id','line_no','detail_no'),
			'fk' => array('order_id' => 'perp_order_detail.order_id','line_no' => 'perp_order_detail.line_no'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.061';
	}


	$test[] = '0.1.061';
	function perp_api_upgrade0_1_061()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_invoice_line','line_type',array(
			'type' => 'int',
			'precision' => '1',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.062';
	}


	$test[] = '0.1.062';
	function perp_api_upgrade0_1_062()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_invoice','discount_taken',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.063';
	}


	$test[] = '0.1.063';
	function perp_api_upgrade0_1_063()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_order_line','invoices','ship_location');
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_order_line','ship_location',array(
			'type' => 'int',
			'precision' => '4'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.064';
	}


	$test[] = '0.1.064';
	function perp_api_upgrade0_1_064()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_order_detail','display',array(
			'type' => 'bool',
			'nullable' => False,
			'default' => 'true'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.065';
	}


	$test[] = '0.1.065';
	function perp_api_upgrade0_1_065()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_shipment_package',array(
			'fd' => array(
				'shipment_id' => array('type' => 'int','precision' => '4'),
				'line_no' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array('shipment_id','line_no','detail_id'),
			'fk' => array('shipment_id' => 'perp_shipment_detail.shipment_id','line_no' => 'perp_shipment_detail.line_no','detail_id' => 'perp_shipment_detail.detail_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.066';
	}


	$test[] = '0.1.066';
	function perp_api_upgrade0_1_066()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_shipment_detail',array(
			'fd' => array(
				'shipment_id' => array('type' => 'int','precision' => '4'),
				'line_no' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'detail_class' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'detail_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'detail_value' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'display' => array('type' => 'bool','nullable' => False,'default' => '1')
			),
			'pk' => array('shipment_id','line_no','detail_id'),
			'fk' => array('shipment_id' => 'perp_shipment_line.shipment_id','line_no' => 'perp_shipment_line.line_no','detail_id' => 'perp_shipment_detail.detail_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.067';
	}
	$test[] = '0.1.067';
	function perp_api_upgrade0_1_067()
	{
		$GLOBALS['egw_setup']->oProc->DropTable('perp_shipment_package');
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.068';
	}


	$test[] = '0.1.068';
	function perp_api_upgrade0_1_068()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_order_detail',array(
			'fd' => array(
				'order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_class' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'detail_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'detail_value' => array('type' => 'varchar','precision' => '255'),
				'display' => array('type' => 'bool','nullable' => False,'default' => 'true')
			),
			'pk' => array('order_id','line_no','detail_no'),
			'fk' => array('order_id' => 'perp_order_line.order_id','line_no' => 'perp_order_line.line_no'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.069';
	}


	$test[] = '0.1.069';
	function perp_api_upgrade0_1_069()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_order_detail','order_id',array(
			'type' => 'int',
			'precision' => '4'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_order_detail','line_no',array(
			'type' => 'int',
			'precision' => '4'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_order_detail','detail_no',array(
			'type' => 'int',
			'precision' => '4'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.070';
	}


	$test[] = '0.1.070';
	function perp_api_upgrade0_1_070()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_shipment_detail',array(
			'fd' => array(
				'shipment_id' => array('type' => 'int','precision' => '4'),
				'line_no' => array('type' => 'int','precision' => '4'),
				'detail_id' => array('type' => 'int','precision' => '4'),
				'detail_class' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'detail_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'detail_value' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'display' => array('type' => 'bool','nullable' => False,'default' => '1')
			),
			'pk' => array('shipment_id','line_no','detail_id'),
			'fk' => array('shipment_id' => 'perp_shipment_line.shipment_id','line_no' => 'perp_shipment_line.line_no'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.071';
	}


	$test[] = '0.1.071';
	function perp_api_upgrade0_1_071()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_tax_auth_rate','tax_rate',array(
			'type' => 'decimal',
			'precision' => '6',
			'scale' => '4'
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.072';
	}


	$test[] = '0.1.072';
	function perp_api_upgrade0_1_072()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_order_line','supplier_stock_code',array(
			'type' => 'varchar',
			'precision' => '50',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.073';
	}


	$test[] = '0.1.073';
	function perp_api_upgrade0_1_073()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_order','bill_to_address',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_order','closed_date',array(
			'type' => 'timestamp'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_order',array(
			'fd' => array(
				'order_id' => array('type' => 'auto','precision' => '8','nullable' => False),
				'our_reference_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'their_reference_number' => array('type' => 'varchar','precision' => '20'),
				'originating_user' => array('type' => 'int','precision' => '4','nullable' => False),
				'approving_user' => array('type' => 'int','precision' => '4'),
				'our_contact_person' => array('type' => 'int','precision' => '4','nullable' => False),
				'their_contact_person' => array('type' => 'int','precision' => '4'),
				'supplier_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'originating_date' => array('type' => 'timestamp','nullable' => False),
				'issue_date' => array('type' => 'timestamp'),
				'approval_date' => array('type' => 'timestamp'),
				'requested_delivery_date' => array('type' => 'timestamp'),
				'actual_delivery_date' => array('type' => 'timestamp'),
				'ship_from_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'requires_approval' => array('type' => 'bool','default' => 'true'),
				'order_currency' => array('type' => 'char','precision' => '3','nullable' => False),
				'payment_terms' => array('type' => 'int','precision' => '4'),
				'comments' => array('type' => 'text'),
				'bill_to_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'closed_date' => array('type' => 'timestamp')
			),
			'pk' => array('order_id'),
			'fk' => array('originating_user' => 'egw_accounts.account_id','approving_user' => 'egw_accounts.account_id','our_contact_person' => 'egw_addressbook.contact_id','their_contact_person' => 'egw_addressbook.contact_id','supplier_id' => 'perp_supplier.supplier_id','client_id' => 'perp_client.client_id','ship_from_address' => 'egw_addressbook.contact_id','ship_to_address' => 'egw_addressbook.contact_id','order_currency' => 'perp_currency.currency_id','payment_terms' => 'perp_payment_term.payment_term_id','bill_to_address' => 'egw_addressbook.contact_id'),
			'ix' => array('our_reference_number','supplier_id','client_id'),
			'uc' => array('order_id')
		));

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.1.074';
	}

	$test[] = '0.1.074';
	function perp_api_upgrade0_1_074() {
		if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
			// These tables need to be InnoDB
			$transaction_tables = array(
				'perp_order',
				'perp_order_line',
				'perp_order_detail',
				'perp_invoice',
				'perp_invoice_line',
				'perp_shipment',
				'perp_shipment_line',
				'perp_shipment_detail'
			);
			$so_perp_api = CreateObject('perp_api.so_perp_api');
			$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, $transaction_tables);
		}
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.2';
	}

	$test[] = '0.2';
	function perp_api_upgrade0_2() {
		// Force tables to InnoDB
		so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_api');
		so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_ledger');
		so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_api');
		so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_ar');
		so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_inventory');
		so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_manufacturing');
		so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_orders');

		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.2.001';
	}
	
	$test[] = '0.2.001';
	function perp_api_upgrade0_2_001() {
		
		$apps = $GLOBALS['egw_setup']->db->select($GLOBALS['egw_setup']->config_table,'config_value',array('config_app'=>'phpgwapi','config_name'=>'files_dir'),__LINES__,__FILES__)->fetchSingle().'/apps/';
		
		if(file_exists($apps)){
			foreach(scandir($apps) as $folder) {
				if ($folder[0]=='.') continue;
				if(strpos($folder,'perp') === 0){
					
					foreach(scandir($apps.$folder) as $link_folder) {
						if ($link_folder[0]=='.') continue;
						if(strpos($link_folder,':')){
							//rename in the if
							if(@rename($apps.$folder.'/'.$link_folder, $apps.$folder.'/'.str_replace(":", "-", $link_folder))){
								//_debug_array($apps.$folder.'/'.$link_folder.'is renamed to'.$apps.$folder.'/'.str_replace(":", "-", $link_folder));
							}
							else{
								foreach(scandir($apps.$folder.'/'.$link_folder) as $file){
									if ($file[0]=='.') continue;
									//rename in the if
									if(@rename($apps.$folder.'/'.$link_folder.'/'.$file, $apps.$folder.'/'.str_replace(":", "-", $link_folder).'/'.$file)){
										//_debug_array($apps.$folder.'/'.$link_folder.'/'.$file.'is moved to'.$apps.$folder.'/'.str_replace(":", "-", $link_folder).'/'.$file);
										//remove the directory in the if
										if(rmdir($apps.$folder.'/'.$link_folder)){
											//_debug_array($apps.$folder.'/'.$link_folder.'is Vaporized!');
										}
									}								
								}
							}						
						}
					}				
				}
			}			
		}		
		
		$sql1 = "UPDATE egw_sqlfs SET fs_name =  REPLACE(fs_name, '-', '_') , fs_name = REPLACE(fs_name, ':', '-')
		WHERE fs_name LIKE BINARY '%STOCK%'
		OR fs_name LIKE BINARY '%LOCATION%'
		OR fs_name LIKE BINARY '%ORDER%'
		OR fs_name LIKE BINARY '%WORK_ORDER%'
		OR fs_name LIKE BINARY '%INVOICE%'
		OR fs_name LIKE BINARY '%CLIENT-BRANCH%'
		OR fs_name LIKE BINARY '%CLIENT%'
		OR fs_name LIKE BINARY '%SALES_ORDER%'
		OR fs_name LIKE BINARY '%SUPPLIER%'
		OR fs_name LIKE BINARY '%RETROFIT%'
		OR fs_name LIKE BINARY '%SHIPMENT%'
		OR fs_name LIKE BINARY '%PAYMENT%'
		OR fs_name LIKE BINARY '%CLIENT-ACCOUNT%'
		OR fs_name LIKE BINARY '%RECEIPT%'
		OR fs_name LIKE BINARY '%SERIAL%'
		OR fs_name LIKE BINARY '%DAMAGE%'
		OR fs_name LIKE BINARY '%PRICE_LIST%'
		OR fs_name LIKE BINARY '%STAFF%'
		OR fs_name LIKE BINARY '%DEPARTMENT%'
		OR fs_name LIKE BINARY '%RECEIVED%'";
		
		$sql2 = "UPDATE egw_links SET link_id1 =  REPLACE(link_id1, '-', '_') , link_id1 = REPLACE(link_id1, ':', '-')
		WHERE link_id1 LIKE BINARY '%STOCK%'
		OR link_id1 LIKE BINARY '%LOCATION%'
		OR link_id1 LIKE BINARY '%ORDER%'
		OR link_id1 LIKE BINARY '%WORK_ORDER%'
		OR link_id1 LIKE BINARY '%INVOICE%'
		OR link_id1 LIKE BINARY '%CLIENT-BRANCH%'
		OR link_id1 LIKE BINARY '%CLIENT%'
		OR link_id1 LIKE BINARY '%SALES_ORDER%'
		OR link_id1 LIKE BINARY '%SUPPLIER%'
		OR link_id1 LIKE BINARY '%RETROFIT%'
		OR link_id1 LIKE BINARY '%SHIPMENT%'
		OR link_id1 LIKE BINARY '%PAYMENT%'
		OR link_id1 LIKE BINARY '%CLIENT-ACCOUNT%'
		OR link_id1 LIKE BINARY '%RECEIPT%'
		OR link_id1 LIKE BINARY '%SERIAL%'
		OR link_id1 LIKE BINARY '%DAMAGE%'
		OR link_id1 LIKE BINARY '%PRICE_LIST%'
		OR link_id1 LIKE BINARY '%STAFF%'
		OR link_id1 LIKE BINARY '%DEPARTMENT%'
		OR link_id1 LIKE BINARY '%RECEIVED%'";
		
		$sql3 = "UPDATE egw_links SET link_id2 =  REPLACE(link_id2, '-', '_') , link_id2 = REPLACE(link_id2, ':', '-')
		WHERE link_id2 LIKE BINARY '%STOCK%'
		OR link_id2 LIKE BINARY '%LOCATION%'
		OR link_id2 LIKE BINARY '%ORDER%'
		OR link_id2 LIKE BINARY '%WORK_ORDER%'
		OR link_id2 LIKE BINARY '%INVOICE%'
		OR link_id2 LIKE BINARY '%CLIENT-BRANCH%'
		OR link_id2 LIKE BINARY '%CLIENT%'
		OR link_id2 LIKE BINARY '%SALES_ORDER%'
		OR link_id2 LIKE BINARY '%SUPPLIER%'
		OR link_id2 LIKE BINARY '%RETROFIT%'
		OR link_id2 LIKE BINARY '%SHIPMENT%'
		OR link_id2 LIKE BINARY '%PAYMENT%'
		OR link_id2 LIKE BINARY '%CLIENT-ACCOUNT%'
		OR link_id2 LIKE BINARY '%RECEIPT%'
		OR link_id2 LIKE BINARY '%SERIAL%'
		OR link_id2 LIKE BINARY '%DAMAGE%'
		OR link_id2 LIKE BINARY '%PRICE_LIST%'
		OR link_id2 LIKE BINARY '%STAFF%'
		OR link_id2 LIKE BINARY '%DEPARTMENT%'
		OR link_id2 LIKE BINARY '%RECEIVED%'";
		
		$sql4 = "UPDATE egw_vfs SET vfs_directory =  REPLACE(vfs_directory, '-', '_') , vfs_directory = REPLACE(vfs_directory, ':', '-')
		WHERE vfs_directory LIKE BINARY '%STOCK%'
		OR vfs_directory LIKE BINARY '%LOCATION%'
		OR vfs_directory LIKE BINARY '%ORDER%'
		OR vfs_directory LIKE BINARY '%WORK_ORDER%'
		OR vfs_directory LIKE BINARY '%INVOICE%'
		OR vfs_directory LIKE BINARY '%CLIENT-BRANCH%'
		OR vfs_directory LIKE BINARY '%CLIENT%'
		OR vfs_directory LIKE BINARY '%SALES_ORDER%'
		OR vfs_directory LIKE BINARY '%SUPPLIER%'
		OR vfs_directory LIKE BINARY '%RETROFIT%'
		OR vfs_directory LIKE BINARY '%SHIPMENT%'
		OR vfs_directory LIKE BINARY '%PAYMENT%'
		OR vfs_directory LIKE BINARY '%CLIENT-ACCOUNT%'
		OR vfs_directory LIKE BINARY '%RECEIPT%'
		OR vfs_directory LIKE BINARY '%SERIAL%'
		OR vfs_directory LIKE BINARY '%DAMAGE%'
		OR vfs_directory LIKE BINARY '%PRICE_LIST%'
		OR vfs_directory LIKE BINARY '%STAFF%'
		OR vfs_directory LIKE BINARY '%DEPARTMENT%'
		OR vfs_directory LIKE BINARY '%RECEIVED%'";
		
		$sql5 = "UPDATE egw_vfs SET vfs_name =  REPLACE(vfs_name, '-', '_') , vfs_name = REPLACE(vfs_name, ':', '-')
		WHERE vfs_name LIKE BINARY '%STOCK%'
		OR vfs_name LIKE BINARY '%LOCATION%'
		OR vfs_name LIKE BINARY '%ORDER%'
		OR vfs_name LIKE BINARY '%WORK_ORDER%'
		OR vfs_name LIKE BINARY '%INVOICE%'
		OR vfs_name LIKE BINARY '%CLIENT-BRANCH%'
		OR vfs_name LIKE BINARY '%CLIENT%'
		OR vfs_name LIKE BINARY '%SALES_ORDER%'
		OR vfs_name LIKE BINARY '%SUPPLIER%'
		OR vfs_name LIKE BINARY '%RETROFIT%'
		OR vfs_name LIKE BINARY '%SHIPMENT%'
		OR vfs_name LIKE BINARY '%PAYMENT%'
		OR vfs_name LIKE BINARY '%CLIENT-ACCOUNT%'
		OR vfs_name LIKE BINARY '%RECEIPT%'
		OR vfs_name LIKE BINARY '%SERIAL%'
		OR vfs_name LIKE BINARY '%DAMAGE%'
		OR vfs_name LIKE BINARY '%PRICE_LIST%'
		OR vfs_name LIKE BINARY '%STAFF%'
		OR vfs_name LIKE BINARY '%DEPARTMENT%'
		OR vfs_name LIKE BINARY '%RECEIVED%'";
		
		$sql6 = "UPDATE perp_stock_history SET link_id =  REPLACE(link_id, '-', '_') , link_id = REPLACE(link_id, ':', '-')
		WHERE link_id LIKE BINARY '%STOCK%'
		OR link_id LIKE BINARY '%LOCATION%'
		OR link_id LIKE BINARY '%ORDER%'
		OR link_id LIKE BINARY '%WORK_ORDER%'
		OR link_id LIKE BINARY '%INVOICE%'
		OR link_id LIKE BINARY '%CLIENT-BRANCH%'
		OR link_id LIKE BINARY '%CLIENT%'
		OR link_id LIKE BINARY '%SALES_ORDER%'
		OR link_id LIKE BINARY '%SUPPLIER%'
		OR link_id LIKE BINARY '%RETROFIT%'
		OR link_id LIKE BINARY '%SHIPMENT%'
		OR link_id LIKE BINARY '%PAYMENT%'
		OR link_id LIKE BINARY '%CLIENT-ACCOUNT%'
		OR link_id LIKE BINARY '%RECEIPT%'
		OR link_id LIKE BINARY '%SERIAL%'
		OR link_id LIKE BINARY '%DAMAGE%'
		OR link_id LIKE BINARY '%PRICE_LIST%'
		OR link_id LIKE BINARY '%STAFF%'
		OR link_id LIKE BINARY '%DEPARTMENT%'
		OR link_id LIKE BINARY '%RECEIVED%'";
		
		$sql7 = "UPDATE perp_client_ledger
		SET link =  CONCAT_WS(':',SUBSTRING_INDEX(`link`, ':', 1),NULL,REPLACE(SUBSTRING_INDEX(`link`, ':', -2), ':', '-'))
		WHERE link LIKE BINARY '%STOCK%'
		OR link LIKE BINARY '%LOCATION%'
		OR link LIKE BINARY '%ORDER%'
		OR link LIKE BINARY '%WORK_ORDER%'
		OR link LIKE BINARY '%INVOICE%'
		OR link LIKE BINARY '%CLIENT-BRANCH%'
		OR link LIKE BINARY '%CLIENT%'
		OR link LIKE BINARY '%SALES_ORDER%'
		OR link LIKE BINARY '%SUPPLIER%'
		OR link LIKE BINARY '%RETROFIT%'
		OR link LIKE BINARY '%SHIPMENT%'
		OR link LIKE BINARY '%PAYMENT%'
		OR link LIKE BINARY '%CLIENT-ACCOUNT%'
		OR link LIKE BINARY '%RECEIPT%'
		OR link LIKE BINARY '%SERIAL%'
		OR link LIKE BINARY '%DAMAGE%'
		OR link LIKE BINARY '%PRICE_LIST%'
		OR link LIKE BINARY '%STAFF%'
		OR link LIKE BINARY '%DEPARTMENT%'
		OR link LIKE BINARY '%RECEIVED%'";
		
		$sql8 = "UPDATE perp_supplier_ledger
		SET link =  CONCAT_WS(':',SUBSTRING_INDEX(`link`, ':', 1),NULL,REPLACE(SUBSTRING_INDEX(`link`, ':', -2), ':', '-'))
		WHERE link LIKE BINARY '%STOCK%'
		OR link LIKE BINARY '%LOCATION%'
		OR link LIKE BINARY '%ORDER%'
		OR link LIKE BINARY '%WORK_ORDER%'
		OR link LIKE BINARY '%INVOICE%'
		OR link LIKE BINARY '%CLIENT-BRANCH%'
		OR link LIKE BINARY '%CLIENT%'
		OR link LIKE BINARY '%SALES_ORDER%'
		OR link LIKE BINARY '%SUPPLIER%'
		OR link LIKE BINARY '%RETROFIT%'
		OR link LIKE BINARY '%SHIPMENT%'
		OR link LIKE BINARY '%PAYMENT%'
		OR link LIKE BINARY '%CLIENT-ACCOUNT%'
		OR link LIKE BINARY '%RECEIPT%'
		OR link LIKE BINARY '%SERIAL%'
		OR link LIKE BINARY '%DAMAGE%'
		OR link LIKE BINARY '%PRICE_LIST%'
		OR link LIKE BINARY '%STAFF%'
		OR link LIKE BINARY '%DEPARTMENT%'
		OR link LIKE BINARY '%RECEIVED%'";
		
		$GLOBALS['egw_setup']->oProc->m_odb->transaction_begin();
		$GLOBALS['egw_setup']->oProc->query($sql1);
		$GLOBALS['egw_setup']->oProc->query($sql2);
		$GLOBALS['egw_setup']->oProc->query($sql3);
		$GLOBALS['egw_setup']->oProc->query($sql4);
		$GLOBALS['egw_setup']->oProc->query($sql5);
		$GLOBALS['egw_setup']->oProc->query($sql6);
		$GLOBALS['egw_setup']->oProc->query($sql7);
		$GLOBALS['egw_setup']->oProc->query($sql8);
		$GLOBALS['egw_setup']->oProc->m_odb->transaction_commit();
		return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.2.002';
		
	}

// Force tables to InnoDB
so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_api');



function perp_api_upgrade0_2_002()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payment_method','payment_method_name',array(
		'type' => 'varchar',
		'precision' => '40',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.2.003';
}


function perp_api_upgrade0_2_003()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_invoice','class',array(
		'type' => 'varchar',
		'precision' => '32',
		'nullable' => False,
		'default' => 'Invoice'
	));

	$GLOBALS['egw_setup']->oProc->m_odb->transaction_begin();
	$GLOBALS['egw_setup']->oProc->query('UPDATE perp_invoice SET class = \'PayableInvoice\' WHERE client_id = 0');
	$GLOBALS['egw_setup']->oProc->query('UPDATE perp_invoice SET class = \'ReceivableInvoice\' WHERE supplier_id = 0');
	$GLOBALS['egw_setup']->oProc->m_odb->transaction_commit();
	
	return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.2.004';
}


function perp_api_upgrade0_2_004()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_order','class',array(
		'type' => 'varchar',
		'precision' => '32',
		'nullable' => False,
		'default' => 'Order'
	));

	$GLOBALS['egw_setup']->oProc->m_odb->transaction_begin();
	$GLOBALS['egw_setup']->oProc->query('UPDATE perp_order SET class = \'PurchaseOrder\' WHERE client_id = 0');
	$GLOBALS['egw_setup']->oProc->query('UPDATE perp_order SET class = \'SalesOrder\' WHERE supplier_id = 0');
	$GLOBALS['egw_setup']->oProc->m_odb->transaction_commit();

	return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.2.005';
}


function perp_api_upgrade0_2_005()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_shipment','class',array(
		'type' => 'varchar',
		'precision' => '32',
		'nullable' => False,
		'default' => 'Shipment'
	));

	$GLOBALS['egw_setup']->oProc->m_odb->transaction_begin();
	$GLOBALS['egw_setup']->oProc->query('UPDATE perp_shipment SET class = \'IncomingShipment\' WHERE client_id = 0');
	$GLOBALS['egw_setup']->oProc->query('UPDATE perp_shipment SET class = \'OutgoingShipment\' WHERE supplier_id = 0');
	$GLOBALS['egw_setup']->oProc->m_odb->transaction_commit();

	return $GLOBALS['setup_info']['perp_api']['currentver'] = '0.2.006';
}

