<?php
	if (!defined('PHPUnit_MAIN_METHOD')) {
		define('PHPUnit_MAIN_METHOD', 'AllTests::main');
	}

	require_once 'PHPUnit/Framework.php';
	require_once 'PHPUnit/TextUI/TestRunner.php';

	// eGroupWare
	$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_api';
	require_once '../../header.inc.php';

	class AllTests {

		public static function main() {
			PHPUnit_TextUI_TestRunner::run(self::suite());
		}

		public static function suite() {
			$ignore = array(
				'AllTests.php',
				'generate_skeleton.php'
			);

			$suite = new PHPUnit_Framework_TestSuite('pERP API');

			$dir_contents = scandir('.');

			foreach($dir_contents as $file) {
				if(in_array($file, $ignore) || !is_file($file) || strpos($file, 'Test.php') != strlen($file) - 8) {
					continue;
				}
				if(is_file($file)) {
					list($class_name) = explode('.', $file);
					include_once($file);

					if(class_exists($class_name)) {
						$suite->addTestSuite($class_name);
					}
				}
			}
			return $suite;
		}
	}

	if (PHPUnit_MAIN_METHOD == 'AllTests::main') {
		AllTests::main();
	}
?>
