<?php
	require_once(EGW_SERVER_ROOT . '/perp_ledger/inc/class.GLTransaction.inc.php');

	class ClientTransactionLine extends TransactionLine {

		private $table = 'perp_client_ledger';
		private $client;
		private $client_account;
		private $due_date;
		private $settled;
		private $exchange_rate;
		private $hold;
		private $our_reference;
		private $their_reference;
		private $link;
		private $comment;

		public function ClientTransactionLine($parent) {
			if(is_a($parent, 'TransactionLine')) {
                                // An associated transaction
                                $this->transaction = $parent->transaction;
                                if(!$this->transaction->get_transaction_number()) {
                                        $this->set_account($parent->get_account());
                                        $this->set_amount($parent->get_amount());
                                        $this->narrative = $parent->get_narrative();
                                }
				$parent->add_associated_line($this);
                        } elseif( is_a($parent, 'GLTransaction')) {
                                // New transaction
                                $this->transaction = $parent;
				if($this->transaction->get_transaction_number()) {
					return $this->read($this->transaction->get_transaction_number());
				}
                        }
		}

		/* Returns the line number */
		public function read($trans_id) {
			$GLOBALS['egw']->db->select($this->table, array(
					'trans_id',
					'line_no',
					'client_id',
					'client_account_id',
					'due_date',
					'exchange_rate',
					'our_reference',
					'their_reference',
					'link',
				),
				array('trans_id'	=>	$trans_id),
				__LINE__, __FILE__, 'perp_ar'
			);
			$row = $GLOBALS['egw']->db->row(true);
			$this->client		=	$row['client_id'];
			$this->client_account_id=	$row['client_account_id'];
			$this->due_date		=	$row['due_date'];
			$this->exchange_rate	=	$row['exchange_rate'];
			$this->our_reference	=	$row['our_reference'];
			$this->their_reference	=	$row['their_reference'];
			$this->link		=	$row['link'];
			return $row['line_no'];
		}

		public function write($line_no) {
			$GLOBALS['egw']->db->insert($this->table, array(
				'trans_id'	=>	$this->transaction->get_transaction_number(),
				'line_no'	=>	$line_no,
				'client_id'	=>	$this->client,
				'client_account_id'	=>	$this->client_account,
				'due_date'	=>	$this->due_date,
				'settled'	=>	$this->settled,
				'exchange_rate'	=>	$this->exchange_rate,
				'amount'	=>	$this->get_amount(),
				'our_reference'	=>	$this->our_reference,
				'their_reference'	=>	$this->their_reference,
				'link'		=>	$this->link,
				),
				array(
					'trans_id'	=>	$this->transaction->get_transaction_number(),
					'line_no'	=>	$line_no
				),
				__LINE__, __FILE__, 'perp_ar'
			);
		}

		public function get_client() {
			return $this->client;
		}

		public function set_client($client_id) {
			$this->client = $client_id;
		}

		public function set_client_account($client_account_id) {
			$this->client_account = $client_account_id;
		}

		public function set_due_date($date) {
			$this->due_date = $date;
		}

		public function get_exchange_rate() {
			return $this->exchange_rate;
		}
		public function set_exchange_rate($rate) {
			$this->exchange_rate = $rate;
		}

		public function set_hold($hold) {
			$this->hold = $hold;
		}

		public function set_our_reference($ref) {
			$this->our_reference = $ref;
		}
		public function set_client_reference($client_ref) {
			$this->their_reference = $client_ref;
		}

		public function set_link($link_to_app, $link_to_id) {
			$temp_id = 0;
			$title = egw_link::title($link_to_app, $link_to_id);
			$this->link = egw_link::link(' ', $temp_id, $link_to_app, $link_to_id, $title);
		}

		public function get_link() {
			return $this->link;
		}

		public function set_comment($c) {
			$this->comment = $c;
		}

		public function __sleep() {
			$sleep = parent::sleep();
			$sleep += array('client', 'client_account', 'due_date', 'settled', 'exchange_rate', 'our_reference', 'their_reference', 'link');
			return $sleep;
		}

		public function __toString() {
			return "ClientTransactionLine \tClient: " . $this->client . "( $this->client_account )\tAmount: " . $this->amount ."\t(" . $this->link . ")\n";
		}
	}
?>
