<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.ajax_perp_shipment.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_ar/inc/class.bo_perp_client_branch.inc.php');
	require_once('class.OutgoingShipment.inc.php');

	class ajax_perp_outgoing_shipment extends ajax_perp_shipment {
		
		protected $response;
		
		function ajax_perp_outgoing_shipment() {
			parent::__construct();
			$this->bo_client_branch = CreateObject('perp_ar.bo_perp_client_branch');
			
			$this->response = new xajaxResponse();
		}
		
		function change_client($client_id) {
			
			
			//Query the client branch list with client id filter
			$query['filter'] = $client_id;
			$query['template'] = false;
			$count = $this->bo_client_branch->get_client_branch_list($query, $branch_list);
			
			//Auto populate the Client Branch Ajax select widget if only one result
			if($count <= 1) {
				$this->response->addScript('
				var branch_search = document.getElementById("exec[client_branch_id][search]");
				if(branch_search) {
					branch_search.value = "'.$branch_list[0]['client_num'].'('.$branch_list[0]['client_branch_id'].') '.$branch_list[0]['branch_name'].'";
				}
				var branch_value = document.getElementById("exec[client_branch_id][value]");
				if(branch_value) {
					
					branch_value.value = "'.$branch_list[0]['client_branch_id'].'";					
				}
			');
			
			//Trigger change_client_branch() method
			$this->change_client_branch($branch_list[0][client_id], $branch_list[0]['client_branch_id'], false);
					
			}
			
			return $this->response->getXML();
			
		}

		/**
		*	User changed the client branch.  We'll get the contact information.
		*/
		function change_client_branch($client_id, $branch_id, $not_triggered = true) {
			
			/*
			$this->response->addScript("alert('".$client_id."')");
			$this->response->addScript("alert('".$branch_id."')");
			$this->response->addScript("alert('".$triggered."')");
			*/
			
			
			$query = array(
				'client_id'	=>	$client_id,
			);

			// Ship to addresses
			
			$this->response->addScript("removeOptions('exec[ship_to_address]')");
			$branches = ExecMethod('perp_ar.bo_perp_client_branch.get_client_branch_list', $query);
			$contacts = array();
			foreach($branches as $branch_id => $branch_name) {
				$contacts += egw_link::get_links('perp_ar', 'CLIENT_BRANCH-' . $branch_id , 'addressbook');
			}
			$contacts += egw_link::get_links('perp_ar', 'CLIENT-' .$client_id, 'addressbook');
			foreach($contacts as $id => &$contact) {
				$name = egw_link::title('addressbook', $contact);
				$this->response->addScript("selectbox_add_option('exec[ship_to_address]', '" . addslashes($name) . "', '" . $contact . "')");
			}
			reset($contacts);
			if(count($contacts) > 0) {
				$this->response->addAssign('exec[ship_to_address]', 'value', current($contacts));
			}
			
			if($not_triggered){
				return $this->response->getXML();
				
			}
						
		}
	}
?>
