<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.ajax_perp_invoice.inc.php');
	require_once('class.ReceivableInvoice.inc.php');
	require_once('class.bo_perp_client_branch.inc.php');
	require_once('class.bo_perp_client_account.inc.php');

	class ajax_perp_receivable_invoice {
		
		function ajax_perp_receivable_invoice() {
			$this->xajax = new xajax();
			$this->response = new xajaxResponse();
			$this->bo_client_branch = new bo_perp_client_branch();
			$this->bo_client_account = new bo_perp_client_account();
		}

		function change_client($client_id) {

			// Change list of contacts
			$contacts = egw_link::get_links('perp_ar', 'CLIENT-' . $client_id, 'addressbook');
			$this->response->addScript("removeOptions('exec[their_contact_person]')");
			if(is_array($contacts)) {
				foreach($contacts as $key => $contact_id) {
					$contact = egw_link::title('addressbook', $contact_id);
					$this->response->addScript("addOption('exec[their_contact_person]', '" . $contact_id . "', '" . $contact . "')");
				}
			}

			// Clear Account & Branch
			$this->response->addScript('
				var branch_search = document.getElementById("exec[client_branch_id][search]");
				if(branch_search) {
					branch_search.value = \'\';
				}
				var branch_value = document.getElementById("exec[client_branch_id][value]");
				if(branch_value) {
					branch_value.value = \'\';
				}
				var account_search = document.getElementById("exec[client_account_id][search]");
				if(account_search) {
					account_search.value = \'\';
				}
				var account_value = document.getElementById("exec[client_account_id][value]");
				if(account_value) {
					account_value.value = \'\';
				}
			');

			// Restrict Account & Branch selection to only this client
			$this->response->addScript('
				var branch = document.getElementById("exec[client_branch_id][results]");
				if(branch) {
					branch.options.client_id = ' . $client_id . ';
				}
				var account = document.getElementById("exec[client_account_id][results]");
				if(account) {
					account.options.client_id = ' . $client_id . ';
				}
			');

			//Query the client branch list with client id filter
			$query = array(
				'client_id'	=>	$client_id,
				'template'	=>	false,
			);
			$count = $this->bo_client_branch->get_client_branch_list($query, $branch_list);

			//Auto populate the Client Branch Ajax select widget if only one result
			if($count == 1) {
				$this->response->addScript('
					var branch_search = document.getElementById("exec[client_branch_id][search]");
					if(branch_search) {
						branch_search.value = "'.$branch_list[0]['client_num'].'('.$branch_list[0]['client_branch_id'].') '.$branch_list[0]['branch_name'].'";
					}
					var branch_value = document.getElementById("exec[client_branch_id][value]");
					if(branch_value) {
	
						branch_value.value = "'.$branch_list[0]['client_branch_id'].'";
					}
				');

				//Trigger change_client_branch() method
				$this->change_client_branch($branch_list[0]['client_branch_id'], false);

			}

			//Query the client account list with client id filter
			$query = array(
				'client_id'	=>	$client_id,
				'template'	=>	false,
			);
			$count = $this->bo_client_account->get_client_account_list($query, $account_list);

			//Auto populate the Client Account Ajax select widget if only one result
			if($count == 1) {
				$this->response->addScript('
					var account_search = document.getElementById("exec[client_account_id][search]");
					if(account_search) {
						account_search.value = "'. ExecMethod('perp_ar.bo_perp_client_account.link_title', $account_list[0]['client_account_id']) . '";
					}
					var account_value = document.getElementById("exec[client_account_id][value]");
					if(account_value) {
	
						account_value.value = "'.$account_list[0]['client_account_id'].'";
					}
				');

				//Trigger change_client_branch() method
				$this->change_client_account($account_list[0]['client_account_id'], false);
			}

			// Default currency
			$client_data = ExecMethod('perp_ar.bo_perp_client.get_client', $client_id);
			$this->response->addScript('
				var currency = document.getElementById("exec[invoice_currency]");
				if(currency) {
					currency.value ="'. $client_data['currency'] . '";
				}'
			);

			// Update Invoice
			$invoice = $GLOBALS['egw']->session->appsession('invoice');
			if($invoice instanceof Invoice) {
				$result = $invoice->set_client_id((int)$client_id);
				if($result === true) {
					// Suggest invoice number
					// Need to clear it first, otherwise it'll just suggest the current value
					$invoice->set_our_reference_number(false);
					$invoice->set_our_reference_number($invoice->suggest_invoice_number());
					$this->response->addScript("
						var our_reference = document.getElementById('exec[our_reference_number]');
						if(our_reference) {
							our_reference.value = '" . $invoice->get_our_reference_number() . "';
						}
						var exchange_rate = document.getElementById('exec[exchange_rate]');
						if(exchange_rate) {
							exchange_rate.value = '" . $invoice->get_exchange_rate() . "';
						}
					");
				} else {
					$this->response->addAlert($result);
				}
			}                        
			$GLOBALS['egw']->session->appsession('invoice', $GLOBALS['egw_info']['flags']['currentapp'], $invoice);

			return $this->response->getXML();
		}

		/**
		*	User changed the client branch.  We'll get the contact information.
		*/
		function change_client_branch($client_branch_id, $return = true) {

			$branch = ExecMethod('perp_ar.bo_perp_client_branch.get_client_branch', $client_branch_id);

			// Change list of contacts
			$contacts = array();
			$this->response->addScript("removeOptions('exec[their_contact_person]')");
			$contacts += egw_link::get_links('perp_ar', 'CLIENT-' . $branch['client_id'], 'addressbook');
			$contacts += egw_link::get_links('perp_ar', 'CLIENT_BRANCH-' . $client_branch_id, 'addressbook');
			if(is_array($contacts)) {
				foreach($contacts as $key => $contact_id) {
					$contact = egw_link::title('addressbook', $contact_id);
					$this->response->addScript("addOption('exec[their_contact_person]', '" . $contact_id . "', '" . $contact . "')");
				}
			}
			if($return) {
				return $this->response->getXML();
			}
		}

		/**
		* 	User changed the client account.  We'll default the payment terms.
		*/
		function change_client_account($client_account_id, $return = true) {
			$account = ExecMethod('perp_ar.bo_perp_client_account.get_client_account', $client_account_id);
			$invoice = $GLOBALS['egw']->session->appsession('invoice');

			if($client_account_id != $invoice->get_client_account_id()) {
				$this->response->addScript('
					var terms = document.getElementById("exec[payment_terms]");
					if(terms) {
						terms.value = "' . $account['payment_terms'] .'";
					}'
				);
			}
			if($return) {
				return $this->response->getXML();
			}
		}
	}
?>
