<?php
	class bo_perp_ar {
		private $so;

		public function bo_perp_ar() {
			$this->so = CreateObject('perp_ar.so_perp_ar');
		}

		public function get_hold_reasons($query = array(), &$rows = array(), &$readonly = array()) {
			if(!$GLOBALS['egw']->acl->check('hold_reason', EGW_ACL_READ, 'perp_ar')) {
				if(isset($query['template'])) {
					$rows = array();
					return 0;
				} else {
					return array();
				}
			}
			$list = $this->so->get_hold_reasons();
			if(!isset($query['template'])) {
				foreach($list as $key => $row) {
					$rows[$row['hold_reason_id']] = $row['hold_reason_name'];
				}
				return $rows;
			} else {
				$rows = array_slice($list, $query['start'], $GLOBALS['egw_info']['user']['preferences']['common']['maxmatchs']);
				$rows['add'] = $GLOBALS['egw']->acl->check('hold_reason', EGW_ACL_ADD, 'perp_ar');
				$rows['edit'] = $GLOBALS['egw']->acl->check('hold_reason', EGW_ACL_EDIT, 'perp_ar');
				$rows['delete'] = $GLOBALS['egw']->acl->check('hold_reason', EGW_ACL_DELETE, 'perp_ar');
				return count($list);
			}
		}

		/**
		* get title for an perp client or client branch identified by $entry
		* 
		* Is called as hook to participate in the linking
		*
		* @param int/array $entry int client_id or string client_id:branch_id or array with client entry
		* @param string  with title/boolean
		*/
		function link_title( $entry ) {	
			if (!is_array($entry)) {
				list($location, $id) = explode('-', $entry);
				if($id) {
					switch($location) {
						case 'CLIENT':
							return ExecMethod('perp_ar.bo_perp_client.link_title', $id);
							break;
						case 'CLIENT_BRANCH':
							return ExecMethod('perp_ar.bo_perp_client_branch.link_title', $id);
							break;
						case 'CLIENT_ACCOUNT':
							return ExecMethod('perp_ar.bo_perp_client_account.link_title', $id);
							break;
						case 'SO':
							break;
						case 'SHIPMENT':
							return ExecMethod('perp_ar.bo_perp_outgoing_shipment.link_title', $id);
							break;
						case 'INVOICE':
							return ExecMethod('perp_ar.bo_perp_receivable_invoice.link_title', $id);
							break;
						case 'RECEIPT':
							return ExecMethod('perp_ar.bo_perp_receipt.link_title', $id);
							break;
					}
				} else {
					return ExecMethod('perp_ar.bo_perp_client.link_title', $location);
				}
			} else {
				if(isset($entry['client_branch_id'])) {
					return ExecMethod('perp_ar.bo_perp_client_branch.link_title', $entry['client_branch_id']);
				} elseif(isset($entry['client_id'])) {
					return ExecMethod('perp_ar.bo_perp_client.link_title', $entry['client_id']);
				} elseif(isset($entry['sales_order_id'])) {
					return ExecMethod('perp_ar.bo_perp_sales_order.link_title', $entry['sales_order_id']);
				} elseif(isset($entry['shipment_id'])) {
					return ExecMethod('perp_ar.bo_perp_client_shipment.link_title', $entry['shipment_id']);
				} elseif(isset($entry['invoice_id'])) {
					return ExecMethod('perp_ar.bo_perp_client_invoice.link_title', $entry['invoice_id']);
				} elseif(isset($entry['receipt_id'])) {
					return ExecMethod('perp_ar.bo_perp_receipt.link_title', $entry['receipt_id']);
				}
			}
			if (!$entry) {
				return $entry;
			}
		}

		
		/**
		* query perp clients for entries matching $pattern
		*
		* Is called as hook to participate in the linking
		*
		* @param string $pattern pattern to search
		* @return array with client_id - title pairs of the matching entries
		*/
		function link_query( $pattern ) {		
			list($location, $pattern) = explode('-', $pattern, 2);
			if(!$pattern) {
				$pattern = $location;
				unset($location);
			} else {
				$location = strtoupper($location);
			}
			$list = array();
			switch (strtoupper($location)) {
				case 'C':
				case 'CLIENT':
				case strtoupper(lang('client')):
					$list = ExecMethod('perp_ar.bo_perp_client.link_query', $pattern);
					break;
				case 'CB':
				case 'CLIENT_BRANCH':
				case strtoupper(lang('Client Branch')):
					$list = ExecMethod('perp_ar.bo_perp_client_branch.link_query', $pattern);
					break;
				case 'I':
				case strtoupper(lang('invoice')):
					$list = ExecMethod('perp_ar.bo_perp_receivable_invoice.link_query', $pattern);
					break;
				default:
					$list = ExecMethod('perp_ar.bo_perp_client.link_query', $pattern);
					$list += ExecMethod('perp_ar.bo_perp_client_branch.link_query', $pattern);
					$list += ExecMethod('perp_ar.bo_perp_receivable_invoice.link_query', $pattern);
					break;
			}
			return $list;
		}
	}
?>
