<?php

	class hook_perp_ar {

		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
			'hold_reason'	=>	True,
		);

		var $appname = 'perp_ar';
		var $template;
		var $bo;
		var $erp;

		public function hook_perp_ar() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_ar.bo_perp_ar');
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file['Site configuration'] = $GLOBALS['phpgw']->link('/index.php', array(
					'menuaction'	=> 'perp_ar.hook_perp_ar.config',
				));
			if($GLOBALS['egw']->acl->check('acl', EGW_ACL_READ, 'perp_ar')) {
				$file['Configure Access Permissions']= $GLOBALS['phpgw']->link('/index.php', array(
					'menuaction'	=> 'perp_ar.hook_perp_ar.acl',
				));
			}
			if($GLOBALS['egw']->acl->check('hold_reason', EGW_ACL_READ, 'perp_ar')) {
				$file['Hold Reasons']= $GLOBALS['phpgw']->link('/index.php', array(
					'menuaction'	=> 'perp_ar.hook_perp_ar.hold_reason',
				));
			}

			display_section($this->appname, $file);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences']            = $GLOBALS['egw']->link('/preferences/preferences.php','appname='.$this->appname);

			//Do not modify below this line
			display_section($this->appname,$this->appname,$file);
		}

		public function user_preferences() {
		}

		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			if($GLOBALS['egw']->acl->check('client', EGW_ACL_READ, $this->appname)) {
				$menu['Clients']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_client.client_list');
			}
			if($GLOBALS['egw']->acl->check('client_branch', EGW_ACL_READ, 'perp_ar')) {
				$menu['Branches'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_client_branch.client_branch_list');
			}
			if($GLOBALS['egw']->acl->check('shipment', EGW_ACL_READ, 'perp_ar')) {
				$menu['Shipments'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_outgoing_shipment.shipment_list');
			}
			if($GLOBALS['egw']->acl->check('invoice', EGW_ACL_READ, 'perp_ar')) {
				$menu['Invoices'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_receivable_invoice.invoice_list');
			}
			if($GLOBALS['egw']->acl->check('receipt', EGW_ACL_READ, 'perp_ar')) {
				$menu['Receipts'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_receipt.receipt_list');
			}
			display_sidebox($this->appname, $menu_title, $menu);
				
			$menu_title = lang('Actions');
			$menu = array();
			if($GLOBALS['egw']->acl->check('client', EGW_ACL_ADD, 'perp_ar')) {
				$menu['New Client'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_client.client_new');
			}
			if($GLOBALS['egw']->acl->check('shipment', EGW_ACL_ADD, 'perp_ar')) {
				$menu['New Shipment'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_outgoing_shipment.new_shipment');
			}
			if($GLOBALS['egw']->acl->check('invoice', EGW_ACL_ADD, 'perp_ar')) {
				$menu['New Invoice'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_receivable_invoice.new_invoice');
			}
			if($GLOBALS['egw']->acl->check('receipt', EGW_ACL_ADD, 'perp_ar')) {
				$menu['New Receipt'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_ar.ui_perp_receipt.receipt_new');
			}
			display_sidebox($this->appname, $menu_title, $menu);
		}

		public function config($content = array()) {
			// validation & correction
			//...
			$selects['credit_transaction_type'] = ExecMethod('perp_ledger.bo_perp_ledger.get_transaction_types');
			$selects['invoice_transaction_type'] = $selects['credit_transaction_type'];
			$selects['shipment_transaction_type'] = $selects['credit_transaction_type'];
			$selects['receipt_transaction_type'] = $selects['credit_transaction_type'];

			// Check bill from address permission
			if($config['default_bill_from']) {
				$address = ExecMethod('addressbook.addressbook_bo.read', $config['default_bill_from']);
				if($address === false) {
					$data['message'] .= lang('Default Bill From address is set, but not readable.  Check permissions.');
				} elseif (is_null($address)) {
					$data['message'] .= lang('Default Bill From address is not set.');
				}
			}

			// Translation for options
			$data['settings'] = array(
				'client_number_params' => array(
					lang('%1 is replaced with %2', '&#37;1$d', lang('Next client number'))
				),
				'invoice_number_params' => array(
					lang('%1 is replaced with %2', '&#37;1$d', lang('client number')),
					lang('%1 is replaced with %2', '&#37;2$d', lang('next number per client')),
					lang('%1 is replaced with %2', 'date(Ymd)', lang('Current date'))
				),
				'invoice_narrative_params' => array(
					lang('%1 is replaced with %2', '&#37;1$d', lang('client number')),
					lang('%1 is replaced with %2', '&#37;2$s', lang('our reference number'))
				),
				'shipment_number_params' => array(
					lang('%1 is replaced with %2', '&#37;2$s', lang('client number')),
					lang('%1 is replaced with %2', '&#37;3$d', lang('next shipment ID number')),
					lang('%1 is replaced with %2', 'date(Ymd)', lang('Current date'))
				),
				'receipt_narrative_params' => array(
					lang('%1 is replaced with %2', '&#37;1$s', lang('client number')),
					lang('%1 is replaced with %2', '&#37;2$s', lang('receipt number')),
					lang('%1 is replaced with %2', '&#37;2$s', lang('our reference number'))
				),
				'discount_narrative_params' => array(
					lang('literal text only')
				)
			);

			// Config hooks for invoicing from other apps - send them the config data
			$hook_settings = array();
			if(is_array($content['settings']['invoicable_config'])) {
				foreach($content['settings']['invoicable_config'] as $key => &$app_settings) {
					$hook_settings[$app_settings['appname']] = $app_settings['config'];
					$hook_settings[$app_settings['appname']]['enabled'] = $app_settings['enabled'];
				}
			}
			unset($content['settings']['invoicable_config']);

			// Get other apps' config data for display
			foreach($GLOBALS['egw_info']['user']['apps'] as $appname => $app_data) {
				$app_hook = $GLOBALS['egw']->hooks->single(
					array(
						'location'      =>      'perp_ar:invoicable',
						'appname'	=>	$appname,
						
					),
					$appname, true
				);
				if($app_hook['config']) {
					$app_config = ExecMethod2($app_hook['config'], $hook_settings[$appname]);
					if($app_config !== false) {
						$app_config['appname'] = $appname;
						$app_config['enabled'] = $app_config['config']['enabled'];
						$data['settings']['invoicable_config'][] = $app_config;
					}
				}
			}
			$this->erp->config($content, $this->appname, 'perp_ar.hook_perp_ar.config',$selects, '', $data);
		}

		public function acl($content = array()) {
			$data = $this->erp->acl($content, 'perp_ar', 'acl', 'acl', $selects, $filters);
		}

		public function home($args = null) {
_debug_array($args);
		}

		/*	search_link is for linking (link widget)
		*/
		public function search_link($params) {
			return array(
				'query'	=>	'perp_ar.bo_perp_ar.link_query',
				'title'	=>	'perp_ar.bo_perp_ar.link_title',
				'view'	=>	array('menuaction'=>'perp_ar.ui_perp_ar.link_view'),
				'view_id'	=>	'link_id',
				'add'	=>	array('menuaction' => 'perp_ar.ui_perp_ar.link_add'),
				'add_id'	=>	'client_id',
				'add_app'	=>	'perp_ar',
				'add_popup'	=>	'750x550',
			);
		}

		public function hold_reason($content = array()) {
			$lookup = 'hold_reason';
                        $data = $this->erp->change_lookup($content, 'perp_ar', $lookup, 'hold_reason', $selects, $filters);
		}

		public function ProjectManagerInvoicable_hook() {
			return array(
				'search'	=>	'perp_ar.ProjectManagerInvoicable.search',
				'config'	=>	'perp_ar.ProjectManagerInvoicable.config',
				'Invoicable'	=>	'perp_ar.ProjectManagerInvoicable',
				'InvoicableItem'	=>	'perp_ar.ProjectManagerInvoicableItem'
			);
		}

		public function TimeSheetInvoicable_hook() {
			return array(
				'search'	=>	'perp_ar.TimeSheetInvoicable.search',
				'config'	=>	'perp_ar.TimeSheetInvoicable.config',
				'Invoicable'	=>	'TimeSheetInvoicable',
				'InvoicableItem'	=>	'TimeSheetInvoicable'
			);
		}
	}
?>
