<?php

	class so_perp_client_branch {
		
		private $db;
		
		public function so_perp_client_branch() {
			$this->db = clone($GLOBALS['egw']->db);
			$this->db->set_app('perp_ar');	
		}

		public function get_client_branch_list($query) {
			$where = array();
			if($query['filter']) {
				if(is_array($query['filter']) && count($query['filter'] > 0)) {
					$where[] = 'perp_client_branch.client_id IN (' . $GLOBALS['egw']->db->quote(implode(',', $query['filter'])) . ')';
				} else {
					$where[] = 'perp_client_branch.client_id = ' . $query['filter'];
				}
			}
			if($query['filter2']) {
				$where[] = 'perp_client.sales_area = ' . $query['filter2'];
			}
			if($query['searchletter']) {
				$where[] = 'branch_name LIKE \'' . $query['searchletter'] . '%\'';
			}

			$this->db->select('perp_client_branch', array(
					'perp_client_branch.client_branch_id',
					'perp_client_branch.client_id',
					'perp_client_branch.branch_name',
					'perp_client.client_num',
					'perp_client.client_name',
					'perp_client_branch.delivery_address',
					'perp_client_branch.postal_address',
					'perp_client_branch.sales_type'),
				$where,
				__LINE__, __FILE__, False,
				"ORDER BY " . $query['order'] . ' ' . $query['sort'], False, 0,
				'JOIN perp_client ON
					perp_client.client_id = perp_client_branch.client_id'
			);

			$list = array();
			while($row = $this->db->row(True)) {
				$list[] = $row;
			}

			return $list;
		}

		public function get_client_branch($id) {
			$this->db->select('perp_client_branch', array(
					'client_branch_id',
					'perp_client_branch.client_id',
					'branch_name',
					'perp_client.client_num',
					'perp_client.client_name',
					'postal_address',
					'delivery_address',
					'est_delivery_days',
					'perp_client_branch.sales_type',
					'sales_rep',
					'service_rep',
					'default_location',
					'default_shipper',
					'tax_group',
					'tax_number',
					'perp_client.user_account',
				),
				array('client_branch_id' => $id),
				__LINE__, __FILE__, False,
				'', False, 0,
				'JOIN perp_client ON
					perp_client.client_id = perp_client_branch.client_id'
			);
			$client = array();
			if($row = $this->db->row(True)) {
				$client = $row;
			}
			return $client;
		}

		public function set_client_branch($id, $branch) {
			$where = array();

			$insert_data = array(
				'client_id'		=>	$branch['client_id'],
				'branch_name'		=>	$branch['branch_name'],
				'postal_address'	=>	$branch['postal_address'],
				'delivery_address'	=>	$branch['delivery_address'],
				'est_delivery_days'	=>	$branch['est_delivery_days'],
				'sales_type'		=>	$branch['sales_type'],
				'sales_rep'		=>	$branch['sales_rep'],
				'service_rep'		=>	$branch['service_rep'],
				'default_location'	=>	$branch['default_location'],
				'default_shipper'	=>	$branch['default_shipper'],
				'tax_group'		=>	$branch['tax_group'],
				'tax_number'		=>	$branch['tax_number'],
				'user_account'		=>	$branch['user_account']
			);

			if($id) {
				$where['client_branch_id'] = $id;
				$insert_data['client_branch_id'] = $id;
			}

			$this->db->insert('perp_client_branch', 
				$insert_data,
				$where,
				__LINE__, __FILE__
			);
			$id = $id ? $id : $this->db->get_last_insert_id('perp_client_branch', 'client_branch_id');
			return $id;
		}

		public function delete_client_branch($id) {
			$this->db->delete('perp_client_branch', 
				array('client_branch_id' => $id),
				__LINE__, __FILE__
			);
		}


		public function link_title($branch_id) {
			$sql = 'SELECT perp_client_branch.client_id, 
					client_branch_id, 
					branch_name, 
					client_num,
					client_name
				FROM perp_client_branch
				JOIN perp_client ON
					perp_client.client_id = perp_client_branch.client_id
				WHERE client_branch_id = ' . $branch_id;
			$this->db->query($sql, __LINE__, __FILE__);
			if($row = $this->db->row(True)) {
				return $row['client_num'] . '(' . $row['client_branch_id'].') ' . 
					$row['client_name'] . ' - '.$row['branch_name'];
			}
			return false;
		}

		public function link_query($pattern) {
			$query_str = 'SELECT 
					perp_client_branch.client_id, 
					client_branch_id, 
					branch_name,
					client_num, 
					client_name
				FROM perp_client_branch 
				JOIN perp_client ON
					perp_client.client_id = perp_client_branch.client_id
				WHERE perp_client_branch.client_id LIKE '.$this->db->quote('%'.$pattern.'%').' OR 
					branch_name LIKE '.$this->db->quote('%'.$pattern.'%') .' OR
					lower(branch_name) LIKE lower('.$this->db->quote('%'.$pattern.'%') .') OR
					client_branch_id LIKE '.$this->db->quote('%'.$pattern.'%');
				
			$this->db->query($query_str, __LINE__, __FILE__);
			$list = array();
			while($row = $this->db->row(True)) {
				$list[] = $row;
			}
			return $list;
		}
	}
?>
