<?php
	require_once('class.ReceivableInvoice.inc.php');

	class so_perp_receipt {

		public function so_perp_receipt() {
		}

		public function get_receipts(&$query) {
			if($query['client_id']) {
				$where[] =' perp_client_ledger.client_id ' . (is_array($query['client_id']) ? ' IN (' . implode(',', $query['client_id']) . ') ' : ' = ' . $GLOBALS['egw']->db->quote($query['client_id']));
			}
			if($query['payment_method']) {
				$where['payment_method'] = (int)$query['payment_method'];
			}
			if($query['search']) {
				$search = $GLOBALS['egw']->db->quote('%' . $query['search'] . '%');
				$where[] = "( payment_number LIKE $search )";
			}
			if(isset($query['col_filter']['status'])) {
				switch ($query['col_filter']['status']) {
					// Outstanding
					case 1:
						$having[] = 'status = 1';
						break;
					// Cleared
					case 2:
						$having[] = 'status = 2';
						break;
					// Reversed
					case 3:
						$having[] = 'status = 3';
						break;
				}

			}
			$sql = 'SELECT DISTINCT
					receipt_id,
					trans_date,
					perp_client_ledger.client_id,
					client_num,
					perp_client_receipt.trans_id,
					round(perp_client_receipt.amount / perp_client_ledger.exchange_rate, 2) AS amount,
					perp_bank_ledger.currency,
					payment_method,
					payment_number,
					CASE
						WHEN reversed.original_id THEN 3
						WHEN SUM(amount_cleared) = perp_bank_ledger.amount THEN 2
						ELSE 1
					END AS status
				FROM (
					SELECT 
						receipt_id,
						trans_id,
						sum(amount) AS amount,
						payment_number
					FROM
						perp_client_receipt
					GROUP BY receipt_id
				) AS perp_client_receipt
				JOIN perp_client_ledger ON
					perp_client_receipt.trans_id = perp_client_ledger.trans_id
				JOIN perp_client ON
					perp_client_ledger.client_id = perp_client.client_id
				JOIN perp_general_ledger ON
					perp_client_ledger.trans_id = perp_general_ledger.trans_no AND
					perp_client_ledger.line_no = perp_general_ledger.line_no
				JOIN perp_bank_ledger ON
					perp_general_ledger.trans_no = perp_bank_ledger.trans_id
				LEFT JOIN perp_bank_reconcile ON
					perp_bank_ledger.trans_id = perp_bank_reconcile.trans_id
					AND perp_bank_ledger.bank_account = perp_bank_reconcile.account
				LEFT JOIN perp_receipt_reversal AS reversed ON
					perp_client_receipt.receipt_id = reversed.original_id
				';
			if(count($where)) {
				$sql .= ' WHERE ' . $GLOBALS['egw']->db->column_data_implode(' AND ', $where);
			}
			$sql .= ' GROUP BY perp_bank_ledger.trans_id, perp_bank_ledger.bank_account ';
			if($having) {
				$sql .= ' HAVING ' . $GLOBALS['egw']->db->column_data_implode(' AND ', $having);
			}
			$sql .= ' ORDER BY ' . $query['order'] . ' ' . $query['sort'];
			$query['count'] = $GLOBALS['egw']->db->query($sql, __LINE__, __FILE__)->NumRows();
			$GLOBALS['egw']->db->query($sql, __LINE__, __FILE__, $query['start'], $query['num_rows']);
			$list = array();

			while($row = $GLOBALS['egw']->db->row(True)) {
				$row['formatted_amount'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', $row['currency'],  $row['amount']);
				$list[] = $row;
			}
			return $list;
		}

		public function get_receipt($receipt_id) {
			$sql = 'SELECT DISTINCT
					receipt_id,
					perp_client_receipt.trans_id,
					trans_date,
					perp_client_receipt.invoice_id,
					perp_client_receipt.payment_number,
					perp_invoice.our_reference_number,
					perp_client_receipt.amount,
					allocation_date,
					perp_client_ledger.client_id,
					client_name,
					perp_bank_ledger.currency,
					perp_bank_ledger.bank_account,
					payment_method,
					CASE
						WHEN reversed.original_id THEN 3
						WHEN SUM(amount_cleared) = perp_bank_ledger.amount THEN 2
						ELSE 1
					END AS status
				FROM perp_client_receipt
				LEFT JOIN perp_invoice ON
					perp_client_receipt.invoice_id = perp_invoice.invoice_id
				JOIN perp_client_ledger ON
					perp_client_receipt.trans_id = perp_client_ledger.trans_id
				JOIN perp_general_ledger ON
					perp_client_ledger.trans_id = perp_general_ledger.trans_no AND
					perp_client_ledger.line_no = perp_general_ledger.line_no
				JOIN perp_client ON
					perp_client_ledger.client_id = perp_client.client_id
				JOIN perp_bank_ledger ON
					perp_general_ledger.trans_no = perp_bank_ledger.trans_id
				LEFT JOIN perp_bank_reconcile ON
					perp_bank_ledger.trans_id = perp_bank_reconcile.trans_id
					AND perp_bank_ledger.bank_account = perp_bank_reconcile.account
				LEFT JOIN perp_receipt_reversal AS reversed ON
					perp_client_receipt.receipt_id = reversed.original_id
				WHERE receipt_id =' . $receipt_id . '
				GROUP BY perp_bank_ledger.trans_id,
					perp_client_receipt.invoice_id,
					perp_client_receipt.allocated_from,
					 perp_bank_ledger.bank_account';
			$GLOBALS['egw']->db->query($sql, __LINE__, __FILE__);

			$list = array(0 => false);
			$list['total'] = 0;
			$list['receipt_id'] = $receipt_id;

			while($row = $GLOBALS['egw']->db->row(True)) {
				$list['client_id'] = $row['client_id'];
				$list['client_name'] = $row['client_name'];
				$list['date'] = $row['trans_date'];
				$list['currency'] = $list['currency'] ? $list['currency'] : $row['currency'];
				$list['payment_number'] = $row['payment_number'];
				$list['payment_method'] = $row['payment_method'];
				$list['bank_account'] = $row['bank_account'];
				$list['trans_id'] = $row['trans_id'];
				$list['status'] = $row['status'];
				$list['total'] += $row['amount'];
				if(!$row['invoice_id']) {
					$row['reference'] = lang('pre-payment');
				}
				$row['formatted_amount'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', $list['currency'], $row['amount']);
				$list[] = $row;
			}
			$list['formatted_total'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', $list['currency'], $list['total']);

			return $list;
		}

		public function get_unallocated_amounts(&$query) {
			$sql = 'SELECT 
					perp_client_receipt.receipt_id AS reference_id,
					perp_client_receipt.receipt_id,
					perp_client_receipt.trans_id,
					perp_client_receipt.allocation_date,
					null AS invoice_id,
					null AS due_date,
					-perp_client_receipt.amount AS original_amount,
					sum(prepay.amount) AS amount_paid
				FROM perp_client_receipt 
				JOIN perp_client_ledger ON
					perp_client_receipt.trans_id = perp_client_ledger.trans_id
				LEFT JOIN perp_client_receipt AS prepay ON
					perp_client_receipt.receipt_id = prepay.allocated_from
				WHERE perp_client_receipt.allocation_date IS NULL
					AND perp_client_ledger.client_id = ' . $query['client_id'] . '
				GROUP BY perp_client_receipt.invoice_id, perp_client_receipt.receipt_id

				UNION 

				SELECT 
					perp_invoice.our_reference_number AS reference_id,
					perp_client_receipt.receipt_id,
					perp_client_receipt.trans_id,
					perp_client_receipt.allocation_date,
					perp_invoice.invoice_id,
					perp_invoice.due_date,
					original_amount,
					sum(perp_client_receipt.amount) AS amount_paid
				FROM perp_invoice
				JOIN (
					SELECT 
						invoice_id,
						sum(perp_invoice_line.quantity * perp_invoice_line.unit_price) AS original_amount
					FROM
						perp_invoice_line 
					GROUP BY perp_invoice_line.invoice_id
				) AS perp_invoice_line ON
					perp_invoice.invoice_id = perp_invoice_line.invoice_id
				LEFT JOIN perp_client_receipt ON
					perp_client_receipt.invoice_id = perp_invoice.invoice_id
				WHERE perp_invoice.client_id = ' . $query['client_id'] . ' AND
					!perp_invoice.invoice_paid AND
					perp_invoice.invoice_transaction_id IS NOT NULL
				GROUP BY perp_invoice.invoice_id, perp_client_receipt.invoice_id';
		
			$result = $GLOBALS['egw']->db->query($sql, __LINE__, __FILE__, $query['start'], $query['num_rows']);
			$list = array();
			$invoice = null;

			foreach($result as $row) {
				$list[] = $row;
			}
			foreach($list as $key => &$row) {
				if($row['invoice_id']) {
					$invoice =& new ReceivableInvoice($row['invoice_id']);
					$row['amount_owing'] = $row['original_amount'] - $row['amount_paid'] - $invoice->get_discount_taken();
					$row['discount_available'] = $invoice->get_discount_available();
					$row['formatted_discount_available'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $row['discount_available']);
				} else {
					$row['amount_owing'] = $row['original_amount'] - $row['amount_paid'];
				}
				$row['formatted_amount_owing'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $row['amount_owing']);
				$row['formatted_original_amount'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $row['original_amount']);

				if($row['amount_owing'] == 0) {
					unset($list[$key]);
				}
			}
	
			$invoice = null;
			return $list;
		}

		public function allocate_receipt($receipt_id, $trans_id, $line_no, $invoice_id, $amount, $date, $pre_payment, $payment_number) {
			if(!$invoice_id) {
				$invoice_id = 0;
			}

			$credit_card = '~^((4\d{3})|(5[1-5]\d{2}))(-?|\040?)(\d{4}(-?|\040?)){3}|^(3[4,7]\d{2})(-?|\040?)\d{6}(-?|\040?)\d{5}~';
			if(preg_match($credit_card, $payment_number)) {
				// Don't store the whole credit card number, max allowed is first 6 and last 4 digits
				$payment_number = substr_replace($payment_number, str_repeat('*', strlen(16 - ($payment_number - 10))), 6, -4);
			}

			$date = (is_null($date) ? null : $GLOBALS['egw']->db->to_timestamp($date));

			return $GLOBALS['egw']->db->insert('perp_client_receipt', 
				array(
					'receipt_id'	=>	$receipt_id,
					'trans_id'	=>	$trans_id,
					'line_no'	=>	$line_no,
					'invoice_id'	=>	$invoice_id,
					'amount'	=>	$amount,
					'allocation_date'	=>	$date,
					'allocated_from'	=>	$pre_payment,
					'payment_number'	=>	$payment_number
				),
				$where,
				__LINE__, __FILE__, 'perp_ar'
			);
		}

		/**
		*	Reverse a receipt
		*/
		public function reverse(Array $receipt, $reason) {

			$GLOBALS['egw']->db->transaction_begin();

			// Generate reversing receipt
			$reverse = $receipt;
			unset($reverse['receipt_id']);
			$reverse['payment_number'] = lang('Reverse %1', $reverse['payment_method_name'] . ' ' . $reverse['payment_number']);
			$reverse['receipt_total'] = -$reverse['total'];
			$reverse['receipt_narrative'] = $reverse['payment_number'];
			$reverse['allocation_date'] = $receipt['date'];
			foreach($reverse as $key => &$row) {
				if(is_numeric($key) && is_array($row)) {
					if($row['invoice_id']) {
						unset($row['receipt_id']);
					}
					$row['receipt_amount'] = -$row['amount'];
				}
			}
			$reverse_id = ExecMethod('perp_ar.bo_perp_receipt.post_receipt', $reverse);
			if(!is_numeric($reverse_id) || !$reverse_id) {
				$GLOBALS['egw']->db->transaction_abort();
			}
			
			// Record the reversal
			$result = $GLOBALS['egw']->db->insert(
				'perp_receipt_reversal',
				array(
					'original_id'	=>	$receipt['receipt_id'],
					'reversal_id'	=>	$reverse_id,
					'account_id'	=>	$GLOBALS['egw_info']['user']['account_id'],
					'timestamp'	=>	time(),
					'reason'	=>	$reason
				), false,
				__LINE__, __FILE__, 'perp_ar'
			);
			if($result === false) {
				$GLOBALS['egw']->db->transaction_abort();
			}

			$GLOBALS['egw']->db->transaction_commit();

			return $reverse_id;
		}

		/**
		*	Read a reversal record
		*
		*	@param receipt_id Either the reversed receipt, or the reversal.
		*	@return array of reversal information
		*/
		public static function get_reversal($receipt_id) {
			
			$where = array(
				'(original_id = ' . (int)$receipt_id . ' OR reversal_id = ' . (int)$receipt_id . ')'
			);

			$result = $GLOBALS['egw']->db->select(
				'perp_receipt_reversal',
				array(
					'original_id',
					'reversal_id',
					'account_id',
					'timestamp',
					'reason'
				),
				$where,
				__LINE__, __FILE__, false,
				'', 'perp_ar'
			)->fetchRow();
			if($result) {
				$result['timestamp'] = $GLOBALS['egw']->db->from_timestamp($result['timestamp']);
			}
			return $result;
		}
	}
?>
