<?php

	class ui_perp_ar {

		public $public_functions = array( 
			'index'		=>	true,
			'link_view'	=>	true,
			'link_add'	=>	true,
			'register_apps'	=>	true,
		);

		private $debug = false;
		private $bo;
		private $template;

		public function ui_perp_ar() {
			$this->template = CreateObject('etemplate.etemplate');
		}

		public function index($content = array()) {

			// ACLs
			$client_read = $GLOBALS['egw']->acl->check('client', EGW_ACL_READ, 'perp_ar');
			$client_branch_read = $GLOBALS['egw']->acl->check('client_branch', EGW_ACL_READ, 'perp_ar');
			$new_sales_order = $GLOBALS['egw']->acl->check('order', EGW_ACL_READ, 'perp_orders');
			$shipment_read = $GLOBALS['egw']->acl->check('shipment', EGW_ACL_READ, 'perp_ar');
			$invoice_read = $GLOBALS['egw']->acl->check('invoice', EGW_ACL_READ, 'perp_ar');
			$receipt_read = $GLOBALS['egw']->acl->check('receipt', EGW_ACL_READ, 'perp_ar');

			// Redirect
			if(isset($content['client_list']) && $client_read) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client.client_list'));
			} elseif(isset($content['client_branch_list']) && $client_branch_read) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client_branch.client_branch_list'));
			} elseif(isset($content['shipment_list']) && $shipment_read) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_outgoing_shipment.shipment_list'));
			} elseif(isset($content['invoice_list']) && $invoice_read) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_receivable_invoice.invoice_list'));
			} elseif(isset($content['receipt_list']) && $receipt_read) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_receipt.receipt_list'));
			} elseif(isset($content['new_sales_order']) && $new_sales_order) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_sales_order.new_sales_order'));
			}
	
			// Hide stuff with no perms
			$readonly['client_list'] = !$client_read;
			$readonly['client_branch_list'] = !$client_branch_read;
			$readonly['new_sales_order'] = !$new_sales_order;
			$readonly['shipment_list'] = !$shipment_read;
			$readonly['invoice_list'] = !$invoice_read;
			$readonly['receipt_list'] = !$receipt_read;
			
			// Display
			$this->template->read('perp_ar.index');
			$this->template->exec('perp_ar.ui_perp_ar.index', $data, $select_box_options, $readonly, $preserve);
		}

		public function link_view() {
			$link = $_GET['link_id'];
			list($location, $id) = explode('-', $link);
			if($id) {
				switch($location) {
					case 'CLIENT':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_ar.ui_perp_client.client_edit', 
								'client_id' 	=>	$id
							)
						);
						break;
					case 'CLIENT_BRANCH':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_ar.ui_perp_client_branch.client_branch_edit', 
								'client_branch_id' 	=>	$id
							)
						);
						break;
					case 'SHIPMENT':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_ar.ui_perp_outgoing_shipment.edit', 
								'shipment_id' 	=>	$id
							)
						);
						break;
					case 'INVOICE';
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_ar.ui_perp_receivable_invoice.edit', 
								'invoice_id' 	=>	$id
							)
						);
						break;
					case 'RECEIPT':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_ar.ui_perp_receipt.receipt_view', 
								'receipt_id' 	=>	$id
							)
						);
						break;
					default:
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_ar.ui_perp_client_branch.client_branch_edit', 
								'client_branch_id' 	=>	$id
							)
						);
						break;
						
				}
			} elseif($client_branch_id) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client_branch.client_branch_edit', 'client_branch_id' => $client_branch_id));
			} elseif($client_id) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client.client_edit', 'client_id' => $client_id));
			} else {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client.client_edit', 'client_id' => $location));
			}
		}

		/**
		*	Add a new entry in Accounts Receivable
		*
		*
		*/
		public function link_add($content = array()) {
			if(!isset($content['link_add'])) {
				$content['link_add'] = $GLOBALS['egw_info']['user']['preferences']['perp_ar']['link_add'];
			}
			if($content['link_add']) {
				switch ($content['link_add']) {
					case 'CLIENT':
						$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client.client_new'));
						break;
					case 'SHIPMENT':
						$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_outgoing_shipment.new_shipment'));
						break;
					case 'INVOICE':
						$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_receivable_invoice.new_invoice'));
						break;
					case 'RECEIPT':
						$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_receipt.receipt_new'));
						break;

				}
			} else {
				// Display
				$this->template->read('perp_ar.link_add');
				$this->template->exec('perp_ar.ui_perp_ar.link_add', $data, $select_box_options, $readonly, $preserve, 2);
			}
		}

		/**
		*	Register any hooks that perp_ar provides for other applications, such as projectmanager,
		*	to hook into it.  This is needed because the regular hook registration won't register
		*	hooks for another application
		*/
		public function register_apps() {
			$file = EGW_INCLUDE_ROOT . '/perp_ar/setup/setup.inc.php';
//			$GLOBALS['egw']->hooks->register_all_hooks();
			if(file_exists($file)) {
				include_once($file);
				foreach($setup_info as $appname => $location) {
					if(is_array($location['hooks'])) {
						$hooks = $GLOBALS['egw']->hooks->found_hooks[$appname];
						if(!is_array($hooks)) {
							$hooks = array();
						}
						$hooks = array_merge($hooks, $location['hooks']);
						$GLOBALS['egw']->hooks->register_hooks($appname, $hooks);
					}
				}
				if (method_exists($GLOBALS['egw'],'invalidate_session_cache')) { // egw object in setup is limited
					$GLOBALS['egw']->invalidate_session_cache();    // in case with cache the egw_info array in the session
				}
			}
			$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.hook_perp_ar.config'));
		}
	}
?>
