<?php

	class ui_perp_client_account {
		
		private $bo;
		private $template;
		private $debug = false;
		
		public $public_functions = array(
			'new_client_account'	=>	True,
			'edit_client_account'	=>	True,
		);

		public function ui_perp_client_account() {
			$this->bo = CreateObject('perp_ar.bo_perp_client_account');
			$this->template = CreateObject('etemplate.etemplate');
		}

		public function new_client_account($content = array()) {
			if($this->debug) {
				echo 'perp_ar.ui_perp_client_account.new_client_account Incoming data';
				_debug_array($content);
			}
			
			// Stub

			return $this->edit_client_account($content);
		}

		public function edit_client_account($content = array()) {
			if($this->debug) {
				echo 'perp_ar.ui_perp_client_account.edit_client_account Incoming data';
				_debug_array($content);
			}

			$client_id = $content['client_id'] ? $content['client_id'] : (isset($_GET['client_id']) ? $_GET['client_id'] : False);
			$client_account_id = $content['client_account_id'] ? $content['client_account_id'] : (isset($_GET['client_account_id']) ? $_GET['client_account_id'] : False);

			$data = array();
			
			// Deal with incoming
			if(isset($content['save']) && $GLOBALS['egw']->acl->check('client_account', EGW_ACL_EDIT, 'perp_ar')) {
				$result = $this->bo->set_client_account($client_account_id, $content);
				if(is_numeric($result)) {
					$client_account_id = $result;
					$msg[] = array('saved', 'success');
				} elseif ($result) {
					$msg[] = array($result, 'error');
				}
			} elseif ($content['disable_account']) {
				$this->bo->disable_account($client_account_id);
			}
			if(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client.client_edit', 'client_id' => $client_id));
			}

			// Read data
			if ($client_id !== False) {
				$client = ExecMethod('perp_ar.bo_perp_client.get_client', $client_id);
				$data['client_name'] = $client['client_name'];
				$data['client_num'] = $client['client_num'];
			} 
			if ($client_account_id) {
				$data += $this->bo->get_client_account($client_account_id);

				/* 
				*	Allow restricting price lists very specificly
				*/
				$info = config::read('perp_ar');
				if($info['individual_client_discounts']) {
					$data['price_lists'] = $this->bo->get_price_lists($client_account_id);
				}
				$sales_categories = array();
				if(is_array($data['price_lists'])) {
					foreach($data['price_lists'] as $price_list_id) {
						$price_list = ExecMethod('perp_orders.bo_perp_price_list.get_price_list', $price_list_id);
						if(isset($price_list['sales_category_id'])) {
							$sales_categories[] = $price_list['sales_category_id'];
						}
					}
				}
				if($info['individual_client_discounts']){
					if(count($sales_categories) > 0) {
						$data['discounts'] = $this->bo->get_discounts($client_account_id, $sales_categories);
					}
					if(count($data['discounts']) > 0 && count($data['price_lists']) > 0) {
						array_unshift($data['discounts'], false);
						$preserve['discounts'] = $data['discounts'];
					} else {
						unset($data['discounts']);
					}
				}

			}

			// Select Boxes
			$select_box_options['payment_terms'] = ExecMethod('perp_api.bo_perp_api.get_payment_terms');
			$select_box_options['hold_reason'] = ExecMethod('perp_ar.bo_perp_ar.get_hold_reasons');

			$select_box_options['price_lists'] = ExecMethod2('perp_orders.bo_perp_price_list.get_price_list_list',
				array(
					'sales_area_id' => $client['sales_area'],
					'sales_type_id' => $client['sales_type'],
					'status'        => 'current'
				)
			);

			// Readonlys
			if(!$GLOBALS['egw']->acl->check('client_account', EGW_ACL_EDIT, 'perp_ar')) {
				$readonly = array(
					'client_account_name'	=>	True,
					'payment_terms'		=>	True,
					'credit_limit'		=>	True,
					'disabled'		=>	true,
					'price_lists'		=>	True,
					'perp_ar.client_edit_account.discount'	=>	True,
					'save'			=>	True,
				);
			}
			$readonly['disabled'] = $readonly['disabled'] || $data['disabled'];

			$preserve['client_id'] = $client_id ? $client_id : $data['client_id'];
			$preserve['client_account_id'] = $client_account_id;

			if($msg) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $msg);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = ($client_account_id) ? lang('Edit Client Account') : lang('New Client Account');
			
			$this->template->read('perp_ar.client_account_edit');
			$this->template->exec('perp_ar.ui_perp_client_account.edit_client_account', $data, $select_box_options, $readonly, $preserve, ($client_account_id ? null : 2)); 
		}
	}
?>
