<?php

	class ui_perp_client_branch {
		
		private $bo;
		private $template;
		private $debug = false;
		
		public $public_functions = array(
			'client_branch_list'	=>	True,
			'client_branch_edit'	=>	True,
			'client_branch_new'	=>	True,
			'client_branch_delete'	=>	True,
		);

		public function ui_perp_client_branch() {
			$this->bo = CreateObject('perp_ar.bo_perp_client_branch');
			$this->template = CreateObject('etemplate.etemplate');
		}

		public function client_branch_list($content = array()) {
			if($this->debug) {
				echo 'perp_ar.ui_perp_client.client_list incoming data:';
				_debug_array($content);
			}

			// Deal with incoming
			if(isset($content['cancel']) || !$GLOBALS['egw']->acl->check('client_branch', EGW_ACL_READ, 'perp_ar')) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_ar.index'));
			}
			if(isset($content['new_client_branch']) && $GLOBALS['egw']->acl->check('client_branch', EGW_ACL_ADD, 'perp_ar')) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client_branch.client_branch_new'));
			} elseif (isset($content['nm']['rows']['edit']) && $GLOBALS['egw']->acl->check('client_branch', EGW_ACL_EDIT, 'perp_ar')) {
				$id = key($content['nm']['rows']['edit']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client_branch.client_branch_edit', 'client_branch_id'=>$id));
			} elseif (isset($content['nm']['rows']['delete']) && $GLOBALS['egw']->acl->check('client_branch', EGW_ACL_DELETE, 'perp_ar')) {
				$id = key($content['nm']['rows']['delete']);
				$this->bo->delete_client_branch($id);
			}

			// Set up outgoing
			$data['nm'] = $GLOBALS['egw']->session->appsession('client_branch.nextmatch');
			if(!$data['nm']) {
				$data['nm'] = array(
					'no_cat'        =>      True,
					'no_filter'     =>      True,
				//	'filter_label'  =>      'Status',
					'filter_no_lang'        =>      True,
				//	'no_filter2'    =>      True,
					'filter2_label' =>      'Sales Area',
					'filter2_no_lang'       =>      True,
					'lettersearch'	=>	true,
					'get_rows'      =>      'perp_ar.ui_perp_client_branch.get_client_branch_list',
					'template'      =>      'perp_ar.client_branch_list.row',
				);
			}

			$select_box_options['sales_type'] = ExecMethod('perp_orders.bo_perp_orders.get_sales_types');
			$select_box_options['filter2'] = array('' => lang('all')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_areas');

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Client Branch List');
			$this->template->read('perp_ar.client_branch_list');
			$this->template->exec('perp_ar.ui_perp_client_branch.client_branch_list', $data, $select_box_options, $readonly, $preserve); 
		}

		public function client_branch_new($content = array()) {
			$client_id = $content['client_id'] ? $content['client_id'] : $_GET['client_id'];

			$content['client_id'] = $client_id;
			return $this->client_branch_edit($content);
		}

		public function client_branch_edit($content = array()) {
			if($this->debug) {
				echo 'perp_ar.ui_perp_client_branch.client_branch_edit Incoming data';
				_debug_array($content);
			}

			$client_branch_id = $content['client_branch_id'] ? $content['client_branch_id'] : (isset($_GET['client_branch_id']) ? $_GET['client_branch_id'] : False);
			$client_id = $content['client_id'] ? $content['client_id'] : (isset($_GET['client_id']) ? $_GET['client_id'] : False);

			$data = array();
			
			// Deal with incoming
			if((isset($content['save']) || isset($content['save_popup'])) && $GLOBALS['egw']->acl->check('client_branch', EGW_ACL_EDIT, 'perp_ar')) {
				$result = $this->bo->set_client_branch($client_branch_id, $content);
				if(is_numeric($result)) {
					$client_branch_id = $result;
					$msg[] = array(lang('saved'), 'success');
				} elseif ($result) {
					$msg[] = array($result, 'error');
				}
			} elseif(isset($content['orders']['rows'])) {
				if(isset($content['orders']['rows']['view'])) {
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'=>'perp_orders.ui_perp_sales_order.edit_sales_order',
						'sales_order_id'=>key($content['orders']['rows']['view'])
					));
				} elseif (isset($content['orders']['rows']['edit'])) {
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'=>'perp_orders.ui_perp_sales_order.edit',
						'order_id'=>key($content['orders']['rows']['edit'])
					));
				} elseif (isset($content['orders']['rows']['invoice'])) {
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'=>'perp_ar.ui_perp_receivable_invoice.new_invoice',
						'order_id'=>key($content['orders']['rows']['invoice'])
					));
				} elseif (isset($content['orders']['rows']['ship'])) {
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'=>'perp_ar.ui_perp_client_shipment.client_shipment_list',
						'client_branch_id'	=>	$this->client_branch_id,
						'client_id'		=>	$this->client_id,
						'order_id'=>key($content['orders']['rows']['ship'])
					));
				} elseif (isset($content['orders']['rows']['cancel'])) {
					$result = ExecMethod('perp_orders.bo_perp_sales_order.delete_sales_order', key($content['orders']['rows']['invoice']));
					if($result !== True) {
						$msg[] = array($result, 'error');
					}
				} elseif (isset($content['orders']['rows']['new'])) {
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'	=>	'perp_orders.ui_perp_sales_order.new_order',
						'client_id'	=>	$client_id,
						'client_branch_id'	=>	$client_branch_id
					));
				}

			// Shipments
			} elseif (isset($content['shipments']['rows'])) {
				$tab_data = $content['shipments'];
				foreach($tab_data['rows'] as $action => $id) {
					if(!is_numeric($action)) {
						if(is_array($id)) {
							$id = key($id);
						} else {
							$id = $client_id;
						}
						$_POST['exec']['client_branch_id'] = $client_branch_id;
						ExecMethod2('perp_ar.ui_perp_client.handle_action', 'shipments.' .  $action, $id);
					}
				}
			}

			if(isset($content['cancel']) || isset($content['cancel_popup'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client_branch.client_branch_list'));
			}

			// Read data
			if($client_branch_id !== False) {
				$data += $this->bo->get_client_branch($client_branch_id);
				$client_id = $data['client_id'];
				$data['p_address'] = array(
					'address'	=>	$data['postal_address']
				);
				$data['d_address'] = array(
					'address'	=>	$data['delivery_address']
				);
			// New branch
			} elseif ($client_id !== False) {
				$client = ExecMethod('perp_ar.bo_perp_client.get_client', $client_id);
				$data['client_name'] = $client['client_name'];
				$data['client_num'] = $client['client_num'];
				$data['sales_type'] = $client['sales_type'];
			}
			$tabs = 'details|address|links|orders|shipments';
			$this->api = CreateObject('perp_api.ui_perp_api');

			// Orders - Needs order entry module
			$data['orders'] = array(
				'client_id'     =>      $client_id,
				'client_branch_id'	=>	$client_branch_id,
				'hide_client'   =>      True,
				'template'      =>      'perp_orders.sales_order_list.row', 
				'get_rows'      =>      'perp_ar.ui_perp_client.get_order_list',
				'no_cat'	=>	true,
				'no_filter2'	=>	true,
			);
			$readonly['orders']['new_order'] = !$GLOBALS['egw']->acl->check('sales_order', EGW_ACL_ADD, 'perp_orders');

			// Shipments
			$data['shipments'] = array(
				'client_id'     =>      $client_id,
				'client_branch_id'	=>	$client_branch_id,
				'template'      =>      'perp_ar.outgoing_shipment_list.row', 
				'get_rows'      =>      'perp_ar.bo_perp_outgoing_shipment.get_shipment_list',
			);
			$data['ship_to_address'] = $data['delivery_address'];
			$readonly['shipments'] = $ros;

			// Links
			$data['links']['to_app'] = 'perp_ar';
			$data['links']['to_id'] = 'CLIENT_BRANCH-' . $client_branch_id;

			// Select Boxes
			$addresses = egw_link::get_links('perp_ar', $data['links']['to_id'], 'addressbook');
			foreach($addresses as $id => $address_id) {
				$address[$address_id] = egw_link::title('addressbook', $address_id);
			}
			$select_box_options['postal_address'] = $address;
			$select_box_options['delivery_address'] = $address;
			$select_box_options['ship_to_address'] = $address;
			$options = ExecMethod('perp_ar.ui_perp_outgoing_shipment.get_selectbox_options', new Shipment());
			$select_box_options['ship_from_address'] = $options['ship_from_address'];

			$select_box_options['filter'] = ExecMethod('perp_orders.bo_perp_sales_order.get_status_list');
			$select_box_options['tax_group'] = ExecMethod('perp_api.bo_perp_api.get_tax_groups');
			$select_box_options['default_location'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$select_box_options['default_shipper'] = ExecMethod('perp_api.bo_perp_api.get_shippers');

			// The following depend on other modules
			$select_box_options['sales_type'] = ExecMethod('perp_orders.bo_perp_orders.get_sales_types');
	
			// Readonlys
			if(!$client_branch_id) {
				foreach(explode('|', $tabs) as $tab) {
					$readonly[$tabs][$tab] = True;
				}
				unset($readonly[$tabs]['details']);
				$readonly['save'] = True;
				$readonly['cancel'] = True;
			} else {
				$readonly['save_popup'] = True;
				$readonly['cancel_popup'] = True;
			}

			if(!$GLOBALS['egw']->acl->check('client_branch', EGW_ACL_EDIT, 'perp_ar')) {
				$readonly['save'] = True;
				$readonly['save_popup'] = True;
			}

			// Check if we use client user accounts
			if(!$this->bo->config->config_data['client_user_accounts']) {
				$readonly['user_account'] = True;
			}
			if(!$data['user_account']) {
				$data['client_user_accounts'] = (boolean)$this->bo->config->config_data['client_user_accounts'];
			}

			$preserve = $data;
			$preserve['client_id'] = $client_id ? $client_id : $data['client_id'];
			$preserve['client_branch_id'] = $client_branch_id;

			if($msg) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $msg);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = $client_branch_id ? lang('Edit Client Branch') : lang('New Client Branch');
			$this->template->read('perp_ar.client_branch_edit');
			$this->template->exec('perp_ar.ui_perp_client_branch.client_branch_edit', $data, $select_box_options, $readonly, $preserve, ($client_branch_id ? 0 : 2)); 
		}

		public function client_branch_delete($content = array()) {
			$branch_id = $content['branch_id'] ? $content['branch_id'] : $_GET['branch_id'];
			$this->bo->delete_client_branch($branch_id);
			$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_ar.ui_perp_client.client_branch_list'));
		}

		/**
		*       Get client branch list, and preserve options in the session
		*/
		public function get_client_branch_list(&$query, &$rows = array(), &$readonlys = array()) {
			$GLOBALS['egw']->session->appsession('client_branch.nextmatch', false, $query);
			return $this->bo->get_client_branch_list($query, $rows, $readonlys);
		}

	}
?>
