<?php
/* This is one part that, due to API constraints, still needs its own hook file */
	// We NEED a preference called homepage_display to get the API to display our app on the homepage
	$settings['homepage_display'] = array(
		'type'	=>	'check',
		'label'	=>	'Show Accounts Receivable information on home page',
		'name'	=>	'homepage_display',
	);

	if($GLOBALS['egw']->acl->check('shipment', EGW_ACL_READ, 'perp_ar')) {
		$values = array(
			'0'	=>	'No',
			'1'	=>	'Today',
			'7'	=>	'This week',
		);

		$settings['homepage_display_outgoing_shipments'] = array(
			'type'	=>	'select',
			'label'	=>	'Show outgoing shipments on home page',
			'name'	=>	'homepage_display_outgoing_shipments',
			'values'	=>	$values,
			'help'	=>	'',
		);
	}

	if($GLOBALS['egw']->acl->check('invoice', EGW_ACL_READ, 'perp_ar')) {
		$settings['homepage_display_upcoming_payments'] = array(
			'type'	=>	'select',
			'label'	=>	'Show invoices coming due on home page',
			'name'	=>	'homepage_display_upcoming_payments',
			'values'=>	array(
				'0'	=>	'No',
				'1'	=>	'Today',
				'7'	=>	'This week',
			),
			'help'	=>	'',
		);
	}		

	if($GLOBALS['egw']->acl->check('invoice', EGW_ACL_CUSTOM_1, 'perp_ar')) {
		$settings['post_action'] = array(
			'type'	=>	'select',
			'label'	=>	'When I post an invoice, I also want to',
			'name'	=>	'post_action',
			'values'=>	array(
				'0'			=>	'Do nothing else',
				'email'			=>	'Email the invoice to the client',
				'invoice_report'	=>	'Create an invoice report'
			),
			'help'	=>	'An action to automatically take after the invoice is chosen.  You can override this for each invoice if you need.',
		);
	}

	if($GLOBALS['egw']->acl->check('receipt', EGW_ACL_ADD, 'perp_ar')) {
		$settings['autofill_receipt'] = array(
			'type'	=>	'select',
			'label'	=>	'Double click fills in receipt fields',
			'name'	=>	'autofill_receipt',
			'values'=>	array(
				'0'	=>	'No',
				'1'	=>	'Yes',
			),
			'help'	=>	'Should the correct value be filled in automatically, or when you double click on Discount Taken or Payment Amount fields.',
		);
	}

	$settings['link_add'] = array(
		'type'	=>	'select',
		'label'	=>	'When I add a new Accounts Receivable link, I want a new',
		'name'	=>	'link_add',
		'values'	=>	array(
			'0'	=>	'Ask me each time',
			'CLIENT'	=>	'Client',
			'SHIPMENT'	=>	'Outgoing Shipment',
			'INVOICE'	=>	'Invoice',
			'RECEIPT'	=>	'Receipt'
		),
		'help'	=>	'In the top right corner there should be a little box that says "Add...".  What would you like to add when you choose "Accounts Receivable" from the list?'
	);

	$GLOBALS['settings'] = $settings;
	unset($temp);
	unset($so_admins);

	return $settings;
?>
