<?php
    include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	
	/**
	*	International Commercial Invoice
	*/
	
	class int_commercial_invoice extends perp_report {
		
		private $permit_countries = array("US");
		
		
		public function int_commercial_invoice(array $parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_ar';
			parent::perp_report($parameters);
			
			$this->template = 'int_commercial_invoice.odt';
			
			$shipment = new OutgoingShipment($parameters['shipment_id']);
			$this->parameters = $parameters;
			
			//Check to see if we need to display Export Permit Field
			$shipment_lines = $shipment->get_lines();
			foreach($shipment_lines as $shipment_line) {
				
				$shippable_item = $shipment_line->get_shippable_item();
				if(is_null($shippable_item)) {
					continue;
				}
				try {
					$stock_id = $shippable_item->get_stock_id();
				} catch (Exception $e) {
					continue;
				}
				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
				$packing = ExecMethod('perp_inventory.bo_perp_stock.get_shipping_packages', $stock_id);
			
				$line['country_of_origin']	=	$stock['country_of_origin'];
				if (in_array($line['country_of_origin'], $this->permit_countries))
				{
				    $this->parameters['is_export_permit'] = 1;
				}				
			}
			//Check to see if we need to display Export permit field
			
			
			
			//Check to see if we need to display the Conveyance identifaction field
			$this->parameters['vessel'] = $shipment->get_vessel();
			
			
			//***Widget Parameters***//
			
			//Pass todays date for default date of export
			$this->parameters['export_date'] = time();
			
			$this->parameters['options-mode'] = array(
				lang('Highway')	=>	lang('Highway'),
				lang('Rail')		=>	lang('Rail'),
				lang('Marine')	=>	lang('Marine'),
				lang('Air')	=>	lang('Air'),
				lang('Other')	=>	lang('Other')
			);
			$this->parameters['options-status'] = array(
				lang('Exporter')	=>	lang('Exporter'),
				lang('Other')		=>	lang('Other')
			);
			$this->parameters['options-reason'] = array(
				lang(' ')	=>	lang('Sold'),
				lang('Lease')	=>	lang('Lease'),
				lang('Rental')		=>	lang('Rental')
			);
			
			// Customs doesn't like it if you sell something for $0, so we'll hide them
			// They also don't like it if you 'forget' to mention something though...
			$this->parameters['exclude_zero_cost_items'] = true;
		}
		
		public function get_data($query = array()) {
			if(!$query['shipment_id']) {
				return false;
			}
			
			$shipment = new OutgoingShipment($query['shipment_id']);
			$carriers = ExecMethod('perp_api.bo_perp_api.get_shippers');
			$data = array(
				'our_reference_number'	=>	$shipment->get_our_reference_number(),
				'their_reference_number'	=>	$shipment->get_their_reference_number(),
				'carrier_name'		=>	$carriers[$shipment->get_shipper_id()],
				'vessel'		=>	$shipment->get_vessel(),		
				'item_count'		=>	0,
				'item_total_value'	=>	0,
				'item_total_weight'	=>	0,
				'currency'		=>	$shipment->get_invoice_currency(),
				'exporter_no'		=>	$query['exporter_no'],
				'mode_of_transport'	=>	$query['mode_of_transport'],
				'containerized'		=>	$query['containerized'],
				'status'		=>	$query['status']				
			);

			$data['shipper'][] = ExecMethod('addressbook.addressbook_bo.read', $shipment->get_ship_from_address());
			$ship_to = ExecMethod('addressbook.addressbook_bo.read', $shipment->get_ship_to_address());
			$bill_to = ExecMethod('addressbook.addressbook_bo.read', $client['address']);
			
			$data['final_destination']	=	$ship_to['adr_one_region'] . ', ' . $ship_to['adr_one_countryname'];
			$data['export_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $query['export_date']);
			$data['export_permit']	=	$query['export_permit'];
			$data['pl_of_exit']	=	$query['pl_of_exit'];
			$data['con_ident_num']	=	$query['con_ident_num'];
			$data['reason'] = $query['reason'];
			$data['container_num'] = $query['container_num'];
			$data['mode'] = $query['mode'];
			$data['freight_charges'] = $query['freight_charges'];
			
			$GLOBALS['egw']->db->select(
				'perp_shipment_detail',
				array('detail_name'),
				array(
					'shipment_id'	=>	$shipment->get_shipment_id(),
					'detail_class'	=>	'ShipmentPackage'
				),
				__LINE__, __FILE__, 0,
				'GROUP BY detail_name', -1,
				'perp_ar'
			);
			$data['package_count'] =  $GLOBALS['egw']->db->num_rows();
			$list = array();
			while($row = $GLOBALS['egw']->db->row(True)) {
				$list[] = $row;
			}
			
			$config = CreateObject('phpgwapi.config', 'perp_ar');
			$config->read_repository();
			$data['business_number'] =  $config->config_data['business_number'];
			$data['user'][] = ExecMethod('addressbook.addressbook_bo.read', $GLOBALS['egw_info']['user']['person_id']);
			$data['broker'][] = ExecMethod('addressbook.addressbook_bo.read', $query['broker']);
			
			
			//Lines On This Order*****
			$lines = array();
			$unit_of_measure = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures');

			$shipment_lines = $shipment->get_lines();
			foreach($shipment_lines as $shipment_line) {
				$line = $shipment_line->toArray();

				$shippable_item = $shipment_line->get_shippable_item();
				if(is_null($shippable_item)) {
					continue;
				}
				try {
					$stock_id = $shippable_item->get_stock_id();
				} catch (Exception $e) {
					continue;
				}
				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
				$packing = ExecMethod('perp_inventory.bo_perp_stock.get_shipping_packages', $stock_id);

				
				$line['description']		=	$shipment_line->get_description();
				$line['serial_number']		=	'';
				$line['country_of_origin']	=	$stock['country_of_origin'];
				$line['hs_code']		=	$stock['usa_inbound_code'];
				$line['unit_of_measure']	=	$unit_of_measure[$stock['unit_of_measure']];

				$line['value']			=	$shipment_line->get_unit_price() * $shipment_line->get_quantity_shipped();
				if($line['value'] == 0 && $query['exclude_zero_cost_items']) {
					continue;
				}
				$data['item_total_value']	+=	$line['value'];
				$line['value'] 			= 	ExecMethod2(
										'perp_api.bo_perp_api.get_formatted_price',
										$shipment->get_invoice_currency(),
										$line['value']
									);
				$line['quantity_shipped'] =	$shipment_line->get_quantity_shipped();
				$data['item_count']		+=	$shipment_line->get_quantity_shipped();
				

				foreach($packing as $package) {
					$data['item_total_weight']	+=	$package['mass'] * $shipment_line->get_quantity_shipped();
				}
				$lines[] = $line;
			}
			$data['item_total_value']		=	ExecMethod2('perp_api.bo_perp_api.get_formatted_price', $shipment->get_invoice_currency(), $data['item_total_value']);
			$data['items'] = $lines;
			//Lines On This Order*****
			
			
			if(is_array($bill_to)) {
				$data['bill_to'][] = $bill_to;

				// If ship_to not set, use bill to
				if(!is_array($ship_to)) {
					$ship_to = $bill_to;
				}
			}
			if(is_array($ship_to)) {
				$data['consignee'][] = $ship_to;
				// If bill_to not set, use ship to
				if(!is_array($bill_to)) {
					$data['bill_to'][] = $ship_to;
				}
			}
			
			return $data;
		}
		
	}
	
?>
