/**
*	Javascript functions for editing receivable invoices.  
*	Be careful not to double-define anything, it will cause all kinds of problems.  
*	Check perp_api::js::invoice::edit.js
*/

function receivable_invoice_edit_setup() {
	
	var client = document.getElementById('exec[client_id][value]');
	if(client) {
		client.addEventListener('change', got_client_id, true);
	}
	got_client_id();
}

/** 
*	Show or hide Client Branch & Client Account fields depending
*	on if Client is set.
*/
function got_client_id() {
	var client = document.getElementById('exec[client_id][value]');
	var client_branch = document.getElementById('exec[client_branch_id][search]');
	var client_account = document.getElementById('exec[client_account_id][search]');

	if(!client || !client_branch || !client_account) {
		return;
	}

	client_branch.style.visibility = (client.value) ? 'visible' : 'hidden';
	client_account.style.visibility = (client.value) ? 'visible' : 'hidden';
}

/**
*	Change the client account, and any information related to it
*/
function change_client_account() {

	var client_account = document.getElementById('exec[client_account_id][value]');
	if(client_account) {
		xajax_doXMLHTTP(ajax_perp_callback + ".change_client_account", client_account.value);
	}
}

/**
*	Change the client branch, and any information related to it
*/
function change_client_branch() {

	var client_branch = document.getElementById('exec[client_branch_id][value]');
	if(client_branch) {
		xajax_doXMLHTTP(ajax_perp_callback + ".change_client_branch", client_branch.value);
	}
}
