<!--
/** 
*	Javascript for creating / editing a receipt
*
*	Actually, you can't edit a receipt once posted...
*
*	@param auto_fill	boolean	Automatically enter the correct amount when you double-click the field
*/
-->

function receipt_new_setup(auto_fill) {

	var inputs = document.getElementsByTagName('input');
	for(i = 0; i < inputs.length; i++) {
		inputs[i].style.textAlign = 'right';
		if(inputs[i].id.indexOf('discount_taken') > 0) {
			if(inputs[i].addEventListener) {
				if(auto_fill) {
					inputs[i].addEventListener('dblclick', set_discount, true);
				}
				inputs[i].addEventListener('blur', update_total, false);
				inputs[i].addEventListener('change', update_total, false);
				inputs[i].addEventListener('keyup', update_total, false);
			} else {
				if(auto_fill) {
					inputs[i].ondblclick = set_discount;
				}
				inputs[i].onchange = update_total;
			}
		} else if (inputs[i].id.indexOf('receipt_amount') > 0) {
			if(inputs[i].addEventListener) {
				if(auto_fill) {
					inputs[i].addEventListener('dblclick', set_receipt_amount, true);
				}
				inputs[i].addEventListener('blur', update_total, false);
				inputs[i].addEventListener('change', update_total, false);
				inputs[i].addEventListener('keyup', update_total, false);
			} else {
				if (auto_fill) {
					inputs[i].ondblclick = set_receipt_amount;
				}
				inputs[i].change = update_total;
			}
		}
	}

	var pre_payment = document.getElementById('exec[pre_payment]');
	if(pre_payment) {
		if(pre_payment.addEventListener) {
			pre_payment.addEventListener('change', update_total, false);
		} else  {
			pre_payment.onchange = update_total;
		}
	}
}

/**
*	Fill in the discount taken column
*/
function set_discount(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}
	var base_id = target.id.replace(/\[discount_taken\]/gi, '');
	var discount_available = document.getElementById(base_id + '[discount_available]');
	if(discount_available) {
		target.value = discount_available.value;
	}
}

/** 
*	Fill in the receipt amount column
*/
function set_receipt_amount (e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if (target.nodeType == 3) { // defeat Safari bug
		target = target.parentNode;
	}
	var base_id = target.id.replace(/\[receipt_amount\]/gi, '');
	var amount_owing = document.getElementById(base_id + '[amount_owing]');
	var discount_taken = document.getElementById(base_id + '[discount_taken]');
	if(amount_owing) {
		var amount = parseFloat(amount_owing.value);

		if(discount_taken && discount_taken.value == parseFloat(discount_taken.value)) {
			amount -= parseFloat(discount_taken.value);
		}

		target.value = amount;
	}
	update_total();
}

/**
*	Update receipt total field
*/
function update_total() {
	var inputs = document.getElementsByTagName('input');
	var total = 0;
	for(i = 0; i < inputs.length; i++) {
		if(inputs[i].id.indexOf('receipt_amount') > 0 && inputs[i].value == parseFloat(inputs[i].value)) {
			total += parseFloat(inputs[i].value) * 100;
		}
	}

	var prepayment = document.getElementById('exec[pre_payment]');
	if(prepayment && prepayment.value == parseFloat(prepayment.value)) {
		total += parseFloat(prepayment.value) * 100;
	}

	var receipt_total = document.getElementById('exec[receipt_total]');
	if(receipt_total && total == parseFloat(total)) {
		receipt_total.value = (total / 100).toFixed(2);
	}
}
