<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.33 2005/12/19 04:27:19 ralfbecker Exp $ */


	$phpgw_baseline = array(
		'perp_client' => array(
			'fd' => array(
				'client_id' => array('type' => 'auto','precision' => '4','nullable' => False),
				'client_num' => array('type' => 'varchar','precision' => '10','nullable' => False),
				'client_name' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'address' => array('type' => 'int','precision' => '4'),
				'currency' => array('type' => 'char','precision' => '3','nullable' => False),
				'sales_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_since' => array('type' => 'date','nullable' => False),
				'hold_reason' => array('type' => 'int','precision' => '4'),
				'payment_terms' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'credit_limit' => array('type' => 'decimal','precision' => '20','scale' => '2'),
				'invoice_branch' => array('type' => 'int','precision' => '4','nullable' => False),
				'user_account' => array('type' => 'int','precision' => '4'),
				'status' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'sales_area' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_id'),
			'fk' => array('address' => 'perp_address.address_id','currency' => 'perp_currency.currency_id','sales_type' => 'perp_sales_type.sales_type_id','payment_terms' => 'perp_payment_term.payment_term_id','invoice_branch' => 'perp_client_branch.client_branch_id','user_account' => 'egw_accounts.account_id','sales_area' => 'perp_sales_area.sales_area_id'),
			'ix' => array('client_id','sales_type'),
			'uc' => array('client_id','client_num')
		),
		'perp_client_ledger' => array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'our_reference' => array('type' => 'varchar','precision' => '40','nullable' => False),
				'their_reference' => array('type' => 'varchar','precision' => '40'),
				'sales_type' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'due_date' => array('type' => 'date'),
				'settled' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'sales_order_id' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'reference' => array('type' => 'text')
			),
			'pk' => array('trans_id','line_no'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_no','line_no' => 'perp_general_ledger.line_no','client_id' => 'perp_client.client_id','sales_type' => 'perp_sales_type.sales_type_id','sales_order_id' => 'perp_sales_order.sales_order_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('trans_id','line_no','sales_type','client_account_id'),
			'uc' => array(array('trans_id','line_no'))
		),
		'perp_client_branch' => array(
			'fd' => array(
				'client_branch_id' => array('type' => 'auto','precision' => '4','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'branch_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'postal_address' => array('type' => 'int','precision' => '4'),
				'est_delivery_days' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'sales_group' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_rep' => array('type' => 'int','precision' => '4'),
				'service_rep' => array('type' => 'int','precision' => '4'),
				'default_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'default_shipper' => array('type' => 'int','precision' => '4'),
				'tax_group' => array('type' => 'int','precision' => '4','nullable' => False),
				'user_account' => array('type' => 'int','precision' => '4'),
				'delivery_address' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('client_branch_id'),
			'fk' => array('client_id' => 'perp_client.client_id','postal_address' => 'perp_address.address_id','sales_group' => 'perp_sales_group.sales_group_id','sales_rep' => 'erp_accounts.account_id','service_rep' => 'erp_accounts.account_id','default_location' => 'perp_location.location_id','default_shipper' => 'perp_shipper.shipper_id','tax_group' => 'perp_tax_group.tax_group_id','user_account' => 'erp_accounts.account_id','delivery_address' => 'perp_address.address_id'),
			'ix' => array('client_branch_id','client_id'),
			'uc' => array('client_branch_id')
		),
		'perp_hold_reason' => array(
			'fd' => array(
				'hold_reason_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'hold_reason_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'allow_invoices' => array('type' => 'bool')
			),
			'pk' => array('hold_reason_id'),
			'fk' => array(),
			'ix' => array('hold_reason_id'),
			'uc' => array('hold_reason_id','hold_reason_name')
		),
		'perp_client_account' => array(
			'fd' => array(
				'client_account_id' => array('type' => 'auto','nullable' => False),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_account_name' => array('type' => 'varchar','precision' => '30','nullable' => False),
				'payment_terms' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'credit_limit' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'hold_reason' => array('type' => 'int','precision' => '4','default' => '0'),
				'discount_percent' => array('type' => 'decimal','precision' => '4','scale' => '1','nullable' => False,'default' => '0')
			),
			'pk' => array('client_account_id'),
			'fk' => array('client_id' => 'perp_client.client_id','payment_terms' => 'perp_payment_term.payment_term_id'),
			'ix' => array('client_account_id','client_id'),
			'uc' => array('client_account_id')
		),
		'perp_client_shipment' => array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'auto','nullable' => False),
				'shipment_num' => array('type' => 'varchar','precision' => '20'),
				'shipper' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipper_ref' => array('type' => 'varchar','precision' => '20'),
				'est_ship_date' => array('type' => 'date','nullable' => False),
				'actual_ship_date' => array('type' => 'date'),
				'client_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to_address' => array('type' => 'int','precision' => '4'),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_by' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'shipped_by' => array('type' => 'int','precision' => '4'),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_shipment_id'),
			'fk' => array('shipper' => 'perp_shipper.shipper_id','client_id' => 'perp_client.client_id','created_by' => 'egw_accounts.account_id','ship_to_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','approved_by' => 'egw_accounts.account_id','shipped_by' => 'egw_accounts.account_id','client_branch_id' => 'perp_client_branch.client_branch_id'),
			'ix' => array('client_shipment_id'),
			'uc' => array('client_shipment_id','shipment_num')
		),
		'perp_client_shipment_detail' => array(
			'fd' => array(
				'client_shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'shipped_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array('client_shipment_id','sales_order_id','line_no'),
			'fk' => array('client_shipment_id' => 'perp_client_shipment.client_shipment_id','sales_order_id' => 'perp_sales_order.sales_order_id','line_no' => 'perp_sales_order_detail.line_no'),
			'ix' => array('client_shipment_id','sales_order_id','line_no'),
			'uc' => array()
		),
		'perp_client_account_price_list' => array(
			'fd' => array(
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_account_id','price_list_id'),
			'fk' => array('client_account_id' => 'perp_client_account.client_account_id','price_list_id' => 'perp_price_list.price_list_id'),
			'ix' => array('client_account_id'),
			'uc' => array(array('client_account_id','price_list_id'))
		),
		'perp_client_account_discount' => array(
			'fd' => array(
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_amount' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '1'),
				'narrative' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'account_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('client_account_id','sales_category_id'),
			'fk' => array('client_account_id' => 'perp_client_account.client_account_id','sales_category_id' => 'perp_sales_category.sales_category_id','account_id' => 'perp_account.account_id'),
			'ix' => array('client_account_id','sales_category_id'),
			'uc' => array()
		),
		'perp_client_receipt' => array(
			'fd' => array(
				'receipt_id' => array('type' => 'auto','nullable' => False),
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'invoice_id' => array('type' => 'int','precision' => '4'),
				'amount' => array('type' => 'varchar','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'allocation_date' => array('type' => 'date'),
				'allocated_from' => array('type' => 'int','precision' => '4'),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('receipt_id','trans_id','invoice_id','line_no'),
			'fk' => array('trans_id' => 'perp_client_ledger.trans_id','invoice_id' => 'perp_invoice.invoice_id','allocated_from' => 'perp_client_receipt.receipt_id','line_no' => 'perp_client_ledger.line_no'),
			'ix' => array('receipt_id','trans_id','line_no'),
			'uc' => array(array('trans_id','line_no','receipt_id','invoice_id'))
		)
	);
