<?php
	/**
	*	Logic layer for dealing with departments
	*	Departments are nested groupings of staff.
	*/

	require_once('class.so_perp_department.inc.php');


	class bo_perp_department {

		private static $so;

		public function __construct() {
			$this->so = new so_perp_department();
		}

		/**
		*	Get a list of departments.
		*
		*	@nextmatch
		*/
		public function get_department_list(&$query = array(), &$rows = array(), &$readonlys = array()) {
			if(!$GLOBALS['egw']->acl->check('department', EGW_ACL_READ, 'perp_human_resources')) {
				if($query['template']) {
					$rows = array();
					return 0;
				} else {
					return array();
				}
			}

			// Get all rows for selectbox
			if(!isset($query['num_rows']) && !isset($query['template'])) {
				$query['num_rows'] = -1;
			}

			if(!isset($query['order'])) {
				$query['order'] = 'department_id';
			}

			$list = $this->so->get_departments($query);

			if(!isset($query['template'])) {
				foreach($list as $department) {
					$rows[$department['department_id']] = $department['indented_name'];
				}
				return $rows;
			}

			// Slice instead of restricting the query because of the nesting
			if(isset($query['num_rows'])) {
				$rows = array_slice($list, $query['start'], $query['num_rows']);
			} else {
				$rows = $list;
			}

			foreach($rows as $row) {
				$readonlys['delete[' . $row['department_id'] .']' ] = true;
			}
			return $query['count'];
		}

		public function get_department($department_id) {
			if(!$GLOBALS['egw']->acl->check('department', EGW_ACL_READ, 'perp_human_resources')) {
				return array();
			} else {
				return $this->so->get_department($department_id);
			}
		}

		public function delete($department_id) {
			if(!$GLOBALS['egw']->acl->check('department', EGW_ACL_DELETE, 'perp_human_resources')) {
				return false;
			} else {
				return $this->so->delete($department_id);
			}
		}

		public function link_title($entry) {
			if($entry instanceof Department) {
				return $entry->get_name();
			} elseif (is_array($entry)) {
				return 'Link title for ' . implode(',', $entry);
			} elseif (is_numeric($entry)) {
				return $this->link_title(new Department($entry));
			}
			return null;
		}
	}
?>
