<?php

	class hook_perp_human_resources {

		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
			'admin_hook'	=>	True,
		);

		var $appname = 'perp_human_resources';
		private $erp;

		public function hook_perp_human_resources() {
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file = array(
				'Site configuration'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_human_resources.hook_perp_human_resources.config',
				)),
				'Configure Access Permissions'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_human_resources.hook_perp_human_resources.acl',
				)),
				'Custom fields'		=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'admin.customfields.edit',
					'appname'	=> 'perp_human_resources'
				)),
			);

			display_section($this->appname, $file);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences']            = $GLOBALS['egw']->link('/preferences/preferences.php','appname='.$this->appname);

			//Do not modify below this line
			display_section($this->appname,$this->appname,$file);
		}

		public function user_preferences() {
		}

		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			$menu = array();
			if($GLOBALS['egw']->acl->check('stock', EGW_ACL_READ, 'perp_human_resources')) {
			//	$menu['Stock List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_human_resources.ui_perp_stock.stock_list');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
				
			$menu_title = lang('Actions');
			$menu = array();
			if($GLOBALS['egw']->acl->check('stock', EGW_ACL_ADD, 'perp_human_resources')) {
			}
			if($GLOBALS['egw']->acl->check('inventory', EGW_ACL_EDIT, 'perp_human_resources')) {
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
		}

		public function config($content = array()) {
			$data['settings']['user_name_params'] = array(
				lang('%1 is replaced with %2', '&#37;1$s', lang('First Name')),
				lang('%1 is replaced with %2', '&#37;2$s', lang('Last Name')),
				lang('%1 is replaced with %2', '&#37;3$s', lang('Department Name')),
				lang('%1 is replaced with %2', '&#37;4$d', lang('User ID')),
				lang('Most sprintf options are valid'),
			);

			$addressbook_ui = new addressbook_ui();
			$selects['staff_addressbook'] = $addressbook_ui->get_addressbooks(EGW_ACL_ADD);
			// Get rid of personal
			unset($selects['staff_addressbook'][$GLOBALS['egw_info']['user']['account_id']]);
			$this->erp->config($content, $this->appname, 'perp_human_resources.hook_perp_human_resources.config',$selects, '', $data);
		}

		public function acl($content = array()) {
			$data = $this->erp->acl($content, 'perp_human_resources', 'acl', 'acl', $selects, $filters);
		}

		public function home($args = null) {
_debug_array($args);
		}

		/*	search_link is for linking (link widget)
		*/
		public function search_link($params) {

			return array(
				'query'	=>	'perp_human_resources.bo_perp_human_resources.link_query',
				'title'	=>	'perp_human_resources.bo_perp_human_resources.link_title',
				'view'	=>	array('menuaction'=>'perp_human_resources.ui_perp_human_resources.link_view'),
				'view_id'	=>	'link_id',
			);

		}
	}
?>
