<?php

	class so_perp_department {

		public function __construct() {

		}

		/**
		*	Get a list of departments according to the 
		*	query parameters
		*/
		public function get_departments(&$query) {

			$where = array();
			if($query['department_id']) {
				$where['department_id'] = (int)$query['department_id'];
			} else {

				if($query['search']) {
					$search = $GLOBALS['egw']->db->quote('%'.$query['search'] . '%');
					$where[] = 'department_name like ' . $search;
				}
				if(!isset($query['department_parent'])) {
					// Start at the top
					$query['department_parent'] = 0;
				}
				if (isset($query['department_parent'])) {
					$where['department_parent'] = (int)$query['department_parent'];
				}
			}

			// Get number of rows
			$GLOBALS['egw']->db->select('perp_staff_department',
				array('count(department_id) AS count'),
				$where,
				__LINE__, __FILE__
			);
			if($row = $GLOBALS['egw']->db->row(true)) {
				$query['count'] = $row['count'];
			}

			$GLOBALS['egw']->db->select('perp_staff_department',
				array(
					'*'
				),
				$where,
				__LINE__, __FILE__, 0,
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'],
				'perp_human_resources'
			);
			$lines = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$lines[] = $row;
			}

			// Looking for a particular department
			if($query['department_id']) {
				return $lines;
			}

			$list = array();
			$sub_query = $query;
			$sub_query['level'] = $query['level'] + 1;

			// Get sub departments
			foreach($lines as &$line) {
				// Indent 3 spaces per level
				$line['indent'] = str_repeat('&nbsp;', max(0, $sub_query['level'] - 1) * 3);
				$line['indented_name'] = $line['indent'] . $line['department_name'];

				$list[] = $line;

				$sub_query['department_parent'] = $line['department_id'];
				$sub_departments = $this->get_departments($sub_query);
				$query['count'] += $sub_query['count'];

				if(count($sub_departments) > 0) {
					$list = array_merge($list, $sub_departments);
				}
			}
			return $list;
		}

		public function get_department($id) {
			$GLOBALS['egw']->db->select(
				'perp_staff_department',
				array('*'),
				array('department_id' => $id),
				__LINE__, __FILE__, 0,
				'', 'perp_human_resources'
			);
			return $GLOBALS['egw']->db->row(true);
		}

		public function delete($department_id) {
			$GLOBALS['egw']->db->delete(
				'perp_staff_department',
				array('department_id' => $department_id),
				__LINE__, __FILE__
			);
		}
	}
?>
