<?php

	/**
	 * eGroupWare - Setup
	 * http://www.egroupware.org 
	 * Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de
	 *
	 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
	 * @package perp_human_resources
	 * @subpackage setup
	 * @version $Id: class.db_tools.inc.php 21408 2006-04-21 10:31:06Z nelius_weiss $
	 */


$phpgw_baseline = array(
	'perp_staff' => array(
		'fd' => array(
			'employee_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'addressbook_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'job_description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'status' => array('type' => 'int','precision' => '1','nullable' => False),
			'department_id' => array('type' => 'int','precision' => '4'),
			'reports_to' => array('type' => 'int','precision' => '4'),
			'staff_id' => array('type' => 'int','precision' => '4'),
			'pay_schedule' => array('type' => 'int','precision' => '4'),
			'gender' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1')
		),
		'pk' => array('staff_id'),
		'fk' => array('addressbook_id' => 'egw_addressbook.addressbook_id','department_id' => 'perp_department.department_id','reports_to' => 'perp_staff.staff_id','staff_id' => 'egw_addressbook.contact_id','pay_schedule' => 'egw_pay_schedule.schedule_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_staff_authentication' => array(
		'fd' => array(
			'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'authentication_type' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'authentication_data' => array('type' => 'blob','nullable' => False)
		),
		'pk' => array(),
		'fk' => array('staff_id' => 'perp_staff.staff_id'),
		'ix' => array(),
		'uc' => array('authentication_data')
	),
	'perp_staff_skill' => array(
		'fd' => array(
			'staff_id' => array('type' => 'int','precision' => '4'),
			'skill_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'skill_start_date' => array('type' => 'date','nullable' => False),
			'skill_expiry_date' => array('type' => 'date'),
			'skill_level' => array('type' => 'int','precision' => '2'),
			'skill_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('staff_id','skill_id'),
		'fk' => array('staff_id' => 'perp_staff.staff_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_staff_department' => array(
		'fd' => array(
			'department_id' => array('type' => 'auto','precision' => '4'),
			'department_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'department_manager' => array('type' => 'int','precision' => '4'),
			'group_id' => array('type' => 'int','precision' => '4'),
			'department_parent' => array('type' => 'int','precision' => '4'),
			'department_number' => array('type' => 'varchar','precision' => '20')
		),
		'pk' => array('department_id'),
		'fk' => array('department_manager' => 'egw_accounts.account_id','group_id' => 'egw_accounts.account_id','department_parent' => 'perp_staff_department.department_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_record_of_employment' => array(
		'fd' => array(
			'staff_id' => array('type' => 'int','precision' => '4'),
			'start_date' => array('type' => 'date','nullable' => False),
			'end_date' => array('type' => 'date'),
			'reason' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('staff_id'),
		'fk' => array('staff_id' => 'perp_staff.staff_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_staff_extra' => array(
		'fd' => array(
			'staff_id' => array('type' => 'int','precision' => '4'),
			'staff_extra_name' => array('type' => 'varchar','precision' => '64'),
			'staff_extra_value' => array('type' => 'text')
		),
		'pk' => array('staff_id','staff_extra_name'),
		'fk' => array('staff_id' => 'perp_staff.staff_id'),
		'ix' => array(),
		'uc' => array()
	)
);
