<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.so_perp_stock_category.inc.php');

	class bo_perp_stock_category {

		// eGW category object
		static $categories;

		public function bo_perp_orders() {
		}

		public function get_category_list($query = array(), &$rows = array(), &$readonly = array()) {
			if(!$GLOBALS['egw']->acl->check('stock_category', EGW_ACL_READ, 'perp_inventory')) {
				if(isset($query['template'])) {
					$rows = array();
					return 0;
				} else {
					return array();
				}
			}

			
			if(!isset($query['template'])) {
				$query['num_rows'] = -1;
			}

			$query['order'] = $query['order'] ? $query['order'] : 'cat_id';
			$query['sort'] = $query['sort'] ? $query['sort'] : 'ASC';

			$list = so_perp_stock_category::get_category_list($query);

			if(!isset($query['template'])) {
				foreach($list as $row) {
					$rows[$row['category_id']] = $row['name'];
				}
				return $rows;
			} else {
				$rows = $list;
				$rows['add'] = $GLOBALS['egw']->acl->check('stock_category', EGW_ACL_ADD, 'perp_inventory');
				$rows['edit'] = $GLOBALS['egw']->acl->check('stock_category', EGW_ACL_EDIT, 'perp_inventory');
				$rows['delete'] = $GLOBALS['egw']->acl->check('stock_category', EGW_ACL_DELETE, 'perp_inventory');
				return $query['count'];
			}
		}

		/**
		*	Get a single category
		*	Includes eGroupWare category info
		*	@param category_id ID of the category to get
		*/
		public function get_category($category_id) {
			if(!is_object(self::$categories)) {
				self::$categories =& CreateObject('phpgwapi.categories', -1, 'perp_inventory');
			}

			$category = array();

			// Get eGW category data
			list($category) = self::$categories->return_single($category_id);
			$category['data'] = unserialize($category['data']);

			// Get list of parents, excluding this category
			$categories = self::get_category_list();
			unset($categories[$category_id]);
			$category['options-parent'] = $categories;

			// Get pERP category data
			$perp_category = so_perp_stock_category::get_category($category_id);

			return $category + $perp_category;
		}

		/**
		*	Set a category
		*	This will also update the eGroupWare category
		*
		*	@param category array of category information
		*/
		public function set_category($category) {
			if(!is_object(self::$categories)) {
				self::$categories =& CreateObject('phpgwapi.categories', -1, 'perp_inventory');
			}
		
			// Update eGroupWare category
			$category['id'] = $category['category_id'];
			$category['data'] = serialize($category['data']);
			$category['descr'] = $category['description'];
			$category['access'] = 'public';
			if($category['id']) {
				$category['category_id'] = self::$categories->edit($category);
			} else {
				$category['category_id'] = self::$categories->add($category);
			}

			// Update pERP category
			so_perp_stock_category::set_category($category);

			return $category['category_id'];
		}

		public function delete_category($category_id) {
			// Check that category is empty
			if(true) {
				return lang('Could not delete, some stock uses this category (%1)', implode(', ', $use));
			}
			if(!is_object(self::$categories)) {
				self::$categories =& CreateObject('phpgwapi.categories', -1, 'perp_inventory');
			}
			$this->categories->delete($category_id);
			so_perp_stock_category::delete_category($category_id);
		}
	}
?>
