<?php

	require_once( EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.so_perp_stock_history.inc.php');

	class bo_perp_stock_history {
		public static function get_stock_history_list(&$query = array(), &$rows = array(), &$readonly = array()) {
			if(!$GLOBALS['egw']->acl->check('stock_history', EGW_ACL_READ, 'perp_inventory')) {
				$rows = array();
				return 0;
			}

			$rows = so_perp_stock_history::get_stock_history_list($query);

			return $query['count'];
		}

		public static function add_history($stock_id, $serial_number, $comment, $link, $line, $file, $timestamp = null) {
			if(!$GLOBALS['egw']->acl->check('stock_history', EGW_ACL_ADD, 'perp_inventory')) {
				throw new egw_exception_no_permission(lang('You do not have permission to add to an item history'));
			}
			if(!(int)$stock_id) {
				throw new egw_exception_wrong_parameter('Missing stock ID');
			}
			if(!trim($serial_number)) {
				throw new egw_exception_wrong_parameter('Missing serial / batch number');
			}
			if(!trim($comment)) {
				throw new egw_exception_wrong_parameter('Missing what happened');
			}
			if($link) {
				if(!is_array($link)) {
					throw new egw_exception_wrong_parameter('Link was passed, but is not an array');
				}
				if(!$link['app']) {
					throw new egw_exception_wrong_parameter('Missing \'app\' key in link array');
				}
				if(!$link['id']) {
					throw new egw_exception_wrong_parameter('Missing \'id\' key in link array');
				}
			}

			if(!$timestamp) {
				$timestamp = time();
			}
			
			return so_perp_stock_history::add_history((int)$stock_id, trim($serial_number), trim($comment), $link, $timestamp);
		}
	}
?>
