<?php

	class hook_perp_inventory {

		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
			'admin_hook'	=>	True,
		);

		var $appname = 'perp_inventory';
		private $erp;

		public function hook_perp_inventory() {
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file = array(
				'Site configuration'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_inventory.hook_perp_inventory.config',
				))
			);
			if($GLOBALS['egw']->acl->check('acl', EGW_ACL_READ, 'perp_inventory')) {
				$file['Configure Access Permissions']	=	$GLOBALS['phpgw']->link('/index.php', array(
					'menuaction'	=> 'perp_inventory.hook_perp_inventory.acl',
				));
			}
			if($GLOBALS['egw']->acl->check('stock_category', EGW_ACL_ADD, 'perp_inventory') || $GLOBALS['egw']->acl->check('stock_category', EGW_ACL_EDIT, 'perp_inventory')) {
				$file['Stock Categories']	=	$GLOBALS['phpgw']->link('/index.php', array(
					'menuaction'	=> 'perp_inventory.ui_perp_stock_category.category_list',
				));
			}

			display_section($this->appname, $file);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences']            = $GLOBALS['egw']->link('/preferences/preferences.php','appname='.$this->appname);

			//Do not modify below this line
			display_section($this->appname,$this->appname,$file);
		}

		public function user_preferences() {
		}

		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			$menu = array();
			if($GLOBALS['egw']->acl->check('stock', EGW_ACL_READ, 'perp_inventory')) {
				$menu['Stock List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_inventory.ui_perp_stock.stock_list');
			}
			if($GLOBALS['egw']->acl->check('location', EGW_ACL_READ, 'perp_inventory')) {
				$menu['Location List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_inventory.ui_perp_location.location_list');
			}
			if($GLOBALS['egw']->acl->check('stock_history', EGW_ACL_READ, 'perp_inventory')) {
				$menu['Controlled Stock']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_inventory.ui_perp_inventory.controlled_list');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}

			$menu_title = lang('perp_manufacturing') . ' ' . lang('Menu');
			$menu = array();
			if($GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_READ, 'perp_manufacturing')) {
				$menu['Bill of Materials'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_manufacturing.ui_perp_bill_of_material.bill_of_material_list');
			}
			if($GLOBALS['egw']->acl->check('build_option', EGW_ACL_READ, 'perp_manufacturing')) {
				$menu['Build Options'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_manufacturing.ui_perp_build_option.build_option_category_list');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}

				
			$menu_title = lang('Actions');
			$menu = array();
			if($GLOBALS['egw']->acl->check('stock', EGW_ACL_ADD, 'perp_inventory')) {
				$menu['New Stock Item']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_inventory.ui_perp_stock.stock_new');
			}
			if($GLOBALS['egw']->acl->check('inventory', EGW_ACL_EDIT, 'perp_inventory')) {
				$menu['Move Inventory']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_inventory.ui_perp_inventory.move');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
		}

		public function config($content = array()) {
			// validation & correction
			//...
			$selects['costing'] = array(
				'fifo'	=>	lang('FIFO')
			);

			$selects['default_stock_status'] = ExecMethod('perp_inventory.bo_perp_stock.get_status_flags');
			$selects['default_stock_type'] = ExecMethod('perp_inventory.bo_perp_stock.get_stock_types');
			$selects['scheduling'] = array(
				'avg_hours'	=>	'Average Hours',
		//		'work_center'	=>	'By work center',
			);
			$selects['stock_general_ledger_groups'] = ExecMethod('perp_ledger.bo_perp_ledger.get_account_groups');
			$selects['allow_stock_number_changes'] = array(
				0	=>	'Number never changes, auto-generate for new',
				1	=>	'Users never change number, system auto-updates',
				2	=>	'Auto-generate for new, users can override for new stock',
				3	=>	'Changes always allowed (with permissions)'
			);

			// Translations for parameters
			$data['settings'] = array(
				'stock_number_params' => array(
					lang('%1 is replaced with %2', '&#37;1$d', lang('next stock ID number')),
					lang('%1 is replaced with %2', '&#37;2$d', lang('category ID number')),
					lang('%1 is replaced with %2', '&#37;3$s', lang('category name')),
					lang('%1 is replaced with %2', '&#37;4$s', lang('one letter status code, with a blank for production')),
					lang('%1 is replaced with %2', '&#37;5$s', lang('one letter status code {[E]xperimental, [P]roduction, [R]etired, [D]iscontinued}')),
				)
			);
					
			$this->erp->config($content, $this->appname, 'perp_inventory.hook_perp_inventory.config',$selects, '', $data);
		}

		public function acl($content = array()) {
			// Give access to the stock count worksheet (report) if access is given to stock counting
			$accounts = $GLOBALS['egw']->acl->get_ids_for_location('stock_count', EGW_ACL_READ, 'perp_inventory');
			foreach($accounts as $account) {
				$GLOBALS['egw']->acl->add_repository('perp_inventory', 'report_stock_count', $account, EGW_ACL_READ);
			}

			$data = $this->erp->acl($content, 'perp_inventory', 'acl', 'acl', $selects, $filters);
		}

		public function home($args = null) {
_debug_array($args);
		}

		/*	search_link is for linking (link widget)
		*/
		public function search_link($params) {

			return array(
				'query'	=>	'perp_inventory.bo_perp_inventory.link_query',
				'title'	=>	'perp_inventory.bo_perp_inventory.link_title',
				'view'	=>	array('menuaction'=>'perp_inventory.ui_perp_inventory.link_view'),
				'view_id'	=>	'link_id',
				'add'	=>	array('menuaction' => 'perp_inventory.ui_perp_inventory.link_add'),
				'add_id'	=>	'location_id',
				'add_app'	=>	'perp_inventory',
				'add_popup'	=>	'800x600',
			);

		}
	}
?>
