<?php

	class so_perp_count {

		public function get_count_list(&$query) {

			$where = array();

			if($query['status']) {
				if($query['status'] == 'current') {
					$where[] = 'finish_date IS NULL';
				} else {
					$where[] = 'finish_date IS NOT NULL';
				}
			}

			$join = '';

			// Get count
			$GLOBALS['egw']->db->select(
				'perp_stock_count',
				array(
					'count(count_id) AS count'
				),
				$where, __LINE__, __FILE__, 0,
				'', 'perp_inventory', 0,
				$join
			);
			if($row = $GLOBALS['egw']->db->row(true)) {
				$query['count'] = $row['count'];
			}

			// Get records
			$GLOBALS['egw']->db->select(
				'perp_stock_count',
				array(
					'*'
				),
				$where, __LINE__, __FILE__, $query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'], 
				'perp_inventory', $query['num_rows'],
				$join
			);

			$list = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$row['count_date'] = $GLOBALS['egw']->db->from_timestamp($row['count_date']);
				$list[] = $row;
			}
			return $list;
		}

		public function get_count($count_id) {
			$GLOBALS['egw']->db->select(
				'perp_stock_count',
				array('*'),
				array(
					'count_id'	=>	$count_id
				),
				__LINE__, __FILE__, false
			);
			$count = $GLOBALS['egw']->db->row(true);
			$count['count_date'] = $GLOBALS['egw']->db->from_timestamp($count['count_date']);
			$count['finish_date'] = $GLOBALS['egw']->db->from_timestamp($count['finish_date']);
			return $count;
		}

		/**
		*	Set the header info for a count instance
		*/
		public function set_count($data) {
			$finish_date = is_null($data['finish_date']) ? null : $GLOBALS['egw']->db->to_timestamp($data['finish_date']);
			$GLOBALS['egw']->db->insert(
				'perp_stock_count',
				array(
					'count_id'	=>	$data['count_id'],
					'supervisor'	=>	$data['supervisor'],
					'count_date'	=>	$GLOBALS['egw']->db->to_timestamp($data['count_date']),
					'finish_date'	=>	$finish_date,
					'count_by'	=>	$data['count_by'],
					'notes'		=>	$data['notes']
				),
				array(
					'count_id'	=>	$data['count_id']
				),
				__LINE__, __FILE__, 'perp_inventory'
			);
			if(!$data['count_id']) {
				$data['count_id'] = $GLOBALS['egw']->db->get_last_insert_id('perp_stock_count', 'count_id');
			} 
			return $data['count_id'];
		}

		public function get_sheet_list(&$query) {
			$where = array();
			$where['count_id'] = (int)$query['count_id'];
			if($query['status']) {
				switch ($query['status']) {
					case 'completed': 
						$where[] = '(completed OR completed IS NULL)';
						$where[] = 'counted_by != ""';
						break;
					case 'not_completed': 
						$where[] = '(NOT completed OR counted_by ="")';
						break;
				}
			}

			$join = 'LEFT JOIN (
				SELECT (count(stock_id) = 0 ) AS completed, sheet_id
				FROM perp_stock_count_detail
				WHERE perp_stock_count_detail.count IS NULL
				GROUP BY sheet_id
			) AS completed ON
				perp_stock_count_sheet.sheet_id = completed.sheet_id';

			// The subquery in the join screws up the WHERE, so do it here
			if(count($where)) {
				$join .= ' WHERE ' . $GLOBALS['egw']->db->column_data_implode(' AND ',$where);
			}

			// Get count
			$GLOBALS['egw']->db->select(
				'perp_stock_count_sheet',
				array(
					'count(perp_stock_count_sheet.sheet_id) AS count'
				),
				array(), __LINE__, __FILE__, 0,
				'', 'perp_inventory', 0,
				$join
			);
			if($row = $GLOBALS['egw']->db->row(true)) {
				$query['count'] = $row['count'];
			}
			
			// Get records
			$GLOBALS['egw']->db->select(
				'perp_stock_count_sheet',
				array(
					'perp_stock_count_sheet.count_id',
					'perp_stock_count_sheet.sheet_id',
					'perp_stock_count_sheet.location_id',
					'perp_stock_count_sheet.counted_by',
					'perp_stock_count_sheet.checked_by',
					'IF(completed IS NULL, true, completed) AS completed'
				),
				array(), __LINE__, __FILE__, $query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'], 
				'perp_inventory', $query['num_rows'],
				$join
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$list[] = $row;
			}
			return $list;
		}

		public function get_sheet($sheet_id) {
			$GLOBALS['egw']->db->select(
				'perp_stock_count_sheet',
				array(
					'*'
				),
				array(
					'sheet_id'	=>	(int)$sheet_id
				),
				__LINE__, __FILE__, false,
				'', 'perp_inventory'
			);
			$sheet = $GLOBALS['egw']->db->row(true);

			if(!$sheet['sheet_id']) {
				return false;
			}

			// Get details
			$GLOBALS['egw']->db->select(
				'perp_stock_count_detail',
				array(
					'perp_stock_count_detail.*',
					'perp_unit_of_measure.*',
					'perp_stock.*',
					'count(perp_stock_count_serial.stock_id) > 0 AS need_serials'
				),
				array(
					'perp_stock_count_detail.sheet_id = ' . (int)$sheet_id
				),
				__LINE__, __FILE__, false,
				'GROUP BY perp_stock_count_detail.sheet_id, perp_stock_count_detail.stock_id
				ORDER BY stock_num', 'perp_inventory', false,
				'JOIN perp_stock ON
					perp_stock.stock_id = perp_stock_count_detail.stock_id
				JOIN perp_unit_of_measure ON
					perp_stock.unit_of_measure = perp_unit_of_measure.uom_id
				LEFT JOIN perp_stock_count_serial ON
					perp_stock_count_serial.sheet_id = perp_stock_count_detail.sheet_id AND
					perp_stock_count_serial.stock_id = perp_stock_count_detail.stock_id'
			);
			$sheet['details'] = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				if(is_numeric($row['expected'])) {
					$row['expected'] = round((float)$row['expected'], $row['decimal_places']);
				}
				if(is_numeric($row['count'])) {
					$row['count'] = round((float)$row['count'], $row['decimal_places']);
				}
				$sheet['details'][] = $row;
			}
			return $sheet;
		}
		
		
		public function set_sheet($data) {
			
			if(!$data['location_id']) {
				return false;
			}
			
			$GLOBALS['egw']->db->insert(
				'perp_stock_count_sheet',
				array(
					'count_id'	=>	$data['count_id'],
					'sheet_id'	=>	$data['sheet_id'],
					'location_id'	=>	$data['location_id'],
					'counted_by'	=>	$data['counted_by'],
					'checked_by'	=>	$data['checked_by']
				),
				array(
					'sheet_id'	=>	(int)$data['sheet_id']
				),
				__LINE__, __FILE__, 'perp_inventory'
			);
			if(!$data['sheet_id']) {
				$data['sheet_id'] = $GLOBALS['egw']->db->get_last_insert_id('perp_stock_count_sheet', 'sheet_id');
			} 
			
			foreach($data['details'] as $detail) {
				if(!($data['sheet_id'] && $detail['stock_id'])) {
					continue;
				}
				$GLOBALS['egw']->db->insert(
					'perp_stock_count_detail',
					array(
						'sheet_id'	=>	$data['sheet_id'],
						'stock_id'	=>	$detail['stock_id'],
						'expected'	=>	$detail['expected'],
						'count'		=>	$detail['count'],
						'unit_cost'	=>	$detail['unit_cost']
					),
					array(
						'sheet_id'	=>	$data['sheet_id'],
						'stock_id'	=>	$detail['stock_id'],
					), __LINE__, __FILE__, 'perp_inventory'
				);
			}
			
			return $data['sheet_id'];
		}

		/**
		*	Get a list of serial numbers that are expected at a location
		*	provided by the sheet_id
		*
		*	@param sheet_id
		*	@param stock_id
		*	
		*	@return Array of serial numbers
		*/
		public function get_serial_numbers($sheet_id, $stock_id) {
			$result =& $GLOBALS['egw']->db->select(
				'perp_stock_count_serial',
				array(
					'perp_stock_count_serial.serial_number',
					'perp_stock_count_serial.quantity_expected',
					'perp_stock_count_serial.count AS quantity_counted',
					'perp_stock_count_serial.quantity_expected AS quantity_expected',
					'perp_stock_count_detail.expected AS total_expected',
					'perp_stock_count_detail.count AS total_counted',
					'perp_stock.controlled',
					'perp_stock_count_sheet.location_id',
				),
				array(
					'perp_stock_count_serial.sheet_id = ' . (int)$sheet_id,
					'perp_stock_count_serial.stock_id = ' . (int)$stock_id
				),
				__LINE__, __FILE__, false,
				'ORDER BY serial_number', 'perp_inventory', false,
				'JOIN perp_stock_count_detail ON
					perp_stock_count_detail.sheet_id = perp_stock_count_serial.sheet_id AND
					perp_stock_count_detail.stock_id = perp_stock_count_serial.stock_id
				JOIN perp_stock_count_sheet ON
					perp_stock_count_detail.sheet_id = perp_stock_count_sheet.sheet_id
				JOIN perp_stock ON
					perp_stock.stock_id = perp_stock_count_serial.stock_id'
			);
			foreach($result as $row) {
				$list[] = $row;
			}
			return $list;
		}

		/**
		*	Set a list of serial numbers that are found at a location
		*	provided by the sheet_id.  
		*
		*	The list of serial numbers can contain serial numbers that were not
		*	expected to be found at the location.  In this case, the 'quantity_expected'
		*	value is 0, and the 'quantity_counted' value is > 0.
		*
		*	@param sheet_id 
		*	@param stock_id
		*	@param serials An array of serial number information, including serial_number and quantity counted
		*/
		public function set_serial_numbers($sheet_id, $stock_id, $serials) {
			$count = 0;
			
			$GLOBALS['egw']->db->transaction_begin();

			foreach($serials as $serial) {
				if(!is_array($serial) || !($serial['serial_number'] && array_key_exists('quantity_counted', $serial))) {
					continue;
				}
				$GLOBALS['egw']->db->insert(
					'perp_stock_count_serial',
					array(
						'sheet_id'	=>	$sheet_id,
						'stock_id'	=>	$stock_id,
						'serial_number'	=>	$serial['serial_number'],
						'quantity_expected'	=>	$serial['quantity_expected'],
						'count'		=>	$serial['quantity_counted']
					),
					array(
						'sheet_id'	=>	$sheet_id,
						'stock_id'	=>	$stock_id,
						'serial_number'	=>	$serial['serial_number']
					),
					__LINE__, __FILE__, 'perp_inventory'
				);
			
				// Update total number counted at this location
				$count += $serial['quantity_counted'];
			}

			// Update, not insert, the row is always already there.
			$GLOBALS['egw']->db->update(
				'perp_stock_count_detail',
				array(
					'count'		=>	$count
				),
				array(
					'sheet_id'	=>	$sheet_id,
					'stock_id'	=>	$stock_id,
				), __LINE__, __FILE__, 'perp_inventory'
			);

			$GLOBALS['egw']->db->transaction_commit();
		}
		
		public function create_sheets($data) {
			$bo_inventory = new bo_perp_inventory();

			$pre_fill = 'null';
			if($data['pre_fill'] == '0') {
				$pre_fill = 0;
			} elseif ($data['pre_fill'] == 'expected') {
				$pre_fill = 'IF(perp_location_stock.quantity_on_hand + perp_location_stock.quantity_reserved IS NULL,
					0,
					perp_location_stock.quantity_on_hand + perp_location_stock.quantity_reserved
				)';
			}
						
			$GLOBALS['egw']->db->transaction_begin();			
	
			//create sheets
			$sql_sheet = 'INSERT INTO perp_stock_count_sheet (count_id, counted_by, location_id)';
			$sql_sheet .= 'SELECT '.$data['count_id'].' AS count_id, "", location_id
				FROM perp_location
				WHERE perp_location.location_id IN ('.implode(",", $data['location_id']).')
				GROUP BY count_id, location_id';
				
			$GLOBALS['egw']->db->query($sql_sheet, __LINE__, __FILE__);
					
			//insert data for all sheets
			$sql_detail = 'INSERT INTO perp_stock_count_detail (sheet_id, stock_id, expected, count, unit_cost)';
			$sql_detail .= 'SELECT perp_stock_count_sheet.sheet_id,
				perp_stock.stock_id,
				IF(perp_location_stock.quantity_on_hand + perp_location_stock.quantity_reserved IS NULL, 
					0, 
					perp_location_stock.quantity_on_hand + perp_location_stock.quantity_reserved
				) AS expected, ';
			$sql_detail .= $pre_fill . ' AS count,
				(SELECT direct_cost + indirect_cost AS unit_cost
				FROM perp_stock_cost
				WHERE stock_id = perp_stock.stock_id
				ORDER BY date DESC
				LIMIT 1) AS unit_cost
				FROM perp_stock_count_sheet
				JOIN perp_location
					ON perp_stock_count_sheet.location_id = perp_location.location_id
				JOIN perp_stock 
					ON perp_stock.stock_category IN ('.implode(",", $data['categories']).')
					AND perp_stock.pseudo = 0
					AND perp_stock.status_flag != "R"
				LEFT JOIN perp_location_stock
					ON  perp_stock.stock_id = perp_location_stock.stock_id
					AND perp_stock_count_sheet.location_id = perp_location_stock.location_id 
				WHERE perp_stock_count_sheet.count_id = '.$data['count_id'].' ';

			// Add in filters to cut down the number of items
			if($data['include_items'] == 'ever_there' || $data['include_items'] == 'last year') {
				$sql_detail .= 'AND (perp_stock.stock_id, perp_stock_count_sheet.location_id) IN (
					SELECT stock_id, to_location_id FROM perp_stock_move ';
				if($data['include_items'] == 'last_year') {
					$sql_detail .= 'WHERE perp_stock_move.timestamp >= ' . 
						$GLOBALS['egw']->db->quote($GLOBALS['egw']->db->to_timestamp(
							strtotime('last year', time())
						));
				}
				$sql_detail .= ' GROUP BY stock_id, to_location_id) ';
			}
			if($data['include_items'] == 'currently_there') {
				$sql_detail .= 'AND (perp_location_stock.quantity_on_hand + perp_location_stock.quantity_reserved) != 0 ';
			}
			$sql_detail .= 'ORDER BY perp_stock.stock_id';

			$GLOBALS['egw']->db->query($sql_detail, __LINE__, __FILE__);

			/**
			*	Get all serial / batch numbers for controlled stock, insert
			*	for expected.
			*/

			$sql_serial = 'INSERT INTO perp_stock_count_serial (sheet_id, stock_id, serial_number, quantity_expected, count)
				SELECT perp_stock_count_detail.sheet_id,
					perp_stock_count_detail.stock_id,
					perp_stock_serial.serial_number,
					perp_stock_serial.quantity AS quantity_expected,
					null AS count
				FROM perp_stock_count_detail
				JOIN perp_stock_count_sheet ON
					perp_stock_count_sheet.sheet_id = perp_stock_count_detail.sheet_id
				JOIN perp_stock ON
					perp_stock_count_detail.stock_id = perp_stock.stock_id AND
					perp_stock.controlled
				LEFT JOIN perp_stock_serial ON
					perp_stock_serial.stock_id = perp_stock_count_detail.stock_id AND
					perp_stock_serial.location_id = perp_stock_count_sheet.location_id
				WHERE count_id = ' . $data['count_id'];
			$GLOBALS['egw']->db->query($sql_serial, __LINE__, __FILE__);
			
			$GLOBALS['egw']->db->transaction_commit();
			
			
			//retrieve stock count details that have no unit_cost
			$sql_retrieve = 'SELECT perp_stock_count_detail.sheet_id, perp_stock_count_detail.stock_id, perp_stock_count_detail.expected, perp_stock_count_detail.count, perp_stock_count_detail.unit_cost, perp_stock.stock_type_flag
				FROM perp_stock_count_detail
				LEFT JOIN perp_stock_count_sheet
				ON perp_stock_count_detail.sheet_id = perp_stock_count_sheet.sheet_id
				LEFT JOIN perp_stock
				ON perp_stock_count_detail.stock_id = perp_stock.stock_id
				WHERE perp_stock_count_sheet.count_id = '.$data['count_id'].'
				AND perp_stock_count_detail.unit_cost = 0
				ORDER BY perp_stock.stock_type_flag DESC, perp_stock_count_detail.sheet_id, perp_stock_count_detail.stock_id
				';
			
			$GLOBALS['egw']->db->query($sql_retrieve, __LINE__, __FILE__);
			$perp_stock_count_detail_without_unit_cost = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$perp_stock_count_detail_without_unit_cost[] = $row;
			}
					
			//replace unit cost in stock count details that have no unit_cost by calling $bo_inventory->get_cost_estimate
			$perp_stock_count_detail_with_unit_cost = array();
			$stock_id_cache = array();
			foreach($perp_stock_count_detail_without_unit_cost as $perp_stock_count_detail_row) {
				
				$perp_stock_count_detail_row['unit_cost'] = $bo_inventory->get_cost_estimate($perp_stock_count_detail_row['stock_id'], $data['count_date'], false);
				
				$GLOBALS['egw']->db->insert(
					'perp_stock_count_detail',
					array(
						'sheet_id'	=>	$perp_stock_count_detail_row['sheet_id'],
						'stock_id'	=>	$perp_stock_count_detail_row['stock_id'],
						'expected'	=>	$perp_stock_count_detail_row['expected'],
						'count'		=>	$perp_stock_count_detail_row['count'],
						'unit_cost'	=>	$perp_stock_count_detail_row['unit_cost']
					),
					array(
						'sheet_id'	=>	$perp_stock_count_detail_row['sheet_id'],
						'stock_id'	=>	$perp_stock_count_detail_row['stock_id'],
					), __LINE__, __FILE__, 'perp_inventory'
				);
				
				$perp_stock_count_detail_with_unit_cost[] = $perp_stock_count_detail_row;
			}
			
			return;	
		}
		
		/**
		*
		*/
		public function delete_count($count_id) {
			
			$sql_delete = 'DELETE perp_stock_count_detail
				FROM perp_stock_count_detail
				INNER JOIN perp_stock_count_sheet
				ON perp_stock_count_detail.sheet_id = perp_stock_count_sheet.sheet_id
				WHERE perp_stock_count_sheet.count_id = '.$count_id.'';			
			$GLOBALS['egw']->db->query($sql_delete, __LINE__, __FILE__);
			$GLOBALS['egw']->db->delete('perp_stock_count_sheet', array('count_id' => $count_id), __LINE__, __FILE__);
			$GLOBALS['egw']->db->delete('perp_stock_count', array('count_id' => $count_id), __LINE__, __FILE__);
			
			return;
		}

		public function get_change_list(&$query) {

			$where = array(
				'perp_stock_count.count_id = ' . (int)$query['count_id'],
				'(
			    		perp_stock_count_detail.expected != perp_stock_count_detail.count
				)',
			);

			if($query['cat_id']) {
				$where[] = 'perp_stock.stock_category = ' . (int)$query['cat_id'];
			}
			if($query['col_filter']) {
				foreach($query['col_filter'] as $col => $value) {
					if($value) {
						$col=='location_id'?$col='perp_stock_count_sheet.location_id':'';
						$where[] = "$col = " . $GLOBALS['egw']->db->quote($value);
					}
				}
			}
			if($query['search']) {
				$search = $GLOBALS['egw']->db->quote('%' . $query['search'] . '%');
				$where[] = "(stock_num LIKE $search OR short_description LIKE $search)";
			}

			$join = 'JOIN perp_stock ON
				perp_stock.stock_id = perp_stock_count_detail.stock_id
			JOIN perp_stock_count_sheet ON
				perp_stock_count_sheet.sheet_id = perp_stock_count_detail.sheet_id
			JOIN perp_stock_count ON
				perp_stock_count_sheet.count_id = perp_stock_count.count_id
			JOIN perp_unit_of_measure ON
				perp_stock.unit_of_measure = perp_unit_of_measure.uom_id
			LEFT JOIN perp_location_stock ON
				perp_stock.stock_id = perp_location_stock.stock_id AND
				perp_stock_count_sheet.location_id = perp_location_stock.location_id
			LEFT JOIN perp_stock_count_serial ON
				perp_stock_count_serial.sheet_id = perp_stock_count_detail.sheet_id 
				AND perp_stock_count_serial.stock_id = perp_stock_count_detail.stock_id';

			// Get count
			$query['count'] = $GLOBALS['egw']->db->select(
				'perp_stock_count_detail',
				array(
					'count(perp_stock_count_detail.stock_id) AS count'
				),
				$where, __LINE__, __FILE__, 0,
				'GROUP BY perp_stock_count_detail.sheet_id, perp_stock_count_detail.stock_id', 'perp_inventory',-1,
				$join
			)->NumRows();

			if(!is_object($GLOBALS['perp_api']['bo'])) {
				$GLOBALS['perp_api']['bo'] =& CreateObject('perp_api.bo_perp_api');
			}

			// Need currencies for exchange
			$GLOBALS['perp_api']['bo']->get_currencies(
				array(
					'template'	=>	false
				),
				$currencies
			);
			$exchange = array();
			foreach($currencies as $currency) {
				$exchange[$currency['currency_id']] = $currency['exchange_rate'];
			}

			$results =& $GLOBALS['egw']->db->select(
				'perp_stock_count_detail',
				array(
					'perp_stock_count_detail.sheet_id',
					'perp_stock_count_sheet.location_id',
					'perp_stock_count_detail.stock_id',
					'perp_stock.stock_num',
					'perp_stock.short_description',
					'perp_stock.decimal_places',
					'perp_unit_of_measure.uom_name',
					'perp_stock_count_detail.expected',
					'perp_stock_count_detail.count',
					'perp_stock_count_detail.unit_cost',
					'IF(perp_stock_count_detail.count IS NULL, \'not counted\', perp_stock_count_detail.count) - expected AS difference',
					'perp_stock_count.count_date',
					'perp_stock_count.finish_date',
					'(perp_location_stock.quantity_on_hand + perp_location_stock.quantity_reserved) AS current',
					'count(serial_number) > 0 AS controlled'
				),
				$where, __LINE__, __FILE__, $query['start'],
				'GROUP BY perp_stock_count_detail.sheet_id, perp_stock_count_detail.stock_id
				ORDER BY ' . $query['order'] . ' ' . $query['sort'], 'perp_inventory',
				$query['num_rows'],
				$join
			);

			$list = array();
			$serials = array();

			foreach($results as $row) {
				$row['count_date'] = $GLOBALS['egw']->db->from_timestamp($row['count_date']);
				$row['finish_date'] = $GLOBALS['egw']->db->from_timestamp($row['finish_date']);
				$row['expected'] = round((float)$row['expected'], $row['decimal_places']);
				$row['count'] = round((float)$row['count'], $row['decimal_places']);
				$row['current'] = round((float)$row['current'], $row['decimal_places']);
				if(is_numeric($row['difference'])) {
					$row['difference'] = round($row['difference'], $row['decimal_places']);
				}

				if($row['controlled']) {
					$serials[] = count($list);
				}
				
				$list[] = $row;
			}

			foreach($serials as $row_number) {
				$serial_numbers = $this->get_serial_numbers($list[$row_number]['sheet_id'], $list[$row_number]['stock_id']);
				foreach($serial_numbers as $serial_info) {
					if($serial_info['quantity_expected'] != $serial_info['quantity_counted']) {
						$list[$row_number]['serial_numbers'][] = $serial_info;
					}
				}
			}

			return $list;
		}

		public function make_changes($count_id, $changes) {
			$GLOBALS['egw']->db->transaction_begin();

			$bo_inventory = new bo_perp_inventory();
			$reference = lang('Inventory Count #%1', $count_id);
			$trans = CreateObject('perp_ledger.GLTransaction');
			$check = true;

			foreach($changes as $change) {
				// Special handling for controlled stock
				if(is_array($change['serial_numbers'])) {
					// Keep a list of unexpected, unfound serials, we'll do them all together
					$unexpected = array();

					// Keep a list of missing serials, we'll do them all together
					$missing = array();

					foreach($change['serial_numbers'] as $serial_array) {
						
			
						if($serial_array['quantity_expected'] < $serial_array['quantity_counted']) {
							// Found a serial number we weren't expecting

							// See if we can find out where we think it is
							$query = array(
								'stock_id'	=>	$change['stock_id'],
								'serial_number'	=>	$serial_array['serial_number'],
							);
							bo_perp_inventory::get_controlled_inventory_list($query, $current_list);

							// Move the item from where it was to where we found it
							foreach($current_list as $current) {
								$quantity = min($current['quantity'], $serial_array['quantity_counted']);
								$bo_inventory->move($current['location_id'], 'on_hand', $change['location_id'], 'on_hand', $change['stock_id'], $quantity,
									array($serial_array['serial_number'], $quantity)
								);
								$serial_array['quantity_counted'] -= $quantity;
								
								if($serial_array['quantity_counted'] <= 0) {
									break;
								}
							}
							
							// Any left that we couldn't find?
							if($serial_array['quantity_counted'] > 0) {
								$unexpected[$serial_array['serial_number']] = $serial_array['quantity_counted'];
							}
						} elseif ($serial_array['quantity_expected'] > $serial_array['quantity_counted']) {
							$missing[$serial_array['serial_number']] = $serial_array['quantity_expected'];
						}
					}
					if(count($unexpected) > 0) {
						// Create them from nothing
						$quantity = array_sum($unexpected);
						$stock_cost_id = $bo_inventory->add_stock_cost($change['stock_id'], $quantity, $change['unit_cost']);

						// -4 is an adjustment
						$result = $bo_inventory->receive($change['stock_id'], $change['location_id'], $quantity, $stock_cost_id, $unexpected, $reference, -4);
						if($result !== true) {
							echo $result;
							$check = false;
							break;
						}
					}
					
					if(count($missing) > 0) {
						// Lost some stock we previously had, reserve & consume it
						$quantity = array_sum($missing);
						$bo_inventory->reserve_stock($change['location_id'], $change['stock_id'], $quantity, $reference);
						$bo_inventory->consume(
							$change['stock_id'], 
							'adjustment', 
							$change['location_id'], 
							$quantity,
							$reference, 
							$missing
						);
					}
				} elseif($change['difference'] < 0) {
					// Lost some stock we previously had, reserve & consume it
					$bo_inventory->reserve_stock($change['location_id'], $change['stock_id'], -$change['difference'], $reference);
					$bo_inventory->consume($change['stock_id'], 'adjustment', $change['location_id'], -$change['difference'], $reference, $change['serials']);
				} elseif ($change['difference'] > 0) {
					// Found some stock we previously didn't have, receive it.
					$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $change['stock_id']);
					$adjustment_account = bo_perp_stock::get_gl_accounts($change['stock_id'], bo_perp_inventory::ADJUSTMENT);
					$on_hand_account = bo_perp_stock::get_gl_accounts($change['stock_id'], bo_perp_inventory::ON_HAND);

					$stock_cost_id = $bo_inventory->add_stock_cost($change['stock_id'], $change['difference'], $change['unit_cost']);

					// -4 is an adjustment
					$result = $bo_inventory->receive($change['stock_id'], $change['location_id'], $change['difference'], $stock_cost_id, is_array($change['serials']) ? $change['serials'] : array(), $reference, -4);
					if($result !== true) {
						$check = false;
						echo $result . '<br />';
					}

					if($check) {
						$cost = bcmul($change['difference'], $change['unit_cost'], 2);
						$trans->add_line($adjustment_account, $reference, -$cost);
						$trans->add_line($on_hand_account, $reference, $cost);
					}
				}
			}

			if($check && $trans->check() === true) {
				$count = $this->get_count($count_id);
				$count['finish_date'] = time();
				$this->set_count($count);

				$trans->write();

				$GLOBALS['egw']->db->transaction_commit();
			} else {
				$GLOBALS['egw']->db->transaction_abort();
			}
		}
	}
?>
