<?php

	class so_perp_stock_category {

		// eGW category object
		static $categories;

		public static function get_category_list(&$query) {
			$where = array(
				'cat_appname'	=>	'perp_inventory'
			);
			if($query['category_id']) {
				$where['category_id'] = $query['category_id'];
			}
			if($query['parent']) {
				$where['cat_parent'] = $query['parent'];
			}

			$join = 'LEFT JOIN perp_stock_category ON
				perp_stock_category.category_id = egw_categories.cat_id';

			$query['count'] = $GLOBALS['egw']->db->select(
				'egw_categories',
				array('count(cat_id) as count'),
				$where,
				__LINE__, __FILE__, 0,'', 
				'perp_inventory', 1, $join
			)->fetchSingle();

			$result =& $GLOBALS['egw']->db->select(
				'egw_categories',
				array(
					'cat_id AS category_id',
					'cat_parent',
					'cat_name AS name',
					'cat_description',
					'cat_data',
				),
				$where,
				__LINE__, __FILE__, $query['start'],
				"ORDER BY {$query['order']} {$query['sort']}",
				'perp_inventory', $query['num_rows'],
				$join
			);
			$list = array();
			foreach($result as $row) {
				$row['indent'] = str_repeat('&nbsp;', $row['level'] * 3);
				$row['indented_name'] = $row['indent'] . $row['name'];
				$row['data'] = unserialize($row['cat_data']);
				if($row['data']['color']) {
					$row['color'] = '<div style="width: 100%; height: 100%; background-color:' . $row['data']['color'] . ';">&nbsp;</div>';
				}
				$list[] = $row;
			}

			return $list;
		}

		public static function get_category($category_id) {
			$row = $GLOBALS['egw']->db->select('perp_stock_category', 
				array('*'),
				array('category_id'	=>	$category_id),
				__LINE__, __FILE__
			)->fetchRow();
			return is_array($row) ? $row : array();
		}

		public static function set_category($category) {
			$GLOBALS['egw']->db->insert('perp_stock_category',
				$category,
				array('category_id' => $category['category_id']),
				__LINE__, __FILE__,
				'perp_inventory'
			);
		}	
		
		public static function delete_category($category_id) {
			$GLOBALS['egw']->db->delete('perp_stock_category',
				array('category_id'	=>	$category_id),
				__LINE__, __FILE__,
				'perp_inventory'
			);
		}
	}
?>
