<?php

	class so_perp_stock_history {

		public static function get_stock_history_list(array &$query = array()) {
			$where = array();
			if($query['stock_id']) {
				$where[] = 'perp_work_order_detail.stock_id = ' . $query['stock_id'];
			}
			if($query['serial_number']) {
				$where[] = 'perp_stock_history.serial_number = ' . $GLOBALS['egw']->db->quote($query['serial_number']);
			}
			if($query['work_order_id']) {
				$where[] = 'perp_stock_history.work_order_id = ' . $query['work_order_id'];
			}
			if(isset($query['detail_id'])) {
				$where[] = 'perp_stock_history.detail_id = ' .$query['detail_id'];
			}
			if($query['work_center']) {
				$where['work_center'] = $query['work_center'];
			}

			$select = 'SELECT 
				history_id,
				perp_stock_history.stock_id,
				perp_stock_history.serial_number,
				timestamp,
				comment,
				link_app, link_id';
			$sql = ' FROM perp_stock_history ';
			$sql .= 'JOIN perp_stock_serial ON
					perp_stock_serial.stock_id = perp_stock_history.stock_id AND
					perp_stock_serial.serial_number = perp_stock_history.serial_number
				LEFT JOIN perp_work_order_detail ON
					perp_work_order_detail.work_order_id = perp_stock_serial.work_order_id AND
					perp_work_order_detail.detail_id = perp_stock_serial.detail_id';
			$sql .= (count($where) > 0 ? ' WHERE ' . $GLOBALS['egw']->db->column_data_implode(' AND ', $where) : '') . ' ';

			if($query['order']) {
				$sql .= 'ORDER BY ' . $query['order'] . ' ' . $query['sort'];
			}

			// Get number of results
			$query['count'] = $GLOBALS['egw']->db->query('SELECT count(history_id) AS count' . $sql, __LINE__, __FILE__)->fetchSingle();

			$GLOBALS['egw']->db->query($select . $sql, __LINE__, __FILE__, $query['start'], $query['num_rows']);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(True)) {
				$list[] = $row;
			}

			// Need to do this seperately as title() will hit the DB, destroying the recordset
			foreach($list as &$row) {
				$row['link'] = array(
					'app'	=>	$row['link_app'],
					'id'	=>	$row['link_id'],
					'title'	=>	egw_link::title($row['link_app'], $row['link_id'])
				);
			}
			return $list;
		}

		public static function add_history($stock_id, $serial_number, $comment, $link, $timestamp) {
			$GLOBALS['egw']->db->insert(
				'perp_stock_history', 
				array(
					'stock_id'	=>	$stock_id,
					'serial_number'	=>	$serial_number,
					'timestamp'	=>	$timestamp,
					'comment'	=>	$comment,
					'link_app'	=>	$link['app'],
					'link_id'	=>	$link['id'],
				),
				array(),
				__LINE__, __FILE__, 'perp_inventory'
			);
			return $GLOBALS['egw']->db->get_last_insert_id('perp_stock_history', 'stock_history_id');
		}
	}
?>
