<?php

	/**
	*	User interface for damage
	*
	*	Most of the good UI stuff is done in ui_perp_stock_history.
	*
	*	@author Nathan Gray
	*/

	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_damage.inc.php');

	class ui_perp_damage {

		public $public_functions = array(
			'view'	=>	true,
		);

		protected $template = null;

		public $messages = array();
		
		public function __construct() {
			$this->template = new etemplate();
		}

		public function view($content = array()) {
			// Get ID
			$stock_history_id = get_var('stock_history_id', 'any', $content['stock_history_id']);

			if(!$GLOBALS['egw']->acl->check('damage', EGW_ACL_READ, 'perp_inventory')) {
				$this->messages[] = array(lang('You are not allowed to read damage reports'), 'error');
			} else {
				$data = self::get_display_data($stock_history_id);
			}

			if($content['cancel']) {
				$GLOBALS['egw']->redirect_link(
					'/index.php', array(
					'menuaction'	=>	'perp_inventory.ui_perp_stock_history.stock_history_list',
					'stock_id'	=>	$data['stock_id'],
					'serial'	=>	$data['serial_number']
				));
			}
			
			$select_box_options = self::get_options($data);

			$readonly['link'] = !$GLOBALS['egw']->acl->check('damage', EGW_ACL_EDIT, 'perp_inventory');
			$preserve['stock_history_id'] = $stock_history_id;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Damage to %1 - %2', $data['stock_num'], $data['serial_number']);
			$this->template->read('perp_inventory.damage');
			$this->template->exec('perp_inventory.ui_perp_damage.view', $data, $select_box_options, $readonly, $preserve);
		}

		/**
		*	Get data for display
		*/
		public static function get_display_data($stock_history_id) {
			if(!$stock_history_id) {
				return array();
			}
			$data = bo_perp_damage::get_damage($stock_history_id);

			// Convert for user display
			$data['discount_percent'] *= 100;
		
			if($data['work_order_id']) {
				$data += ExecMethod2('perp_manufacturing.bo_perp_work_order.get_work_order', $data['work_order_id']);
				$data += ExecMethod2('perp_manufacturing.bo_perp_work_order.get_work_order_detail', $data['work_order_id'], $data['detail_id']);
			}
			$data += ExecMethod2('perp_inventory.bo_perp_stock.get_stock_item', $data['stock_id']);

			$serial = ExecMethod2('perp_manufacturing.bo_perp_work_order.get_serial_number', $data['work_order_id'], $data['stock_id']);
			if(count($serial) == 1) {
				$data += $serial[0];
			}

			$data['link'] = array(
				'to_id'		=>	'DAMAGE-' . $stock_history_id,
				'to_app'	=>	'perp_inventory'
			);

			return $data;
		}

		/**
		*	Get information for selectbox options
		*/
		public static function get_options($data) {
			$options = array();

			return $options;
		}
	}

?>
