<?php

	require_once('class.bo_perp_location.inc.php');
	require_once( EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_stock.inc.php');

	class ui_perp_inventory {
		private $bo;
		private $template;
		public $public_functions = array(
			'index'		=>	True,
			'move'		=>	True,
			'move_serial'	=>	True,
			'controlled_list'	=>	True,
			'link_view'	=>	True,
			'link_add'	=>	true,
			'stock_movement'	=>	true,
		);

		private $debug = false;

		/**
		*	Array of messages for the user
		*/
		private $messages = array();

		function ui_perp_inventory() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_inventory.bo_perp_inventory');
		}

		function index($content = array()) {
			$stock = $GLOBALS['egw']->acl->check('stock', EGW_ACL_READ, 'perp_inventory');
			$location = $GLOBALS['egw']->acl->check('location', EGW_ACL_READ, 'perp_inventory');
			$inventory_move = $GLOBALS['egw']->acl->check('inventory', EGW_ACL_EDIT, 'perp_inventory');
			$stock_history = $GLOBALS['egw']->acl->check('stock_history', EGW_ACL_READ, 'perp_inventory');
			$count = $GLOBALS['egw']->acl->check('stock_count', EGW_ACL_READ, 'perp_inventory');

			if(isset($content['stock_list']) && $stock) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_stock.stock_list'));
			} elseif (isset($content['location_list']) && $location) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_location.location_list'));
			} elseif (isset($content['inventory_move']) && $inventory_move) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_inventory.move'));
			} elseif (isset($content['controlled']) && $stock_history) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_inventory.controlled_list'));
			} elseif (isset($content['count']) && $count) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_count.count_list'));
			}

			$readonly['stock_list'] = !$stock;
			$readonly['location_list'] = !$location;
			$readonly['inventory_move'] = !$inventory_move;
			$readonly['controlled'] = !$stock_history;
			$readonly['count'] = !$count;

			// Display
			$this->template->read('perp_inventory.index');
			$this->template->exec('perp_inventory.ui_perp_inventory.index', $data, $select_box_options, $readonly, $preserve);
		}

		public function move($content = array()) {
			if($this->debug) {
				echo '<strong>perp_inventory.ui_perp_inventory.move</strong> incoming data:';
				_debug_array($content);
			}
			
			$from_location = $content['from_location'] ? $content['from_location'] : $_GET['from_location'];
			$from_work_center = $content['from_work_center'] ? $content['from_work_center'] : $_GET['from_work_center'];
			$to_location = $content['to_location'] ? $content['to_location'] : $_GET['to_location'];
			$to_work_center = $content['to_work_center'] ? $content['to_work_center'] : $_GET['to_work_center'];

			$data = array();

			// Move stock
			if(isset($content['save'])) {
				$locations = ExecMethod('perp_inventory.bo_perp_location.get_location_list');
				$stock_groups = array('on_hand' => lang('On Hand'), 'reserved' => lang('Reserved'), 'garbage' => lang('Garbage'));
				$errors = 0;

				if(isset($content['items'])) {
					$quantity_query = array(
						'from_location'		=>	$content['from_location'],
						'to_location'		=>	$content['to_location'],
						'from_work_center'	=>	$content['from_work_center'],
						'to_work_center'	=>	$content['to_work_center']
					);
					foreach($content['items'] as $key => &$item) {
						if($item['stock_id'] && $item['quantity'] > 0) {
							$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $item['stock_id']);
							if($stock['controlled'] && $stock['serial_setup'] != bo_perp_stock::SERIAL_WHEN_NEEDED && !$item['serial_numbers']) {
								$this->messages[] = array(lang('Need serial numbers for controlled stock item %1', $stock['stock_num']), 'error'); 
								$errors++;
								continue;
							}

							// Check for valid quantity
							$quantity_query['stock_id'] = $item['stock_id'];
							$this->bo->get_movable_stock($quantity_query, $result);
							if(count($result) != 1 || (is_numeric($result[0]['maximum']) && $item['quantity'] > $result[0]['maximum'])) {
								if(!is_array($result[0])) {
									$result[0]['maximum'] = 0;
								}
								$this->messages[] = array(
									lang(
										'Move %1 %2, maximum is %3', 
										$item['quantity'],
										$stock['stock_num'],
										$result[0]['maximum']
									),
									'warning'
								);
								$item['quantity'] = $result[0]['maximum'];
							}

							// Move expects serial numbers in (S/N => quantity) format
							$item_serials = array();
							if(is_array($item['serial_numbers'])) {
								foreach($item['serial_numbers'] as $values) {
									$item_serials[$values['serial_number']] = $values['quantity'];
								}
							}
							
							$result = $this->bo->move(
								$from_location, $from_work_center, 
								$to_location, $to_work_center, 
								$item['stock_id'], $item['quantity'], 
								$item_serials
							);
				
							if($result !== True) {
								$this->messages[] = array($result . ' (' . $item['stock_id'] . ')', 'error');
								$errors++;
							} else {
								$this->messages[] = array(
									lang(
										'Moved %1 %2 from %3 %4 to %5 %6',
										$item['quantity'], 
										ExecMethod('perp_inventory.bo_perp_stock.link_title', $item['stock_id']),
										$locations[$content['from_location']], $stock_groups[$content['from_work_center']],
										$locations[$content['to_location']], $stock_groups[$content['to_work_center']]
									), 
									'info'
								);
								unset($content['items'][$key]);
							}
						} else {
							unset($content['items'][$key]);
						}
						$item = array();
					}
				}
				if($errors == 0) {
					$this->messages[] = array(lang('success'), 'success');
					$content = array();
				}
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('index.php', array('menuaction'=>'perp_inventory.ui_perp_inventory.index'));
			}

			$data += $content;
			if(!is_array($data['items'])) {
				$data['items'] = array();
				$data['items'][1] = array();
			} elseif ($data['items'][count($data['items'])]['stock_id']) {
				$data['items'][] = array();
			}

			foreach($data['items'] as $key => &$item) {
				$stock_id = $item['stock_id'];
				$item['stock_id'] = array(
					'stock_id'	=>	$stock_id,
					'location_id'	=>	$from_location,
				);
				$item['stock_id']['from_location'] = $from_location;
				$item['stock_id']['to_location'] = $to_location;
				$item['stock_id']['from_work_center'] = $from_work_center;
				$item['stock_id']['to_work_center'] = $to_work_center;

				// Hide serial number button
				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
				$readonly['items'][ 'serials[' . $key . ']'] = !$stock['controlled'];
				$item['serial_numbers'] = array(
					'stock_id'	=>	$stock_id,
					'serials'	=>	$item['serial_numbers'],
				);
			}

			$data += array(
				'from_location'		=>	$from_location,
				'from_work_center'	=>	$from_work_center,
				'to_location'		=>	$to_location,
				'to_work_center'	=>	$to_work_center,
			);

			// Select boxes
			$select_box_options['from_location'] = array('' => lang('Select')) + ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$select_box_options['to_location'] = $select_box_options['from_location'];

			$pseudo = array('on_hand' => lang('On Hand'), 'reserved' => lang('Reserved'), 'garbage' => lang('Garbage'));
			$select_box_options['from_work_center'] = $pseudo;
			$select_box_options['to_work_center'] = $pseudo;

			$readonly['perp_inventory.inventory_move.row'] = !$data['from_work_center'] || !$data['from_location'] || !$data['to_location'] || !$data['to_work_center'];

			// Messages
			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Move Inventory');
			$this->template->read('perp_inventory.inventory_move');
			$this->template->exec('perp_inventory.ui_perp_inventory.move', $data, $select_box_options, $readonly, $preserve);
		}

		public function controlled_list($content = array()) {
			if(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_inventory.index'));
			}
			
			$data['nm'] = array(
				'cat'		=>	True,
				'filter_label'  =>      'Location',
				'filter_no_lang'        =>      True,
				'filter2_label' =>      'Stock Item',
				'filter2_no_lang'       =>      True,
				'get_rows'      =>      'perp_inventory.bo_perp_inventory.get_controlled_inventory_list',
				'template'      =>      'perp_inventory.controlled_list.row',
				'sort'		=>	'DESC',
				'order'		=>	'serial_number',
			);
			$data['nm']['cat_id'] = $GLOBALS['egw_info']['user']['preferences']['perp_inventory']['stock_category'];
			$select_box_options['filter'] = array('' => lang('All')) + 
				bo_perp_location::$pseudo_locations + 
				array(-4 => lang('Missing')) +
				ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$select_box_options['filter2'] = array('' => lang('All')) + ExecMethod('perp_inventory.bo_perp_stock.get_stock_list', array('controlled' => true, 'cat_id' => $data['nm']['cat_id']));
			$select_box_options['location_id'] = $select_box_options['filter'];

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Controlled Stock List');
			$this->template->read('perp_inventory.controlled_list');
			$this->template->exec('perp_inventory.ui_perp_inventory.controlled_list', $data, $select_box_options, $readonly, $preserve);
		}

		public function link_view() {
			$link = $_GET['link_id'];
			list($location, $id) = explode('-', $link);
			
			if($id) {
				switch($location) {
					case 'STOCK':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_inventory.ui_perp_stock.stock_edit', 
								'stock_id'	=>	$id
							)
						);
						break;
					case 'LOCATION':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_inventory.ui_perp_location.location_edit', 
								'location_id'	=>	$id
							)
						);
						break;
					case 'SERIAL':
						break;
					case 'DAMAGE':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_inventory.ui_perp_damage.view', 
								'stock_history_id'	=>	$id
							)
						);
						break;
				}
			}
		}

		/**
		*	Add a new entry in Inventory
		*
		*/
		public function link_add($content = array()) {
			if(!isset($content['link_add'])) {
				$content['link_add'] = $GLOBALS['egw_info']['user']['preferences']['perp_inventory']['link_add'];
			}
			if($content['link_add']) {
				switch ($content['link_add']) {
					case 'STOCK':
						$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_stock.stock_new','popup'=>true));
						break;
					case 'LOCATION':
						$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_location.location_new','popup'=>true));
						break;
				}
			} else {
				// Display
				$this->template->read('perp_inventory.link_add');
				$this->template->exec('perp_inventory.ui_perp_inventory.link_add', $data, $select_box_options, $readonly, $preserve, 2);
			}
		}

		/**
		*	Display a history of stock movements
		*
		*	@param content array of data returned from the eTemplate
		*/
		public function stock_movement($content = array()) {
			$stock_id = get_var('stock_id', 'any', $content['stock_id']);

			if($stock_id) {
				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
			}

			if(isset($content['cancel'])) {
				if($stock_id) {
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'	=>	'perp_inventory.ui_perp_stock.stock_edit',
						'stock_id'	=>	$stock_id
					));
				} else {
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'	=>	'perp_inventory.ui_perp_inventory.index',
					));
				}
			}
			$data['nm'] = array(
				'stock_id'	=>	$stock_id,
				'cat_app'	=>	'perp_inventory',
				'filter'	=>	$stock_id,
				'no_filter2'    =>      True,
				'get_rows'      =>      'perp_inventory.bo_perp_inventory.get_stock_movement',
				'template'      =>      'perp_inventory.stock_move.row',
			);

			$locations = array('' => lang('all')) + ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$select_box_options['filter'] = array('' => lang('all')) +  ExecMethod('perp_inventory.bo_perp_stock.get_stock_list');
			$select_box_options['from_location_id'] =& $locations;
			$select_box_options['to_location_id'] =& $locations;
			$select_box_options['location_id'] =& $locations;
			$select_box_options['move_type'] =& $this->bo->get_stock_move_types();

			$preserve['stock_id'] = $stock_id;

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Stock Movement History');
			$this->template->read('perp_inventory.stock_move');
			$this->template->exec('perp_inventory.ui_perp_inventory.stock_movement', $data, $select_box_options, $readonly, $preserve);
		}
	}
?>
