<?php

	class ui_perp_location {

		public $public_functions = array(
			'location_list'	=>	True,
			'location_new'	=>	True,
			'location_edit'	=>	True,
		);
		private $bo;
		private $template;
		private $debug = false;

		public function ui_perp_location() {
			$this->bo = CreateObject('perp_inventory.bo_perp_location');
			$this->template = CreateObject('etemplate.etemplate');
		}

		public function location_list($content = array()) {
			if($this->debug) {
				echo '<strong>perp_inventory.ui_perp_location.location_list</strong> incoming data:';
				_debug_array($content);
			}

			$new = $GLOBALS['egw']->acl->check('location', EGW_ACL_ADD, 'perp_inventory');

			$preserve['return'] = $_GET['return'] ? $_GET['return'] : ($content['return'] ? $content['return'] : $_SERVER['HTTP_REFERER']);

			if(isset($content['new_location']) && $new) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_location.location_new'));
			} elseif($content['nm']['rows']['edit']) {
				$location_id = key($content['nm']['rows']['edit']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_location.location_edit', 'location_id'=>$location_id));
			} elseif($content['nm']['rows']['delete']) {
				$location_id = key($content['nm']['rows']['delete']);
				$this->messages[] = array(ExecMethod('perp_inventory.bo_perp_location.delete_location', $location_id), 'error');
			} elseif($content['cancel']) {
				$GLOBALS['egw']->redirect($preserve['return'] ? $preserve['return'] : $GLOBALS['egw']->link('/index.php?menuaction=perp_inventory.ui_perp_inventory.index'));
			}

			$data['nm'] = array(
				'include_work_centers'	=>	True,
				'no_cat'        =>      True,
			//	'no_filter'     =>      True,
				'filter_label'  =>      'Location status',
				'filter_no_lang'        =>      True,
				'no_filter2'    =>      True,
			//	'filter2_label' =>      'Stock Category',
			//	'filter2_no_lang'       =>      True,
				'get_rows'      =>      'perp_inventory.bo_perp_location.get_location_list',
				'template'      =>      'perp_inventory.location_list.row',
			//	'header_left'   =>      '',
			//	'header_right'  =>      '',
				'filter'	=>	$content['nm']['filter'] ? $content['nm']['filter'] : 1
			);
			$data['location_delete'] = $GLOBALS['egw']->acl->check('location', EGW_ACL_DELETE, 'perp_inventory');

			// Select box options
			$select_box_options['filter'] = array('' => lang('all')) + $this->bo->get_location_status();

			// Readonlys
			$readonly['new_location'] = !$new;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Location List');
			$this->template->read('perp_inventory.location_list');
			$this->template->exec('perp_inventory.ui_perp_location.location_list', $data, $select_box_options, $readonly, $preserve);
		}

		public function location_new($content = array()) {
			$content['new'] = True;
			return $this->location_edit($content);
		}

		public function location_edit($content = array()) {
			if($this->debug) {
				echo '<strong>perp_inventory.ui_perp_location.location_edit</strong> incoming data:';
				_debug_array($content);
			}

			$tabs = 'details|links|work_center|accounts|inventory';

			$location_id = $content['location_id'] ? $content['location_id'] : $_GET['location_id'];
			$data = array();

			if(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_location.location_list'));
			}

			// Update location
			$this->location_update($location_id, $content);

			// Load location
			if($location_id) {
				$location = $this->bo->get_location($location_id);
			}


			$data = $this->get_display_data($location);
			$data['accounts'] = $content['accounts'];
			if($location_id) {
				$this->get_general_ledger_accounts($data, $readonlys);
			}
			$data['tabs'] = $tabs;
			$data[$tabs] = $content[$tabs];

			$preserve['location_id'] = $location_id;

			$select_box_options = $this->get_options($location);
			$readonly = $this->get_readonlys($data);

			if(!isset($location_id)) {
				$preserve['new'] = true;
			}
			$preserve['accounts'] = $data['accounts'];
			$preserve['work_center'] = $data['work_center'];

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = $location_id ? lang('Edit Location') . ' - ' . $data['location_name'] : lang('New Location');
			$this->template->read('perp_inventory.location_edit');
			$this->template->exec('perp_inventory.ui_perp_location.location_edit', $data, $select_box_options, $readonly, $preserve, ($_GET['popup'] ? 2 : 0));
		}

		/**
		*	Update the location
		*	@param location array of information about a location
		*	@param content arrya of new information to update the location with
		*/
		protected function location_update(&$location_id, &$content) {
			// Deal with incoming
			if(isset($content['save'])) {
				if(!$GLOBALS['egw']->acl->check('location', EGW_ACL_EDIT, 'perp_inventory')) {
					$this->messages[] = array(lang('Access not allowed'), 'error');
					return false;
				}

				unset($content['save']);

				$result = $this->bo->set_location($location_id, $content);
				if(is_numeric($result) && $result != false) {
					$location_id = $result;
					$this->messages[] = array(lang('Location saved'), 'success');
				} else {
					$this->messages[] = array($result, 'error');
				}
				if($content['work_center_id']) {
					if($content['work_center']['work_center_id'] != $content['work_center_id']) {
						ExecMethod2('perp_manufacturing.bo_perp_work_center.remove_work_center_location', $content['work_center_id'], $location_id);
					}
					if(count($content['work_center'])) {
						// Already a work center, update it
						$result = ExecMethod2('perp_manufacturing.bo_perp_work_center.set_work_center_location', $content['work_center']);
						$this->messages[] = ($result === true) ? array(lang('Work center saved'), 'success') : array($result, 'error');
					} else {
						// New work center
						$result = ExecMethod2('perp_manufacturing.bo_perp_work_center.add_work_center_location', $content['work_center_id'], $location_id);
					}
				} elseif($location_id) {
					$result = ExecMethod2('perp_manufacturing.bo_perp_work_center.remove_work_center_location', $content['work_center']['work_center_id'], $location_id);
					if($result !== true) {
						$this->messages[] = array($result, 'error');
					}
					unset($content['work_center']);
				}
			}
		}

		/**
		*	Get information for displaying a location
		*	@param location array of information about a location
		*/
		protected function get_display_data(&$location) {
			$data = $location;
			$data['address'] = $location['delivery_address'];

			// Set up inventory nextmatch
			$data['inventory'] = array(
				'location_id'	=>	$location['location_id'],
				'no_filter'     =>      True,
			//	'filter_label'  =>      'Stock Category',
			//	'filter_no_lang'        =>      True,
			//	'no_filter2'    =>      True,
				'filter2_label' =>      '',
				'filter2_no_lang'       =>      True,
				'get_rows'      =>      'perp_inventory.bo_perp_location.get_inventory',
				'template'      =>      'perp_inventory.location_edit.inventory.row',
			//	'header_left'   =>      '',
			//	'header_right'  =>      '',
			);

			// Links 
			$data['links']['to_app'] = 'perp_inventory';
			$data['links']['to_id'] = 'LOCATION-'.$location['location_id'];
			
			if($location['location_id']) {
				$data['work_center'] = ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center_location', $location['location_id']);
				$data['work_center_id'] = $data['work_center']['work_center_id'];
			}

			return $data;
		}

		/**
		*	Set up general ledger account tab
		*	@param data data for display
		*	@readonlys array of widgets to set readonly
		*/
		protected function get_general_ledger_accounts(&$data, &$readonly) {
			// General Ledger Accounts
			if($GLOBALS['egw']->acl->check('account', EGW_ACL_READ, 'perp_ledger') && $data['location_id']) {
				$data['accounts'] = $GLOBALS['egw']->session->appsession('gl_accounts.' . $data['location_id']);
				if(!is_array($data['accounts'])) {
					$data['accounts'] = array();
				}
				$data['accounts'] += array(
					'location_id'	=>	$data['location_id'],
					'get_rows'	=>	'perp_inventory.ui_perp_location.get_gl_accounts',
					'template'	=>	'perp_inventory.location_edit.accounts.row',
					'no_cat'	=>	true,
					'no_filter'	=>	true,
					'no_filter2'	=>	true
				);
			} else {
				$readonly[$data['tabs']]['accounts'] = True;
			}
		}

		protected function get_options($location) {
			$options['location_parent'] = $this->bo->get_location_list();
			if($location['location_id']) {
				unset($options['location_parent'][$location['location_id']]);
			}

			$options['filter'] = array('' => lang('All')) + bo_perp_stock_category::get_category_list();
			$options['filter2'] = array(
				''	=>	lang('All'),
				'on_hand'	=>	lang('On hand'),
				'not_on_hand'	=>	lang('Not on hand'),
				'reserved'	=>	lang('Reserved'),
			);

			$options['status'] = $this->bo->get_location_status();

			$options['tax_location'] = ExecMethod('perp_api.bo_perp_api.get_tax_locations');

			$addresses = ExecMethod2('phpgwapi.bolink.get_links', 'perp_inventory', 'LOCATION-'.$location['location_id'], 'addressbook');
			foreach($addresses as $id => $address_id) {
				$options['delivery_address'][$address_id] = egw_link::title('addressbook', $address_id);
			}

			$options['work_center_id'] = array(null => lang('Inventory location')) + array(
				lang('Work Centers') => ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center_list')
			);

			return $options;
		}

		/**
		*	Get a list of widgets to be set readonly
		*	when editing a location
		*/
		protected function get_readonlys($data) {
			$edit = $GLOBALS['egw']->acl->check('location', EGW_ACL_EDIT, 'perp_inventory');

			// Check for general ledger accounts
			$can_have_inventory = false;
			$can_be_work_center = false;
			if($data['location_id'] && !is_array($data['accounts']['rows'])) {
				$this->get_gl_accounts($data['accounts'], $data['accounts']['rows']);
			}
			if(is_array($data['accounts']['rows'])) {
				foreach($data['accounts']['rows'] as $category) {
					$can_have_inventory |= ($category['stock_gl_account'] != 0);
					$can_be_work_center |= ($category['work_in_progress_gl_account'] != 0);
				}
			}
			if(!$data['delivery_address']) {
				$this->messages[] = array(
					lang('%1 cannot receive or ship inventory because there are no addresses linked', 
					$data['location_name']
					), 'info'
				);
			}
/*
			if(!$can_have_inventory) {
				$this->messages[] = array(
					lang('%1 cannot have inventory because there is no "%2" general ledger account set', 
					$data['location_name'],
					lang('stock on hand')
					), 'info'
				);
			}
			if(!$can_be_work_center) {
				$this->messages[] = array(
					lang('%1 cannot be a work center because there is no "%2" general ledger account set', 
					$data['location_name'],
					lang('work in progress')
					), 'info'
				);
			}
*/

			// Readonlys
			$readonly['location_name'] = !$edit;
			$readonly['perp_inventory.location_edit.details'] = !$edit;
			$readonly['is_a_work_center'] = !$can_be_work_center;
			$readonly['perp_inventory.location_edit.accounts'] = !$edit;
			$readonly[$data['tabs']]['work_center'] = !$GLOBALS['egw']->acl->check('work_center', EGW_ACL_READ, 'perp_manufacturing') || !$data['work_center_id'];
			$readonly[$data['tabs']]['inventory'] = !$GLOBALS['egw']->acl->check('inventory', EGW_ACL_READ, 'perp_inventory') || !$data['location_id'] || !$can_have_inventory;

			// This tab disabled until it can be completely removed, after stock GL account changes are done
			$readonly[$data['tabs']]['accounts'] = !$GLOBALS['egw']->acl->check('account', EGW_ACL_READ, 'perp_ledger') || !$data['location_id'];
			$readonly[$data['tabs']]['accounts'] = true;

			$readonly[$data['tabs']]['links'] = !$data['location_id'];
			$readonly['save'] = !$edit;
			return $readonly;
		}

		public function get_gl_accounts(&$query = array(), &$rows = array(), &$readonly = array()) {
			$GLOBALS['egw']->session->appsession('gl_accounts.' . $query['location_id'], 'perp_inventory', $query);

			$count = $this->bo->get_gl_accounts($query, $rows, $readonly);
			

			// Add in filters on GL accounts
			$info = config::read('perp_inventory');
			foreach($rows as &$row) {
				// Set up filters on Ajax Select Widgets
				$row['stock_gl_account'] = array(
					'account_id'		=>	$row['stock_gl_account'],
					'account_group'		=>	$info['stock_general_ledger_groups']
				);
				$row['work_in_progress_gl_account'] = array(
					'account_id'		=>	$row['work_in_progress_gl_account'],
					'account_group'		=>	$info['stock_general_ledger_groups']
				);
				$row['shrinkage_gl_account'] = array(
					'account_id'		=>	$row['shrinkage_gl_account'],
					'account_group'		=>	$info['stock_general_ledger_groups']
				);
			}
			
			return $count;
		}
	
	}
?>
