<?php
	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/barcode/class.perp_barcode.inc.php');

	class ui_perp_stock {

		public $public_functions = array(
			'stock_list'	=>	True,
			'stock_edit'	=>	True,
			'stock_new'	=>	True,
			'cost_details'	=>	True,
			'change_stock_status'	=>	True,
		);

		private $bo;
		private $template;
		private $config;
		private $orders_installed;
		private $api;
		private $messages = array();

		private $debug = false;

		public function ui_perp_stock() {
			$this->bo = CreateObject('perp_inventory.bo_perp_stock');
			$this->template = CreateObject('etemplate.etemplate');
			$this->config = config::read('perp_inventory');
	
			$this->api = CreateObject('perp_api.ui_perp_api');

			$this->orders_installed = file_exists(EGW_SERVER_ROOT . '/perp_orders/inc/');
		}

		public function stock_list($content = array()) {
			if($this->debug) {
				echo '<strong>perp_inventory.ui_perp_stock.stock_list</strong> incoming data:';
				_debug_array($content);
			}

			$new = $GLOBALS['egw']->acl->check('stock', EGW_ACL_ADD, 'perp_inventory');

			if(isset($content['new_stock']) && $new) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_stock.stock_new'));
			} elseif($content['nm']['rows']['edit']) {
				$stock_id = key($content['nm']['rows']['edit']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_stock.stock_edit', 'stock_id'=>$stock_id));
			} elseif($content['nm']['rows']['delete']) {
				$stock_id = key($content['nm']['rows']['delete']);
				$this->bo->delete($stock_id);
			} elseif(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_inventory.ui_perp_inventory.index');
			}

			$data['nm'] = $GLOBALS['egw']->session->appsession('stock_list', 'perp_inventory');
			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'no_filter'     =>      True,
					'filter2_label' =>      'Status',
					'filter2_no_lang'       =>      True,
					'lettersearch'	=>	true,
					'selectcols'	=>	$GLOBALS['egw_info']['user']['preferences']['perp_inventory']['nextmatch-perp_inventory.stock_list.row'],
					'default_cols'	=>	'stock_num,short_description',
					'get_rows'      =>      'perp_inventory.ui_perp_stock.get_stock_list',
					'template'      =>      'perp_inventory.stock_list.row',
				);
			}

			$data['nm']['cat_id'] = $GLOBALS['egw_info']['user']['preferences']['perp_inventory']['stock_category'];
			$data['nm']['filter2'] = $GLOBALS['egw_info']['user']['preferences']['perp_inventory']['stock_status'];

			$select_box_options['filter2'] = array('' => lang('All')) + ExecMethod('perp_inventory.bo_perp_stock.get_status_flags');
			$select_box_options['stock_type_flag'] = ExecMethod('perp_inventory.bo_perp_stock.get_stock_types');
			$select_box_options['controlled'] = array(0 => lang('No'), 1 => lang('Batched'), 2 => lang('Serialized'));
			$select_box_options['has_attachments'] = array('' => lang('Any'), 1=> lang('yes'), 2=> lang('no'));
			$select_box_options['unit_of_measure'] = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures');
			$select_box_options['status_flag'] = ExecMethod('perp_inventory.bo_perp_stock.get_status_flags');
			$select_box_options['inventory'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');
	

			$readonly['new_stock'] = !$new;

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Stock List');
			$this->template->read('perp_inventory.stock_list');
			$this->template->exec('perp_inventory.ui_perp_stock.stock_list', $data, $select_box_options, $readonly, $preserve);
		}

		public function stock_new($content = array()) {
			if($content['copy'] || $_GET['copy']) {
				$stock_id = $content['copy'] ? $content['copy'] : $_GET['copy'];
				if($stock_id) {
					$clone_id = $this->bo->stock_clone($stock_id);
				}
				if(!is_numeric($clone_id)) {
					$this->messages[] = array($clone_id, 'error');
				} else {
					$stock_id = $clone_id;
				}
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_inventory.ui_perp_stock.stock_edit',
					'stock_id'	=>	$stock_id
				));
			} else {
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_inventory.ui_perp_stock.stock_edit',
					'new'		=>	True,
					'popup'		=>	$_GET['popup']
				));
			}
		}

		public function stock_edit($content = array()) {
			if($this->debug) {
				echo '<strong>perp_inventory.ui_perp_stock.stock_edit</strong> incoming data:';
				_debug_array($content);
			}
			$tabs = 'details|shipping|suppliers|links|bill_of_material|options_view|options_edit|financial|inventory|pricing';
			$data = array();
			$data[$tabs] = $content[$tabs] ? $content[$tabs] : $_GET['tab'];
			$content['tabs'] = $tabs;
			
			$stock_id = $content['stock_id'] ? $content['stock_id'] : $_GET['stock_id'];
			if(!$stock_id) {
				if(!(count($content) || $_GET['new'])) {
					$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_inventory.ui_perp_stock.stock_list');
				}
			}

			$ro = !$GLOBALS['egw']->acl->check('stock', EGW_ACL_EDIT, 'perp_inventory');
			
			// Default price change effective date to tomorrow, start of day
                        $tomorrow = strtotime('tomorrow');
                        $default_date = mktime($GLOBALS['egw_info']['user']['preferences']['calendar']['workdaystarts'], 0, 0, date('m', $tomorrow), date('d', $tomorrow), date('Y', $tomorrow));
			
			// Deal with incoming data

			// Buttons
			if(isset($content['save'])) {
				unset($content['save']);

				// Check for a changed stock number
				if($GLOBALS['egw']->session->appsession($stock_id . ':new_stock_number', 'perp_inventory')) {
					$content['stock_num'] = $GLOBALS['egw']->session->appsession($stock_id . ':new_stock_number', 'perp_inventory');
					$GLOBALS['egw']->session->appsession($stock_id . ':new_stock_number', 'perp_inventory', null);
				}

				// Move controlled settings out, they're just inside a grid for easy handling
				if($content['controlled_settings']) {
					$content = array_merge($content, $content['controlled_settings']);
				}
		
				// etemplate.process_exec() puts all rows into the result, which causes problems if there was a filter applied
				$content['options'] = $_POST['exec']['options'];

				// Purpose of the GL account doesn't get returned
				$value = $content['general_ledger_accounts'];
				$content['general_ledger_accounts'] = array();
				if(is_array($_POST['exec']['general_ledger_accounts'])) {
					foreach($_POST['exec']['general_ledger_accounts'] as $row => $account) {
						$content['general_ledger_accounts'][$account['account_use']] = $value[$row];
					}
				}
				
				// If user is not editing prices, don't send them into set_stock_item(), it will try and update them
				if(!array_key_exists('edit_prices', $content)) {
					unset($content['pricing']);
				}
				
				$save = $this->bo->set_stock_item($stock_id, $content);
				$GLOBALS['egw']->session->appsession('bill_of_material', false, $content['bill_of_material']);
				unset($bom);

				if($save !== True) {
					$data = $content;
					if(is_numeric($save)) {
						if(!$stock_id) {
							/*
							Just saved a new stock item, redirect so the supplier popup won't create another 
							stock item if the user tries to add supplier (popup reloads parent page).
							*/
							$GLOBALS['egw']->redirect_link('/index.php', array(
								'menuaction'	=>	'perp_inventory.ui_perp_stock.stock_edit',
								'stock_id'	=>	$save
							));
						}
						$stock_id = $save;
						$this->messages[] = array(lang('Stock Item') . ' - ' . lang('saved'), 'success');
					} elseif(is_array($save)) {
						$this->messages = array_merge($this->messages, $save);
					} else {
						$this->messages[] = array($save, 'error');
					}
				}
			} elseif (isset($content['sales_categories']['pricing']['add_sales_category'])) {
				$this->bo->add_sales_category($stock_id, $content['sales_categories']['pricing']['new_sales_category']);
			} elseif (isset($content['sales_categories']['delete'])) {
				$id = key($content['sales_categories']['delete']);
				$this->bo->delete_sales_category($stock_id, $id);
			} elseif (isset($content['clone'])) {
				$GLOBALS['egw']->session->appsession('bill_of_material', false, null);
				$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_inventory.ui_perp_stock.stock_new&copy='. $stock_id);
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->session->appsession('bill_of_material', false, null);
				$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_inventory.ui_perp_stock.stock_list');
			}

			// Read data for display			
			if($stock_id) {
				// Details
				$data = array_merge($data, ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id));
				$data['barcodes'] = $this->bo->get_barcodes($stock_id);
				
                                // Serialized / Batch settings
                                if($data['controlled']) {
                                        $data['controlled_settings'] = array(
                                                'serial_setup'  =>      $data['serial_setup']
                                        );

                                        if($data['controlled_settings']['serial_setup'] > 0) {
                                                // pERP will create the S/Ns
                                                $data['controlled_settings']['next_serial'] = $this->bo->get_next_serial($stock_id);
                                        }

                                        if($data['controlled_settings']['serial_setup'] == bo_perp_stock::SERIAL_WHEN_NEEDED){
						
						$data['patterns'] = $this->bo->get_serial_patterns($stock_id);
						if($data['patterns'] && !$ro) {
							$data['patterns'][] = array(
								'stock_id' => $stock_id,
								'pattern' => lang('new pattern')
							);
						}		
						$data['use_patterns'] = 1;
                                        }
                                }					

				// Get barcode images
				foreach($data['barcodes'] as $key => &$barcode) {
					if($GLOBALS['egw_info']['user']['preferences']['perp_inventory']['display_barcodes'] && perp_barcode::is_enabled()) {
						$barcode['barcode_image'] = $GLOBALS['egw']->link('/perp_api/inc/barcode/image.php', array(
							'encoding'	=>	$barcode['encoding'],
							'code'		=>	$barcode['barcode']
							)
						);
					} else {
						$barcode['barcode_image'] = '';
					}
				}
				if($data['barcodes'] && !$ro) {
					$data['barcodes'][] = array(
						'stock_id' => $stock_id,
						'barcode'	=>	lang('new barcode'),
						'barcode_image'	=>	''
					);
				}
				$readonly['short_description'] = $ro;

				$readonly['save'] = $ro;
				$readonly['clone'] = !$GLOBALS['egw']->acl->check('stock', EGW_ACL_ADD, 'perp_inventory');

				$readonly['perp_inventory.stock_edit.details'] = $ro;
				$readonly['perp_inventory.stock_edit.shipping'] = $ro;

				$data['status_flag'] = $data['status_flag'] ? $data['status_flag'] : $this->config['default_stock_status'];

				// Shipping
				$this->setup_shipping_tab($data);

				// Links
				$data['links']['to_app'] = 'perp_inventory';
				$data['links']['to_id'] = 'STOCK-' . $stock_id;

				$data['history_log'] = array(
					'id'	=>	$stock_id,
					'status-widgets'	=>	$this->bo->get_history_widgets($stock_id),
				);
				$select_box_options['status'] = $this->bo->history2field;

				$this->setup_workflow($tabs, $data, $select_box_options, $readonly);

				// Bill Of Materials
				$bom_read = $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_READ, 'perp_manufacturing');
				if($bom_read) {
					$this->setup_bill_of_materials_tab($data, $select_box_options, $readonly);
				} else {
					$readonly[$tabs]['bill_of_material'] = True;
				}

				if($data['stock_type_flag'] != 'R') {
					$readonly[$tabs]['suppliers'] = True;

					// Build Options
					//setting the states of the stock edit options and stock view options
					if($content[$tabs] == 'perp_inventory.stock_edit.options_edit' || $content[$tabs] == 'perp_inventory.stock_edit.options_view'){
						if($content['view_mode']){
							$build_view_mode = true;
							$select_view_mode = true;
						} elseif($content['edit_mode']) {
							$build_edit_mode = true;
							$select_edit_mode = true;
						}
					} else {
						$build_view_mode = true;						
					}
				
					$bo_option = CreateObject('perp_manufacturing.bo_perp_build_option');
					if($bo_option) {
					
						if($build_edit_mode) {
							if($select_edit_mode){
								$data[$tabs] = 'options_edit';
							}							
							$preserve['edit_mode'] = true;
							
							// Set effective date
							if($content['options_edit']['effective_from'] && $content[$tabs] == 'perp_inventory.stock_edit.options_edit') {
								$options_edit['effective_from'] = $content['options_edit']['effective_from'];
							} else {
								$options_edit['effective_from'] = mktime(0,0,0,date('m'), date('d'), date('Y'));
							}

							$data['options'] = array(
								'cat_id'		=>	$data['stock_category'],
								'filter'		=>	$content['build_options_view_nm']['filter'],
								'effective_from'	=>	$options_edit['effective_from'],
								'status'		=>	'as_of_date',
								'stock_id'		=>	$stock_id,
								'options-filter'	=>	array('' => lang('All')) + ExecMethod('perp_manufacturing.bo_perp_build_option.get_build_option_category_list', array('cat_id' => $data['stock_category'])),
								'no_cat'		=>	True,
								'no_filter'            =>      False,
								'no_filter2'		=>	True,
								'get_rows'		=>	'perp_inventory.bo_perp_stock.stock_edit_options_edit',
								'template'		=>	'perp_inventory.stock_edit.options.row',
							);							
							
							$data['options_edit'] = $options_edit;
							$readonly[$tabs]['options_view'] = True;
						} else {
							if($select_view_mode){
								$data[$tabs] = 'options_view';
							}	
													
							$data['build_options_view_nm'] = array(
								'stock_id'			=>		$data['stock_id'],
								'stock_category'	=>		$data['stock_category'],
								'no_cat'     		=>      True,
								'num_rows'     		=>      200,
								'no_filter'		=>	False,
								'no_search'     	=>      True,
								'filter2'     		=>      'current',
								'get_rows'      	=>      'perp_inventory.bo_perp_stock.stock_edit_options_view',
								'template'      	=>      'perp_inventory.stock_edit.options.readonly_row',
							);
							
							$select_box_options['filter'] = array('' => lang('All')) + ExecMethod('perp_manufacturing.bo_perp_build_option.get_build_option_category_list', array('cat_id' => $data['stock_category']));
							$select_box_options['filter2'] = ExecMethod('perp_manufacturing.bo_perp_build_option.get_build_option_status_list');
							
							$readonly[$tabs]['options_edit'] = True;							
						}
												
					} else {
						$readonly[$tabs]['options_view'] = True;
						$readonly[$tabs]['options_edit'] = True;
					}

				} elseif($data['stock_type_flag'] == 'R') {
				// Suppliers
					$readonly[$tabs]['options_view'] = True;
					$readonly[$tabs]['options_edit'] = True;
					
					$suppliers = $this->bo->get_suppliers($stock_id, true);
					foreach($suppliers as $key => &$supplier) {
						if(!is_array($supplier)) {
							continue;
						}
						$supplier['formatted_unit_cost'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $supplier['our_unit_cost']);
						$supplier['formatted_price'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', $supplier['supplier_currency'], $supplier['price']);
						$supplier['conversion_factor'] = round($supplier['conversion_factor'], $data['decimal_places']);
						if($supplier['preferred']) {
							$suppliers['preferred'] = $preserve['suppliers']['old_preferred'] = $supplier['supplier_id'];
						}
					}

					array_unshift($suppliers, 'title');
					$data['suppliers'] = $suppliers;
					$readonly['perp_inventory.stock_edit.suppliers'] = $ro && !$GLOBALS['egw']->acl->check('catalog', EGW_ACL_EDIT | EGW_ACL_ADD, 'perp_ap');
					$data['can_add_new_supplier'] = $GLOBALS['egw']->acl->check('catalog', EGW_ACL_EDIT | EGW_ACL_ADD, 'perp_ap');
				}
				// Financial
				if(!$data['pseudo'] && $GLOBALS['egw']->acl->check('inventory', EGW_ACL_READ, 'perp_inventory')) {
					// General Ledger accounts
					$accounts = bo_perp_stock::get_gl_accounts($stock_id);
					$data['general_ledger_accounts'] = array();
					foreach($accounts as $use => $gl_account) {
						$data['general_ledger_accounts'][] = array(
							'account_use'	=>	$use,
							'gl_account'	=>	$gl_account
						);
					}
					$select_box_options['account_use'] = bo_perp_inventory::$account_uses;

					// Costs
					$cost = $this->bo->get_cost_summary($stock_id);
					array_unshift($cost, 'title');
					foreach($cost as $key => $row) {
						$readonly['cost'][$key]['price'] = True;
					}
					$preserve['cost'] = $cost;
					$cost['start_date'] = True;
					$cost['end_date'] = True;
					$cost['edit'] = False; // Don't want to edit these, because they're an aggregate
					$data['cost'] = $cost;
					$readonly['perp_inventory.stock_edit.financial'] = $ro;
	
				// Inventory
					$inventory = ExecMethod2('perp_inventory.bo_perp_stock.get_inventory', $stock_id);
					array_unshift($inventory, false);
					$data['inventory'] = $inventory;
					$data['inventory']['location'] = $content['inventory']['location'];
					$preserve['inventory'] = $inventory;
				} else {
					$readonly[$tabs]['financial'] = True;
					$readonly[$tabs]['inventory'] = True;
				}

				// Taxes
				$taxes = $this->bo->get_tax_categories($stock_id);
				if(count($taxes)) {
					array_unshift($taxes, false);
					$data['taxes'] = $taxes;
					$select_box_options['tax_authority_id'] = ExecMethod('perp_api.bo_perp_api.get_tax_authorities');
					$select_box_options['tax_category_id'] = ExecMethod('perp_api.bo_perp_api.get_tax_categories');
					$readonly['perp_inventory.stock_edit.pricing.taxes'] = $ro;
				}

				// Pricing
				if($this->orders_installed && $GLOBALS['egw']->acl->check('price_list', EGW_ACL_READ, 'perp_orders')) {
					$sales_categories = $this->bo->get_sales_categories($stock_id);
					$select_box_options['sales_category_id'] = ExecMethod('perp_orders.bo_perp_orders.get_sales_categories');
					$select_box_options['sales_area_id'] = ExecMethod('perp_orders.bo_perp_orders.get_sales_areas');
					$select_box_options['sales_type_id'] = ExecMethod('perp_orders.bo_perp_orders.get_sales_types');

					if(count($sales_categories)) {
						foreach($sales_categories as &$category) {
							$category['data'] = unserialize($category['cat_data']);
						}
						array_unshift($sales_categories, false);
						$data['sales_categories'] = $sales_categories;
						$data['sales_categories']['no_delete_sales_categories'] = $ro;
					}

					if(count($sales_categories)) {
						$pricing = $this->bo->get_pricing($stock_id, $content['pricing']['effective_date']);
					}
					// Set effective date
					if($content['pricing']['effective_date'] && $content[$tabs] == 'perp_inventory.stock_edit.pricing') {
						$pricing['effective_date'] = $content['pricing']['effective_date'];
					} else {
						$pricing['effective_date'] = time();
					}

					// User wants to change prices
					if(array_key_exists('edit_prices', $content)) {
						$preserve['edit_prices'] = $content['edit_prices'];
						if($pricing['effective_date'] < time()) {
							$pricing['effective_date'] = time();
						}
					}

					$data['stock_kit'] = $data['stock_type_flag'] == 'K';

					if(!$pricing[0]) {
						// No current pricing
						$data['no_pricing'] = true;
					} else {
						array_unshift($pricing, 'title');
						$preserve['pricing'] = $pricing;
						$data['pricing'] = $pricing;
					}
					
					$select_box_options['new_sales_category'] = array('' => lang('Select')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_categories');

					if(!$GLOBALS['egw']->acl->check('price_list', EGW_ACL_EDIT, 'perp_orders')) {
						$readonly['sales_categories'] = true;
					} else {
						$readonly['save'] = false;
					}
					$readonly['economic_order_quantity'] = $ro;
					$readonly['edit_prices'] = !$GLOBALS['egw']->acl->check('price_list', EGW_ACL_EDIT, 'perp_orders') || $data['stock_type_flag'] == 'K' || $data['no_pricing'];
					$readonly['perp_inventory.stock_edit.pricing.row'] = !$GLOBALS['egw']->acl->check('price_list', EGW_ACL_EDIT, 'perp_orders') || 
						($pricing['effective_date'] < time()) || $data['stock_type_flag'] == 'K';
					
					// Turn off editable prices until user clicks 'Edit' button
					$readonly['perp_inventory.stock_edit.pricing.row'] = !$content['edit_prices'] || $readonly['perp_inventory.stock_edit.pricing.row'];
				} else {
					$readonly[$tabs]['pricing'] = true;
				}
			} else {
				// Disable all tabs other than details
				foreach(explode('|', $tabs) as $tab) {
					$readonly[$tabs][$tab] = True;
				}
				$readonly[$tabs]['details'] = False;
			}

			// Defaults

			if(!$data['status_flag']) {
				$data['status_flag'] = $this->config['default_stock_status'];
			}
			if(!$data['stock_type_flag']) {
				$data['stock_type_flag'] = $this->config['default_stock_type'];
			}
			if(!$data['stock_category']) {
				$data['stock_category'] = $this->config['default_stock_category'];
			}

			

			// Select box options
			$select_box_options['status_flag'] = ExecMethod('perp_inventory.bo_perp_stock.get_status_flags');
			// Don't allow retired for items in inventory
			if(isset($inventory['total']) && $inventory['total'] > 0 && $data['status_flag'] != 'R') {
				unset($select_box_options['status_flag']['R']);
			}
			$select_box_options['stock_type_flag'] = ExecMethod('perp_inventory.bo_perp_stock.get_stock_types');
			$select_box_options['unit_of_measure'] = $select_box_options['our_unit_of_measure'] = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures');
			$select_box_options['controlled'] = array(0 => lang('No'), 1 => lang('Batched'), 2 => lang('Serialized'));
			$select_box_options['serial_setup'] = array(
				lang('Supplier') => array(
				bo_perp_stock::SERIAL_ALWAYS		=>	lang('Track through system (receiving -> shipped)'),
				bo_perp_stock::SERIAL_WHEN_NEEDED	=>	lang('Only ask when needed')
			));
			if($GLOBALS['egw_info']['apps']['perp_manufacturing']) {
				$select_box_options['serial_setup'] += array(
					lang('pERP generates serial number')	=>	ExecMethod('perp_manufacturing.bo_perp_manufacturing.get_serial_setup')
				);
			}

			//barcodes
			$select_box_options['encoding'] = perp_barcode::get_encoding_list();
			$select_box_options['ship_uom'] = $select_box_options['unit_of_measure'];
			$select_box_options['work_center'] = array('' => lang('Select')) + ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center_list');
			$select_box_options['location'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$select_box_options['value'] = ExecMethod('perp_manufacturing.bo_perp_build_option.get_allowed_option_value_list');
			unset($select_box_options['option_status']['']);

			// Default new stock number
			if ($_GET['new']) {
				$data['stock_num'] = $this->bo->suggest_stock_number($data);
			}

			// Readonlys
			$readonly['preferred'] = !$GLOBALS['egw']->acl->check('catalog', EGW_ACL_EDIT, 'perp_ap');
			$readonly['stock_num'] = !($this->config['allow_stock_number_changes'] == 2 && !$stock_id || $this->config['allow_stock_number_changes'] == 3);

			$preserve['stock_num'] = $data['stock_num'];
			$preserve['stock_id'] = $stock_id;

			// ajax
			$GLOBALS['egw_info']['flags']['include_xajax'] = True;

			// JavaScript
			if(!is_object($GLOBALS['egw']->js)) {
				$GLOBALS['egw']->js =& CreateObject('phpgwapi.javascript');
			}
			$change_status_link = $GLOBALS['egw']->link('/index.php', 
				array(
					'menuaction'	=>	'perp_inventory.ui_perp_stock.change_stock_status',
					'stock_id'	=>	$stock_id
				)
			);
			
			$GLOBALS['egw']->js->set_onload("link='$change_status_link'; stock_edit_setup(); ");
			$GLOBALS['egw']->js->set_onload("supplier_link='" . $GLOBALS['egw']->link('/index.php', 
				array(
					'menuaction'	=>	'perp_ap.ui_perp_catalog.edit'
				)
			) . "'; ");
			$GLOBALS['egw']->js->validate_file('stock', 'edit', 'perp_inventory');

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}
			
			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = $stock_id ? lang('Edit Stock Item %1', $data['stock_num']) : lang('New Stock Item');
			$this->template->read('perp_inventory.stock_edit');
			$this->template->exec('perp_inventory.ui_perp_stock.stock_edit', $data, $select_box_options, $readonly, $preserve, ($_GET['popup'] ? 2 : 0));
		}

		/** 
		*	Get stock list for stock_list, above
		*	This is in the UI so preferences can be saved
		*/
		public function get_stock_list(&$query, &$rows, &$readonlys) {
			$GLOBALS['egw']->session->appsession('stock_list', 'perp_inventory', $query);
			if($query['cat_id'] != $GLOBALS['egw_info']['user']['preferences']['perp_inventory']['stock_category']) {
				$GLOBALS['egw']->preferences->add('perp_inventory', 'stock_category', $query['cat_id']);
				$GLOBALS['egw']->preferences->save_repository(true);
			}


			if($query['filter2'] != $GLOBALS['egw_info']['user']['preferences']['perp_inventory']['stock_status']) {
				$GLOBALS['egw']->preferences->add('perp_inventory', 'stock_status', $query['filter2']);
				$GLOBALS['egw']->preferences->save_repository(true);
			}

			return $this->bo->get_stock_list($query, $rows, $readonlys);
		}

		public function cost_details($content = array()) {

			$edit = $GLOBALS['egw']->acl->check('inventory', EGW_ACL_EDIT, 'perp_inventory');
			$stock_id = $content['stock_id'] ? $content['stock_id'] : $_GET['stock_id'];

			// Incoming
			if(isset($content['save'])) {
				$this->bo->set_cost_details($content['stock_id'], $content['nm']['rows']);
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_inventory.ui_perp_stock.stock_edit', 'stock_id'=>$stock_id));
			}

			// Outgoing
			$data = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
			$data['nm'] = array(
				'stock_id'	=>	$stock_id,
				'stock_type_flag'	=>	$data['stock_type_flag'] == 'R',
				'no_cat'        =>      True,
				'no_filter'     =>      True,
			//	'filter_label'  =>      'Stock Category',
			//	'filter_no_lang'        =>      True,
				'no_filter2'    =>      True,
			//	'filter2_label' =>      'Status',
			//	'filter2_no_lang'       =>      True,
				'get_rows'      =>      'perp_inventory.bo_perp_stock.get_cost_details',
				'template'      =>      'perp_inventory.stock_edit.financial.cost.row',
			//	'header_left'   =>      'ledger.reconcile.start_date',
			//	'header_right'  =>      'ledger.reconcile.end_date',
			);
			
			$preserve['stock_id'] = $stock_id;

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Cost Details') . ' - ' . $this->bo->link_title($stock_id);
			$this->template->read('perp_inventory.stock_cost_details');
			$this->template->exec('perp_inventory.ui_perp_stock.cost_details', $data, $select_box_options, $readonly, $preserve);
		}

		public function change_stock_status($content = array()) {
			$stock_id = $content['stock_id'] ? $content['stock_id'] : $_GET['stock_id'];
			$new_status = $content['new_status'] ? $content['new_status'] : $_GET['new_status'];

			if(!$GLOBALS['egw']->acl->check('stock', EGW_ACL_EDIT, 'perp_inventory')) {
				echo lang('Access not allowed');
				return false;
			}

			if(isset($content['save'])) {
				$this->bo->change_status($stock_id, $content['old_status'], $new_status, $content['replacement']);
				if(!is_object($GLOBALS['egw']->js)) {
					$GLOBALS['egw']->js =& CreateObject('phpgwapi.javascript');
				}

				// Click the save button on the parent, close the popup
				$GLOBALS['egw']->js->set_onload("
					window.opener.document.getElementById('exec[save]').click();
					self.close();
				");
			}

			$stock = $this->bo->get_stock_item($stock_id);

			$data['stock_id'] = $stock_id;
			$data['old_status'] = $stock['status_flag'];

			$select_box_options['old_status'] = $this->bo->get_status_flags();
			$select_box_options['new_status'] = $this->bo->get_status_flags();

			$readonly['stock_id']['search'] = true;

			$preserve['stock_id'] = $stock_id;
			$preserve['old_status'] = $stock['status_flag'];

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Change Stock Status');
			$this->template->read('perp_inventory.change_stock_status');
			$this->template->exec('perp_inventory.ui_perp_stock.change_stock_status', $data, $select_box_options, $readonly, $preserve, 2);
		}

		/**
		*	Set up the shipping tab
		*/
		protected function setup_shipping_tab(&$data) {
			$data['packages'] = $this->bo->get_shipping_packages($data['stock_id']);
			$data['package_count'] = count($data['packages']);
			array_unshift($data['packages'], false);

			$volume_cm = $data['ship_length'] * $data['ship_width'] * $data['ship_height'];
			$data['ship_volume_m'] = sprintf("%.2f", $volume_cm * pow(10, -6));
			$data['ship_volume_ft'] = sprintf("%.2f", $volume_cm * 3.53146667 * pow(10,-5));
		}

		/**
		*	Set up the Bill of Materials tab
		*/
		protected function setup_bill_of_materials_tab(&$data, &$selects, &$readonly) {
			$bo_bom =& CreateObject('perp_manufacturing.bo_perp_bill_of_material');
			
			// Find out where this item is used, if anywhere
			$used_by = $bo_bom->get_used_by($data['stock_id']);
			$data['used_by'] = array(
				'get_rows'	=>	'perp_manufacturing.bo_perp_bill_of_material.get_used_by_list',
				'template'	=>	'perp_inventory.stock_edit.bill_of_material.row',
				'order'		=>	'perp_bill_of_material.bill_of_material_id',
				'default_cols'	=>	'perp_bill_of_material.bill_of_material_id,perp_stock.stock_num',
				'selectcols'	=>	$GLOBALS['egw_info']['user']['preferences']['perp_inventory']['nextmatch-perp_inventory.stock_edit.bill_of_material.row'],
				'stock_id'	=>	$data['stock_id'],
				'cat_app'	=>	'perp_inventory',
				'filter2_label'	=>	'Status',
				'options-filter2'	=>	$bo_bom->get_bill_of_material_status_list(),
				'filter2'	=>	'current',
				'no_filter'	=>	true
			);

			if($data['stock_type_flag'] == 'R') {
				$data['bill_of_material_edit'] = false;
				$data['bill_of_material_new'] = false;
				$data['bill_of_material_id'] = null;
			} else {
				$bill_of_material_id = $this->bo->get_current_bom($data['stock_id']);
				if($bill_of_material_id) {
					$data['bill_of_material'] = $bo_bom->get_bill_of_material($bill_of_material_id);
				} 
				$query = array(
					'stock_id'	=>	$data['stock_id'],
					'order'		=>	'effective_after_date',
					'sort'		=>	'DESC'
				);
				$count = $bo_bom->get_bill_of_material_list($query, $data['bill_of_material']['bom_list']);
				if($count > 0) {
					// Make room for headings
					array_unshift($data['bill_of_material']['bom_list'], false);
					$data['bill_of_material_list'] = true;
				}

				$data['bill_of_material_edit'] = $bill_of_material_id && $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_EDIT, 'perp_manufacturing') && $GLOBALS['egw']->acl->check('run', EGW_ACL_READ, 'perp_manufacturing');
				$data['bill_of_material_new'] = !$bill_of_material_id && $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_EDIT, 'perp_manufacturing') && $GLOBALS['egw']->acl->check('run', EGW_ACL_READ, 'perp_manufacturing');
				$data['bill_of_material_id'] = $bill_of_material_id;
			}
		
			if(!(count($used_by) || $count)) {
				$readonly[$tabs]['bill_of_material'] = True;
			}
		}

		/**
		*	Set up the workflow select
		*/
		protected function setup_workflow(&$tabs, &$data, &$options, &$readonly) {
			if(isset($GLOBALS['egw_info']['apps']['workflow'])) {
				$workflow_process = ExecMethod('perp_manufacturing.bo_perp_workflow.get_process_id', $data['stock_id']);
				$workflow =& CreateObject('workflow.workflow_processmanager');
			}

			if(!$workflow || $data['stock_type_flag'] != 'A') {
				return;
			}

			$data['workflow_process'] = $workflow_process;

			$option_list = array('' => lang('none'));
			$process_list = $workflow->list_processes(0, -1, 'wf_last_modif`', false, "wf_is_active='y'" );
			foreach($process_list['data'] as $process) {
				$option_list[$process['wf_p_id']] = $process['wf_name'] . ' ' . $process['wf_version'];
			}
			$options['workflow_process'] = $option_list;
		}
	}
?>
