<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_inventory.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_location.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_stock.inc.php');

	/**
	*	Shows inventory by location.
	*	
	*	This report contains one line per stock item, and one column per location.  Columns show
	*	quantity available, with one grand total column and one total column per main location.
	*/

	class inventory_location extends perp_report {

		public function __construct(array $parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_inventory';
			parent::perp_report($parameters);
			$this->template = 'inventory_location.ods';

			$this->parameters = $parameters;
		}

		public function get_data($query = array()) {

			$inventory_bo = new bo_perp_inventory();
			$location_bo = new bo_perp_location();
			$stock_bo = new bo_perp_stock();

			$location_bo->get_location_list(
				array(
					'template'	=>	false
				),
				$location_list
			);

			$stock_bo->get_stock_list(
				array(
					'template'	=>	false,
					'num_rows'	=>	-1,
					'order'		=>	'stock_category, stock_num',
					'selectcols'	=>	'stock_num,short_description,unit_of_measure,stock_category'
				),
				$stock_list
			);

			$stock_categories = $inventory_bo->get_stock_categories();
			$unit_of_measure = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures');

			// Data
			$grid = array();
			
			foreach($stock_list as $row => $stock_item) {
				if(!is_array($stock_item)) {
					continue;
				}
				$stock_item['stock_category_name'] = trim($stock_categories[$stock_item['stock_category']], '&nbsp;');
				$stock_item['unit_of_measure_name'] = $unit_of_measure[$stock_item['unit_of_measure']];
				foreach($location_list as $location) {
					$inventory_bo->get_inventory(
						array(
							'template'	=>	false,
							'location_id'	=>	$location['location_id'],
							'stock_id'	=>	$stock_item['stock_id'],
						),
						$inventory
					);
					if(count($inventory) == 1) {
						$stock_item[$location['location_id']] = $inventory[0];
					}
					$parent_location_id = ($location['location_parent'] != 0 ? $location['location_parent'] : $location['location_id']);
					$stock_item[$parent_location_id]['location_total'] += $stock_item[$location['location_id']]['quantity_in_stock'];
					$stock_item['total'] += $stock_item[$location['location_id']]['quantity_in_stock'];
				}
				$grid[$row] = $stock_item;
			}

			$data = array(
				'location0,location1'	=>	$location_list,
				'stock'		=>	$grid,
			);

			$this->filename = lang('Inventory %1', 
				date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], time())
			);

			return $data;
		}
	}
?>
