<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_inventory.inc.php');

	/**
	*	Worksheet for counting stock at various locations
	*/
	class stock_count extends perp_report {

		public function __construct(array &$parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_inventory';
			parent::perp_report($parameters);

			$this->template = 'stock_count.ods';

			$this->parameters = $parameters;

			if($_GET['count_id']) {
				$this->parameters['count_id'] = $_GET['count_id'];
				$parameters['generate_report'] = true;
			}
		}

		public function get_data($query = array()) {
			$count_id = isset($query['count_id']) ? $query['count_id'] : $this->parameters['count_id'];
			if(!$count_id && $_GET['count_id']) {
				$count_id = $_GET['count_id'];
			}
			if(!$count_id) {
				echo 'Could not find count ID';
				die();
			}

			$bo_count = new bo_perp_count();
			$count = $bo_count->get_count($count_id);

			$data = array(
				'stock_code'	=>	lang('stock code'),
				'description'	=>	lang('description'),
				'counted_by'	=>	lang('counted by'),
				'checked_by'	=>	lang('checked by'),
				'expected'	=>	lang('expected'),
				'counted'	=>	lang('counted'),
				'note'		=>	lang('note'),
				'sheet'	=>	array(),
			);

			$sheet_query = array(
				'count_id'	=>	$count_id,
				'num_rows'	=>	-1
			);
			$bo_count->get_sheet_list($sheet_query, $data['sheet']);

			foreach($data['sheet'] as &$sheet) {
				$location_name = ExecMethod('perp_inventory.bo_perp_location.link_title', $sheet['location_id']);
				$sheet['title'] = lang('Inventory Count #%1 %2 - %4 - Sheet #%3',
					$sheet['count_id'],
					date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $count['count_date']),
					$sheet['sheet_id'],
					$location_name
				);
				$details = $bo_count->get_sheet($sheet['sheet_id']);
				$data['stock' . $sheet['sheet_id']] = $details['details'];
			}

			$this->filename = lang('Inventory Count #%1 %2', $count_id, date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $count['count_date']));
			return $data;
		}
	}
?>
