

// JavaScript for editing a Stock item

// Link and popup are set in inventory/inc/class.ui_perp_stock.stock_edit
var supplier_link = null;
var link = null;
var popup = null;

// These values are calculated, not entered
var ship_dimensions = new Array();

// Called on_load
function stock_edit_setup() {
	// Set up stock number suggesting
	var stock_category = document.getElementById('exec[stock_category]');
	if(stock_category) {
		if(stock_category.addEventListener) {
			stock_category.addEventListener('change', suggest_stock_number, true);
		} else {
			stock_category.onchange = suggest_stock_number;
		}
	}

	// If stock_num is disabled, it won't get submitted.  We need to send it back.
	var stock_num = document.getElementById('exec[stock_num]');
	var save = document.getElementById('exec[save]');
	if(save && stock_num && stock_num.disabled == true) {
		if(save.addEventListener) {
			save.addEventListener('click', enable_stock_code, true);
		} else {
			save.onclick = enable_stock_code;
		}
	}

	// Set up shipping dimension calculating
	var inputs = document.getElementsByTagName("INPUT");
	for(var i = 0; i < inputs.length; i++) {
		if(inputs[i].id.indexOf("exec[packages]") != 0) {
			continue;
		}
		inputs[i].style.textAlign='right';
		if(inputs[i].id.indexOf("volume") > 0) {
			inputs[i].disabled = true;
		} else {
			ship_dimensions[ship_dimensions.length] = inputs[i];
		}
	}

	for(var i = 0; i < ship_dimensions.length; i++) {
		if(ship_dimensions[i]) {
			if(ship_dimensions[i].addEventListener) {
				ship_dimensions[i].addEventListener('change', change_dimension, true);
			} else {
				ship_dimensions[i].onchange = change_dimension;
			}
		}
	}

	// Status
	var status = document.getElementById('exec[status_flag]');
	if(status) {
		if(status.addEventListener) {
			status.addEventListener('change', change_status, true);
			status.addEventListener('change', suggest_stock_number, true);
		} else {
			status.onchange = function() {change_status; suggest_stock_number}
		}
	}
}

function change_dimension(e) {
	if(!e) {
		var e = window.event
	}
	if(e.target) {
		var base_name = e.target.id.substr(0,"exec[packages][x]".length);
	} else if (e.srcElement) {
		var base_name = e.srcElement.id.substr(0,"exec[packages][x]".length);
	} else {
		return;
	}

	// Expecting units of cm
	var length = document.getElementById(base_name + '[length]').value;
	var width = document.getElementById(base_name + '[width]').value;
	var height = document.getElementById(base_name + '[height]').value;

	var volume_m = length * width * height;	// m^3
	volume_m = volume_m.toFixed(2);
	//volume_ft = volume_ft.toFixed(1);
	
	document.getElementById(base_name + '[volume_m]').value = volume_m;
}

function change_status() {
	var status = document.getElementById('exec[status_flag]');
	if(!status) {
		return;
	}

	if(status.value == 'D' || status.value == 'R') {
		popup = window.open(link, '_blank','dependent=yes,width=600,height=500,scrollbars=yes,status=yes');
		window.setTimeout('var new_status = popup.document.getElementById(\'exec[new_status]\');if(new_status) {new_status.value = \'' + status.value + '\';} else { popup.document.bgColor = \'lightblue\';}', 2000);
		popup.onload = onload;
	}
}

function suggest_stock_number() {
	var stock_id = document.getElementById('stock_id');
	var stock_category = document.getElementById('exec[stock_category]');
	var status = document.getElementById('exec[status_flag]');
	var stock_num = document.getElementById('exec[stock_num]');
	xajax_doXMLHTTP("perp_inventory.ajax_perp_stock.suggest_stock_number", stock_id.value, stock_category.value, status.value);
}

function add_supplier() {
	var new_supplier = document.getElementById('exec[new_supplier][value]');
	var url = supplier_link + '&supplier_id=' + new_supplier.value;
	var add_supplier = window.open(url, 'add_supplier','width=550,height=400,resizable=1,scrollbars=yes');
	return false;
}

function enable_stock_code() {
	document.getElementById('exec[stock_num]').disabled = false;
}

/**
*	If the user sets one option in an option category to 'Required', that means that all the others are
*	'Not allowed', so we set them as such.
*/
function check_required_option(element) {

	var REQUIRED = -1;
	var NOT_ALLOWED = 0;

	if(element.value != REQUIRED) {
		return;
	}

	var category_key = '[build_option_category_name]';
	var value_key = 'exec[options][rows][%1][value]';

	var row_base_id = element.id.substr(0,element.id.lastIndexOf('[') - 1);
	var row_number = row_base_id.substr(row_base_id.lastIndexOf('[') + 1, row_base_id.length - 1);
	var category_id = row_number + category_key;
	var category = document.getElementById(category_id).innerHTML;

	var lines_to_change = new Array();

	// Look up for other lines
	var check_line = row_number;
	var check_category = '';
	do {
		check_line--;
		check_category = document.getElementById(check_line + category_key);
		if(check_category && check_category.innerHTML == category) {
			lines_to_change.push(check_line);
		}
	} while(check_category && check_category.innerHTML == category);

	// Look down for other lines
	check_line = row_number;
	check_category = '';
	do {
		check_line++;
		check_category = document.getElementById(check_line + category_key);
		if(check_category && check_category.innerHTML == category) {
			lines_to_change.push(check_line);
		}
	} while(check_category && check_category.innerHTML == category);

	// Change all the other rows to 'Not allowed'
	var change_element = null;
	for(var i = 0; i < lines_to_change.length; i++) {

		change_element = document.getElementById(value_key.replace('%1', lines_to_change[i]));
		change_element.style.backgroundColor = 'green';
		change_element.value = NOT_ALLOWED;
		animate_change_highlight(change_element, 0, 255, 3, 50, 1);
	}
}

/**
*	Animate a hightlight that illustrates that a field has been changed automatically
*
*	@see http://www.hesido.com/web.php?page=javascriptanimation
*	@param element that is going to be animated
*	@param start_width Starting width of the border
*	@param end_width Ending width of the border
*	@param steps How many frames in the animation
*	@param intervals How long between frames
*	@param power A smoothing factor
*/
function animate_change_highlight(element, start_width, end_width, steps, intervals, power) {
	if(element.change_highlight) {
		window.clearInterval(element.change_highlight);
	}
	var act_step = 0;
	element.change_highlight = window.setInterval(
		function() {
			var change = ease_in_out(start_width, end_width, steps, act_step, power);
			element.style.backgroundColor = 'rgb(' + change + ',255,' + change + ')';
			act_step++;
			if(act_step > steps) {
				window.clearInterval(element.change_highlight);
			}
		},
		intervals
	);
}

/**
*	Code that smooths animation
*/
function ease_in_out(minValue,maxValue,totalSteps,actualStep,powr) { 
	//Generic Animation Step Value Generator By www.hesido.com 
	var delta = maxValue - minValue; 
	var stepp = minValue+(Math.pow(((1 / totalSteps) * actualStep), powr) * delta); 
	return Math.ceil(stepp) 
} 

