
// Javascript for stock select widget

var widget_id;
var row_swap_temp; 

function stock_select_setup(w_id, dom, onchange, query) {
	widget_id = w_id;
	
	if(onchange) {
		var value = document.getElementById(widget_id + '[stock_id]');
		if(value) {
			if(value.addEventListener) {
				value.addEventListener('change', function() {
					submitit(this.form, 'change');
				}, true);
			} else {
				var old = (value.onchange) ? value.onchange : function () {};
				value.onchange = function() {
					old();
					submitit(this.form, 'change');
				};
			}
		}
	}
	
	var widget = document.getElementById(widget_id + '[stock_num]');
	if(widget) {
		widget.disableautocomplete = true;
		widget.showpopup = false;
		if(widget.addEventListener) {
			widget.addEventListener('keyup', change, true);
			if(dom) {
				widget.addEventListener('blur', hideBox, false);
			}
		} else {
			widget.onkeyup = change;
			if(dom) {
				widget.onblur = hideBox;
			}
		}

		if(dom) {
			var options = document.createElement('div');
			options.id = widget_id + '[options]';
			options.className = 'resultBox';
			options.style.top = widget.style.top + widget.style.height;
			options.style.position = 'absolute';
			options.style.border='1px solid black';
			options.style.padding = '1px';
			options.style.display='none';
			options.style.backgroundColor = 'white';
			options.style.zIndex = 50;
			options.query = query;
			options.innerHTML = "Search Results<br />Multiline";

			document.getElementById(widget_id + '[stock_id]').style.display = 'none';
			document.getElementById(widget_id + '[search]').style.display = 'none';
			widget.parentNode.appendChild(options);
		} else {
			document.getElementById(widget_id + '[stock_id]').query = query;
		}			
	}
}

function change(e, value) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		} 
		var id = target.id;
		var value = target.value;
	} else if (e) {
		var id = e;
		if(value) {
			var value = value;
		} else {
			var value = e.value;
		}
		var set_id = id.substr(0, id.lastIndexOf('['));
	}

	var base_id = id.substr(0, id.lastIndexOf('['));
	if(document.getElementById(base_id + '[options]')) {
		set_id = base_id + '[options]'; 
	} else {
		set_id = base_id + '[stock_id]';
	}

	var query = document.getElementById(set_id).query;
	query.filter = document.getElementById(base_id + '[filter]').value;

	// Hide selectboxes for IE
	if(document.all) {
		var selects = document.getElementsByTagName('select');
		for(var i = 0; i < selects.length; i++) {
			selects[i].style.visibility = 'hidden';
		}
	}
	xajax_doXMLHTTP("perp_inventory.ajax_perp_stock_select.change", id, value, set_id, query);
}


/* Remove options from a select box
*  @param id - The id of the select
*/
function removeOptions(id) {
	if(document.getElementById(id)) {
		var element = document.getElementById(id);
		if(element.options) {
			while(element.options.length > 0) {
				element.remove(0);
			}
		} else if (element.tagName == 'DIV') {
			element.innerHTML = '';
		}
	}
}

/* Add an option to a select box
*  @param id - The id of the select box
*  @param key - The key of the option
*  @param value - The value of the option
*/
function addOption(id, key, value) {
	var objOption = new Option(value, key);
	var select = document.getElementById(id);
	if(select) {
		if(select.options || select.tagName == 'SELECT') {
			try {
				select.options.add(objOption); // standards compliant
			} catch (ex) {
				select.add(objOption); // IE
			}
		} else if (select.tagName == 'DIV') {
			var base_id = select.id.substr(0, select.id.lastIndexOf('['));
			set_id = base_id +  '[stock_id]';
			set_num = base_id + '[stock_num]';

			select.style.display = 'block';
			var option = document.createElement('div');

			option.style.display = 'block';
			option.style.padding = '5px';
			option.className = (select.childNodes.length % 2) ? 'row_on' : 'row_off';
			if(key) {
				option.stock_id = document.getElementById(set_id);
				option.stock_num = document.getElementById(set_num);
				option.value = new Object();
				option.value.key = key;
				option.value.value = value;


				option.innerHTML = value ;
				// when they click, add that item to the stock_id selectbox
				if(option.addEventListener) {
					option.addEventListener('mouseover', function() {row_swap_temp = this.className; this.className='th';}, true);
					option.addEventListener('mouseout', function() {this.className = row_swap_temp;}, true);
					option.addEventListener('click', select_stock, true);
				} else {
					option.onmouseover = function () {row_swap_temp = this.className; this.className='th'};
					option.onmouseout = function () {this.className=row_swap_temp};
					option.onclick = select_stock;
				}
			} else {
				option.innerHTML += value + "<br />";
			}
			select.appendChild(option);
		}
	}
}

function select_stock(e) {
	// when they click, add that item to the stock_id selectbox & call onchange()
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		} 
	}

	addOption(target.stock_id.id, target.value.key, target.value.value);
	target.stock_num.value = target.value.value;
	target.stock_id.value = target.value.key;
	try {
		target.stock_id.onchange();
	} catch (err) {
		//no onchange;
		var event = document.createEvent('HTMLEvents');
		event.initEvent('change', true, true);
		target.stock_id.dispatchEvent(event);
	}
}

function hideBox(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		} 
	}
	var set_id = target.id.substr(0, target.id.lastIndexOf('[')) + '[options]';
	setTimeout("document.getElementById('" + set_id + "').style.display = 'none'", 200);
	var selects = document.getElementsByTagName('select');

	// Un-hide select boxes for IE
	if(document.all) {
		for(var i = 0; i < selects.length; i++) {
			selects[i].style.visibility = 'visible';
		}
	}
}
