<?php
	/**************************************************************************\
	* pERP - Setup                                                             *
	* http://pERP.org                                                          *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


$phpgw_baseline = array(
	'perp_stock' => array(
		'fd' => array(
			'stock_id' => array('type' => 'auto','nullable' => False),
			'stock_category' => array('type' => 'int','precision' => '4','nullable' => False),
			'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'long_description' => array('type' => 'text'),
			'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
			'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
			'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
			'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
			'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
			'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_setup' => array('type' => 'int','precision' => '4'),
			'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
			'stock_num' => array('type' => 'varchar','precision' => '20'),
			'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
			'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
			'country_of_origin' => array('type' => 'varchar','precision' => '2'),
			'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
			'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
			'international_code' => array('type' => 'varchar','precision' => '7'),
			'ship_notes' => array('type' => 'text'),
			'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
			'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
		),
		'pk' => array('stock_id'),
		'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','serial_setup' => 'perp_serial_setup.setup_id'),
		'ix' => array('stock_id'),
		'uc' => array('stock_id','stock_num')
	),
	'perp_location' => array(
		'fd' => array(
			'location_id' => array('type' => 'auto','nullable' => False),
			'location_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'delivery_address' => array('type' => 'int','precision' => '4'),
			'tax_location' => array('type' => 'int','precision' => '4'),
			'status' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
			'location_parent' => array('type' => 'int','precision' => '4','default' => 'null')
		),
		'pk' => array('location_id'),
		'fk' => array('delivery_address' => 'perp_address.address_id','tax_location' => 'perp_tax_location.tax_location_id','location_parent' => 'perp_location.location_id'),
		'ix' => array('status'),
		'uc' => array('location_name')
	),
	'perp_location_stock' => array(
		'fd' => array(
			'location_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'min_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'max_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'quantity_reserved' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
		),
		'pk' => array('location_id','stock_id'),
		'fk' => array('location_id' => 'perp_location.location_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_location_transfer' => array(
		'fd' => array(
			'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'reference' => array('type' => 'varchar','precision' => '50'),
			'ship_location' => array('type' => 'int','precision' => '4','nullable' => False),
			'receive_location' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('shipment_id'),
		'fk' => array('shipment_id' => 'perp_shipment.shipment_id','ship_location' => 'perp_location.location_id','receive_location' => 'perp_location.location_id'),
		'ix' => array('shipment_id','ship_location','receive_location'),
		'uc' => array('shipment_id')
	),
	'perp_stock_serial' => array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'location_id' => array('type' => 'int','precision' => '4'),
			'stock_cost_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('stock_id','serial_number'),
		'fk' => array('stock_id' => 'perp_stock.stock_id','work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','location_id' => 'perp_location.location_id','stock_cost_id' => 'perp_stock_cost.stock_cost_id'),
		'ix' => array('stock_id','serial_number','work_order_id','location_id'),
		'uc' => array()
	),
	'perp_fifo_costing' => array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'location' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_cost_id' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array(),
		'fk' => array('stock_id' => 'perp_stock.stock_id','location' => 'perp_location.location_id','stock_cost_id' => 'perp_stock_cost.stock_cost_id'),
		'ix' => array('stock_id','stock_cost_id'),
		'uc' => array()
	),
	'perp_location_gl_account' => array(
		'fd' => array(
			'location_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
			'work_in_progress_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
			'shrinkage_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('location_id','stock_category_id'),
		'fk' => array('location_id' => 'perp_location.location_id','stock_category_id' => 'perp_stock_category.stock_category_id','stock_gl_account' => 'perp_account.account_id','work_in_progress_gl_account' => 'perp_account.account_id','shrinkage_gl_account' => 'perp_account.account_id'),
		'ix' => array('location_id','stock_category_id'),
		'uc' => array()
	),
	'perp_stock_tax_category' => array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'tax_category_id' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('stock_id','tax_authority_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id','tax_authority_id' => 'perp_tax_authority.tax_authority_id','tax_category_id' => 'perp_tax_category.tax_category_id'),
		'ix' => array('stock_id','tax_authority_id'),
		'uc' => array(array('stock_id','tax_authority_id'))
	),
	'perp_stock_cost' => array(
		'fd' => array(
			'stock_cost_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'date' => array('type' => 'timestamp','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
		),
		'pk' => array('stock_cost_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array('stock_cost_id')
	),
	'perp_stock_ship_package' => array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
			'length' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'width' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'height' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'mass' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0.1')
		),
		'pk' => array(),
		'fk' => array('stock_id' => 'perp_stock.stock_id','unit_of_measure' => 'perp_unit_of_measure.uom_id'),
		'ix' => array('stock_id'),
		'uc' => array()
	),
	'perp_stock_barcode' => array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4'),
			'barcode' => array('type' => 'varchar','precision' => '50'),
			'encoding' => array('type' => 'varchar','precision' => '16','nullable' => False,'default' => 'C128B'),
			'preferred' => array('type' => 'bool','nullable' => False,'default' => 'false')
		),
		'pk' => array('stock_id','barcode'),
		'fk' => array('stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_move' => array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'timestamp' => array('type' => 'timestamp','nullable' => False),
			'from_location_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'to_location_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'move_type' => array('type' => 'int','precision' => '1','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'narrative' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array(),
		'fk' => array('stock_id' => 'perp_stock.stock_id','from_location_id' => 'perp_location.location_id','to_location_id' => 'perp_location.location_id'),
		'ix' => array('stock_id','from_location_id','to_location_id'),
		'uc' => array()
	),
	'perp_stock_count_sheet' => array(
		'fd' => array(
			'count_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'sheet_id' => array('type' => 'auto','nullable' => False),
			'counted_by' => array('type' => 'varchar','precision' => '100','nullable' => False),
			'checked_by' => array('type' => 'varchar','precision' => '100'),
			'location_id' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('sheet_id'),
		'fk' => array('count_id' => 'perp_stock_count.count_id','location_id' => 'perp_location.location_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_count' => array(
		'fd' => array(
			'count_id' => array('type' => 'auto','nullable' => False),
			'count_date' => array('type' => 'timestamp','nullable' => False),
			'supervisor' => array('type' => 'int','precision' => '4','nullable' => False),
			'finish_date' => array('type' => 'timestamp'),
			'count_by' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '0'),
			'notes' => array('type' => 'text')
		),
		'pk' => array('count_id'),
		'fk' => array('supervisor' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_count_detail' => array(
		'fd' => array(
			'sheet_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'expected' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'count' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'unit_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
		),
		'pk' => array('sheet_id','stock_id'),
		'fk' => array('sheet_id' => 'perp_stock_count_sheet.sheet_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_damage' => array(
		'fd' => array(
			'stock_history_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_damaged' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'discount_percent' => array('type' => 'decimal','precision' => '6','scale' => '4','nullable' => False)
		),
		'pk' => array('stock_history_id'),
		'fk' => array('stock_history_id' => 'perp_stock_history.stock_history_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_history' => array(
		'fd' => array(
			'history_id' => array('type' => 'auto','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'timestamp' => array('type' => 'timestamp','nullable' => False),
			'comment' => array('type' => 'text','nullable' => False),
			'link_app' => array('type' => 'varchar','precision' => '25'),
			'link_id' => array('type' => 'varchar','precision' => '50')
		),
		'pk' => array('history_id'),
		'fk' => array('stock_id' => 'perp_stock_serial.stock_id','serial_number' => 'perp_stock_serial.serial_number'),
		'ix' => array('stock_id'),
		'uc' => array()
	),
	'perp_stock_count_serial' => array(
		'fd' => array(
			'sheet_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'serial_number' => array('type' => 'varchar','precision' => '20'),
			'quantity_expected' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '1'),
			'count' => array('type' => 'decimal','precision' => '20','scale' => '3')
		),
		'pk' => array('sheet_id','stock_id','serial_number'),
		'fk' => array('sheet_id' => 'perp_stock_count_detail.sheet_id','stock_id' => 'perp_stock_count_detail.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_serial_pattern' => array(
		'fd' => array(
			'serial_pattern_id' => array('type' => 'auto','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'pattern' => array('type' => 'varchar','precision' => '255','nullable' => False)
		),
		'pk' => array('serial_pattern_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array('serial_pattern_id')
	),
	'perp_stock_gl_account' => array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'account_use' => array('type' => 'int','precision' => '1','nullable' => False),
			'gl_account' => array('type' => 'varchar','precision' => '7','nullable' => False)
		),
		'pk' => array(),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_category' => array(
		'fd' => array(
			'category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'on_hand_gl_account' => array('type' => 'varchar','precision' => '7'),
			'work_in_progress_gl_account' => array('type' => 'varchar','precision' => '7'),
			'shrinkage_gl_account' => array('type' => 'varchar','precision' => '7'),
			'adjustment_gl_account' => array('type' => 'varchar','precision' => '7')
		),
		'pk' => array('category_id'),
		'fk' => array('category_id' => 'egw_categories.cat_id'),
		'ix' => array(),
		'uc' => array()
	)
);
