<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


// Required to force tables to InnoDB
require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.so_perp_api.inc.php');

	$test[] = '0.1.0';
	function inventory_upgrade0_1_0()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_stock_category',array(
			'fd' => array(
				'stock_category_id' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'stock_category_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'adjustment_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'purchase_price_varience_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'usage_variance_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_in_progress_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_category_id'),
			'fk' => array('stock_type' => 'erp_stock_type.stock_type_id','stock_gl_account' => 'erp_account.account_id','adjustment_gl_account' => 'erp_account.account_id','purchase_price_varience_gl_account' => 'erp_account.account_id','usage_variance_gl_account' => 'erp_account.account_id','work_in_progress_gl_account' => 'erp_account.account_id'),
			'ix' => array('stock_category_id','stock_type'),
			'uc' => array('stock_category_id','stock_category_name')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.001';
	}


	$test[] = '0.1.001';
	function inventory_upgrade0_1_001()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('erp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'C'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'volume' => array('type' => 'decimal','precision' => '20','scale' => '4'),
				'mass' => array('type' => 'decimal','precision' => '20','scale' => '4'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'erp_stock_category.category_id','unit_of_measure' => 'erp_unit_of_measure.uom_id','tax_category' => 'erp_tax_category.tax_category_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id')
		),'min_on_hand');
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_stock','serialized',array(
			'type' => 'bool',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.002';
	}


	$test[] = '0.1.002';
	function inventory_upgrade0_1_002()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_location',array(
			'fd' => array(
				'location_id' => array('type' => 'auto','nullable' => False),
				'location_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'address' => array('type' => 'int','precision' => '4'),
				'tax_location' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('location_id'),
			'fk' => array('address' => 'erp_address.address_id','tax_location' => 'erp_tax_location.tax_location_id'),
			'ix' => array('location_id'),
			'uc' => array('location_id','location_name')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.003';
	}


	$test[] = '0.1.003';
	function inventory_upgrade0_1_003()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_location_stock',array(
			'fd' => array(
				'location_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'quantity_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'min_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'max_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('location_id','stock_id'),
			'fk' => array('location_id' => 'erp_location.location_id','stock_id' => 'erp_stock.stock_id'),
			'ix' => array('location_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.004';
	}


	$test[] = '0.1.004';
	function inventory_upgrade0_1_004()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_location_transfer',array(
			'fd' => array(
				'shipment_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'reference' => array('type' => 'varchar','precision' => '50'),
				'ship_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'receive_location' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('shipment_id'),
			'fk' => array('shipment_id' => 'erp_shipment.shipment_id','ship_location' => 'erp_location.location_id','receive_location' => 'erp_location.location_id'),
			'ix' => array('shipment_id','ship_location','receive_location'),
			'uc' => array('shipment_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.005';
	}


	$test[] = '0.1.005';
	function inventory_upgrade0_1_005()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_location_stock','quantity_reserved',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.006';
	}


	$test[] = '0.1.006';
	function inventory_upgrade0_1_006()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_work_order',array(
			'fd' => array(
				'work_order_id' => array('type' => 'auto','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'required_date' => array('type' => 'date','nullable' => False),
				'start_date' => array('type' => 'date'),
				'competed_date' => array('type' => 'date'),
				'sales_order' => array('type' => 'int','precision' => '4'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => '=')
			),
			'pk' => array('work_order_id'),
			'fk' => array('sales_order' => 'erp_sales_order.sales_order_id'),
			'ix' => array('work_order_id','created_date','required_date'),
			'uc' => array('work_order_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.007';
	}


	$test[] = '0.1.007';
	function inventory_upgrade0_1_007()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_work_order','completed',array(
			'type' => 'bool',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.008';
	}


	$test[] = '0.1.008';
	function inventory_upgrade0_1_008()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_work_order_detail',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'cost' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('work_order_id','detail_id'),
			'fk' => array('work_order_id' => 'erp_work_order.work_order_id','stock_id' => 'erp_stock.stock_id'),
			'ix' => array('work_order_id','detail_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.009';
	}


	$test[] = '0.1.009';
	function inventory_upgrade0_1_009()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_work_order_option',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','build_option_id'),
			'fk' => array('work_order_id' => 'erp_work_order_detail.work_order_id','detail_id' => 'erp_work_order_detail.detail_id','build_option_id' => 'erp_build_option.build_option_id'),
			'ix' => array('work_order_id','detail_id','build_option_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.010';
	}


	$test[] = '0.1.010';
	function inventory_upgrade0_1_010()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_build_option',array(
			'fd' => array(
				'build_option_id' => array('type' => 'auto','nullable' => False),
				'build_option_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'build_option_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'effective_after_date' => array('type' => 'date','nullable' => False),
				'effective_to_date' => array('type' => 'date')
			),
			'pk' => array('build_option_id'),
			'fk' => array('build_option_category' => 'erp_build_option_category'),
			'ix' => array('build_option_id','build_option_category','effective_after_date','effective_to_date'),
			'uc' => array('build_option_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.011';
	}


	$test[] = '0.1.011';
	function inventory_upgrade0_1_011()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_build_option_category',array(
			'fd' => array(
				'build_option_category_id' => array('type' => 'auto','nullable' => False),
				'build_option_category_name' => array('type' => 'varchar','precision' => '50','nullable' => False)
			),
			'pk' => array('build_option_category_id'),
			'fk' => array(),
			'ix' => array('build_option_category_id'),
			'uc' => array('build_option_category_id','build_option_category_name')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.012';
	}


	$test[] = '0.1.012';
	function inventory_upgrade0_1_012()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_allowed_build_option',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'value' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'bill_of_materials' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('build_option_id','stock_id'),
			'fk' => array('build_option_id' => 'erp_build_option.build_option_id','stock_id' => 'erp_stock.stock_id','bill_of_materials' => 'erp_bill_of_material.bill_of_material_id'),
			'ix' => array('build_option_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.013';
	}


	$test[] = '0.1.013';
	function inventory_upgrade0_1_013()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_bill_of_material',array(
			'fd' => array(
				'bill_of_material_id' => array('type' => 'auto','nullable' => False),
				'effective_after_date' => array('type' => 'date','nullable' => False),
				'effective_to_date' => array('type' => 'date'),
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'comment' => array('type' => 'text')
			),
			'pk' => array('bill_of_material_id'),
			'fk' => array('stock_id' => 'erp_stock.stock_id'),
			'ix' => array('bill_of_material_id','effective_after_date','effective_to_date','stock_id'),
			'uc' => array('bill_of_material_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.014';
	}


	$test[] = '0.1.014';
	function inventory_upgrade0_1_014()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_bill_of_material_detail',array(
			'fd' => array(
				'bill_of_material_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array('bill_of_material_id','component'),
			'fk' => array('bill_of_material_id' => 'erp_bill_of_material.bill_of_material_id','component' => 'erp_stock.stock_id','work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('bill_of_material_id','component'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.015';
	}


	$test[] = '0.1.015';
	function inventory_upgrade0_1_015()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'bill_of_material_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','bill_of_material_id'),
			'fk' => array('work_order_id' => 'erp_work_order_detail.work_order_id','detail_id' => 'erp_work_order_detail.detail_id','bill_of_material_id' => 'erp_bill_of_material.bill_of_material_id'),
			'ix' => array('work_order_id','detail_id','bill_of_material_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.016';
	}


	$test[] = '0.1.016';
	function inventory_upgrade0_1_016()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_work_center',array(
			'fd' => array(
				'work_center_id' => array('type' => 'auto','nullable' => False),
				'work_center_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_center_id'),
			'fk' => array('location' => 'erp_location.location_id','overhead_account' => 'erp_account.account_id'),
			'ix' => array('work_center_id'),
			'uc' => array('work_center_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.017';
	}


	$test[] = '0.1.017';
	function inventory_upgrade0_1_017()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_work_center_bin',array(
			'fd' => array(
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'capacity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'quantity_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('work_center_id','stock_id'),
			'fk' => array('work_center_id' => 'erp_work_center.work_center_id','stock_id' => 'erp_stock.stock_id'),
			'ix' => array('work_center_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.018';
	}


	$test[] = '0.1.018';
	function inventory_upgrade0_1_018()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_stock_serial',array(
			'fd' => array(
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
			),
			'pk' => array('stock_id','serial_number'),
			'fk' => array('stock_id' => 'erp_stock.stock_id','location' => 'erp_location.location_id'),
			'ix' => array('stock_id','serial_number'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.019';
	}


	$test[] = '0.1.019';
	function inventory_upgrade0_1_019()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_stock_history',array(
			'fd' => array(
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text')
			),
			'pk' => array('stock_id','serial_number','timestamp'),
			'fk' => array('stock_id' => 'erp_stock_serial.stock_id','serial_number' => 'erp_stock_serial.serial_number','work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('stock_id','serial_number','timestamp'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.020';
	}


	$test[] = '0.1.020';
	function inventory_upgrade0_1_020()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_stock_assembly_serial',array(
			'fd' => array(
				'assembly_stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'assembly_serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'component_stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'component_serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False)
			),
			'pk' => array('assembly_stock_id','assembly_serial_number','timestamp'),
			'fk' => array('assembly_stock_id' => 'erp_stock_history.stock_id','assembly_serial_number' => 'erp_stock_history.serial_number','component_stock_id' => 'erp_stock_serial.stock_id','component_serial_number' => 'erp_stock_serial.serial_number','timestamp' => 'erp_stock_history.timestamp'),
			'ix' => array('assembly_stock_id','assembly_serial_number'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.021';
	}


	$test[] = '0.1.021';
	function inventory_upgrade0_1_021()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_stock','status','status_flag');
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_stock','status_flag',array(
			'type' => 'varchar',
			'precision' => '1',
			'nullable' => False,
			'default' => 'E'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.022';
	}


	$test[] = '0.1.022';
	function inventory_upgrade0_1_022()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_location','address','delivery_address');
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_location',array(
			'fd' => array(
				'location_id' => array('type' => 'auto','nullable' => False),
				'location_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'delivery_address' => array('type' => 'int','precision' => '4'),
				'tax_location' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('location_id'),
			'fk' => array('delivery_address' => 'erp_address.address_id','tax_location' => 'erp_tax_location.tax_location_id'),
			'ix' => array('location_id'),
			'uc' => array('location_id','location_name')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.023';
	}


	$test[] = '0.1.023';
	function inventory_upgrade0_1_023()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_work_center_bin','stock_id',array(
			'type' => 'varchar',
			'precision' => '20'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_center_bin','work_center_bin_id',array(
			'type' => 'auto',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_center_bin',array(
			'fd' => array(
				'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'varchar','precision' => '20'),
				'capacity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'quantity_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'work_center_bin_id' => array('type' => 'auto','nullable' => False)
			),
			'pk' => array('work_center_bin_id'),
			'fk' => array('work_center_id' => 'erp_work_center.work_center_id','stock_id' => 'erp_stock.stock_id'),
			'ix' => array('work_center_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.024';
	}


	$test[] = '0.1.024';
	function inventory_upgrade0_1_024()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_stock_category','usage_variance_gl_account','usage_varience_gl_account');
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_stock_category',array(
			'fd' => array(
				'stock_category_id' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'stock_category_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'adjustment_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'purchase_price_varience_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'usage_varience_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_in_progress_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_category_id'),
			'fk' => array('stock_type' => 'erp_stock_type.stock_type_id','stock_gl_account' => 'erp_account.account_id','adjustment_gl_account' => 'erp_account.account_id','purchase_price_varience_gl_account' => 'erp_account.account_id','usage_varience_gl_account' => 'erp_account.account_id','work_in_progress_gl_account' => 'erp_account.account_id'),
			'ix' => array('stock_category_id','stock_type'),
			'uc' => array('stock_category_id','stock_category_name')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.025';
	}


	$test[] = '0.1.025';
	function inventory_upgrade0_1_025()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_bill_of_material_detail','comment',array(
			'type' => 'varchar',
			'precision' => '255'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.026';
	}


	$test[] = '0.1.026';
	function inventory_upgrade0_1_026()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_bill_of_material_detail',array(
			'fd' => array(
				'bill_of_material_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'comment' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('bill_of_material_id','component','work_center'),
			'fk' => array('bill_of_material_id' => 'erp_bill_of_material.bill_of_material_id','component' => 'erp_stock.stock_id','work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('bill_of_material_id','component','work_center'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.027';
	}


	$test[] = '0.1.027';
	function inventory_upgrade0_1_027()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_stock','stock_id',array(
			'type' => 'auto',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_stock','stock_num',array(
			'type' => 'varchar',
			'precision' => '20'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'volume' => array('type' => 'decimal','precision' => '20','scale' => '4'),
				'mass' => array('type' => 'decimal','precision' => '20','scale' => '4'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'erp_stock_category.category_id','unit_of_measure' => 'erp_unit_of_measure.uom_id','tax_category' => 'erp_tax_category.tax_category_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.028';
	}


	$test[] = '0.1.028';
	function inventory_upgrade0_1_028()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_build_option_category','stock_category',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_build_option_category',array(
			'fd' => array(
				'build_option_category_id' => array('type' => 'auto','nullable' => False),
				'build_option_category_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'stock_category' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('build_option_category_id'),
			'fk' => array('stock_category' => 'erp_stock_category.stock_category_id'),
			'ix' => array('build_option_category_id','stock_category'),
			'uc' => array('build_option_category_id','build_option_category_name')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.029';
	}


	$test[] = '0.1.029';
	function inventory_upgrade0_1_029()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_allowed_build_option','bill_of_materials','component');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_allowed_build_option','value',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_allowed_build_option',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'value' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('build_option_id','stock_id'),
			'fk' => array('build_option_id' => 'erp_build_option.build_option_id','stock_id' => 'erp_stock.stock_id','component' => 'erp_stock.stock_id'),
			'ix' => array('build_option_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.030';
	}


	$test[] = '0.1.030';
	function inventory_upgrade0_1_030()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_allowed_build_option',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'value' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('build_option_id','stock_id'),
			'fk' => array('build_option_id' => 'erp_build_option.build_option_id','stock_id' => 'erp_stock.stock_id','component' => 'erp_stock.stock_id'),
			'ix' => array('build_option_id','stock_id','component'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.031';
	}


	$test[] = '0.1.031';
	function inventory_upgrade0_1_031()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_stock_category','stock_type',array(
			'type' => 'char',
			'precision' => '1',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.032';
	}


	$test[] = '0.1.032';
	function inventory_upgrade0_1_032()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_allowed_build_option','work_center',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_allowed_build_option',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'value' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('build_option_id','stock_id'),
			'fk' => array('build_option_id' => 'erp_build_option.build_option_id','stock_id' => 'erp_stock.stock_id','component' => 'erp_stock.stock_id','work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('build_option_id','stock_id','component','work_center'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.033';
	}


	$test[] = '0.1.033';
	function inventory_upgrade0_1_033()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_stock','option_selection_deferred',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.034';
	}


	$test[] = '0.1.034';
	function inventory_upgrade0_1_034()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_work_order_detail','stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.035';
	}


	$test[] = '0.1.035';
	function inventory_upgrade0_1_035()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_allowed_build_option','stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.036';
	}


	$test[] = '0.1.036';
	function inventory_upgrade0_1_036()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_bill_of_material','stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.037';
	}


	$test[] = '0.1.037';
	function inventory_upgrade0_1_037()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_bill_of_material_detail','component',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.038';
	}


	$test[] = '0.1.038';
	function inventory_upgrade0_1_038()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_work_center_bin','stock_id',array(
			'type' => 'int',
			'precision' => '4'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.039';
	}


	$test[] = '0.1.039';
	function inventory_upgrade0_1_039()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_stock_serial','stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.040';
	}


	$test[] = '0.1.040';
	function inventory_upgrade0_1_040()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_stock_history','stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.041';
	}


	$test[] = '0.1.041';
	function inventory_upgrade0_1_041()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_stock_assembly_serial','assembly_stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_stock_assembly_serial','component_stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.042';
	}


	$test[] = '0.1.042';
	function inventory_upgrade0_1_042()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_order','work_order_reference',array(
			'type' => 'varchar',
			'precision' => '20'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.043';
	}


	$test[] = '0.1.043';
	function inventory_upgrade0_1_043()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_work_order','competed_date','completed_date');

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.044';
	}


	$test[] = '0.1.044';
	function inventory_upgrade0_1_044()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_order_option','category',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_order_option',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'category' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','category'),
			'fk' => array('work_order_id' => 'erp_work_order_detail.work_order_id','detail_id' => 'erp_work_order_detail.detail_id','build_option_id' => 'erp_build_option.build_option_id'),
			'ix' => array('work_order_id','detail_id','category'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.045';
	}


	$test[] = '0.1.045';
	function inventory_upgrade0_1_045()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_order','location',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_order',array(
			'fd' => array(
				'work_order_id' => array('type' => 'auto','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'required_date' => array('type' => 'date','nullable' => False),
				'start_date' => array('type' => 'date'),
				'completed_date' => array('type' => 'date'),
				'sales_order' => array('type' => 'int','precision' => '4'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'work_order_reference' => array('type' => 'varchar','precision' => '20'),
				'location' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id'),
			'fk' => array('sales_order' => 'erp_sales_order.sales_order_id','location' => 'erp_location.location_id'),
			'ix' => array('work_order_id','created_date','required_date','location'),
			'uc' => array('work_order_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.046';
	}


	$test[] = '0.1.046';
	function inventory_upgrade0_1_046()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_bill_of_material','start_work_center',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_bill_of_material','finished_work_center',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_bill_of_material',array(
			'fd' => array(
				'bill_of_material_id' => array('type' => 'auto','nullable' => False),
				'effective_after_date' => array('type' => 'date','nullable' => False),
				'effective_to_date' => array('type' => 'date'),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'comment' => array('type' => 'text'),
				'start_work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'finished_work_center' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('bill_of_material_id'),
			'fk' => array('stock_id' => 'erp_stock.stock_id','start_work_center' => 'erp_work_center.work_center_id','finished_work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('bill_of_material_id','effective_after_date','effective_to_date','stock_id','start_work_center','finished_work_center'),
			'uc' => array('bill_of_material_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.047';
	}


	$test[] = '0.1.047';
	function inventory_upgrade0_1_047()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_location_stock','stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.048';
	}


	$test[] = '0.1.048';
	function inventory_upgrade0_1_048()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_order_option','stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_order_option',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'category' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','category'),
			'fk' => array('work_order_id' => 'erp_work_order_detail.work_order_id','detail_id' => 'erp_work_order_detail.detail_id','build_option_id' => 'erp_allowed_build_option.build_option_id','stock_id' => 'erp_allowed_build_option.stock_id'),
			'ix' => array('work_order_id','detail_id','category'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.049';
	}


	$test[] = '0.1.049';
	function inventory_upgrade0_1_049()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_work_order_bill_of_material','bill_of_material_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_order_bill_of_material','stock_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_order_bill_of_material','quantity',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'bill_of_material_id' => array('type' => 'int','precision' => '4'),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('work_order_id','detail_id','bill_of_material_id','stock_id'),
			'fk' => array('work_order_id' => 'erp_work_order_detail.work_order_id','detail_id' => 'erp_work_order_detail.detail_id','bill_of_material_id' => 'erp_bill_of_material.bill_of_material_id','stock_id' => 'erp_stock.stock_id'),
			'ix' => array('work_order_id','detail_id','bill_of_material_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.050';
	}


	$test[] = '0.1.050';
	function inventory_upgrade0_1_050()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'bill_of_material_id' => array('type' => 'int','precision' => '4'),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('work_order_id','detail_id','bill_of_material_id','stock_id'),
			'fk' => array('work_order_id' => 'erp_work_order_detail.work_order_id','detail_id' => 'erp_work_order_detail.detail_id','bill_of_material_id' => 'erp_bill_of_material.bill_of_material_id','stock_id' => 'erp_stock.stock_id'),
			'ix' => array('work_order_id','detail_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.051';
	}


	$test[] = '0.1.051';
	function inventory_upgrade0_1_051()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_work_order_bill_of_material','bill_of_material_id','component');
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_work_order_bill_of_material','stock_id','bom_or_stock');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_work_order_bill_of_material','component',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_work_order_bill_of_material','bom_or_stock',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '1'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_order_bill_of_material',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'bom_or_stock' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('work_order_id','detail_id','component'),
			'fk' => array('work_order_id' => 'erp_work_order_detail.work_order_id','detail_id' => 'erp_work_order_detail.detail_id'),
			'ix' => array('work_order_id','detail_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.052';
	}


	$test[] = '0.1.052';
	function inventory_upgrade0_1_052()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_stock','pseudo',array(
			'type' => 'bool',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.053';
	}


	$test[] = '0.1.053';
	function inventory_upgrade0_1_053()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_center','scanning',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.054';
	}


	$test[] = '0.1.054';
	function inventory_upgrade0_1_054()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array('stock_id','timestamp'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.055';
	}


	$test[] = '0.1.055';
	function inventory_upgrade0_1_055()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_fifo_costing','location',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'erp_stock.stock_id','location' => 'erp_location.location_id'),
			'ix' => array('stock_id','timestamp'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.056';
	}


	$test[] = '0.1.056';
	function inventory_upgrade0_1_056()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_allowed_build_option','required',array(
			'type' => 'bool',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.057';
	}


	$test[] = '0.1.057';
	function inventory_upgrade0_1_057()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('erp_allowed_build_option',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'value' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('build_option_id','stock_id'),
			'fk' => array('build_option_id' => 'erp_build_option.build_option_id','stock_id' => 'erp_stock.stock_id','component' => 'erp_stock.stock_id','work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('build_option_id','stock_id','component','work_center'),
			'uc' => array()
		),'required');

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.058';
	}


	$test[] = '0.1.058';
	function inventory_upgrade0_1_058()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_build_option_category','required',array(
			'type' => 'bool',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.059';
	}


	$test[] = '0.1.059';
	function inventory_upgrade0_1_059()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_center','account',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_center',array(
			'fd' => array(
				'work_center_id' => array('type' => 'auto','nullable' => False),
				'work_center_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_center_id'),
			'fk' => array('location' => 'erp_location.location_id','overhead_account' => 'erp_account.account_id','account' => 'egw_accounts.account_id'),
			'ix' => array('work_center_id'),
			'uc' => array('work_center_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.060';
	}


	$test[] = '0.1.060';
	function inventory_upgrade0_1_060()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_bill_of_material_detail','time',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.061';
	}


	$test[] = '0.1.061';
	function inventory_upgrade0_1_061()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_center','next_work_center',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_center',array(
			'fd' => array(
				'work_center_id' => array('type' => 'auto','nullable' => False),
				'work_center_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False),
				'next_work_center' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('work_center_id'),
			'fk' => array('location' => 'erp_location.location_id','overhead_account' => 'erp_account.account_id','account' => 'egw_accounts.account_id','next_work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('work_center_id'),
			'uc' => array('work_center_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.062';
	}


	$test[] = '0.1.062';
	function inventory_upgrade0_1_062()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('erp_work_center',array(
			'fd' => array(
				'work_center_id' => array('type' => 'auto','nullable' => False),
				'work_center_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_center_id'),
			'fk' => array('location' => 'erp_location.location_id','overhead_account' => 'erp_account.account_id','account' => 'egw_accounts.account_id','next_work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('work_center_id'),
			'uc' => array('work_center_id')
		),'next_work_center');
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_work_center',array(
			'fd' => array(
				'work_center_id' => array('type' => 'auto','nullable' => False),
				'work_center_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_center_id'),
			'fk' => array('location' => 'erp_location.location_id','overhead_account' => 'erp_account.account_id','account' => 'egw_accounts.account_id'),
			'ix' => array('work_center_id'),
			'uc' => array('work_center_id')
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.063';
	}


	$test[] = '0.1.063';
	function inventory_upgrade0_1_063()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('erp_stock_build_path',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'time' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'order' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_id','work_center'),
			'fk' => array('stock_id' => 'erp_stock.stock_id','work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('stock_id','work_center','order'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.064';
	}


	$test[] = '0.1.064';
	function inventory_upgrade0_1_064()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_stock_build_path','order','sort_order');
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_stock_build_path',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'time' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'sort_order' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_id','work_center'),
			'fk' => array('stock_id' => 'erp_stock.stock_id','work_center' => 'erp_work_center.work_center_id'),
			'ix' => array('stock_id','work_center','sort_order'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.065';
	}


	$test[] = '0.1.065';
	function inventory_upgrade0_1_065()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_fifo_costing','quantity',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.066';
	}


	$test[] = '0.1.066';
	function inventory_upgrade0_1_066()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_fifo_costing','quantity',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.067';
	}


	$test[] = '0.1.067';
	function inventory_upgrade0_1_067()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('erp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'erp_stock.stock_id','location' => 'erp_location.location_id'),
			'ix' => array('stock_id','timestamp'),
			'uc' => array()
		),'quantity_received');

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.068';
	}


	$test[] = '0.1.068';
	function inventory_upgrade0_1_068()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_fifo_costing','quantity_received',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.069';
	}


	$test[] = '0.1.069';
	function inventory_upgrade0_1_069()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_fifo_costing','price','direct_cost');

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.070';
	}


	$test[] = '0.1.070';
	function inventory_upgrade0_1_070()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_fifo_costing','indirect_cost',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.071';
	}


	$test[] = '0.1.071';
	function inventory_upgrade0_1_071()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('erp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_received' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'erp_stock.stock_id','location' => 'erp_location.location_id'),
			'ix' => array('stock_id'),
			'uc' => array()
		),'timestamp');
		$GLOBALS['egw_setup']->oProc->DropColumn('erp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_received' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'erp_stock.stock_id','location' => 'erp_location.location_id'),
			'ix' => array('stock_id'),
			'uc' => array()
		),'direct_cost');
		$GLOBALS['egw_setup']->oProc->DropColumn('erp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'erp_stock.stock_id','location' => 'erp_location.location_id'),
			'ix' => array('stock_id'),
			'uc' => array()
		),'quantity_received');
		$GLOBALS['egw_setup']->oProc->DropColumn('erp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'erp_stock.stock_id','location' => 'erp_location.location_id'),
			'ix' => array('stock_id'),
			'uc' => array()
		),'indirect_cost');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_fifo_costing','goods_received_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('erp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'goods_received_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'erp_stock.stock_id','location' => 'erp_location.location_id','goods_received_id' => 'erp_goods_received.goods_received_id'),
			'ix' => array('stock_id','goods_received_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.072';
	}


	$test[] = '0.1.072';
	function inventory_upgrade0_1_072()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('erp_work_order_detail','cost','direct_cost');
		$GLOBALS['egw_setup']->oProc->AlterColumn('erp_work_order_detail','direct_cost',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'default' => '0'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('erp_work_order_detail','indirect_cost',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'default' => '0'
		));

		return $GLOBALS['setup_info']['inventory']['currentver'] = '0.1.073';
	}


	$test[] = '0.1.073';
	function perp_inventory_upgrade0_1_073()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_serial','location','work_order_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_serial',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
			),
			'pk' => array('stock_id','serial_number'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','work_order_id' => 'perp_work_order.work_order_id'),
			'ix' => array('stock_id','serial_number','work_order_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.074';
	}


	$test[] = '0.1.077';
	function perp_inventory_upgrade0_1_077()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'mass' => array('type' => 'decimal','precision' => '20','scale' => '4'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'perp_stock_category.category_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		),'volume');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock','mass','ship_mass');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','ship_mass',array(
			'type' => 'decimal',
			'precision' => '4',
			'scale' => '4',
			'nullable' => False,
			'default' => '1'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','ship_length',array(
			'type' => 'decimal',
			'precision' => '3',
			'scale' => '4',
			'nullable' => False,
			'default' => '0'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','ship_width',array(
			'type' => 'decimal',
			'precision' => '3',
			'scale' => '4',
			'nullable' => False,
			'default' => '0'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','ship_height',array(
			'type' => 'decimal',
			'precision' => '3',
			'scale' => '4',
			'nullable' => False,
			'default' => '0'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','country_of_origin',array(
			'type' => 'varchar',
			'precision' => '2'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','us_inbound_code',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','us_outbound_code',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','international_code',array(
			'type' => 'int',
			'precision' => '2'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','ship_quantity',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False,
			'default' => '1'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','ship_uom',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','ship_notes',array(
			'type' => 'text'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'ship_mass' => array('type' => 'decimal','precision' => '4','scale' => '4','nullable' => False,'default' => '1'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'ship_length' => array('type' => 'decimal','precision' => '3','scale' => '4','nullable' => False,'default' => '0'),
				'ship_width' => array('type' => 'decimal','precision' => '3','scale' => '4','nullable' => False,'default' => '0'),
				'ship_height' => array('type' => 'decimal','precision' => '3','scale' => '4','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'us_inbound_code' => array('type' => 'int','precision' => '4'),
				'us_outbound_code' => array('type' => 'int','precision' => '4'),
				'international_code' => array('type' => 'int','precision' => '2'),
				'ship_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'ship_uom' => array('type' => 'int','precision' => '4'),
				'ship_notes' => array('type' => 'text')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'perp_stock_category.category_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','ship_uom' => 'perp_unit_of_measure.uom_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.078';
	}


	$test[] = '0.1.078';
	function perp_inventory_upgrade0_1_078()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','ship_length',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '0'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','ship_width',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '0'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','ship_height',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.079';
	}


	$test[] = '0.1.079';
	function perp_inventory_upgrade0_1_079()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','ship_mass',array(
			'type' => 'decimal',
			'precision' => '8',
			'scale' => '3',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.080';
	}


	$test[] = '0.1.080';
	function perp_inventory_upgrade0_1_080()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_work_order_detail','option_search',array(
			'type' => 'text'
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.081';
	}


	$test[] = '0.1.081';
	function perp_inventory_upgrade0_1_081()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_work_center',array(
			'fd' => array(
				'work_center_id' => array('type' => 'auto','nullable' => False),
				'work_center_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_center_id'),
			'fk' => array('location' => 'perp_location.location_id','overhead_account' => 'perp_account.account_id','account' => 'egw_accounts.account_id'),
			'ix' => array('work_center_id'),
			'uc' => array('work_center_id',array('location','work_center_name'))
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.082';
	}


	$test[] = '0.1.082';
	function perp_inventory_upgrade0_1_082()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock','us_inbound_code','usa_inbound_code');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock','us_outbound_code','usa_returning_code');
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','usa_inbound_code',array(
			'type' => 'varchar',
			'precision' => '13'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','usa_returning_code',array(
			'type' => 'varchar',
			'precision' => '13'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','international_code',array(
			'type' => 'varchar',
			'precision' => '7'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','canadian_inbound_code',array(
			'type' => 'varchar',
			'precision' => '13'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock','canadian_returning_code',array(
			'type' => 'varchar',
			'precision' => '13'
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.083';
	}


	$test[] = '0.1.083';
	function perp_inventory_upgrade0_1_083()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_location_gl_account',array(
			'fd' => array(
				'location_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_in_progress_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'shrinkage_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('location_id','stock_category_id'),
			'fk' => array('location_id' => 'perp_location.location_id','stock_category_id' => 'perp_stock_category.stock_category_id','stock_gl_account' => 'perp_account.account_id','work_in_progress_gl_account' => 'perp_account.account_id','shrinkage_gl_account' => 'perp_account.account_id'),
			'ix' => array('location_id','stock_category_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.084';
	}


	$test[] = '0.1.084';
	function perp_inventory_upgrade0_1_084()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_category',array(
			'fd' => array(
				'stock_category_id' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'stock_category_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_type' => array('type' => 'char','precision' => '1','nullable' => False),
				'adjustment_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'purchase_price_varience_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'usage_varience_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_in_progress_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_category_id'),
			'fk' => array('stock_type' => 'perp_stock_type.stock_type_id','stock_gl_account' => 'perp_account.account_id','adjustment_gl_account' => 'perp_account.account_id','purchase_price_varience_gl_account' => 'perp_account.account_id','usage_varience_gl_account' => 'perp_account.account_id','work_in_progress_gl_account' => 'perp_account.account_id'),
			'ix' => array('stock_category_id','stock_type'),
			'uc' => array('stock_category_id','stock_category_name')
		),'stock_gl_account');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_category',array(
			'fd' => array(
				'stock_category_id' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'stock_category_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_type' => array('type' => 'char','precision' => '1','nullable' => False),
				'purchase_price_varience_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'usage_varience_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_in_progress_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_category_id'),
			'fk' => array('stock_type' => 'perp_stock_type.stock_type_id','stock_gl_account' => 'perp_account.account_id','adjustment_gl_account' => 'perp_account.account_id','purchase_price_varience_gl_account' => 'perp_account.account_id','usage_varience_gl_account' => 'perp_account.account_id','work_in_progress_gl_account' => 'perp_account.account_id'),
			'ix' => array('stock_category_id','stock_type'),
			'uc' => array('stock_category_id','stock_category_name')
		),'adjustment_gl_account');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_category',array(
			'fd' => array(
				'stock_category_id' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'stock_category_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_type' => array('type' => 'char','precision' => '1','nullable' => False),
				'usage_varience_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_in_progress_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_category_id'),
			'fk' => array('stock_type' => 'perp_stock_type.stock_type_id','stock_gl_account' => 'perp_account.account_id','adjustment_gl_account' => 'perp_account.account_id','purchase_price_varience_gl_account' => 'perp_account.account_id','usage_varience_gl_account' => 'perp_account.account_id','work_in_progress_gl_account' => 'perp_account.account_id'),
			'ix' => array('stock_category_id','stock_type'),
			'uc' => array('stock_category_id','stock_category_name')
		),'purchase_price_varience_gl_account');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_category',array(
			'fd' => array(
				'stock_category_id' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'stock_category_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_type' => array('type' => 'char','precision' => '1','nullable' => False),
				'work_in_progress_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_category_id'),
			'fk' => array('stock_type' => 'perp_stock_type.stock_type_id','stock_gl_account' => 'perp_account.account_id','adjustment_gl_account' => 'perp_account.account_id','purchase_price_varience_gl_account' => 'perp_account.account_id','usage_varience_gl_account' => 'perp_account.account_id','work_in_progress_gl_account' => 'perp_account.account_id'),
			'ix' => array('stock_category_id','stock_type'),
			'uc' => array('stock_category_id','stock_category_name')
		),'usage_varience_gl_account');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_category',array(
			'fd' => array(
				'stock_category_id' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'stock_category_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_type' => array('type' => 'char','precision' => '1','nullable' => False)
			),
			'pk' => array('stock_category_id'),
			'fk' => array('stock_type' => 'perp_stock_type.stock_type_id','stock_gl_account' => 'perp_account.account_id','adjustment_gl_account' => 'perp_account.account_id','purchase_price_varience_gl_account' => 'perp_account.account_id','usage_varience_gl_account' => 'perp_account.account_id','work_in_progress_gl_account' => 'perp_account.account_id'),
			'ix' => array('stock_category_id','stock_type'),
			'uc' => array('stock_category_id','stock_category_name')
		),'work_in_progress_gl_account');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_category',array(
			'fd' => array(
				'stock_category_id' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'stock_category_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_type' => array('type' => 'char','precision' => '1','nullable' => False)
			),
			'pk' => array('stock_category_id'),
			'fk' => array('stock_type' => 'perp_stock_type.stock_type_id'),
			'ix' => array('stock_category_id','stock_type'),
			'uc' => array('stock_category_id','stock_category_name')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.085';
	}


	$test[] = '0.1.085';
	function perp_inventory_upgrade0_1_085()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_tax_category',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_category_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_id','tax_authority_id','tax_category_id'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','tax_authority_id' => 'perp_tax_authority.tax_authority_id','tax_category_id' => 'perp_tax_category.tax_category_id'),
			'ix' => array('stock_id','tax_authority_id','tax_category_id'),
			'uc' => array(array('stock_id','tax_authority_id','tax_category_id'))
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.086';
	}


	$test[] = '0.1.086';
	function perp_inventory_upgrade0_1_086()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_tax_category',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_authority_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'tax_category_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_id','tax_authority_id'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','tax_authority_id' => 'perp_tax_authority.tax_authority_id','tax_category_id' => 'perp_tax_category.tax_category_id'),
			'ix' => array('stock_id','tax_authority_id'),
			'uc' => array(array('stock_id','tax_authority_id'))
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.087';
	}


	$test[] = '0.1.087';
	function perp_inventory_upgrade0_1_087()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_location','status',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '1'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_location',array(
			'fd' => array(
				'location_id' => array('type' => 'auto','nullable' => False),
				'location_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'delivery_address' => array('type' => 'int','precision' => '4'),
				'tax_location' => array('type' => 'int','precision' => '4'),
				'status' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1')
			),
			'pk' => array('location_id'),
			'fk' => array('delivery_address' => 'perp_address.address_id','tax_location' => 'perp_tax_location.tax_location_id'),
			'ix' => array('location_id','status'),
			'uc' => array('location_id','location_name')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.088';
	}


	$test[] = '0.1.088';
	function perp_inventory_upgrade0_1_088()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_history',array(
			'fd' => array(
				'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text')
			),
			'pk' => array('serial_number','timestamp'),
			'fk' => array('stock_id' => 'perp_stock_serial.stock_id','serial_number' => 'perp_stock_serial.serial_number','work_center' => 'perp_work_center.work_center_id'),
			'ix' => array('serial_number','timestamp'),
			'uc' => array()
		),'stock_id');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_history','serial_number','stock_history_id');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_history','stock_history_id',array(
			'type' => 'auto',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_history','work_order_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_history','line_no',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_history',array(
			'fd' => array(
				'stock_history_id' => array('type' => 'auto','precision' => '4','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_history_id'),
			'fk' => array('work_center' => 'perp_work_center.work_center_id','work_order_id' => 'perp_work_order_detail.work_order_id','line_no' => 'perp_work_order_detail.line_no'),
			'ix' => array('stock_history_id','work_order_id','line_no'),
			'uc' => array('stock_history_id')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.089';
	}


	$test[] = '0.1.089';
	function perp_inventory_upgrade0_1_089()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_assembly_serial','assembly_stock_id','work_order_id');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_assembly_serial','assembly_serial_number','line_no');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_assembly_serial','timestamp','stock_history');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_assembly_serial','stock_history',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_assembly_serial',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'component_stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component_serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_history' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','line_no','stock_history'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','line_no' => 'perp_work_order_detail.line_no','component_stock_id' => 'perp_stock_serial.stock_id','component_serial_number' => 'perp_stock_serial.serial_number','stock_history' => 'perp_stock_history.stock_history_id'),
			'ix' => array('work_order_id','line_no'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.090';
	}


	$test[] = '0.1.090';
	function perp_inventory_upgrade0_1_090()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_serial','detail_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_serial',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_id','serial_number'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id'),
			'ix' => array('stock_id','serial_number','work_order_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.091';
	}


	$test[] = '0.1.091';
	function perp_inventory_upgrade0_1_091()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_history','line_no','detail_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_history',array(
			'fd' => array(
				'stock_history_id' => array('type' => 'auto','precision' => '4','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_history_id'),
			'fk' => array('work_center' => 'perp_work_center.work_center_id','work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id'),
			'ix' => array('stock_history_id','work_order_id','detail_id'),
			'uc' => array('stock_history_id')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.092';
	}


	$test[] = '0.1.092';
	function perp_inventory_upgrade0_1_092()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_assembly_serial','line_no','detail_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_assembly_serial',array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'component_stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component_serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'stock_history' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','stock_history'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','component_stock_id' => 'perp_stock_serial.stock_id','component_serial_number' => 'perp_stock_serial.serial_number','stock_history' => 'perp_stock_history.stock_history_id'),
			'ix' => array('work_order_id','detail_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.1.093';
	}



	$test[] = '0.1.093';
	function perp_inventory_upgrade0_1_093()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_cost',array(
			'fd' => array(
				'stock_cost_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'date' => array('type' => 'timestamp','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('stock_cost_id'),
			'fk' => array('stock_id' => 'perp_stock.stock_id'),
			'ix' => array(),
			'uc' => array('stock_cost_id')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.001';
	}


	$test[] = '0.2.000';
	function perp_inventory_upgrade0_2_000()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_fifo_costing','goods_received_id','stock_cost_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_fifo_costing',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_cost_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'perp_stock.stock_id','location' => 'perp_location.location_id','stock_cost_id' => 'perp_stock_cost.stock_cost_id'),
			'ix' => array('stock_id','stock_cost_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.001';
	}


	$test[] = '0.2.001';
	function perp_inventory_upgrade0_2_001()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_cost','stock_cost_id',array(
			'type' => 'auto',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.002';
	}

	$test[] = '0.2.002';
	function perp_inventory_upgrade0_2_002() {
		// Manual upgrade - removed manufacturing tables
		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.003';
	}

	$test[] = '0.2.003';
	function perp_inventory_upgrade0_2_003()
	{
		// Manual upgrading because this rename seems to get missed
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_fifo_costing','goods_received_id','stock_cost_id');
		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.004';
	}


	$test[] = '0.2.004';
	function perp_inventory_upgrade0_2_004()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_serial','location_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_serial',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'location_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('stock_id','serial_number'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','location_id' => 'perp_location.location_id'),
			'ix' => array('stock_id','serial_number','work_order_id','location_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.005';
	}


	$test[] = '0.2.005';
	function perp_inventory_upgrade0_2_005()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_serial','stock_cost_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_serial',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'location_id' => array('type' => 'int','precision' => '4'),
				'stock_cost_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('stock_id','serial_number'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','location_id' => 'perp_location.location_id','stock_cost_id' => 'perp_stock_cost.stock_cost_id'),
			'ix' => array('stock_id','serial_number','work_order_id','location_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.006';
	}


	$test[] = '0.2.006';
	function perp_inventory_upgrade0_2_006()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_location_stock',array(
			'fd' => array(
				'location_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'min_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'max_on_hand' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'quantity_reserved' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('location_id','stock_id'),
			'fk' => array('location_id' => 'perp_location.location_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.007';
	}

	$test[] = '0.2.007';
	function perp_inventory_upgrade0_2_007() {
		$select = 'SELECT 
			stock_category_id,
			0 AS cat_parent, 
			0 AS cat_level,
			-1 AS cat_owner,
			\'public\' AS cat_access,
			\'perp_inventory\' AS cat_appname,
			stock_category_name AS cat_name
		FROM perp_stock_category';

		$db_clone = clone($GLOBALS['egw_setup']->db);
		$GLOBALS['egw_setup']->db->query($select, __LINE__, __FILE__);
		while($row = $GLOBALS['egw_setup']->db->row(true)) {
			$stock_category_id = $row['stock_category_id'];
			unset($row['stock_category_id']);
			$db_clone->insert('egw_categories', $row, array(), __LINE__, __FILE__);
			$new_cat_id = $db_clone->get_last_insert_id('egw_categories', 'cat_id');
			$update = 'UPDATE perp_stock SET stock_category = ' . $new_cat_id . ' WHERE stock_category = ' . $stock_category_id;
			$db_clone->query($update, __LINE__, __FILE__);
			$update = 'UPDATE perp_location_gl_account SET stock_category_id = ' . $new_cat_id . ' WHERE stock_category_id = ' . $stock_category_id;
			$db_clone->query($update, __LINE__, __FILE__);
		}
		$GLOBALS['egw_setup']->oProc->DropTable('perp_stock_category');
		$db_clone->delete('egw_acl',
			array(
				'acl_appname'	=>	'perp_inventory',
				'acl_location'	=>	'stock_category'
			),
			__LINE__, __FILE__
		);
		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.008';
	}


	$test[] = '0.2.008';
	function perp_inventory_upgrade0_2_008()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_location','location_parent',array(
			'type' => 'int',
			'precision' => '4',
			'default' => 'null'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_location',array(
			'fd' => array(
				'location_id' => array('type' => 'auto','nullable' => False),
				'location_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'delivery_address' => array('type' => 'int','precision' => '4'),
				'tax_location' => array('type' => 'int','precision' => '4'),
				'status' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'location_parent' => array('type' => 'int','precision' => '4','default' => 'null')
			),
			'pk' => array('location_id'),
			'fk' => array('delivery_address' => 'perp_address.address_id','tax_location' => 'perp_tax_location.tax_location_id','location_parent' => 'perp_location.location_id'),
			'ix' => array('status'),
			'uc' => array('location_name')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.009';
	}

	$test[] = '0.2.009';
	function perp_inventory_upgrade0_2_009()
	{

		/*
		This is ugly, and probably bad because I'm creating things that probably shouldn't
		be created in setup, and calling things that probably shouldn't be called in setup.
		*/

		$GLOBALS['egw']->db =& $GLOBALS['egw_setup']->db;
		$GLOBALS['egw']->common = CreateObject('phpgwapi.common');

		// Create config object to get install_id
		$config = CreateObject('phpgwapi.config', 'phpgwapi');
		$config->read_repository();
		$GLOBALS['egw_info']['server']['install_id'] = $config->config_data['install_id'];
		$GLOBALS['egw_setup']->db->query('SELECT stock_id FROM perp_stock ', __LINE__, __FILE__);
		while($row = $GLOBALS['egw_setup']->db->row(true)) {
			$stock_id = $row['stock_id'];
			ExecMethod2('phpgwapi.contenthistory.updateTimeStamp', 'perp_inventory:STOCK', $stock_id, 'add', time());
		}
		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.010';
	}


	$test[] = '0.2.010';
	function perp_inventory_upgrade0_2_010()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_ship_package',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'length' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'width' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'height' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'mass' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0.1')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','unit_of_measure' => 'perp_unit_of_measure.uom_id'),
			'ix' => array(),
			'uc' => array()
		));

		$GLOBALS['egw_setup']->db->query(
			'SELECT 
				stock_id,
				ship_mass,
				ship_length,
				ship_width,
				ship_height,
				ship_uom
			FROM perp_stock',
			__LINE__, __FILE__
		);
		$stock = array();
		while ($row = $GLOBALS['egw_setup']->db->row(true)) {
			$row['unit_of_measure'] = $row['ship_uom'];
			$stock[] = $row;
		}
		foreach($stock as $stock_item) {
			$GLOBALS['egw_setup']->db->insert(
				'perp_stock_ship_package',
				$stock_item,
				array(),
				__LINE__, __FILE__,
				'perp_inventory'
			);
		}

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.011';
	}


	$test[] = '0.2.011';
	function perp_inventory_upgrade0_2_011()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'ship_length' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'ship_width' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'ship_height' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'ship_uom' => array('type' => 'int','precision' => '4'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','ship_uom' => 'perp_unit_of_measure.uom_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		),'ship_mass');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'ship_width' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'ship_height' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'ship_uom' => array('type' => 'int','precision' => '4'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','ship_uom' => 'perp_unit_of_measure.uom_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		),'ship_length');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'ship_height' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'ship_uom' => array('type' => 'int','precision' => '4'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','ship_uom' => 'perp_unit_of_measure.uom_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		),'ship_width');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'ship_uom' => array('type' => 'int','precision' => '4'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','ship_uom' => 'perp_unit_of_measure.uom_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		),'ship_height');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_uom' => array('type' => 'int','precision' => '4'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','ship_uom' => 'perp_unit_of_measure.uom_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		),'ship_quantity');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','ship_uom' => 'perp_unit_of_measure.uom_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		),'ship_uom');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'varchar','precision' => '6','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.012';
	}


	$test[] = '0.2.012';
	function perp_inventory_upgrade0_2_012()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_ship_package','stock_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_ship_package',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'length' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'width' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'height' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'mass' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0.1')
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'perp_stock.stock_id','unit_of_measure' => 'perp_unit_of_measure.uom_id'),
			'ix' => array('stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.013';
	}


	$test[] = '0.2.013';
	function perp_inventory_upgrade0_2_013()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock','stock_category',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.014';
	}


	$test[] = '0.2.014';
	function perp_inventory_upgrade0_2_014()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_barcode',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4'),
				'barcode' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'encoding' => array('type' => 'varchar','precision' => '5','nullable' => False,'default' => 'C128B'),
				'preferred' => array('type' => 'bool','nullable' => False,'default' => 'false')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_id' => 'perp_stock.stock_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.015';
	}

	$test[] = '0.2.015';
	function perp_inventory_upgrade0_2_015() {
		$sql = "INSERT INTO perp_stock_barcode (stock_id, barcode) SELECT stock_id,  barcode 
		FROM perp_stock 
		WHERE barcode != ''";
		$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);
		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.016';
	}


	$test[] = '0.2.016';
	function perp_inventory_upgrade0_2_016()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serialized' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		),'barcode');

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.017';
	}


	$test[] = '0.2.017';
	function perp_inventory_upgrade0_2_017()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_barcode','barcode',array(
			'type' => 'varchar',
			'precision' => '50'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_barcode',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4'),
				'barcode' => array('type' => 'varchar','precision' => '50'),
				'encoding' => array('type' => 'varchar','precision' => '5','nullable' => False,'default' => 'C128B'),
				'preferred' => array('type' => 'bool','nullable' => False,'default' => 'false')
			),
			'pk' => array('stock_id','barcode'),
			'fk' => array('stock_id' => 'perp_stock.stock_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.018';
	}


	$test[] = '0.2.018';
	function perp_inventory_upgrade0_2_018()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_move',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'from_location_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'to_location_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'move_type' => array('type' => 'int','precision' => '1','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'narrative' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('stock_id','timestamp','from_location_id','to_location_id'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','from_location_id' => 'perp_location.location_id','to_location_id' => 'perp_location.location_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.019';
	}


	$test[] = '0.2.019';
	function perp_inventory_upgrade0_2_019()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_move',array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'timestamp' => array('type' => 'timestamp','nullable' => False),
				'from_location_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'to_location_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'move_type' => array('type' => 'int','precision' => '1','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'narrative' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'perp_stock.stock_id','from_location_id' => 'perp_location.location_id','to_location_id' => 'perp_location.location_id'),
			'ix' => array('stock_id','from_location_id','to_location_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.020';
	}

	$test[] = '0.2.020';
	function perp_inventory_upgrade0_2_020()
	{
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_inventory', 'stock_category', 0,15)");
		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.021';
	}


	$test[] = '0.2.021';
	function perp_inventory_upgrade0_2_021()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_count_sheet',array(
			'fd' => array(
				'count_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sheet_id' => array('type' => 'auto','nullable' => False),
				'counted_by' => array('type' => 'varchar','precision' => '100','nullable' => False),
				'checked_by' => array('type' => 'varchar','precision' => '100')
			),
			'pk' => array('sheet_id'),
			'fk' => array('count_id' => 'perp_stock_count.count_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.022';
	}


	$test[] = '0.2.022';
	function perp_inventory_upgrade0_2_022()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_count',array(
			'fd' => array(
				'count_id' => array('type' => 'auto','nullable' => False),
				'count_date' => array('type' => 'date','nullable' => False),
				'supervisor' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('count_id'),
			'fk' => array('supervisor' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.023';
	}


	$test[] = '0.2.023';
	function perp_inventory_upgrade0_2_023()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_count_detail',array(
			'fd' => array(
				'sheet_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'location_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'count' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('sheet_id','stock_id','location_id','count'),
			'fk' => array('sheet_id' => 'perp_stock_count_sheet.sheet_id','stock_id' => 'perp_stock.stock_id','location_id' => 'perp_location.location_id'),
			'ix' => array(),
			'uc' => array()
		));

		// Add rights
		$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_inventory', 'stock_count', 0,7)");

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.024';
	}


	$test[] = '0.2.024';
	function perp_inventory_upgrade0_2_024()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_count','status',array(
			'type' => 'int',
			'precision' => '1',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.025';
	}


	$test[] = '0.2.025';
	function perp_inventory_upgrade0_2_025()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_count','count_by',array(
			'type' => 'int',
			'precision' => '1',
			'nullable' => False,
			'default' => '0'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_count','notes',array(
			'type' => 'text'
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.026';
	}


	$test[] = '0.2.026';
	function perp_inventory_upgrade0_2_026()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_count_sheet','location_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_count_sheet',array(
			'fd' => array(
				'count_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sheet_id' => array('type' => 'auto','nullable' => False),
				'counted_by' => array('type' => 'varchar','precision' => '100','nullable' => False),
				'checked_by' => array('type' => 'varchar','precision' => '100'),
				'location_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sheet_id'),
			'fk' => array('count_id' => 'perp_stock_count.count_id','location_id' => 'perp_location.location_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.027';
	}


	$test[] = '0.2.027';
	function perp_inventory_upgrade0_2_027()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_count_detail','location_id','expected');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_count_detail','expected',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'default' => '0'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_count_detail','count',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'default' => '0'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_count_detail',array(
			'fd' => array(
				'sheet_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'expected' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'count' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0')
			),
			'pk' => array('sheet_id','stock_id'),
			'fk' => array('sheet_id' => 'perp_stock_count_sheet.sheet_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.028';
	}


	$test[] = '0.2.028';
	function perp_inventory_upgrade0_2_028()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_count','status','finish_date');
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_count','count_date',array(
			'type' => 'timestamp',
			'nullable' => False
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_count','finish_date',array(
			'type' => 'timestamp'
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.029';
	}


	$test[] = '0.2.029';
	function perp_inventory_upgrade0_2_029()
	{
		$GLOBALS['egw_setup']->oProc->Query('UPDATE perp_stock SET controlled = 2 WHERE serialized = 1');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock','serialized','serial_setup');
		$GLOBALS['egw_setup']->oProc->Query('UPDATE perp_stock SET serial_setup = 0');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock',array(
			'fd' => array(
				'stock_id' => array('type' => 'auto','nullable' => False),
				'stock_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'short_description' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'long_description' => array('type' => 'text'),
				'unit_of_measure' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_type_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'B'),
				'status_flag' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'controlled' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'economic_order_quantity' => array('type' => 'float','precision' => '4','nullable' => False,'default' => '1'),
				'discount_category' => array('type' => 'varchar','precision' => '2','nullable' => False),
				'tax_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'serial_setup' => array('type' => 'int','precision' => '4'),
				'decimal_places' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'stock_num' => array('type' => 'varchar','precision' => '20'),
				'option_selection_deferred' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'pseudo' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'country_of_origin' => array('type' => 'varchar','precision' => '2'),
				'usa_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'usa_returning_code' => array('type' => 'varchar','precision' => '13'),
				'international_code' => array('type' => 'varchar','precision' => '7'),
				'ship_notes' => array('type' => 'text'),
				'canadian_inbound_code' => array('type' => 'varchar','precision' => '13'),
				'canadian_returning_code' => array('type' => 'varchar','precision' => '13')
			),
			'pk' => array('stock_id'),
			'fk' => array('stock_category' => 'egw_categories.cat_id','unit_of_measure' => 'perp_unit_of_measure.uom_id','tax_category' => 'perp_tax_category.tax_category_id','serial_setup' => 'perp_serial_setup.setup_id'),
			'ix' => array('stock_id'),
			'uc' => array('stock_id','stock_num')
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.030';
	}


	$test[] = '0.2.030';
	function perp_inventory_upgrade0_2_030()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_count_detail','unit_cost',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.031';
	}

	$test[] = '0.2.031';
	function perp_inventory_upgrade0_2_031()
	{
		if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
			// These tables need to be InnoDB
			$transaction_tables = array(
				'perp_location_stock',
				'perp_location_transfer',
				'perp_stock_serial',
				'perp_fifo_costing',
				'perp_stock_cost',
				'perp_stock_move',
			);
			$so_perp_api = CreateObject('perp_api.so_perp_api');
			$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_inventory', $transaction_tables);
		}
		return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.032';
	}


function perp_inventory_upgrade0_2_032()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_damage',array(
		'fd' => array(
			'damage_id' => array('type' => 'auto','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'quantity_damaged' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'discount_percent' => array('type' => 'decimal','precision' => '6','scale' => '4','nullable' => False)
		),
		'pk' => array('damage_id'),
		'fk' => array('stock_id' => 'perp_stock_serial.stock_id','serial_number' => 'perp_stock_serial.serial_number'),
		'ix' => array('stock_id','serial_number'),
		'uc' => array()
	));

	$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_inventory', 'damage', 0,7)");

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.033';
}


function perp_inventory_upgrade0_2_033()
{
	$GLOBALS['egw_setup']->oProc->RenameColumn('perp_stock_damage','damage_id','stock_history_id');
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_damage','stock_history_id',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_damage',array(
		'fd' => array(
			'stock_history_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'quantity_damaged' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'discount_percent' => array('type' => 'decimal','precision' => '6','scale' => '4','nullable' => False)
		),
		'pk' => array('stock_history_id'),
		'fk' => array('stock_history_id' => 'perp_stock_history.stock_history_id','stock_id' => 'perp_stock_serial.stock_id','serial_number' => 'perp_stock_serial.serial_number'),
		'ix' => array('stock_id','serial_number'),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.034';
}


function perp_inventory_upgrade0_2_034()
{
	$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_damage',array(
		'fd' => array(
			'stock_history_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'quantity_damaged' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'discount_percent' => array('type' => 'decimal','precision' => '6','scale' => '4','nullable' => False)
		),
		'pk' => array('stock_history_id'),
		'fk' => array('stock_history_id' => 'perp_stock_history.stock_history_id','stock_id' => 'perp_stock_serial.stock_id','serial_number' => 'perp_stock_serial.serial_number'),
		'ix' => array('serial_number'),
		'uc' => array()
	),'stock_id');
	$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_damage',array(
		'fd' => array(
			'stock_history_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_damaged' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'discount_percent' => array('type' => 'decimal','precision' => '6','scale' => '4','nullable' => False)
		),
		'pk' => array('stock_history_id'),
		'fk' => array('stock_history_id' => 'perp_stock_history.stock_history_id','stock_id' => 'perp_stock_serial.stock_id','serial_number' => 'perp_stock_serial.serial_number'),
		'ix' => array(),
		'uc' => array()
	),'serial_number');
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_damage',array(
		'fd' => array(
			'stock_history_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_damaged' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'discount_percent' => array('type' => 'decimal','precision' => '6','scale' => '4','nullable' => False)
		),
		'pk' => array('stock_history_id'),
		'fk' => array('stock_history_id' => 'perp_stock_history.stock_history_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.035';
}


function perp_inventory_upgrade0_2_035()
{
	$GLOBALS['egw_setup']->oProc->DropColumn('perp_stock_damage',array(
		'fd' => array(
			'stock_history_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_damaged' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'discount_percent' => array('type' => 'decimal','precision' => '6','scale' => '4','nullable' => False)
		),
		'pk' => array('stock_history_id'),
		'fk' => array('stock_history_id' => 'perp_stock_history.stock_history_id'),
		'ix' => array(),
		'uc' => array()
	),'description');

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.036';
}

function perp_inventory_upgrade0_2_036()
{
	$GLOBALS['egw_setup']->oProc->query("UPDATE egw_acl SET acl_rights = 15 WHERE acl_appname = 'perp_inventory' AND acl_location = 'stock_count' AND acl_account = 0");
	
	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.037';
}


// Force tables to InnoDB
so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_inventory');

function perp_inventory_upgrade0_2_037()
{
	// Rename the history table
	$GLOBALS['egw_setup']->oProc->RenameTable('perp_stock_history', 'perp_work_order_history');

	// Create new history table
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_history',array(
		'fd' => array(
			'history_id' => array('type' => 'auto','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'timestamp' => array('type' => 'timestamp','nullable' => False),
			'comment' => array('type' => 'text','nullable' => False),
			'link_app' => array('type' => 'varchar','precision' => '25'),
			'link_id' => array('type' => 'varchar','precision' => '50')
		),
		'pk' => array('history_id'),
		'fk' => array('stock_id' => 'perp_stock_serial.stock_id', 'serial_number' => 'perp_stock_serial.serial_number'),
		'ix' => array('stock_id'),
		'uc' => array()
	));

	// Copy relevant information from work_order_history
	$copy = 'INSERT INTO perp_stock_history (history_id, stock_id, serial_number, timestamp, comment, link_app, link_id)
	SELECT stock_history_id AS history_id, stock_id, serial_number, timestamp, comment, link_app, link_id
	FROM perp_work_order_history
	JOIN perp_stock_serial ON
	    perp_work_order_history.work_order_id = perp_stock_serial.work_order_id AND
	    perp_work_order_history.detail_id = perp_stock_serial.detail_id';

	$GLOBALS['egw_setup']->oProc->query($copy);

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.038';
}


function perp_inventory_upgrade0_2_038()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_count_serial',array(
		'fd' => array(
			'sheet_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'serial_number' => array('type' => 'varchar','precision' => '20'),
			'quantity_expected' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '1'),
			'count' => array('type' => 'decimal','precision' => '20','scale' => '3')
		),
		'pk' => array('sheet_id','stock_id','serial_number'),
		'fk' => array('sheet_id' => 'perp_stock_count_detail.sheet_id','stock_id' => 'perp_stock_count_detail.stock_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.039';
}

function perp_inventory_upgrade0_2_039()
{
	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.041';
}

function perp_inventory_upgrade0_2_041()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_serial_pattern',array(
		'fd' => array(
			'serial_pattern_id' => array('type' => 'auto','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'pattern' => array('type' => 'varchar','precision' => '255','nullable' => False)
		),
		'pk' => array('serial_pattern_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array('serial_pattern_id')
	));

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.042';
}


function perp_inventory_upgrade0_2_042()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_gl_account',array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'account_use' => array('type' => 'int','precision' => '1','nullable' => False),
			'gl_account' => array('type' => 'varchar','precision' => '7','nullable' => False)
		),
		'pk' => array(),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.043';
}


function perp_inventory_upgrade0_2_043()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_category',array(
		'fd' => array(
			'category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'on_hand_gl_account' => array('type' => 'varchar','precision' => '7'),
			'work_in_progress_gl_account' => array('type' => 'varchar','precision' => '7'),
			'shrinkage_gl_account' => array('type' => 'varchar','precision' => '7'),
			'adjustment_gl_account' => array('type' => 'varchar','precision' => '7')
		),
		'pk' => array('category_id'),
		'fk' => array('category_id' => 'egw_categories.cat_id'),
		'ix' => array(),
		'uc' => array()
	));

	$sql = 'INSERT INTO perp_stock_category (category_id, on_hand_gl_account, work_in_progress_gl_account, shrinkage_gl_account, adjustment_gl_account)
		SELECT stock_category_id AS category_id, min(stock_gl_account), min(work_in_progress_gl_account), min(shrinkage_gl_account), null
		FROM perp_location_gl_account
		WHERE stock_gl_account > 0 
		    OR work_in_progress_gl_account > 0
		    OR shrinkage_gl_account > 0
		GROUP BY stock_category_id';

	$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);
	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.044';
}


function perp_inventory_upgrade0_2_044()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_stock_barcode','encoding',array(
		'type' => 'varchar',
		'precision' => '16',
		'nullable' => False,
		'default' => 'C128B'
	));

	// Update encoding names to match new barcode generator
	$GLOBALS['egw_setup']->db->query('UPDATE perp_stock_barcode SET encoding = "Code39" WHERE encoding = "39"', __LINE__, __FILE__);
	$GLOBALS['egw_setup']->db->query('UPDATE perp_stock_barcode SET encoding = "int25" WHERE encoding = "I25"', __LINE__, __FILE__);
	$GLOBALS['egw_setup']->db->query('UPDATE perp_stock_barcode SET encoding = "code128" WHERE encoding LIKE "128%"', __LINE__, __FILE__);

	return $GLOBALS['setup_info']['perp_inventory']['currentver'] = '0.2.045';
}

