<?php
	/**
	*	Get data for various GL Reports
	*
	*	@ingroup perp_ledger
	*/
	class bo_perp_ledger_report {

		/**
		*	Link to data access object so_perp_ledger
		*/
		var $so;

		/**
		*	Constructor\n
		*	Creates data access object
		*/
		public function bo_perp_ledger_report() {
			$this->so = CreateObject('perp_ledger.so_perp_ledger_report');
		}
		
		/**
		*	Get data for trial balance report
		*
		*	@param startDate Date to start
		*	@param endDate Date to end 
		*	@return array Trial balances
		*/
		public function trial_balance($startDate, $endDate) {
			if(is_null($startDate)) {
				$startDate = date('U');
			}
			if(is_null($endDate)) {
				$endDate = date('U');
			}
			$data = $this->so->trial_balance($startDate, $endDate);
			if(isset($data['data'])) {
				array_unshift($data['data'], false);
			}
			return $data;
		}

		/**
		*	Get data for balance sheet report
		*
		*	@param startDate Date to start 
		*	@param endDate Date to end 
		*	@return array Balance Sheet data 
		*/
		public function balance_sheet($startDate, $endDate) {
			if(is_null($startDate)) {
				$startDate = date('U');
			}
			if(is_null($endDate)) {
				$endDate = date('U');
			}
			$data = $this->so->balance_sheet($startDate, $endDate);
			return $data;
		}

		
		/**
		*	Get data for account_inquiry report
		*
		*	@param account int General Ledger account to inquire about
		*	@param startDate Date to start 
		*	@param endDate Date to end 
		*	@return array Account inquiry data
		*/
		public function account_inquiry($account, $startDate, $endDate) {
			if(is_null($startDate)) {
				$startDate = date('U');
			}
			if(is_null($endDate)) {
				$endDate = date('U');
			}
			$data = $this->so->account_inquiry($account, $startDate, $endDate);
			return $data;
		}
	}
?>
