<?php

	/**
	*	@deprecated	?
	*	@todo	See if this is needed anymore, the pERP API reports may have replaced it.
	*/
	class ui_perp_ledger_report {
	
		/**
		*	Reference to logic object
		*/
		var $bo;

		/**
		*	Reference to eTemplate object for display
		*/
		var $template;

		/**
		*	List of public functions that phpgwapi allows to be
		*	called from the browser.  All other functions are denied.
		*/
		var $public_functions = array(
			'trial_balance'	=>	True,
			'balance_sheet'	=>	True,
			'account_inquiry'	=>	True,
		);

		/**
		*	Constructor
		*/
		public function ui_perp_ledger_report() {
			$this->bo = CreateObject('perp_ledger.bo_perp_ledger_report');
			$this->template = CreateObject('etemplate.etemplate');
		}

		/**
		*	User interface for old trial balance report
		*	@param content  array   Data returned from eTemplate when the user submits the form
		*	@depricated ?
		*/
		public function trial_balance($content = array()) {
			$startDate = $content['startDate'] ? date('U', $content['startDate']) : date('U', mktime(0,0,0,date('m'), 1, date('Y')));
			$endDate = $content['endDate'] ? date('U', $content['endDate']) : date('U');
			$data = $this->bo->trial_balance($startDate, $endDate);
			$data['startDate'] = $content['startDate'] ? $content['startDate'] : date('U', mktime(0,0,0,date('m'), 1, date('Y')));
			$data['endDate'] = $content['endDate'] ? $content['endDate'] : date('U');
		
			if(isset($content['sequence'])) {
				foreach($content['sequence'] as $seq => $sequence) {
					foreach($sequence['sections'] as $key => $section) {
						if(is_array($section)) {
							foreach($section['accounts'] as $line => $account) {
								$content['account_id'] = $line;
								unset($content['sections']);
								return $this->account_inquiry($content);
							}
						}
					}
				}
			}

			// Set title
			$GLOBALS['egw_info']['flags']['app_header'] = lang('perp_ledger') . ' - ' .
                                lang('trial_balance') . ' ' . lang('report');
			$this->template->read('perp_ledger.report.trial_balance');
			$this->template->exec('perp_ledger.ui_perp_ledger_report.trial_balance', $data);
		}

		/**
		*	User interface for old balance sheet report
		*	@param content  array   Data returned from eTemplate when the user submits the form
		*
		*	@depricated ?
		*/
		public function balance_sheet($content = array()) {
			$data['endDate'] = $content['endDate'] ? $content['endDate'] : date('U', mktime(0,0,0,12, 31, date('Y') - 1));
			$data += $this->bo->balance_sheet(0, $data['endDate']);
			foreach($data['sequence'] as $key => &$sequence) {
				if($sequence['sections']) {
					foreach($sequence['sections'] as &$section) {
						$section['debit']	=	ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $section['debit']);
						$section['credit']	=	ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $section['credit']);					
					}
					/*
					$sequence['sections'][] = array(
						'section_name'	=>	lang('Total'),
						'debit'		=>	ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $sequence['debit']),
						'credit'		=>	ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $sequence['credit']),
					);
					*/
				}
			}
		
			// Set title
			$GLOBALS['egw_info']['flags']['app_header'] = lang('perp_ledger') . ' - ' .
                                lang('balance sheet') . ' ' . lang('report');
			$this->template->read('perp_ledger.report.balance_sheet');
			$this->template->exec('perp_ledger.ui_perp_ledger_report.balance_sheet', $data);
		}

		/**
		*	User interface for old account inquiry report
		*	@param content  array   Data returned from eTemplate when the user submits the form
		*/
		public function account_inquiry($content = array()) {
			$startDate = $content['startDate'] ? date('U', $content['startDate']) : date('U');
			$endDate = $content['endDate'] ? date('U', $content['endDate']) : date('U');

			$account_id = $content['account_id'] ? $content['account_id'] : $_GET['account_id'];
			if($content['journal']) {
				$ui = CreateObject('perp_ledger.ui_perp_ledger');
				return $ui->journal(array('trans_no' => key($content['journal'])));
			}
			
			$data['transactions'] = $this->bo->account_inquiry($account_id, $startDate, $endDate);

			// Massage amount into debit or credit
			foreach($data['transactions'] as &$trans) {
				$trans[ ($trans['amount'] >= 0 ? 'credit' : 'debit')] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, abs($trans['amount']));
			}
			$data['startDate'] = $content['startDate'] ? $content['startDate'] : date('U');
			$data['endDate'] = $content['endDate'] ? $content['endDate'] : date('U');
			$data['account_id'] = $account_id;


			$bo = CreateObject('perp_ledger.bo_perp_ledger');
			$selects['account_id'] = $bo->get_accounts();

			// Set title
			$account = array();
			$bo->get_accounts(array('search' => $content['account_id']), $account);
			$GLOBALS['egw_info']['flags']['app_header'] = lang('perp_ledger') . ' - ' .
                                $account[0]['account_name'] . ' ' . lang('account inquiry');
			$this->template->read('perp_ledger.view_account');
			$this->template->exec('perp_ledger.ui_perp_ledger_report.account_inquiry', $data, $selects);
		}
	}
?>
