<?php

	/**
	*	User interface for matching up (reconciling) pERP's bank ledger
	*	to a bank's statement.
	*
	*	@author Nathan Gray
	*/

	require_once( EGW_INCLUDE_ROOT . '/perp_ledger/inc/class.bo_perp_ledger.inc.php');
	require_once( EGW_INCLUDE_ROOT . '/perp_ledger/inc/class.bo_perp_reconcile.inc.php');

	require_once( EGW_INCLUDE_ROOT . '/etemplate/inc/class.etemplate.inc.php');

	class ui_perp_reconcile {

		public $public_functions = array(
			'reconcile'	=>	true,
		);

		protected static $template;

		public function __construct() {
			if(!is_object(self::$template)) {
				self::$template = new etemplate();
			}
		}

		/**
		*	Reconcile a bank account
		*
		*	@param content	array	Data returned from eTemplate when the user submits the form
		*/
		public function reconcile($content = array()) {
			if($this->debug) {
				echo 'perp_ledger.ui_perp_ledger.reconcile incoming data:';
				_debug_array($content);
			}

			$select_box_options['account'] = array(''=> 'Select');
			$select_box_options['account'] += ExecMethod('perp_ledger.bo_perp_ledger.get_bank_accounts');
			$select_box_options['filter2'] = array('0' => 'Outstanding', '1' => 'All');
			$select_box_options['payment_method'] = ExecMethod('perp_api.bo_perp_api.get_payment_methods');

			// Match up keys with rows, trans_id comes from hidden input in the template that doesn't get sent in $content
			if(isset($_POST['exec']['nm']['rows'])) {
				foreach($_POST['exec']['nm']['rows'] as $key => $row) {
					if(is_numeric($key)) {
						$content['nm']['rows'][$key]['trans_id'] = $row['trans_id'];
						$content['nm']['rows'][$key]['outstanding'] = $row['outstanding'];
					}            
				}
			}

			// Deal with returned data
			if($content['save']) {
				foreach($content['nm']['rows'] as $row) {
					if($row['trans_id']) {
						if($row['clear']) {
							bo_perp_reconcile::clear_bank_transaction($content['statement_date'], $row['trans_id'], $content['account'], $row['clear']);
						} elseif($row['amount_cleared'] && $row['outstanding']) {
							bo_perp_reconcile::clear_bank_transaction($content['statement_date'], $row['trans_id'], $content['account'], $row['amount_cleared']);
						} else {
							bo_perp_reconcile::clear_bank_transaction($content['statement_date'], $row['trans_id'], $content['account'], 0);
						}
					}
				}
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/perp_ledger/index.php');
			}

			// Get data 

			$data['statement_date'] = $content['statement_date'] ? $content['statement_date'] : date('U', mktime(0,0,0, date('m') - 1, 1, date('Y')));
			$data['statement_balance'] = $content['statement_balance'];
			$data['account'] = $content['account'];
			$data['balance'] = bo_perp_ledger::get_bank_balance($data['statement_date'], $data['account']);
			$data['difference'] = round($data['balance'] - bo_perp_reconcile::get_reconciled_balance($data['statement_date'], $data['account']), 2);

			if($content['account']) {
				$data['nm'] = array(
					'no_cat'	=>	True,
					'no_filter'	=>	True,
					'filter2_label'	=>	'Show %s transactions',
					'filter2_no_lang'	=>	True,
					'filter2'	=>	$content['nm']['filter2'],
					'get_rows'      =>      'perp_ledger.bo_perp_reconcile.get_reconciliation',
					'template'	=>	'perp_ledger.reconcile.row',
				);
				$data['nm']['filter'] = $content['account'];
				$data['nm']['statement_date'] = $data['statement_date'];
			}

			// JavaScript
			if(!is_object($GLOBALS['egw']->js)) {
				$GLOBALS['egw']->js =& CreateObject('phpgwapi.javascript');
			}
			$GLOBALS['egw']->js->set_onload('mySetup()');
			$GLOBALS['egw']->js->validate_file('reconcile', 'reconcile', 'perp_ledger');

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('perp_ledger') .' - ' . lang('Bank Account') . ' ' . lang('Reconciliation');
			self::$template->read('perp_ledger.reconcile');
			self::$template->exec('perp_ledger.ui_perp_reconcile.reconcile', $data, $select_box_options, $readonly, $preserve);

		}
	}
?>
