<?php
	/**
        *       General Ledger Chart of Accounts
        *       This report lists the Chart of Accounts.
        *
        *       @author John Trudel
        *       @ingroup perp_ledger
        *       @ingroup perp_report
        */
        include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
        include_once(EGW_INCLUDE_ROOT . '/perp_ledger/inc/class.bo_perp_ledger.inc.php');

        class general_ledger_chart_of_accounts extends perp_report {
		
		private $bo_ledger;

                /**
                *       Constructor
                */
                function general_ledger_chart_of_accounts(array $parameters = array()) {
                        // JavaScript
                        if(!is_object($GLOBALS['egw']->js)) {
                                $GLOBALS['egw']->js =& CreateObject('phpgwapi.javascript');
                        }
			//add in suport for a select all button for a multi-selectbox
                        $GLOBALS['egw']->js->validate_file('api', 'multi_select', 'perp_api');

			parent::perp_report($parameters);
                        $this->bo_ledger = new bo_perp_ledger();
			$this->template = 'general_ledger_chart_of_accounts.odt';
			
			$account_groups = $this->bo_ledger->get_account_groups($query,$rows);
			$this->parameters['options-account_groups'] = $account_groups;
			if(!$parameters['account_groups']){
				$this->parameters['account_groups'] = array_keys($account_groups);
			}
			$this->parameters['options-sort_by'] = array(
				'account_id' => 'Account Number',
				'account_name' => 'Account Name',
				'group_name' => 'Group Name'
			);
                }

                /**
                *       Get the data for the report
                *
                *       @param query    array   Optional.  Report parameters, as set by the user.  These are passed from the template for this report.
                *       @return Data for TinyButStrong to generate the report
                */
                public function get_data($query = array()) {
			$query['template'] = false;
			$query['order'] = $query['sort_by'];
			$query['account_group'] = explode(",",$query['account_groups']);
			
			$this->bo_ledger->get_accounts($query,$rows);
			

			$data['accounts'] = $rows; 

			return $data;
		}
	}
?>
