/*
Javascript support for reconciliation
Recalculates total when a line is selected
*/

var statement_balance;
var account_balance;
var difference;
var outstanding;
var amount_fields = {};

function mySetup() {
	if (document.getElementsByTagName) {
		var checkboxes = document.getElementsByTagName('INPUT');
	} else if (document.all) {
		var checkboxes = document.all.tags('INPUT');
	} else {
		return;
	}

	// Assign event handlers
	for (i=0;i<checkboxes.length;++i) {
		if(checkboxes[i].type == 'checkbox') {
			var old = (checkboxes[i].onclick) ? checkboxes[i].onclick : function () {};
			if(checkboxes[i].addEventListener) {
				checkboxes[i].addEventListener('click', update_total, true);
			} else {
				checkboxes[i].onclick = function () {old(); update_total()};
			}
			if (checkboxes[i].captureEvents) {
				checkboxes[i].captureEvents(Event.CLICK);
			}
		} else if (checkboxes[i].name.indexOf('[amount_cleared]') != -1) {
			amount_fields[amount_fields.length] = parseFloat(checkboxes[i]);

			var old = (checkboxes[i].onchange) ? checkboxes[i].onchange : function () {};
			if(checkboxes[i].addEventListener) {
				checkboxes[i].addEventListener('change', update_total, true);
			} else {
				checkboxes[i].onchange = function () {old(); update_total()};
			}
		}
	}

	statement_balance = document.getElementById('exec[statement_balance]');
	account_balance = document.getElementById('exec[balance]');
	difference = document.getElementById('exec[difference]');
	outstanding = parseFloat(difference.value);

	return false;
}

function update_total(e) {
	var targ;
	if (!e) {
		var e = window.event;
	}
	if (e.target) {
		targ = e.target;
	} else if (e.srcElement) {
		targ = e.srcElement;
	}
	if (targ.nodeType == 3) { // defeat Safari bug
		targ = targ.parentNode;
	}

	// Get associated text box
	var base_id = targ.id.substr(0, targ.id.lastIndexOf('['));
	var row = base_id.substring(base_id.lastIndexOf('[') + 1, base_id.lastIndexOf(']'));
	var text = document.getElementById(base_id + '[amount_cleared]');
	var checkbox = document.getElementById(base_id + '[clear]');

	if(amount_fields[row]) {
		outstanding += amount_fields[row];
	}

	if(targ.checked) {
		text.value = parseFloat(targ.value).toFixed(2);
	} else if (targ.type == 'checkbox') {
		text.value = 0;
	} else {
		checkbox.checked =  ( parseFloat(text.value) == parseFloat(checkbox.value));
	}
		
	
	outstanding -= parseFloat(text.value);
	if(Math.abs(outstanding) < 0.0001) {
		outstanding = 0;
	}
	amount_fields[row] = parseFloat(text.value);
	difference.value = outstanding.toFixed(2);
}

function print_r(theObj) {
	if (theObj.constructor == Array || theObj.constructor == Object) {
		document.write("<ul>")
		for (var p in theObj) {
			if (theObj[p].constructor == Array || theObj[p].constructor == Object) {
				document.write("<li>["+p+"] => "+typeof(theObj)+"</li>");
				document.write("<ul>")
				print_r(theObj[p]);
				document.write("</ul>")
			} else {
				document.write("<li>["+p+"] => "+theObj[p]+"</li>");
			}
		}
		document.write("</ul>")
	}
}
