<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


$phpgw_baseline = array(
	'perp_general_ledger' => array(
		'fd' => array(
			'trans_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
			'trans_date' => array('type' => 'date','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
			'narrative' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('trans_no','line_no'),
		'fk' => array('trans_type' => 'perp_transaction_type.trans_id','account' => 'perp_account.account_id'),
		'ix' => array('trans_no'),
		'uc' => array(array('trans_no','line_no'))
	),
	'perp_transaction_type' => array(
		'fd' => array(
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'trans_name' => array('type' => 'varchar','precision' => '50','nullable' => False)
		),
		'pk' => array('trans_id'),
		'fk' => array(),
		'ix' => array('trans_id'),
		'uc' => array('trans_id')
	),
	'perp_account' => array(
		'fd' => array(
			'account_id' => array('type' => 'varchar','precision' => '7'),
			'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'account_group' => array('type' => 'varchar','precision' => '3','nullable' => False)
		),
		'pk' => array('account_id'),
		'fk' => array('account_group' => 'perp_account_group.group_id'),
		'ix' => array('account_group'),
		'uc' => array()
	),
	'perp_account_group' => array(
		'fd' => array(
			'group_name' => array('type' => 'varchar','precision' => '255'),
			'group_section' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'group_id' => array('type' => 'varchar','precision' => '3'),
			'asset_or_liability' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1')
		),
		'pk' => array('group_id'),
		'fk' => array('group_section' => 'perp_account_section.section_id'),
		'ix' => array('group_name','group_section'),
		'uc' => array('group_name')
	),
	'perp_account_section' => array(
		'fd' => array(
			'section_id' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'section_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'section_sequence' => array('type' => 'varchar','precision' => '2','nullable' => False)
		),
		'pk' => array('section_id'),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	),
	'perp_bank_account' => array(
		'fd' => array(
			'bank_account_id' => array('type' => 'varchar','precision' => '7'),
			'bank_account_name' => array('type' => 'varchar','precision' => '50'),
			'bank_account_number' => array('type' => 'varchar','precision' => '255'),
			'bank_address' => array('type' => 'int','precision' => '4'),
			'currency' => array('type' => 'varchar','precision' => '3'),
			'payment_methods' => array('type' => 'varchar','precision' => '255'),
			'sort_order' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0')
		),
		'pk' => array('bank_account_id'),
		'fk' => array('bank_account_id' => 'perp_account.account_id','currency' => 'perp_currency.currency_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_bank_ledger' => array(
		'fd' => array(
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'bank_account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'exchange_rate' => array('type' => 'decimal','precision' => '4','scale' => '3','nullable' => False,'default' => '1'),
			'payment_method' => array('type' => 'int','precision' => '4','nullable' => False),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
			'currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('trans_id','line_no'),
		'fk' => array('trans_id' => 'perp_general_ledger.trans_id','bank_account' => 'perp_bank_account.bank_account_id','payment_method' => 'perp_payment_method.id','currency' => 'perp_currency.currency_id','line_no' => 'perp_general_ledger.line_no'),
		'ix' => array('trans_id'),
		'uc' => array()
	),
	'perp_sequence' => array(
		'fd' => array(
			'sequence_id' => array('type' => 'varchar','precision' => '2'),
			'sequence_name' => array('type' => 'varchar','precision' => '50','nullable' => False)
		),
		'pk' => array('sequence_id'),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	),
	'perp_eft_account' => array(
		'fd' => array(
			'account_id' => array('type' => 'int','precision' => '4'),
			'eft_type' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'eft_data' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'enabled' => array('type' => 'bool','nullable' => False,'default' => 'true')
		),
		'pk' => array('account_id'),
		'fk' => array('account_id' => 'perp_account.account_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_bank_reconcile' => array(
		'fd' => array(
			'trans_id' => array('type' => 'int','precision' => '4'),
			'account' => array('type' => 'varchar','precision' => '7'),
			'statement_date' => array('type' => 'date'),
			'amount_cleared' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('trans_id','account','statement_date','line_no'),
		'fk' => array('trans_id' => 'perp_bank_ledger.trans_id','line_no' => 'perp_bank_ledger.line_no'),
		'ix' => array(),
		'uc' => array()
	)
);
