<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */

// Required to force tables to InnoDB
require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.so_perp_api.inc.php');

// Force tables to InnoDB
so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_ledger');

	$test[] = '0.1.0';
	function perp_ledger_upgrade0_1_0()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_transaction_type',array(
			'fd' => array(
				'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_name' => array('type' => 'varchar','precision' => '255','nullable' => False)
			),
			'pk' => array('trans_type'),
			'fk' => array(),
			'ix' => array('trans_type'),
			'uc' => array('trans_type','trans_name')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.001';
	}


	$test[] = '0.1.001';
	function perp_ledger_upgrade0_1_001()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_general_ledger',array(
			'fd' => array(
				'trans_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'date' => array('type' => 'date','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'account' => array('type' => 'int','precision' => '4','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '10','nullable' => False),
				'narrative' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('trans_no','line_no'),
//			'fk' => array('trans_type' => 'perp_transaction_types.trans_type'),
			'ix' => array('trans_no'),
			'uc' => array(array('trans_no','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.002';
	}


	$test[] = '0.1.002';
	function perp_ledger_upgrade0_1_002()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_general_ledger',array(
			'fd' => array(
				'trans_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'date' => array('type' => 'date','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'account' => array('type' => 'int','precision' => '4','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '10','nullable' => False),
				'narrative' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('trans_no','line_no'),
			'fk' => array(),
			'ix' => array('trans_no'),
			'uc' => array(array('trans_no','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.003';
	}


	$test[] = '0.1.003';
	function perp_ledger_upgrade0_1_003()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_transaction_type',array(
			'fd' => array(
				'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_name' => array('type' => 'varchar','precision' => '255','nullable' => False)
			),
			'pk' => array('trans_type'),
			'fk' => array(),
			'ix' => array('trans_type'),
			'uc' => array('trans_type')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.004';
	}


	$test[] = '0.1.004';
	function perp_ledger_upgrade0_1_004()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_general_ledger','date','trans_date');

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.005';
	}


	$test[] = '0.1.005';
	function perp_ledger_upgrade0_1_005()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_account',array(
			'fd' => array(
				'account_code' => array('type' => 'int','precision' => '4','nullable' => False),
				'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False)
			),
			'pk' => array('account_code'),
			'fk' => array(),
			'ix' => array('account_code'),
			'uc' => array('account_code')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.006';
	}


	$test[] = '0.1.006';
	function perp_ledger_upgrade0_1_006()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_account_group',array(
			'fd' => array(
				'group_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'group_section' => array('type' => 'int','precision' => '4'),
				'sequence' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('group_name'),
			'fk' => array(),
			'ix' => array('group_name','group_section'),
			'uc' => array('group_name')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.007';
	}


	$test[] = '0.1.007';
	function perp_ledger_upgrade0_1_007()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_account','account_group',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account',array(
			'fd' => array(
				'account_code' => array('type' => 'int','precision' => '4','nullable' => False),
				'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'account_group' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('account_code'),
			'fk' => array(),
			'ix' => array('account_code','account_group'),
			'uc' => array('account_code')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.008';
	}


	$test[] = '0.1.008';
	function perp_ledger_upgrade0_1_008()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_group','group_name',array(
			'type' => 'varchar',
			'precision' => '255'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_account_group','group_code',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account_group',array(
			'fd' => array(
				'group_name' => array('type' => 'varchar','precision' => '255'),
				'group_section' => array('type' => 'int','precision' => '4'),
				'sequence' => array('type' => 'int','precision' => '4'),
				'group_code' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('group_code'),
			'fk' => array(),
			'ix' => array('group_name','group_section','group_code'),
			'uc' => array('group_name','group_code')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.009';
	}


	$test[] = '0.1.009';
	function perp_ledger_upgrade0_1_009()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_account_section',array(
			'fd' => array(
				'section_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'section_name' => array('type' => 'varchar','precision' => '255','nullable' => False)
			),
			'pk' => array('section_id'),
			'fk' => array(),
			'ix' => array('section_id'),
			'uc' => array('section_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.010';
	}


	$test[] = '0.1.010';
	function perp_ledger_upgrade0_1_010()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_general_ledger',array(
			'fd' => array(
				'trans_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_date' => array('type' => 'date','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'account' => array('type' => 'int','precision' => '4','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '10','nullable' => False),
				'narrative' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('trans_no','line_no'),
//			'fk' => array('trans_type' => 'perp_transaction_types.type_id'),
			'ix' => array('trans_no'),
			'uc' => array(array('trans_no','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.011';
	}


	$test[] = '0.1.011';
	function perp_ledger_upgrade0_1_011()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_general_ledger',array(
			'fd' => array(
				'trans_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_date' => array('type' => 'date','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'account' => array('type' => 'int','precision' => '4','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '10','nullable' => False),
				'narrative' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('trans_no','line_no'),
//			'fk' => array('trans_type' => 'perp_transaction_types.type_id','account' => 'perp_account.account_code'),
			'ix' => array('trans_no'),
			'uc' => array(array('trans_no','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.012';
	}


	$test[] = '0.1.012';
	function perp_ledger_upgrade0_1_012()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account',array(
			'fd' => array(
				'account_code' => array('type' => 'int','precision' => '4','nullable' => False),
				'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'account_group' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('account_code'),
//			'fk' => array('account_group' => 'perp_account_group.group_id'),
			'ix' => array('account_code','account_group'),
			'uc' => array('account_code')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.013';
	}


	$test[] = '0.1.013';
	function perp_ledger_upgrade0_1_013()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account',array(
			'fd' => array(
				'account_code' => array('type' => 'int','precision' => '4','nullable' => False),
				'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'account_group' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('account_code'),
//			'fk' => array('account_group' => 'perp_account_group.group_code'),
			'ix' => array('account_code','account_group'),
			'uc' => array('account_code')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.014';
	}


	$test[] = '0.1.014';
	function perp_ledger_upgrade0_1_014()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_transaction_type','trans_type',array(
			'type' => 'auto',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.015';
	}


	$test[] = '0.1.015';
	function perp_ledger_upgrade0_1_015()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_group','group_code',array(
			'type' => 'auto',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.016';
	}


	$test[] = '0.1.016';
	function perp_ledger_upgrade0_1_016()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_section','section_id',array(
			'type' => 'auto',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.017';
	}


	$test[] = '0.1.017';
	function perp_ledger_upgrade0_1_017()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_section','section_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.018';
	}


	$test[] = '0.1.018';
	function perp_ledger_upgrade0_1_018()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_group','group_code',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.019';
	}


	$test[] = '0.1.019';
	function perp_ledger_upgrade0_1_019()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_transaction_type','trans_type',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.020';
	}


	$test[] = '0.1.020';
	function perp_ledger_upgrade0_1_020()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_transaction_type',array(
			'fd' => array(
				'trans_name' => array('type' => 'varchar','precision' => '255','nullable' => False)
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array(),
			'uc' => array()
		),'trans_type');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_transaction_type','trans_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_transaction_type',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_name' => array('type' => 'varchar','precision' => '255','nullable' => False)
			),
			'pk' => array('trans_id'),
			'fk' => array(),
			'ix' => array('trans_id'),
			'uc' => array('trans_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.021';
	}


	$test[] = '0.1.021';
	function perp_ledger_upgrade0_1_021()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_account',array(
			'fd' => array(
				'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'account_group' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('account_group' => 'perp_account_group.group_code'),
			'ix' => array('account_group'),
			'uc' => array()
		),'account_code');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_account','account_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account',array(
			'fd' => array(
				'account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'account_group' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('account_id'),
			'fk' => array('account_group' => 'perp_account_group.group_code'),
			'ix' => array('account_id','account_group'),
			'uc' => array('account_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.022';
	}


	$test[] = '0.1.022';
	function perp_ledger_upgrade0_1_022()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_account_group',array(
			'fd' => array(
				'group_name' => array('type' => 'varchar','precision' => '255'),
				'group_section' => array('type' => 'int','precision' => '4'),
				'sequence' => array('type' => 'int','precision' => '4')
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array('group_name','group_section'),
			'uc' => array('group_name')
		),'group_code');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_account_group','group_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account_group',array(
			'fd' => array(
				'group_name' => array('type' => 'varchar','precision' => '255'),
				'group_section' => array('type' => 'int','precision' => '4'),
				'sequence' => array('type' => 'int','precision' => '4'),
				'group_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('group_id'),
			'fk' => array(),
			'ix' => array('group_name','group_section','group_id'),
			'uc' => array('group_name','group_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.023';
	}


	$test[] = '0.1.023';
	function perp_ledger_upgrade0_1_023()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_bank_account',array(
			'fd' => array(
				'bank_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'bank_account_name' => array('type' => 'varchar','precision' => '50'),
				'bank_account_number' => array('type' => 'varchar','precision' => '255'),
				'bank_address' => array('type' => 'text')
			),
			'pk' => array('bank_account_id'),
			'fk' => array(),
			'ix' => array('bank_account_id'),
			'uc' => array('bank_account_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.024';
	}


	$test[] = '0.1.024';
	function perp_ledger_upgrade0_1_024()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_currency',array(
			'fd' => array(
				'currency_id' => array('type' => 'varchar','precision' => '3','nullable' => False),
				'currency' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'country' => array('type' => 'varchar','precision' => '50'),
				'hundreds_name' => array('type' => 'varchar','precision' => '20'),
				'exchange_rate' => array('type' => 'decimal','nullable' => False,'default' => '1')
			),
			'pk' => array('currency_id'),
			'fk' => array(),
			'ix' => array('currency_id'),
			'uc' => array('currency_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.025';
	}


	$test[] = '0.1.025';
	function perp_ledger_upgrade0_1_025()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_currency','currency','currency_name');

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.026';
	}


	$test[] = '0.1.026';
	function perp_ledger_upgrade0_1_026()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_currency','country',array(
			'type' => 'varchar',
			'precision' => '6'
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.027';
	}


	$test[] = '0.1.027';
	function perp_ledger_upgrade0_1_027()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_currency','exchange_rate',array(
			'type' => 'float',
			'precision' => '4',
			'nullable' => False,
			'default' => '1.00'
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.028';
	}


	$test[] = '0.1.028';
	function perp_ledger_upgrade0_1_028()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_transaction_type','trans_name',array(
			'type' => 'varchar',
			'precision' => '50',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.029';
	}


	$test[] = '0.1.029';
	function perp_ledger_upgrade0_1_029()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_account_group',array(
			'fd' => array(
				'group_name' => array('type' => 'varchar','precision' => '255'),
				'group_section' => array('type' => 'int','precision' => '4'),
				'group_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('group_id'),
			'fk' => array(),
			'ix' => array('group_name','group_section','group_id'),
			'uc' => array('group_name','group_id')
		),'sequence');

		$GLOBALS['egw_setup']->oProc->AddColumn('perp_account_section','section_sequence',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.030';
	}


	$test[] = '0.1.030';
	function perp_ledger_upgrade0_1_030()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_bank_account','currency',array(
			'type' => 'varchar',
			'precision' => '3'
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.031';
	}


	$test[] = '0.1.031';
	function perp_ledger_upgrade0_1_031()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account_group',array(
			'fd' => array(
				'group_name' => array('type' => 'varchar','precision' => '255'),
				'group_section' => array('type' => 'int','precision' => '4'),
				'group_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('group_id'),
			'fk' => array('group_section' => 'perp_account_section.section_id'),
			'ix' => array('group_name','group_section','group_id'),
			'uc' => array('group_name','group_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.032';
	}


	$test[] = '0.1.032';
	function perp_ledger_upgrade0_1_032()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_bank_account',array(
			'fd' => array(
				'bank_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'bank_account_name' => array('type' => 'varchar','precision' => '50'),
				'bank_account_number' => array('type' => 'varchar','precision' => '255'),
				'bank_address' => array('type' => 'text'),
				'currency' => array('type' => 'varchar','precision' => '3')
			),
			'pk' => array('bank_account_id'),
			'fk' => array('currency' => 'perp_currency.currency_id'),
			'ix' => array('bank_account_id'),
			'uc' => array('bank_account_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.033';
	}


	$test[] = '0.1.033';
	function perp_ledger_upgrade0_1_033()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_bank_ledger',array(
			'fd' => array(
				'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'bank_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'amount_cleared' => array('type' => 'float','precision' => '4','nullable' => False),
				'exchange_rate' => array('type' => 'float','precision' => '6','nullable' => False,'default' => '1'),
				'payment_method' => array('type' => 'int','precision' => '4','nullable' => False),
				'amount' => array('type' => 'float','precision' => '4','nullable' => False),
				'currency' => array('type' => 'varchar','precision' => '3','nullable' => False)
			),
			'pk' => array('trans_id'),
			'fk' => array('trans_id' => 'perp_general_ledger.trans_id','bank_account' => 'perp_bank_account.bank_account_id','payment_method' => 'perp_payment_method.id','currency' => 'perp_currency.currency_id'),
			'ix' => array('trans_id'),
			'uc' => array('trans_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.034';
	}


	$test[] = '0.1.034';
	function perp_ledger_upgrade0_1_034()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_general_ledger','amount',array(
			'type' => 'decimal',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.035';
	}


	$test[] = '0.1.035';
	function perp_ledger_upgrade0_1_035()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','amount_cleared',array(
			'type' => 'decimal',
			'nullable' => False
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','exchange_rate',array(
			'type' => 'decimal',
			'nullable' => False,
			'default' => '1'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','amount',array(
			'type' => 'decimal',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.036';
	}


	$test[] = '0.1.036';
	function perp_ledger_upgrade0_1_036()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_general_ledger','amount',array(
			'type' => 'decimal',
			'precision' => '4',
			'scale' => '2',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.037';
	}


	$test[] = '0.1.037';
	function perp_ledger_upgrade0_1_037()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','amount_cleared',array(
			'type' => 'decimal',
			'precision' => '2',
			'nullable' => False
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','exchange_rate',array(
			'type' => 'decimal',
			'precision' => '4',
			'scale' => '3',
			'nullable' => False,
			'default' => '1'
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','amount',array(
			'type' => 'decimal',
			'precision' => '2',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.038';
	}


	$test[] = '0.1.038';
	function perp_ledger_upgrade0_1_038()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_general_ledger','amount',array(
			'type' => 'decimal',
			'precision' => '2',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.039';
	}


	$test[] = '0.1.039';
	function perp_ledger_upgrade0_1_039()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','amount_cleared',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '2',
			'nullable' => False
		));
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','amount',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '2',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.040';
	}


	$test[] = '0.1.040';
	function perp_ledger_upgrade0_1_040()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_general_ledger','amount',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '2',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.041';
	}


	$test[] = '0.1.041';
	function perp_ledger_upgrade0_1_041()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_general_ledger',array(
			'fd' => array(
				'trans_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_date' => array('type' => 'date','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'account' => array('type' => 'int','precision' => '4','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'narrative' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('trans_no','line_no'),
			'fk' => array('trans_type' => 'perp_transaction_types.type_id','account' => 'perp_account.account_id'),
			'ix' => array('trans_no'),
			'uc' => array(array('trans_no','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.042';
	}


	$test[] = '0.1.042';
	function perp_ledger_upgrade0_1_042()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_general_ledger',array(
			'fd' => array(
				'trans_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'trans_date' => array('type' => 'date','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'account' => array('type' => 'int','precision' => '4','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'narrative' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('trans_no','line_no'),
			'fk' => array('trans_type' => 'perp_transaction_type.trans_id','account' => 'perp_account.account_id'),
			'ix' => array('trans_no'),
			'uc' => array(array('trans_no','line_no'))
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.043';
	}


	$test[] = '0.1.043';
	function perp_ledger_upgrade0_1_043()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account',array(
			'fd' => array(
				'account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'account_group' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('account_id'),
			'fk' => array('account_group' => 'perp_account_group.group_id'),
			'ix' => array('account_id','account_group'),
			'uc' => array('account_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.044';
	}


	$test[] = '0.1.044';
	function perp_ledger_upgrade0_1_044()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_bank_account',array(
			'fd' => array(
				'bank_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'bank_account_name' => array('type' => 'varchar','precision' => '50'),
				'bank_account_number' => array('type' => 'varchar','precision' => '255'),
				'bank_address' => array('type' => 'text'),
				'currency' => array('type' => 'varchar','precision' => '3')
			),
			'pk' => array('bank_account_id'),
			'fk' => array('bank_account_id' => 'perp_account.account_id','currency' => 'perp_currency.currency_id'),
			'ix' => array('bank_account_id'),
			'uc' => array('bank_account_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.045';
	}


	$test[] = '0.1.045';
	function perp_ledger_upgrade0_1_045()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_account_group','asset_or_liability',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.046';
	}


	$test[] = '0.1.047';
	function perp_ledger_upgrade0_1_047()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_sequence',array(
			'fd' => array(
				'sequence_id' => array('type' => 'auto','nullable' => False),
				'sequence_name' => array('type' => 'varchar','precision' => '20','nullable' => False)
			),
			'pk' => array('sequence_id'),
			'fk' => array(),
			'ix' => array('sequence_id'),
			'uc' => array('sequence_id')
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.048';
	}


	$test[] = '0.1.048';
	function perp_ledger_upgrade0_1_048()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sequence','sequence_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.049';
	}


	$test[] = '0.1.049';
	function perp_ledger_upgrade0_1_049()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sequence','sequence_name',array(
			'type' => 'varchar',
			'precision' => '50',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.050';
	}


	$test[] = '0.1.050';
	function perp_ledger_upgrade0_1_050()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_account','bank_address',array(
			'type' => 'int',
			'precision' => '4'
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.051';
	}


	$test[] = '0.1.051';
	function perp_ledger_upgrade0_1_051()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_eft_account',array(
			'fd' => array(
				'account_id' => array('type' => 'int','precision' => '4'),
				'eft_type' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'eft_data' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'enabled' => array('type' => 'bool','nullable' => False,'default' => 'true')
			),
			'pk' => array('account_id'),
			'fk' => array('account_id' => 'perp_account.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.052';
	}


	$test[] = '0.1.052';
	function perp_ledger_upgrade0_1_052()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_account','bank_account_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_bank_account','payment_methods',array(
			'type' => 'varchar',
			'precision' => '255'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_bank_account',array(
			'fd' => array(
				'bank_account_id' => array('type' => 'int','precision' => '4'),
				'bank_account_name' => array('type' => 'varchar','precision' => '50'),
				'bank_account_number' => array('type' => 'varchar','precision' => '255'),
				'bank_address' => array('type' => 'int','precision' => '4'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'payment_methods' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('bank_account_id'),
			'fk' => array('bank_account_id' => 'perp_account.account_id','currency' => 'perp_currency.currency_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.1.053';
	}

	$test[] = '0.1.053';
	function perp_ledger_upgrade0_1_053()
	{
		if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
			// These tables need to be InnoDB
			$transaction_tables = array(
				'perp_general_ledger',
				'perp_bank_ledger',
			);
			$so_perp_api = CreateObject('perp_api.so_perp_api');
			$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_ledger', $transaction_tables);
		}
		return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2';
	}


$test[] = '0.2';
function perp_ledger_upgrade0_2()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_general_ledger','account',array(
		'type' => 'varchar',
		'precision' => '7',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.001';
}


$test[] = '0.2.001';
function perp_ledger_upgrade0_2_001()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_ledger','bank_account',array(
		'type' => 'varchar',
		'precision' => '7',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.002';
}


$test[] = '0.2.002';
function perp_ledger_upgrade0_2_002()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_bank_account','bank_account_id',array(
		'type' => 'varchar',
		'precision' => '7'
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.003';
}


$test[] = '0.2.003';
function perp_ledger_upgrade0_2_003()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account','account_id',array(
		'type' => 'varchar',
		'precision' => '7'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account',array(
		'fd' => array(
			'account_id' => array('type' => 'varchar','precision' => '7'),
			'account_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'account_group' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('account_id'),
		'fk' => array('account_group' => 'perp_account_group.group_id'),
		'ix' => array('account_group'),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.004';
}


$test[] = '0.2.004';
function perp_ledger_upgrade0_2_004()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_group','group_id',array(
		'type' => 'varchar',
		'precision' => '3'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account_group',array(
		'fd' => array(
			'group_name' => array('type' => 'varchar','precision' => '255'),
			'group_section' => array('type' => 'int','precision' => '4'),
			'group_id' => array('type' => 'varchar','precision' => '3'),
			'asset_or_liability' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1')
		),
		'pk' => array('group_id'),
		'fk' => array('group_section' => 'perp_account_section.section_id'),
		'ix' => array('group_name','group_section'),
		'uc' => array('group_name')
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.005';
}


$test[] = '0.2.005';
function perp_ledger_upgrade0_2_005()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_section','section_id',array(
		'type' => 'varchar',
		'precision' => '3',
		'nullable' => False
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_account_section',array(
		'fd' => array(
			'section_id' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'section_name' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'section_sequence' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('section_id'),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.006';
}


$test[] = '0.2.006';
function perp_ledger_upgrade0_2_006()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sequence','sequence_id',array(
		'type' => 'varchar',
		'precision' => '2'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sequence',array(
		'fd' => array(
			'sequence_id' => array('type' => 'varchar','precision' => '2'),
			'sequence_name' => array('type' => 'varchar','precision' => '50','nullable' => False)
		),
		'pk' => array('sequence_id'),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.007';
}


$test[] = '0.2.007';
function perp_ledger_upgrade0_2_007()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account','account_group',array(
		'type' => 'varchar',
		'precision' => '3',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.008';
}


$test[] = '0.2.008';
function perp_ledger_upgrade0_2_008()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_group','group_section',array(
		'type' => 'varchar',
		'precision' => '3',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.009';
}


$test[] = '0.2.009';
function perp_ledger_upgrade0_2_009()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_account_section','section_sequence',array(
		'type' => 'varchar',
		'precision' => '2',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.010';
}


$test[] = '0.2.010';
function perp_ledger_upgrade0_2_010() {
	// Trigger an update to force table types
	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.011';
}

function perp_ledger_upgrade0_2_011()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_bank_reconcile',array(
		'fd' => array(
			'trans_id' => array('type' => 'int','precision' => '4'),
			'account' => array('type' => 'varchar','precision' => '7'),
			'statement_date' => array('type' => 'date'),
			'amount_cleared' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
		),
		'pk' => array('trans_id','account','statement_date'),
		'fk' => array('trans_id' => 'perp_bank_ledger.trans_id'),
		'ix' => array(),
		'uc' => array()
	));

	echo 'Bank reconciliation has been reset.  It never worked properly before, but if you have done any reconciliation, it has been reset.<br />';
	
	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.012';
}

function perp_ledger_upgrade0_2_012()
{
	$GLOBALS['egw_setup']->oProc->DropColumn('perp_bank_ledger',array(
		'fd' => array(
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'bank_account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'exchange_rate' => array('type' => 'decimal','precision' => '4','scale' => '3','nullable' => False,'default' => '1'),
			'payment_method' => array('type' => 'int','precision' => '4','nullable' => False),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
			'currency' => array('type' => 'varchar','precision' => '3','nullable' => False)
		),
		'pk' => array('trans_id'),
		'fk' => array('trans_id' => 'perp_general_ledger.trans_id','bank_account' => 'perp_bank_account.bank_account_id','payment_method' => 'perp_payment_method.id','currency' => 'perp_currency.currency_id'),
		'ix' => array('trans_id'),
		'uc' => array('trans_id')
	),'amount_cleared');

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.013';
}


function perp_ledger_upgrade0_2_013()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_bank_account','sort_order',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False,
		'default' => '0'
	));

	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.014';
}


function perp_ledger_upgrade0_2_014()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_bank_ledger','line_no',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_bank_ledger',array(
		'fd' => array(
			'trans_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'bank_account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'exchange_rate' => array('type' => 'decimal','precision' => '4','scale' => '3','nullable' => False,'default' => '1'),
			'payment_method' => array('type' => 'int','precision' => '4','nullable' => False),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
			'currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('trans_id','line_no'),
		'fk' => array('trans_id' => 'perp_general_ledger.trans_id','bank_account' => 'perp_bank_account.bank_account_id','payment_method' => 'perp_payment_method.id','currency' => 'perp_currency.currency_id','line_no' => 'perp_general_ledger.line_no'),
		'ix' => array('trans_id'),
		'uc' => array()
	));

	$sql = 'UPDATE perp_bank_ledger
		JOIN perp_general_ledger ON 
		    perp_bank_ledger.trans_id = trans_no 
		    AND bank_account = account 
		SET perp_bank_ledger.line_no = perp_general_ledger.line_no
		WHERE perp_bank_ledger.line_no != perp_general_ledger.line_no';
	$GLOBALS['egw_setup']->oProc->query($sql);


	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.015';
}


function perp_ledger_upgrade0_2_015()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_bank_reconcile','line_no',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_bank_reconcile',array(
		'fd' => array(
			'trans_id' => array('type' => 'int','precision' => '4'),
			'account' => array('type' => 'varchar','precision' => '7'),
			'statement_date' => array('type' => 'date'),
			'amount_cleared' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('trans_id','account','statement_date','line_no'),
		'fk' => array('trans_id' => 'perp_bank_ledger.trans_id','line_no' => 'perp_bank_ledger.line_no'),
		'ix' => array(),
		'uc' => array()
	));

	$sql = 'UPDATE perp_bank_reconcile
		JOIN perp_bank_ledger ON 
		    perp_bank_ledger.trans_id = perp_bank_reconcile.trans_id 
		    AND bank_account = account 
		SET perp_bank_reconcile.line_no = perp_bank_ledger.line_no';
	$GLOBALS['egw_setup']->oProc->query($sql);


	return $GLOBALS['setup_info']['perp_ledger']['currentver'] = '0.2.016';
}

