<?php

	require_once(EGW_API_INC.'/xajax.inc.php');
	require_once('class.ui_perp_bill_of_material.inc.php');

	class ajax_perp_bill_of_material {

		private $ui;
		private $xajax;
		protected $response;

		public function __construct() {
			$this->ui =& new ui_perp_bill_of_material();
			$this->xajax =& new xajax();
			$this->response = new xajaxResponse();
		}

		public function add_component($bom_id, $stock_id, $key, $work_center = '', $quantity = 1, $time = 0) {
			$bom =& $this->get_bill_of_materials($bom_id);
			$details = array(
				'component'	=>	$stock_id,
				'stock_id'	=>	$stock_id,
				'work_center'	=>	$work_center,
				'quantity'	=>	$quantity,
				'time'		=>	$time
			);
			$bom['details'][$key] = $details;

			$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);

			$node_key = $bom['bill_of_material_id'] . '/' . $key;
			$tree_node = $this->ui->make_tree_node(
				($stock['stock_type_flag'] == 'A' ? 'ASSEMBLY' : 'RAW'), 
				$node_key,
				$details,
				($GLOBALS['egw_info']['flags']['currentapp'] != 'perp_manufacturing')
			);

			$this->response->addScript("
				bill_of_materials.insertNewItem(
					'" . $bom['bill_of_material_id'] . "',
					'" . $node_key . "',
					'" . addslashes($tree_node['label']) . "',
					onNodeSelect_bill_of_materials,
					'" . $tree_node['image'] . "',
					'" . $tree_node['image'] . "',
					'" . $tree_node['image'] . "',
					'CHILD'
				);"
			);

			return $this->response->getXML();
		}

		/**
		*	Remove a component from the bill of materials currently stored in
		*	the session variable
		*/
		public function remove_component($bom_id, $node_key) {
			$bom =& $this->get_bill_of_materials($bom_id);
			$detail_key = str_replace($bom['bill_of_material_id'] . '/', '', $node_key);
			unset($bom['details'][$detail_key]);
			$this->response->addScript("bill_of_materials.deleteItem('$node_key', false);");
			return $this->response->getXML();
		}

		/**
		*	Retrieve a reference to bill of materials stored in the session
		*/
		protected function &get_bill_of_materials($bom_id) {
			$bom =& $GLOBALS['egw']->session->appsession('bill_of_material' . $bom_id, 'perp_manufacturing');
			return $bom;
		}
	}
?>
