<?php

	class hook_perp_manufacturing {

		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
			'admin_hook'	=>	True,
			'workflow_agent'	=>	True,
		);

		var $appname = 'perp_manufacturing';
		private $erp;

		public function hook_perp_manufacturing() {
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file = array(
				'Site configuration'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_manufacturing.hook_perp_manufacturing.config',
				)),
				'Configure Access Permissions'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_manufacturing.hook_perp_manufacturing.acl',
				)),
				'Serial Number Setup'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_manufacturing.ui_perp_manufacturing.serials',
				)),
			);

			display_section($this->appname, $file);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences']            = $GLOBALS['egw']->link('/preferences/preferences.php','appname='.$this->appname);

			//Do not modify below this line
			display_section($this->appname,$this->appname,$file);
		}

		public function user_preferences() {
		}

		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			$menu = array(
				'Bill of Materials'	=>	$GLOBALS['egw']->link('/index.php','menuaction=perp_manufacturing.ui_perp_bill_of_material.bill_of_material_list'),
				//'_NewLine_'	=>	'', // give a newline
			);
			if($GLOBALS['egw']->acl->check('build_option', EGW_ACL_READ, 'perp_manufacturing')) {
				$menu['Build Options']			=	$GLOBALS['egw']->link('/index.php','menuaction=perp_manufacturing.ui_perp_build_option.build_option_category_list');
				$menu['Build Option Exclusion Matrix']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_manufacturing.ui_perp_build_option.exclusion_matrix');
			}
			if($GLOBALS['egw']->acl->check('work_order', EGW_ACL_READ, 'perp_manufacturing')) {
				$menu['Work Order List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_manufacturing.ui_perp_work_order.work_order_list');
			}
			display_sidebox($this->appname, $menu_title, $menu);
			
				
			$menu_title = $GLOBALS['egw_info']['apps']['perp_inventory']['title'] . ' ' . lang('Menu');
			$menu = array();
			if($GLOBALS['egw']->acl->check('stock', EGW_ACL_READ, 'perp_inventory')) {
				$menu['Stock List']		=	$GLOBALS['egw']->link('/index.php','menuaction=perp_inventory.ui_perp_stock.stock_list');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
				
			$menu_title = lang('Actions');

			$menu = array();
			if($GLOBALS['egw']->acl->check('work_order', EGW_ACL_ADD, 'perp_manufacturing')) {
				$menu['New Work Order']			=	$GLOBALS['egw']->link('/index.php','menuaction=perp_manufacturing.ui_perp_work_order.work_order_new');
			//	$menu['New Batch of Work Orders']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_manufacturing.ui_perp_work_order.work_order_batch');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
		}

		public function config($content = array()) {
			// validation & correction
			//...
			$selects['costing'] = array(
				'fifo'	=>	lang('FIFO')
			);
			$selects['creation_transaction_type'] = ExecMethod('perp_ledger.bo_perp_ledger.get_transaction_types');
			$selects['scheduling'] = array(
				'avg_hours'	=>	'Average Hours',
		//		'work_center'	=>	'By work center',
			);
			$selects['default_location'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');


			$data['settings'] = array(
				'work_order_number_params' => array(
					lang('%1 is replaced with %2', '&#37;1$d', lang('Next work order ID number')),
					lang('%1 is replaced with %2', '&#37;2$d', lang('Stock ID number')),
					lang('%1 is replaced with %2', '&#37;3$d', lang('Stock category ID')),
				),
			);
			$config = config::read('perp_manufacturing');
			if($config['use_workflow']) {
				$process_list = ExecMethod2('workflow.workflow_processmanager.list_processes', 0, -1, 'wf_name__asc', null);
				foreach($process_list['data'] as $process) {
						$data['settings']['wf_processes'][] = $process;
						$data['settings']['wf_processes']['production_start_activity'][$process['wf_p_id']] = $config['wf_processes']['production_start_activity'][$process['wf_p_id']];

					// Add workflow activities into the Status filter
					$activity_list = ExecMethod('workflow.workflow_activitymanager.get_process_activities', $process['wf_p_id'] );
					$activity_number = array();

					// Sort activities so they're in approximate order
					if(is_array($activity_list)) {
						foreach($activity_list as $key => $act) {
							$activity_number[$key] = $act['wf_flow_num'];
						}
						array_multisort($activity_number, $activity_list);

						$activities = array();
						foreach($activity_list as $act) {
							$activities[$act['wf_activity_id']] = $act['wf_name'];
						}
						$selects['production_start_activity[' . $process['wf_p_id'] . ']'] = array('' => lang('Never')) + $activities;
					}
				
				}
			}

			$this->erp->config($content, $this->appname, 'perp_manufacturing.hook_perp_manufacturing.config',$selects, '', $data);
		}

		public function acl($content = array()) {
			$data = $this->erp->acl($content, 'perp_manufacturing', 'acl', 'acl', $selects, $filters);
		}

		public function home($args = null) {
		}

		/*	search_link is for linking (link widget)
		*/
		public function search_link($params) {

			return array(
				'query'	=>	'perp_manufacturing.bo_perp_manufacturing.link_query',
				'title'	=>	'perp_manufacturing.bo_perp_manufacturing.link_title',
				'view'	=>	array('menuaction'=>'perp_manufacturing.ui_perp_manufacturing.link_view'),
				'view_id'	=>	'link_id',
		//		'add'	=>	array('menuaction' => 'perp_manufacturing.ui_perp_location.location_new'),
		//		'add_id'	=>	'location_id',
		//		'add_app'	=>	'perp_manufacturing',
		//		'add_popup'	=>	'750x550',
			);

		}

		/**
		*	Workflow agents
		*/
		public function workflow_agent() {
			return array(
				array(
					'wf_agent_type'		=>	'perp_build',
					'wf_agent_priority'	=>	1,
					'wf_agent_class'	=>	'perp_manufacturing.ui_agent_perp_build'
				)
			);
		}
	}
?>
