<?php
/**************************************************************************\
* eGroupWare - Workflow Agent's SO-layer (storage-object)                  *
* http://www.egroupware.org                                                *
* --------------------------------------------                             *
*  This program is free software; you can redistribute it and/or modify it *
*  under the terms of the GNU General Public License as published by the   *
*  Free Software Foundation; either version 2 of the License, or (at your  *
*  option) any later version.                                              *
\**************************************************************************/

require_once(EGW_INCLUDE_ROOT . SEP .'workflow' . SEP . 'inc' . SEP . 'class.so_agent.inc.php');

/**
*	Class to store/read all agents data
*
*	Creation and deletion of agents records are done by the workflow engine, not
*	by this class and her childs.
*
*	Copied from smtp_mail by regis.leroy@glconseil.com
*
*/

class so_agent_perp_build extends so_agent
{
	 // Constructor of the so_agent class
	function __construct()
	{
		parent::so_agent();
		$this->agent_table = $this->wf_table.'perp_build';
	}
	
	/**
	 * @abstract read all agent datas from the database
	 * @param $agent_id int id of the entry to read
	 * @return array/boolean array with column => value pairs or false if entry not found
	 */
	function read($agent_id)
	{
		//perform the query
		$GLOBALS['egw']->db->select($this->agent_table,'*',array('wf_agent_id'=>$agent_id),__LINE__,__FILE__, 'workflow');
		
		while (($row = $GLOBALS['egw']->db->row(true)))
		{
			return $row;
		}

		return false;
	}

	/**
	 * @abstract save all agent datas to the database
	 * @param $agent_id int id of the entry to save
	 * @param $datas is an array containing columns => value pairs which will be saved for this agent
	 * @return true if everything was ok, false else
	 */
	function save($agent_id, &$datas)
	{
		$GLOBALS['egw']->db->update($this->agent_table,$datas,array('wf_agent_id'=>$agent_id),__LINE__,__FILE__, 'perp_manufacturing');
		return false;
	}

	/**
	*	Get the workflow activity that uses the given manufacturing work center
	*
	*	This function is here because it's the build agent that maps workflow activity to work center.
	*/
	public function get_work_center_activity($process_id, $work_center_id) {
		return $GLOBALS['egw']->db->select(
			$this->agent_table,
			array('egw_wf_activities.wf_activity_id'),
			array(
				"wf_p_id = $process_id",
				"work_center_id = $work_center_id"
			),
			__LINE__, __FILE__, false, '', 'perp_manufacturing', 1,
			'JOIN egw_wf_activity_agents ON
				' . $this->agent_table . '.wf_agent_id = egw_wf_activity_agents.wf_agent_id
			JOIN egw_wf_activities ON
				egw_wf_activity_agents.wf_activity_id = egw_wf_activities.wf_activity_id'
		)->fetchSingle();
	}
}
?>
