<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_orders/inc/class.so_perp_price.inc.php');

	class so_perp_build_option {

		public function so_perp_build_option() {
		}

		public function get_build_option_list(&$query) {
			$where = array();
			if($query['cat_id']) {
				$where['stock_category'] = (int)$query['cat_id'];
			} elseif($query['stock_category']) {
				$where['stock_category'] = $query['stock_category'];
			}
			if($query['option_category']) {
				$where['build_option_category_id'] = $query['option_category'];
			}
			if($query['status']) {
				switch ($query['status']) {
					case 'current':
						$s_where[] = "NOW() >= effective_after_date AND (NOW() BETWEEN effective_after_date AND effective_to_date OR effective_to_date IS NULL)";
						$where[] = 'build_option_id';
						break;
					case 'previous':
						$s_where[] = "effective_to_date <= NOW()";
						$where[] = 'build_option_id';
						break;
					case 'future':
						$s_where[] = "effective_after_date >= NOW()";
						break;
					case 'as_of_date':
						$effective_from = $GLOBALS['egw']->db->quote($GLOBALS['egw']->db->to_timestamp($query['effective_from']));
						$s_where[] = "$effective_from >= effective_after_date AND ($effective_from BETWEEN effective_after_date AND effective_to_date OR effective_to_date IS NULL)";
						break;
				}
			}
			if($query['search']) {
				$search = $GLOBALS['egw']->db->quote('%' . $query['search'] . '%');
				$search_num = (int)$query['search'];
				$where[] = "(build_option_name LIKE $search OR build_option_id = $search_num OR
					build_option_category_name LIKE $search OR build_option_category_id = $search_num)";
			}
			if(array_key_exists('can_retrofit', $query)) {
				$where[] = 'can_retrofit = '  . (boolean)$query['can_retrofit'];
			}
			if(array_key_exists('ships_separate', $query)) {
				$where[] = 'ships_separate = '  . (boolean)$query['ships_separate'];
			}


			// Have to use $db->query(), because the WHERE in the sub-SELECT 
			// trips up the $db->select() function
			$count = 'SELECT build_option_id ';
			$data = 'SELECT
					build_option_id,
					build_option_name,
					build_option_category_id,
					build_option_category_name,
					stock_category,
					perp_build_option.effective_after_date,
					perp_build_option.effective_to_date ';
			$sql = '
				FROM perp_build_option_category
				LEFT JOIN (
					SELECT *
					FROM perp_build_option ' . 
					($s_where ? 'WHERE ' . implode(' AND ', $s_where) : '').
				') AS perp_build_option
					ON perp_build_option.build_option_category = perp_build_option_category.build_option_category_id' . 
				(count($where) ? ' WHERE ' . $GLOBALS['egw']->db->column_data_implode(' AND ', $where, true, false) : '') . 
				' ORDER BY ' . $query['order'] . ' ' . $query['sort'];

			// Get number of rows
			$query['total'] = $GLOBALS['egw']->db->query($count . $sql, __LINE__, __FILE__)->NumRows();

			$list = array();
			foreach($GLOBALS['egw']->db->query($data . $sql ,
				__LINE__, __FILE__, $query['start'], 
				$query['num_rows']
			) as $row) {
				$row['effective_after_date'] = $GLOBALS['egw']->db->from_timestamp($row['effective_after_date']);
				$row['effective_to_date'] = $GLOBALS['egw']->db->from_timestamp($row['effective_to_date']);
				$list[] = $row;
			}

			return $list;
		}
		
		public function get_build_option_time_period_list($query = array(), &$rows = array(), &$readonlys = array()) {
			
			if($debug){
				_debug_array($query);
			}			
			
			if($query['stock_id']){
				$where[] = 'perp_allowed_build_option.stock_id = '.$query['stock_id'];
			}else{
				return 0;
			}
			if($query['filter']){
				$where[] = 'build_option_category = '.$query['filter'];
			}
			if(strtolower($query['filter2']) == 'future'){
				$date = $GLOBALS['egw']->db->to_timestamp(time());
				$where[] = "perp_allowed_build_option.effective_from > '$date'";
			}
			if(strtolower($query['filter2']) == 'previous'){
				$date = $GLOBALS['egw']->db->to_timestamp(time());
				$where[] = "previous_option.effective_from < '$date'";
			}

			if($query['search']) {
				$search = $GLOBALS['egw']->db->quote('%' . $query['search'] . '%');
				$where[] = "(build_option_category_name LIKE $search OR build_option_name LIKE $search)";
			}
			
			$join = 'LEFT JOIN (SELECT * FROM perp_allowed_build_option ORDER by effective_from DESC) as previous_option
					ON previous_option.build_option_id = perp_allowed_build_option.build_option_id
					AND previous_option.stock_id = perp_allowed_build_option.stock_id
					AND previous_option.effective_from > perp_allowed_build_option.effective_from
					LEFT JOIN perp_build_option
					ON perp_allowed_build_option.build_option_id = perp_build_option.build_option_id
					JOIN perp_build_option_category
					ON perp_build_option.build_option_category = perp_build_option_category.build_option_category_id';
			$GLOBALS['egw']->db->select(
				'perp_allowed_build_option',
				array('perp_allowed_build_option.build_option_id',
					'build_option_category',
					'build_option_category_name',
					'build_option_name',
					'perp_allowed_build_option.value',
					'perp_allowed_build_option.component',
					'perp_allowed_build_option.work_center',
					'perp_allowed_build_option.effective_from',
					'MIN(previous_option.effective_from) AS effective_to'
				),
				$where,
				__LINE__,
				__FILE__,
				false,
				"GROUP BY perp_allowed_build_option.build_option_id,
				perp_allowed_build_option.stock_id,
				perp_allowed_build_option.effective_from
				ORDER BY build_option_category_name ASC, build_option_name ASC, effective_from ASC",
				'perp_manufacturing',
				'',
				$join
			);
			while($row = $GLOBALS['egw']->db->row(True)) {
				$row['effective_from'] = $GLOBALS['egw']->db->from_timestamp($row['effective_from']);
				$row['effective_to'] = $GLOBALS['egw']->db->from_timestamp($row['effective_to']);
				$rows[] = $row;
			}
			
			return count($rows);
		}

		public function get_build_option_category($id) {
			$GLOBALS['egw']->db->select('perp_build_option_category', array(
				'build_option_category_id',
				'build_option_category_name',
				'stock_category',
				'required',
				'ships_separate',
				'can_retrofit'
				),
				array('build_option_category_id' => $id),
				__LINE__, __FILE__,
				false, '', 'perp_manufacturing'
			);
			$list = $GLOBALS['egw']->db->row(True);
			return $list;
		}
		
		public function set_build_option_category($id, $category) {
			$GLOBALS['egw']->db->insert(
				'perp_build_option_category', 
				array(
					'build_option_category_id'	=>	$id,
					'build_option_category_name'	=>	$category['build_option_category_name'],
					'stock_category'		=>	$category['stock_category'],
					'required'			=>	$category['required'],
					'ships_separate'		=>	$category['ships_separate'],
					'can_retrofit'			=>	$category['can_retrofit']
				),
				array('build_option_category_id' => $id),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
		}
		
		/**
		*	this function checks the database in certain tables to determine
		*	that the build option category is not being activly used, if so return false
		*	if the test passes return true, it also uses $this->build_option_valid_delete() to
		*	determine the same for the build options
		*
		*	@param build_option_category_id
		*	@return boolean
		*/
		public function build_option_category_valid_delete($id) {
			
			$GLOBALS['egw']->db->select('perp_build_option',
				array('build_option_id','build_option_category'),
				array('build_option_category' => $id),
				__LINE__,
				__FILE__, 
				false,
				'',
				'perp_manufacturing'
			);
			$build_option_ids = array();
			while($row = $GLOBALS['egw']->db->row(True)) {
				$build_option_ids[] = $row;
			}
			
			foreach($build_option_ids as $build_option_id) {
				if($this->build_option_valid_delete($build_option_id['build_option_id'])){
					continue;		
				}else{
					return false;
				}
			}
			return true;
			
		}
		
		/**
		*	deletes a build option category after checking to make sure it is
		*	candidate for deletion by calling $this->build_option_category_valid_delete
		*	it will also delete the build options within that category, again assuming they also
		*	are candidates for deletion
		*
		*	@param build_option_category_id
		*/
		public function delete_build_option_category($id) {
			
			if($this->build_option_category_valid_delete($id)){
				
				$GLOBALS['egw']->db->select('perp_build_option',
					array('build_option_id','build_option_category'),
					array('build_option_category' => $id),
					__LINE__,
					__FILE__, 
					false,
					'',
					'perp_manufacturing'
				);
				$build_option_ids = array();
				while($row = $GLOBALS['egw']->db->row(True)) {
					$build_option_ids[] = $row;
				}
				
				foreach($build_option_ids as $build_option_id) {
					$GLOBALS['egw']->db->delete('perp_build_option_price',
						array('build_option_id' => $build_option_id),
						__LINE__, __FILE__, 'perp_manufacturing'
					);
					
					$GLOBALS['egw']->db->delete('perp_allowed_build_option',
						array('build_option_id' => $build_option_id),
						__LINE__, __FILE__, 'perp_manufacturing'
					);
					
					$GLOBALS['egw']->db->delete('perp_build_option',
						array('build_option_id' => $build_option_id),
						__LINE__, __FILE__, 'perp_manufacturing'
					);
				}			
				
				$GLOBALS['egw']->db->delete('perp_build_option_category',
					array('build_option_category_id' => $id),
					__LINE__, __FILE__, 'perp_manufacturing'
				);
			}
			else{
				//_debug_array('NO DELETE');
			}
			
		}		
		
		/**
		*	this function checks the database in certain tables to determine
		*	that the build option is not being activly used, if so return false
		*	if the test passes return true
		*
		*	@param build_option_id
		*	@return boolean
		*/
		public function build_option_valid_delete($id) {
			
			$where[] = 'build_option_id = '.$id;
			$where[] = 'value != 0';
			$GLOBALS['egw']->db->select('perp_allowed_build_option',
				array('build_option_id','value'),
				$where,
				__LINE__,
				__FILE__, 
				false,
				'',
				'perp_manufacturing'
			);
			$allowed_build_option = array();
			while($row = $GLOBALS['egw']->db->row(True)) {
				$allowed_build_option = $row;
			}	
					
			
			$GLOBALS['egw']->db->select('perp_work_order_option',
				array('work_order_id','detail_id','build_option_id'),
				array('build_option_id' => $id),
				__LINE__,
				__FILE__, 
				false,
				'',
				'perp_manufacturing'
			);
			$work_order_build_option = array();
			while($row = $GLOBALS['egw']->db->row(True)) {
				$work_order_build_option = $row;
			}
			
			if(!$allowed_build_option && !$work_order_build_option){
				return true;		
			}		
			return false;
		}
		
		/**
		*	deletes a build option after checking to make sure it is
		*	candidate for deletion by calling $this->build_option_valid_delete
		*
		*	@param build_option_id
		*/
		public function delete_build_option($id) {
			
			if($this->build_option_valid_delete($id)){				
				$GLOBALS['egw']->db->delete('perp_build_option_price',
					array('build_option_id' => $id),
					__LINE__, __FILE__, 'perp_manufacturing'
				);
				
				$GLOBALS['egw']->db->delete('perp_allowed_build_option',
					array('build_option_id' => $id),
					__LINE__, __FILE__, 'perp_manufacturing'
				);
				
				$GLOBALS['egw']->db->delete('perp_build_option',
					array('build_option_id' => $id),
					__LINE__, __FILE__, 'perp_manufacturing'
				);
								
			}else{
				//_debug_array('NO DELETE');
			}			
		}

		public function get_build_option($id) {
			$GLOBALS['egw']->db->select('perp_build_option', array(
				'build_option_id',
				'build_option_name',
				'effective_after_date',
				'effective_to_date',
				'build_option_category'),
				array('build_option_id' => $id),
				__LINE__, __FILE__, 
				false, '', 'perp_manufacturing'
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(True)) {
				$row['effective_after_date'] = $GLOBALS['egw']->db->from_timestamp($row['effective_after_date']);
				$row['effective_to_date'] = $GLOBALS['egw']->db->from_timestamp($row['effective_to_date']);
				$list = $row;
			}
			return $list;
		}

		public function set_build_option($id, $option) {
			$option['effective_after_date'] = $GLOBALS['egw']->db->to_timestamp($option['effective_after_date']);
			$option['effective_to_date'] = !($option['effective_to_date']) ? null : $GLOBALS['egw']->db->to_timestamp($option['effective_to_date']);
			$GLOBALS['egw']->db->insert('perp_build_option', 
				$option,
				array('build_option_id' => $id),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
			$id = $id ? $id : $GLOBALS['egw']->db->get_last_insert_id('perp_build_option', 'build_option_id');
			return $id;
		}

		public function get_allowed_build_option_list($query = array()) {
			$stock_id = ($query['stock_id'])?$query['stock_id']:'';
			$value = ($query['value'])?$query['value']:'';
			$as_of_date = ($query['as_of_date'])?$query['as_of_date']:'';
			$build_option_category_id = ($query['build_option_category'])?$query['build_option_category']:'';
			
			if(!array_key_exists('include_discontinued_options',$query)) {
				$query['include_discontinued_options'] = true;
			}

			if(!$stock_id) {
				return array();
			}
			$discontinued_option_tag = ' (' . lang('While supplies last') . ')';

			$where = array(
				"perp_stock.stock_id = $stock_id"
			);
			if($build_option_category_id) {
				$category_where = 'perp_build_option.build_option_category ';
				if(is_array($build_option_category_id)) {
					$category_where .= 'IN (' . implode(',', $build_option_category_id) . ') ';
				} else {
					$category_where .= '= ' . (int)$build_option_category_id;
				}
				$where[] = $category_where;
			}
			$current_where = $where;
			$build_where = $where;

			if($as_of_date) {
				$as_of_date = $GLOBALS['egw']->db->to_timestamp($as_of_date);
			} else {
				$as_of_date = $GLOBALS['egw']->db->to_timestamp(time());
			}
			$current_where[] = "(('$as_of_date' BETWEEN effective_after_date AND effective_to_date) OR ('$as_of_date' >= effective_after_date AND effective_to_date IS NULL))";
			$build_where[] = "('$as_of_date' > perp_build_option.effective_to_date)";

			if($value) {
				if(is_array($value)) {
					$current_where[] = 'perp_allowed_build_option.value IN (' . implode(',',$value) . ')';
				} else {
					$current_where[] = 'perp_allowed_build_option.value = ' .$value;
				}
			} else {
				$current_where[] = 'perp_allowed_build_option.value != 0';
			}
			
			$build_where[] = '(
				sold.quantity_sold < perp_work_order_detail.quantity OR
			        sold.quantity_sold IS NULL
			)';
			$sql = array();

			// Active, allowed options
			// Done as straight SQL because the nested SELECT in the JOIN clause causes the select() function
			// issues, it appends the WHERE to the end of the JOIN 
			$active_fields = array(
				'build_option_category',
				'build_option_category_name',
				'required',
				'perp_build_option.build_option_id',
				'perp_build_option.build_option_name',
				'perp_allowed_build_option.component',
				'component.stock_type_flag',
				'perp_allowed_build_option.work_center',
				'perp_allowed_build_option.value',
				'perp_allowed_build_option.effective_from',
				'perp_allowed_build_option.effective_to'
			);
			$active_join = 'JOIN perp_build_option_category 
					ON perp_build_option_category.build_option_category_id = perp_build_option.build_option_category 
				JOIN perp_stock
					ON perp_stock.stock_category = perp_build_option_category.stock_category
				JOIN (
					SELECT * FROM (
						SELECT perp_allowed_build_option.*,
							MIN(previous_option.effective_from) AS effective_to 
						FROM perp_allowed_build_option
						LEFT JOIN (SELECT * FROM perp_allowed_build_option ORDER by effective_from DESC) as previous_option
                        ON previous_option.build_option_id = perp_allowed_build_option.build_option_id 
                        AND previous_option.stock_id = perp_allowed_build_option.stock_id 
                        AND previous_option.effective_from > perp_allowed_build_option.effective_from
                        WHERE perp_allowed_build_option.stock_id = '.$stock_id.'
                        AND perp_allowed_build_option.effective_from <= \'' . $as_of_date . '\'
                        GROUP BY perp_allowed_build_option.build_option_id, perp_allowed_build_option.stock_id, perp_allowed_build_option.effective_from
                        ORDER BY build_option_id ASC, effective_from DESC
					) AS current_options
					GROUP BY build_option_id
				) AS perp_allowed_build_option ON 
					perp_build_option.build_option_id = perp_allowed_build_option.build_option_id AND
					perp_allowed_build_option.stock_id = perp_stock.stock_id
				LEFT JOIN perp_stock AS component ON
					perp_allowed_build_option.component = component.stock_id';
			if(count($current_where)) {
				$active_where .= "WHERE " . implode(' AND ', $current_where);
			}
			$active = "SELECT " . implode(',', $active_fields) . "
				FROM perp_build_option
				$active_join
				$active_where
				ORDER BY build_option_category, build_option_id
			";
			$sql[] = $active;

			// Options on in stock work orders that took a single component
			if($query['include_discontinued_options']){
				$build_fields = array(
					'build_option_category',
					'build_option_category_name,required,perp_build_option.build_option_id',
					'concat(perp_build_option.build_option_name, \'' . $discontinued_option_tag . '\')',
					'perp_work_order_option.component',
					'perp_stock.stock_type_flag',
					'perp_work_order_option.work_center_id',
					'perp_work_order_option.build_option_id',
					'perp_allowed_build_option.effective_from',
					'perp_allowed_build_option.effective_to'
				);
				$build_join = 'JOIN perp_build_option_category ON 
						perp_build_option_category.build_option_category_id = perp_build_option.build_option_category 
					JOIN ( 
						SELECT perp_allowed_build_option.*,
              				MIN(previous_option.effective_from) AS effective_to 
        				FROM perp_allowed_build_option 
        				LEFT JOIN (SELECT * FROM perp_allowed_build_option ORDER by effective_from DESC) as previous_option
        				ON previous_option.build_option_id = perp_allowed_build_option.build_option_id 
        				AND previous_option.stock_id = perp_allowed_build_option.stock_id 
				        AND previous_option.effective_from > perp_allowed_build_option.effective_from
				        WHERE perp_allowed_build_option.stock_id = '.$stock_id.'
				        GROUP BY perp_allowed_build_option.build_option_id, perp_allowed_build_option.stock_id, perp_allowed_build_option.effective_from
				        ORDER BY build_option_id ASC, effective_from DESC
     				) AS perp_allowed_build_option ON
						perp_allowed_build_option.build_option_id = perp_build_option.build_option_id
					JOIN perp_stock ON 
						perp_stock.stock_category = perp_build_option_category.stock_category AND
						perp_stock.stock_id = perp_allowed_build_option.stock_id
					JOIN perp_work_order_option ON
						perp_work_order_option.work_order_id > 0 AND
						perp_build_option.build_option_category = perp_work_order_option.option_category_id AND
						perp_build_option.build_option_id = perp_work_order_option.build_option_id AND 
						perp_work_order_option.component = perp_allowed_build_option.component
					JOIN perp_work_order_detail ON
						perp_work_order_detail.work_order_id = perp_work_order_option.work_order_id AND
						perp_work_order_detail.detail_id = perp_work_order_option.detail_id AND
						perp_work_order_detail.stock_id = perp_allowed_build_option.stock_id
					LEFT JOIN (
						SELECT
							perp_order_detail.detail_value AS work_order_id,
							perp_sales_order_work_order.work_order_detail_id AS detail_id,
							sum(quantity) AS quantity_sold
						FROM perp_order_detail 
						JOIN perp_sales_order_work_order ON
							perp_order_detail.order_id = perp_sales_order_work_order.order_id AND
							perp_order_detail.line_no = perp_sales_order_work_order.line_no AND
							perp_order_detail.detail_no = perp_sales_order_work_order.detail_no
						GROUP BY perp_order_detail.detail_value, perp_sales_order_work_order.work_order_detail_id
					) AS sold ON
						sold.work_order_id = perp_work_order_option.work_order_id AND
						sold.detail_id = perp_work_order_option.detail_id
					LEFT JOIN perp_stock AS component ON
						perp_allowed_build_option.component = component.stock_id';
				if(count($build_where)) {
					$discontinued_where .= "WHERE " . implode(' AND ', $build_where);
				}
				$build = 'SELECT ' . implode(',', $build_fields) . "
					FROM perp_build_option
					$build_join
					$discontinued_where
					GROUP BY perp_build_option.build_option_id";
				$sql[] = $build;

			}
			
			// Options on in stock work orders that used an assembly
			/**
			* I don't think this part is needed anymore, because the component is stored either way, so should be
			* picked up by the above query
			*
			$sql[] = $GLOBALS['egw']->db->select(
				'perp_build_option',
				array(
					'build_option_category',
					'build_option_category_name,required,perp_build_option.build_option_id',
					'concat(perp_build_option.build_option_name, \'' . $discontinued_option_tag . '\')',
					'perp_stock.stock_id',
					'perp_work_order_option.work_center_id',
					'perp_work_order_option.build_option_id'
				),
				$build_where,
				false, false, false,
				'GROUP BY perp_build_option.build_option_id', 'perp_manufacturing', -1,
				'JOIN perp_build_option_category ON 
					perp_build_option_category.build_option_category_id = perp_build_option.build_option_category 
				JOIN perp_allowed_build_option ON
					perp_allowed_build_option.build_option_id = perp_build_option.build_option_id
				JOIN perp_stock ON 
					perp_stock.stock_category = perp_build_option_category.stock_category AND
					perp_stock.stock_id = perp_allowed_build_option.stock_id
				JOIN perp_bill_of_material ON
					perp_stock.stock_id = perp_bill_of_material.stock_id
				JOIN perp_work_order_option ON
					perp_work_order_option.work_order_id > 0 AND
					perp_build_option.build_option_category = perp_work_order_option.option_category_id AND
					perp_build_option.build_option_id = perp_work_order_option.build_option_id AND (
						perp_work_order_option.option_bom_id = perp_bill_of_material.bill_of_material_id 
					)
				JOIN perp_work_order_detail ON
					perp_work_order_detail.work_order_id = perp_work_order_option.work_order_id AND
					perp_work_order_detail.detail_id = perp_work_order_option.detail_id
				LEFT JOIN (
					SELECT
						perp_order_detail.detail_value AS work_order_id,
						perp_sales_order_work_order.work_order_detail_id AS detail_id,
						sum(quantity) AS quantity_sold
					FROM perp_order_detail 
					JOIN perp_sales_order_work_order ON
						perp_order_detail.order_id = perp_sales_order_work_order.order_id AND
						perp_order_detail.line_no = perp_sales_order_work_order.line_no AND
						perp_order_detail.detail_no = perp_sales_order_work_order.detail_no
					GROUP BY perp_order_detail.detail_value, perp_sales_order_work_order.work_order_detail_id
				) AS sold ON
					sold.work_order_id = perp_work_order_option.work_order_id AND
					sold.detail_id = perp_work_order_option.detail_id'
			);

			*/

			$query = 'SELECT * FROM ( (' . implode (') UNION (', $sql) . ' )) AS options
				GROUP BY options.build_option_id
				ORDER BY build_option_category, build_option_id';
			$list = array();
			//echo $query;
			foreach($GLOBALS['egw']->db->query($query, __LINE__, __FILE__) as $row) {
				$row['effective_from'] = $GLOBALS['egw']->db->from_timestamp($row['effective_from']);
				$row['effective_to'] = $GLOBALS['egw']->db->from_timestamp($row['effective_to']);
				$list[] = $row;
			}
			
			return $list;
		}

		public function get_allowed_build_option($stock_id, $option, $effective_from) {
			$where[] = "perp_allowed_build_option.stock_id = '$stock_id'";
			$where[] = "perp_allowed_build_option.build_option_id = '$option'";
			if($effective_from) {
				$where[] = 'perp_allowed_build_option.effective_from <= ' . $GLOBALS['egw']->db->quote($GLOBALS['egw']->db->to_timestamp($effective_from));
			}



			$join = 'LEFT JOIN (SELECT * FROM perp_allowed_build_option ORDER by effective_from DESC) as previous_option
					ON previous_option.build_option_id = perp_allowed_build_option.build_option_id 
					AND previous_option.stock_id = perp_allowed_build_option.stock_id 
					AND previous_option.effective_from > perp_allowed_build_option.effective_from';


			$GLOBALS['egw']->db->select('
				perp_allowed_build_option',
				array(
					'perp_allowed_build_option.build_option_id',
					'perp_allowed_build_option.stock_id',
					'perp_allowed_build_option.component',
					'perp_allowed_build_option.work_center',
					'perp_allowed_build_option.value',
					'perp_allowed_build_option.effective_from',
					'MIN(previous_option.effective_from) AS effective_to'
				),
				$where,
				__LINE__,
				__FILE__,
				false,
				'GROUP BY perp_allowed_build_option.build_option_id, perp_allowed_build_option.stock_id, perp_allowed_build_option.effective_from
				ORDER BY effective_from DESC',
				'perp_manufacturing',
				'',
				$join
			);

			$list = array();
			if($row = $GLOBALS['egw']->db->row(True)) {
				$row['effective_from'] = $GLOBALS['egw']->db->from_timestamp($row['effective_from']);
				$row['effective_to'] = $GLOBALS['egw']->db->from_timestamp($row['effective_to']);
				$list = $row;
			}
			return $list;
		}

		public function set_allowed_build_option($stock_id, $option) {
			$GLOBALS['egw']->db->insert('perp_allowed_build_option', array(
				'build_option_id'	=>	(int)$option['build_option_id'],
				'stock_id'		=>	(int)$stock_id,
				'value'			=>	(int)$option['value'],
				'work_center'		=>	(int)$option['work_center'],
				'component'		=>	(int)$option['component'],
				'effective_from'	=>	$GLOBALS['egw']->db->to_timestamp($option['effective_from'])
				),
				array(
					'build_option_id'	=>	$option['build_option_id'],
					'stock_id'		=>	$stock_id,
					'effective_from'	=>	$GLOBALS['egw']->db->to_timestamp($option['effective_from'])
				),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
		}

		/**
		*	Get a list of options where the option is discontinued, but we have something with that option 
		*	in stock.
		*/
		public function get_in_stock_options($query) {
			// Get allowed build options
			$allowed_build_option_list_query['stock_id'] = $query['stock_id'];
			$allowed = $this->get_allowed_build_option_list($allowed_build_option_list_query);

			$options = array();
			foreach($allowed as $option) {
				$options[] = $option['build_option_id'];
			}
			$where = array(
				'perp_build_option.build_option_id NOT IN (' . implode(',', $options) . ')'
			);
			if($query['build_option_category_id']) {
				$where[] = 'perp_build_option.build_option_category = ' . $query['build_option_category_id'];
			}
			if($query['stock_id']) {
				$where[] = 'perp_stock.stock_id = ' . $query['stock_id'];
			}
			if($query['work_order_id'] && $query['detail_id']) {
				$where[] = 'perp_work_order_detail.work_order_id';
				$where[] = 'perp_work_order_detail.detail_id';
			}


			$join = 'JOIN perp_build_option_category ON 
					perp_build_option_category.build_option_category_id = perp_build_option.build_option_category
				JOIN perp_stock ON 
					perp_stock.stock_category = perp_build_option_category.stock_category
				JOIN (
					perp_work_order_option 
					JOIN perp_work_order_detail ON
						perp_work_order_detail.work_order_id = perp_work_order_option.work_order_id AND
						perp_work_order_detail.detail_id = perp_work_order_option.detail_id
				) ON 
					perp_build_option.build_option_id = perp_work_order_option.build_option_id ';

			if(!$query['work_order_id']) {
				$where[] = 'perp_order_detail.order_id IS NULL';
				$join .= ' LEFT JOIN (
					perp_order_detail 
				JOIN perp_sales_order_work_order ON
					perp_order_detail.detail_class = \'WorkOrderDetail\' AND
					perp_order_detail.order_id = perp_sales_order_work_order.order_id AND
					perp_order_detail.line_no = perp_sales_order_work_order.line_no AND
					perp_order_detail.detail_no = perp_sales_order_work_order.detail_no
				) ON
					perp_order_detail.detail_value = perp_work_order_detail.work_order_id AND
					perp_sales_order_work_order.work_order_detail_id = perp_work_order_detail.detail_id';
			}

			$list = array();
			foreach($GLOBALS['egw']->db->select(
				'perp_build_option',
				array(
					'perp_build_option.build_option_id',
					'perp_build_option.build_option_name',
				),
				$where, __LINE__, __FILE__, false, '',
				'perp_manufacturing', -1,
				$join
			) as $row) {

				$list[$row['build_option_id']] = $row;
			}
			return $list;
		}
		
		/**
		*	
		*	
		*/
		public function get_stock_item_stock_options($query = array(), &$rows = array(), &$readonlys = array()) {
			
			$rows = array();
			if($query['build_option_id'] && $query['build_option_category']){
				
				$where[] = 'perp_build_option_category.build_option_category_id = '.$query['build_option_category'];
				if($query['filter']) {
					$where[] = 'perp_stock.status_flag = '.$GLOBALS['egw']->db->quote($query['filter']);
				}
				if($query['search']) {
					$search = $GLOBALS['egw']->db->quote('%'.$query['search'] . '%');
					$where[] = "(perp_stock.stock_num LIKE $search OR
						perp_stock.short_description LIKE $search)";
				}
				$where[] = "perp_stock.stock_type_flag != 'R'";				
				$join = 'JOIN perp_build_option_category ON perp_stock.stock_category = perp_build_option_category.stock_category';

				// Get total number of records
				$count = $GLOBALS['egw']->db->select(
					'perp_stock',
					'count(*) as count',
					$where,
					__LINE__, __FILE__, 0, '', 0, 1,
					$join
				)->fetchSingle();

				$GLOBALS['egw']->db->select(
					'perp_stock',
					array(
						'perp_stock.stock_id',
						'perp_stock.stock_num AS stock_code',
						'perp_stock.short_description AS description'
					),
					$where,
					__LINE__,
					__FILE__,
					$query['start'],
					'',
					0,
					$query['num_rows'],
					$join				
				);
				
				$return = array();
				while($row = $GLOBALS['egw']->db->row(true)) {
					$return[] = $row;
				}
							
				$readonlys[] = '';
				foreach ($return as $row) {
					$allowed_build_option = ExecMethod2('perp_manufacturing.bo_perp_build_option.get_allowed_build_option',$row['stock_id'], $query['build_option_id'],$query['effective_from']);
					$row['value'] = $allowed_build_option['value'];
					$row['component'] = $allowed_build_option['component'];
					$row['work_center'] = $allowed_build_option['work_center'];
					$rows[] = $row;
					if($query['effective_from'] < mktime(0,0,0, date('m'), date('d'), date('Y'))){
						$readonlys[] = true;
					}				
				}
			}
			
			return $count;
		}

		/**
		*	Get a list of prices for build options.
		*
		*	The data returned varies depending on the query parameters passed. 
		*	The extra parameters are all optional:
		*		price_list_id	(int)
		*		stock_id	(int)
		*		date		(timestamp)
		*
		*	If none of the extra parameters are provided, you'll get a list of all prices,
		*	one price per price list, stock item (and default), for every option, and every
		*	price change ever made.  
		*	By providing a price_list_id, you restrict the prices to just that price list.  
		*	Stock_id will restrict to prices on allowed build options for that stock item.
		*	Date will get you the prices at that point in time, rather than the entire history.
		*
		*	@nextmatch
		*/
		public function get_price_list(&$query, &$readonly) {
			$where = array();
			if($query['cat_id'] && is_numeric($query['cat_id'])) {
				$where[] = 'perp_price_list.sales_category_id = ' . (int)$query['cat_id'];
			};

			if($query['date']) {
				$date = $GLOBALS['egw']->db->to_timestamp($query['date']);
				
				// Effective price
				$where[] = "(perp_build_option_price.effective_date <= '$date' OR perp_build_option_price.effective_date IS NULL)";
				// Effective options
				$where[] = "perp_build_option.effective_after_date <= '$date'  AND (
					perp_build_option.effective_to_date > '$date'  OR
					perp_build_option.effective_to_date IS NULL
				)";
				// Effective price list
				$where[] = "(perp_price_list.effective_to > '$date' OR perp_price_list.effective_to IS NULL)";
			}
			if($query['stock_id']) {
				$where[] = 'perp_build_option_price.stock_id = ' . (int)$query['stock_id'];
			}

			if($query['search']) {
				$search = $GLOBALS['egw']->db->quote('%' . $query['search'] . '%');
				$search_clause = '(';
				if(!$query['price_list_id']) {
					$search_clause .= "price_list_name LIKE $search OR ";
				}
				$search_clause .= "build_option_category_name LIKE $search OR
					build_option_name LIKE $search OR
					price LIKE $search)";
				$where[] = $search_clause;
			}

			$join_tail .= '
				JOIN perp_build_option_category ON
					perp_build_option.build_option_category = perp_build_option_category.build_option_category_id
				JOIN perp_sales_category ON
					perp_price_list.sales_category_id = perp_sales_category.sales_category_id
				JOIN egw_categories ON
					perp_sales_category.sales_category_id = egw_categories.cat_id
				JOIN perp_sales_area ON
					perp_sales_area.sales_area_id = perp_price_list.sales_area_id ';

			$fields = array(
				'perp_build_option_price.stock_id',
				'perp_price_list.price_list_id',
				'perp_price_list.price_list_name',
				'build_option_category_name',
				'build_option_name',
				'price_list_name',
				'currency',
				'cat_name AS sales_category_name',
				'sales_area_name',
				'price',
				'effective_date',
			);

			if($query['price_list_id']) {
				/**
				*	Get a list of options & option prices for a certain price list
				*/
				$fields[] = 'perp_allowed_build_option.build_option_id';

				$where[] = 'perp_price_list.price_list_id = ' . (int)$query['price_list_id'];
				
				$from = '(
					SELECT * FROM (
						SELECT *
						FROM perp_allowed_build_option ';
				if($query['date']) {
					$allowed_where[] = 'effective_from <= \'' . $date . '\' ';
				}
				if(count($allowed_where)) {
					$from .= 'WHERE ' . implode(' AND ', $allowed_where);
				}
				$from .= ' ORDER BY effective_from DESC
					) AS dated_options
					GROUP BY ' . (($query['stock_id']) ? ' stock_id, ' : '') . ' build_option_id
					) AS perp_allowed_build_option ';

				if($query['date']) {
					$join = ' LEFT JOIN (
							SELECT * FROM (
								SELECT *
								FROM perp_build_option_price
								WHERE (
									perp_build_option_price.stock_id = 0 OR
									perp_build_option_price.stock_id = ' . (int)$query['stock_id'] . 
								') AND
								perp_build_option_price.price_list_id = ' . (int)$query['price_list_id'] . " AND 
								perp_build_option_price.effective_date <= '$date'
								ORDER BY effective_date DESC, stock_id DESC
							) as dated_prices
							GROUP BY stock_id, build_option_id";
				} else {
					$join = ' LEFT JOIN (
							SELECT *
							FROM perp_build_option_price
							WHERE (
								perp_build_option_price.stock_id = 0 OR
								perp_build_option_price.stock_id = ' . (int)$query['stock_id'] . 
							') AND
								perp_build_option_price.price_list_id = ' . (int)$query['price_list_id'] . "\n";
				}
				$join .= ' ORDER BY effective_date DESC, stock_id DESC
					) AS perp_build_option_price ON
						perp_allowed_build_option.build_option_id = perp_build_option_price.build_option_id
					JOIN perp_build_option ON
						perp_allowed_build_option.build_option_id = perp_build_option.build_option_id AND
						perp_build_option.effective_after_date <= \'' . $date . '\' AND (
							perp_build_option.effective_to_date > \'' . $date . '\' OR
							perp_build_option.effective_to_date IS NULL
						)';
				$join .= 'LEFT JOIN perp_price_list ON
					perp_price_list.price_list_id = perp_build_option_price.price_list_id OR (
						perp_price_list.price_list_id = ' . (int)$query['price_list_id'] . ' AND 
						perp_build_option_price.price_list_id IS NULL)';

				$join = $join . $join_tail;

				/**
				*	This has to be SQL, because the WHERE in the nested SELECT causes issues
				*/
				$sql = "SELECT count(*) FROM $from $join WHERE " . implode(' AND ', $where);
				$query['total'] = $GLOBALS['egw']->db->query($sql, __LINE__, __FILE__)->fetchSingle();

				$sql = 'SELECT ' . implode(',', $fields) . " FROM $from $join WHERE " . implode(' AND ', $where) . ' ' . 
					"ORDER BY {$query['order']} {$query['sort']}";

				$results = $GLOBALS['egw']->db->query($sql, __LINE__, __FILE__, $query['start'], $query['num_rows']);
			} else {
			/*
			*	Get a list of price lists & option prices, rather than options for one price list
			*/
				$fields[] = 'perp_build_option.build_option_id';

				$pre_join = 'JOIN perp_build_option ON
					perp_build_option.build_option_id ';
				if(is_array($query['build_option_id'])) {
					$pre_join .= ' IN ' . implode(',', $query['build_option_id']) . ' ';
				} else {
					$pre_join .= ' = ' . (int)$query['build_option_id'] . ' ';
				}
				$pre_join .= 'LEFT JOIN (
						SELECT *
						FROM perp_build_option_price
						WHERE     
							perp_build_option_price.effective_date <= \''. $date . '\' AND 
							perp_build_option_price.stock_id = 0 
						ORDER BY effective_date DESC
					) AS perp_build_option_price ON 
					perp_build_option.build_option_id = perp_build_option_price.build_option_id AND
					perp_build_option_price.price_list_id = perp_price_list.price_list_id';

				$join = $pre_join . $join_tail;
				
					
				$query['total'] = $GLOBALS['egw']->db->select(
					'perp_price_list',
					array('count(*)'),
					$where,
					__LINE__, __FILE__, false,
					'', 'perp_manufacturing', 0,
					$join
				)->fetchSingle();

				$results = $GLOBALS['egw']->db->select('perp_price_list', 
					$fields,
					$where,
					__LINE__, __FILE__, $query['start'],
					"GROUP BY perp_build_option.build_option_id, stock_id, perp_price_list.price_list_id
					ORDER BY {$query['order']} {$query['sort']}",
					'perp_manufacturing', $query['num_rows'],
					$join
				);
			}

			$list = array();
			$read_only = !$GLOBALS['egw']->acl->check('price_list', EGW_ACL_EDIT, 'perp_orders') || $query['date'] < time();

			foreach($results as $row) {
				$row['effective_date'] = $GLOBALS['egw']->db->from_timestamp($row['effective_date']);
				if(is_null($row['price'])) {
					$row['price'] = so_perp_price::NOT_ALLOWED;
				} else {
					$row['price'] = number_format($row['price'], 2);
				}

				$readonly[(count($list) + 1) . '[price]'] = $read_only;
				$list[] = $row;
			}
			return $list;
		}

		/**
		*	Get a list of build options that use the provided stock id as the component
		*	for the option.
		*
		*	@param stock_id int ID of the stock item to search
		*
		*	@return array of allowed build options that use that item as the component
		*/
		public function get_used_by($stock_id) {
			$list = array();
			$result = $GLOBALS['egw']->db->select(
				'perp_allowed_build_option',
				array('*'),
				array(
					'component'	=>	$stock_id
				),
				__LINE__, __FILE__, false, '',
				'perp_manufacturing', -1
			);
			foreach($result as $row) {
				$list[] = $row;
			}
			return $list;
		}

		/**
		*	Get the entire exclusion matrix
		*/
		public static function get_exclusion_matrix() {
			$list = array();
			$result =& $GLOBALS['egw']->db->select(
				'perp_build_option_exclusion',
				array('*'),
				array(),
				__LINE__, __FILE__, false, '',
				'perp_manufacturing', -1
			);

			foreach($result as $row) {
				$list[$row['option_1']][] = $row['option_2'];

				// Put the relationship in both ways, makes it easier to look through,
				// but can cause mutual exclusions, and lock out some options
				//$list[$row['option_2']][] = $row['option_1'];
			}
			return $list;
		}

		/**
		*	Set the exclusion matrix
		*/
		public static function set_exclusion_matrix($list) {
			$GLOBALS['egw']->db->transaction_begin();
		
			$GLOBALS['egw']->db->delete(
				'perp_build_option_exclusion',
				array(true),
				__LINE__, __FILE__,
				'perp_manufacturing'
			);

			foreach($list as $option_1 => $exclude) {
				foreach($exclude as $option_2) {
					$GLOBALS['egw']->db->insert(
						'perp_build_option_exclusion',
						array(
							'option_1'	=>	$option_1,
							'option_2'	=>	$option_2,
						),
						array(),
						__LINE__, __FILE__,
						'perp_manufacturing'
					);
				}
			}

			$GLOBALS['egw']->db->transaction_commit();
		}
	}
?>
