<?php

	class so_perp_manufacturing {

		public function so_perp_manufacturing() {
		}

		public function time_in_production($stock_id, $serial_num, $work_center = '') {
			$sql = 'SELECT IFNULL((finish - start) / 3600 ,0) AS production_time
				FROM (
					SELECT sum(timestamp) as start
					FROM perp_stock_history
					WHERE 
						serial_number = ' . $serial_num . 
						' AND comment = \'Started\' ';
			if($work_center) {
				$sql .= 'AND work_center = ' . $work_center;
			}
			$sql .= ') AS starts
				,(
					SELECT sum(timestamp) as finish
					FROM perp_stock_history
					WHERE serial_number = ' . $serial_num .
					' AND comment = \'Finished\' ';
			if($work_center) {
				$sql .= 'AND work_center = ' . $work_center;
			}
			$sql .= ') as finishes';
			$row = $GLOBALS['egw']->db->query($sql, __LINE__, __FILE__)->fetch(FETCH_ASSOC);
			if($row) {
				return $row['production_time'];
			} else {
				return False;
			}
		}

		/* Take care of the transaction on your own
		*/
		public function update_cost($work_order_id, $detail_id, $direct_cost = 0, $indirect_cost = 0) {
			if(!$direct_cost) {
				$direct_cost = 0;
			}
			if(!$indirect_cost) {
				$indirect_cost = 0;
			}
			$GLOBALS['egw']->db->update('perp_work_order_detail', 
				array('direct_cost = IF(direct_cost IS NULL, 0, direct_cost) + ' . $direct_cost,
					'indirect_cost = IF(indirect_cost IS NULL, 0, indirect_cost) + ' . $indirect_cost),
				array(
					'work_order_id'	=>	$work_order_id,
					'detail_id'	=>	$detail_id,
				),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
		}

		public function order_by_production($start_wc, $end_wc, $work_centers) {
			$sorted = array();
			$current = $start_wc;
			while($current != $end_wc && count($work_centers) > 0) {
				$GLOBALS['egw']->db->select('perp_work_center', 
					array('next_work_center'),
					array('work_center_id' => $current),
					__LINE__, __FILE__, 
					false, '', 'perp_manfuacturing'
				);
				$row = $GLOBALS['egw']->db->row(True);

				// Check for merging lines
				if($row && $row['next_work_center']) {
					$GLOBALS['egw']->db->select('perp_work_center',
						array('work_center_id'),
						array(
							'next_work_center' => $row['next_work_center'],
							'work_center_id != ' . $current,
						),
						__LINE__, __FILE__,
						false, '', 'perp_manfuacturing'
					);
					while($r = $GLOBALS['egw']->db->row(True)) {
						$sorted[] = array(
							'work_center_id'	=>	$r['work_center_id'],
							'next' => $current,
						);
					}
				}
				if($row['next_work_center']) {
					$sorted[] = array(
						'work_center_id'	=>	$current,
						'next' => $row['next_work_center'],
					);
					$current = $row['next_work_center'];
				} else {
					break;
				}
				unset($work_centers[$current]);
			}

			return $sorted;
		}

		/**
		*	Get the settings for making serial numbers
		*/
		public function get_serial_setup($setup_id) {
			$where = array();
			if($setup_id) {
				$where[] = 'setup_id = ' . (int)$setup_id;
			}
			$GLOBALS['egw']->db->select(
				'perp_serial_setup',
				array(
					'perp_serial_setup.setup_id',
					'perp_serial_setup.name',
					'perp_serial_setup.pattern',
					'egw_nextid.id AS next_id'
				),
				$where, __LINE__, __FILE__, false,
				'ORDER BY setup_id', 'perp_manufacturing', -1,
				'LEFT JOIN egw_nextid ON
					appname = CONCAT(\'perp_serial:\', setup_id)'
			);
			$settings = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$row['next_serial'] = $this->get_next_serial($row);
				$settings[] = $row;
			}
			return $settings;
		}

		/**
		*	Generate the next serial number for a given serial setting
		*
		*	@param setup_id ID or setup array
		*	@param stock_id stock ID of the item to make the number for
		*	@param work_order_id 	ID of the work order that created this item
		*	@param detail_id	ID of the work order detail line (usually 1)
		*	@param consume		Consume this number, making it unavailable for others
		*
		*	@return Number according to defined pattern
		*/
		public function get_next_serial($setup_id, $stock_id = '', $work_order_id = '', $detail_id = '', $consume = false) {
			if($stock_id) {
				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
				if(!$setup_id) {
					$setup_id = $stock['controlled'];
				}
			}
			if(!$setup_id) {
				return false;
			}
				
			if(is_numeric($setup_id)) {
				$setup = $this->get_serial_setup($setup_id);
				$pattern = $setup[0]['pattern'];
				$next_id = $setup[0]['next_id'];
			} else {
				$pattern = $setup_id['pattern'];
				$next_id = $setup_id['next_id'];
				$setup_id = $setup_id['setup_id'];
			}
			if($work_order_id) {
				$work_order = ExecMethod('perp_manufacturing.bo_perp_work_order.get_work_order', $work_order_id);
				if($detail_id) {
					$detail= ExecMethod2('perp_manufacturing.bo_perp_work_order.get_work_order_detail', $work_order_id, $detail_id);
				}
			}

			// Date
			preg_match('/date\(.+\)/', $pattern, $regs);
			if(count($regs)) {
				eval('$date = date(\'' .
					substr($regs[0], 5, strlen($regs[0]) - 6) .
					'\');'
				);
				$pattern = str_replace($regs[0], '%7$s', $pattern);
			}
			$serial = sprintf($pattern,
				$next_id,
				$stock_id,
				$stock['stock_num'],
				$stock['stock_category'],
				$work_order['work_order_reference'],
				$detail['option_search'],
				$date
			);
			if($consume) {
				$GLOBALS['egw']->db->update(
					'egw_nextid',
					array(
						'id = id + 1'
					),
					array(
						'appname'	=>	'perp_serial:' . $setup_id,
					),
					__LINE__, __FILE__, 'phpgwapi'
				);
			}
			return $serial;
		}

		/**
		*	Set the settings for making serial numbers
		*/
		public function set_serial_setup($setup_id, $data) {
			$GLOBALS['egw']->db->insert(
				'perp_serial_setup',
				array(
					'name'		=>	$data['name'],
					'pattern'	=>	$data['pattern']
				),
				array(
					'setup_id'	=>	$setup_id
				),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
			if(!$setup_id) {
				$setup_id = $GLOBALS['egw']->db->get_last_insert_id('perp_serial_setup', 'setup_id');
			}
			if($setup_id && $data['next_id']) {
				// Check current ID
				$settings = $this->get_serial_setup($setup_id);
				$settings = $settings[0];
				if($settings['next_id'] > $data['next_id']) {
					return lang('Cannot set serial settings for %2, next ID is too low (min %1)', $settings['next_id'], $data['name']);
				} elseif ($settings['next_id'] == $data['next_id']) {
					return $setup_id;
				} else {
					$GLOBALS['egw']->db->insert(
						'egw_nextid',
						array(
							'appname'	=>	'perp_serial:' . $setup_id,
							'id'		=>	$data['next_id']
						),
						array(
							'appname'	=>	'perp_serial:' . $setup_id,
						),
						__LINE__, __FILE__, 'phpgwapi'
					);
				}
			}
			return $setup_id;
		}
	}
?>
