<?php

	require_once( EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_stock_history.inc.php');

	class so_perp_serial_assembly {

		public static function serial_assembly($work_order_id, $detail_id, $c_stock_id, $c_serial, $quantity, $timestamp) {
			$component = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $c_stock_id);
			$comment = lang('Serialized component %1 added (s/n %2)', $component['stock_num'], $c_serial);
			$stock_history_id = bo_perp_stock_history::add_history(
				$c_stock_id, $c_serial, $comment, 
				array(
					'app'	=>	'perp_manufacturing',
					'id'	=>	'WORK_ORDER-'.$work_order_id . '-' . $detail_id,
				),
				__LINE__, __FILE__
			); 

			$GLOBALS['egw']->db->insert('perp_stock_assembly_serial', array(
				'work_order_id'		=>	$work_order_id,
				'detail_id'		=>	$detail_id,
				'component_stock_id'	=>	$c_stock_id,
				'component_serial_number'	=>	$c_serial,
				'quantity'		=>	$quantity,
				'stock_history'		=>	$stock_history_id
				),
				array(),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
		}

		public static function get_serial_assemblies(&$query = array()) {
			$where = array();
			if($query['stock_id']) {
				$where[] = '(component_stock_id = ' . $query['stock_id'] . ' OR ' .
					'stock_id = ' . $query['stock_id'] . ')';
			}
			if($query['work_order_id']) {
				$where[] = 'perp_stock_assembly_serial.work_order_id = ' . $query['work_order_id'];
			}
			if($query['detail_id']) {
				$where[] = 'perp_stock_assembly_serial.detail_id = ' . $query['detail_id'];
			}
			if($query['component_stock_id']) {
				$where['component_stock_id'] = $query['component_stock_id'];
			}
			if($query['serial_number']) {
				$where['component_serial_number'] = $query['serial_number'];
			}
			if($query['stock_history_id']) {
				$where['stock_history'] = $query['stock_history_id'];
			}

			$GLOBALS['egw']->db->select('perp_stock_assembly_serial',
				array(
					'component_stock_id',
					'component_serial_number',
					'stock_history',
					'perp_stock_assembly_serial.quantity'
				),
				$where,
				__LINE__, __FILE__, false,
				'', 'perp_manufacturing', $query['num_rows'],
				'JOIN perp_work_order_detail ON
					perp_work_order_detail.work_order_id = perp_stock_assembly_serial.work_order_id AND
					perp_work_order_detail.detail_id = perp_stock_assembly_serial.detail_id'
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$list[] = $row;
			}
			$query['count'] = count($list);
			return $list;
		}

		/**
		*	Allow changing of recorded serial numbers
		*
		*/
		public static function change_serial_assembly($stock_history_id, $work_order_id, $detail_id, $new_serial_number, $old_record = null) {
			if(is_null($old_record)) {
				$query = array(
					'stock_history_id'      =>      $stock_history_id
				);
				$old_serial = self::get_serial_assemblies($query);
				$old_record = $old_serial[0];
			}
			$c_stock_id = $old_record['component_stock_id'];
			

			// Make commment
			$component = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $c_stock_id);
			$comment = lang(
				'Serialized component changed: %1 (s/n %2 added, %3 removed)', 
				$component['stock_num'], 
				$new_serial_number, 
				$old_record['component_serial_number']
			);

			// Record removal of old one
			bo_perp_stock_history::add_history(
				$c_stock_id, $old_record['component_serial_number'], $comment, 
				array(
					'app'	=>	'perp_manufacturing',
					'id'	=>	'WORK_ORDER-'.$work_order_id . '-' . $detail_id,
				),
				__LINE__, __FILE__
			);

			// Record new one
			$new_stock_history_id = bo_perp_stock_history::add_history(
				$c_stock_id, $new_serial_number, $comment, 
				array(
					'app'	=>	'perp_manufacturing',
					'id'	=>	'WORK_ORDER-'.$work_order_id . '-' . $detail_id,
				),
				__LINE__, __FILE__
			); 

			$GLOBALS['egw']->db->insert('perp_stock_assembly_serial', array(
				'work_order_id'		=>	$work_order_id,
				'detail_id'		=>	$detail_id,
				'component_stock_id'	=>	$c_stock_id,
				'component_serial_number'	=>	$new_serial_number,
				'quantity'		=>	$quantity,
				'stock_history'		=>	$new_stock_history_id
				),
				array(
					'stock_history'	=>	$stock_history_id
				),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
		}
	}
?>
