<?php
	class so_perp_work_center {

		public function so_perp_work_center() {
		}

		public function get_work_centers(&$query) {
			$where = array();
			if($query['work_center_id']) {
				$where[] = 'perp_work_center.work_center_id = ' .(int)$query['work_center_id'];
			}
			if($query['search']) {
				$search = $GLOBALS['egw']->db->quote('%' . $query['search'] . '%');
				$where[] = "(name LIKE $search OR description LIKE $search)";
			}

			$query['count'] = $GLOBALS['egw']->db->select('perp_work_center', 
				array('count(*) AS count'),
				$where,
				__LINE__, __FILE__, false, '', 'perp_manufacturing', 1
			)->fetchSingle();

			$GLOBALS['egw']->db->select('perp_work_center', 
				array(
					'*'
				),
				$where, __LINE__, __FILE__, $query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'],
				'perp_manufacturing', $query['num_rows']
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(True)) {
				$list[] = $row;
			}
			return $list;
		}

		public function set_work_center($work_center_id, $work_center) {
			$GLOBALS['egw']->db->insert('perp_work_center', 
				array(
					'work_center_id'		=>	$work_center_id,
					'name'				=>	$work_center['name'],
					'description'			=>	$work_center['description'],
					'default_overhead_per_hour'	=>	$work_center['default_overhead_per_hour'],
					'default_overhead_account'	=>	$work_center['default_overhead_account'],
					'default_user_account'		=>	$work_center['default_user_account'],
				),
				array(
					'work_center_id'	=>	$work_center_id
				),
				__LINE__, __FILE__, 'perp_manufacturing'
			);

			$work_center_id = $work_center_id ? $work_center_id : $GLOBALS['egw']->db->get_last_insert_id('perp_work_center', 'work_center_id');

			return $work_center_id;
		}

		public function delete_work_center($work_center_id) {
			$work_center = ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center', $work_center_id);
			$GLOBALS['egw']->db->delete('perp_work_center',
				array('work_center_id' => $work_center_id),
				__LINE__, __FILE__, 'perp_manufacturing'
			);

			if($work_center['account']) {
				$GLOBALS['egw']->accounts->delete($work_center['account']);
				$GLOBALS['egw']->acl->delete_account($work_center['account']);
			}

			return True;
		}

		public function get_history($work_center_id, $status, $search) {
trigger_error(__METHOD__ . ' has been depricated, use perp_inventory.bo_perp_stock_history.get_stock_history_list, or workflow, instead');
			$where['work_center'] = $work_center_id;
			if($search) {
				$where[] = "(stock_num LIKE '%$search%' OR 
					work_order_reference LIKE '%$search%' OR
					serial_number LIKE '%$search%')";
			}

			$GLOBALS['egw']->db->select('perp_stock_history', array(
				'perp_stock_history.stock_history_id',
				'perp_stock.stock_id',
				'perp_stock.stock_num',
				'perp_stock.short_description AS description',
				'perp_stock_serial.serial_number',
				'perp_stock_history.work_order_id',
				'perp_stock_history.detail_id',
				'perp_work_order.work_order_reference',
				'timestamp',
				'comment'),
				$where,
				__LINE__, __FILE__,
				False, 'ORDER BY timestamp DESC',
				'perp_manufacturing', 0,
				'JOIN perp_work_order ON 
					perp_stock_history.work_order_id = perp_work_order.work_order_id
				JOIN perp_work_order_detail ON 
					perp_stock_history.work_order_id = perp_work_order_detail.work_order_id AND
					perp_stock_history.detail_id = perp_work_order_detail.detail_id
				JOIN perp_stock ON
					perp_stock.stock_id = perp_work_order_detail.stock_id
				LEFT JOIN perp_stock_serial ON
					perp_stock_serial.work_order_id = perp_work_order.work_order_id AND
					perp_stock_serial.detail_id = perp_work_order_detail.detail_id AND
					perp_stock_serial.stock_id = perp_stock_serial.serial_number'
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(True)) {
				$list[] = $row;
			}

			if($status) {
				switch($status) {
					case 'in_work_center':
						foreach($list as $key => $row) {
							if(ExecMethod('perp_manufacturing.bo_perp_stock_history.get_location', $query) != $work_center_id) {
								unset($list[$key]);
							}
						}
						break;
					case 'incoming':
						// TODO: Figure out the future
						break;
					case 'previous':
						foreach($list as $key => $row) {
							if(!ExecMethod('perp_manufacturing.bo_perp_work_order.get_work_order_status', $row['work_order_id'], $row['detail_id'], $query['work_center_id'])) {
								unset($list[$key]);
							}
						}
						break;
				}
			}
			return $list;
		}

		/**
		*	Get a list of physical locations that are work centers
		*
		*
		*	@nextmatch
		*	Extra parameters:
		*		work_center_id
		*		location_id
		*
		*	@return array of results
		*/
		public function get_work_center_location_list(&$query) {
			$where = array();
			if($query['location_id']) {
				if(is_array($query['location_id'])) {
					$where[] = 'perp_work_center_location.location_id IN (' . implode(',', $query['location_id']) . ')';
				} else {
					$where[] = 'perp_work_center_location.location_id = ' . (int)$query['location_id'];
				}
			}
			if($query['work_center_id']) {
				$where['work_center_id'] = $query['work_center_id'];
			}

			$join = 'JOIN perp_location ON
				perp_location.location_id = perp_work_center_location.location_id';

			// Get number of records
			$query['total'] = $GLOBALS['egw']->db->select(
				'perp_work_center_location',
				array('count(*)'),
				$where,
				__LINE__, __FILE__, false, 
				'', 'perp_manufacturing', 1,
				$join
			)->fetchSingle();

			$list = array();
			$resultset =& $GLOBALS['egw']->db->select(
				'perp_work_center_location',
				array(
					'work_center_id',
					'perp_work_center_location.location_id',
					'location_name',
					'overhead_per_hour',
					'overhead_account',
					'user_account'
				),
				$where,
				__LINE__, __FILE__, $query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'], 
				'perp_manufacturing', $query['num_rows'],
				$join
			);
			foreach($resultset as $row) {
				$list[] = $row;
			}
			return $list;
		}

		/**
		*	Set or update a physical location as a certain type of work center
		*
		*	@param work_center_location
		*/
		public function set_work_center_location($work_center_location) {
			if($work_center_location['location_id'] && !$work_center_location['work_center_id']) {
				// Remove work center from the location, it's just a regular location
			}

			$GLOBALS['egw']->db->insert('perp_work_center_location',
				$work_center_location,
				array(
					'work_center_id'	=>	$work_center_location['work_center_id'],
					'location_id'		=>	$work_center_location['location_id'],
				),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
			return true;
		}

		/**
		*	Un-set a location as a certain type of work center
		*
		*	@param work_center_id
		*	@param location_id
		*/
		public function remove_work_center_location($work_center_id, $location_id) {
			$GLOBALS['egw']->db->delete('perp_work_center_location',
				array(
					'work_center_id'	=>	$work_center_id,
					'location_id'		=>	$location_id
				),
				__LINE__, __FILE__, 'perp_manufacturing'
			);
			return true;
		}

		/**
		*	Get a list of stock items that are used at a work center
		*
		*	Works by getting a list of stock_ids, then passing it off to 
		*	perp_inventory, so all filters are available without re-coding
		*/
		public static function get_work_center_stock_list(&$query) {
			$bom_stock_ids = array(
				'table'	=>	'perp_bill_of_material_detail',
				'cols'	=>	array(
					'component'
				),
				'where'	=>	array(
					'work_center'	=>	$query['work_center_id']
				),
				'append'	=>	'GROUP BY component',
				'app'	=>	'perp_manufacturing'
			);
			
			$option_components = array(
				'table'	=>	'perp_allowed_build_option',
				'cols'	=>	array(
					'component'
				),
				'where'	=>	array(
					'work_center'	=>	$query['work_center_id']
				),
				'append'	=>	'GROUP BY component',
				'app'	=>	'perp_manufacturing'
			);
			
			$result =& $GLOBALS['egw']->db->union(
				array($bom_stock_ids, $option_components), 
				__LINE__, __FILE__
			);
			$stock_ids = array();
			foreach($result as $row) {
				$stock_ids[] = $row['component'];
			}
			return $stock_ids;
		}
	}
?>
