<?php
	class ui_perp_bill_of_material {

		public $public_functions = array(
			'bill_of_material_list'	=>	True,
			'bill_of_material_new'	=>	True,
			'bill_of_material_edit'	=>	True,
			'bill_of_material_listing'		=>	True,
		);

		private $debug = false;

		private $template;
		private $bo;

		public function ui_perp_bill_of_material() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_manufacturing.bo_perp_bill_of_material');
		}

		public function bill_of_material_list($content = array()) {
			if($this->debug) {
				echo '<strong>perp_manufacturing.ui_perp_bill_of_material.bill_of_material_list</strong> incoming data:';
				_debug_array($content);
			}

			$read = $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_READ, 'perp_manufacturing');
			$add = $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_ADD, 'perp_manufacturing');
			$edit = $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_EDIT, 'perp_manufacturing');
			$delete = $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_DELETE, 'perp_manufacturing');
			
			if(!$read) {
				echo 'I don\'t know how you got here, but you should not be here';
			}

			if(isset($content['new_bill_of_material']) && $add) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_bill_of_material.bill_of_material_new'));
			} elseif($content['nm']['rows']['view'] && $read) {
				$bom_id = key($content['nm']['rows']['view']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_bill_of_material.bill_of_material_edit', 'bill_of_material_id'=>$bom_id));
			} elseif($content['nm']['rows']['edit'] && $edit) {
				$bom_id = key($content['nm']['rows']['edit']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_bill_of_material.bill_of_material_edit', 'bill_of_material_id'=>$bom_id));
			} elseif($content['nm']['rows']['delete'] && $delete) {
				$bom_id = key($content['nm']['rows']['delete']);
				$this->bo->delete_bill_of_material($bom_id);
			} elseif($content['cancel']) {
				$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_manufacturing.ui_perp_manufacturing.index');
			}

			$readonly['new_bill_of_material'] = !$add;
			$data['nm'] = $GLOBALS['egw']->session->appsession('bill_of_materials_listing');
			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'cat_app'	=>	'perp_inventory',
					'no_filter'     =>      True,
				//	'no_filter2'    =>      True,
					'filter2_label' =>      'Status',
					'filter2_no_lang'       =>      True,
					'filter2'	=>	'current',
					'get_rows'      =>      'perp_manufacturing.ui_perp_bill_of_material.get_bill_of_material_list',
					'template'      =>      'perp_manufacturing.bill_of_material_list.row',
				//	'header_left'   =>      '', // Template
				//	'header_right'  =>      '', // Template
				);
				$data['nm']['filter2'] = $content['nm']['filter2'] ? $content['nm']['filter2'] : 'current';
			}

			$select_box_options['filter2'] = ExecMethod('perp_manufacturing.bo_perp_bill_of_material.get_bill_of_material_status_list');

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Bill of Materials List');
			$this->template->read('perp_manufacturing.bill_of_material_list');
			$this->template->exec('perp_manufacturing.ui_perp_bill_of_material.bill_of_material_list', $data, $select_box_options, $readonly, $preserve);
		}

		public function bill_of_material_new($content = array()) {
			$GLOBALS['egw']->session->appsession('bill_of_material', false, null);
			if($_GET['stock_id']) {
				$content['stock_id'] = $_GET['stock_id'];
			}
			$content['effective_after_date'] = strtotime('tomorrow');
			return $this->bill_of_material_edit($content);
		}
	
		public function bill_of_material_edit($content = array()) {
			if($this->debug) {
				echo 'bill_of_material_edit incoming data:';
				_debug_array($content);
				_debug_array($_POST['exec']);
			}

			// Permissions
			$add = $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_ADD, 'perp_manufacturing');
			$edit = $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_EDIT, 'perp_manufacturing');
			$delete = $GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_DELETE, 'perp_manufacturing');

			// Where to return to
			$preserve['return'] = $_GET['return'] ? $_GET['return'] : ($content['return'] ? $content['return'] : $_SERVER['HTTP_REFERER']);

			$bom_id = $_GET['bill_of_material_id'] ? $_GET['bill_of_material_id'] : $content['bill_of_material_id'];

			// Check if this is the start of an edit, or continuation 
			$bom = $GLOBALS['egw']->session->appsession('bill_of_material' . $bom_id);

			// Deal with incoming
			$bom['effective_after_date'] = $content['effective_after_date'];
			$bom['effective_to_date'] = $content['effective_to_date'];
			$bom['start_work_center'] = $content['start_work_center'];
			$bom['finished_work_center'] = $content['finished_work_center'];
			if($content['stock_id']) {
				$bom['stock_id'] = $content['stock_id'];
			}
			$bom['comment'] = $content['comment'];
			$bom['details'] = isset($_POST['exec'][$bom_id]) ? $_POST['exec'][$bom_id] : array();

			if(isset($content['save'])) {
				unset($content['save']);
				$result = $this->bo->set_bill_of_material($bom['bill_of_material_id'], $bom);
				if(is_numeric($result)) {
					$bom_id = $result;
					$this->messages[] = array(lang('Bill of materials saved'), 'success');
					$GLOBALS['egw']->session->appsession('bill_of_material' . $bom_id, false, null);
					unset($bom);
				} else {
					$this->messages[] = array($result, 'error');
				}
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->session->appsession('bill_of_material' . $bom_id, false, null);
				$GLOBALS['egw']->redirect($preserve['return'] ? $preserve['return'] : $GLOBALS['egw']->link('/index.php?menuaction=perp_manufacturing.ui_perp_bill_of_material.bill_of_material_list'));
			}

			// Set up outgoing
			if($bom && !$bom_id) {
				$GLOBALS['egw']->session->appsession('bill_of_material', false, $bom);
				$data = $bom;
			} elseif ($bom_id) {
				$data = $this->bo->get_bill_of_material($bom_id);
				$GLOBALS['egw']->session->appsession('bill_of_material' . $bom_id, false, $data);
			}
			$data['stock_id'] = array(
				'stock_id'	=>	$data['stock_id'],
				'stock_type_flag'	=>	'A'
			);
			$data['add']['component'] = array(
				'filter2'	=>	'E,P'	// Status
			);
			if($bom_id && count($data['details']) == 0) {
				$this->messages[] = array(lang('Bill of materials is empty'), 'warning');
			}

			$data['no_edit'] = !$edit || !$data['stock_id']['stock_id'];
			$data['no_add'] = $data['no_edit'] || !$bom_id;
			$data['edit'] = $edit;
			$data['delete'] = $delete;
			$data['save'] = (!$bom_id ? lang('Next') : lang('Save'));

			// Sort order
			$order = get_var('order');
			$sort = $GLOBALS['egw']->session->appsession('sort');
			if($order != $GLOBALS['egw']->session->appsession('old_order')) {
				$sort = '';
			}
			if($order) {
				switch ($sort) {
					case 'ASC':
						$sort = 'DESC';
						$image = 'up';
						break;
					case 'DESC':
						$order = '';
						$sort = '';
						break;
					default:
						$sort = 'ASC';
						$image = 'down';
						break;
				}
			}
			$data[$order . '_image'] = 'etemplate/' . $image;
			$GLOBALS['egw']->session->appsession('order', false, $order);
			$GLOBALS['egw']->session->appsession('old_order', false, $order);
			$GLOBALS['egw']->session->appsession('sort', false, $sort);

			// Select boxes

			// Put this globally to save the tree building some work
			$this->work_center_list = array(0 => lang('Any')) + ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center_list');
			$select_box_options['work_center'] =& $this->work_center_list;

			if($bom_id) {
				$select_box_options['bill_of_materials'] = $this->get_tree_data($bom_id);
			}

			// Preserve
			$preserve['bill_of_material_id'] = $bom_id;
			$preserve['sort'] = $sort;

			// Readonlys
			$readonly['effective_after_date']	=	!$edit;
			$readonly['effective_to_date']		=	!$edit;
			$readonly['stock_id']			=	!$edit || ($data['stock_id'] && $bom_id);
			$readonly['start_work_center']		=	!$edit;
			$readonly['finished_work_center']	=	!$edit;
			$readonly['comments']			=	!$edit;
			$readonly['add_line']			=	!$edit;
			$readonly['save']			=	!$edit;

			// ajax
			$GLOBALS['egw_info']['flags']['include_xajax'] = True;

			// JavaScript
			if(!is_object($GLOBALS['egw']->js)) {
				$GLOBALS['egw']->js =& CreateObject('phpgwapi.javascript');
			}
			$GLOBALS['egw']->js->validate_file('bill_of_material', 'edit', 'perp_manufacturing');
			$GLOBALS['egw']->js->set_onload("bill_of_materials.openItem('$bom_id'); \n");

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = $bom_id ? lang('Edit Bill of Materials') : lang('New Bill of Materials');
			$this->template->read('perp_manufacturing.bill_of_material_edit');
			return $this->template->exec('perp_manufacturing.ui_perp_bill_of_material.bill_of_material_edit', $data, $select_box_options, $readonly, $preserve);
		}

		/**
		*	Bill of Material Listing
		*	Shows a bill of material for the selected stock item exploded to include all sub-assemblies and options (also exploded) 
		*	By default, it uses the current BOM, but can also take a starting bill_of_material_id, and using the dates show historical data
		*	
		*	@param	int	$_GET['stock_id'] or $content['stock_id'] - the stock item to display
		*	@param	int	$_GET['bill_of_material_id']  - the Bill of Materials to display
		*/
		public function bill_of_material_listing($content = array()) {
			if($this->debug) {
				echo 'perp_manufacturing.bo_perp_bill_of_material.build_list incoming data:';
				_debug_array($content);
			}

			
			$stock_id = $content['stock_id'] ? $content['stock_id'] : $_GET['stock_id'];
			if(!$stock_id) {
				$bom_id = $content['bill_of_material_id'] ? $content['bill_of_material_id'] : $_GET['bill_of_material_id'];
				$bom = $this->bo->get_bill_of_material($bom_id);
				$stock_id = $bom['stock_id'];
			}
			$date = $content['as_of_date'] ? $content['as_of_date'] : date('U');

			$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
			$html = '<link href="http://devel.projecterp.org/perp_manufacturing/templates/default/full_bom.css" type="text/css" rel="StyleSheet" />';
			$html .= $this->print_stock($stock_id, 1, $date, $content['location']);

			$data['stock_id'] = $stock_id;
			$data['as_of_date'] = $date;
			$data['short_description'] = $stock['short_description'];
			$data['html'] = $html;
			if(isset($this->cost) && $content['location']) {
				$data['cost'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $this->cost);
				unset($this->cost);
			}
			$data['location'] = $content['location'];

			$select_box_options['location'] = array('' => lang('No costing')) + ExecMethod('perp_inventory.bo_perp_location.get_location_list');

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Bill of Materials Listing');
			$this->template->read('perp_manufacturing.bill_of_material_listing');
			$this->template->exec('perp_manufacturing.ui_perp_bill_of_material.bill_of_material_listing', $data, $select_box_options, $readonly, $preserve);
		}

		private function print_stock($component, $quantity = 1, $date = null, $location = null, $add_cost = true) {
			if(is_numeric($component)) {
				$component = array('stock_id' => $component);
			} 
			if(!isset($component['stock_id'])) {
				return;
			}
			$stock_array = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $component['stock_id']);

			$html .= "<div class='stock_item'>\n";
			$html .= "<div class='stock_item_heading'>";
			$html .= "<div class='stock_num'>" . $stock_array['stock_num'] . '</div>';
			$html .= "<div class='stock_quantity'>";
			if($stock_array['pseudo']) {
				$html .= '[pseudo]';
			}

			$quantity = number_format($quantity, $stock_array['decimal_places']);
			$uom = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures', $stock_array['unit_of_measure']);

			$html .= "($quantity $uom)</div>\n";
			$html .= "<div class='stock_description'>" . $stock_array['short_description'] . '</div>';
			if($location) {
				$cost = ExecMethod2('perp_inventory.bo_perp_inventory.get_cost_estimate', $stock_array, $date, false) * $quantity;
				if($add_cost) {
					$this->cost += $cost;
				}
				if($cost) {
					$html .= "<div class='cost'>" . ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $cost) . "</div>";
				}
			}
			$work_center = ExecMethod('perp_inventory.bo_perp_location.get_location', $component['work_center']);

			$html .= '<div class="build_details"><work_center>' . $work_center['location_name'] . '</work_center><time>' . $component['time'] . '</time><comment>' . $component['comment'] . '</comment></div>';
			$html .= "</div>"; // stock_item_heading
			$html .= $this->print_stock_bom($stock_array['stock_id'], $date, $location);
			$html .= $this->print_stock_options($stock_array['stock_id'], $date, $location);
			$html .= "</div>\n"; // Stock_item

			$this->part_count += $quantity;

			return $html;
		}

		private function print_stock_bom($stock_id, $date, $location) {
			$bom_list = array();
			$query['stock_id'] = $stock_id;

			if(!$date) {
				$query['filter2'] = 'current';
			} else {
				$query['as_of_date'] = $date;
			}

		        $this->bo->get_bill_of_material_list($query, $bom_list);
			$bom = $this->bo->get_bill_of_material($bom_list[0]['bill_of_material_id']); // Only one allowed
			if(!isset($bom['details'])) {
				return;
			}

			$html .= "<div class='stock_bom'>\n";
			$html .= '<comment>' . $bom['comment'] . '</comment>';
			foreach($bom['details'] as $detail) {
				$detail['stock_id'] = $detail['component'];
				$html .= $this->print_stock($detail, $detail['quantity'], $date, $location, false);
			}
			$html .= '</div>';
			return $html;
		}

		private function print_stock_options($stock_id, $date, $location) {
			$bo_option = CreateObject('perp_manufacturing.bo_perp_build_option');			
			$allowed_build_option_list_query['stock_id'] = $stock_id;
			$allowed_build_option_list_query['value'] = array(-1,-2,-3);
			$allowed_build_option_list_query['as_of_date'] = $date;
			$options = ExecMethod2('perp_manufacturing.bo_perp_build_option.get_allowed_build_option_list', $allowed_build_option_list_query);
			if(!count($options)) {
				return;
			}

			$values = $bo_option->get_allowed_option_value_list();
			$html .= "<div class='stock_options'>";
			foreach($options as $option) {
				$html .= "<div class='option'>\n";
				$html .= "<div class='option_category_name'>" . $option['build_option_category_name'] . '</div>';
				$html .= "<div class='option_name'>" . $option['build_option_name'] . ($option['value'] != -3 ? ' (' . $values[$option['value']] . ')' : '') . '</div>';
				$work_center = ExecMethod('perp_inventory.bo_perp_location.get_location', $option['work_center']);
				$html .= "<option_work_center>" . $work_center['location_name'] . '</option_work_center>';
				if($option['component']) {
					// Cost is added to total if option is default or required
					$html .= $this->print_stock($option['component'], 1, $date, $location, in_array($option['value'], array(-1,-2)));
				}
				$html .= "</div>";
			}
			$html .= '</div>';
			return $html;
		}

		/**
		*	Build the tree for displaying a bill of materials.
		*	Returns an array of data suitable for display in the tree widget.
		*
		*	@param bill_of_material_id
		*	@param path_string is the node path (address)
		*	@param readonly default is false
		*	@return array
		*/
		public function get_tree_data($bill_of_materials_id, $path_string = '', $readonly = false) {

			$bom = $GLOBALS['egw']->session->appsession('bill_of_material' . $bill_of_materials_id);
			if($bom['bill_of_material_id'] != $bill_of_materials_id) {
				// Get the different BOM, but don't put it in the session because it's a sub-assembly
				$bom = $this->bo->get_bill_of_material($bill_of_materials_id);
			}

			$tree = array();
			if(strlen($path_string) == 0) {
				$path_string = $bom['bill_of_material_id'];
				$tree[(string)$path_string] = $this->make_tree_node('ROOT', $path_string, $bom, $readonly);
			}

			if(!is_array($bom['details'])) {
				return $tree;
			}

			// Sort is done in memory, instead of in SQL because we don't save the BOM until we're done changing it
			$order = get_var('order');
			if ($order) {
				$sort = $GLOBALS['egw']->session->appsession('sort');
				$sort = ($sort == 'DESC') ? SORT_DESC : SORT_ASC;
				$order_by = array();
				foreach($bom['details'] as $key => $detail) {
					$order_by[$key] = $detail[$order];
				}
				$data =& $bom['details'];
				array_multisort($order_by, $sort, $bom['details']);
			}
			foreach($bom['details'] as $key => $detail) {
				if($detail['bill_of_material_detail_id']) {
					$id = $detail['bill_of_material_detail_id'];
				} else {
					$id = $key;
				}
				$component = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $detail['component']);
				$detail['stock_id'] = $detail['component'];
				if($component['stock_type_flag'] == 'A') {
					$tree[$path_string . '/' . $id] = $this->make_tree_node('ASSEMBLY', $path_string . '/' . $id, $detail, $readonly);
					$sub_bom_id = ExecMethod('perp_inventory.bo_perp_stock.get_current_bom', $component['stock_id']);
					if($sub_bom_id) {
						$sub_tree = $this->get_tree_data($sub_bom_id, $path_string . '/' . $id, $readonly );
					}
					if(is_array($sub_tree) && count($sub_tree) > 0) {
						$tree += $sub_tree;
					}
				} else {
					$tree[$path_string . '/' . $id] = $this->make_tree_node('RAW', $path_string . '/' . $id, $detail, $readonly);
				}
			}
			return $tree;
		}

		/**
		*	Format a tree node
		*/
		public function make_tree_node($node_type, $node_path, $node_data, $readonly) {

			// Sub-assemblies are not editable
			if(substr_count($node_path, '/') > 1) {
				$uneditable = true;
			}
			$uneditable = $uneditable || $readonly;

			if($node_data['stock_id']) {
				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $node_data['stock_id']);
			}

			// Label is a link to stock item
			$node_data['label'] = $GLOBALS['egw']->html->a_href(
				ExecMethod('perp_inventory.bo_perp_stock.link_title', $node_data['stock_id']),
				'/index.php',
				array(
					'menuaction'	=>	'perp_inventory.ui_perp_stock.stock_edit',
					'stock_id'	=>	$node_data['stock_id']
				)
			);
			
			switch ($node_type) {
				case 'ROOT':
					$node_data['label']	= lang('bill of materials') . ' ' . $node_data['label'];
				case 'ASSEMBLY':
					break;
				case 'RAW':
					break;
			}

			if($stock) {
				$node_data['image'] = $this->get_tree_icon($stock);
				$node_data['quantity'] = round($node_data['quantity'], $stock['decimal_places']);
			}

			if($node_type != 'ROOT') {
				if(!is_array($this->work_center_list)) {
					$this->work_center_list = array(0 => lang('Any')) + ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center_list');
				}
				$label = '';
				$node_id = 'exec[' . str_replace('/', '][', $node_path) . ']';
				$label = '<span class="perp_bom_node">' .
					'<node_label class="perp_bom_node_node_label" >' . $node_data['label'] .'</node_label>';
				foreach($node_data as $id => $value) {
					if($id == 'label' || $uneditable || $id == 'comment') {
						// Label is unneeded, and the line breaks in comments break the tree
						continue;
					}
					$hidden_id = $node_id . "[$id]";
					$label .= 	"<input type=\"hidden\" id=\"$hidden_id\" name=\"$hidden_id\" value=\"" . 
						@htmlspecialchars(nl2br($value),ENT_COMPAT,$this->charset) . '" />';
				}
				$label .= 
					'<div class="perp_bom_node_unit_of_measure">' . 
						($node_data['uom'] ? $node_data['uom'] : ExecMethod('perp_api.bo_perp_api.get_unit_of_measures', $stock['unit_of_measure'])) . 
					'</div>'.
					'<div class="perp_bom_node_quantity">' . 
						(($GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_EDIT, 'perp_manufacturing') && !$uneditable) ? 
							'<input id="' . $node_id . '[quantity]" name="' . $node_id . '[quantity]" value="' . $node_data['quantity'] . '" autocomplete="off"/>' :
							$node_data['quantity'] 
						) . 
					'</div>'.
					'<div class="perp_bom_node_work_center">' .
						(($GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_EDIT, 'perp_manufacturing') && !$uneditable) ? 
							str_replace("\n", '', $GLOBALS['egw']->html->select($node_id . '[work_center]', $node_data['work_center'], $this->work_center_list)) : 
							$this->work_center_list[$node_data['work_center']] 
						) . 
					'</div>' .
					'<div class="perp_bom_node_time">' .
						(($GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_EDIT, 'perp_manufacturing') && !$uneditable) ? 
							'<input id="' . $node_id . '[time]" name="' . $node_id . '[time]" value="' . $node_data['time'] . '" autocomplete="off"/>' :
							$node_data['time'] 
						) . ' ' . lang('minutes') .
					'</div>' .
					(($GLOBALS['egw']->acl->check('bill_of_material', EGW_ACL_EDIT, 'perp_manufacturing') && !$uneditable) ? 
						str_replace("\n", '', $GLOBALS['egw']->html->submit_button($node_id . '[remove]', $node_id, "remove_component('$node_path'); return false;", false, 'class="remove"', 'delete')) :
						''
					) .
				'</span>';
				$node_data['label'] = str_replace("\n", '', $label);
			} 
			return $node_data;
		}

		/**
		*	Get an icon to show for the tree nodes
		*
		*	@param stock Stock array
		*	@return string image path, for the tree widget
		*/
		private function get_tree_icon(array $stock) {
			$prefix = '../../../../../../../';
			$bom_image = $prefix . '/perp_manufacturing/templates/' . 'default' . '/images/bom_big.png';
			$stock_image = $prefix . '/perp_inventory/templates/' . 'default' . '/images/inventory_big.png';

			// Defaults
			if(count($stock) == 0 || $stock['stock_type_flag'] == 'A') {
				return $bom_image;
			} else {
				$image = $stock_image;
			}

			// Use category icons
			$this->categories = CreateObject('phpgwapi.categories', 'perp_inventory');
			$category = $this->categories->return_single($stock['stock_category']);
			$category = $category[0];
			$category['data'] = unserialize($category['data']);
			if($category['data']['icon']) {
				$image = $prefix . '/phpgwapi/images/' . $category['data']['icon'];
			}
			return $image;
		}

		/**
		*	Preserve list settings in session
		*/
		public function get_bill_of_material_list(&$query, &$rows = array(), &$readonlys = array()) {
			$GLOBALS['egw']->session->appsession('bill_of_materials_listing', false, $query);
			return $this->bo->get_bill_of_material_list($query, $rows, $readonlys);
		}
	}
?>
