<?php

	class ui_perp_build_option {

		public $public_functions = array(
			'build_option_category_list'	=>	True,
			'build_option_category_new'	=>	True,
			'build_option_category_edit'	=>	True,
			'build_option_new'		=>	True,
			'build_option_edit'		=>	True,
			'get_stock_item_stock_options'	=>	true,
			'exclusion_matrix'		=>	true,
		);

		private $debug = False;

		private $template;
		private $bo;

		public function ui_perp_build_option() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_manufacturing.bo_perp_build_option');
		}

		public function build_option_category_list($content = array()) {
			if($this->debug) {
				echo '<strong>perp_manufacturing.ui_perp_build_option.build_option_category_list</strong> incoming data:';
				_debug_array($content);
			}
			
			$read = $GLOBALS['egw']->acl->check('build_option', EGW_ACL_READ, 'perp_manufacturing');
			$add = $GLOBALS['egw']->acl->check('build_option', EGW_ACL_ADD, 'perp_manufacturing');
			$edit = $GLOBALS['egw']->acl->check('build_option', EGW_ACL_EDIT, 'perp_manufacturing');
			$delete = $GLOBALS['egw']->acl->check('build_option', EGW_ACL_DELETE, 'perp_manufacturing');
			
			// Where to return to
			$preserve['return'] = $_GET['return'] ? $_GET['return'] : ($content['return'] ? $content['return'] : $_SERVER['HTTP_REFERER']);

			if(!$read) {
				unset($content);
				$content['cancel'] = True;
			}

			$preserve['return'] = $_GET['return'] ? $_GET['return'] : ($content['return'] ? $content['return'] : $_SERVER['HTTP_REFERER']);

			if(isset($content['new_build_option_category'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_build_option.build_option_category_new'));
			} elseif(isset($content['new_build_option'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_build_option.build_option_new'));
			} elseif($content['nm']['rows']['view']) {
				$bom_id = key($content['nm']['rows']['view']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_bill_of_material.bill_of_material_edit', 'bill_of_material_id'=>$bom_id));
			} elseif($content['nm']['rows']['edit'] && $edit) {
				$bom_id = key($content['nm']['rows']['edit']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_bill_of_material.bill_of_material_edit', 'bill_of_material_id'=>$bom_id));
			} elseif($content['nm']['rows']['delete_cat'] && $delete) {
				$bom_id = key($content['nm']['rows']['delete_cat']);
				$this->bo->delete_build_option_category($bom_id);
			} elseif($content['nm']['rows'] && $delete) {
				$build_option_id = key($content['nm']['rows'][key($content['nm']['rows'])]['options']['delete']);
				$this->bo->delete_build_option($build_option_id);
			} elseif($content['cancel']) {
				$GLOBALS['egw']->redirect($preserve['return'] ? $preserve['return'] : $GLOBALS['egw']->link('/index.php?menuaction=perp_manufacturing.ui_perp_manufacturing.index'));
			}

			$readonly['new_build_option_category'] = !$add;
			$readonly['new_build_option'] = !$add;
			
			$data['nm'] = $GLOBALS['egw']->session->appsession('build_option_category_list', 'perp_manufacturing');
			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'by_category'	=>	True,
					'cat_app'	=>	'perp_inventory',
					'filter_label'  =>      'Option Category',
					'filter_no_lang'        =>      True,
					'filter2_label' =>      'Status',
					'filter2_no_lang'       =>      True,
					'filter2'	=>	'current',
					'get_rows'      =>      'perp_manufacturing.ui_perp_build_option.get_build_option_list',
					'template'      =>      'perp_manufacturing.build_option_list.row',
				);				
			}
			
			$select_box_options['filter'] = array('' => lang('All')) + $this->bo->get_build_option_category_list();
			$select_box_options['filter2'] = $this->bo->get_build_option_status_list();
			$select_box_options['stock_category'] = ExecMethod('perp_inventory.bo_perp_stock_category.get_category_list');

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Build Option List');
			$this->template->read('perp_manufacturing.build_option_list');
			$this->template->exec('perp_manufacturing.ui_perp_build_option.build_option_category_list', $data, $select_box_options, $readonly, $preserve);
		}		
		
		/** 
		*	Get build option list for build_option_category_list, above
		*	This is in the UI so preferences can be saved
		*/
		public function get_build_option_list(&$query, &$rows, &$readonlys) {
			$GLOBALS['egw']->session->appsession('build_option_category_list', 'perp_manufacturing', $query);
			
			return $this->bo->get_build_option_list($query, $rows, $readonlys);
		}		
		
		public function build_option_category_new($content = array()) {
			return $this->build_option_category_edit($content);
		}

		public function build_option_category_edit($content = array()) {

			$preserve['return'] = $_GET['return'] ? $_GET['return'] : ($content['return'] ? $content['return'] : $_SERVER['HTTP_REFERER']);

			if(isset($content['save'])) {
				try {
					$result = $this->bo->set_build_option_category($content['build_option_category_id'], $content);
				} catch (Exception $e) {
					$this->messages[] = array($e->getMessage(), 'error');
				}
				if(is_numeric($result)) {
					$this->messages[] = array(lang('Category saved'), 'success');
				}
			} elseif($content['cancel']) {
				$GLOBALS['egw']->redirect($preserve['return'] ? $preserve['return'] : $GLOBALS['egw']->link('/index.php?menuaction=perp_manufacturing.ui_perp_manufacturing.index'));
			}
		
			$id = $content['build_option_category_id'] ? $content['build_option_category_id'] : $_GET['build_option_category_id'];

			$data = $this->bo->get_build_option_category($id);

			$preserve['build_option_category_id'] = $id;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('New') . ' ' . lang('Build Option Category');
			$this->template->read('perp_manufacturing.build_option_category_edit');
			$this->template->exec('perp_manufacturing.ui_perp_build_option.build_option_category_edit', $data, $select_box_options, $readonly, $preserve);
		}

		public function build_option_new($content = array()) {
			//check the session to grab the the category filter to preset the category selectbox
			$build_option_category_list = $GLOBALS['egw']->session->appsession('build_option_category_list', 'perp_manufacturing');
			$content['build_option_category_list_filter'] = $build_option_category_list['filter'];

			return $this->build_option_edit($content);
		}

		public function build_option_edit($content = array()) {
			if($this->debug) {
				echo '<strong>perp_manufacturing.ui_perp_build_option.build_option_edit</strong> incoming data:';
				_debug_array($content);
			}
			
			$preserve['return'] = $_GET['return'] ? $_GET['return'] : ($content['return'] ? $content['return'] : $_SERVER['HTTP_REFERER']);
			$data = array();
			$data['default_pricing|stock_items'] = $content['default_pricing|stock_items'];
			// Default price change effective date to tomorrow, start of day
			$tomorrow = strtotime('tomorrow');
                        $default_date = mktime($GLOBALS['egw_info']['user']['preferences']['calendar']['workdaystarts'], 0, 0, date('m', $tomorrow), date('d', $tomorrow), date('Y', $tomorrow));
			$data['effective_from'] = $content['effective_from']?$content['effective_from']:mktime(0,0,0, date('m'), date('d'), date('Y'));

			$id = $content['build_option_id'] ? $content['build_option_id'] : $_GET['build_option_id'];
			if(isset($content['save'])) {
				if($content['pricing']['rows']) {
					$pricing = $content['pricing']['rows'];
					unset($content['pricing']);
				}
				if($content['stock_items_list']['rows']) {
					foreach($content['stock_items_list']['rows'] as $option) {						
						$option['build_option_id'] = $content['build_option_id'];
						$option['effective_from'] = $data['effective_from'];
						$result = ExecMethod2('perp_manufacturing.bo_perp_build_option.set_allowed_build_option', $option['stock_id'], $option);
						if($result !== true) {
							$this->messages[] = array($result, 'error');
						}
					}
				}
				
				$result = $this->bo->set_build_option($content['build_option_id'], $content);
				if(is_numeric($result)) {
					$id = $result;
					if(is_array($pricing)) {
						foreach($pricing as $price) {
							$result = ExecMethod2('perp_orders.bo_perp_price.set_price', $price['price_list_id'], null, $price['price'], $content['effective_date'], $id);
							if($result !== true) {
								$this->messages[] = array($result, 'error');
								$this->messages[] = array('Changing prices was aborted', 'warning');
								break;
							}
						}
					}
					$this->messages[] = array(lang('Build Option Saved'), 'success');
				} else {
					$this->messages[] = array($result, 'error');
				}
			}
			if($content['cancel']) {
				$GLOBALS['egw']->redirect($preserve['return'] ? $preserve['return'] : $GLOBALS['egw']->link('/index.php?menuaction=perp_manufacturing.ui_perp_build_option.build_option_list'));
			}		

			$data += $this->bo->get_build_option($id);

			$data['effective_date'] = $content['effective_date'] ? $content['effective_date'] : $default_date;
			
			$data['stock_items_list'] = array_merge(
				array(
					'build_option_category'	=>	$data['build_option_category'],
					'build_option_id'	=>	$id,
					'effective_from' 	=>	$data['effective_from'],
					'no_cat'        	=>	True,
					'no_filter'     	=>	False,
					'filter_label'		=>	'Status',
					'filter_no_lang'	=>	True,
					'filter'		=>	'P',
					'no_filter2'     	=>	True,
					'filter_no_lang'	=>	True,
					'get_rows'		=>	'perp_manufacturing.ui_perp_build_option.get_stock_item_stock_options',
					'template'		=>	'perp_manufacturing.build_option_edit.stock_items.row',
				),
				$content['stock_items_list'] ? $content['stock_items_list'] : array()
			);
				
			//$data['nm']['filter2'] = $GLOBALS['egw_info']['user']['preferences']['perp_inventory']['stock_status'];
			$select_box_options['filter'] = array('' => lang('All')) + ExecMethod('perp_inventory.bo_perp_stock.get_status_flags');
			$select_box_options['work_center'] = array('' => lang('Select')) + ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center_list');
			$select_box_options['value'] = ExecMethod('perp_manufacturing.bo_perp_build_option.get_allowed_option_value_list');
			
			$data['pricing'] = array(
				'build_option_id'	=>	$id,
				'date'			=>	$data['effective_date'],
				'no_cat'        	=>      false,
				'cat_app'		=>	'perp_orders',
				'no_filter'     	=>      True,
				'no_filter2'     	=>      True,
				'get_rows'		=>      'perp_manufacturing.bo_perp_build_option.get_price_list',
				'template'		=>      'perp_manufacturing.build_option_edit.default_pricing.row',
				'order'			=>	isset($content['pricing']['order']) ? $content['pricing']['order'] : 'sales_category_name',
				'sort'			=>	isset($content['pricing']['sort']) ? $content['pricing']['sort'] : 'ASC',
			);
			if(!$data['effective_after_date']) {
				$data['effective_after_date'] = $default_date;
			}
			$preserve['old_effective_after_date'] = $data['effective_after_date'];
			$select_box_options['build_option_category'] = $this->bo->get_build_option_category_list();

			//set the category selectbox to the filter from build_option_category_list
			if(!$data['build_option_category'] && $content['build_option_category_list_filter']) {
				$data['build_option_category'] = $content['build_option_category_list_filter'];
			}

			$preserve['build_option_id'] = $id;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			if(!(($GLOBALS['egw']->acl->check('build_option', EGW_ACL_ADD, 'perp_manufacturing') && !$id) || 
				$GLOBALS['egw']->acl->check('build_option', EGW_ACL_EDIT, 'perp_manufacturing')
			)) {
				$readonly = array(
					'save'	=>	true,
				);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = $id ? lang('Edit Build Option - %1', $data['build_option_name']) : lang('New Build Option');
			$this->template->read('perp_manufacturing.build_option_edit');
			$this->template->exec('perp_manufacturing.ui_perp_build_option.build_option_edit', $data, $select_box_options, $readonly, $preserve);
		}

		public function get_stock_item_stock_options(&$query, &$rows = array(), &$readonlys = array()) {
			$count = $this->bo->get_stock_item_stock_options($query, $rows, $readonlys);

			// Add in filters
			foreach($rows as &$row) {
				$row['component'] = array(
					'stock_id'	=>	$row['component'],
					'status'	=>	'P,E'
				);
			}
			return $count;
		}

		/**
		*	Display an exclusion matrix, which build options cannot co-exist with other build options.
		*
		*	This grid allows you to set up interactions BETWEEN build options, without making a 
		*	deep or complicated option tree.  The restriction is limited to exclusions, and is
		*	for build options.  No reference is made to a specific stock item, so this is a global
		*	exclusion.  No exceptions.
		*
		*	@param content
		*/
		public function exclusion_matrix($content = array()) {
			
			// Deal with incoming
			if($content['save']) {
				$matrix = array();
				if(is_array($_POST['exclude'])) {
					foreach($_POST['exclude'] as $row_option_id => $columns) {
						foreach($columns as $column_option_id => $garbage) {
							$matrix[$row_option_id][] = $column_option_id;
						}
					}
				}
				bo_perp_build_option::set_exclusion_matrix($matrix);
			} elseif ($content['cancel']) {
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_manufacturing.ui_perp_build_option.build_option_category_list'
				));
			}

			// Get all build options
			$query = array(
				'template'	=>	true,
				'status'	=>	'current',
				'num_rows'	=>	-1
			);
			$this->bo->get_build_option_list($query, $build_options);
			$exclusions = $this->bo->get_exclusion_matrix();

			// Check for discontinued
			$query['status'] = 'previous';
			$this->bo->get_build_option_list($query, $discontinued);
			foreach($discontinued as $discontinued_option) {
				if($exclusions[$discontinued_option['build_option_id']]) {
					$build_options[] = $discontinued_option;
				}
			}

			$readonly = !$GLOBALS['egw']->acl->check('build_option', EGW_ACL_EDIT, 'perp_manufacturing');

			$html .= '<link rel="STYLESHEET" type="text/css" href="'.$GLOBALS['egw_info']['server']['webserver_url'].'/perp_manufacturing/templates/default/exclusion.css" />'."\n";
			$table = '<table ><thead><tr class="column_header"><th></th>';
			foreach($build_options as $col_header) {
				$table .= "<th><div>{$col_header['build_option_name']}</div></th>";
			}
			$table .= '</thead><tbody>';
			foreach($build_options as $row_key => $row) {
				if($row['effective_to_date'] && $row['effective_to_date'] < time()) {
					$class = ' disabled';
				}
				$table .= "<tr class='$class'><td class='row_header'>{$row['build_option_name']}</td>";
				foreach($build_options as $col_key => $col) {
					$table .= self::exclusion_cell($row_key, $row, $col_key, $col, $exclusions);
				}
				$table .= '<td class="row-footer"></td></tr>';
			}

			// Look through leftovers
			foreach($exclusions as $option_1 => $excluded) {
				
			}
			$table .= '</tbody></table>';
			
			$html .= '<div id="GridContainer" class="grid-div">';
			$html .= $table;
			$html .= '</div>';

			$data['matrix'] = $html;
			$readonlys['save'] = $readonly;

			$GLOBALS['egw_info']['flags']['app_header'] = lang('Build Option Exclusion Matrix');
			$this->template->read('perp_manufacturing.exclusion_matrix');
			$this->template->exec('perp_manufacturing.ui_perp_build_option.exclusion_matrix', $data, $select_box_options, $readonlys, $preserve);
		}

		private static function exclusion_cell($row_key, $row, $col_key, $col, &$exclusions) {
			$table .= '';
			// Skip the top half of the grid
			if($col_key >= $row_key) {
				return;
			}

			// Skip things in the same category, but mark them
			if($col['build_option_category_id'] == $row['build_option_category_id']) {
				$table .= '<td>X';
			} else {
				$disabled = ($row['build_option_category_id'] == $col['build_option_category_id'] || $readonly) ? 'disabled' : '';
				$checked = (is_array($exclusions[$row['build_option_id']]) && in_array($col['build_option_id'], $exclusions[$row['build_option_id']])) ? 'checked' : '';
				$table .= "<td><input type='checkbox' name='exclude[{$row['build_option_id']}][{$col['build_option_id']}]' {$disabled} $checked/>";
			}
			
			$table .= '<div class="tooltip" id="tip[' . "{$row['build_option_id']}][{$col['build_option_id']}" . ']"><table>';
			$table .= "<tr><td class='tooltip_category'>{$row['build_option_category_name']}</td>";
			$table .= "<td>{$row['build_option_name']}</td>";
			$table .= "<tr><td class='tooltip_category'>{$col['build_option_category_name']}</td>";
			$table .= "<td>{$col['build_option_name']}</td></tr>";
			$table .= '</table></div>';
			$table .= '</td>';
			return $table;
		}
}
?>
