<?php

	/**
	*	User interface for retrofits
	*
	*	Most of the good UI stuff is done in ui_perp_stock_history.
	*
	*	@author Nathan Gray
	*/

	require_once(EGW_INCLUDE_ROOT . '/perp_manufacturing/inc/class.bo_perp_retrofit.inc.php');

	class ui_perp_retrofit {

		public $public_functions = array(
			'view'	=>	true,
		);

		protected $template = null;
		
		public function __construct() {
			$this->template = new etemplate();
		}

		public function view($content = array()) {
			// Get ID
			$stock_history_id = get_var('stock_history_id', 'any', $content['stock_history_id']);

			$data = self::get_display_data($stock_history_id);

			if($content['cancel']) {
				$GLOBALS['egw']->redirect_link(
					'/index.php', array(
					'menuaction'	=>	'perp_inventory.ui_perp_stock_history.stock_history_list',
					'stock_id'	=>	$data['stock_id'],
					'serial'	=>	$data['serial_number']
				));
			}
			
			$select_box_options = self::get_options($data);

			$preserve['stock_history_id'] = $stock_history_id;

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Retrofit of %1 - %2', $data['stock_num'], $data['serial_number']);
			$this->template->read('perp_manufacturing.retrofit');
			$this->template->exec('perp_manufacturing.ui_perp_retrofit.view', $data, $select_box_options, $readonly, $preserve);
		}

		/**
		*	Get data for display
		*/
		public static function get_display_data($stock_history_id) {
			if(!$stock_history_id) {
				return array();
			}
	
			$data = bo_perp_retrofit::get_retrofit($stock_history_id);

			$query = array(
                                'stock_id'	=>	$data['stock_id'],
                                'serial_number'	=>	$data['serial_number'],
                        );
                        $bo_inventory = CreateObject('perp_inventory.bo_perp_inventory');
                        $bo_inventory->get_controlled_inventory_list($query, $serial_data);
                        if(count($serial_data) == 1) {
                                $serial_data = $serial_data[0];
                                $data += $serial_data;
			}

			$data += ExecMethod2('perp_manufacturing.bo_perp_work_order.get_work_order', $data['work_order_id']);
			$data += ExecMethod2('perp_manufacturing.bo_perp_work_order.get_work_order_detail', $data['work_order_id'], $data['detail_id']);
			$data += ExecMethod2('perp_inventory.bo_perp_stock.get_stock_item', $data['stock_id']);

			$serial = ExecMethod2('perp_manufacturing.bo_perp_work_order.get_serial_number', $data['work_order_id'], $data['stock_id']);
			if(count($serial) == 1) {
				$data += $serial[0];
			}

			$build_option_category = ExecMethod('perp_manufacturing.bo_perp_build_option.get_build_option_category', $data['build_option_category_id']);
			$original_option = ExecMethod2('perp_manufacturing.bo_perp_work_order.get_work_order_detail_option', $data['work_order_id'], $data['detail_id'], $data['build_option_category_id']);
			$original_option = ExecMethod('perp_manufacturing.bo_perp_build_option.get_build_option', $original_option['build_option_id']);
			$build_option = ExecMethod('perp_manufacturing.bo_perp_build_option.get_build_option', $data['build_option_id']);

			$data['build_option_category_name'] = $build_option_category['build_option_category_name'];
			$data['build_option_name'] = $build_option['build_option_name'];
			$data['original_option_name'] = $original_option['build_option_name'];

			$data['link'] = array(
				'to_id'		=>	'RETROFIT-' . $stock_history_id,
				'to_app'	=>	'perp_manufacturing'
			);

			return $data;
		}

		/**
		*	Get information for selectbox options
		*/
		public static function get_options($data) {
			$options = array();

			return $options;
		}
	}

?>
