<?php

	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_inventory.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_inventory/inc/class.bo_perp_location.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_manufacturing/inc/class.bo_perp_work_center.inc.php');

	class ui_perp_work_order {

		public $public_functions = array(
			'work_order_list'	=>	True,
			'work_order_new'	=>	True,
			'work_order_edit'	=>	True,
			'work_order_detail_new'	=>	True,
			'work_order_detail_edit'	=>	True,
			'work_order_batch'	=>	True,
			'work_order_detail_bom'	=>	true,
			'option_history'	=>	true,
			'serial_history'	=>	true,
		);

		private $template;
		private $bo;
		private $messages = array();

		private $debug = false;

		public function ui_perp_work_order() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_manufacturing.bo_perp_work_order');
		}

		public function work_order_list($content = array()) {
			if($this->debug) {
				echo '<strong>perp_manufacturing.ui_perp_work_order.work_order_list</strong> incoming data:';
				_debug_array($content);
			}

			$edit = $GLOBALS['egw']->acl->check('work_order', EGW_ACL_EDIT, 'perp_manufacturing');
			$delete = $GLOBALS['egw']->acl->check('work_order', EGW_ACL_DELETE, 'perp_manufacturing');
			$build = $GLOBALS['egw']->acl->check('production', EGW_ACL_EDIT, 'perp_manufacturing');

			if(isset($content['new_work_order'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_work_order.work_order_new'));
			} elseif($content['nm']['rows']['edit'] && ($edit || $GLOBALS['egw']->acl->check('work_order', EGW_ACL_READ, 'perp_manufacturing')) ) {
				$id = key($content['nm']['rows']['edit']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_manufacturing.ui_perp_work_order.work_order_edit', 'work_order_id'=>$id));
			} elseif($content['nm']['rows']['delete'] && $delete) {
				$id = key($content['nm']['rows']['delete']);
				$result = $this->bo->delete_work_order($id);
				if($result !== True) {
					$msg[] = array($result, 'error');
				} else {
					$msg[] = array(lang('Work order deleted'), 'success');
				}
			} elseif($content['nm']['rows']['build'] && $build) {
				$id = key($content['nm']['rows']['build']);
				$result = $this->bo->build_work_order($id);
				if($result !== True) {
					$msg[] = array($result, 'error');
				} else {
					$msg[] = array(lang('Work order completed'), 'success');
				}
			} elseif($content['nm']['rows']['move_to'] && $build) {
				// Only do one
				foreach($content['nm']['rows']['move_to'] as $work_order_id => $work_center_id) {
					if($work_center_id) {
						$detail_id = 1;
						$result = bo_perp_workflow::move_to($work_order_id, $detail_id, $work_center_id);
						break;
					}
				}
			} elseif(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_manufacturing.ui_perp_manufacturing.index');
			}

			// Actions
			$this->handle_actions($content);
			
			$config = config::read('perp_manufacturing');
			if(!$config['auto_history_bom']) {
				// Turning this option off makes for easier setup, but can cause mismatched options and incorrect historical data
				$msg[] = array(lang('The Force Bill of Material history option is off.  This can cause a loss of historical data as to what was actually
					put into a particular work order, or mismatched build options.  Turning this option off is recommended while you are setting 
					up, but should be turned on under Admin -> Manufacturing -> Site Configuration as soon as you get your 
					Bills of Materials and build options correctly entered.'), 'warning');
			}

			$data['nm'] = $GLOBALS['egw']->session->appsession('work_order_list', 'perp_manufacturing');
			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'include_details'	=>	true,
					'cat_app'		=>	'perp_inventory',
					'filter_label'		=>	'Status',
					'filter_no_lang'	=>	True,
					'filter2_label'		=>	'Location',
					'filter2_no_lang'	=>	True,
					'get_rows'		=>	'perp_manufacturing.ui_perp_work_order.get_work_order_list',
					'template'		=>	'perp_manufacturing.work_order_list.row',
					'order'			=>	'work_order_reference',
					'sort'			=>	'DESC',
				);
			}
			$select_box_options['filter'] = array('' => lang('All')) + $this->bo->get_work_order_status_list();
			if($config['use_workflow']) {
				$process_list = ExecMethod('perp_manufacturing.bo_perp_workflow.get_process_list', $data['nm']['rows']['stock_id']);
				foreach($process_list as $process_id) {
					// Add workflow activities into the Status filter
					$activity_list = ExecMethod('workflow.workflow_activitymanager.get_process_activities', $process_id );

					// Sort activities so they're in approximate order
					if(is_array($activity_list) && count($activity_list) > 0) {
						foreach($activity_list as $key => $act) {
							$activity_number[$key] = $act['wf_flow_num'];
						}
						array_multisort($activity_number, $activity_list);

						foreach($activity_list as $act) {
							$activities[$act['wf_activity_id']] = $act['wf_name'];
						}
						$select_box_options['filter'] += array(lang('Activities') => $activities);
						$select_box_options['move_to'] = $activities;
					}
				}
			}
			$select_box_options['filter2'] = array('' => lang('All')) + ExecMethod('perp_manufacturing.bo_perp_work_order.get_end_locations');
			$select_box_options['status'] = $this->bo->get_work_order_status_list() + ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center_list');
			$select_box_options['stock_id'] = ExecMethod('perp_inventory.bo_perp_stock.get_stock_list', array('cat_id' => $data['nm']['cat_id'], 'stock_type_flag' => 'A'));
			$select_box_options['action'] = array();
			if($GLOBALS['egw']->acl->check('report_build_tag', EGW_ACL_READ, 'perp_manufacturing')) {
				$select_box_options['action']['build_tag']	=	lang('Generate build tags');
			}

			if($msg) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $msg);
			}

			$readonly['new_work_order'] = !$GLOBALS['egw']->acl->check('work_order', EGW_ACL_ADD, 'perp_manufacturing');
	
			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Work Order List');
			$this->template->read('perp_manufacturing.work_order_list');
			$this->template->exec('perp_manufacturing.ui_perp_work_order.work_order_list', $data, $select_box_options, $readonly, $preserve);
		}

		public function work_order_new($content = array()) {
			return $this->work_order_edit($content);
		}

		public function work_order_edit($content = array()) {
			if($this->debug) {
				echo 'perp_manufacturing.ui_perp_work_order.work_order_edit incoming data';
				_debug_array($content);
			}
			
			$work_order_id = $content['work_order_id'] ? $content['work_order_id'] : $_GET['work_order_id'];
			$data = array();

			// Incoming Data
			if(isset($content['save'])) {
				$content['details'] = $content['nm']['rows'];
				unset($content['nm']);
				unset($content['save']);
				$result = $this->bo->set_work_order($work_order_id, $content);
				if(is_numeric($result)) {
					$work_order_id = $result;
					$this->messages[] = array(lang('Work Order saved'), 'success');
				} else { 
					$this->messages[] = array($result, 'error');
				}
				$GLOBALS['egw']->redirect_link('/index.php',
					array(
						'menuaction'	=>	'perp_manufacturing.ui_perp_work_order.work_order_edit',
						'work_order_id'	=>	$work_order_id
					)
				);
			} elseif(isset($content['nm']['rows']['delete'])) {
				$detail_id = key($content['nm']['rows']['delete']);
				$detail = $this->bo->get_work_order_detail($work_order_id, $detail_id);
				$detail['quantity'] = 0;
				$this->bo->set_work_order_detail($work_order_id, $detail_id, $detail);
			} elseif(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_manufacturing.ui_perp_work_order.work_order_list');
			}

			// Redirect to avoid re-posting from popup dialog
			if(isset($content['save']) || isset($content['nm']['rows'])) {
			}

			// Read data for display
			if($work_order_id) {
				$data += $this->bo->get_work_order($work_order_id);

				$data['nm'] = array(
					'work_order_id'	=>	$work_order_id,
					'no_cat'        =>      True,
					'no_filter'     =>      True,
				//	'filter_label'  =>      'Stock Category',
				//	'filter_no_lang'        =>      True,
					'no_filter2'    =>      True,
				//	'filter2_label' =>      'Stock Category',
				//	'filter2_no_lang'       =>      True,
					'get_rows'      =>      'perp_manufacturing.ui_perp_work_order.get_work_order_detail_list',
					'template'      =>      'perp_manufacturing.work_order_edit.row',
				//	'header_left'   =>      '',
				//	'header_right'  =>      '',
				);
		
				$this->bo->get_work_order_detail_list($data['nm'], $data['nm']['rows']);

				foreach($data['nm']['rows'] as $row) {
					$data['cost'] += $row['direct_cost'];
				}
				$data['cost'] = ExecMethod2('perp_api.bo_perp_api.get_formatted_price', null, $data['cost']);

				$data['save'] = lang('Save');

				if(!$data['location']) {
					$this->messages[] = array(lang('End location for this work order is not set.  Save the work order.'), 'error');
				}
			} else {
				$data['save'] = lang('Next');
			}
			$data['detail_id'] = count($data['nm']['rows']) + 1;
			if(!$data['created_date']) {
				$data['created_date'] = date('U');
			}

			if(!$data['work_order_reference']) {
				$data['work_order_reference'] = $this->bo->get_reference();
				$readonly['work_order_reference'] = False;
			} else {
				$readonly['work_order_reference'] = True;
			}

			// Readonlys
			$serialized = False;
			$this->bo->get_work_order_detail_list(array('work_order_id' => $work_order_id), $details);
			foreach($details as $detail) {
				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $detail['stock_id']);
				$serialized |= $stock['serialized'];
			}

			if(!$work_order_id || $serialized || !$GLOBALS['egw']->acl->check('work_order', EGW_ACL_EDIT, 'perp_manufacturing')) {
				$readonly['add_line'] = True;
			}
			$readonly['save'] = !$GLOBALS['egw']->acl->check('work_order', EGW_ACL_EDIT, 'perp_manufacturing');

			// Select box options
			$select_box_options['location'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');

			$preserve['work_order_reference'] = $data['work_order_reference'];
			$preserve['work_order_id'] = $work_order_id;
			$preserve['created_date'] = $data['created_date'];

			if(count($this->messages)) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = $work_order_id ? lang('Edit Work Order %1', $data['work_order_reference']) : lang('New Work Order');
			$this->template->read('perp_manufacturing.work_order_edit');
			$this->template->exec('perp_manufacturing.ui_perp_work_order.work_order_edit', $data, $select_box_options, $readonly, $preserve);
		}
	
		public function work_order_detail_new($content = array()) {
			$work_order_id = $content['work_order_id'] ? $content['work_order_id'] : $_GET['work_order_id'];
			$detail_id = count($this->bo->get_work_order_detail_list(array('work_order_id' => $work_order_id))) + 1;

			$detail = array(
				'work_order_id'	=>	$work_order_id,
				'detail_id'	=>	$detail_id,
				'quantity'	=>	1,
			);
			return $this->work_order_detail_edit($detail);
		}

		public function work_order_detail_edit($content = array()) {
			if($this->debug) {
				echo 'perp_manufacturing.ui_perp_work_order.work_order_detail_edit incoming data';
				_debug_array($content);
			}

			$work_order_id = $content['work_order_id'] ? $content['work_order_id'] : $_GET['work_order_id'];
			$detail_id = $content['detail_id'] ? $content['detail_id'] : $_GET['detail_id'];

			// Incoming data
			$data = $this->bo->get_work_order_detail($work_order_id, $detail_id, true);
			if($content['stock_id'] && !$data['stock_id']) {
				// Just set stock ID, save detail so it's there for options
				$this->bo->set_work_order_detail($work_order_id, $detail_id, $content);
			} elseif(isset($content['stock_id']) && $content['stock_id'] && $GLOBALS['egw']->acl->check('work_order', EGW_ACL_EDIT, 'perp_manufacturing')) {
				if(isset($content['options']) && isset($content['options']['rows'])) {
					foreach($content['options']['rows'] as $key => $row) {
						$this->bo->set_work_order_detail_option($work_order_id, $detail_id, $row['stock_id'], $row['build_option_category_id'], $row['value']);
					}
				}
			}
			if(isset($content['save']) && $GLOBALS['egw']->acl->check('work_order', EGW_ACL_EDIT, 'perp_manufacturing')) {
				$this->bo->set_work_order_detail($work_order_id, $detail_id, $content);
			}

			// Outgoing
			$data = $this->bo->get_work_order_detail($work_order_id, $detail_id, true);
			if(!$data['stock_category']) {
				if($data['stock_id']) {
					$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $data['stock_id']);
					$data['stock_category'] = $stock['stock_category'];
				} else {
					$data['stock_category'] = $content['stock_category'];
				}
			}
			if(!$data['stock_id']) {
				$data['stock_id'] = $content['stock_id'];
			}
			if(!$data['quantity']) {
				$data['quantity'] = $content['quantity'];
			}
			$work_order = $this->bo->get_work_order($work_order_id);
			$stock_item = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $data['stock_id']);
			$set_options = $this->bo->get_work_order_detail_option($work_order_id, $detail_id);
			if($data['options'] || count($set_options) > 0) {
				$data['set_options'] = True;
				$readonly['set_options'] = True;
			} else {
				$data['set_options'] = $content['set_options'];
			}

			if($data['set_options'] && $data['stock_id'] && ($stock_item['stock_type_flag'] == 'A')) {
				$data['options'] = array(
					'work_order_id'	=>	$work_order_id,
					'detail_id'	=>	$detail_id,
					'stock_id'	=>	$data['stock_id'],
					'effective_date'	=>	$work_order['created_date'],
					'no_cat'        =>      True,
					'no_filter'     =>      True,
				//	'filter_label'  =>      'Stock Category',
				//	'filter_no_lang'        =>      True,
					'no_filter2'    =>      True,
				//	'filter2_label' =>      'Stock Category',
				//	'filter2_no_lang'       =>      True,
					'get_rows'      =>      'perp_manufacturing.bo_perp_work_order.get_work_order_detail_option_list',
					'template'      =>      'perp_manufacturing.work_order_detail_edit.row',
				//	'header_left'   =>      '',
				//	'header_right'  =>      '',
				);
			}

			if($data['stock_id']) {
				$data['work_order_id'] = $work_order_id;
				$data['detail_id'] = $detail_id;
				if(!$work_order['completed']) {
					$this->messages += $this->check_work_order_detail($data);
				}

				if(!$data['quantity']) {
					$data['quantity'] = 1;
				}
			}

			// Check here to see if there are no errors, and we can close the popup
			if(count($this->messages) == 0 && $content['save']) {
				$GLOBALS['egw']->js->set_onload('self.close();');
			}

			// Filter stock to only assemblies
			$data['stock_id'] = array(
				'stock_id'		=>	$data['stock_id'],
				'stock_type_flag'	=>	'A',
				'pseudo'		=>	false,
				'status'		=>	'E,P'
			);

			// Select box options
			if(is_numeric($data['stock_id']['stock_id']) && $data['set_options']) {
				$this->bo->get_work_order_detail_option_list($data['options'], $data['options']['rows'], $readonlys['options']);
				if(is_array($data['options']['rows'])) {
					array_unshift($data['options']['rows'], false);
					foreach($data['options']['rows'] as $key => $row) {
						if(!is_array($row['options-value'])) {
							continue;
						}
						foreach($row['options-value'] as $id => $option) {
							$select_box_options[$key][$id] = $option['build_option_name'];
						}
					}
				}
			}


			// Readonlys
			if(!$data['stock_id'] || $data['direct_cost'] + $data['indirect_cost'] != 0 || 
					!$GLOBALS['egw']->acl->check('work_order', EGW_ACL_EDIT, 'perp_manufacturing')) {
				$readonly['quantity'] = True;
				$readonly['save'] = True;
			}
			
			$preserve['work_order_id'] = $work_order_id;
			$preserve['detail_id'] = $detail_id;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Edit Work Order');
			$this->template->read('perp_manufacturing.work_order_detail_edit');
			$this->template->exec('perp_manufacturing.ui_perp_work_order.work_order_detail_edit', $data, $select_box_options, $readonly, $preserve, 2);
		}

		public function check_work_order_detail($detail_array) {
			$messages = array();

			// Check for a current bill of materials
			$bom_id = ExecMethod('perp_inventory.bo_perp_stock.get_current_bom', $detail_array['stock_id']);
			if(!$bom_id) {
				$messages[] = array(lang('No current bill of materials for %1, unable to build.', ExecMethod('perp_inventory.bo_perp_stock.link_title', $detail_array['stock_id'])), 'error');
			}

			// Check for a workflow
			$config = config::read('perp_manufacturing');
			$workflow_process = ExecMethod('perp_manufacturing.bo_perp_workflow.get_process_id', $detail_array['stock_id']);
			if($config['use_workflow']) {
				if(!$workflow_process) {
					$messages[] = array(lang('No workflow for %1, unable to build.', ExecMethod('perp_inventory.bo_perp_stock.link_title', $detail_array['stock_id'])), 'error');
				} else {
					$result = ExecMethod2(
						'perp_manufacturing.bo_perp_workflow.check_process', 
						$workflow_process, 
						$detail_array['stock_id'], 
						$detail_array['work_order_id'],
						$detail_array['detail_id']
					);
					if(is_array($result)) {
						foreach($result as $message) {
							$messages[] = array($message, 'error');
						}
					}
				}
			}

			// Check to make sure there's inventory
			if($detail_array['quantity'] == 0) {
				return $messages;
			}

			// Make sure we get all the items
			$detail_array['num_rows'] = -1;

			$this->bo->get_work_order_detail_bom($detail_array, $bom);
			if(!$bom) {
				$bom = ExecMethod('perp_manufacturing.bo_perp_bill_of_material.get_bill_of_material', $bom_id);
				$bom = $bom['details'];
				$check_type_flag = true;
			}

			$bo_inventory = new bo_perp_inventory();
			$bo_work_center = new bo_perp_work_center();
			$work_order = $this->bo->get_work_order($detail_array['work_order_id']);
			$categories = array();
			$components = array();

			foreach($bom as $component) {
				if($check_type_flag) {
					// Coming from the original BOM because this detail isn't saved yet, so we need to check the type
					$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $component['component']);
					if($stock['pseudo']) {
						continue;
					}
					$component['quantity'] *= $detail_array['quantity'];
				}
				if($component['pseudo']) {
					continue;
				}
				
				/**
				*	@todo Change the key 'work_center' to 'work_center_id'.
				*	If we get the BOM from perp_manufacturing.bo_perp_bill_of_material.get_bill_of_material,
				*	the key is 'work_center'.  It needs to be changed to 'work_center_id' throughout the code.
				*/
				if($component['work_center']) {
					$component['work_center_id'] = $component['work_center'];
				}
				if($component['work_center_id']) {
					$component_query = array(
						'template'	=>	false,
						'work_center_id'=>	$component['work_center_id'],
						'stock_id'	=>	$component['component']
					);
					$bo_work_center->get_work_center_location_list($component_query, $work_centers);
					$location = $work_centers[0]['location_id'];
					$location_name = $work_centers[0]['location_name'];

					if(!$location) {
						$work_center = $bo_work_center->get_work_center($component['work_center_id']);
						$messages[] = array(lang('No inventory location set up at %1 for the work center "%2", but you use %3 there.', 
							ExecMethod('perp_inventory.bo_perp_location.link_title', $work_order['location']),
							$work_center['name'],
							ExecMethod('perp_inventory.bo_perp_stock.link_title', $component['component'])
						), 'error');
						continue;
					}
							
				} else {
					$location = $work_order['location'];
				}
				if($component['quantity'] != 0 && !in_array($component['component'], $components)) {
					$bo_inventory->get_inventory(
						array('stock_id' => $component['component'], 'location_id' => $location),
						$stock_on_hand
					);
					if(!$stock_on_hand[0]) {
						$location_name = ExecMethod('perp_inventory.bo_perp_location.link_title', $location);
					}
					if(!$stock_on_hand[0] || $stock_on_hand[0]['quantity_on_hand'] < $component['quantity']) {
						$messages[] = array(lang('Not enough %1 on hand at %4.  <br />You need %2 %5, you have %3.', 
							ExecMethod('perp_inventory.bo_perp_stock.link_title', $component['component']),
							$component['quantity'],
							number_format($stock[0]['quantity_on_hand']),
							$stock_on_hand[0]['location_name'] ? $stock_on_hand[0]['location_name'] : $location_name,
							$component['uom']
						), $component['controlled'] ? 'error' : 'warning');
						$components[] = $component['component'];
						continue;
					}

					// Make sure controlled items use workflow, at least until some other way of recording serial numbers is developed.
					if($component['controlled'] && !$workflow_process) {
						$messages[] = array(lang('%1 is controlled.  You need to use a workflow so pERP can record the serial / batch number.',
							ExecMethod('perp_inventory.bo_perp_stock.link_title', $component['component'])),
							'error'
						);
					}
					$categories[$stock_on_hand[0]['stock_category']][] = $location;
				}
				$components[] = $component['component'];
			}

			// Check to make sure the work in progress and stock in hand account account is there
			$bo_location = new bo_perp_location();
			$location_names = $bo_location->get_location_list();
			foreach($categories as $stock_category => &$locations) {
				$locations = array_unique($locations);
				foreach($locations as $location_id) {
					$gl_accounts = $bo_location->get_gl_accounts(
						array(
							'location_id'	=>	$location_id,
							'stock_category_id'	=>	$stock_category
						)
					);
					if(!$gl_accounts['work_in_progress_gl_account']) {
						$messages[] = array(lang('Missing work in progress General Ledger account for %1 at %2.  If you have permission, you can %3.',
							$gl_accounts['stock_category_name'],
							$location_names[$location_id],
							'<a href="' . $GLOBALS['egw']->link('/index.php', array(
							'menuaction'    =>      'perp_inventory.ui_perp_location.location_edit',
							'location_id'   =>      $location_id,
							'tab'           =>      'accounts'
							)) . '">' . lang('fix it') . '</a>'), 
						'error');
					}
					if(!$gl_accounts['stock_gl_account']) {
						$messages[] = array(lang('Missing stock General Ledger account for %1 at %2.  If you have permission, you can %3.',
							$gl_accounts['stock_category_name'] ? $gl_accounts['stock_category_name'] : '<' . lang('Not set') . '>',
							$location_names[$location_id],
							'<a href="' . $GLOBALS['egw']->link('/index.php', array(
							'menuaction'    =>      'perp_inventory.ui_perp_location.location_edit',
							'location_id'   =>      $location_id,
							'tab'           =>      'accounts'
							)) . '">' . lang('fix it') . '</a>'), 
						'error');
					}
				}
			}

			// Check to make sure we have somewhere to put the finished goods
			$work_order = $this->bo->get_work_order($detail_array['work_order_id']);
			if(!$work_order['location']) {
				$messages[] = array(lang('End location for this work order is not set.  Save the work order.'), 'error');
			} elseif($detail_array['stock_category']) {
				$gl_accounts = $bo_location->get_gl_accounts(array(
					'location_id'	=>	$work_order['location'],
					'stock_category_id'	=>	$detail_array['stock_category']
				));
				if(!$gl_accounts['stock_gl_account']) {
					$messages[] = array(lang('Missing stock General Ledger account for %1 at %2.  If you have permission, you can %3.',
						$gl_accounts['stock_category_name'] ? $gl_accounts['stock_category_name'] : '<' . lang('Not set') . '>',
						$location_names[$work_order['location']],
						'<a href="' . $GLOBALS['egw']->link('/index.php', array(
						'menuaction'    =>      'perp_inventory.ui_perp_location.location_edit',
						'location_id'   =>      $work_order['location'],
						'tab'           =>      'accounts'
						)) . '">' . lang('fix it') . '</a>'), 
					'error');
				}
			}
				
			// Check for received cost (never received will throw off costing)
			$components = array_unique($components);
			foreach($components as $stock_id) {
				$cost = ExecMethod('perp_inventory.bo_perp_stock.get_cost_summary', $stock_id);
				if(!isset($cost[0])) {
					$messages[] = array(lang('No cost history for %1, cost for this work order may not be accurate.',
						ExecMethod('perp_inventory.bo_perp_stock.link_title', $stock_id)), 
						'warning'
					);
				}
			}

			return $messages;
		}

		public function work_order_batch($content = array()) {
			if($this->debug) {
				echo 'perp_manufacturing.ui_perp_work_order.work_order_batch incoming data';
				_debug_array($content);
			}
			
			// Incoming
			if(isset($content['save']) && $content['start_date'] && $content['required_date']) {
				unset($content['save']);
				$work_order = array(
					'created_date'	=>	$content['created_date'],
					'start_date'	=>	$content['start_date'],
					'required_date'	=>	$content['required_date'],
					'location'	=>	$content['location'],
					'details'	=>	array( 0=> array(
						'stock_id'	=>	$content['stock_id'],
						'quantity'	=>	1
					))
				);
				for($i = 0; $i < $content['quantity']; $i++) {
					$work_order['work_order_reference'] = $this->bo->get_reference($content['stock_id']);
					$m = $this->bo->set_work_order(null, $work_order);
					if($m !== True && !is_numeric($m)) {
						$msg[] = array($m, 'error');
					}
				}
				if($msg && !is_numeric($msg)) {
					$msg[] = array($msg, 'error');
				} else {
					$msg[] = array(lang('Success'), 'success');
				}
			} elseif(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_manufacturing.ui_perp_manufacturing.index');
			}

			// Outgoing
			$data = $content;
			if($data['stock_id']) {
				$option_count = $this->bo->get_work_order_detail_option_list(array('stock_id' => $data['stock_id']));
			}

			if(!$data['created_date']) {
				$data['created_date'] = date('U');
			}

			// Select box options
			$select_box_options['stock_category'] = array('' => lang('Select')) + ExecMethod('perp_inventory.bo_perp_stock_category.get_category_list');
			$select_box_options['stock_id'] = array('' => lang('Select')) + ExecMethod('perp_inventory.bo_perp_stock.get_stock_list', array('filter' => $content['stock_category']));
			$select_box_options['location'] = ExecMethod('perp_inventory.bo_perp_location.get_location_list');

			// Readonlys
			if(!$data['stock_category']) {
				$readonly['stock_id'] = True;
			}
			if(!$data['stock_id']) {
				$readonly['quantity'] = True;
				$readonly['save'] = True;
			}
			if(!$option_count) {
				$readonly['set_options'] = True;
				$data['no_options'] = True;
			}

			if($msg) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $msg);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Batch Work Order');
			$this->template->read('perp_manufacturing.work_order_batch');
			$this->template->exec('perp_manufacturing.ui_perp_work_order.work_order_batch', $data, $select_box_options, $readonly, $preserve);
		}

		/**
		*	View / edit the bill of materials for a work order detail
		*
		*	@param content Array of data sent from the template
		*/
		public function work_order_detail_bom($content = array()) {
			if($this->debug) {
				echo __METHOD__ . ' incoming data:';
				_debug_array($content);
			}

			$work_order_id = $content['work_order_id'] ? $content['work_order_id'] : $_GET['work_order_id'];
			$detail_id = $content['detail_id'] ? $content['detail_id'] : $_GET['detail_id'];

			// Incoming data
			if($content['save']) {
				// Get original rows from session for comparison
				$data['bom'] = $GLOBALS['egw']->session->appsession('detail_bom_' . $work_order_id . '-' . $detail_id, 'perp_manufacturing');
				foreach($content['bom']['rows'] as $key => $row) {
					$original = $data['bom']['rows'][$key - 1];
					if(!$original) {
						continue;
					}
					if($row['quantity'] != $original['quantity']) {
						// They changed the quantity
						$delta_quantity = $row['quantity'] - $original['quantity'];
						$row = array_merge($original, $row);
						$this->bo->change_bill_of_material(
							$work_order_id, $detail_id, 
							$original['component'], $delta_quantity, 
							$original['bill_of_material_detail_id'], 
							$row['work_center_id']
						);
					}
				}
			} elseif ($content['add'] && $content['add']['component'] && $content['add']['delta_quantity'] != 0) {
				$this->bo->change_bill_of_material(
					$work_order_id, $detail_id, 
					$content['add']['component'], $content['add']['delta_quantity'], 
					0, $content['add']['work_center_id']
				);
				unset($content['add']);
			} elseif ($content['cancel']) {
				$GLOBALS['egw']->session->appsession('detail_bom_' . $work_order_id . '-' . $detail_id, 'perp_manufacturing', null);
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_manufacturing.ui_perp_work_order.work_order_edit',
					'work_order_id'	=>	$work_order_id,
				));
			}

			// Outgoing
			$work_order = $this->bo->get_work_order($work_order_id);
			$detail = $this->bo->get_work_order_detail($work_order_id, $detail_id);

			// Look for nextmatch settings in session
			$data['bom'] = $GLOBALS['egw']->session->appsession('detail_bom_' . $work_order_id . '-' . $detail_id, 'perp_manufacturing');
			if(!is_array($data['bom'])) {
				// Default nextmatch settings
				$data['bom'] = array(
					'work_order_id'	=>	$work_order_id,
					'detail_id'	=>	$detail_id,
					'get_rows'	=>	'perp_manufacturing.ui_perp_work_order.get_detail_bom',
					'template'	=>	'perp_manufacturing.work_order_bom.row',
					'cat_app'	=>	'perp_inventory',
					'filter_label'	=>	'Work Center',
					'no_filter2'	=>	true,
				);
			}
			$data['bom']['work_order_id'] = $work_order_id;
			$data['bom']['detail_id'] = $detail_id;

			// Select box options
			$select_box_options['work_center_id'] = array('' => 'All') + ExecMethod('perp_manufacturing.bo_perp_work_center.get_work_center_list');
			$select_box_options['unit_of_measure'] = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures');
			$select_box_options['filter'] = $select_box_options['work_center_id'];

			// Readonlys
			$ro = !in_array($this->bo->get_work_order_status($work_order_id), bo_perp_work_order::$build_statuses) || 
				!$GLOBALS['egw']->acl->check('work_order', EGW_ACL_EDIT, 'perp_manufacturing');
			$readonly['save'] = $ro;
			$readonly['add'] = $ro;

			// Preserve
			$preserve['work_order_id'] = $work_order_id;
			$preserve['detail_id'] = $detail_id;

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang(
				'Bill of Materials for %1 - #%2 <br />%3', 
				$work_order['work_order_reference'], 
				$detail_id, 
				ExecMethod('perp_inventory.bo_perp_stock.link_title', $detail['stock_id'])
			);
			$this->template->read('perp_manufacturing.work_order_bom');
			$this->template->exec('perp_manufacturing.ui_perp_work_order.work_order_detail_bom', $data, $select_box_options, $readonly, $preserve);
		}

		/**
		*	Get bill of material components for a work order detail fo viewing or editing
		*	
		*	Changes in nextmatch parameters are saved in the session, so the nextmatch 
		*	doesn't bounce around.
		*/
		public function get_detail_bom(&$query = array(), &$rows = array(), &$readonlys = array()) {
			$count = $this->bo->get_work_order_detail_bom($query, $rows, $readonlys);
			$GLOBALS['egw']->session->appsession('detail_bom_' . $query['work_order_id'] . '-' . $query['detail_id'], 'perp_manufacturing', $query);

			return $count;
		}

		/**
		*	Store the query in the session so people don't have to keep flipping through the list
		*/
		public function get_work_order_list(&$query, &$rows = array(), &$readonlys = array()) {
			$GLOBALS['egw']->session->appsession('work_order_list', 'perp_manufacturing', $query);
			return $this->bo->get_work_order_list($query, $rows, $readonlys);
		}

		/**
		*	Handle actions on work orders
		*
		*	@param content Full content array returned from eTemplate
		*/
		protected function handle_actions($content = array()) {
			if(!$content['action']) {
				return true;
			}
			switch ($content['action']) {
				case 'build_tag':
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'	=>	'perp_api.ui_perp_report.get_report',
						'report_name'	=>	'perp_manufacturing.build_tag',
						'work_order_id'	=>	$content['nm']['rows']['checked']
					));
					break;
			}
		}

		/**
		*	Display a list of changes to build options
		*/
		public function option_history($content = array()) {
			if($this->debug) {
				echo __METHOD__ . ' incoming data:';
				_debug_array($content);
			}

			$work_order_id = $content['work_order_id'] ? $content['work_order_id'] : $_GET['work_order_id'];
			$detail_id = $content['detail_id'] ? $content['detail_id'] : $_GET['detail_id'];

			if($content['cancel']) {
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_manufacturing.ui_perp_work_order.work_order_edit',
					'work_order_id'	=>	$work_order_id
				));
			}

		
			// Outgoing
			$work_order = $this->bo->get_work_order($work_order_id);
			$detail = $this->bo->get_work_order_detail($work_order_id, $detail_id);
			$data['history'] = bo_perp_work_order::get_option_history($work_order_id, $detail_id);
			array_unshift($data['history'], false);

			$select_box_options['build_option_category_id'] = ExecMethod('perp_manufacturing.bo_perp_build_option.get_build_option_category_list');
			$select_box_options['old_option'] = $select_box_options['new_option'] = ExecMethod('perp_manufacturing.bo_perp_build_option.get_build_option_list');

			$preserve['work_order_id'] = $work_order_id;
			$preserve['detail_id'] = $detail_id;


			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang(
				'Option Changes for %1-%2 %3', 
				$work_order['work_order_reference'], 
				$detail_id, 
				ExecMethod('perp_inventory.bo_perp_stock.link_title', $detail['stock_id'])
			);
			$this->template->read('perp_manufacturing.option_history');
			$this->template->exec('perp_manufacturing.ui_perp_work_order.option_history', $data, $select_box_options, $readonly, $preserve);
		}

		/**
		*	User interface layer for list of work order details
		*	We add some UI specific stuff in here, such as component serial numbers
		*
		*	@nextmatch
		*/
		public function get_work_order_detail_list(&$query = array(), &$rows = array(), &$readonlys = array()) {
			
			$count = $this->bo->get_work_order_detail_list($query, $rows, $readonlys);

			// Add in extra stuff
			$serial_query = array(
				'work_order_id'	=>	$query['work_order_id']
			);
			foreach($rows as &$row) {
				$serial_query['detail_id'] = $row['detail_id'];
				$readonlys['component_serials[' . $row['detail_id'] . ']'] = (0 == bo_perp_serial_assembly::get_serial_assemblies($serial_query));
			}
			return $count;
		}

		/**
		*	Display a list of controlled components that were put into the build.
		*	
		*	If the work order has not been completed, someone with the appropriate permission
		*	(production:edit) can change the recorded serial numbers in the event that
		*	a number was mis-entered.
		*
		*	After the work order has been completed, this page is read-only.
		*/
		public function serial_history($content = array()) {
			
			// Find the variables we need
			$work_order_id = get_var('work_order_id', 'any', $content['work_order_id']);
			$detail_id = get_var('detail_id', 'any', $content['detail_id']);

			$work_order = $this->bo->get_work_order($work_order_id);
			$detail = $this->bo->get_work_order_detail($work_order_id, $detail_id);

			$serial_query = array(
				'work_order_id'	=>	$work_order_id,
				'detail_id'	=>	$detail_id
			);

			// Deal with incoming
			if(!$work_order['completed'] && $content['save'] && $GLOBALS['egw']->acl->check('production', EGW_ACL_EDIT, 'perp_manufacturing')) {
				// Check for changed serial numbers
				foreach($content['old_component_serials'] as $key => $component) {
					if($content['component_serials'][$key]['component_serial_number'] != $component['component_serial_number']) {
						// They changed the serial number.  
						try {
							$result = bo_perp_serial_assembly::change_serial_assembly(
								$content['old_component_serials'][$key]['stock_history'],
								$work_order_id,
								$detail_id, 
								$content['component_serials'][$key]['component_serial_number']
							);
						} catch (Exception $e) {
							$this->messages[] = array($e->getMessage(), 'error');
						}
						if($result === true) {
							$this->messages[] = array(lang(
								'%1 number %2 changed to %3',
								ExecMethod('perp_inventory.bo_perp_stock.link_title', $content['old_component_serials'][$key]['component_stock_id']),
								$component['component_serial_number'],
								$content['component_serials'][$key]['component_serial_number']
							), 'success');
						}
					}
				}
			} elseif ($content['cancel']) {
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_manufacturing.ui_perp_work_order.work_order_edit',
					'work_order_id'	=>	$work_order_id
				));
			}

			// Load data for display
			bo_perp_serial_assembly::get_serial_assemblies($serial_query, $data['component_serials']);

			if($work_order['completed'] || !$GLOBALS['egw']->acl->check('production', EGW_ACL_EDIT, 'perp_manufacturing')) {
				$readonly['component_serials'] = true;
				$readonly['save'] = true;
			}

			$preserve['work_order_id'] = $work_order_id;
			$preserve['detail_id'] = $detail_id;
			$preserve['old_component_serials'] = $data['component_serials'];

			if(count($this->messages)) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			
			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang(
				'Controlled Components for %1-%2 %3', 
				$work_order['work_order_reference'], 
				$detail_id, 
				ExecMethod('perp_inventory.bo_perp_stock.link_title', $detail['stock_id'])
			);

			$this->template->read('perp_manufacturing.serial_history');
			$this->template->exec('perp_manufacturing.ui_perp_work_order.serial_history', $data, $select_box_options, $readonly, $preserve);
		}
	}
?>
