<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');

	class bill_of_material extends perp_report {

		private $stock_item_subtemplate;

		function bill_of_material(array $parameters = array()) {
			parent::perp_report($parameters);
			$this->template = 'bom_head.odt';
			$this->stock_item_subtemplate = EGW_INCLUDE_ROOT . '/perp_manufacturing/inc/report/en/stock_item.inc';

			// Default parameters
			if(!count($parameters)) {
				$this->parameters = array(
					'as_of_date'		=>	date('U'),
					'options-location'	=>	ExecMethod('perp_inventory.bo_perp_location.get_location_list')
				);
			}
		}

		public function get_data($query = array()) {
			$data = $query;
			$data['date'] = $query['as_of_date'];
			$data += ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $query['stock_id']);
			$data += ExecMethod('perp_inventory.bo_perp_location.get_location', $query['location']);

			$stock_item = 'SELECT * FROM perp_stock WHERE stock_id = %p1%';
			$bom = 'SELECT * 
				FROM perp_bill_of_material
				JOIN perp_bill_of_material_detail ON
					perp_bill_of_material.bill_of_material_id = perp_bill_of_material_detail.bill_of_material_id
				JOIN perp_stock ON
					perp_bill_of_material_detail.component = perp_stock.stock_id
				WHERE perp_bill_of_material.stock_id = %p1% AND
					(effective_after_date <= \'' . $GLOBALS['egw']->db->to_timestamp($data['as_of_date']) . '\' AND (
						effective_to_date IS NULL OR
						effective_to_date >= \'' . $GLOBALS['egw']->db->to_timestamp($data['as_of_date']) . '\'
					)
				)';
			$data['stock_item'] = array(
				'source_type'	=>	'mysql',
				'query'		=>	$stock_item
			);
			$data['bom'] = array(
				'source_type'	=>	'mysql',
				'query'		=>	$bom
			);
			return $data;
		}

		/** 
		*	Override display() function to do sub-templates
		*/
		public function display() {
			// Check for template
			if(!file_exists($this->template)) {
				$data['template_missing']	= lang('template is either not set or missing');
				$data['template_name']		= $this->template;
				$this->template = EGW_INCLUDE_ROOT . '/perp_api/inc/report/no_report.odt';
			}

			// Create new document
			$data = (isset($data) ? $data : $this->get_data($this->get_parameters()));

			$this->bo = CreateObject('perp_manufacturing.bo_perp_bill_of_material');
			$query = array(
				'stock_id'	=>	$data['stock_id'],
				'as_of_date'	=>	$data['as_of_date'],
			);
			$GLOBALS['stock_item_subtemplate'] = $this->stock_item_subtemplate;
/*
			$this->bo->get_bill_of_material_list($query, $bom_list);
			$data['bill_of_material_id'] = $bom_list[0]['bill_of_material_id'];
			$bom = $this->bo->get_bill_of_material($bom_list[0]['bill_of_material_id']);
			$data['bom'] = $bom;
$this->OOo->ObjectRef = array();
$this->OOo->ObjectRef =& $data;
*/
			$this->OOo->NewDocFromTpl($this->template);
//_debug_array($bom);
			$this->OOo->LoadXmlFromDoc('content.xml');

			$this->OOo->MergeBlock('data', 'array', array(0=>$data));
			foreach($data as $key => $block) {
				if(is_string($key) && is_array($block) && !isset($block['source_type'])) {
					$this->OOo->MergeBlock($key, 'array', $data[$key]);
				} elseif(is_string($key) && is_array($block) && isset($block['source_type'])) {
					$this->OOo->MergeBlock($key, $block['source_type'], $block['query']);
				}
			}
			$this->OOo->SaveXmlToDoc();

			// ===== xml meta =============================================================
			$this->OOo->LoadXmlFromDoc('meta.xml');
			//$this->OOo->SaveXmlToDoc();

			// Styles data
			$this->OOo->LoadXmlFromDoc('styles.xml');
			$this->OOo->SaveXmlToDoc();


			// Output
			switch ($header) {
				// method 1 : send to the browser via header location (problem with IE)
				case 'location':
					header('Location:'.$this->OOo->GetPathnameDoc());
				break;

				// method 2 : send to the browser via header content-type
				case 'content':
				default:
					$filename = basename($this->template);
					header('Content-type: '.$this->OOo->GetMimetypeDoc());
					header('Content-Length: '.filesize($this->OOo->GetPathnameDoc()));
					header('Content-Disposition: inline; filename="' . $filename . '"');
					$this->OOo->FlushDoc();
					$this->OOo->RemoveDoc();
				break;
			}
		}
	}
?>
