<?php

	/**
	*	A tag for attaching to goods as they're being built.
	*/

	require_once( EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once( EGW_INCLUDE_ROOT . '/perp_api/inc/barcode/image.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_manufacturing/inc/class.bo_perp_work_order.inc.php');

	class build_tag extends perp_report {
		
		public function __construct(&$parameters) {
			parent::__construct($parameters);

			$this->template = 'build_tag.odt';

			$this->parameters['work_order_id'] = reg_var('work_order_id');

			// If work_order_id is provided, just generate the report
			if($this->parameters['work_order_id']) {
				$parameters['generate_report'] = true;
			}
		}

		public function get_data($query = array()) {
			$data = array(
				'images'	=>	array(),
			);
			if(!$query['work_order_id']) {
				return false;
			}

			$bo_work_order = new bo_perp_work_order();

			if(!is_array($query['work_order_id'])) {
				$query['work_order_id'] = explode(',', $query['work_order_id']);
			}

			// Make sure we have detail IDs
			foreach($query['work_order_id'] as $key => $work_order_number) {
				list($work_order_id, $detail_id) = explode(':', $work_order_number);
				if(!$detail_id) {
					unset($query['work_order_id'][$key]);
					$bo_work_order->get_work_order_detail_list(array('work_order_id' => $work_order_id), $detail_list);
					foreach($detail_list as $detail_id => $line) {
						$query['work_order_id'][] = $work_order_id . ':' . $detail_id;
					}
				}
			}

			foreach($query['work_order_id'] as $work_order_number) {
				list($work_order_id, $detail_id) = explode(':', $work_order_number);

				$work_order = $bo_work_order->get_work_order($work_order_id);
				$detail = $bo_work_order->get_work_order_detail($work_order_id, $detail_id);
				$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $detail['stock_id']);

				// Make sure we don't display more than desired
				$detail['quantity'] = round($detail['quantity'], $stock['decimal_places']);
				$uoms = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures');
				$detail['unit_of_measure'] = $uoms[$stock['unit_of_measure']];

				$instance_id = ExecMethod2('perp_manufacturing.bo_perp_workflow.get_instance_id', $work_order_id, $detail_id);
				if($instance_id) {
					$instance_manager = new workflow_instancemanager();
					$instance = CreateObject('workflow.workflow_instance');
					$instance->loadInstance($instance_id);
					$bar_code = $instance->getName();
				} else {
					$bar_code = $work_order['work_order_reference'] . ':' . $detail_id;
				}

				$option_query = array(
					'work_order_id'	=>	$work_order_id,
					'detail_id'	=>	$detail_id,
					'stock_id'	=>	$detail['stock_id'],
					'effective_date'	=>	$work_order['created_date']
				);
				$options = array();
				$bo_work_order->get_work_order_detail_option_list($option_query, $options);

				foreach($options as &$option) {
					$option['build_option_name'] = $option['options-value'][$option['value']]['build_option_name'];
				}


				$data['tag'][] = array(
					'work_order'	=>	$work_order,
					'detail'	=>	$detail,
					'stock'		=>	$stock,
				);
				$data[ (count($data['tag']) - 1) . '_option'] = $options;


				$data['images'][] = array(
					'name'	=>	(count($data['tag']) - 1) . '_bar_code',
					'path'	=>	$GLOBALS['egw']->link('/perp_api/inc/barcode/image.php', array(
						'code'		=>	$bar_code,
						'encoding'	=>	'code128',
					)),
				);
				$data['images'][] = array(
					'name'	=>	(count($data['tag']) - 1) . '_stock_barcode',
					'path'	=>	$GLOBALS['egw']->link('/perp_api/inc/barcode/image.php', array(
						'code'		=>	$stock['stock_num'],
						'encoding'	=>	'code128',
					))
				);
			}
//_debug_array($data);die();
			return $data;
		}
	}
?>
