/**
 * 	Javascript for editing a bill of materials
 * 	
 */


/**
 * Populate the unit of measure when the user chooses a component to add
 */
function select_component() {
	var new_component = document.getElementById('exec[add][component][value]');
}

/**
 * Add the selected component to the tree
 */
function add_component() {

	var new_component = document.getElementById('exec[add][component][value]');
	var keys = bill_of_materials.getSubItems(bill_of_materials.getSubItems(0)).split(',');

	// Key is the path, like 102/7.  We need the 102 and the 7
	var key = keys[keys.length - 1].split('/');
	var bom_id = parseInt(key[0]);
	if(!bom_id) {
		bom_id = parseInt(document.getElementById('bill_of_material_id').innerHTML);
	}

	// We need to get the highest key, to add it to the bottom.  It may be sorted,
	// so the last key isn't the highest key.
	key = 0;
	for(var i = 0; i < keys.length; i++) {
		max_key = keys[i].split('/');
		key = Math.max(key, max_key[max_key.length - 1]);
	}
	// We want the next key after the highest key
	key++;

	// Get quantity
	var quantity = document.getElementById('exec[add][quantity]');

	// Work center
	var work_center = document.getElementById('exec[add][work_center]');
	
	// Time
	var time = document.getElementById('exec[add][time]');

	if(bom_id) {
		xajax_doXMLHTTP("perp_manufacturing.ajax_perp_bill_of_material.add_component", bom_id, new_component.value, key, work_center.value, quantity.value, time.value);
	}

	// Clear the boxes for next time
	new_component.value = '';
	document.getElementById('exec[add][component][search]').value = '';
	quantity.value = '';
	work_center.selectedIndex = 0;
	time.value = '';

	// Focus back to new_component
	document.getElementById('exec[add][component][search]').focus();
}

function remove_component(key) {
	// Transform PHP node key to JS node key
	var node_key = key.replace(/exec/, '').replace(/\]\[/g, '/');
	node_key = node_key.replace(/\[/g, '').replace(/\]/g, '');
	var key = node_key.split('/');
	var bom_id = parseInt(key[0]);

	xajax_doXMLHTTP("perp_manufacturing.ajax_perp_bill_of_material.remove_component", bom_id, node_key);
}
