<?php
	/**************************************************************************\
	* pERP - Setup                                                             *
	* http://pERP.org                                                          *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


	$phpgw_baseline = array(
		'perp_work_order' => array(
			'fd' => array(
				'work_order_id' => array('type' => 'auto','nullable' => False),
				'created_date' => array('type' => 'date','nullable' => False),
				'required_date' => array('type' => 'date','nullable' => False),
				'start_date' => array('type' => 'date'),
				'completed_date' => array('type' => 'date'),
				'sales_order' => array('type' => 'int','precision' => '4'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'work_order_reference' => array('type' => 'varchar','precision' => '20'),
				'location' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id'),
			'fk' => array('sales_order' => 'perp_sales_order.sales_order_id','location' => 'perp_location.location_id'),
			'ix' => array('work_order_id','created_date','required_date','location'),
			'uc' => array('work_order_id')
		),
		'perp_work_order_detail' => array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'option_search' => array('type' => 'text')
			),
			'pk' => array('work_order_id','detail_id'),
			'fk' => array('work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('work_order_id','detail_id'),
			'uc' => array()
		),
		'perp_work_order_option' => array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'category' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_order_id','detail_id','category'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','build_option_id' => 'perp_allowed_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id'),
			'ix' => array('work_order_id','detail_id','category'),
			'uc' => array()
		),
		'perp_build_option' => array(
			'fd' => array(
				'build_option_id' => array('type' => 'auto','nullable' => False),
				'build_option_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'build_option_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'effective_after_date' => array('type' => 'date','nullable' => False),
				'effective_to_date' => array('type' => 'date')
			),
			'pk' => array('build_option_id'),
			'fk' => array('build_option_category' => 'perp_build_option_category'),
			'ix' => array('build_option_id','build_option_category','effective_after_date','effective_to_date'),
			'uc' => array('build_option_id')
		),
		'perp_build_option_category' => array(
			'fd' => array(
				'build_option_category_id' => array('type' => 'auto','nullable' => False),
				'build_option_category_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'stock_category' => array('type' => 'int','precision' => '4','nullable' => False),
				'required' => array('type' => 'bool','nullable' => False,'default' => '1')
			),
			'pk' => array('build_option_category_id'),
			'fk' => array('stock_category' => 'perp_stock_category.stock_category_id'),
			'ix' => array('build_option_category_id','stock_category'),
			'uc' => array('build_option_category_id','build_option_category_name')
		),
		'perp_allowed_build_option' => array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'value' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('build_option_id','stock_id'),
			'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_stock.stock_id','component' => 'perp_stock.stock_id','work_center' => 'perp_work_center.work_center_id'),
			'ix' => array('build_option_id','stock_id','component','work_center'),
			'uc' => array()
		),
		'perp_bill_of_material' => array(
			'fd' => array(
				'bill_of_material_id' => array('type' => 'auto','nullable' => False),
				'effective_after_date' => array('type' => 'date','nullable' => False),
				'effective_to_date' => array('type' => 'date'),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'comment' => array('type' => 'text'),
				'start_work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'finished_work_center' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('bill_of_material_id'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','start_work_center' => 'perp_work_center.work_center_id','finished_work_center' => 'perp_work_center.work_center_id'),
			'ix' => array('bill_of_material_id','effective_after_date','effective_to_date','stock_id','start_work_center','finished_work_center'),
			'uc' => array('bill_of_material_id')
		),
		'perp_bill_of_material_detail' => array(
			'fd' => array(
				'bill_of_material_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'comment' => array('type' => 'varchar','precision' => '255'),
				'time' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1')
			),
			'pk' => array('bill_of_material_id','component','work_center'),
			'fk' => array('bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id','component' => 'perp_stock.stock_id','work_center' => 'perp_work_center.work_center_id'),
			'ix' => array('bill_of_material_id','component','work_center'),
			'uc' => array()
		),
		'perp_work_order_bill_of_material' => array(
			'fd' => array(
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'component' => array('type' => 'int','precision' => '4','nullable' => False),
				'bom_or_stock' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('work_order_id','detail_id','component'),
			'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id'),
			'ix' => array('work_order_id','detail_id'),
			'uc' => array()
		),
		'perp_work_center' => array(
			'fd' => array(
				'work_center_id' => array('type' => 'auto','nullable' => False),
				'work_center_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255'),
				'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'overhead_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'scanning' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
				'account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('work_center_id'),
			'fk' => array('location' => 'perp_location.location_id','overhead_account' => 'perp_account.account_id','account' => 'egw_accounts.account_id'),
			'ix' => array('work_center_id'),
			'uc' => array('work_center_id',array('location','work_center_name'))
		),
		'perp_fifo_costing' => array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'location' => array('type' => 'int','precision' => '4','nullable' => False),
				'goods_received_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('stock_id' => 'perp_stock.stock_id','location' => 'perp_location.location_id','goods_received_id' => 'perp_goods_received.goods_received_id'),
			'ix' => array('stock_id','goods_received_id'),
			'uc' => array()
		),
		'perp_stock_build_path' => array(
			'fd' => array(
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
				'time' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'sort_order' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('stock_id','work_center'),
			'fk' => array('stock_id' => 'perp_stock.stock_id','work_center' => 'perp_work_center.work_center_id'),
			'ix' => array('stock_id','work_center','sort_order'),
			'uc' => array()
		),
	);
