<?php
	/**************************************************************************\
	* pERP - Setup                                                             *
	* http://pERP.org                                                          *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.32 2005/11/10 12:27:04 ralfbecker Exp $ */


$phpgw_baseline = array(
	'perp_work_order' => array(
		'fd' => array(
			'work_order_id' => array('type' => 'auto','nullable' => False),
			'created_date' => array('type' => 'date','nullable' => False),
			'required_date' => array('type' => 'date','nullable' => False),
			'start_date' => array('type' => 'date'),
			'completed_date' => array('type' => 'date'),
			'sales_order' => array('type' => 'int','precision' => '4'),
			'completed' => array('type' => 'bool','nullable' => False,'default' => '0'),
			'work_order_reference' => array('type' => 'varchar','precision' => '20'),
			'location' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('work_order_id'),
		'fk' => array('sales_order' => 'perp_sales_order.sales_order_id','location' => 'perp_location.location_id'),
		'ix' => array('work_order_id','created_date','required_date','location'),
		'uc' => array('work_order_id')
	),
	'perp_work_order_detail' => array(
		'fd' => array(
			'work_order_id' => array('type' => 'int','precision' => '4'),
			'detail_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'direct_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'indirect_cost' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'option_search' => array('type' => 'text')
		),
		'pk' => array('work_order_id','detail_id'),
		'fk' => array('work_order_id' => 'perp_work_order.work_order_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_work_order_option' => array(
		'fd' => array(
			'work_order_id' => array('type' => 'int','precision' => '4'),
			'detail_id' => array('type' => 'int','precision' => '4'),
			'build_option_id' => array('type' => 'int','precision' => '4'),
			'component' => array('type' => 'int','precision' => '4'),
			'option_bom_id' => array('type' => 'int','precision' => '4'),
			'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'option_category_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('work_order_id','detail_id','option_category_id'),
		'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','build_option_id' => 'perp_build_option.build_option_id','component' => 'perp_stock.stock_id','option_bom_id' => 'perp_work_order_bill_of_material.bill_of_material_id','work_center_id' => 'perp_work_center.location_id','option_category_id' => 'perp_build_option.build_option_category'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_build_option' => array(
		'fd' => array(
			'build_option_id' => array('type' => 'auto','nullable' => False),
			'build_option_category' => array('type' => 'int','precision' => '4','nullable' => False),
			'build_option_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'effective_after_date' => array('type' => 'date','nullable' => False),
			'effective_to_date' => array('type' => 'date')
		),
		'pk' => array('build_option_id'),
		'fk' => array('build_option_category' => 'perp_build_option_category.build_option_category_id'),
		'ix' => array('build_option_id','build_option_category','effective_after_date','effective_to_date'),
		'uc' => array('build_option_id')
	),
	'perp_build_option_category' => array(
		'fd' => array(
			'build_option_category_id' => array('type' => 'auto','nullable' => False),
			'build_option_category_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'stock_category' => array('type' => 'int','precision' => '4','nullable' => False),
			'required' => array('type' => 'bool','nullable' => False,'default' => '1'),
			'ships_separate' => array('type' => 'bool','nullable' => False,'default' => 'false'),
			'can_retrofit' => array('type' => 'bool','nullable' => False,'default' => 'false')
		),
		'pk' => array('build_option_category_id'),
		'fk' => array('stock_category' => 'perp_stock_category.stock_category_id'),
		'ix' => array('build_option_category_id','stock_category','can_retrofit'),
		'uc' => array('build_option_category_id','build_option_category_name')
	),
	'perp_allowed_build_option' => array(
		'fd' => array(
			'build_option_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'value' => array('type' => 'int','precision' => '4','nullable' => False),
			'component' => array('type' => 'int','precision' => '4','nullable' => False),
			'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
			'effective_from' => array('type' => 'timestamp')
		),
		'pk' => array('build_option_id','stock_id','effective_from'),
		'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_stock.stock_id','component' => 'perp_stock.stock_id','work_center' => 'perp_work_center.work_center_id'),
		'ix' => array('component','work_center'),
		'uc' => array()
	),
	'perp_bill_of_material' => array(
		'fd' => array(
			'bill_of_material_id' => array('type' => 'auto','nullable' => False),
			'effective_after_date' => array('type' => 'date','nullable' => False),
			'effective_to_date' => array('type' => 'date'),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'comment' => array('type' => 'text'),
			'start_work_center' => array('type' => 'int','precision' => '4','nullable' => False),
			'finished_work_center' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('bill_of_material_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id','start_work_center' => 'perp_work_center.work_center_id','finished_work_center' => 'perp_work_center.work_center_id'),
		'ix' => array('bill_of_material_id','effective_after_date','effective_to_date','stock_id','start_work_center','finished_work_center'),
		'uc' => array('bill_of_material_id')
	),
	'perp_bill_of_material_detail' => array(
		'fd' => array(
			'bill_of_material_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'component' => array('type' => 'int','precision' => '4','nullable' => False),
			'work_center' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'comment' => array('type' => 'varchar','precision' => '255'),
			'time' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
			'bill_of_material_detail_id' => array('type' => 'auto','nullable' => False)
		),
		'pk' => array('bill_of_material_detail_id'),
		'fk' => array('bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id','component' => 'perp_stock.stock_id','work_center' => 'perp_work_center.work_center_id'),
		'ix' => array('bill_of_material_id','component','work_center'),
		'uc' => array()
	),
	'perp_work_order_bill_of_material' => array(
		'fd' => array(
			'work_order_id' => array('type' => 'int','precision' => '4'),
			'detail_id' => array('type' => 'int','precision' => '4'),
			'bill_of_material_id' => array('type' => 'int','precision' => '4'),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
		),
		'pk' => array('work_order_id','detail_id','bill_of_material_id'),
		'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','bill_of_material_id' => 'perp_bill_of_material.bill_of_material_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_work_center' => array(
		'fd' => array(
			'work_center_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'default_overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'default_overhead_account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'default_user_account' => array('type' => 'int','precision' => '4','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '30','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('work_center_id'),
		'fk' => array('default_overhead_account' => 'perp_account.account_id','default_user_account' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array('name')
	),
	'perp_stock_assembly_serial' => array(
		'fd' => array(
			'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'component_stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'component_serial_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'stock_history' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
		),
		'pk' => array('work_order_id','detail_id','stock_history'),
		'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','component_stock_id' => 'perp_stock_serial.stock_id','component_serial_number' => 'perp_stock_serial.serial_number','stock_history' => 'perp_stock_history.stock_history_id'),
		'ix' => array('work_order_id','detail_id'),
		'uc' => array()
	),
	'egw_wf_agent_perp_build' => array(
		'fd' => array(
			'wf_agent_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'display_parts' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '0')
		),
		'pk' => array('wf_agent_id'),
		'fk' => array('work_center_id' => 'perp_work_center.location_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_serial_setup' => array(
		'fd' => array(
			'setup_id' => array('type' => 'auto','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'pattern' => array('type' => 'varchar','precision' => '50','nullable' => False,'default' => '%1$05d')
		),
		'pk' => array('setup_id'),
		'fk' => array(),
		'ix' => array(),
		'uc' => array('name')
	),
	'perp_work_order_bom_change' => array(
		'fd' => array(
			'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'work_center_id' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
			'component' => array('type' => 'int','precision' => '4'),
			'bill_of_material_detail_id' => array('type' => 'int','precision' => '4'),
			'delta_quantity' => array('type' => 'float','precision' => '20','scale' => '3','nullable' => False)
		),
		'pk' => array('work_order_id','detail_id','component','bill_of_material_detail_id'),
		'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','work_center_id' => 'perp_work_center.location_id','component' => 'perp_stock.stock_id','bill_of_material_detail_id' => 'perp_bill_of_material.bill_of_material_detail_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_work_center_location' => array(
		'fd' => array(
			'work_center_id' => array('type' => 'int','precision' => '4'),
			'location_id' => array('type' => 'int','precision' => '4'),
			'overhead_per_hour' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'overhead_account' => array('type' => 'varchar','precision' => '7','nullable' => False),
			'user_account' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('work_center_id','location_id'),
		'fk' => array('work_center_id' => 'perp_work_center.work_center_id','location_id' => 'perp_location.location_id','user_account' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_work_order_retrofit' => array(
		'fd' => array(
			'stock_history_id' => array('type' => 'int','precision' => '4'),
			'account_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'reference' => array('type' => 'varchar','precision' => '255'),
			'build_option_category_id' => array('type' => 'int','precision' => '4'),
			'build_option_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('stock_history_id'),
		'fk' => array('stock_history_id' => 'perp_stock_history.stock_history_id','account_id' => 'egw_accounts.account_id','build_option_category_id' => 'perp_build_option_category.build_option_category_id','build_option_id' => 'perp_build_option.build_option_id'),
		'ix' => array('build_option_category_id'),
		'uc' => array()
	),
	'perp_work_order_option_history' => array(
		'fd' => array(
			'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'build_option_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'old_option' => array('type' => 'int','precision' => '4','nullable' => False),
			'new_option' => array('type' => 'int','precision' => '4','nullable' => False),
			'timestamp' => array('type' => 'timestamp','nullable' => False),
			'changed_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'history_id' => array('type' => 'auto','nullable' => False)
		),
		'pk' => array('history_id'),
		'fk' => array('work_order_id' => 'perp_work_order_detail.work_order_id','detail_id' => 'perp_work_order_detail.detail_id','build_option_category_id' => 'perp_build_option_category.build_option_category_id','old_option' => 'perp_build_option.build_option_id','new_option' => 'perp_build_option.build_option_id','changed_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_workflow_stock' => array(
		'fd' => array(
			'workflow_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'last_change' => array('type' => 'timestamp')
		),
		'pk' => array('workflow_id','stock_id'),
		'fk' => array('workflow_id' => 'egw_wf_processes.wf_p_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_build_option_exclusion' => array(
		'fd' => array(
			'option_1' => array('type' => 'int','precision' => '4'),
			'option_2' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('option_1','option_2'),
		'fk' => array('option_1' => 'perp_build_option.build_option_id','option_2' => 'perp_build_option.build_option_id'),
		'ix' => array(),
		'uc' => array()
	)
);
