<?php

	/**
	*	Server side of AJAX calls for price calculations
	*/

	require_once( EGW_INCLUDE_ROOT . '/perp_orders/inc/class.bo_perp_price_calculation.inc.php');

	class ajax_perp_price_calculation {

		public static $base_examples = array(
			array(
				'name'	=>	'Zero (free)',
				'price'	=>	0.00
			),
			array(
				'name'	=>	'Refund',
				'price'	=>	-5.00
			),
			array(
				'name'	=>	'Not allowed',
				'price'	=>	so_perp_price::NOT_ALLOWED
			),
		);

		private static $example_count = 10;
		private static $extra_examples = array();
		private static $extra_examples_price_list_id = null;

		private static $example_target = 'exec[examples]';

		public static function examples($calculation, $prompt) {
			

			$response = new xajaxResponse();
			$response->addClear(self::$example_target, 'innerHTML');

			// Find some random items to use as examples
			if(count(self::$extra_examples) < self::$example_count) {
				$extra_examples = array();
				self::$extra_examples_price_list_id = key(ExecMethod('perp_orders.bo_perp_price_list.get_price_list_list', array('sort' => 'DESC')));

				if(count(self::$extra_examples) >= self::$example_count) {
					break;
				}
				$query = array(
					'template'	=>	false,
					'num_rows'	=>	self::$example_count - count(self::$extra_examples),
					'date'		=>	time(),
					'price_list_id'	=>	self::$extra_examples_price_list_id,
					'order'		=>	'stock_id',
				);
				$bo_price = new bo_perp_price();
				$bo_price->get_price_list($query, $extra_examples);

				foreach($extra_examples as $item) {
					if(!is_array($item)) continue;
					self::$extra_examples[] = $item['stock_id'];
				}
			}

			// Check the calculation
			$query = array(
				'calculation'	=>	$calculation
			);
			if($prompt) {
				$query['variable_prompt'] = $prompt;
			}
			$check = bo_perp_price_calculation::check($query);
			if($check !== true) {
				$response->addCreate(self::$example_target, 'div', 'error');
				if($check) {
					$response->addAssign('error', 'innerHTML', $check);
				} else {
					$response->addAssign('error', 'innerHTML', lang('Invalid calculation'));
				}
			} else {
				$response->addCreate(self::$example_target, 'table', 'examples');
				$response->addCreate('examples', 'thead', 'heading');
				$response->addCreate('examples', 'tr', 'heading-row');
				$response->addAppend('heading-row', 'innerHTML', '<td>Item</td><td>Current Price</td><td>New Price</td>');


				foreach(self::$base_examples as $example) {
					$response->addCreate('examples', 'tr', $example['name']);
					$current_price = $example['price'];

					eval('$price = ' . $calculation . ';');
					$example['new_price'] = $price;

					$response->addAppend($example['name'], 'innerHTML', self::make_example($response, $example));
				}

				if(count(self::$extra_examples)) {
					$query = array(
						'calculation'	=>	$calculation,
						'price_list_id'	=>	self::$extra_examples_price_list_id,
						'effective_date'	=>	time() + 1,
						'stock_id'	=>	self::$extra_examples,
					);
					if($prompt) {
						$query['variable_prompt'] = $prompt;
					}
					$prices = bo_perp_price_calculation::run($query, false);
					foreach($prices as $example) {
						if(!is_array($example)) {
							continue;
						}
						$response->addCreate('examples', 'tr', $example['stock_id']);
						$example['name'] = ExecMethod('perp_inventory.bo_perp_stock.link_title', $example['stock_id']);
						$response->addAppend($example['stock_id'], 'innerHTML', self::make_example($response, $example));
					}
				}
			}

			
			return $response->getXML();
		}

		/**
		*	Make an example of a calculation
		*/
		protected static function make_example(&$response, $example) {
			if($example['new_price'] !== 0.00 && (!$example['new_price'] || !is_numeric($example['new_price']))) {
				$example['new_price'] = so_perp_price::NOT_ALLOWED;
			} else {
				$example['new_price'] = number_format($example['new_price'], 2);
			}
			if(is_numeric($example['price'])) {
				$example['price'] = number_format($example['price'], 2);
			}

			$string = "<td class=\"name\">" . htmlspecialchars($example['name']) . "</td>
				<td class=\"current price\">{$example['price']}</td><td class=\"new price\">{$example['new_price']}</td>";

			return $string;
		}
	}
