<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.ajax_perp_order.inc.php');
	require_once('class.SalesOrder.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_ar/inc/class.bo_perp_client_branch.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_ar/inc/class.bo_perp_client_account.inc.php');


	class ajax_perp_sales_order extends ajax_perp_order {

		private $xajax;

		public function ajax_perp_sales_order() {
			$this->xajax = new xajax();
			$this->response = new xajaxResponse();
			$this->bo_client_branch = new bo_perp_client_branch();
			$this->bo_client_account = new bo_perp_client_account();
		}

		public function change_client($et_request_id, $client_id, $client_account, $client_branch) {

			$request = etemplate_request::read($et_request_id);

			// Set client_id in client_account_id and client_branch_id AJAX select widgets
			$this->response->addScript("
				var account_id = document.getElementById('exec[client_account_id][results]');
				if(account_id) {
					account_id.options.client_id = '$client_id';
				}
				var branch_id = document.getElementById('exec[client_branch_id][results]');
				if(branch_id) {
					branch_id.options.client_id = '$client_id';
				}
			");
			if($client_id) {

				// Get the form name so we can add the options to the etemplate
				$form_name = etemplate::form_name($cname='exec', 'their_contact_person');
				$contact_field = $request->to_process[$form_name];

				// Get their contacts
				$link_id = 'CLIENT-' . $client_id;
				$contacts = egw_link::get_links('perp_ar', $link_id, 'addressbook');
				$this->response->addScript("removeOptions('$form_name')");
				if(is_array($contacts)) {
					foreach($contacts as $key => $contact_id) {
						$contact = egw_link::title('addressbook', $contact_id);
						$this->response->addScript("addOption('$form_name', '" . $contact_id . "', '" . addslashes($contact) . "')");
						$contact_field['allowed'][] = $contact_id;
					}
				}
				$request->set_to_process($form_name, $request->to_process[$form_name]['type'], $contact_field);

				$client = ExecMethod('perp_ar.bo_perp_client.get_client', $client_id);
			} else {
				return $this->response->getXML();
			}

			// Clear price list options
			$price_list = ExecMethod('perp_ar.bo_perp_client_account.get_price_lists', $client_account);
			if(is_array($price_list)) {
				$price_list = implode(',', $price_list);
				$this->response->addScript("update_stock_selection('', 'price_list_id', '$price_list');");
			} elseif ($price_list) {
				// Error
				$this->response->addAlert(lang('Error finding price lists: %1', $price_list));
			}

			// Auto-set account & branch
			$this->auto_set($et_request_id, $client_id);

			// Set currency
			if ($client) {
				$this->response->addScript(
					"var currency = document.getElementById('exec[order_currency]');
					if(currency) {
						currency.value = '" . $client['currency'] . "';
					}"
				);
			}

			// Update Order
			$order = $GLOBALS['egw']->session->appsession('order');
			if(!is_object($order)) {
				return $this->missing_order();
			}
			if($order instanceof Order) {
				$order->set_client_id((int)$client_id);

				if(!$order->get_our_reference_number() && $client_id) {
					$order->set_our_reference_number($order->suggest_order_number());
	
					$this->response->addScript("
						var our_reference = document.getElementById('exec[our_reference_number]');
						if(our_reference) {
							our_reference.value = '" . $order->get_our_reference_number() . "';
						}
					");
				}
			} else {
				$this->missing_order();
			}

			$GLOBALS['egw']->session->appsession('order', $GLOBALS['egw_info']['flags']['currentapp'], $order);

			return parent::change_client($client_id) . $this->response->getXML();
		}

		/**
		*	Change information specific to a client branch when the user changes the client branch
		*	- Ship to addresses
		*/
		public function change_client_branch($et_request_id, $client_id, $branch_id, $return = true) {

			// Get the form name so we can add the options to the etemplate
			$form_name = etemplate::form_name($cname='exec', 'ship_to_address');


			// Need the etemplate request
			$request =& etemplate_request::read($et_request_id);

			$query = array(
				'client_id'	=>	$client_id,
			);

			// Ship to addresses
			$this->response->addScript("removeOptions('$form_name')");
			$branches = ExecMethod('perp_ar.bo_perp_client_branch.get_client_branch_list', $query);
			$contacts = array();

			foreach($branches as $branch_id => $branch_name) {
				$contacts += egw_link::get_links('perp_ar', 'CLIENT_BRANCH-' . $branch_id , 'addressbook');
			}
			$contacts += egw_link::get_links('perp_ar', 'CLIENT-' .$client_id, 'addressbook');
			$contacts = array_unique($contacts);
			$contact_field = $request->to_process[$form_name];
			foreach($contacts as $id => &$contact) {
				$name = egw_link::title('addressbook', $contact);
				$this->response->addScript("addOption('$form_name', '$contact', '" . addslashes($name) . "')");
				$contact_field['allowed'][] = $contact;
			}
			$request->set_to_process($form_name, $request->to_process[$form_name]['type'], $contact_field);

			$branch = ExecMethod('perp_ar.bo_perp_client_branch.get_client_branch', $branch_id);
			if($branch['delivery_address'] && in_array($branch['delivery_address'], $contacts)) {
				$this->response->addAssign($form_name, 'value', $branch['delivery_address']);
			} elseif(count($contacts) > 0) {
				$this->response->addAssign($form_name, 'value', current($contacts));
			}

			if($return) {
				return $this->response->getXML();
			}
		}

		
		/**
		*	Change information specific to a client account when the user changes the client account
		*	- payment terms
		*	- price lists
		*/
		public function change_client_account($et_request_id, $client_id, $client_account, $return = true) {
			$order = $GLOBALS['egw']->session->appsession('order');
			if(!is_object($order)) {
				return $this->missing_order();
			}
			$account = ExecMethod('perp_ar.bo_perp_client_account.get_client_account', $client_account);

			if($client_account != $order->get_client_account_id()) {
				$this->response->addScript(
					"var terms = document.getElementById('exec[payment_terms]');
					if(terms) {
						terms.value = '" . $account['payment_terms'] . "';
					}"
				);

				$price_list = ExecMethod('perp_ar.bo_perp_client_account.get_price_lists', $client_account);
				$price_lists = implode(',', $price_list);
				$this->response->addScript("update_stock_selection('', 'price_list_id', '$price_lists');");
			}
		
			// Update Order
			if($order instanceof SalesOrder) {
				$order->set_client_account_id((int)$client_account);
				$GLOBALS['egw']->session->appsession('order', $GLOBALS['egw_info']['flags']['currentapp'], $order);
			}
			if($return) {
				return $this->response->getXML();
			}
		}


		/**
		*	Check to see if the client has only 1 account and 1 branch.  If 
		*	there is only 1 option, it is chosen.
		*/
		protected function auto_set($et_request_id, $client_id) {
			//Query the client branch list with client id filter
			$query = array(
				'client_id'     =>      $client_id,
				'template'      =>      false,
			);
			$branch_count = $this->bo_client_branch->get_client_branch_list($query, $branch_list);

			//Auto populate the Client Branch Ajax select widget if only one result
			if($branch_count == 1) {
				$this->response->addScript('
					var branch_search = document.getElementById("exec[client_branch_id][search]");
					if(branch_search) {
						branch_search.value = "'. egw_link::title('perp_ar', 'CLIENT_BRANCH-' . $branch_list[0]['client_branch_id']) . '";
					}
					var branch_value = document.getElementById("exec[client_branch_id][value]");
					if(branch_value) {
						branch_value.value = "'.$branch_list[0]['client_branch_id'].'";
					}
				');

				//Trigger change_client_branch() method
				$this->change_client_branch($et_request_id, $branch_list[0][client_id], $branch_list[0]['client_branch_id'], false);

			}

			//Query the client account list with client id filter
			$query = array(
				'client_id'     =>      $client_id,
				'template'      =>      false,
			);
			$account_count = $this->bo_client_account->get_client_account_list($query, $account_list);

			//Auto populate the Client Account Ajax select widget if only one result
			if($account_count == 1) {
				$this->response->addScript('
					var account_search = document.getElementById("exec[client_account_id][search]");
					if(account_search) {
						account_search.value = "'. egw_link::title('perp_ar', 'CLIENT_ACCOUNT-' . $account_list[0]['client_account_id']) . '";
					}
					var account_value = document.getElementById("exec[client_account_id][value]");
					if(account_value) {
						account_value.value = "'.$account_list[0]['client_account_id'].'";
					}
				');

				//Trigger change_client_branch() method
				$this->change_client_account($et_request_id, $account_list[0][client_id], $account_list[0]['client_account_id'], false);
			}

			// Send focus to add line
			if($account_count == 1 && $branch_count != 1) {
				$this->response->addScript("
					var branch = document.getElementById('exec[client_branch_id][search]');
					if(branch) {
						branch.select();
					}
				");
			} elseif($branch_count == 1 && $account_count == 1) {
				// Focus to item code
				$this->response->addScript("
					var stock = document.getElementById('exec[new][stock_id][search]');
					if(stock) {
						stock.select();
					}
				");
			}
		}

		public function change_stock_id($client_id, $stock_id, $query, $base_id) {
			$stock = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
			$client = ExecMethod('perp_ar.bo_perp_client.get_client', $client_id);

			$order = $GLOBALS['egw']->session->appsession('order');
			if(!is_object($order)) {
				return $this->missing_order();
			}
		
			$query = array(
				'stock_id'	=>	$stock['stock_id'], 
				'price_list_id'	=>	explode(',', $query['price_list_id']),
				'date'		=>	$query['date'] ? $query['date'] : $order->get_issue_date(),
				'template'	=>	false	
			);

			if($client['sales_type']) {
				$query['sales_type']	=	$client['sales_type'];
			}
			$price_list = array();
			$bo = CreateObject('perp_orders.bo_perp_price');
			$bo->get_price_list($query, $price_list);

			$unit_price = (int)PHP_INT_MAX;
			foreach($price_list as $list) {
				if(is_array($list)) {
					if($list['price']) {
						$unit_price = min($list['price'], $unit_price);
					}
				}
			}
			$this->response->addScript("
				var quantity = document.getElementById('" .$base_id. "[quantity_ordered]');
				if(quantity) {
					quantity.value = Math.ceil(quantity.value / " . $stock['economic_order_quantity'] . ");
				}"
			);
			if($unit_price !== false) {
				$this->response->addScript("
					var unit_price = document.getElementById('" . $base_id . "[unit_price]');
					if(unit_price) {
						unit_price.value = $unit_price;
					}
					var description = document.getElementById('" . $base_id . "[description]');
					if(description) {
						description.value = '" . addslashes($stock['short_description']) . "'
					}
				");
			}
				
			if($stock['stock_type_flag'] == 'R') {
				$this->raw_stock($this->response, $client, $stock, $query, $base_id);
			} elseif ($stock['stock_type_flag'] == 'A') {
				$this->assembly_stock($this->response, $client, $stock, $query, $base_id);
			}
			
			// Focus to quantity field
			$this->response->addScript("
					var quantity = document.getElementById('exec[new][quantity_ordered]');
					quantity.select();
				");
			
	
	
			return $this->response->getXML();
		}

		private function raw_stock(&$response, $client, $stock, $query, $base_id) {
			// Stub, for future use if needed
		}

		private function assembly_stock(&$response, $client, $stock, $query, $base_id) {
			// Stub, for future use if needed
		}

		/**
		*	If the user changes the Order Date, that affects the price lists available, so
		*	we need to update the price lists.  Only Admins are allowed to change the order
		*	date, for others it should be read only.  After adding a line to the order,
		*	the date should be read only to avoid crossing price list dates
		*/
		public function change_order_date($date) {
			$order =& ExecMethod('perp_orders.ui_perp_sales_order.get_order', 'SalesOrder');
			if(!is_object($order)) {
				return $this->missing_order();
			}

			// $date comes in as a string, not a timestamp
			$date = strtotime($date);
			$this->response->addScript("update_stock_selection('', 'date', '$date');");

			// Have to put the order back
			$GLOBALS['egw']->session->appsession('order', $GLOBALS['egw_info']['flags']['currentapp'], $order);

			return $this->response->getXML();
		}

	}
?>
