<?php

	require_once('class.SalesOrder.inc.php');

	class hook_perp_orders {

		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
			'sales_area'	=>	True,
			'sales_type'	=>	True,
		);

		var $appname = 'perp_orders';
		var $template;
		var $bo;
		var $erp;

		public function hook_perp_orders() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_orders.bo_perp_orders');
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file['Site configuration'] = $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_orders.hook_perp_orders.config',
				));
			if($GLOBALS['egw']->acl->check('acl', EGW_ACL_READ, 'perp_orders')) {
				$file['Configure Access Permissions']= $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_orders.hook_perp_orders.acl',
				));
			}
			if($GLOBALS['egw']->acl->check('sales_area', EGW_ACL_READ, 'perp_orders')) {
				$file['Sales Areas']= $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_orders.hook_perp_orders.sales_area',
				));
			}
			if($GLOBALS['egw']->acl->check('sales_type', EGW_ACL_READ, 'perp_orders')) {
				$file['Sales Types']= $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_orders.hook_perp_orders.sales_type',
				));
			}
			if($GLOBALS['egw']->acl->check('sales_category', EGW_ACL_READ, 'perp_orders')) {
				$file['Sales Categories']= $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_orders.ui_perp_orders.sales_category_list',
				));
			}
			if($GLOBALS['egw']->acl->check('calculation', EGW_ACL_READ, 'perp_orders')) {
				$file['Price Calculations']= $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_orders.ui_perp_price_calculation.calculation_list',
				));
			}

			display_section($this->appname, $file);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences']            = $GLOBALS['egw']->link('/preferences/preferences.php','appname='.$this->appname);

			//Do not modify below this line
			display_section($this->appname,$this->appname,$file);
		}

		public function user_preferences() {
		}

		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			if($GLOBALS['egw']->acl->check('price_list', EGW_ACL_READ, $this->appname)) {
				$menu['Price List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_orders.ui_perp_price_list.price_list_list');
			}
			if($GLOBALS['egw']->acl->check('order', EGW_ACL_READ, $this->appname)) {
				$menu['Sales Order List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_orders.ui_perp_sales_order.order_list');
			}
			if($GLOBALS['egw']->acl->check('order', EGW_ACL_READ, $this->appname)) {
				$menu['Backorders List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_orders.ui_perp_backorder.backorder_list');
			}
			display_sidebox($this->appname, $menu_title, $menu);
			
			
			
			
			$menu_title = lang('Actions');
			$menu = array();
			if($GLOBALS['egw']->acl->check('price_list', EGW_ACL_ADD, $this->appname)) {
				$menu['New Price List'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_orders.ui_perp_price_list.price_list_list');
			}
			if($GLOBALS['egw']->acl->check('order', EGW_ACL_ADD, $this->appname)) {
				$menu['New Order'] = $GLOBALS['egw']->link('/index.php','menuaction=perp_orders.ui_perp_sales_order.new_order');
			}
			display_sidebox($this->appname, $menu_title, $menu);
		}

		public function config($content = array()) {
			// validation & correction
			//...

			$selects['cost_of_goods_sold_section'] = ExecMethod('perp_ledger.bo_perp_ledger.get_account_sections');
			$selects['sales_section'] = $selects['cost_of_goods_sold_section'];

			$infolog_bo = CreateObject('infolog.infolog_bo');
			$selects['price_override_type'] = $infolog_bo->enums['type'];

			// Translations for options for generated numbers
			$data['settings']['order_number_params'] = array(
				lang('%1 is replaced with %2', '&#37;1$s', lang('client number')),
				lang('%1 is replaced with %2', '&#37;2$d', lang('Next order ID number')),
				lang('%1 is replaced with %2', '&#37;3$d', lang('Next order number per client')),
				lang('%1 is replaced with %2', '&#37;4$d', lang('Next order number per day')),
				lang('%1 is replaced with %2', '&#37;6$d', lang('client account number')),
				lang('%1 is replaced with %2', 'date(Ymd)', lang('Current date'))
			);
			$this->erp->config($content, $this->appname, 'perp_orders.hook_perp_orders.config',$selects, '', $data);
		}

		public function acl($content = array()) {
			$data = $this->erp->acl($content, 'perp_orders', 'acl', 'acl', $selects, $filters);
		}

		public function home($args = null) {
_debug_array($args);
		}

		/*	search_link for linking (link widget)
		*/
		public function search_link() {
			return array(
				'query'	=>	'perp_orders.bo_perp_orders.link_query',
				'title'	=>	'perp_orders.bo_perp_orders.link_title',
				'view'	=>	array('menuaction'=>'perp_orders.ui_perp_orders.link_view'),
				'view_id'	=>	'link_id',
				'add'	=>	array('menuaction' => 'perp_orders.ui_perp_sales_order.new_order'),
				'add_id'	=>	'link_id',
				'add_app'	=>	'perp_orders',
				'add_popup'	=>	'800x600',

				'notify'	=>	'perp_orders.hook_perp_orders.link_notify',
			);
		}

		public function sales_area($content = array()) {
			$lookup = 'sales_area';
                        $data = $this->erp->change_lookup($content, 'perp_orders', $lookup, 'sales_area', $selects, $filters);
		}

		public function sales_type($content = array()) {
			if($content['nm']['rows']['new'] && $content['nm']['rows']['new']['sales_type_name'] && !$content['nm']['rows']['new']['sales_type_id']) {
				$content['nm']['rows']['new']['sales_type_id'] = 0;
			}
			$lookup = 'sales_type';
                        $data = $this->erp->change_lookup($content, 'perp_orders', $lookup, 'sales_type', $selects, $filters);
		}

		/**
		*	Deal with notifications from other apps of changes on linked objects.
		*	In particular, we care about deleted price override infolog entries.
		*
		*	@see phpgwapi/inc/class.bolink.inc.php, function notify()
		*
		*	@param array - the following data in an array:
		*	@param type: 'link' for new links, 'unlink' for unlinked entries, 'update' of content in linked entries
		*	@param notify_app: app to notify
		*	@param notify_id: id in $notify_app
		*	@param target_app: name of app whos entry changed, linked or deleted
		*	@param target_id: id in $target_app
		*	@param data: null data of entry in app2 (optional)
		*/
		public function link_notify($notify_data) {
			$config = config::read('perp_orders');
			switch( $notify_data['target_app'] ) {
				case 'infolog':
					$infolog = ExecMethod('infolog.infolog_bo.read', $notify_data['target_id']);

					if($notify_data['type'] == 'unlink' && $infolog['info_type'] == $config['price_override_type']) {
						/**
						* They're trying to delete a price override!  
						* We can't stop it, but we can put it back.
						echo 'Bad user!';
						*/
						// Get the Order
						list($target, $order_id, $line_id) = explode(':', $notify_data['id']);
						$order = new SalesOrder($order_id);
						if(!is_object($order)) {
							return false;
						}
						$order_line = $order->get_line($line_id);
						if(!is_object($order_line)) {
							return false;
						}

						// Re-create the infolog entry
						unset($infolog['info_id']);
						$new_id = ExecMethod('infolog.infolog_bo.write', $infolog);
						egw_link::link($this->appname, $notify_data['id'], $notify_data['target_app'], $new_id);

						// Clear the old price override
						$order_line->clear_price_override();

						// Add the new price override
						$order_line->set_price_override($new_id);
						$order->write();
					}
					break;
			}
		}


		/**
		*	Required to participate in the Add Line From... on a receivable invoice
		*/
		public function invoicable() {
			return array(
				'search'		=>	'perp_orders.bo_perp_sales_order.invoicable_search',
				'config'		=>	'perp_orders.hook_perp_orders.invoicable_config',
				'Invoicable'		=>	'SalesOrder',
				'InvoicableItem'	=>	'SalesOrderLine'
			);
		}

		/**
		*	Configure how invoicing Sales Orders happens
		*/
		public function invoicable_config($content = array()) {
			// Save updated settings
			if(count($content)) {
				config::save_value('invoicable', $content['enabled'], 'perp_orders');
			}

			$config = config::read('perp_orders');
			return array(
				'template'	=>	'',
				'config'	=>	array(
					'enabled'	=>	$config['invoicable']
				),
				'help'		=>	'General ledger accounts for Sales Orders are per Sales Category, and are set in Admin -> Sales Orders -> Sales Categories'
			);
		}
	}
?>
