<?php
	/**
	*	A list of backordered stock items.
	*	For the purpose of this report, backordered means it has been ordered by a Client, 
	*	but we do not have the stock on hand to fulfill their order.
	*/

	require_once('class.bo_perp_backorder.inc.php');

	class ui_perp_backorder {

		public $public_functions = array(
			'backorder_list'	=>	True
		);

		protected $bo_perp_backorder;
		protected $template;

		private $debug = false;

		public function __construct() {
			$this->bo_perp_backorder = new bo_perp_backorder();

			$this->template = CreateObject('etemplate.etemplate');
		}

		/**
		*	Get a list of goods that have been backordered
		*
		*	@param content array of data returned by the etemplate 
		*/
		public function backorder_list($content = array()) {
			if($this->debug) {
				echo __METHOD__ . ' incoming data: ';
				_debug_array($content);
			}

			$this->handle_backorder_actions(&$content);

			$data = $this->get_backorder_data($content);

			$select_box_options = $this->get_select_options($data);

			$GLOBALS['egw_info']['flags']['app_header'] = lang('Backorders');
			$this->template->read('perp_orders.backorder_list');
			$this->template->exec(
				$GLOBALS['egw_info']['flags']['currentapp'] . '.' . get_class($this) . '.' . __FUNCTION__,
				$data, $select_box_options, $readonly, $preserve
			);
		}

		/**
		*	Deal with any user actions from the backorder list
		*
		*	@param content array of data returned from the etemplate
		*/
		protected function handle_backorder_actions(&$content) {
		}

		/**
		*	Get data for displaying the backorder list
		*	
		*	@param content array of data returned from the etemplate
		*/
		protected function get_backorder_data(&$content) {
			$data = array();

			// Set up nextmatch widget
			$data['nextmatch'] = array(
				'get_rows'	=>	'perp_orders.bo_perp_backorder.get_backorder_list',
				'template'	=>	'perp_orders.backorder_list.row',
				'filter_label'	=>	'Ship From',
				'no_filter2'	=>	true,
				'cat_app'	=>	'perp_inventory',
			);
			return $data;
		}

		/**
		*	Get data for selectboxes
		*
		*	@param data array of data that will be displayed by the eTemplate
		*/
		protected function get_select_options($data) {
			$options = array();

			$options['filter'] = array('' => lang('All')) + ExecMethod('perp_inventory.bo_perp_location.get_location_list');
			$options['client_id'] = array('' => lang('All')) + ExecMethod('perp_ar.bo_perp_client.get_client_list');

			return $options;
		}
	}
?>
