<?php

	class ui_perp_orders {

		public $public_functions = array( 
			'index'		=>	true,
			'link_view'	=>	true,
			'sales_category_list'	=>	true,
			'edit_category'	=>	true
		);

		protected $template;

		protected $edit_category_template = 'perp_orders.sales_category_edit';

		private $debug = false;

		public function ui_perp_orders() {
			$this->template = CreateObject('etemplate.etemplate');
		}

		public function index($content = array()) {
			$price_list = $GLOBALS['egw']->acl->check('price_list', EGW_ACL_READ, 'perp_orders');
			$order_list = $GLOBALS['egw']->acl->check('order', EGW_ACL_READ, 'perp_orders');
			$backorder = $GLOBALS['egw']->acl->check('order', EGW_ACL_READ, 'perp_orders');

			if(isset($content['price_list']) && $price_list) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_price_list.price_list_list'));
			} elseif (isset($content['sales_order_list']) && $order_list) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_sales_order.order_list'));
			} elseif (isset($content['backorder']) && $backorder) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_backorder.backorder_list'));
			}

			$readonly['price_list'] = !$price_list;
			$readonly['sales_order_list'] = !$order_list;
			$readonly['backorder'] = !$backorder;

			// Display
			$this->template->read('perp_orders.index');
			$this->template->exec('perp_orders.ui_perp_orders.index', $data, $select_box_options, $readonly, $preserve);
		}

		public function link_view() {
			$link = $_GET['link_id'];
			list($location, $id, $line) = explode('-', $link);
			if($id) {
				switch($location) {
					case 'ORDER':

					// SALES_ORDER is deprecated
					case 'SALES_ORDER':
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'	=>	'perp_orders.ui_perp_sales_order.edit',
						'order_id'	=>	$id
					));
					break;
				}
			}
		}

		/**
		*	Display an indented list of sales categories
		*	
		*	@param content array of data returned from the eTemplate
		*/
		public function sales_category_list($content = array()) {
			$this->handle_category_actions($content);

			$data = $this->get_category_list_display_data();

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Sales Categories');
			$this->template->read('perp_orders.sales_category_list');
			$this->template->exec(
				$GLOBALS['egw_info']['flags']['currentapp'] . '.' . get_class($this) . '.sales_category_list',
				$data, $select_box_options, $readonly, $preserve
			);
		}

		/**
		*	Handle action and button clicks from the list of sales
		*	categories.
		*/
		protected function handle_category_actions($content) {
			if(isset($content['add'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_orders.edit_category'));
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/admin/index.php');
			} elseif (isset($content['nextmatch']['rows']['delete'])) {
				$category_id = key($content['nextmatch']['rows']['delete']);
				$message = ExecMethod('perp_orders.bo_perp_orders.delete_sales_category', $category_id);
				if($message !== true) {
					$this->messages[] = array($message, 'error');
				}
			}
		}

		/**
		*	Get data required for displaying a list of sales categories
		*/
		protected function get_category_list_display_data() {

			// Set up nextmatch
			$data['nextmatch'] = array(
				'get_rows'	=>	'perp_orders.bo_perp_orders.get_sales_categories',
				'template'	=>	'perp_orders.sales_category_list.row',
				'cat_app'	=>	'perp_inventory',
				'never_hide'	=>	false,
				'no_cat'	=>	true,
				'no_filter'	=>	true,
				'no_filter2'	=>	true,
			);
			return $data;
		}

		public function edit_category($content = array()) {
			$content['data']['color'] = $_POST['exec']['data']['color'];
			if($this->debug) {
				echo get_class($this) . '.edit_category incoming data:';
				_debug_array($content);
			}

			$category_id = reg_var('category_id');
			if(!$category_id && isset($content['category_id'])) {
				$category_id = $content['category_id'];
			}
			$content['category_id'] = $category_id;

			$parent_id = reg_var('parent_id');

			// Update
			if(isset($content['save'])) {
				$content_id = ExecMethod('perp_orders.bo_perp_orders.set_sales_category', $content);
				if(is_numeric($content_id)) {
					$this->messages[] = array(lang('Category saved'), 'success');
					$category_id = $content_id;
				} else {
					$this->messages[] = array($content_id, 'error');
				}
			} elseif ($content['new_stock_id']) {
				ExecMethod2('perp_inventory.bo_perp_stock.add_sales_category', $content['new_stock_id'], $category_id);
			} elseif (isset($content['delete'])) {
				ExecMethod('perp_orders.bo_perp_orders.delete_sales_category', $category_id);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_orders.sales_category_list'));
			} elseif (isset($content['nextmatch']['rows']['delete'])) {
				$stock_id = key($content['nextmatch']['rows']['delete']);
				ExecMethod2('perp_inventory.bo_perp_stock.delete_sales_category', $stock_id, $category_id);
			} elseif (isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_orders.sales_category_list'));
			}

			// Read category for display
			$data = $this->get_category_display_data($category_id);
			if(!$category_id && $parent_id) {
				$data['parent'] = $parent_id;
			}

			$readonly = $this->get_category_readonlys($category_id);

			$preserve = $category;
			$preserve['category_id'] = $category_id;
			$preserve['old_parent'] = $category['parent'];

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			$GLOBALS['egw_info']['flags']['app_header'] = ($category_id ? lang('Edit sales category'):lang('Add sales category'));
			$this->template->read($this->edit_category_template);
			$this->template->exec(
				$GLOBALS['egw_info']['flags']['currentapp'] . '.' . get_class($this) . '.edit_category', 
				$data, $select_box_options, $readonly, $preserve
			);
		}

		/**
		*	Get data for displaying or editing a sales category
		*	@param category_id The id number of the category to display
		*	@return array of data for display
		*/
		protected function get_category_display_data($category_id) {
			if($category_id) {
				$category = ExecMethod('perp_orders.bo_perp_orders.get_sales_category', $category_id);
			} else {
				$category = array();
				$category['options-parent'] = ExecMethod('perp_orders.bo_perp_orders.get_sales_categories');
			}

			$data = $category;

			$config = config::read('perp_orders');
			$data['sales_gl_account'] = array(
				'account_id'	=>	$category['sales_gl_account'],
				'group_section'	=>	$config['sales_section']
			);
			$data['cost_of_sales_gl_account'] = array(
				'account_id'	=>	$category['cost_of_sales_gl_account'],
				'group_section'	=>	$config['cost_of_goods_sold_section']
			);


			$data['data']['color'] = $GLOBALS['egw']->html->inputColor('exec[data][color]', $data['data']['color'], lang('Click to select a color'));

			// Set up nextmatch
		//	if($category['sales_gl_account']) {
				$data['nextmatch'] = array(
					'sales_category_id'	=>	$category_id,
					'get_rows'	=>	'perp_orders.bo_perp_orders.get_sales_category_stock',
					'template'	=>	'perp_orders.sales_category_edit.row',
					'cat_app'	=>	'perp_inventory',
					'no_filter'	=>	true,
					'no_filter2'	=>	true
				);
		//	}

			// Hide add stock widget if needed (no category_id or sales general ledger account
			$data['can_add_stock'] = (boolean)$category_id && (boolean)$data['sales_gl_account'];

			return $data;
		}

		/**
		*	Get readonlys for viewing or editing a category
		*/
		protected function get_category_readonlys($category_id) {
			$readonly['delete'] = !$GLOBALS['egw']->acl->check('sales_category', EGW_ACL_DELETE, 'perp_orders');

			$no_edit = !$GLOBALS['egw']->acl->check('sales_category', EGW_ACL_EDIT, 'perp_orders');

			$readonly['parent'] = $no_edit;
			$readonly['name'] = $no_edit;
			$readonly['description'] = $no_edit;
			$readonly['data']['color'] = $no_edit;
			$readonly['data']['icon'] = $no_edit;
			$readonly['sales_gl_account'] = $no_edit;
			$readonly['cost_of_sales_gl_account'] = $no_edit;
			$readonly['new_stock_id'] = $no_edit;
			$readonly['save'] = $no_edit;
			
			return $readonly;
		}
	}
?>
