<?php
	
	require_once( EGW_INCLUDE_ROOT . '/perp_orders/inc/class.bo_perp_price.inc.php');
	require_once( EGW_INCLUDE_ROOT . '/perp_orders/inc/class.bo_perp_price_list.inc.php');
	require_once( EGW_INCLUDE_ROOT . '/perp_manufacturing/inc/class.bo_perp_build_option.inc.php');

	class ui_perp_price {

		public $public_functions = array(
			'price_history'	=>	True,
		);

		private $template;
		private $bo_price;
		private $bo_price_list;
		private $bo_option;

		private $debug = False;

		public function ui_perp_price() {
			$this->template = CreateObject('etemplate.etemplate');

			$this->bo_price = new bo_perp_price();
			$this->bo_price_list = new bo_perp_price_list();
			$this->bo_option = new bo_perp_build_option();
		}

		public function price_list($content = array()) {
			if($this->debug) {
				echo '<strong>perp_orders.ui_perp_price.price_list</strong> incoming data:';
				_debug_array($content);
			}

			$new = $GLOBALS['egw']->acl->check('price', EGW_ACL_ADD, 'perp_orders');

			if(isset($content['price_new']) && $new) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_price.price_new'));
			} elseif($content['nm']['rows']['edit']) {
				$id = key($content['nm']['rows']['edit']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_price.price_edit', 'price_list_id'=>$id));
			} elseif($content['nm']['rows']['delete']) {
				$id = key($content['nm']['rows']['delete']);
			} elseif(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect('/index.php?menuaction=perp_orders.ui_perp_price_list.price_list_list');
			}

			$data['nm'] = array(
				'no_cat'        =>      True,
				'filter_label'  =>      'Price List',
				'filter_no_lang'        =>      True,
				'filter2_label' =>      'Status',
				'filter2_no_lang'       =>      True,
				'get_rows'      =>      'perp_orders.bo_perp_price.get_price_list',
				'template'      =>      'perp_orders.price_list.row',
			);
			$select_box_options['filter'] = array('' => lang('All')) + ExecMethod('perp_orders.bo_perp_price_list.get_price_list_list');
	
			$readonly['price_new'] = !$new;
		}

		public function price_history($content = array()) {
			$price_list_id		=	reg_var('price_list_id');
			$stock_id		=	reg_var('stock_id');
			$build_option_id	=	reg_var('build_option_id');
			$parent_component_id	=	reg_var('parent_component_id');
			$data = array();

			$price_list = $this->bo_price_list->get_price_list($price_list_id);
			$data += $price_list;

			$data['stock_id'] = $stock_id;
			$data['stock_name'] = ExecMethod('perp_inventory.bo_perp_stock.link_title', $stock_id);

			$data['nextmatch'] = $GLOBALS['egw']->session->appsession('price_history.' . $price_list_id . '.' . $stock_id . '.' . $query['build_option_id']);
			if(!is_array($data['nextmatch'])) {
				$data['nextmatch'] = array(
					'price_list_id'	=>	$price_list_id,
					'stock_id'	=>	$stock_id,
					'parent_component_id'	=>	$parent_component_id,
					'include_not_allowed'	=>	true,
					'get_rows'	=>	'perp_orders.ui_perp_price.get_price_history',
					'template'	=>	'perp_orders.price_history.row',
					'no_cat'	=>	true,
					'no_filter'	=>	true,
					'no_filter2'	=>	true,
					'no_search'	=>	true,
					'order'		=>	'effective_date',
					'sort'		=>	'DESC',
					'format'	=>	true
				);
				if($build_option_id) {
					$data['nextmatch']['build_option_id'] = $build_option_id;
					$data += $this->bo_option->get_build_option($build_option_id);
				}
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang(
				'Price History: Price List #%1 (%2) - %3', 
				$price_list_id, 
				$price_list['price_list_name'], 
				$data['stock_name']
			);
			if($build_option_id) {
				$GLOBALS['egw_info']['flags']['app_header'] .= ' [' . $data['build_option_name'] . ']';
			}
			$this->template->read('perp_orders.price_history');
			$this->template->exec('perp_orders.ui_perp_price.price_history', $data, $select_box_options, $readonly, $preserve);
		}

		public function get_price_history(&$query = array(), &$rows = array(), &$readonlys = array()) {
			$GLOBALS['egw']->session->appsession('price_history.' . $query['price_list_id'] . '.' . $query['stock_id'] . '.' . $query['build_option_id'], 'perp_orders', $query);

			if($query['build_option_id']) {
				$options = array();
				$rows = array();
				$count = $this->bo_price->get_option_price_history($query, $rows, $readonlys);
			} else {
				$count = $this->bo_price->get_price_list($query, $rows, $readonlys);
			}

			// Set status for class
			$current_row = null;
			$current_time = null;
			foreach($rows as $key => &$row) {
				if(!$row['effective_date']) {
					continue;
				}
				if($row['effective_date'] <= time()) {
					if($row['effective_date'] > $current_time) {
						$current_row = $key;
						$current_time = $row['effective_date'];
					}
					$row['class'] = 'past';
				} elseif ($row['effective_date'] > time()) {
					$row['class'] = 'future';
				}
			}
			$rows[$current_row]['class'] = 'current';

			return $count;
		}
	}
?>
