<?php
	include_once(EGW_INCLUDE_ROOT . '/perp_manufacturing/inc/class.bo_perp_build_option.inc.php');

	class ui_perp_price_list {

		public $public_functions = array(
			'price_list_list'	=>	True,
			'price_list_edit'	=>	True,
			'price_list_new'	=>	True,
			'price_list_view'	=>	True,
			'option_default_edit'	=>	true,
			'client_account_list'	=>	true,
		);

		private $bo;
		private $template;
		private $config;
		private $debug = false;
		private $messages = array();

		public function ui_perp_price_list() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = CreateObject('perp_orders.bo_perp_price_list');
			$this->config = config::read('perp_orders');
		}

		public function price_list_list($content = array()) {
			if($this->debug) {
				echo '<strong>perp_orders.ui_perp_price_list.price_list_list</strong> incoming data:';
				_debug_array($content);
			}

			$new = $GLOBALS['egw']->acl->check('price_list', EGW_ACL_ADD, 'perp_orders');

			if(isset($content['price_list_new']) && $new) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_price_list.price_list_new'));
			} elseif($content['nm']['rows']['edit']) {
				$id = key($content['nm']['rows']['edit']);
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_price_list.price_list_edit', 'price_list_id'=>$id));
			} elseif(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php?menuaction=perp_orders.ui_perp_orders.index');
			}

			// Check for delete
			if($content['nm']['rows']) {
				foreach($content['nm']['rows'] as $action => $row) {
					if($action == 'delete') {
						$id = key($row);
						$this->bo->delete_price_list($id);
						break;
					}
				}
			}
			$data['nm'] = $GLOBALS['egw']->session->appsession('price_list_list', 'perp_orders');
			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'no_filter'     =>      True,
				//	'no_filter2'    =>      True,
					'filter2_label' =>      'Status',
					'filter2_no_lang'       =>      True,
					'get_rows'      =>      'perp_orders.ui_perp_price_list.get_rows',
					'template'      =>      'perp_orders.price_list_list.row',
				);
				$data['nm']['filter2'] = $content['nm']['filter2'] ? $content['nm']['filter2'] : 'current';
			}
	
			$select_box_options['filter2'] = array('' => lang('All')) + ExecMethod('perp_orders.bo_perp_price_list.get_status_list');

			$readonly['price_list_new'] = !$new;

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Price Lists');
			$this->template->read('perp_orders.price_list_list');
			$this->template->exec('perp_orders.ui_perp_price_list.price_list_list', $data, $select_box_options, $readonly, $preserve);
		}

		public function price_list_new($content = array()) {
			return $this->price_list_edit($content);
		}

		public function price_list_edit($content = array()) {
			if($this->debug) {
				echo '<strong>perp_orders.ui_perp_price_list.price_list_edit</strong> incoming data:';
				_debug_array($content);
			}

			$price_list_id = $content['price_list_id'] ? $content['price_list_id'] : $_GET['price_list_id'];
			$edit = $GLOBALS['egw']->acl->check('price_list', EGW_ACL_EDIT, 'perp_orders');
			$data = array();

			// Deal with incoming
			// eTemplate doesn't return the preserve data, and an array_merge won't work because of numeric IDs
			if($content['prices']['rows']) {
				$prices = $content['prices']['rows'];
			}

			// Prices - check if this is the start of an edit, or a continuation
			if($content['prices']) {
				$price_list = $GLOBALS['egw']->session->appsession('price_list' . $price_list_id);
				$price_list['price_list_id'] = $price_list_id;
				$price_list['effective_to'] = $content['effective_to'];
				$price_list['price_list_name'] = $content['price_list_name'];
				$price_list['price_list_title'] = $content['price_list_title'] ? $content['price_list_title'] : $content['price_list_name'];
				$price_list['currency'] = $content['currency'];
				$price_list['sales_category_id'] = $content['sales_category_id'];
				$price_list['sales_type_id'] = $content['sales_type_id'];
				$price_list['sales_area_id'] = $content['sales_area_id'];
				$price_list['order_by'] = $content['order_by'];
				$price_list['sort'] = $content['sort'];

                                $price_list['prices'] = isset($prices) ? $prices : array();
			} else {
				$price_list = $content;
			}
			if(isset($content['save']) && $edit) {
				if($this->config['auto_history_price_list'] && isset($content['effective_date']) && $content['effective_date'] <= time()) {
					$this->messages[] = array(lang('You should not change a price list effective before now.'), 'warning');
				}
				unset($content['save']);
				$price_list['effective_date'] = $content['effective_date'];
				$result = $this->bo->set_price_list($price_list_id, $price_list);
				if(is_numeric($result) && $result != False) {
					if($price_list_id == $result) {
						$this->messages[] = array(lang('Price list saved'), 'success');
					} else {
						$this->messages[] = array(lang('New price list created.  You are now editing price list #%1.', $result), 'success');
					}
					$price_list_id = $result;
				} else {
					$this->messages[] = array($result, 'error');
				}
			} elseif(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_price_list.price_list_list'));
			}
			if($content['option_defaults']) {
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_orders.ui_perp_price_list.option_default_edit',
					'price_list_id'	=>	$price_list_id,
					'effective_date'	=>	$content['effective_date']
				));
			}

			// Load price list
			if($price_list_id) {
				$price_list = $this->bo->get_price_list($price_list_id);
				$data += $price_list;
			}

			if($data['effective_to'] && $data['effective_to'] <= time()) {
				// Viewing an old price list.  Use just before the end date, otherwise it will appear empty
				$default_date = $data['effective_to'] - 1;
			} else {
				// Default price change effective date to tomorrow, start of day
				$tomorrow = strtotime('tomorrow');
				$default_date = mktime($GLOBALS['egw_info']['user']['preferences']['calendar']['workdaystarts'], 0, 0, date('m', $tomorrow), date('d', $tomorrow), date('Y', $tomorrow));
			}
			$data['effective_date'] = $content['effective_date'] ? $content['effective_date'] : $default_date;

			if(isset($price_list_id)) {
				$bo_price = CreateObject('perp_orders.bo_perp_price');
				$data['prices'] = $GLOBALS['egw']->session->appsession('price_list' . $price_list_id, 'perp_orders');
				if(!is_array($data['prices'])) {
					$data['prices'] = array(
						'price_list_id'		=>	$price_list_id,
						'sales_category_id'	=>	$price_list['sales_category_id'],
						'option_template'	=>	'perp_orders.price_list.option_price',
						'template'		=>	'perp_orders.price_list.row',
						'get_rows'		=>	'perp_orders.ui_perp_price_list.get_price_list',
						'no_cat'		=>	true,
						'filter_label'		=>	'Display',
						'filter2_label'		=>	'Sales Category Stock Items',
						'format'		=>	true,
						'order'			=>	$price_list['order_by'],
						'sort'			=>	$price_list['sort'],
						'filter'		=>	!($price_list_id)
					);
				}
				$data['prices']['date'] = $data['effective_date'];
				$GLOBALS['egw']->session->appsession('price_list' . $price_list_id, 'perp_orders', $data['prices']);
			}

			// Check for default option pricing
			if($price_list_id && $GLOBALS['egw_info']['apps']['perp_manufacturing']) {
				$bo_build_option = new bo_perp_build_option();
				$query = array(
					'price_list_id'	=>	$price_list_id,
					'template'	=>	false
				);
				$option_count = $bo_build_option->get_price_list($query, $rows);
			}

			// Store 'hide option' choice in session so it can be easily retrieved from price widget
			if(array_key_exists('hide_options', $content)) {
				$data['hide_options'] = $content['hide_options'];
			} else {
				$data['hide_options'] = $GLOBALS['egw_info']['user']['preferences']['perp_orders']['hide_options'];
			}
			$data['no_hide_options'] = !($option_count || $price_list_id);
			$GLOBALS['egw']->session->appsession('hide_options', 'perp_orders', $data['hide_options']);

			// Select box options
			$select_box_options['currency'] = ExecMethod('perp_api.bo_perp_api.get_currencies');
			$select_box_options['sales_area_id'] = array('' => lang('Select')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_areas');
			$select_box_options['sales_type_id'] = array('' => lang('Select')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_types');
			$select_box_options['sales_category_id'] = array(''=> lang('Select')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_categories');
			
			$select_box_options['filter'] = array(
				false	=>	'Only on this price list',
				true	=>	'All stock items and options'
			);
			
			$select_box_options['sort'] = array(
				1	=>	lang('Ascending'),
				-1	=>	lang('Descending')
			);
			
			$select_box_options['order_by'] = array(
				'stock_num'		=>	'Stock Code',
				'short_description'	=>	'Description',
				'price'			=>	'Price'
			);

			// Readonlys
			$readonly = array(
				'currency'		=>	isset($price_list_id),
				'sales_category_id'	=>	isset($price_list_id),
				'sales_area_id'		=>	isset($price_list_id),
				'sales_type_id'		=>	isset($price_list_id),
				'option_defaults'	=>	!($option_count || $price_list_id),
			);


			$preserve = array(
				'price_list_id'	=>	$price_list_id,
				'currency'	=>	$data['currency'],
				'sales_category_id'	=>	$data['sales_category_id'],
				'sales_area_id'		=>	$data['sales_area_id'],
				'sales_type_id'		=>	$data['sales_type_id']
			);
			
			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = $price_list_id ? lang('Edit Price List #%1', $price_list_id) : lang('New Price List');
			$this->template->read('perp_orders.price_list_edit');
			$this->template->exec('perp_orders.ui_perp_price_list.price_list_edit', $data, $select_box_options, $readonly, $preserve);
		}

		public function price_list_view($content = array()) {
			if($this->debug) {
				echo '<strong>perp_orders.ui_perp_price_list.view</strong> incoming data:';
				_debug_array($content);
			}

			$content['price_list_id'] = $content['price_list_id'] ? $content['price_list_id'] : $_GET['price_list_id'];
			$content['sales_category_id'] = $content['sales_category_id'] ? $content['sales_category_id'] : $_GET['sales_category_id'];
			$data = array();

			// Deal with incoming
			if(isset($content['price_list_id'])) {
				$price_list = $this->bo->get_price_list($content['price_list_id']);
				$data['sales_area_id'] = $price_list['sales_area_id'];
				$data['sales_type_id'] = $price_list['sales_type_id'];
				$data['sales_category_id'] = $price_list['sales_category_id'];
				$data['date']		=	$content['date'] ? $content['date'] : time();
			} else {
				$data['sales_area_id']	=	$content['sales_area_id'];
				$data['sales_type_id']	=	$content['sales_type_id'];
				$data['sales_category_id']	=	$content['sales_category_id'];
				$data['date'] 		=	$content['date'] ? $content['date'] : time();
			}
			
			// Store 'hide option' choice in session so it can be easily retrieved from price widget
			if(array_key_exists('hide_options', $content)) {
				$data['hide_options'] = $content['hide_options'];
			} else {
				$data['hide_options'] = $GLOBALS['egw_info']['user']['preferences']['perp_orders']['hide_options'];
			}
			$GLOBALS['egw']->session->appsession('hide_options', 'perp_orders', $data['hide_options']);

			if(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_price_list.price_list_list'));
			}

			// Get outgoing
			$bo_price = CreateObject('perp_orders.bo_perp_price');
			if(!$data['sales_category_id']) {
				$sales_category_id = array_keys( ExecMethod('perp_orders.bo_perp_orders.get_sales_categories'));
			} else { 
				$sales_category_id = array($content['sales_category_id']);
			}
			
			$price_count = 0;
			foreach($sales_category_id as $cat_id) {
				$query = array(
					'option_template'	=>	'perp_orders.price_widget.option_category',
					'cat_id'		=>	$cat_id,
					'sales_area_id'		=>	$data['sales_area_id'],
					'sales_type_id'		=>	$data['sales_type_id'],
					'date'			=>	$data['date'],
					'template'		=>	false,
					'order'			=>	'perp_price_list.sales_category_id',
					'format'		=>	true
				);
				if($content['price_list_id']) {
					$query['price_list_id'] = $content['price_list_id'];
				}
				if($price_count += $bo_price->get_merged_price_list($query, $prices)) {
					$category = ExecMethod('perp_orders.bo_perp_orders.get_sales_category', $cat_id);
					$data[] = array(
						'category'	=>	$category,
					);
					$data[] = $prices;
				}
			}

			if($price_count == 0) {
				$this->messages[] = array(lang('This price list has no items for sale.  Consider discontinuing the price list.'), 'warning');
			}
			$this->messages[] = array(lang(
				'Prices in effect until %1.', 
				($price_list['effective_to'] ? date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $price_list['effective_to']) : 'further notice')
			), 'info');

			// Select box options
			$select_box_options['sales_area_id'] = ExecMethod('perp_orders.bo_perp_orders.get_sales_areas');
			$select_box_options['sales_type_id'] = array('' => lang('All')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_types');
			$select_box_options['sales_category_id'] = array(''=> lang('All')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_categories');

			// Readonlys
			$client_ids = ExecMethod('perp_ar.bo_perp_client.get_client_by_user_account');
			if(is_array($client_ids) && count($client_ids)) {
				// Hide sales type from clients
				$readonly['sales_type_id'] = true;
			}
			if(count($select_box_options['sales_category_id']) <= 1) {
				// Hide sales category if there are no values to choose from
				$readonly['sales_category_id'] = true;
			}
			$readonly['save'] = !$edit;
			$data['edit'] = $edit;

			$preserve = $data;

			// Display
			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			$GLOBALS['egw_info']['flags']['app_header'] = lang('Price List') . (isset($price_list) ? ' ' . $price_list['price_list_id'] . ' - ' . ($price_list['price_list_name'] ? $price_list['price_list_name'] : $price_list['price_list_title']) : '');
			$this->template->read('perp_orders.price_list_view');
			$this->template->exec('perp_orders.ui_perp_price_list.price_list_view', $data, $select_box_options, $readonly, $preserve);
		}


		/**
		*	Get a list of pricelists for display
		*/
		public function get_rows(&$query = array(), &$rows = array(), &$readonly = array()) {
			$client_ids = ExecMethod('perp_ar.bo_perp_client.get_client_by_user_account');
			$forbidden_cols = array();
			if(is_array($client_ids) && count($client_ids) > 0) {
				// Hide some info from clients
				$forbidden_cols = array(
					'sales_type_name',
					'perp_price_list.sales_area_id',
					'price_list_name'
				);
				foreach($forbidden_cols as $name) {
					$query['options-selectcols'][$name] = false;
				}
			}
			$GLOBALS['egw']->session->appsession('price_list_list', 'perp_orders', $query);

			$count =  $this->bo->get_price_list_list($query, $rows, $readonly);
						
			foreach($forbidden_cols as $col_name) {
				$rows["no_$col_name"] = true;
			}
			return $count;
		}

		/**
		*	Get a list of prices to display for editing a pricelist
		*	This function adds in the bits needed by eTemplate for nested display
		*/
		public function get_price_list(&$query = array(), &$rows = array(), &$readonly = array()) {
			if(reg_var('effective_date')) {
				$query['date'] = reg_var('effective_date');
			}
			if($query['price_list_id']) {
				$GLOBALS['egw']->session->appsession('price_list' . $query['price_list_id'], 'perp_orders', $query);
			}
			$bo_price =& CreateObject('perp_orders.bo_perp_price');
			$count = $bo_price->get_price_list($query, $rows, $readonly);
			$rows['option_template'] = 'perp_orders.price_widget.option_category'; //$query['option_template'];
			foreach($rows as $key => &$row) {
				// Format date to user's preference here, so we can use it as a link
				if(is_numeric($row['effective_date'])) {
					$row['formatted_effective_date'] = date(
						$GLOBALS['egw_info']['user']['preferences']['common']['dateformat'] .
						($GLOBALS['egw_info']['user']['preferences']['common']['timeformat'] == '24' ? ' H:i' : ' g:i a'),
						$row['effective_date']
					);
					$row['formatted_effective_to'] = date(
                                                $GLOBALS['egw_info']['user']['preferences']['common']['dateformat'] .
                                                ($GLOBALS['egw_info']['user']['preferences']['common']['timeformat'] == '24' ? ' H:i' : ' g:i a'),
                                                $row['effective_to']
                                        );
					if(is_array($row['options'])) {
						foreach($row['options'] as &$category) {
							foreach($category['build_option_prices'] as &$option) {
								$option['price_list_id'] = $row['price_list_id'];
								$option['stock_id'] = $row['stock_id'];
								/**
								*	build_option_id is later changed to HTML, so it 
								*	comes back properly, so we need the actual value
								*/
								$option['build_option'] = $option['build_option_id'];
								if($option['effective_date'] != null){
									$option['formatted_effective_date'] = date(
										$GLOBALS['egw_info']['user']['preferences']['common']['dateformat'] .
										($GLOBALS['egw_info']['user']['preferences']['common']['timeformat'] == '24' ? ' H:i' : ' g:i a'),
										$option['effective_date']
									);
								} else{
									$option['formatted_effective_date'] = 'n/a';
								}
								if($option['effective_to'] != null){
									$option['formatted_effective_to'] = date(
                                                                        	$GLOBALS['egw_info']['user']['preferences']['common']['dateformat'] .
                                                                        	($GLOBALS['egw_info']['user']['preferences']['common']['timeformat'] == '24' ? ' H:i' : ' g:i a'),
                                                                        	$option['effective_to']
                                                                	);
								} else{
									$option['formatted_effective_to'] = 'n/a';
								}
							}
						}
					}
				}
				if(is_array($row['options'])) {
					$row['option_template'] = $query['option_template'];
					
					$bo_price->add_sub_option_template($query, $row['options'], $readonly);
				}
			}
			return $count;
		}

		private function format_prices($prices) {
			$price_list = array('price_list_id' => null);

			foreach($prices as &$category) {
				if(is_array($category)) {
					foreach($category as &$stock) {
						if(!is_array($stock)) {
							continue;
						}
						if($price_list['price_list_id'] != $stock['price_list_id']) {
							$price_list = ExecMethod('perp_orders.bo_perp_price_list.get_price_list', $stock['price_list_id']);
						}
						$stock['price'] = ($stock['price'] == 0) ? null : ExecMethod2('perp_api.bo_perp_api.get_formatted_price', $price_list['currency'], $stock['price']);
						if(isset($stock['options'])) {
							foreach($stock['options'] as &$options) {
								$this->format_option_prices($options, $price_list['currency']);
							}
						}
					}
				}
			}
			return $prices;
		}

		private function format_option_prices(&$options, $currency) {
			if(is_array($options['options'])) {
				foreach($options['options'] as &$option) {
					if(isset($option['price'])) {
						$option['price'] = ($option['price'] == 0) ? null : ExecMethod2('perp_api.bo_perp_api.get_formatted_price', $currency, $option['price']);
					}
					if(isset($option['options'])) {
						$this->format_option_prices($option['options'], $currency);
					}
				}
			}
		}

		private function set_stock_price($stock) {
			ExecMethod2('perp_orders.bo_perp_price.set_price', $stock['price_list_id'], $stock['override_price'], $stock['stock_id']);
			if($stock['options']) {
				foreach($stock['options'] as $option) {
					if(!is_array($option)) {
						continue;
					}
					if(!isset($option['price_list_id'])) {
						$option['price_list_id'] = $stock['price_list_id'];
					}
					$this->set_option_price($stock['stock_id'], $option);
				}
			}
		}

		private function set_option_price($stock_id, $option) {
			if($option['build_option_id']) {
				ExecMethod2('perp_orders.bo_perp_price.set_price', $option['price_list_id'], $option['override_price'], $option['stock_id'], $option['build_option_id']);
			}
			if($option['options']) {
				foreach($option['options'] as $opt) {
					if(!isset($opt['price_list_id'])) {
						$opt['price_list_id'] = $option['price_list_id'];
					}
					$this->set_option_price($stock_id, $opt);
				}
			}
		}

		/**
		*	View & edit the default prices for build options.
		*	
		*	This allows a fast way to set the default prices for a build option, regardless of
		*	which stock item it is for, or if it is used by many stock items.  Each stock item
		*	can override the price for the option.
		*/
		public function option_default_edit($content = array()) {
			if($this->debug) {
				echo '<strong>' . __METHOD__ . '</strong> incoming data:';
				_debug_array($content);
			}

			$price_list_id = $content['price_list_id'] ? $content['price_list_id'] : $_GET['price_list_id'];
			$edit = $GLOBALS['egw']->acl->check('price_list', EGW_ACL_EDIT, 'perp_orders');
			if(isset($content['cancel']) || !$edit) {
				$GLOBALS['egw']->redirect_link('/index.php', array(
					'menuaction'	=>	'perp_orders.ui_perp_price_list.price_list_edit',
					'price_list_id'	=>	$price_list_id
				));
			} elseif ($content['save'] && $edit) {
				// Save default prices
				$success = true;
				foreach($content['nm']['rows'] as $key => $option) {
					$result = ExecMethod2('perp_orders.bo_perp_price.set_price', $price_list_id, 0, $option['price'], $content['effective_date'], $option['build_option_id']);
					if($result !== true) {
						$this->messages[] = array($result, 'error');
						$this->messages[] = array(lang('Save aborted.'), 'warning');
						$succss = false;
						break;
					}
				}
				if($success) {
					$this->messages[] = array(lang('Default option prices saved.  Assemblies using default pricing have been updated'), 'success');
				}
			}

			$data = $this->bo->get_price_list($price_list_id);

			// Get effective date for changes
			if(reg_var('effective_date') && !$content['effective_date']) {
				// See if it was passed from the price list
				$data['effective_date'] = reg_var('effective_date');
			} elseif($content['effective_date']) {
				$data['effective_date'] = $content['effective_date'];
			} else {
				// Default price change effective date to tomorrow, start of day
				$tomorrow = strtotime('tomorrow');
				$default_date = mktime($GLOBALS['egw_info']['user']['preferences']['calendar']['workdaystarts'], 0, 0, date('m', $tomorrow), date('d', $tomorrow), date('Y', $tomorrow));
				$data['effective_date'] = $content['effective_date'] ? $content['effective_date'] : $default_date;
			}

			$data['nm'] = $GLOBALS['egw']->session->appsession('option_default' . $price_list_id, 'perp_orders');
			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'price_list_id'		=>	$price_list_id,
					'stock_id'		=>	0,
					'template'		=>	'perp_orders.option_default_price.row',
					'get_rows'		=>	'perp_orders.ui_perp_price_list.get_option_defaults',
					'no_cat'		=>	true,
					'no_filter'		=>	true,
					'no_filter2'		=>	true,
					'order'			=>	'build_option_category_name,build_option_name'
				);
			}
			$data['nm']['date'] = $data['effective_date'];

			$preserve['price_list_id'] = $price_list_id;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Default Option Prices for #%1 - %2', $price_list_id, $data['price_list_name']);
			$this->template->read('perp_orders.option_default_price');
			$this->template->exec('perp_orders.ui_perp_price_list.option_default_edit', $data, $select_box_options, $readonly, $preserve);
		}

		/**
		*	Get default option prices
		*	
		*	@nextmatch
		*/
		public function get_option_defaults(&$query = array(), &$rows = array(), &$readonly = array()) {
			$GLOBALS['egw']->session->appsession('option_default' . $query['price_list_id'], 'perp_orders', $query);
			if(!is_object($this->bo_option)) {
				$this->bo_option = new bo_perp_build_option();
			}
			return $this->bo_option->get_price_list($query, $rows, $readonly);
		}
			
		/**
		*	A list of client accounts that have access to a certain price list
		*/
		public function client_account_list($content = array()) {
			$price_list_id = $_GET['price_list_id'] ? $_GET['price_list_id'] : $content['price_list_id'];

			if(isset($content['cancel'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_orders.ui_perp_price_list.price_list_list'));
			}

			$data = $this->bo->get_price_list($price_list_id);

			$data['nm'] = $GLOBALS['egw']->session->appsession('client_account_list' . $price_list_id, 'perp_orders');

			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'price_list_id'		=>	$price_list_id,
					'template'		=>	'perp_orders.client_account_list.row',
					'get_rows'		=>	'perp_orders.ui_perp_price_list.get_client_accounts',
					'no_cat'		=>	true,
					'no_filter'		=>	true,
					'no_filter2'		=>	true,
					'lettersearch'		=>	true,
				);
			}
			
			// Select box options
			$select_box_options['currency'] = ExecMethod('perp_api.bo_perp_api.get_currencies');
			$select_box_options['sales_area_id'] = array('' => lang('Select')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_areas');
			$select_box_options['sales_type_id'] = array('' => lang('Select')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_types');
			$select_box_options['sales_category_id'] = array(''=> lang('Select')) + ExecMethod('perp_orders.bo_perp_orders.get_sales_categories');

			$preserve['price_list_id'] = $price_list_id;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$GLOBALS['egw_info']['flags']['app_header'] = lang(
				'Client Accounts Using #%1 %2', 
				$price_list_id,
				$data['price_list_title']
			);
			$this->template->read('perp_orders.client_account_list');
			$this->template->exec('perp_orders.ui_perp_price_list.client_account_list', $data, $select_box_options, $readonly, $preserve);
		}

		public function get_client_accounts(&$query = array(), &$rows = array(), &$readonlys = array()) {
			// Keep query in session so user can jump around and the results will stay 
			$GLOBALS['egw']->session->appsession('client_account_list' . $query['price_list_id'], 'perp_orders', $query);

			return bo_perp_price_list::get_client_accounts($query, $rows, $readonlys);
		}
	}
?>
