<?php

	/**
	*	Price overrides are stored in the infolog, but require an extra bit to allow viewing of 1 
	*	single override because infolog doesn't provide viewing of an infolog entry.
	*	If you try to edit a single entry that you don't have permission for, you get
	*	an access denied message.  
	*	This hooks into infolog, and reuses as much logic as possible, and only displays.
	*/

	class ui_perp_price_override {

		private $debug = false;

		protected $template;

		protected $infolog_bo;

		protected $tabs = 'description|links|delegation|project|customfields';

		public $public_functions = array(
			'view'	=>	true
		);

		public function __construct() {
			$this->template = CreateObject('etemplate.etemplate');

			$this->infolog_bo = CreateObject('infolog.infolog_bo');
		}

		/**
		*	View a single infolog entry representing a price override
		*	Still subject to view ACLs though.
		*/
		public function view($content = array()) {
			if($this->debug) {
				echo __METHOD__ . ' incoming data.<br />';
				_debug_array($content);
			}

			$infolog_id = reg_var('info_id');
			
			if(!$infolog_id) {
				return false;
			}

			$data = $this->get_display_data($infolog_id);

			if ($infolog_id && $this->infolog_bo->check_access($infolog_id,EGW_ACL_EDIT)) {
				return ExecMethod('infolog.infolog_ui.edit', $infolog_id);
			}

			$readonly = $this->get_readonly($data);

			$this->template->read('infolog.edit');
			$this->template->exec('perp_orders.ui_perp_price_override.view',
				$data,
				$select_box_options,
				$readonly,
				$preserve,
				2
			);
		}

		protected function get_display_data($infolog_id) {

			$data = $this->infolog_bo->read($infolog_id);

			return $data;
		}

		protected function get_readonly($data) {

			return array(
				'info_type'			=>	true,
				'info_cat'		=>	true,
				'info_contact'		=>	true,
				'info_addr'		=>	true,
				'info_from'		=>	true,
				'info_custom_from'	=>	true,
				'info_subject'		=>	true,
				$this->tabs		=>	true,

				'info_startdate'	=>	true,
				'info_enddate'		=>	true,
				'info_percent'		=>	true,
				'info_access'		=>	true,
				'info_status'		=>	true,
				'info_datecompleted'	=>	true,
				'button[save]'		=>	true,
				'button[apply]'		=>	true,
				'button[delete]'	=>	true
			);
		}
	}
?>
