
/* Javascript for editing sales order */

function sales_order_edit_setup(admin) {
	var client_account = document.getElementById('exec[client_account_id][value]');
	var currency = document.getElementById('exec[currency]');
	if(currency) {
		if(currency.addEventListener) {
			currency.addEventListener('change', change_currency, true);
		} else {
			currency.onchange = change_currency;
		}
	}

	// Add listeners to quantity, disable amount fields
	inputs = document.getElementsByTagName('INPUT');
	for(var i = 0; i < inputs.length; i++) {
		if(inputs[i].id.lastIndexOf('[quantity_ordered]') > 0 || inputs[i].id.lastIndexOf('[unit_price]') > 0) {
			if(inputs[i].addEventListener) {
				inputs[i].addEventListener('keyup', change_quantity, false);
			} else {
				var old = (inputs[i].onkeyup) ? inputs[i].onkeyup : function () {};
				inputs[i].onkeyup = function() { old(); change_quantity();};
			}
			inputs[i].style.textAlign = 'right';
		} else if (inputs[i].id.lastIndexOf('[unit_price]') > 0 || inputs[i].id.lastIndexOf('[extended_cost]') > 0) {
			if(!admin || inputs[i].id.lastIndexOf('[extended_cost]') > 0) {
				inputs[i].disabled = true;
			}
			inputs[i].style.textAlign = 'right';
		}
	}

	// Add listener to re-enable new line amount fields
	var add_line = document.getElementById('exec[add_line]');
	if(add_line) {
		if(add_line.addEventListener) {
			add_line.addEventListener('click', function() {
				document.getElementById('exec[new][unit_price]').disabled = false;
			}, true);
		} else {
			var old = (add_line.onkeyup) ? add_line.onkeyup : function () {};
			add_line.onkeyup = function() { old(); document.getElementById('exec[new][1][unit_price]').disabled = false;};
		}
	}

	hide_link();
	var client = document.getElementById('exec[client_id][value]');
	if(client) {
		change_client(client);
	}
	var client_account = document.getElementById('exec[client_account_id][value]');
	if(client_account) {
		change_client_account(client_account);
	}
}

function change_client(e) {
	if(!e) {
		var e = window.event;
	}
	if(!e) {
		return;
	} else if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		}
	} else {
		var target = e;
	}
	var client = target.value;
	if(target != client) {
		var account = document.getElementById('exec[client_account_id][value]');
		var branch = document.getElementById('exec[client_branch_id][value]');
	}

	xajax_doXMLHTTP("perp_orders.ajax_perp_sales_order.change_client", 
		document.forms[0].etemplate_exec_id.value,
		client,
		(account ? account.value : ''),
		(branch ? branch.value : '')
	);

	if(branch && branch.value == -1) { // Other
		show_link();
	}
}

function change_client_branch(e) {
	if(!e) {
		var e = window.event;
	}
	if(!e) {
		return;
	} else if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		}
	} else {
		var target = e;
	}
	var client_id = document.getElementById('exec[client_id][value]');
	if(client_id) {
		client_id = client_id.value;
	} else {
		return false;
	}
	var client_branch = target.value;
	xajax_doXMLHTTP("perp_orders.ajax_perp_sales_order.change_client_branch", 
		document.forms[0].etemplate_exec_id.value,
		client_id, client_branch
	);
}
		
function change_client_account(e) {
	if(!e) {
		var e = window.event;
	}
	if(!e) {
		return;
	} else if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		}
	} else {
		var target = e;
	}
	var client_id = document.getElementById('exec[client_id][value]');
	if(client_id) {
		client_id = client_id.value;
	} else {
		return false;
	}
	var client_account = target.value;
	xajax_doXMLHTTP("perp_orders.ajax_perp_sales_order.change_client_account", 
		document.forms[0].etemplate_exec_id.value,
		client_id, client_account
	);
}

function change_currency(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		}
	}
	update_stock_selection('', 'currency', target.value);
}

function change_order_date(e) {
	var order_date = document.getElementById('exec[issue_date][str]');
	var order_hour = document.getElementById('exec[issue_date][H]');
	var order_minute = document.getElementById('exec[issue_date][i]');
	xajax_doXMLHTTP("perp_orders.ajax_perp_sales_order.change_order_date", 
		order_date.value + ' ' + order_hour.value + ':' + order_minute.value
	);
}

function select_item(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		}
	}

	var stock_id = target.value;

	// Description box
	var base_id = target.id.substr(0, target.id.lastIndexOf('['));
	var query_holder = document.getElementById(base_id + '[results]');
	if(query_holder && !query_holder.options) {
		query_holder = document.getElementById(base_id + '[stock_id]');
	}
	var options = query_holder.options;
	base_id = base_id.substr(0, base_id.lastIndexOf('['));
	var description = document.getElementById(base_id + '[description]');
	//description.value = target.options[target.selectedIndex].text;
	var client = document.getElementById('exec[client_id][value]');
	
	// xajax will handle the rest
	xajax_doXMLHTTP("perp_orders.ajax_perp_sales_order.change_stock_id", client.value, stock_id, options, base_id);
}


// When the user changes a quantity, adjust line price accordingly
function change_quantity(e) {
	if(!e) {
		var e = window.event;
	}
	if(e.target) {
		var target = e.target;
	} else if (e.srcElement) {
		var target = e.srcElement;
	}
	if(target) {
		if (target.nodeType == 3) { // defeat Safari bug
			target = target.parentNode;
		}
	}
	var base_id = target.id.substr(0, target.id.lastIndexOf('['));
	var quantity = document.getElementById(base_id + '[quantity_ordered]');
	var unit_price = document.getElementById(base_id + '[unit_price]');
	var extended_cost = document.getElementById(base_id + '[extended_cost]');
	if(extended_cost && unit_price && quantity) {
		var value = unit_price.value * quantity.value;
		if(value.toFixed) {
			value = value.toFixed(2);
		}
		extended_cost.value = value;
	}
}


/* Update the query for the stock selectors
*	(called via ajax)
*/
function update_stock_selection(id, key, value) {
	if(id) {	// Do only one
		var results = document.getElementById(id);
		if(results && results.options) {
			eval("results.options." + key + " = '" + value + "';");
		}
	} else {	// Do them all
		inputs = document.getElementsByTagName('INPUT');

		for(var i = 0; i < inputs.length; i++) {
			if(inputs[i].id.lastIndexOf('[stock_id][search]') > 0) {
				var base_id = inputs[i].id.substr(0, inputs[i].id.lastIndexOf('['));
				var results = document.getElementById(base_id + '[results]');
				if(results && results.options) {
					eval("results.options." + key + " = '" + value + "';");
					// We need to submit it, too
					var submit_option = document.getElementById(base_id + '[' + key + ']');
					if(!submit_option) {
						var submit_option = document.createElement('input');
						submit_option.style.display = 'none';
						submit_option.id = base_id + '[' + key + ']';
						submit_option.name = submit_option.id;
						results.parentNode.appendChild(submit_option);
					}
					submit_option.value = value;
				} else {
					alert('Could not find options');
				}
			}
		}
	}
}

function show_link() {
	set_style_by_class("table", "other_address", "display", "inline");
}

function hide_link() {
	set_style_by_class("table", "other_address", "display", "none");
}


/* Remove options from a select box
*  @param id - The id of the select
*/
function removeOptions(id) {
	if(document.getElementById(id)) {
		var element = document.getElementById(id);
		if(element.options) {
			while(element.options.length > 0) {
				element.remove(0);
			}
		}
	}
}

/* Add an option to a select box
*  @param id - The id of the select box
*  @param key - The key of the option
*  @param value - The value of the option
*/
function addOption(id, key, value) {
	var objOption = new Option(value, key);
	var select = document.getElementById(id);
	if(select) {
		try {
			select.options.add(objOption); // standards compliant
		} catch (ex) {
			if(select.add) {
				select.add(objOption); // IE
			}
		}
	}
}

