/**
*	Javascript for editing a Sales Order detail in a popup
*/

// Set up handlers
function add_handlers() {
	var unclaimed = document.getElementById('exec[unclaimed][unclaimed]');
	if(unclaimed) {
		var work_orders = unclaimed.getElementsByClassName('work_order');
		for(i = 0; i < work_orders.length; i++) {
			// That gives us the TD
			work_orders[i].addEventListener('mouseover', show_work_order, false);
			work_orders[i].addEventListener('mouseout', hide_work_order, false);
		}
	}
}

/**
*	Display an unclaimed work order's details
*/
function show_work_order(event) {
	var target = event.target;

	while(target.parentNode && target.nodeName != 'TD') {
		target = target.parentNode
	}

	// Options over two, down one, over 3
	var options = target.nextSibling.nextSibling.firstChild.nextSibling.nextSibling.nextSibling;
	move_options(target.parentNode, options);
	options.style.visibility = 'visible';
}

/**
*	Hide an unclaimed work order's details
*/
function hide_work_order(event) {
	var target = event.target;
	while(target.parentNode && target.nodeName != 'TD') {
		target = target.parentNode
	}

	// Options over two, down one, over 3
	var options = target.nextSibling.nextSibling.firstChild.nextSibling.nextSibling.nextSibling;
	options.style.visibility = 'visible';
	options.style.visibility = 'hidden';
}

function move_options(align_to, element) {
	var position = find_position(align_to);

	element.style.top = (position.top - element.offsetHeight) + 'px';

	if (position.left + element.offsetWidth > document.getElementById('popupMainDiv').offsetWidth) {
		element.style.left = (document.getElementById('popupMainDiv').offsetWidth - element.offsetWidth)+ 'px';
	} else if (position.left < 0) {
		element.style.left = 0; 
	} else {
		element.style.left = position.left + 'px';
	}
}

/**
*	Find the position information for the given element
*/
function find_position(element) {
	var position = {
		top:	0,
		left:	0,
	};

	if(element.offsetParent) {
		while(element.offsetParent) {
			position.left += element.offsetLeft;
			position.top += element.offsetTop;
			element = element.offsetParent;
		}
	} else if (element.x || element.y) {
		position.left += element.x;
		position.top += element.y;
	}
	
	return position;
}
