/**
 * Javascript for providing some nice AJAXy examples of how the user's calculation will work.
 */

// Used to prevent flooding the server as the user types
var timer_id = 0;
var timer_timeout = 500;

function price_calculation() {
	document.getElementById('exec[calculation]').addEventListener('keyup', timer_change, false);
}

function change_calculation() {

	// Re-calculate some examples
	var calculation = document.getElementById('exec[calculation]').value;
	var prompt_input = document.getElementById('exec[variable_prompt]');
	var prompt = null;
	if(prompt_input) {
		prompt = prompt_input.value;
	}
	xajax_doXMLHTTP("perp_orders.ajax_perp_price_calculation.examples", 
		calculation, prompt
	);

}

/**
 * Set a timeout to prevent user from flooding the server with requests as
 * they type.  Waits to see if the user is still typing before sending the
 * request.  Adjust ajax_select_timeout to change how long to wait (in ms).
 */
function timer_change() {
	if ( timer_id != 0) {
		clearTimeout(timer_id);
	}
	timer_id = setTimeout(
		function() {
			change_calculation();
		},
		timer_timeout
	);
}
