<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.33 2005/12/19 04:27:19 ralfbecker Exp $ */


$phpgw_baseline = array(
	'perp_sales_category' => array(
		'fd' => array(
			'sales_category_id' => array('type' => 'int','precision' => '4'),
			'cost_of_sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
			'sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('sales_category_id'),
		'fk' => array('sales_category_id' => 'egw_categories.cat_id','cost_of_sales_gl_account' => 'perp_account.account_id','sales_gl_account' => 'perp_account.account_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_sales_category' => array(
		'fd' => array(
			'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('sales_category_id','stock_id'),
		'fk' => array('sales_category_id' => 'perp_sales_category.sales_category_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_price_list' => array(
		'fd' => array(
			'price_list_id' => array('type' => 'auto','nullable' => False),
			'price_list_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'sales_area_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'effective_to' => array('type' => 'date'),
			'sales_type_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'price_list_title' => array('type' => 'varchar','precision' => '50'),
			'order_by' => array('type' => 'varchar','precision' => '50','nullable' => False,'default' => 'stock_num'),
			'sort' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '1')
		),
		'pk' => array('price_list_id'),
		'fk' => array('currency' => 'perp_currency.currency_id','sales_category_id' => 'perp_sales_category.sales_category_id','sales_area_id' => 'perp_sales_area.sales_area_id','sales_type_id' => 'perp_sales_type.sales_type_id'),
		'ix' => array('price_list_id','sales_category_id','sales_area_id','sales_type_id'),
		'uc' => array('price_list_id')
	),
	'perp_price' => array(
		'fd' => array(
			'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'effective_date' => array('type' => 'timestamp','nullable' => False),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'modified_date' => array('type' => 'timestamp','nullable' => False,'default' => 'current_timestamp')
		),
		'pk' => array('price_list_id','stock_id','effective_date'),
		'fk' => array('price_list_id' => 'perp_price_list.price_list_id','stock_id' => 'perp_stock.stock_id','modified_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_sales_area' => array(
		'fd' => array(
			'sales_area_id' => array('type' => 'auto','nullable' => False),
			'sales_area_name' => array('type' => 'varchar','precision' => '50','nullable' => False)
		),
		'pk' => array('sales_area_id'),
		'fk' => array(),
		'ix' => array('sales_area_id'),
		'uc' => array('sales_area_id','sales_area_name')
	),
	'perp_build_option_price' => array(
		'fd' => array(
			'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'effective_date' => array('type' => 'timestamp'),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'modified_date' => array('type' => 'timestamp','nullable' => False,'default' => 'current_timestamp'),
			'parent_component_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('build_option_id','stock_id','price_list_id','effective_date','parent_component_id'),
		'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id','price_list_id' => 'perp_price_list.price_list_id','effective_date' => 'current_timestamp','modified_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_sales_order' => array(
		'fd' => array(
			'order_id' => array('type' => 'auto','nullable' => False),
			'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('order_id'),
		'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','client_account_id' => 'perp_client_account.client_account_id'),
		'ix' => array('order_id'),
		'uc' => array('order_id')
	),
	'perp_sales_order_detail' => array(
		'fd' => array(
			'order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2')
		),
		'pk' => array('order_id','line_no'),
		'fk' => array('order_id' => 'perp_sales_order.order_id'),
		'ix' => array('order_id','line_no'),
		'uc' => array(array('order_id','line_no'))
	),
	'perp_sales_type' => array(
		'fd' => array(
			'sales_type_id' => array('type' => 'auto','precision' => '4','nullable' => False),
			'sales_type_name' => array('type' => 'varchar','precision' => '20','nullable' => False)
		),
		'pk' => array('sales_type_id'),
		'fk' => array(),
		'ix' => array('sales_type_id'),
		'uc' => array('sales_type_id')
	),
	'perp_sales_order_work_order' => array(
		'fd' => array(
			'order_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'detail_no' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'work_order_detail_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity_returned' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
		),
		'pk' => array('order_id','line_no','detail_no'),
		'fk' => array('order_id' => 'perp_sales_order_detail.order_id','line_no' => 'perp_sales_order_detail.line_no','detail_no' => 'perp_order_detail.detail_id','work_order_detail_id' => 'perp_work_order_detail.detail_id'),
		'ix' => array(),
		'uc' => array(array('order_id','line_no','detail_no'))
	),
	'perp_stock_kit_price' => array(
		'fd' => array(
			'price_list_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'kit_stock_id' => array('type' => 'int','precision' => '4'),
			'component_id' => array('type' => 'int','precision' => '4'),
			'effective_date' => array('type' => 'timestamp'),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'modified_date' => array('type' => 'timestamp','nullable' => False),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('price_list_id','stock_id','component_id','effective_date','kit_stock_id'),
		'fk' => array('price_list_id' => 'perp_price_list.price_list_id','stock_id' => 'perp_stock.stock_id','component_id' => 'perp_stock.stock_id','modified_by' => 'egw_accounts.account_id','kit_stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_price_calculation' => array(
		'fd' => array(
			'id' => array('type' => 'auto','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'calculation' => array('type' => 'text','nullable' => False),
			'variable_prompt' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('id'),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	)
);
