<?php
	/**************************************************************************\
	* eGroupWare - Setup                                                       *
	* http://www.eGroupWare.org                                                *
	* Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de *
	* --------------------------------------------                             *
	* This program is free software; you can redistribute it and/or modify it  *
	* under the terms of the GNU General Public License as published by the    *
	* Free Software Foundation; either version 2 of the License, or (at your   *
	* option) any later version.                                               *
	\**************************************************************************/
	
	/* $Id: class.db_tools.inc.php,v 1.33 2005/12/19 04:27:19 ralfbecker Exp $ */


// Required to force tables to InnoDB
require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.so_perp_api.inc.php');

	$test[] = '0.1.004';
	function perp_orders_upgrade0_1_004()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_sales_category',array(
			'fd' => array(
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_category_id','stock_id'),
			'fk' => array('sales_category_id' => 'perp_sales_category.sales_category_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_category_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.005';
	}


	$test[] = '0.1.005';
	function perp_orders_upgrade0_1_005()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_price_list',array(
			'fd' => array(
				'price_list_id' => array('type' => 'auto','nullable' => False),
				'price_list_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'currency' => array('type' => 'varchar','precision' => '30','nullable' => False),
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('price_list_id'),
			'fk' => array('sales_category_id' => 'perp_sales_category.sales_category_id'),
			'ix' => array('price_list_id'),
			'uc' => array('price_list_id')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.006';
	}


	$test[] = '0.1.006';
	function perp_orders_upgrade0_1_006()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_price',array(
			'fd' => array(
				'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('price_list_id','stock_id'),
			'fk' => array('price_list_id' => 'perp_price_list.price_list_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('price_list_id','stock_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.007';
	}


	$test[] = '0.1.007';
	function perp_orders_upgrade0_1_007()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_price_list','sales_area_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_price_list',array(
			'fd' => array(
				'price_list_id' => array('type' => 'auto','nullable' => False),
				'price_list_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'currency' => array('type' => 'varchar','precision' => '30','nullable' => False),
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_area_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('price_list_id'),
			'fk' => array('sales_category_id' => 'perp_sales_category.sales_category_id','sales_area_id' => 'perp_sales_area.sales_area_id'),
			'ix' => array('price_list_id','sales_category_id','sales_area_id'),
			'uc' => array('price_list_id')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.008';
	}


	$test[] = '0.1.008';
	function perp_orders_upgrade0_1_008()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_sales_area',array(
			'fd' => array(
				'sales_area_id' => array('type' => 'auto','nullable' => False),
				'sales_area_name' => array('type' => 'varchar','precision' => '50','nullable' => False)
			),
			'pk' => array('sales_area_id'),
			'fk' => array(),
			'ix' => array('sales_area_id'),
			'uc' => array('sales_area_id','sales_area_name')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.009';
	}


	$test[] = '0.1.009';
	function perp_orders_upgrade0_1_009()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_build_option_price',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('build_option_id','stock_id','price_list_id'),
			'fk' => array('build_option_id' => 'perp_allowed_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id','price_list_id' => 'perp_price_list.price_list_id'),
			'ix' => array('build_option_id','stock_id','price_list_id'),
			'uc' => array(array('build_option_id','stock_id','price_list_id'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.010';
	}


	$test[] = '0.1.010';
	function perp_orders_upgrade0_1_010()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'sales_order_num' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'customer_reference' => array('type' => 'varchar','precision' => '10'),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'delivery_date' => array('type' => 'date'),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool')
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id'),
			'ix' => array('sales_order_id','sales_order_num'),
			'uc' => array('sales_order_id','sales_order_num')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.011';
	}


	$test[] = '0.1.011';
	function perp_orders_upgrade0_1_011()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'qty_ordered' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'qty_invoiced' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'unit_price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'narrative' => array('type' => 'varchar','precision' => '50'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => 'false')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.012';
	}


	$test[] = '0.1.012';
	function perp_orders_upgrade0_1_012()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sales_order_detail','completed',array(
			'type' => 'bool',
			'nullable' => False,
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.013';
	}


	$test[] = '0.1.013';
	function perp_orders_upgrade0_1_013()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_build_option_price','stock_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_build_option_price',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('build_option_id','price_list_id'),
			'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id','price_list_id' => 'perp_price_list.price_list_id'),
			'ix' => array('build_option_id','stock_id','price_list_id'),
			'uc' => array(array('build_option_id','price_list_id'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.014';
	}


	$test[] = '0.1.014';
	function perp_orders_upgrade0_1_014()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_build_option_price',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('build_option_id','price_list_id'),
			'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id','price_list_id' => 'perp_price_list.price_list_id'),
			'ix' => array('build_option_id','stock_id','price_list_id'),
			'uc' => array(array('build_option_id','price_list_id','stock_id'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.015';
	}


	$test[] = '0.1.015';
	function perp_orders_upgrade0_1_015()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_price_list','effective_from',array(
			'type' => 'date',
			'nullable' => False
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_price_list','effective_to',array(
			'type' => 'date'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.016';
	}


	$test[] = '0.1.016';
	function perp_orders_upgrade0_1_016()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_build_option_price',array(
			'fd' => array(
				'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4'),
				'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('build_option_id','stock_id','price_list_id'),
			'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id','price_list_id' => 'perp_price_list.price_list_id'),
			'ix' => array('build_option_id','stock_id','price_list_id'),
			'uc' => array(array('build_option_id','price_list_id','stock_id'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.017';
	}


	$test[] = '0.1.017';
	function perp_orders_upgrade0_1_017()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_sales_type',array(
			'fd' => array(
				'sales_type_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_type_name' => array('type' => 'varchar','precision' => '20','nullable' => False)
			),
			'pk' => array('sales_type_id'),
			'fk' => array(),
			'ix' => array('sales_type_id'),
			'uc' => array('sales_type_id')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.018';
	}


	$test[] = '0.1.018';
	function perp_orders_upgrade0_1_018()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sales_type','sales_type_id',array(
			'type' => 'auto',
			'precision' => '4',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.019';
	}


	$test[] = '0.1.019';
	function perp_orders_upgrade0_1_019()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_price_list','sales_type_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_price_list',array(
			'fd' => array(
				'price_list_id' => array('type' => 'auto','nullable' => False),
				'price_list_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'currency' => array('type' => 'varchar','precision' => '30','nullable' => False),
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_area_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'effective_from' => array('type' => 'date','nullable' => False),
				'effective_to' => array('type' => 'date'),
				'sales_type_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('price_list_id'),
			'fk' => array('sales_category_id' => 'perp_sales_category.sales_category_id','sales_area_id' => 'perp_sales_area.sales_area_id','sales_type_id' => 'perp_sales_type.sales_type_id'),
			'ix' => array('price_list_id','sales_category_id','sales_area_id','sales_type_id'),
			'uc' => array('price_list_id')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.020';
	}


	$test[] = '0.1.020';
	function perp_orders_upgrade0_1_020()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','ship_date',array(
			'type' => 'date'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.021';
	}


	$test[] = '0.1.021';
	function perp_orders_upgrade0_1_021()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','currency',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'sales_order_num' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'customer_reference' => array('type' => 'varchar','precision' => '10'),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'delivery_date' => array('type' => 'date'),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id'),
			'ix' => array('sales_order_id','sales_order_num'),
			'uc' => array('sales_order_id','sales_order_num')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.022';
	}


	$test[] = '0.1.022';
	function perp_orders_upgrade0_1_022()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'sales_order_num' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'customer_reference' => array('type' => 'varchar','precision' => '10'),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id'),
			'ix' => array('sales_order_id','sales_order_num'),
			'uc' => array('sales_order_id','sales_order_num')
		),'delivery_date');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','est_ship_date',array(
			'type' => 'date'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','initiator',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','approver',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','approved_date',array(
			'type' => 'date'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','invoiced_date',array(
			'type' => 'date'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','terms',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'sales_order_num' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'customer_reference' => array('type' => 'varchar','precision' => '10'),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'int','precision' => '4'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id'),
			'ix' => array('sales_order_id','sales_order_num'),
			'uc' => array('sales_order_id','sales_order_num')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.023';
	}


	$test[] = '0.1.023';
	function perp_orders_upgrade0_1_023()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_sales_order_detail','qty_ordered','quantity_ordered');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_sales_order_detail','qty_invoiced','quantity_invoiced');
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order_detail','quantity_shipped',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.024';
	}


	$test[] = '0.1.024';
	function perp_orders_upgrade0_1_024()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order_detail','ship_date',array(
			'type' => 'date'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.025';
	}


	$test[] = '0.1.025';
	function perp_orders_upgrade0_1_025()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order_detail','invoiced_date',array(
			'type' => 'date'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.026';
	}


	$test[] = '0.1.026';
	function perp_orders_upgrade0_1_026()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','client_account_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'sales_order_num' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'customer_reference' => array('type' => 'varchar','precision' => '10'),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'int','precision' => '4'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('sales_order_id','sales_order_num'),
			'uc' => array('sales_order_id','sales_order_num')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.027';
	}


	$test[] = '0.1.027';
	function perp_orders_upgrade0_1_027()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_sales_order','client_branch_id','ship_to');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'sales_order_num' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False),
				'customer_reference' => array('type' => 'varchar','precision' => '10'),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'int','precision' => '4'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('ship_to' => 'egw_addressbook.id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('sales_order_id','sales_order_num'),
			'uc' => array('sales_order_id','sales_order_num')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.028';
	}


	$test[] = '0.1.028';
	function perp_orders_upgrade0_1_028()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order','ship_to',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'sales_order_num' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'customer_reference' => array('type' => 'varchar','precision' => '10'),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'int','precision' => '4'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id','sales_order_num'),
			'uc' => array('sales_order_id','sales_order_num')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.029';
	}


	$test[] = '0.1.029';
	function perp_orders_upgrade0_1_029()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sales_order','terms',array(
			'type' => 'varchar',
			'precision' => '2'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.030';
	}


	$test[] = '0.1.030';
	function perp_orders_upgrade0_1_030()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sales_order','currency',array(
			'type' => 'varchar',
			'precision' => '3'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.031';
	}


	$test[] = '0.1.031';
	function perp_orders_upgrade0_1_031()
	{
		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.032';
	}


	$test[] = '0.1.032';
	function perp_orders_upgrade0_1_032()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_sales_order_work_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_no' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1')
			),
			'pk' => array('sales_order_id','line_no','work_order_id'),
			'fk' => array('sales_order_id' => 'perp_sales_order_detail.sales_order_id','line_no' => 'perp_sales_order_detail.stock_id','work_order_id' => 'perp_work_order.work_order_id','detail_no' => 'perp_work_order_detail.detail_id'),
			'ix' => array('sales_order_id','line_no','work_order_id'),
			'uc' => array(array('sales_order_id','line_no','work_order_id'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.033';
	}


	$test[] = '0.1.033';
	function perp_orders_upgrade0_1_033()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sales_order','terms',array(
			'type' => 'int',
			'precision' => '4'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.034';
	}


	$test[] = '0.1.034';
	function perp_orders_upgrade0_1_034()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order_work_order','quantity',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False,
			'default' => '1'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order_work_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_no' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
			),
			'pk' => array('sales_order_id','line_no','work_order_id','detail_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order_detail.sales_order_id','line_no' => 'perp_sales_order_detail.stock_id','work_order_id' => 'perp_work_order.work_order_id','detail_no' => 'perp_work_order_detail.detail_id'),
			'ix' => array('sales_order_id','line_no','work_order_id'),
			'uc' => array(array('sales_order_id','line_no','work_order_id','detail_no'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.035';
	}


	$test[] = '0.1.035';
	function perp_orders_upgrade0_1_035()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_sales_category',array(
			'fd' => array(
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'stock_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_category_id','stock_id'),
			'fk' => array('sales_category_id' => 'perp_sales_category.sales_category_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.036';
	}


	$test[] = '0.1.036';
	function perp_orders_upgrade0_1_036()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order_work_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'work_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_no' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
			),
			'pk' => array('sales_order_id','line_no','work_order_id','detail_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order_detail.sales_order_id','line_no' => 'perp_sales_order_detail.stock_id','work_order_id' => 'perp_work_order.work_order_id','detail_no' => 'perp_work_order_detail.detail_id'),
			'ix' => array(),
			'uc' => array(array('sales_order_id','line_no','work_order_id','detail_no'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.037';
	}


	$test[] = '0.1.037';
	function perp_orders_upgrade0_1_037()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_category','cost_of_sales_gl_account',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_category','sales_gl_account',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_category',array(
			'fd' => array(
				'sales_category_id' => array('type' => 'auto','nullable' => False),
				'parent_category_id' => array('type' => 'int','precision' => '4'),
				'sales_category_name' => array('type' => 'varchar','precision' => '30','nullable' => False),
				'abbreviation' => array('type' => 'varchar','precision' => '4'),
				'cost_of_sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_category_id'),
			'fk' => array('parent_category_id' => 'perp_sales_category.sales_category_id','cost_of_sales_gl_account' => 'perp_account.account_id','sales_gl_account' => 'perp_account.account_id'),
			'ix' => array('sales_category_id'),
			'uc' => array('sales_category_id')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.038';
	}

	$test[] = '0.1.038';
	function perp_orders_upgrade0_1_038()
	{
		$sql = "UPDATE egw_acl SET acl_location = 'order' WHERE acl_appname = 'perp_orders' AND acl_location = 'sales_order'";
		$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);

		// Copy Sales Orders
		$sql = "INSERT INTO perp_order (
				our_reference_number,
				their_reference_number,
				originating_user,
				approving_user,
				our_contact_person,
				their_contact_person,
				supplier_id,
				client_id,
				originating_date,
				issue_date,
				approval_date,
				requested_delivery_date,
				actual_delivery_date,
				ship_from_address,
				ship_to_address,
				requires_approval,
				order_currency,
				payment_terms,
				comments
			) ( 
				SELECT 
				sales_order_num,
				customer_reference,
				initiator,
				approver,
				null,
				contact,
				0,
				client_id,
				order_date,
				printed_date,
				approved_date,
				est_ship_date,
				ship_date,
				null,
				ship_to,
				false,
				currency,
				terms,
				comment
				FROM perp_sales_order
				JOIN perp_client_account ON
					perp_client_account.client_account_id = perp_sales_order.client_account_id
		)";
		$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);

		$sql = 'INSERT INTO perp_order_line (
				order_id,
				line_no,
				stock_id,
				supplier_stock_code,
				our_stock_code,
				description,
				quantity_ordered,
				unit_price
			) (
			SELECT
				order_id,
				line_no,
				perp_stock.stock_id,
				stock_num,
				stock_num,
				narrative,
				quantity_ordered,
				unit_price
			FROM perp_sales_order_detail
			JOIN perp_stock ON perp_stock.stock_id = perp_sales_order_detail.stock_id
			JOIN perp_sales_order ON
				perp_sales_order.sales_order_id = perp_sales_order_detail.sales_order_id
			JOIN perp_order ON
				perp_order.our_reference_number = perp_sales_order.sales_order_num
			)';
		$GLOBALS['egw_setup']->db->query($sql, __LINE__, __FILE__);

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.039';
	}


	$test[] = '0.1.039';
	function perp_orders_upgrade0_1_039()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_sales_order','sales_order_id','order_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'customer_reference' => array('type' => 'varchar','precision' => '10'),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'sales_order_num');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'contact' => array('type' => 'int','precision' => '4'),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'customer_reference');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'comment' => array('type' => 'text'),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'contact');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'order_date' => array('type' => 'date','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'comment');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'printed_date' => array('type' => 'date'),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'order_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'delivery_address' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'printed_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'from_location' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'delivery_address');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quotation' => array('type' => 'bool'),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'from_location');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_date' => array('type' => 'date'),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'quotation');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'currency' => array('type' => 'varchar','precision' => '3'),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'ship_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'est_ship_date' => array('type' => 'date'),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'currency');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'initiator' => array('type' => 'int','precision' => '4'),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'est_ship_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'approver' => array('type' => 'int','precision' => '4'),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'initiator');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'approved_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'approver');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'invoiced_date' => array('type' => 'date'),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'approved_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'terms' => array('type' => 'int','precision' => '4'),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'invoiced_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'ship_to' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'terms');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','delivery_address' => 'egw_addressbook.id','from_location' => 'perp_location.location_id','currency' => 'perp_currency.currency_id','initiator' => 'egw_accounts.account_id','approver' => 'egw_accounts.account_id','terms' => 'perp_payment_term.payment_term_id','client_account_id' => 'perp_client_account.client_account_id','ship_to' => 'egw_addressbook.id'),
			'ix' => array('sales_order_id'),
			'uc' => array('sales_order_id')
		),'ship_to');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order',array(
			'fd' => array(
				'order_id' => array('type' => 'auto','nullable' => False),
				'client_branch_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'client_account_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('order_id'),
			'fk' => array('client_branch_id' => 'perp_client_branch.branch_id','client_account_id' => 'perp_client_account.client_account_id'),
			'ix' => array('order_id'),
			'uc' => array('order_id')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.040';
	}


	$test[] = '0.1.040';
	function perp_orders_upgrade0_1_040()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_sales_order_detail','sales_order_id','order_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_ordered' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'quantity_invoiced' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'unit_price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'narrative' => array('type' => 'varchar','precision' => '50'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'quantity_shipped' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'ship_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'stock_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity_invoiced' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'unit_price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'narrative' => array('type' => 'varchar','precision' => '50'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'quantity_shipped' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'ship_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'quantity_ordered');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'unit_price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'narrative' => array('type' => 'varchar','precision' => '50'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'quantity_shipped' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'ship_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'quantity_invoiced');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'narrative' => array('type' => 'varchar','precision' => '50'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'quantity_shipped' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'ship_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'unit_price');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'completed' => array('type' => 'bool','nullable' => False,'default' => '0'),
				'quantity_shipped' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'ship_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'narrative');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'quantity_shipped' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'ship_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'completed');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'ship_date' => array('type' => 'date'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'quantity_shipped');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2'),
				'invoiced_date' => array('type' => 'date')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'ship_date');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_detail',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2')
			),
			'pk' => array('sales_order_id','line_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order.sales_order_id','stock_id' => 'perp_stock.stock_id'),
			'ix' => array('sales_order_id','line_no'),
			'uc' => array(array('sales_order_id','line_no'))
		),'invoiced_date');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order_detail',array(
			'fd' => array(
				'order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'discount_percent' => array('type' => 'decimal','precision' => '5','scale' => '2')
			),
			'pk' => array('order_id','line_no'),
			'fk' => array('order_id' => 'perp_sales_order.order_id'),
			'ix' => array('order_id','line_no'),
			'uc' => array(array('order_id','line_no'))
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.041';
	}


	$test[] = '0.1.041';
	function perp_orders_upgrade0_1_041()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_sales_order_work_order','sales_order_id','order_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_order_work_order',array(
			'fd' => array(
				'sales_order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_no' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
			),
			'pk' => array('sales_order_id','line_no','detail_no'),
			'fk' => array('sales_order_id' => 'perp_sales_order_detail.sales_order_id','line_no' => 'perp_sales_order_detail.stock_id','work_order_id' => 'perp_work_order.work_order_id','detail_no' => 'perp_work_order_detail.detail_id'),
			'ix' => array(),
			'uc' => array(array('sales_order_id','line_no','work_order_id','detail_no'))
		),'work_order_id');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sales_order_work_order','detail_no',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order_work_order','work_order_detail_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_order_work_order',array(
			'fd' => array(
				'order_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'line_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'detail_no' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'work_order_detail_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('order_id','line_no','detail_no'),
			'fk' => array('order_id' => 'perp_sales_order_detail.order_id','line_no' => 'perp_sales_order_detail.line_no','detail_no' => 'perp_order_detail.detail_id','work_order_detail_id' => 'perp_work_order_detail.detail_id'),
			'ix' => array(),
			'uc' => array(array('order_id','line_no','detail_no'))
		));


		// Add an infolog type for price overrides
		// We have to do it directly, because infolog can't use the regular db object.
		$config =& CreateObject('phpgwapi.config', 'infolog');
		$config->read_repository();
		if(is_array($config->config_data['types'])) {
			$config->config_data['types']['price_override'] = 'price override';
			$config->config_data['status']['defaults']['price_override'] = 'ongoing';
			$config->config_data['status']['price_override']['ongoing'] = 'ongoing';
			$config->config_data['status']['price_override']['done'] = 'done';
			$config->save_repository();
		}

		// Default infolog type to price override
		$config =& CreateObject('phpgwapi.config', $app_name);
		$config->read_repository();
		$config->value('price_override_type', lang('price_override'));
		$config->save_repository();

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.042';
	}


	$test[] = '0.1.042';
	function perp_orders_upgrade0_1_042()
	{
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_category',array(
			'fd' => array(
				'sales_category_id' => array('type' => 'auto','nullable' => False),
				'sales_category_name' => array('type' => 'varchar','precision' => '30','nullable' => False),
				'abbreviation' => array('type' => 'varchar','precision' => '4'),
				'cost_of_sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_category_id'),
			'fk' => array('parent_category_id' => 'perp_sales_category.sales_category_id','cost_of_sales_gl_account' => 'perp_account.account_id','sales_gl_account' => 'perp_account.account_id'),
			'ix' => array('sales_category_id'),
			'uc' => array('sales_category_id')
		),'parent_category_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_category',array(
			'fd' => array(
				'sales_category_id' => array('type' => 'auto','nullable' => False),
				'abbreviation' => array('type' => 'varchar','precision' => '4'),
				'cost_of_sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_category_id'),
			'fk' => array('parent_category_id' => 'perp_sales_category.sales_category_id','cost_of_sales_gl_account' => 'perp_account.account_id','sales_gl_account' => 'perp_account.account_id'),
			'ix' => array('sales_category_id'),
			'uc' => array('sales_category_id')
		),'sales_category_name');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_sales_category',array(
			'fd' => array(
				'sales_category_id' => array('type' => 'auto','nullable' => False),
				'cost_of_sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_category_id'),
			'fk' => array('parent_category_id' => 'perp_sales_category.sales_category_id','cost_of_sales_gl_account' => 'perp_account.account_id','sales_gl_account' => 'perp_account.account_id'),
			'ix' => array('sales_category_id'),
			'uc' => array('sales_category_id')
		),'abbreviation');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_sales_category','sales_category_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_sales_category',array(
			'fd' => array(
				'sales_category_id' => array('type' => 'int','precision' => '4'),
				'cost_of_sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_gl_account' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('sales_category_id'),
			'fk' => array('sales_category_id' => 'egw_categories.cat_id','cost_of_sales_gl_account' => 'perp_account.account_id','sales_gl_account' => 'perp_account.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.043';
	}


	$test[] = '0.1.043';
	function perp_orders_upgrade0_1_043()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_price_list','currency',array(
			'type' => 'varchar',
			'precision' => '3',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_price_list',array(
			'fd' => array(
				'price_list_id' => array('type' => 'auto','nullable' => False),
				'price_list_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
				'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'sales_area_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'effective_from' => array('type' => 'date','nullable' => False),
				'effective_to' => array('type' => 'date'),
				'sales_type_id' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('price_list_id'),
			'fk' => array('currency' => 'perp_currency.currency_id','sales_category_id' => 'perp_sales_category.sales_category_id','sales_area_id' => 'perp_sales_area.sales_area_id','sales_type_id' => 'perp_sales_type.sales_type_id'),
			'ix' => array('price_list_id','sales_category_id','sales_area_id','sales_type_id'),
			'uc' => array('price_list_id')
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.044';
	}


	$test[] = '0.1.044';
	function perp_orders_upgrade0_1_044()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_price_list','price_list_title',array(
			'type' => 'varchar',
			'precision' => '50'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.045';
	}


	$test[] = '0.1.045';
	function perp_orders_upgrade0_1_045()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_build_option_price','price',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'default' => '0'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.046';
	}


	$test[] = '0.1.046';
	function perp_orders_upgrade0_1_046()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_price_list','order_by',array(
			'type' => 'varchar',
			'precision' => '50',
			'nullable' => False,
			'default' => 'stock_num'
		));
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_price_list','sort',array(
			'type' => 'int',
			'precision' => '1',
			'nullable' => False,
			'default' => '1'
		));

		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.1.047';
	}

	$test[] = '0.1.047';
	function perp_orders_upgrade0_1_047()
	{
		if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
			// These tables need to be InnoDB
			$transaction_tables = array(
				'perp_sales_order',
				'perp_sales_order_detail',
				'perp_sales_order_work_order'
			);
			$so_perp_api = CreateObject('perp_api.so_perp_api');
			$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_orders', $transaction_tables);
		}
		return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2';
	}


function perp_orders_upgrade0_2()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_price','price_list_id',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_price','stock_id',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_price','effective_date',array(
		'type' => 'timestamp',
		'nullable' => False
	));*/
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_price','modified_by',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False
	));*/
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_price','modified_date',array(
		'type' => 'timestamp',
		'nullable' => False,
		'default' => 'current_timestamp'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_price',array(
		'fd' => array(
			'price_list_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'effective_date' => array('type' => 'timestamp','nullable' => False),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'modified_date' => array('type' => 'timestamp','nullable' => False,'default' => 'current_timestamp')
		),
		'pk' => array('price_list_id','stock_id'),
		'fk' => array('price_list_id' => 'perp_price_list.price_list_id','stock_id' => 'perp_stock.stock_id','modified_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.001';
}


function perp_orders_upgrade0_2_001()
{

	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_price',array(
		'fd' => array(
			'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'effective_date' => array('type' => 'timestamp','nullable' => False),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'modified_date' => array('type' => 'timestamp','nullable' => False,'default' => 'current_timestamp')
		),
		'pk' => array('price_list_id','stock_id','effective_date'),
		'fk' => array('price_list_id' => 'perp_price_list.price_list_id','stock_id' => 'perp_stock.stock_id','modified_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));


	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_build_option_price',array(
		'fd' => array(
			'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'effective_date' => array('type' => 'timestamp'),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'modified_date' => array('type' => 'timestamp','nullable' => False,'default' => 'current_timestamp')
		),
		'pk' => array('build_option_id','stock_id','price_list_id','effective_date'),
		'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id','price_list_id' => 'perp_price_list.price_list_id','effective_date' => 'current_timestamp','modified_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));

	$GLOBALS['egw_setup']->oProc->query('UPDATE perp_price
		JOIN perp_price_list ON
			perp_price_list.price_list_id = perp_price.price_list_id
		SET perp_price.effective_date = perp_price_list.effective_from, perp_price.modified_date = perp_price_list.effective_from
		WHERE perp_price.effective_date IS NULL 
	');
	$GLOBALS['egw_setup']->oProc->query('UPDATE perp_build_option_price
		JOIN perp_price_list ON
			perp_price_list.price_list_id = perp_build_option_price.price_list_id
		SET perp_build_option_price.effective_date = perp_price_list.effective_from, perp_build_option_price.modified_date = perp_price_list.effective_from
		WHERE perp_build_option_price.effective_date IS NULL 
	');

	$GLOBALS['egw_setup']->oProc->DropColumn('perp_price_list',array(
		'fd' => array(
			'price_list_id' => array('type' => 'auto','nullable' => False),
			'price_list_name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'currency' => array('type' => 'varchar','precision' => '3','nullable' => False),
			'sales_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'sales_area_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'effective_to' => array('type' => 'date'),
			'sales_type_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'price_list_title' => array('type' => 'varchar','precision' => '50'),
			'order_by' => array('type' => 'varchar','precision' => '50','nullable' => False,'default' => 'stock_num'),
			'sort' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '1')
		),
		'pk' => array('price_list_id'),
		'fk' => array('currency' => 'perp_currency.currency_id','sales_category_id' => 'perp_sales_category.sales_category_id','sales_area_id' => 'perp_sales_area.sales_area_id','sales_type_id' => 'perp_sales_type.sales_type_id'),
		'ix' => array('price_list_id','sales_category_id','sales_area_id','sales_type_id'),
		'uc' => array('price_list_id')
	),'effective_from');

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.007';
}

function perp_orders_upgrade0_2_007()
{
	// Repair damaged work order details
	$GLOBALS['egw_setup']->oProc->query("
	INSERT INTO perp_sales_order_work_order (order_id, line_no, detail_no, quantity, work_order_detail_id) 
	SELECT order_id, line_no, detail_no, 1, 1
	FROM perp_order_detail
	WHERE 
		detail_class = 'WorkOrderDetail' AND
		(order_id,line_no, detail_no) NOT IN (
			SELECT order_id, line_no, detail_no
			FROM perp_sales_order_work_order
		)
	");

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.008';
}

function perp_orders_upgrade0_2_008()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_stock_kit_price',array(
		'fd' => array(
			'price_list_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'component_id' => array('type' => 'int','precision' => '4'),
			'effective_date' => array('type' => 'timestamp'),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'modified_date' => array('type' => 'timestamp','nullable' => False),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('price_list_id','stock_id','component_id','effective_date'),
		'fk' => array('price_list_id' => 'perp_price_list.price_list_id','stock_id' => 'perp_stock.stock_id','component_id' => 'perp_stock.stock_id','modified_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.009';
}

function perp_orders_upgrade0_2_009()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_price_calculation',array(
		'fd' => array(
			'id' => array('type' => 'auto','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'calculation' => array('type' => 'text','nullable' => False),
			'variable_prompt' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('id'),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	));

	$GLOBALS['egw_setup']->oProc->query("INSERT INTO egw_acl (acl_appname, acl_location, acl_account, acl_rights) VALUES ('perp_orders', 'calculation', 0,15)");

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.010';
}



// Force tables to InnoDB
so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_orders');

function perp_orders_upgrade0_2_010()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_stock_kit_price','kit_stock_id',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_stock_kit_price',array(
		'fd' => array(
			'price_list_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'kit_stock_id' => array('type' => 'int','precision' => '4'),
			'component_id' => array('type' => 'int','precision' => '4'),
			'effective_date' => array('type' => 'timestamp'),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'modified_date' => array('type' => 'timestamp','nullable' => False),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('price_list_id','stock_id','component_id','effective_date','kit_stock_id'),
		'fk' => array('price_list_id' => 'perp_price_list.price_list_id','stock_id' => 'perp_stock.stock_id','component_id' => 'perp_stock.stock_id','modified_by' => 'egw_accounts.account_id','kit_stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.011';
}


function perp_orders_upgrade0_2_011()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_build_option_price','component',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_build_option_price',array(
		'fd' => array(
			'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'effective_date' => array('type' => 'timestamp'),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'modified_date' => array('type' => 'timestamp','nullable' => False,'default' => 'current_timestamp'),
			'component' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('build_option_id','stock_id','price_list_id','effective_date','component'),
		'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id','price_list_id' => 'perp_price_list.price_list_id','effective_date' => 'current_timestamp','modified_by' => 'egw_accounts.account_id','component' => 'perp_allowed_build_option.component'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.012';
}


function perp_orders_upgrade0_2_012()
{
	$GLOBALS['egw_setup']->oProc->RenameColumn('perp_build_option_price','component','parent_component_id');
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_build_option_price',array(
		'fd' => array(
			'build_option_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'price_list_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'price' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'effective_date' => array('type' => 'timestamp'),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'modified_date' => array('type' => 'timestamp','nullable' => False,'default' => 'current_timestamp'),
			'parent_component_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('build_option_id','stock_id','price_list_id','effective_date','parent_component_id'),
		'fk' => array('build_option_id' => 'perp_build_option.build_option_id','stock_id' => 'perp_allowed_build_option.stock_id','price_list_id' => 'perp_price_list.price_list_id','effective_date' => 'current_timestamp','modified_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.013';
}


function perp_orders_upgrade0_2_013()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_sales_order_work_order','quantity_returned',array(
		'type' => 'decimal',
		'precision' => '20',
		'scale' => '3',
		'nullable' => False,
		'default' => '0'
	));

	return $GLOBALS['setup_info']['perp_orders']['currentver'] = '0.2.014';
}

