<?php


	/**
	*	A percentage.
	*/

	require_once(EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.Calculation.inc.php');

	class Percent extends Calculation {

		// Options include PayStubEntryTypes, so cache it instead of reloading every time
		protected static $options = array();

		public static function getName() {
			return 'Percentage';
		}

		public static function calculate(PaystubLine &$line, $value) {
			$lines = $line->get_paystub()->get_lines(explode(',',$value['types']));

			$base = 0;
			foreach($lines as $line) {
				$base += $line->get_amount();
			}
			$result = round(($value['percent'] / 100) * $base, 2);
			return $result;	
		}

		public static function getTemplate() {
			return 'perp_payroll.DeductionValue.percent';
		}

		public static function getOverrideTemplate() {
			return 'perp_payroll.DeductionValue.percent';
		}

		public static function getOptions() {
			if(!self::$options) {
				self::$options = array(
					'types'		=>	ExecMethod('perp_payroll.bo_perp_payroll.get_line_types')
				);
			}
			return self::$options;
		}
	}
?>
