<?php


	/**
	*	A total = Earnings - Taxes - Employee Deductions 
	*	The value contains the line types to add, which will be added or deducted as appropriate.
	*	Employer contributions and accrual accumulations (if accidentally included) do not contribute to the total either way.
	*/

	require_once(EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.Calculation.inc.php');

	class Total extends Calculation {

		// Options include PayStubEntryTypes, so cache it instead of reloading every time
		protected static $options = array();

		public static function getName() {
			return 'Total';
		}

		public static function calculate(PaystubLine &$line, $value) {
			$lines =& $line->get_paystub()->get_lines(explode(',',$value['types']));
			$total = 0;
			foreach($lines as &$_line) {
				switch (get_class($_line->get_type())) {
					case 'EarningType':
					case 'TotalType':
						$total += $_line->get_amount();
						break;
					case 'DeductionType':
						if($_line->get_type()->get_type() != DeductionType::EMPLOYER) {
							$total -= $_line->get_amount();
						}
						break;
				}
			}
			return round($total, 2);
		}

		public static function getTemplate() {
			return 'perp_payroll.DeductionValue.source_lines';
		}

		public static function getOverrideTemplate() {
			return false;
		}

		public static function getOptions() {
			if(count(self::$options) == 0) {
				self::$options = array(
					'types'		=>	ExecMethod('perp_payroll.bo_perp_payroll.get_line_types')
				);
			}
			return self::$options;
		}
	}
?>
