<?php
	/**
	*	BO layer for dealing with tax rates
	*/
	
	class bo_perp_rate {
		
		/**
		*	Get a list of tax rates
		*
		*	@nextmatch
		*/
		public static function rate_list(&$query = array(), &$rows = array(), &$readonly = array()) {
			if(!$query['order']) {
				$query['order'] = 'country, region, locality, effective_date, income, rate, constant';
			}
			
			$rows = so_perp_rate::get_rates($query);

			return $query['total'];
		}

		/**
		*	Get header filters for rates 
		*/
		public static function get_header_filters() {
			return so_perp_rate::get_header_filters();
		}

		/**
		*	Get a particular rate, according to the settings
		*
		*	- effective_date
		*	- [maximum] income
		*	- country
		*	- region
		*	- locality
		*/
		public static function get_rate($query) {
			if(!$query['effective_date']) {
				throw new egw_exception_wrong_userinput(lang('Missing effective date'));
			}
			return so_perp_rate::get_rate($query);
		}

		public static function set_rate($rate_info) {
			if(!$rate_info['country']) {
				throw new egw_exception_wrong_userinput(lang('Missing country'));
			}
			if(!$rate_info['effective_date']) {
				throw new egw_exception_wrong_userinput(lang('Missing effective date'));
			}
			return so_perp_rate::set_rate($rate_info);
		}

		public static function delete_rate($rate_info) {
			return so_perp_rate::delete_rate($rate_info);
		}
	}
?>
