<?php

	class hook_perp_payroll {

		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
			'admin_hook'	=>	True,
			'earning_type'	=>	true,
		);

		var $appname = 'perp_payroll';
		private $erp;
		public function __construct() {
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file = array(
				'Site configuration'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_payroll.hook_perp_payroll.config',
				)),
				'Configure Access Permissions'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_payroll.hook_perp_payroll.acl',
				)),
				'Pay schedules'		=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_payroll.ui_perp_pay_schedule.schedule_list',
				)),
				'Pay stub entry types'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_payroll.ui_perp_pay_stub_entry_type.type_list'
				)),
				'Tax Rates'		=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_payroll.ui_perp_rate.rate_list'
				)),
			);

			display_section($this->appname, $file);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences']            = $GLOBALS['egw']->link('/preferences/preferences.php','appname='.$this->appname);

			//Do not modify below this line
			display_section($this->appname,$this->appname,$file);
		}

		public function user_preferences() {
		}

		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			$menu = array();
			if($GLOBALS['egw']->acl->check('stock', EGW_ACL_READ, 'perp_payroll')) {
			//	$menu['Stock List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_payroll.ui_perp_stock.stock_list');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
				
			$menu_title = lang('Actions');
			$menu = array();
			if($GLOBALS['egw']->acl->check('inventory', EGW_ACL_EDIT, 'perp_payroll')) {
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
		}

		public function config($content = array()) {
			$groups = ExecMethod('perp_ledger.bo_perp_ledger.get_account_groups');
			$selects['PayStubEntryType_debit_group'] = $groups;
			$selects['PayStubEntryType_credit_group'] = $groups;
			$selects['DeductionType_debit_group'] = $groups;
			$selects['DeductionType_credit_group'] = $groups;
			$selects['AccrualType_debit_group'] = $groups;
			$selects['AccrualType_credit_group'] = $groups;

			$this->erp->config($content, $this->appname, 'perp_payroll.hook_perp_payroll.config',$selects, '', $data);
		}

		public function acl($content = array()) {
			$data = $this->erp->acl($content, 'perp_payroll', 'acl', 'acl', $selects, $filters);
		}

		public function home($args = null) {
_debug_array($args);
		}

		/*	search_link is for linking (link widget)
		*/
		public function search_link($params) {

			return array(
				'query'	=>	'perp_payroll.bo_perp_payroll.link_query',
				'title'	=>	'perp_payroll.bo_perp_payroll.link_title',
				'view'	=>	array('menuaction'=>'perp_payroll.ui_perp_payroll.link_view'),
				'view_id'	=>	'link_id',
			//	'add'	=>	array('menuaction' => 'perp_payroll.ui_perp_location.location_new'),
			//	'add_id'	=>	'location_id',
			//	'add_app'	=>	'perp_payroll',
			//	'add_popup'	=>	'750x550',
			);

		}

		/**
		*	Edit earning types (Regular, Overtime, Stat)
		*/
		public function earning_type($content = array()) {
			require_once('class.Paystub.inc.php');
			$selects['pay_type'] = Paystub::$pay_type;
			$this->erp->change_lookup($content, 'perp_payroll', 'earning_type', 'earning_type', $selects);
		}
	}
?>
