<?php

	class so_perp_payroll {
		
		public function __construct() {
		}


		public function get_earning_types(&$query) {
			$where = array();
			if($query['pay_type']) {
				$where[] = 'pay_type = ' . $GLOBALS['egw']->db->quote($query['pay_type']);
			}

			// Get number of rows
			$GLOBALS['egw']->db->select(
				'perp_earning_type',
				array('count(type_id) AS count'),
				$where,
				__LINE__, __FILE__, 0, '',
				'perp_payroll'
			);
			if($row = $GLOBALS['egw']->db->row(true)) {
				$query['count'] = $row['count'];
			}

			// Get data
			$GLOBALS['egw']->db->select(
				'perp_earning_type',
				array('*'),
				$where,
				__LINE__, __FILE__, $query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'],
				'perp_payroll', $query['num_rows'],
				'JOIN perp_pay_stub_entry_type ON
					perp_pay_stub_entry_type.type_id = perp_earning_type.type_id'
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$list[] = $row;
			}
			return $list;
		}

		public function get_staff_data($staff_id) {
			$GLOBALS['egw']->db->select(
				'perp_staff_pay_detail',
				array('*'),
				array('staff_id'	=>	$staff_id),
				__LINE__, __FILE__, 0,
				'', 'perp_payroll'
			);
			if($row = $GLOBALS['egw']->db->row(true)) {
				return $row;
			}
		}

		/**
		*	Get a list of pay periods
		*/
		public function get_pay_periods(&$query) {
			$where = array();

			// Get result count
			$GLOBALS['egw']->db->select(
				'perp_pay_period',
				array('count(pay_period_id) AS count'),
				$where,
				__LINE__, __FILE__, 0,
				'', 'perp_payroll', 1
			);
			$row = $GLOBALS['egw']->db->row(true);
			$query['count'] = $row['count'];

			$GLOBALS['egw']->db->select(
				'perp_pay_period',
				array('*'),
				$where,
				__LINE__, __FILE__, $query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'],
				'perp_payroll', $query['num_rows']
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$row['start_date'] = $GLOBALS['egw']->db->from_timestamp($row['start_date']);
				$row['end_date'] = $GLOBALS['egw']->db->from_timestamp($row['end_date']);
				$row['transaction_date'] = $GLOBALS['egw']->db->from_timestamp($row['transaction_date']);
				$list[] = $row;
			}
			return $list;
		}

		/**
		*	Get a list of pay stubs
		*
		*	@param query array of query parameters
		*	@nextmatch
		*/
		public function get_paystubs(&$query) {
			$where = array();
			if($query['pay_period_id']) {
				$where['pay_period_id'] = (int)$query['pay_period_id'];
			}
			if($query['staff_id']) {
				$where[] = 'perp_pay_stub.staff_id = ' . (int)$query['staff_id'];
			}

			$join = 'JOIN perp_staff ON
				perp_staff.staff_id = perp_pay_stub.staff_id
			JOIN egw_addressbook ON
				egw_addressbook.contact_id = perp_staff.addressbook_id';

			// Get result count
			$GLOBALS['egw']->db->select(
				'perp_pay_stub',
				array('count(' . ($query['pay_period_id'] ? 'perp_pay_stub.pay_period_id' : 'perp_pay_stub.staff_id') . ') AS count'),
				$where,
				__LINE__, __FILE__, 0,
				'', 'perp_payroll', 1,
				$join
			);
			$row = $GLOBALS['egw']->db->row(true);
			$query['count'] = $row['count'];

			$GLOBALS['egw']->db->select(
				'perp_pay_stub',
				array('*'),
				$where,
				__LINE__, __FILE__, $query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'],
				'perp_payroll', $query['num_rows'],
				$join
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$list[] = $row;
			}
			return $list;
		}

		/**
		*	Get a list of pay stub amendments
		*/
		public function get_pay_amendments(&$query) {
			$where = array();
			if($query['pay_period_id']) {
				$where['pay_period_id'] = (int)$query['pay_period_id'];
			}
			if($query['staff_id']) {
				$where[] = 'perp_pay_amendment.staff_id = ' . (int)$query['staff_id'];
			}
			if($query['type_id']) {
				$where['type_id'] = (int)$query['type_id'];
			}


			// Get result count
			$GLOBALS['egw']->db->select(
				'perp_pay_amendment',
				array('count(amendment_id) AS count'),
				$where,
				__LINE__, __FILE__, 0,
				'', 'perp_payroll', 1,
				$join
			);
			if($row = $GLOBALS['egw']->db->row(true)) {
				$query['count'] = $row['count'];
			}

			// Get data
			$GLOBALS['egw']->db->select(
				'perp_pay_amendment',
				array('*') + explode(',', $query['selectcols']),
				$where,
				__LINE__, __FILE__, $query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'],
				'perp_payroll', $query['num_rows'],
				$join
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$list[] = $row;
			}
			return $list;
		}
	}
?>
