<?php

	require_once( EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.bo_perp_payroll.inc.php');

	class ui_perp_payroll {
		private $bo;
		private $template;
		public $public_functions = array(
			'index'		=>	True,
			'link_view'	=>	True,
		);

		private $debug = false;

		/**
		*	Array of messages for the user
		*/
		private $messages = array();

		function ui_perp_payroll() {
			$this->template = CreateObject('etemplate.etemplate');
			$this->bo = new bo_perp_payroll();
		}

		function index($content = array()) {
			if($this->debug) {
				echo __METHOD__ . '() incoming:<br />';
				_debug_array($content);
			}

			$pay_period = $GLOBALS['egw']->acl->check('pay_period', EGW_ACL_READ, 'perp_payroll');
			$amendment = $GLOBALS['egw']->acl->check('amendment', EGW_ACL_READ, 'perp_payroll');

			if(isset($content['pay_period']) && $pay_period) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_payroll.ui_perp_pay_period.period_list'));
			} elseif (isset($content['amendment']) && $amendment) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_payroll.ui_perp_pay_amendment.amendment_list'));
			}

			if($pay_period) {
				$this->get_stub_log($this->messages);
			}

			$readonly['pay_period'] = !$pay_period;
			$readonly['amendment'] = !$amendment;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}

			// Display
			$this->template->read('perp_payroll.index');
			$this->template->exec('perp_payroll.ui_perp_payroll.index', $data, $select_box_options, $readonly, $preserve);

		}

		public function link_view() {
			$link = $_GET['link_id'];
			list($location, $id) = explode('-', $link);
			if($id) {
				switch($location) {
					case 'STAFF':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_payroll.ui_perp_staff.saff_edit', 
								'staff_id'	=>	$id
							)
						);
						break;
					case 'DEPARTMENT':
						$GLOBALS['egw']->redirect_link(
							'/index.php', 
							array(
								'menuaction'	=>	'perp_payroll.ui_perp_department.department_edit', 
								'department_id'	=>	$id
							)
						);
						break;
				}
			}
		}

		/**
		*	Get a list of log messages from creating pay stubs
		*	Only shows errors from last stub creation attempt.
		*
		*/
		public function get_stub_log(&$message_array) {
			$config = config::read('perp_payroll');

			$query = array(
				'where'	=>	array(
					'log_date >= ' . $GLOBALS['egw']->db->quote($GLOBALS['egw']->db->to_timestamp($config['last_create_paystub_date'])),
					'log_app = ' . $GLOBALS['egw']->db->quote('perp_payroll'),
					'log_msg_code IN (\'Paystub\', \'Payperiod\')',
					'log_msg_severity IN (\'I\', \'W\', \'E\')',
				)
			);
			$log = ExecMethod('admin.bolog.get_error', $query);
			$severity = array(
				'I'	=>	'info',
				'W'	=>	'warning',
				'E'	=>	'error'
			);
			foreach($log as $entry) {
				$message_array[] = array(
					$entry['log_msg_msg']['value'],
					$severity[$entry['log_msg_severity']['value']],
				);
			}
			return $log;
		}

	}
?>
