<?php

	/**
	*	UI for viewing/setting [income] tax rates
	*
	*/

	class ui_perp_rate {

		public $public_functions = array(
			'rate_list'	=>	true
		);

		protected static $template;

		public function __construct() {
			if(!is_object(self::$template)) {
				self::$template = new etemplate();
			}
		}

		public function rate_list($content = array()) {
			if($this->debug) {
				echo __METHOD__ . '() incoming:<br />';
				_debug_array($content);
			}

			// Deal with incoming
			if ($content['cancel']) {
				$GLOBALS['egw']->redirect($GLOBALS['egw']->link('/admin/index.php'));
			} elseif ($content['add']['add']) {
				try {
					bo_perp_rate::set_rate($content['add']);
				} catch (Exception $e) {
					$this->messages[] = array($e->getMessage(), 'error');
				}
			} elseif ($content['nm']['rows']['delete']) {
				try {
					$result = bo_perp_rate::delete_rate(explode(',', key($content['nm']['rows']['delete'])));
				} catch (Exception $e) {
					$this->messages[] = array($e->getMessage(), 'error');
				}
				if($result === true) {
					$this->messages[] = array(lang('Rate removed'), 'success');
				} else {
					$this->messages[] = array(lang('Unable to remove rate'), 'error');
				}
			}

			// Read data for display
			$data['nm'] = $GLOBALS['egw']->session->appsession('tax_rate_list', 'perp_payroll');
			if(!is_array($data['nm'])) {
				$data['nm'] = array(
					'no_cat'        =>      true,
					'no_filter'     =>      true,
					'no_filter2'    =>      true,
					'template'      =>      'perp_payroll.rate_list.row',
					'get_rows'      =>      'perp_payroll.ui_perp_rate.get_rows'
				);
			}

			// Default add to most popular choice(s)
			$filters = bo_perp_rate::get_header_filters();
			foreach($filters as $name => $list) {
				$data['add'][$name] = key($list);
			}
			$preserve = $data;

			if(count($this->messages) > 0) {
				$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
			}
			$GLOBALS['egw_info']['flags']['app_header'] = lang('Tax Rates');
			self::$template->read('perp_payroll.rate_list');
			self::$template->exec('perp_payroll.' . __CLASS__ . '.' . __FUNCTION__, $data, $select_box_options, $readonly, $preserve);
		}

		/**
		*	UI layer to preserve search settings
		*/
		public function get_rows(&$query = array(), &$rows = array(), &$readonly = array()) {
			$GLOBALS['egw']->session->appsession('tax_rate_list', 'perp_payroll', $query);

			// Get values for filter headers
			$filters = bo_perp_rate::get_header_filters();

			$count = bo_perp_rate::rate_list($query, $rows, $readonly);

			foreach($filters as $name => $list) {
				//$query['options-' . $name] = $list;
				$rows['sel_options'][$name] = $list;
			}
			return $count;
		}
	}
?>
