<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.bo_perp_payroll.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.Paystub.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.PayPeriod.inc.php');

	/**
	*	Summary of all Paystub entry types, totalled.  Also includes every paystub, but not in as nice a format as the paystub report
	*/

	class payroll_summary extends perp_report {

		public function __construct(array $parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_payroll';
			parent::perp_report($parameters);
			$this->template = 'payroll_summary.odt';

			$this->parameters = $parameters;
			$this->parameters['options-pay_period_id'] = ExecMethod('perp_payroll.bo_perp_payroll.get_pay_periods');
		}

		public function get_data($query = array()) {
			$bo_payroll = new bo_perp_payroll();
			$pay_period = new PayPeriod($query['pay_period_id']);
			$entry_types = $bo_payroll->get_line_types();

			$pay_period_array = $pay_period->toArray();
			$pay_period_array['start_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $pay_period_array['start_date']);
			$pay_period_array['end_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $pay_period_array['end_date']);
			$pay_period_array['transaction_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $pay_period_array['transaction_date']);

			$query['order'] = 'n_family, n_given';
			$stubs = $pay_period->get_paystubs($query);
			$lines = array();
			$GLOBALS['paystub_report'] = array(
				'employer'	=>	$employer,
				'pay_period'	=>	$pay_period,
				'pay_period_array'	=>	$pay_period_array,
				'stubs1'		=>	$stubs,
			);

			if($query['include_paystubs']) {
				$data['stubs'] =& $stubs;
			} else {
				$data['stubs'] = array();
			}

			$amend_query = array(
				'pay_period_id'	=>	$query['pay_period_id'],
				'num_rows'	=>	-1
			);
			$bo_payroll->get_pay_amendments($amend_query, $data['amendment']);
			foreach($data['amendment'] as &$amendment) {
				$staff =& new Staff($amendment['staff_id']);
				$address = ExecMethod('addressbook.addressbook_bo.read', $staff->get_addressbook_id());
				$amendment['staff_name'] = $address['n_fn'];
				$amendment['entry_name'] = $entry_types[$amendment['type_id']];
				$amendment['amount'] = $amendment['rate'] * $amendment['quantity'];
			}

			// PayStubEntryType Summary
			$bo_payroll->get_line_types(array('template'=>false, num_rows=>-1), $summary_lines);
			foreach($summary_lines as $line) {
				$type = PayStubEntryType::factory($line['type_id']);
				$data['summary_lines'][$line['type_id']] = $type->toArray();
				$data['summary_lines'][$line['type_id']] += array(
					'quantity'	=>	false,
					'amount'	=>	0,
					'ytd_amount'	=>	0,
				);
				if($data['summary_lines'][$line['type_id']]['type']) {
					$data['summary_lines'][$line['type_id']]['type_name'] = lang(DeductionType::$type_array[$type->get_type()]);
				}

			}

			// PayStubEntryType extending class summary
			$classes = array(
				'EarningType', 
				'AccrualType', 
				'DeductionType', 
				'DeductionType-D', 
				'DeductionType-C', 
				'DeductionType-T'
			);
			foreach($classes as $class) {
				$data['class_summary'][$class] = array(
					'name'		=>	lang(substr($class, 0, -4)),
					'amount'	=>	0,
				);
			}

			// Pay stub detail
			foreach($stubs as $key => $stub) {
				$data['staff-' . $key] = new Staff($stub->get_staff_id());
				$staff_info[$key] = ExecMethod('addressbook.addressbook_bo.read', $data['staff-' . $key]->get_addressbook_id());
				$data['stub-' . $key] = $stub->toArray();
				
				$lines =& $stub->get_lines();
				foreach($lines as $num => $line) {
					$line_array =& $line->toArray();
					$data['lines-' . $key][$num] = $line_array;
					$data['summary_lines'][$line->get_type()->get_id()]['quantity'] += $line->get_quantity();
					$data['summary_lines'][$line->get_type()->get_id()]['amount'] += $line->get_amount();
					$data['summary_lines'][$line->get_type()->get_id()]['ytd_amount'] += $line_array['ytd_amount'];

					if($data['class_summary'][get_class($line->get_type())]) {
						$data['class_summary'][get_class($line->get_type())]['amount'] += $line->get_amount();
						if(get_class($line->get_type()) == 'DeductionType') {
							$deduction_key = 'DeductionType-' . $line->get_type()->get_type();
							$data['class_summary'][$deduction_key]['name'] = "\t".lang(DeductionType::$type_array[$line->get_type()->get_type()]);
							$data['class_summary'][$deduction_key]['amount'] += $line->get_amount();
						}
					}
				}
			}
//_debug_array($data['amendments']);
//die();
			$GLOBALS['paystub_report']['staff_info'] =& $staff_info;

			$this->filename = lang('Payroll Summary PP-%1', $this->parameters['pay_period_id']);

			return $data;
		}

		public function __destruct() {
		//	parent::__destruct();
			unset($GLOBALS['pay_stub_report']);
		}
	}
?>
