<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.Paystub.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.PayPeriod.inc.php');

	/**
	*	Paystubs in a pretty format you can take home to your wife.
	*/

	class paystub_report extends perp_report {

		public function __construct(array $parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_payroll';
			parent::perp_report($parameters);
			$this->template = 'paystub.odt';

			$this->parameters = $parameters;
			$this->parameters['options-pay_period_id'] = ExecMethod('perp_payroll.bo_perp_payroll.get_pay_periods');
		}

		public function get_data($query = array()) {
			$config = config::read('perp_payroll');

			$employer = ExecMethod('addressbook.addressbook_bo.read', $config['address']);
			$pay_period = new PayPeriod($this->parameters['pay_period_id']);
			$pay_period_array = $pay_period->toArray();
			$pay_period_array['start_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $pay_period_array['start_date']);
			$pay_period_array['end_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $pay_period_array['end_date']);
			$pay_period_array['transaction_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $pay_period_array['transaction_date']);
			$query = $this->parameters;
			$stubs = $pay_period->get_paystubs($query);
			$lines = array();
			$GLOBALS['paystub_report'] = array(
				'employer'	=>	$employer,
				'pay_period'	=>	$pay_period,
				'pay_period_array'	=>	$pay_period_array,
				'stubs1'		=>	$stubs,
			);
			$data['stubs'] =& $stubs;
			foreach($stubs as $key => $stub) {
				$data['staff-' . $key] = new Staff($stub->get_staff_id());
				$staff_info[$key] = ExecMethod('addessbook.addressbook_bo.read', $data['staff-' . $key]->get_addressbook_id());
				$data['stub-' . $key] = $stub->toArray();
				
				// paystub notes
				$data['notes-' . $key] = array();
				foreach( $data['stub-' . $key]['notes'] as $reference => $note ) {
					$data['notes-' . $key][$reference] = array(
						'reference'	=>	'',
						'note'		=>	$note
					);
				}
				$lines =& $stub->get_lines();
				foreach($lines as $num => $line) {
					if(!$this->parameters['include_employer_contributions']) {
						if($line->get_type() instanceof DeductionType && $line->get_type()->get_type() == DeductionType::EMPLOYER) {
							continue;
						}
					}
					$line_array =& $line->toArray();
					$line_array['note_keys'] = implode(' ', array_keys($line_array['notes']));
					foreach($line_array['notes'] as $reference => $note) {
						$data['notes-' . $key][$reference] = array(
							'reference'	=>	$reference,
							'note'		=>	$note
						);
					}
					$data['lines-' . $key][$num] = $line_array;
				}
			}
//_debug_array($data['lines-0']);
//die();
			$GLOBALS['paystub_report']['staff_info'] =& $staff_info;

			$this->filename = lang('Paystubs PP-%1', $this->parameters['pay_period_id']);

			// Logo
			$config = config::read('perp_api');
			$data['images'] = array();
			$data['images'][] = array(
				'name'	=>	'company_logo',
			) + $config['company_logo'];

			return $data;
		}

		public function __destruct() {
		//	parent::__destruct();
			unset($GLOBALS['pay_stub_report']);
		}
	}
?>
