<?php

	/**
	 * eGroupWare - Setup
	 * http://www.egroupware.org 
	 * Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de
	 *
	 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
	 * @package perp_payroll
	 * @subpackage setup
	 * @version $Id: class.db_tools.inc.php 21408 2006-04-21 10:31:06Z nelius_weiss $
	 */


$phpgw_baseline = array(
	'perp_earning_type' => array(
		'fd' => array(
			'type_id' => array('type' => 'int','precision' => '4'),
			'timesheet_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'rate_multiplier' => array('type' => 'decimal','precision' => '6','scale' => '3','nullable' => False,'default' => '1'),
			'pay_type' => array('type' => 'char','precision' => '1','nullable' => False,'default' => 'W')
		),
		'pk' => array('type_id'),
		'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_staff_pay_detail' => array(
		'fd' => array(
			'staff_id' => array('type' => 'int','precision' => '4'),
			'type_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'pay_rate' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
			'pay_unit' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'h'),
			'effective_date' => array('type' => 'date')
		),
		'pk' => array('staff_id','effective_date'),
		'fk' => array('staff_id' => 'perp_staff.staff_id','type_id' => 'perp_earning_type.type_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_pay_period' => array(
		'fd' => array(
			'pay_period_id' => array('type' => 'auto','nullable' => False),
			'start_date' => array('type' => 'date','nullable' => False),
			'end_date' => array('type' => 'date','nullable' => False),
			'transaction_date' => array('type' => 'date','nullable' => False),
			'transaction_id' => array('type' => 'int','precision' => '4'),
			'reverted_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('pay_period_id'),
		'fk' => array('transaction_id' => 'perp_general_ledger.trans_id','reverted_id' => 'perp_general_ledger.trans_id'),
		'ix' => array(array('start_date','end_date')),
		'uc' => array()
	),
	'perp_pay_stub' => array(
		'fd' => array(
			'pay_period_id' => array('type' => 'int','precision' => '4'),
			'staff_id' => array('type' => 'int','precision' => '4'),
			'currency' => array('type' => 'char','precision' => '3','nullable' => False),
			'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
		),
		'pk' => array('pay_period_id','staff_id'),
		'fk' => array('pay_period_id' => 'perp_pay_stub.pay_stub_id','staff_id' => 'perp_staff.staff_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_pay_stub_note' => array(
		'fd' => array(
			'pay_period_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'entry_id' => array('type' => 'int','precision' => '4'),
			'note' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array(),
		'fk' => array('pay_period_id' => 'perp_pay_stub.pay_stub_id','staff_id' => 'perp_staff.staff_id','entry_id' => 'perp_pay_stub_entry.entry_id'),
		'ix' => array(array('pay_period_id','staff_id')),
		'uc' => array()
	),
	'perp_pay_stub_entry' => array(
		'fd' => array(
			'pay_period_id' => array('type' => 'int','precision' => '4'),
			'staff_id' => array('type' => 'int','precision' => '4'),
			'entry_id' => array('type' => 'int','precision' => '4'),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'type' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('pay_period_id','staff_id','entry_id'),
		'fk' => array('pay_period_id' => 'perp_pay_stub.pay_stub_id','staff_id' => 'perp_staff.staff_id','type' => 'perp_pay_stub_entry_type'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_pay_stub_entry_type' => array(
		'fd' => array(
			'type_id' => array('type' => 'auto','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'gl_credit_account' => array('type' => 'int','precision' => '4'),
			'gl_debit_account' => array('type' => 'int','precision' => '4'),
			'sort_order' => array('type' => 'int','precision' => '4'),
			'default_value' => array('type' => 'text'),
			'calculation' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'disabled' => array('type' => 'bool','nullable' => False,'default' => '0')
		),
		'pk' => array('type_id'),
		'fk' => array('gl_credit_account' => 'perp_account.account_id','gl_debit_account' => 'perp_account.account_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_pay_type_ytd' => array(
		'fd' => array(
			'type_id' => array('type' => 'int','precision' => '4'),
			'staff_id' => array('type' => 'int','precision' => '4'),
			'ytd_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'ytd_amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'first_pay_period' => array('type' => 'int','precision' => '4'),
			'last_pay_period' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('type_id','staff_id','first_pay_period'),
		'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id','staff_id' => 'perp_staff.staff_id','first_pay_period' => 'perp_pay_period.pay_period_id','last_pay_period' => 'perp_pay_period.pay_period_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_deduction_type' => array(
		'fd' => array(
			'type_id' => array('type' => 'int','precision' => '4'),
			'deduction_type' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
			'calculation' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'value' => array('type' => 'text')
		),
		'pk' => array('type_id'),
		'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_staff_entry_type' => array(
		'fd' => array(
			'staff_id' => array('type' => 'int','precision' => '4'),
			'type_id' => array('type' => 'int','precision' => '4'),
			'value' => array('type' => 'text')
		),
		'pk' => array('staff_id','type_id'),
		'fk' => array('staff_id' => 'perp_staff.staff_id','type_id' => 'perp_deduction_type.type_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_accrual_type' => array(
		'fd' => array(
			'type_id' => array('type' => 'int','precision' => '4'),
			'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'minimum' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
			'maximum' => array('type' => 'decimal','precision' => '20','scale' => '3'),
			'under_min' => array('type' => 'int','precision' => '4'),
			'over_max' => array('type' => 'int','precision' => '4'),
			'base_types' => array('type' => 'text','nullable' => False),
			'draw_type' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('type_id'),
		'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id','draw_type' => 'perp_pay_stub_entry_type.type_id'),
		'ix' => array('draw_type'),
		'uc' => array()
	),
	'perp_accrual_breakpoint' => array(
		'fd' => array(
			'type_id' => array('type' => 'int','precision' => '4'),
			'service_length' => array('type' => 'int','precision' => '4'),
			'service_units' => array('type' => 'char','precision' => '1'),
			'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
		),
		'pk' => array('type_id','service_length','service_units'),
		'fk' => array('type_id' => 'perp_accrual_type.type_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_staff_accrual' => array(
		'fd' => array(
			'staff_id' => array('type' => 'int','precision' => '4'),
			'type_id' => array('type' => 'int','precision' => '4'),
			'balance' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
			'accrues' => array('type' => 'bool','nullable' => False,'default' => '1')
		),
		'pk' => array('staff_id','type_id'),
		'fk' => array('staff_id' => 'perp_staff.staff_id','type_id' => 'perp_accrual_type.type_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_pay_schedule' => array(
		'fd' => array(
			'schedule_id' => array('type' => 'int','precision' => '4'),
			'stub_delay_days' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '3'),
			'pay_delay_days' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '5')
		),
		'pk' => array('schedule_id'),
		'fk' => array('schedule_id' => 'egw_cal.cal_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_income_tax_rate' => array(
		'fd' => array(
			'country' => array('type' => 'char','precision' => '2','nullable' => False),
			'region' => array('type' => 'varchar','precision' => '5'),
			'locality' => array('type' => 'varchar','precision' => '10'),
			'effective_date' => array('type' => 'date','nullable' => False),
			'income' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
			'rate' => array('type' => 'decimal','precision' => '5','scale' => '3','nullable' => False),
			'constant' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False,'default' => '0')
		),
		'pk' => array(),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	),
	'perp_pay_amendment' => array(
		'fd' => array(
			'amendment_id' => array('type' => 'auto'),
			'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'pay_period_id' => array('type' => 'int','precision' => '4'),
			'type_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('amendment_id'),
		'fk' => array('staff_id' => 'perp_staff.staff_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_payroll_ledger' => array(
		'fd' => array(
			'transaction_id' => array('type' => 'int','precision' => '4'),
			'staff_id' => array('type' => 'int','precision' => '4'),
			'type_id' => array('type' => 'int','precision' => '4'),
			'pay_period_id' => array('type' => 'int','precision' => '4'),
			'entry_id' => array('type' => 'int','precision' => '4'),
			'amount' => array('type' => 'decimal','precision' => '20','scale' => '3')
		),
		'pk' => array('transaction_id','staff_id','type_id','pay_period_id','entry_id'),
		'fk' => array('transaction_id' => 'perp_general_ledger.trans_no','staff_id' => 'perp_staff.staff_id','type_id' => 'perp_pay_stub_entry.type_id','pay_period_id' => 'perp_pay_stub_entry.pay_period_id','entry_id' => 'perp_pay_stub_entry.entry_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_pay_period_staff' => array(
		'fd' => array(
			'pay_period_id' => array('type' => 'int','precision' => '4'),
			'staff_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('pay_period_id','staff_id'),
		'fk' => array('pay_period_id' => 'perp_pay_period.pay_period_id','staff_id' => 'perp_staff.staff_id'),
		'ix' => array(),
		'uc' => array()
	)
);
