<?php

	/**
	 * eGroupWare - Setup
	 * http://www.egroupware.org 
	 * Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de
	 *
	 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
	 * @package perp_payroll
	 * @subpackage setup
	 * @version $Id: class.db_tools.inc.php 23717 2007-04-29 14:25:19Z ralfbecker $
	 */


// Required to force tables to InnoDB
require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.so_perp_api.inc.php');

	$test[] = '0.0.000';
	function perp_payroll_upgrade0_0_000()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_earning_type',array(
			'fd' => array(
				'earning_type_id' => array('type' => 'auto'),
				'earning_type_name' => array('type' => 'varchar','precision' => '20','nullable' => False),
				'timesheet_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'rate_multiplier' => array('type' => 'decimal','precision' => '5','scale' => '3','nullable' => False,'default' => '1')
			),
			'pk' => array('earning_type_id'),
			'fk' => array(),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.001';
	}


	$test[] = '0.0.001';
	function perp_payroll_upgrade0_0_001()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_staff_pay_detail',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'pay_type' => array('type' => 'varchar','precision' => '1'),
				'pay_rate' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'pay_unit' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'h'),
			),
			'pk' => array('staff_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.002';
	}


	$test[] = '0.0.002';
	function perp_payroll_upgrade0_0_002()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_timecard','staff_id','user_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_timecard',array(
			'fd' => array(
				'user_id' => array('type' => 'int','precision' => '4'),
				'timestamp' => array('type' => 'timestamp')
			),
			'pk' => array('user_id','timestamp'),
			'fk' => array('user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.003';
	}


	$test[] = '0.0.003';
	function perp_payroll_upgrade0_0_003()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_pay_detail','staff_id','user_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_pay_detail',array(
			'fd' => array(
				'user_id' => array('type' => 'int','precision' => '4'),
				'pay_type' => array('type' => 'varchar','precision' => '1'),
				'pay_rate' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'pay_unit' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'h')
			),
			'pk' => array('user_id'),
			'fk' => array('user_id' => 'egw_accounts.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.004';
	}


	$test[] = '0.0.004';
	function perp_payroll_upgrade0_0_004()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_earning_type','pay_type',array(
			'type' => 'char',
			'precision' => '1',
			'nullable' => False,
			'default' => 'W'
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.005';
	}

	$test[] = '0.0.005';
	function perp_payroll_upgrade0_0_005() {
		$GLOBALS['egw_setup']->oProc->DropTable('perp_timecard');
		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.006';
	}


	$test[] = '0.0.006';
	function perp_payroll_upgrade0_0_006()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_period',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'auto'),
				'start_date' => array('type' => 'date','nullable' => False),
				'end_date' => array('type' => 'date','nullable' => False),
				'transaction_date' => array('type' => 'date','nullable' => False)
			),
			'pk' => array('pay_period_id'),
			'fk' => array(),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.007';
	}


	$test[] = '0.0.007';
	function perp_payroll_upgrade0_0_007()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_stub',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4'),
				'currency' => array('type' => 'char','precision' => '3','nullable' => False),
				'exchange_rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
			),
			'pk' => array('pay_period_id','staff_id'),
			'fk' => array('pay_period_id' => 'perp_pay_stub.pay_stub_id','staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.008';
	}


	$test[] = '0.0.008';
	function perp_payroll_upgrade0_0_008()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_stub_note',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4'),
				'entry_id' => array('type' => 'int','precision' => '4'),
				'note' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('pay_period_id','staff_id'),
			'fk' => array('pay_period_id' => 'perp_pay_stub.pay_stub_id','staff_id' => 'perp_staff.staff_id','entry_id' => 'perp_pay_stub_entry.entry_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.009';
	}


	$test[] = '0.0.009';
	function perp_payroll_upgrade0_0_009()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_stub_entry',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4'),
				'entry_id' => array('type' => 'int','precision' => '4'),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
				'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'type' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('pay_period_id','staff_id','entry_id'),
			'fk' => array('pay_period_id' => 'perp_pay_stub.pay_stub_id','staff_id' => 'perp_staff.staff_id','type' => 'perp_pay_stub_entry_type'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.010';
	}


	$test[] = '0.0.010';
	function perp_payroll_upgrade0_0_010()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_stub_entry_type',array(
			'fd' => array(
				'type_id' => array('type' => 'auto'),
				'name' => array('type' => 'varchar','precision' => '50','nullable' => False),
				'gl_credit_account' => array('type' => 'int','precision' => '4'),
				'gl_debit_account' => array('type' => 'int','precision' => '4'),
				'order' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('type_id' ),
			'fk' => array('gl_credit_account' => 'perp_account.account_id','gl_debit_account' => 'perp_account.account_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.011';
	}


	$test[] = '0.0.011';
	function perp_payroll_upgrade0_0_011()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_type_ytd',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4'),
				'ytd_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'ytd_amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
			),
			'pk' => array('type_id','staff_id'),
			'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id','staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.012';
	}


	$test[] = '0.0.012';
	function perp_payroll_upgrade0_0_012()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_deduction_type',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'deduction_type' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'E'),
				'calculation' => array('type' => 'varchar','precision' => '255','nullable' => False),
				'value' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('type_id'),
			'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.013';
	}


	$test[] = '0.0.013';
	function perp_payroll_upgrade0_0_013()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_staff_deduction',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'type_id' => array('type' => 'int','precision' => '4'),
				'value' => array('type' => 'decimal','precision' => '20','scale' => '3')
			),
			'pk' => array('staff_id','type_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id','type_id' => 'perp_deduction_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.014';
	}


	$test[] = '0.0.014';
	function perp_payroll_upgrade0_0_014()
	{
		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.015';
	}


	$test[] = '0.0.015';
	function perp_payroll_upgrade0_0_015()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_accrual_type','type_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_accrual_type','rate',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False,
			'default' => '0'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_accrual_type','minimum',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'default' => '0'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_accrual_type','maximum',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_accrual_type','under_min',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_accrual_type','over_max',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_accrual_type',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'minimum' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'maximum' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'under_min' => array('type' => 'int','precision' => '4'),
				'over_max' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('type_id'),
			'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.016';
	}


	$test[] = '0.0.016';
	function perp_payroll_upgrade0_0_016()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_accrual_breakpoint',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'service_length' => array('type' => 'int','precision' => '4'),
				'service_units' => array('type' => 'char','precision' => '1','nullable' => False),
				'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array('type_id','service_length'),
			'fk' => array('type_id' => 'perp_accrual_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.017';
	}


	$test[] = '0.0.017';
	function perp_payroll_upgrade0_0_017()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_staff_accrual',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('staff_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.018';
	}


	$test[] = '0.0.018';
	function perp_payroll_upgrade0_0_018()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff_accrual','type_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff_accrual','balance',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3',
			'nullable' => False,
			'default' => '0'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff_accrual','accrues',array(
			'type' => 'bool',
			'nullable' => False,
			'default' => '1'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_accrual',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'type_id' => array('type' => 'int','precision' => '4'),
				'balance' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'accrues' => array('type' => 'bool','nullable' => False,'default' => '1')
			),
			'pk' => array('staff_id','type_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id','type_id' => 'perp_accrual_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.019';
	}


	$test[] = '0.0.019';
	function perp_payroll_upgrade0_0_019()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_staff_pay_detail','effective_date',array(
			'type' => 'date',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.020';
	}


	$test[] = '0.0.020';
	function perp_payroll_upgrade0_0_020()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_pay_stub_entry_type','order','sort_order');

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.021';
	}


	$test[] = '0.0.021';
	function perp_payroll_upgrade0_0_021()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_pay_type_ytd','first_pay_period',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_pay_type_ytd','last_pay_period',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_pay_type_ytd',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4'),
				'ytd_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'ytd_amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'first_pay_period' => array('type' => 'int','precision' => '4','nullable' => False),
				'last_pay_period' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('type_id','staff_id'),
			'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id','staff_id' => 'perp_staff.staff_id','first_pay_period' => 'perp_pay_period.pay_period_id','last_pay_period' => 'perp_pay_period.pay_period_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.022';
	}


	$test[] = '0.0.022';
	function perp_payroll_upgrade0_0_022()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_pay_type_ytd','first_pay_period',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_pay_type_ytd',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4'),
				'ytd_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'ytd_amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'first_pay_period' => array('type' => 'int','precision' => '4'),
				'last_pay_period' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('type_id','staff_id','first_pay_period'),
			'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id','staff_id' => 'perp_staff.staff_id','first_pay_period' => 'perp_pay_period.pay_period_id','last_pay_period' => 'perp_pay_period.pay_period_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.023';
	}


	$test[] = '0.0.023';
	function perp_payroll_upgrade0_0_023()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_schedule',array(
			'fd' => array(
				'schedule_id' => array('type' => 'int','precision' => '4'),
				'stub_delay_days' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '3'),
				'pay_delay_days' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '5')
			),
			'pk' => array('schedule_id'),
			'fk' => array('schedule_id' => 'egw_cal.cal_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.024';
	}


	$test[] = '0.0.024';
	function perp_payroll_upgrade0_0_024()
	{
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_pay_period',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'auto'),
				'start_date' => array('type' => 'date','nullable' => False),
				'end_date' => array('type' => 'date','nullable' => False),
				'transaction_date' => array('type' => 'date','nullable' => False)
			),
			'pk' => array('pay_period_id'),
			'fk' => array(),
			'ix' => array(),
			'uc' => array(array('start_date','end_date'))
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.025';
	}


	$test[] = '0.0.025';
	function perp_payroll_upgrade0_0_025()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_earning_type','earning_type_id','type_id');
		$GLOBALS['egw_setup']->oProc->DropColumn('perp_earning_type',array(
			'fd' => array(
				'earning_type_id' => array('type' => 'auto'),
				'timesheet_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'rate_multiplier' => array('type' => 'decimal','precision' => '5','scale' => '3','nullable' => False,'default' => '1'),
				'pay_type' => array('type' => 'char','precision' => '1','nullable' => False,'default' => 'W')
			),
			'pk' => array('earning_type_id'),
			'fk' => array(),
			'ix' => array(),
			'uc' => array()
		),'earning_type_name');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_earning_type','type_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_earning_type','rate_multiplier',array(
			'type' => 'decimal',
			'precision' => '6',
			'scale' => '3',
			'nullable' => False,
			'default' => '1'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_earning_type',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'timesheet_category_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'rate_multiplier' => array('type' => 'decimal','precision' => '6','scale' => '3','nullable' => False,'default' => '1'),
				'pay_type' => array('type' => 'char','precision' => '1','nullable' => False,'default' => 'W')
			),
			'pk' => array('type_id'),
			'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.026';
	}


	$test[] = '0.0.026';
	function perp_payroll_upgrade0_0_026()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_pay_detail','user_id','staff_id');
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_pay_detail','pay_type','earning_type_name');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff_pay_detail','earning_type_name',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_pay_detail',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'earning_type_name' => array('type' => 'int','precision' => '4','nullable' => False),
				'pay_rate' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'pay_unit' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'h'),
				'effective_date' => array('type' => 'date','nullable' => False)
			),
			'pk' => array('staff_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id','earning_type_name' => 'perp_earning_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.027';
	}


	$test[] = '0.0.027';
	function perp_payroll_upgrade0_0_027()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_pay_detail','earning_type_name','earning_type');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_pay_detail',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'earning_type' => array('type' => 'int','precision' => '4','nullable' => False),
				'pay_rate' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'pay_unit' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'h'),
				'effective_date' => array('type' => 'date','nullable' => False)
			),
			'pk' => array('staff_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id','earning_type' => 'perp_earning_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.028';
	}


	$test[] = '0.0.028';
	function perp_payroll_upgrade0_0_028()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_staff_pay_detail','earning_type','type_id');
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_pay_detail',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'type_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'pay_rate' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'pay_unit' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'h'),
				'effective_date' => array('type' => 'date','nullable' => False)
			),
			'pk' => array('staff_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id','type_id' => 'perp_earning_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.029';
	}


	$test[] = '0.0.029';
	function perp_payroll_upgrade0_0_029()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_deduction_type','value',array(
			'type' => 'text'
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.030';
	}


	$test[] = '0.0.030';
	function perp_payroll_upgrade0_0_030()
	{
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff_deduction','value',array(
			'type' => 'text'
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.031';
	}


	$test[] = '0.0.031';
	function perp_payroll_upgrade0_0_031()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_income_tax_rate',array(
			'fd' => array(
				'country' => array('type' => 'char','precision' => '2','nullable' => False),
				'region' => array('type' => 'varchar','precision' => '5'),
				'locality' => array('type' => 'varchar','precision' => '10'),
				'effective_date' => array('type' => 'date','nullable' => False),
				'income' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'rate' => array('type' => 'decimal','precision' => '5','scale' => '3','nullable' => False),
				'constant' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False,'default' => '0')
			),
			'pk' => array(),
			'fk' => array(),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.032';
	}


	$test[] = '0.0.032';
	function perp_payroll_upgrade0_0_032()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_accrual_type','base_types',array(
			'type' => 'text',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.033';
	}


	$test[] = '0.0.033';
	function perp_payroll_upgrade0_0_033()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_pay_stub_entry_type','default_value',array(
			'type' => 'text'
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.034';
	}


	$test[] = '0.0.034';
	function perp_payroll_upgrade0_0_034()
	{
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_pay_stub_entry_type','calculation',array(
			'type' => 'varchar',
			'precision' => '255',
			'nullable' => False
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.035';
	}


	$test[] = '0.0.035';
	function perp_payroll_upgrade0_0_035()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_pay_period','transaction_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_pay_period',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'auto'),
				'start_date' => array('type' => 'date','nullable' => False),
				'end_date' => array('type' => 'date','nullable' => False),
				'transaction_date' => array('type' => 'date','nullable' => False),
				'transaction_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('pay_period_id'),
			'fk' => array('transaction_id' => 'perp_general_ledger.trans_id'),
			'ix' => array(),
			'uc' => array(array('start_date','end_date'))
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.036';
	}


	$test[] = '0.0.036';
	function perp_payroll_upgrade0_0_036()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_pay_stub_note','pay_period_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_pay_stub_note','staff_id',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_pay_stub_note',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'entry_id' => array('type' => 'int','precision' => '4'),
				'note' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array(),
			'fk' => array('pay_period_id' => 'perp_pay_stub.pay_stub_id','staff_id' => 'perp_staff.staff_id','entry_id' => 'perp_pay_stub_entry.entry_id'),
			'ix' => array(array('pay_period_id','staff_id')),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.037';
	}


	$test[] = '0.0.037';
	function perp_payroll_upgrade0_0_037()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_amendment',array(
			'fd' => array(
				'amendment_id' => array('type' => 'auto'),
				'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'pay_period_id' => array('type' => 'int','precision' => '4'),
				'type_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
				'description' => array('type' => 'varchar','precision' => '255')
			),
			'pk' => array('amendment_id'),
			'fk' => array('staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.038';
	}


	$test[] = '0.0.038';
	function perp_payroll_upgrade0_0_038()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_accrual_type','draw_type',array(
			'type' => 'int',
			'precision' => '4',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_accrual_type',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0'),
				'minimum' => array('type' => 'decimal','precision' => '20','scale' => '3','default' => '0'),
				'maximum' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'under_min' => array('type' => 'int','precision' => '4'),
				'over_max' => array('type' => 'int','precision' => '4'),
				'base_types' => array('type' => 'text','nullable' => False),
				'draw_type' => array('type' => 'int','precision' => '4','nullable' => False)
			),
			'pk' => array('type_id'),
			'fk' => array('type_id' => 'perp_pay_stub_entry_type.type_id','draw_type' => 'perp_pay_stub_entry_type.type_id'),
			'ix' => array('draw_type'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.039';
	}


	$test[] = '0.0.039';
	function perp_payroll_upgrade0_0_039()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_staff_pay_detail','effective_date',array(
			'type' => 'date'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_staff_pay_detail',array(
			'fd' => array(
				'staff_id' => array('type' => 'int','precision' => '4'),
				'type_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'pay_rate' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False),
				'pay_unit' => array('type' => 'varchar','precision' => '1','nullable' => False,'default' => 'h'),
				'effective_date' => array('type' => 'date')
			),
			'pk' => array('staff_id','effective_date'),
			'fk' => array('staff_id' => 'perp_staff.staff_id','type_id' => 'perp_earning_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.040';
	}


	$test[] = '0.0.040';
	function perp_payroll_upgrade0_0_040()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_payroll_ledger',array(
			'fd' => array(
				'transaction_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'staff_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'type_id' => array('type' => 'int','precision' => '4','nullable' => False),
				'date' => array('type' => 'timestamp','nullable' => False),
				'amount' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array(),
			'fk' => array('transaction_id' => 'perp_general_ledger.trans_no','staff_id' => 'perp_staff.staff_id','type_id' => 'perp_pay_stub_entry_type.type_id'),
			'ix' => array('staff_id','type_id'),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.041';
	}

	$test[] = '0.0.041';
	function perp_payroll_upgrade0_0_041() {
		$GLOBALS['egw_setup']->oProc->RenameTable('perp_staff_deduction', 'perp_staff_entry_type');
		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.042';
	}


	$test[] = '0.0.042';
	function perp_payroll_upgrade0_0_042()
	{
		$GLOBALS['egw_setup']->oProc->RenameColumn('perp_payroll_ledger','date','pay_period_id');
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payroll_ledger','transaction_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payroll_ledger','staff_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payroll_ledger','type_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payroll_ledger','pay_period_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_payroll_ledger','amount',array(
			'type' => 'decimal',
			'precision' => '20',
			'scale' => '3'
		));*/
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AddColumn('perp_payroll_ledger','entry_id',array(
			'type' => 'int',
			'precision' => '4'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_payroll_ledger',array(
			'fd' => array(
				'transaction_id' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4'),
				'type_id' => array('type' => 'int','precision' => '4'),
				'pay_period_id' => array('type' => 'int','precision' => '4'),
				'amount' => array('type' => 'decimal','precision' => '20','scale' => '3'),
				'entry_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('transaction_id','staff_id','type_id','pay_period_id','entry_id'),
			'fk' => array('transaction_id' => 'perp_general_ledger.trans_no','staff_id' => 'perp_staff.staff_id','type_id' => 'perp_pay_stub_entry.type_id','pay_period_id' => 'perp_pay_stub_entry.pay_period_id','entry_id' => 'perp_pay_stub_entry.entry_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.043';
	}


	$test[] = '0.0.043';
	function perp_payroll_upgrade0_0_043()
	{
		$GLOBALS['egw_setup']->oProc->CreateTable('perp_pay_period_staff',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'int','precision' => '4'),
				'staff_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('pay_period_id','staff_id'),
			'fk' => array('pay_period_id' => 'perp_pay_period.pay_period_id','staff_id' => 'perp_staff.staff_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.044';
	}


	$test[] = '0.0.044';
	function perp_payroll_upgrade0_0_044()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_pay_period','pay_period_id',array(
			'type' => 'auto',
			'nullable' => False
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_pay_period',array(
			'fd' => array(
				'pay_period_id' => array('type' => 'auto','nullable' => False),
				'start_date' => array('type' => 'date','nullable' => False),
				'end_date' => array('type' => 'date','nullable' => False),
				'transaction_date' => array('type' => 'date','nullable' => False),
				'transaction_id' => array('type' => 'int','precision' => '4')
			),
			'pk' => array('pay_period_id'),
			'fk' => array('transaction_id' => 'perp_general_ledger.trans_id'),
			'ix' => array(array('start_date','end_date')),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.0.045';
	}

	
	$test[] = '0.0.045';
	function perp_payroll_upgrade0_0_045()
	{
		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.1.00';
	}


	$test[] = '0.1.00';
	function perp_payroll_upgrade0_1_00()
	{
		/* done by RefreshTable() anyway
		$GLOBALS['egw_setup']->oProc->AlterColumn('perp_accrual_breakpoint','service_units',array(
			'type' => 'char',
			'precision' => '1'
		));*/
		$GLOBALS['egw_setup']->oProc->RefreshTable('perp_accrual_breakpoint',array(
			'fd' => array(
				'type_id' => array('type' => 'int','precision' => '4'),
				'service_length' => array('type' => 'int','precision' => '4'),
				'service_units' => array('type' => 'char','precision' => '1'),
				'rate' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
			),
			'pk' => array('type_id','service_length','service_units'),
			'fk' => array('type_id' => 'perp_accrual_type.type_id'),
			'ix' => array(),
			'uc' => array()
		));

		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.1.001';
	}

	$test[] = '0.1.001';
	function perp_payroll_upgrade0_1_001()
	{
		if($GLOBALS['egw_setup']->oProc->m_odb->Type == 'mysql') {
			// These tables need to be InnoDB
			$transaction_tables = array(
				'perp_earning_type',
				'perp_staff_pay_detail',
				'perp_pay_period',
				'perp_pay_stub',
				'perp_pay_stub_note',
				'perp_pay_stub_entry',
				'perp_pay_stub_entry_type',
				'perp_pay_type_ytd',
				'perp_deduction_type',
				'perp_staff_entry_type',
				'perp_accrual_type',
				'perp_accrual_breakpoint',
				'perp_staff_accrual',
				'perp_pay_schedule',
				'perp_income_tax_rate',
				'perp_pay_amendment',
				'perp_payroll_ledger',
				'perp_pay_period_staff'
			);
			$so_perp_api = CreateObject('perp_api.so_perp_api');
			$so_perp_api->change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_payroll', $transaction_tables);
		}
		return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.2';
	}

// Force tables to InnoDB
so_perp_api::change_table_engine($GLOBALS['egw_setup']->oProc, 'perp_payroll');


function perp_payroll_upgrade0_2()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_pay_period','reverted_id',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_pay_period',array(
		'fd' => array(
			'pay_period_id' => array('type' => 'auto','nullable' => False),
			'start_date' => array('type' => 'date','nullable' => False),
			'end_date' => array('type' => 'date','nullable' => False),
			'transaction_date' => array('type' => 'date','nullable' => False),
			'transaction_id' => array('type' => 'int','precision' => '4'),
			'reverted_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('pay_period_id'),
		'fk' => array('transaction_id' => 'perp_general_ledger.trans_id','reverted_id' => 'perp_general_ledger.trans_id'),
		'ix' => array(array('start_date','end_date')),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.2.001';
}


function perp_payroll_upgrade0_2_001()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_pay_stub_entry_type','type_id',array(
		'type' => 'auto',
		'nullable' => False
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_pay_stub_entry_type','disabled',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '0'
	));

	return $GLOBALS['setup_info']['perp_payroll']['currentver'] = '0.2.002';
}

