<?php
	/**
	* @class ui_perp_setup_wizard
	* @brief pERP Setup Wizard extends Wizard. This application is used for a new perp install. It guides user/users to enter in the correct
	* required data for a running instance of pERP
	* @author John Trudel
	* @version 1.0
	* @date September 2008
	* @extends ui_wizard 
	*/
	
	require_once(EGW_INCLUDE_ROOT . '/wizard/inc/class.ui_wizard.inc.php');
	
	class ui_perp_setup_wizard extends ui_wizard {
		
		//variable for pre steps
		private $pre_steps = true;
		
		public function ui_perp_setup_wizard() {
			
			
			$this->wizard_title = 'Perp Setup';
			$this->wizard_app_name = $GLOBALS['egw_info']['flags']['currentapp'];
			$this->wizard_class_name = get_class($this);
			
			$this->steps_dir = EGW_INCLUDE_ROOT.'/'.$this->wizard_app_name.'/inc/steps/';
			
			if($this->debug){
				echo '<br />--BEGIN "ui_perp_setup_wizard" debug--<br /><br />';
				echo 'wizard_title:';
				_debug_array($this->wizard_title);
				echo '<br />';
				echo 'wizard_app_name:';
				_debug_array($this->wizard_app_name);
				echo '<br />';				
				echo 'steps_dir:';
				_debug_array($this->steps_dir);
				echo '<br />';
				echo 'pre_steps on?: ';
				$this->pre_steps?_debug_array('turned on'):_debug_array('turned off');
				echo '<br />';
			}
			//begin code block - if pre_steps is true, it will continue to check if they are finished and set the session to boolean
			//$wizard_config = config::read($this->wizard_app_name);
			//_debug_array($wizard_config['question_answers']);
			
			if($this->pre_steps){
				$perp_setup_wizard_config = config::read($this->wizard_app_name);
				$is_pre_steps_finished = $perp_setup_wizard_config['is_pre_steps_finished'];
				if($is_pre_steps_finished){
					$this->pre_steps=false;
					config::save_value('is_sidebox',true,'wizard');					
				}else{
					$this->pre_steps=true;
					config::save_value('is_sidebox',false,'wizard');
				}
			}
			$GLOBALS['egw']->session->appsession('is_pre_step', $data['wizard_app_name'], $this->pre_steps);
			//end of code block
			
			if($this->debug){
				echo 'pre_steps done?: ';
				$this->pre_steps?_debug_array('still going'):_debug_array('finished');
				echo '<br />--END "ui_perp_setup_wizard" debug--<br /><br />';
			}
						
			parent::__construct();
			
		}
		
		public function index($content = array()) {
						
			$data = $content;
			//$data['wizard_app_name'] = $this->wizard_app_name;
			
			$this->build_permissions();
			$this->wizard_index($data);			
		}
		
	}
?>