<?php
	/**
	* @brief pERP Setup Wizard hook_topmenu_info.inc.php is ran before the application and also outside of the application. it is use to keep
	* track of the progress of the wizard while not using it. Its main function is to initialize the pERP Setup Wizard blinker.
	* @author John Trudel
	* @version 1.0
	* @date September 2008
	*/
	
	//Pre Application Configuration Calls
	require_once(EGW_INCLUDE_ROOT . '/wizard/inc/class.ui_wizard.inc.php');
	$debug = false;
	$data = array();
	
	$data['wizard_app_name'] = 'perp_setup_wizard';
	$data['steps_dir'] = EGW_INCLUDE_ROOT.'/'.$data['wizard_app_name'].'/inc/steps/';
	$data['post'] = $_POST;
	
	// calls the apropriate complete_step function by in the step that is stored in the current_working_step session
	ui_wizard::complete_step($data);
	
	
	$data['all_steps'] = ui_wizard::get_steps_list($data);
	if($debug){
		echo '<br />--BEGIN "hook_topmenu_info.inc.php" debug--<br /><br />';
		echo 'all_steps:';
		_debug_array($data['all_steps']);
		echo '<br />:';
	}
	
	//$data['first_step']  = '_1_1_unit_of_measure';
	$data['first_step']  = '_0_1_question_one';
	if($debug){
		echo 'first_step:';
		_debug_array($data['first_step']);
		echo '<br />:';
	}
	
	//returns the next step number
	$next_step = ui_wizard::generate_next_step($data);
	if($debug){
		echo 'next step number:';
		_debug_array($next_step);
		echo '<br />:';
	}
	
	//wizard_icon url
	$data['wizard_icon'] = $GLOBALS['egw']->common->image('perp_setup_wizard','perp_setup_wizard_icon_x16');
	if($debug){
		echo 'wizard_icon url:';
		_debug_array($data['wizard_icon']);
		echo '<br />:';
	}
	
	//begin code block - generate the link to the next step
	if($next_step == !null){
		$data['next_step_link'] = $GLOBALS['egw_info']['server']['webserver_url'].'/index.php?menuaction=perp_setup_wizard.ui_perp_setup_wizard.index&step='.$next_step;
	}else{
		$data['next_step_link'] = $GLOBALS['egw_info']['server']['webserver_url'].'/index.php?menuaction=perp_setup_wizard.ui_perp_setup_wizard.index';
	}
	if($debug){
		echo 'next_step_link:';
		_debug_array($data['next_step_link']);
		echo '<br />--END "hook_topmenu_info.inc.php" debug--<br /><br />';
	}
	//end code block
	
	$data['wizard_title'] = 'Perp Setup Wizard';
	
	ui_wizard::wizard_blink_method($data);

?>