<?php
	/**
	* @brief pERP Setup Wizard this class is used for a dashboard for the pERP Setup Wizard
	* @author John Trudel
	* @version 1.0
	* @date September 2008
	*/
	
	class _0_0_wizard {
		
		public function _0_0_wizard() {	
			$applications = array_keys($GLOBALS['egw_info']['user']['apps']);
			
			foreach($applications as $value){
				if(strstr( $value, 'perp' )){
					$perp_apps_installed[] = strstr( $value, 'perp' );
				}
				
			}
		}
		
		public function get_step_data($content = array(), &$data, &$select_box_options, &$readonly, &$preserve) {
			
			$steps_status = $GLOBALS['egw']->session->appsession('steps_status', $content['wizard_app_name']);
			$step_count = $GLOBALS['egw']->session->appsession('step_count', $content['wizard_app_name']);
			
			$data['template_name'] = 'perp_setup_wizard.generic_link_index';
			
			$data['decription_body'] = 'Main';	
						
			//setup section links//
			$section_links = $this->build_sections($content['all_steps'], $content['current_step'], $content['exploded_step']);
						
			//build html//			
			$links_status = $this->build_sections_html($section_links);
			$data['links_status'] = $links_status;		
		}
		
		public function build_sections($all_steps, $current_step, $class_exploded) {
			
			$steps_status = $GLOBALS['egw']->session->appsession('steps_status', 'perp_setup_wizard');
			$permissions = $GLOBALS['egw']->session->appsession('permissions', 'perp_setup_wizard');
			
			for ($i = 1; $i <= count($all_steps); $i++) {								
				$class_exploded = explode("_",$all_steps[$i]);				
			 	if(($class_exploded[1]) != 0){
					if(($class_exploded[2]) == 0){
						for ($t = 1; $t <= count($all_steps); $t++) {								
							$class_exploded_inner = explode("_",$all_steps[$t]);
							if($class_exploded_inner[1] == $class_exploded[1]){
								unset($step);
								if($class_exploded_inner[2] == 0){
									$step['step_header'] = $all_steps[$t];
								}elseif($class_exploded_inner[2] > 0){
									$step['step_name'] =$all_steps[$t];
									$step['status'] = isset($steps_status[$step['step_name']])?'finish':'start';
									$step['permission'] = $permissions[$step['step_name']]['perms'];
									$step['tooltip'] = isset($permissions[$step['step_name']]['reasons'][0])?lang($permissions[$step['step_name']]['reasons'][0]):lang($step['step_name']);
									$step['step_name'] =lang($step['step_name']);
								}
								if($step['permission']){
									$step['link'] = $t;
								}
								$section[] = $step;
							}							
						}						
						$sections[] = $section;
						$section = array();						
			 		}	
			 	}				
			}
			array_unshift($sections,false);
			unset($sections[0]);
			return $sections;
		}
		
		public function build_sections_html($section_links) {
					
			foreach($section_links as $key => $value){
				$count = 1;
				foreach($value as $key => $value){
					$count++;
				}
				$count_steps[] = $count;
			}
			$box_size = max($count_steps)*1.7;
			
			$html = '<!-- BEGIN eTemplate perp_setup_wizard.generic_link_section_block -->';
			
			foreach($section_links as $key => $value){
				$html .= '	<!-- BEGIN section  -->
							<div class="section_background" style="float:left;height:'.$box_size.'em;">
							
							<!-- BEGIN list  -->
							<span class="section_heading">'.lang($value[0]['step_header']).'</span>
							<ul class="section_step">';
							foreach($value as $key => $value){
									if($key == 0){
														
									}elseif($key != 0){
										$front_of_link = $value['permission']?'<a href="'.$GLOBALS['egw']->link('/index.php', array('menuaction' => 'perp_setup_wizard.ui_perp_setup_wizard.index','step'=>$value['link'])).'" title="'.$value['tooltip'].'" >':' ';
										$back_of_link = $value['permission']?'</a>':'';
										$html .= '<li type="'.$value['status'].'">'.$front_of_link.'<span id="1[step_name]" title="'.$value['tooltip'].'">'.$value['step_name'].'</span>'.$back_of_link.'</li>';						
									}
									
								}							
				$html .= '</ul></div><!-- END section  -->';
				
			}
			$html .= '<!-- END eTemplate perp_setup_wizard.generic_link_section_block -->';
			
			return $html;
		}
				
	}
?>