<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_setup_wizard/inc/steps/class.question.inc.php');

	class _0_1_question_one extends question {
		
		protected $app = 'perp_api';
		
		//this array is the set of acl check it must pass to alloww the user to complete
		//protected $acls = array('step');
		
		//the protected variable $dependencies is the set of steps that this step needs completed to be able to work
		//protected $dependencies = array('step');
		
		public function _0_1_question_one() {
			parent::__construct();
		}
		
		/**
		*  get_step_data function
		*  
		* @param content the variables passed in from the wizard
		* @param data passed by reference from the wizard to pass in exec template call
		* @param select_box_options passed by reference from the wizard to pass in exec template call
		* @param readonly passed by reference from the wizard to pass in exec template call
		* @param preserve passed by reference from the wizard to pass in exec template call
		*/
		public function get_step_data($content = array(), &$data, &$select_box_options, &$readonly, &$preserve) {
			
			
			$perp_setup_wizard_config = config::read($content['wizard_app_name']);
			$question_answers = $perp_setup_wizard_config['question_answers'];
			if(isset($content['answers'])){
				$question_answers[$this->question_class_name] = $content['answers'];
				config::save_value('question_answers',$question_answers,$content['wizard_app_name']);
			}
						
			$data['template_name'] = 'perp_setup_wizard.questions.ques_combo_popup';
						
			$data['question'] = 'Do you already have your business in eGroupware Addressbook?';
			
			if($question_answers[$this->question_class_name] == 3){
				$data['button_label'] = 'Click here to add business address';
				$readonly['button'] = false;
			}
			if(!($question_answers[$this->question_class_name] == 2 || $question_answers[$this->question_class_name] == 3)){
				$data['right'] = '1rightarrow_grey.png';
				unset($data['step_forward']);
			}
			
			// Select box options
			$select_box_options['answers'] = array(1 => lang('--select--'), 2 => lang('Yes'), 3 => lang('No'));
			$data['answers'] = $question_answers[$this->question_class_name];
			
			$preserve['current_step'] = $content['current_step'];
		}
		
		/**
		*  get_permission function
		*  @brief this function is ran from wizards build_permissions function
		*  it calls the parent generic_step get_permission
		*/
		public function get_permission(){
			return parent::get_permission();		
		}
		
		/**
		*  complete_step function
		*  @brief this function is ran when it is the current working step in the session
		*  it determines if the step is complete from any location in eGroupware
		*  it is called from hook_topmenu_info
		*  @param content the variables passed in from the wizard
		*/
		public function complete_step($content){		
			
			parent::complete_step($content, $this->question_class_name);
						
		}
		
	}
?>