<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_setup_wizard/inc/steps/class.question.inc.php');

	class _0_6_question_six extends question {
		
		protected $app = 'perp_api';
		
		//this array is the set of acl check it must pass to alloww the user to complete
		//protected $acls = array('step');
		
		//the protected variable $dependencies is the set of steps that this step needs completed to be able to work
		//protected $dependencies = array('step');
		
		public function _0_6_question_six() {
			parent::__construct();
		}
		
		/**
		*  get_step_data function
		*  
		* @param content the variables passed in from the wizard
		* @param data passed by reference from the wizard to pass in exec template call
		* @param select_box_options passed by reference from the wizard to pass in exec template call
		* @param readonly passed by reference from the wizard to pass in exec template call
		* @param preserve passed by reference from the wizard to pass in exec template call
		*/
		public function get_step_data($content = array(), &$data, &$select_box_options, &$readonly, &$preserve) {			
		
			$data['template_name'] = 'perp_setup_wizard.questions.year_end';
			
			$perp_ledger_config = config::read('perp_ledger');
			$fiscal_year = $perp_ledger_config['next_year_end'];
			
			if(isset($content['next_year_end'])){
				$fiscal_year = $content['next_year_end'];
				config::save_value('next_year_end',$fiscal_year,'perp_ledger');
			}
			
			if(!$fiscal_year){
				$data['right'] = '1rightarrow_grey.png';
				unset($data['step_forward']);
			}
			
			$data['next_year_end'] = $fiscal_year;
			$preserve['current_step'] = $content['current_step'];			
		}
		
		/**
		*  get_permission function
		*  @brief this function is ran from wizards build_permissions function
		*  it calls the parent generic_step get_permission
		*/
		public function get_permission(){
			return parent::get_permission();		
		}
		
		/**
		*  complete_step function
		*  @brief this function is ran when it is the current working step in the session
		*  it determines if the step is complete from any location in eGroupware
		*  it is called from hook_topmenu_info
		*  @param content the variables passed in from the wizard
		*/
		public function complete_step($content){
			
			$perp_ledger_config = config::read('perp_ledger');
			$fiscal_year = $perp_ledger_config['next_year_end'];
			$perp_setup_wizard_config = config::read($content['wizard_app_name']);
			$steps_status_array = $perp_setup_wizard_config['steps_status'];
			
			if($fiscal_year != null){							
				$steps_status_array[$this->question_class_name] = 1;				
			}else{
				unset($steps_status_array[$this->question_class_name]);				
			}
			
			config::save_value('steps_status',$steps_status_array,$content['wizard_app_name']);
		}
		
	}
?>