<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_setup_wizard/inc/steps/class.question.inc.php');

	class _0_7_question_seven extends question {
		
		protected $app = 'perp_api';
		
		//this array is the set of acl check it must pass to alloww the user to complete
		//protected $acls = array('step');
		
		//the protected variable $dependencies is the set of steps that this step needs completed to be able to work
		//protected $dependencies = array('step');
		
		public function _0_7_question_seven() {
			parent::__construct();
		}
		
		/**
		*  get_step_data function
		*  
		* @param content the variables passed in from the wizard
		* @param data passed by reference from the wizard to pass in exec template call
		* @param select_box_options passed by reference from the wizard to pass in exec template call
		* @param readonly passed by reference from the wizard to pass in exec template call
		* @param preserve passed by reference from the wizard to pass in exec template call
		*/
		public function get_step_data($content = array(), &$data, &$select_box_options, &$readonly, &$preserve) {
			
			$perp_setup_wizard_config = config::read($content['wizard_app_name']);
			$question_answers = $perp_setup_wizard_config['question_answers'];
			
			if(isset($content['manufacture'])){
				$answers['manufacture'] = $content['manufacture'];
				$question_answers[$this->question_class_name] = $answers;
			}
			if(isset($content['inventory'])){
				$answers['inventory'] = $content['inventory'];
				$question_answers[$this->question_class_name] = $answers;
			}
			if(isset($content['services'])){
				$answers['services'] = $content['services'];
				$question_answers[$this->question_class_name] = $answers;
			}
			config::save_value('question_answers',$question_answers,$content['wizard_app_name']);
						
			$data['template_name'] = 'perp_setup_wizard.questions.multi_ques';
						
			$data['question'] = 'Does your business manufacture goods?';
			
			if($question_answers[$this->question_class_name]['manufacture'] == 2){
				$data['questionthree'] = 'Does your business sell services as well?';
				$select_box_options['services'] = array(1 => lang('select'), 2 => lang('Yes'), 3 => lang('No'));
				$readonly['questionthree'] = false;
				$readonly['services'] = false;				
			}elseif($question_answers[$this->question_class_name]['manufacture'] == 3){
				$data['questiontwo'] = 'Does your business sell goods, either retail or wholesale, for which you must maintain an inventory or stock on hand?';
				$select_box_options['inventory'] = array(1 => lang('select'), 2 => lang('Yes'), 3 => lang('No'));
				$readonly['questiontwo'] = false;
				$readonly['inventory'] = false;
				
				if($question_answers[$this->question_class_name]['inventory'] == 2){
					$data['questionthree'] = 'Does your business sell services as well?';
					$select_box_options['services'] = array(1 => lang('--select--'), 2 => lang('Yes'), 3 => lang('No'));
					$readonly['questionthree'] = false;
					$readonly['services'] = false;
				}
				if($question_answers[$this->question_class_name]['inventory'] == 3){
					$data['questionthree'] = 'Does your business sell services?';
					$select_box_options['services'] = array(1 => lang('--select--'), 2 => lang('Yes'), 3 => lang('No'));
					$readonly['questionthree'] = false;
					$readonly['services'] = false;	
					
					if($question_answers[$this->question_class_name]['services'] == 3){
						
						//types of messages ('success', 'info', 'warning', 'error')
						$this->messages[] = array(lang('Your answers suggest that you have no need to use Perp. In order to run a business you need to Manufacture or hold Inventory, if not you need to at least provide Services'), 'warning');
						if(count($this->messages)) {
							$data['message'] = ExecMethod('perp_api.ui_perp_api.make_message', $this->messages);
						}
						
						$readonly['message'] = false;
						//_debug_array('are you crazy');
					}	
				}
			}
			
			$sequence = $question_answers[$this->question_class_name]['manufacture'].$question_answers[$this->question_class_name]['inventory'].$question_answers[$this->question_class_name]['services'];
			$continue_to = $content['wizard_app_name'].'.ui_perp_setup_wizard.index';
			
			switch ($sequence) {
			case 22:
			    //manufacture - inventory - services
			    $data['step_forward'] = $continue_to;
				$data['right'] = '1rightarrow.png';
				break;
			case 23:
			   //manufacture - inventory
			    $data['step_forward'] = $continue_to;
				$data['right'] = '1rightarrow.png';
				break;
			case 322:
			    //inventory - services
			    $data['step_forward'] = $continue_to;
				$data['right'] = '1rightarrow.png';
				break;
			case 323:
			    //inventory
			    $data['step_forward'] = $continue_to;
				$data['right'] = '1rightarrow.png';
				break;
			case 332:
			    //services
			    $data['step_forward'] = $continue_to;
				$data['right'] = '1rightarrow.png';
				break;							
			}
			
			// Select box options
			$select_box_options['manufacture'] = array(1 => lang('select'), 2 => lang('Yes'), 3 => lang('No'));
			
			$data['manufacture'] = $question_answers[$this->question_class_name]['manufacture'];
			$data['inventory'] = $question_answers[$this->question_class_name]['inventory'];
			$data['services'] = $question_answers[$this->question_class_name]['services'];
			
			$preserve['current_step'] = $content['current_step'];
			
		}
		
		/**
		*  get_permission function
		*  @brief this function is ran from wizards build_permissions function
		*  it calls the parent generic_step get_permission
		*/
		public function get_permission(){
			return parent::get_permission();		
		}
		
		/**
		*  complete_step function
		*  @brief this function is ran when it is the current working step in the session
		*  it determines if the step is complete from any location in eGroupware
		*  it is called from hook_topmenu_info
		*  @param content the variables passed in from the wizard
		*/
		public function complete_step($content){
						
			$perp_setup_wizard_config = config::read($content['wizard_app_name']);
			$question_answers = $perp_setup_wizard_config['question_answers'];
			$perp_setup_wizard_config = config::read($content['wizard_app_name']);
			$steps_status_array = $perp_setup_wizard_config['steps_status'];
						
			$sequence = $question_answers[$this->question_class_name]['manufacture'].$question_answers[$this->question_class_name]['inventory'].$question_answers[$this->question_class_name]['services'];
						
			$continue_to = $this->wizard_app_name.'.'.$this->wizard_class_name.'.index';
			
			switch ($sequence) {
			case 22:
			    //manufacture - inventory - services
				$steps_status_array[$this->question_class_name] = 1;
				$finished = true;
				break;
			case 23:
			   //manufacture - inventory
			   $steps_status_array[$this->question_class_name] = 1;
			   $finished = true;
				break;
			case 322:
			    //inventory - services
				$steps_status_array[$this->question_class_name] = 1;
				$finished = true;
				break;
			case 323:
			    //inventory
				$steps_status_array[$this->question_class_name] = 1;
				$finished = true;
				break;
			case 332:
			    //services
				$steps_status_array[$this->question_class_name] = 1;
				$finished = true;
				break;
			case 333:
			    //nothing - stop using perp
				unset($steps_status_array[$this->question_class_name]);
				$finished = false;
			    break;
			default:
				unset($steps_status_array[$this->question_class_name]);
				$finished = false;
				
			}
			
			if($finished){
				$steps_status_array[$this->question_class_name] = 1;
				config::save_value('is_pre_steps_finished',true,$content['wizard_app_name']);
			}else{
				unset($steps_status_array[$this->question_class_name]);
				config::save_value('is_pre_steps_finished',false,$content['wizard_app_name']);
			}
			config::save_value('steps_status',$steps_status_array,$content['wizard_app_name']);
			
			
		}
		
	}
?>