<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_setup_wizard/inc/steps/class.perp_setup_step.inc.php');

	class _3_6_tax_rates extends perp_setup_step {
		
		protected $app = 'perp_api';
		
		//this array is the set of acl check it must pass to alloww the user to complete
		protected $acls = array('tax_auth_rate');
		
		//the protected variable $dependencies is the set of steps that this step needs completed to be able to work
		//protected $dependencies = array('step_one');
		
		public function _3_6_tax_rates() {
			parent::__construct();
		}
		
		/**
		*  get_step_data function
		*  
		* @param content the variables passed in from the wizard
		* @param data passed by reference from the wizard to pass in exec template call
		* @param select_box_options passed by reference from the wizard to pass in exec template call
		* @param readonly passed by reference from the wizard to pass in exec template call
		* @param preserve passed by reference from the wizard to pass in exec template call
		*/
		public function get_step_data($content = array(), &$data, &$select_box_options, &$readonly, &$preserve) {
			
			$data['step_name'] = $this->step_name;			
			parent::get_step_data($content, $data, $step_data, $select_box_options, $readonly, $preserve);
			
			//step data
			$step_data['decription_body'] = lang('_3_6_tax_rates_description_body');
			$step_data['link_to_step'] = 'perp_api.hook_perp_api.tax_auth_rate';
			$data['step_data'] = $step_data;
			
		}
		
		/**
		*  get_permission function
		*  @brief this function is ran from wizards build_permissions function
		*  it calls the parent generic_step get_permission
		*/
		public function get_permission(){
			return parent::get_permission();		
		}
		
		/**
		*  complete_step function
		*  @brief this function is ran when it is the current working step in the session
		*  it determines if the step is complete from any location in eGroupware
		*  it is called from hook_topmenu_info
		*  @param content the variables passed in from the wizard
		*/
		public function complete_step($content){
			if(array_pop(split("[.]",$_SERVER["REQUEST_URI"])) == 'tax_auth_rate'){
				$data = $content;
				$data['step_name']	= $this->step_name;
				parent::complete_step($data);
			}		
		}		
		
	}
?>