<?php

	require_once(EGW_INCLUDE_ROOT . '/perp_payroll/inc/class.bo_perp_payroll.inc.php');

	class hook_perp_timeclock {

		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
			'admin_hook'	=>	True,
		);

		var $appname = 'perp_timeclock';
		private $erp;
		public function __construct() {
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file = array(
				'Site configuration'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_timeclock.hook_perp_timeclock.config',
				)),
				'Configure Access Permissions'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_timeclock.hook_perp_timeclock.acl',
				)),
			);

			display_section($this->appname, $file);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences']            = $GLOBALS['egw']->link('/preferences/preferences.php','appname='.$this->appname);

			//Do not modify below this line
			display_section($this->appname,$this->appname,$file);
		}

		public function user_preferences() {
		}

		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			$menu = array();
			if($GLOBALS['egw']->acl->check('stock', EGW_ACL_READ, 'perp_timeclock')) {
			//	$menu['Stock List']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_timeclock.ui_perp_stock.stock_list');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
				
			$menu_title = lang('Actions');
			$menu = array();
			if($GLOBALS['egw']->acl->check('inventory', EGW_ACL_EDIT, 'perp_timeclock')) {
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
		}

		public function config($content = array()) {
			$config = config::read($this->appname);
			$async_id = 'perp_timeclock.bo_perp_timesheet.import';

			if($content['settings']['cancel_timeclock_import']) {
				ExecMethod('phpgwapi.asyncservice.cancel_timer', $async_id);
				unset($content['settings']['cancel_timeclock_import']);
				$content['settings']['schedule_time'] = array();
				$content['save'] = true;
				$this->erp->messages[] = array(lang('Timeclock information will not be automatically imported'), 'success');
			} elseif(isset($content['settings']['timeclock_import'])) {
				$result = ExecMethod('perp_timeclock.bo_perp_timesheet.import', $config['timesheet_import_last_run'], time());
				if($result == true) {
					$this->erp->messages[] = array(lang('Timeclock information imported'), 'success');
				}
				if(is_array($result)) {
					if(!is_array($this->erp->messages)) {
						$this->erp->messages = array();
					}
					$this->erp->messages = array_merge($this->erp->messages, $result);
				}
			} elseif($content['settings']['schedule_time']) {
				foreach($content['settings']['schedule_time'] as $key => &$value) {
					if($value === '') {
						$value = '*';
					}
				}
				ExecMethod('phpgwapi.asyncservice.cancel_timer', $async_id);
				$result = ExecMethod2(
					'phpgwapi.asyncservice.set_timer', 
					$content['settings']['schedule_time'], 
					$async_id,
					'perp_timeclock.bo_perp_timesheet.import',
					false
				);
				$run = ExecMethod('phpgwapi.asyncservice.read', $async_id);
				if($run != false && ExecMethod('phpgwapi.asyncservice.installed') !== false) {
					$next_run = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'] . ' H:i', $run[$async_id]['next']);
					$this->erp->messages[] = array(
						lang('Timeclock information will be imported.  (Next update on %1)', 
							$next_run
						), 
						'success'
					);
				} else {
					$this->erp->messages[] = array(lang('Timeclock information will not be automatically imported'), 'warning');
				}
				// Don't store schedule in config, async has it
				unset($content['settings']['schedule_time']);
			}

			// Check some things that are going to be required for import
			$this->bo_payroll = new bo_perp_payroll();
			$this->bo_payroll->get_earning_types(array('template' => false), $time_categories);
			$regular_time = false;
			$over_time = false;

			if(is_array($time_categories)) {
				foreach($time_categories as $type) {
					if($type['pay_type'] == 'W' && $type['rate_multiplier'] == 1) {
						$regular_time = $no_regular_time || true;
					} elseif($type['pay_type'] == 'W' && $type['rate_multiplier'] > 1) {
						$over_time = $over_time || true;
					}
				}
			}
			if(!$regular_time) {
				$this->erp->messages[] = array(lang('You have no earning types set up as wage, regular time.  Create earning types in Admin -> Payroll.'), 'error');
			} 
			if(!$over_time) {
				$this->erp->messages[] = array(lang('You have no earning types set up as wage, overtime.  Create earning types in Admin -> Payroll.'), 'error');
			}

			// Check staff_id custom field on timesheet
			$config = config::get_customfields('timesheet');
			if(!$config['staff_id']) {
				$this->erp->messages[] = array(lang('Missing TimeSheet custom field "staff_id".  Please create it in Admin -> TimeSheet -> Custom Fields.  The Type should be "Human Resources"'), 'error');
			}

			// Load scheduled time from async
			$async = ExecMethod('phpgwapi.asyncservice.read', $async_id);
			$data['settings']['schedule_time'] = $async[$async_id]['times'];
			if(is_array($data['settings']['schedule_time'])) {
				foreach($data['settings']['schedule_time'] as $interval => &$value) {
					if(is_array($value)) {
						$value = implode(',', array_keys($value));
					}
				}
			}
			$selects['time_resolution'] = array(
				1	=>	1,
				5	=>	5,
				10	=>	10,
				15	=>	15,
				20	=>	20,
				30	=>	30,
				60	=>	60
			);

			$this->erp->config($content, $this->appname, 'perp_timeclock.hook_perp_timeclock.config',$selects, '', $data);
		}

		public function acl($content = array()) {
			$data = $this->erp->acl($content, 'perp_timeclock', 'acl', 'acl', $selects, $filters);
		}
	}
?>
