<?php

	class so_perp_timecard {

		public function get_timestamps(&$query) {
			$where = array();
			if($query['user_id']) {
				$where[] = 'perp_timecard.account_id = ' . $query['user_id'];
			}
			if($query['start_date']) {
				$where[] = 'timestamp >= \'' . $GLOBALS['egw']->db->to_timestamp($query['start_date']). '\'';
			}
			if($query['end_date']) {
				$where[] = 'timestamp <= \'' . $GLOBALS['egw']->db->to_timestamp($query['end_date']) .'\'';
			}
			if($query['department_id']) {
				if(is_array($query['department_id'])) {
					$where[] = 'department_id IN (' . implode(',',$query['department_id']) . ')';
				} else {
					$where[] = 'department_id = ' . $query['department_id'];
				}
			}

			$GLOBALS['egw']->db->select(
				'perp_timecard',
				array(
					'perp_timecard.account_id',
					'timestamp'
				),
				$where,
				__LINE__, __FILE__,$query['start'],
				'ORDER BY ' . $query['order'] . ' ' . $query['sort'],
				'perp_timeclock',
				$query['num_rows'],
				'JOIN perp_staff ON
					perp_staff.staff_id = perp_timecard.account_id'
			);
			$list = array();
			while($row = $GLOBALS['egw']->db->row(true)) {
				$row['timestamp'] = $GLOBALS['egw']->db->from_timestamp($row['timestamp']);
				$list[] = $row;
			}
			return $list;
		}

		public function timestamp($account_id) {
			$GLOBALS['egw']->db->insert(
				'perp_timecard',
				array(
					'account_id'	=>	$account_id,
					'timestamp'	=>	time()
				),
				array(),
				__LINE__, __FILE__,
				'perp_timeclock'
			);
			return true;
		}

		public function people_in_building(Array $query) {
			$sql = 'SELECT count(in_building) AS people_in_building
				FROM (
					SELECT 
						COUNT(account_id) % 2 AS in_building
					FROM perp_timecard
					GROUP BY account_id
				) as in_building
				WHERE in_building = 1';

			return $GLOBALS['egw']->db->query($sql, __LINE__,__FILE__)->fetchSingle();
		}
	}
?>
