<?php

	include_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_human_resources/inc/class.bo_perp_staff.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_human_resources/inc/class.bo_perp_department.inc.php');
	require_once(EGW_INCLUDE_ROOT . '/perp_timeclock/inc/class.bo_perp_timecard.inc.php');

	/**
	*	Shows a listing of timeclock punches.
	*/

	class time_report extends perp_report {

		public function __construct(array $parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_timeclock';
			parent::perp_report($parameters);
			$this->template = 'time_report.ods';

			$this->parameters = $parameters;
			if(!$this->parameters['start_date']) {
				$this->parameters['start_date'] = strtotime('-1 week', strtotime('last Monday'));
				$this->parameters['end_date'] = strtotime('last Sunday');
			}
			$this->parameters['options-department_id'] = ExecMethod('perp_human_resources.bo_perp_department.get_department_list');
			$this->parameters['max_per_day'] = 8.5;
		}

		public function get_data($query = array()) {
			$bo_staff = new bo_perp_staff();
			$bo_department = new bo_perp_department();
			$bo_timecard = new bo_perp_timecard();

			if(strpos($query['department_id'], ',') !== false) {
				$query['department_id'] = explode(',', $query['department_id']);
			}
			$staff_query = array(
				'template'	=>	false,
				'department_id'	=>	$query['department_id'],
				'order'		=>	'department_id',
			);
			$bo_staff->get_staff_list($staff_query, $staff_list);
		
			$timestamp_query = array(
				'start_date'	=>	$query['start_date'],
				'end_date'	=>	$query['end_date'],
				'department_id'	=>	$query['department_id'],
				'num_rows'	=>	-1,		// Get all rows
			);

			$valid_weeks = array();

			foreach($staff_list as &$staff) {
				$timestamp_query['staff_id'] = $staff['staff_id'];
				$department = $bo_department->get_department($staff['department_id']);
				$staff['department_name'] = $department['department_name'];
				$timecard = $bo_timecard->get_timestamps($timestamp_query);
				$dow = array();
				$week = array();

				foreach($timecard as $key => $timestamp) {
					$timestamp = $timestamp['timestamp'];
					$current_week	=	date('W', $timestamp);
					$current_dow	=	date('w', $timestamp);
					$valid_weeks[$current_week] = true;
					$dow[$current_dow] = array(
						'id'	=>	$current_dow,
						'name'	=>	date('l', $timestamp)
					);
					$staff[$current_week][$current_dow][]['timestamp'] = date('H:i', $timestamp);

					// Find the difference between two timestamps on the same day
					$next_timestamp = $timecard[$key + 1]['timestamp'];
					if ($staff[$current_week][$current_dow]['timestamp_count'] % 2 == 0 && date('w', $next_timestamp) == $current_dow) {
						$staff[$current_week][$current_dow]['total'] += ($next_timestamp - $timestamp);
						$hours = floor($staff[$current_week][$current_dow]['total'] / 3600);
						$minutes = floor(($staff[$current_week][$current_dow]['total'] - ($hours * 3600)) / 60);
						$staff[$current_week][$current_dow]['string_total'] = $hours . ':' . sprintf("%02s", $minutes);
					} elseif (($staff[$current_week][$current_dow]) % 2 == 0) {
					/*
					echo 'Not part of total:<br />';
					echo 'Key: ' . $key . ', ' . date('w', $next_timestamp) . ' != ' . $current_dow;
					echo date('l H:i', $timestamp) . ' - ' . date('l H:i',$next_timestamp) . '<br />';
					*/
					}
					$staff[$current_week][$current_dow]['timestamp_count']++;
				}
			}

			// Get weeks
			foreach($valid_weeks as $week_number => $garbage) {
				$week[] = array(
					'id'	=>	$week_number,
					'name'	=>	lang('Week %1', $week_number)
				);
			}

			$data = array(
				'level2'	=>	$dow,
				'level1'	=>	$week,
				'timecard'	=>	$report,
				'staff'		=>	$staff_list,
				'in_out'	=>	array(
					'in'	=>	lang('clock_in'),
					'out'	=>	lang('clock_out')
				),
				'start_date'	=>	date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $query['start_date']),
				'end_date'	=>	date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'], $query['end_date']),
				'max_per_day'	=>	$query['max_per_day'] / 24.0,
			);

			$this->filename = lang('Timeclock %1-%2', $data['start_date'], $data['end_date']);

			// Logo
			$config = config::read('perp_api');
			$data['images'] = array();
			$data['images'][] = array(
				'name'	=>	'company_logo',
			) + $config['company_logo'];

//_debug_array($data);
//die();
			return $data;
		}
	}
?>
