<?php

	/**
	*	Client claim
	*/
	
	require_once( EGW_INCLUDE_ROOT . '/perp_warranty/inc/class.Claim.inc.php');

	class ClientClaim extends Claim {

		/**
		*	See if we can tie this claim to one of our work orders
		*
		*	@return array with keys work_order_id & detail_id
		*/
		public function get_work_order_keys() {
			$parent = $this->get_parent();
			if($parent) {
				$components = $parent->get_components();
				$stock_id = $components[0]->get_stock_id();
				$stock_item = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $stock_id);
				if($stock_item['stock_type_flag'] == 'A') {
					// It's one of our assemblies.  Look for a work order...
					if($components[0]->get_serial_numbers()) {
						// Ok, serialized.  That was easy.
						$serial_numbers = $components[0]->get_serial_numbers();
						$serial_number = $serial_numbers[0]['serial_number'];

						// Look for a work order, it's best if we use its bill of materials
						$work_order_data = ExecMethod2('perp_manufacturing.bo_perp_work_order.get_by_serial_number', $stock_id, $serial_number);
						if($work_order_data) {
							$work_order_data = $work_order_data[0];
							$details = ExecMethod('perp_manufacturing.bo_perp_work_order.get_work_order_detail_list', $work_order_data);
							$work_order_data['detail_id'] = key($details);
							return $work_order_data;
						}
					} else {
						// Not so easy, we'll have to look for registration.  
						// Need to see what exactly the caller wants
echo __METHOD__ . ' not implemented. ' . __FILE__ . ':' . __LINE__ . '<br />';
					}
				} else {
					// No work order, it's not an assembly
					return false;
				}
			}
			return false;
		}
	}
?>
