<?php

	/**
	*	Ajax functions for RMAs
	*
	*	@package perp_warranty
	*	@author Nathan Gray
	*/

	require_once(EGW_API_INC.'/xajax.inc.php');

	class ajax_perp_rma {

		protected $response;

		public function __construct() {
			$this->response = new xajaxResponse();
		}

		/**
		*	When the user changes the stock code, change the unit of measure
		*/
		public function change_stock_code($stock_id) {
			$stock_item = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', (int)$stock_id);
			$uom = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures');
			$uom_location = etemplate::form_name($cname='exec', 'unit_of_measure');

			$unit_of_measure = '';
	
			$unit_of_measure = $uom[$stock_item['unit_of_measure']] ;
			/*	Supplier's UOM - need a supplier
				' ('  . ($item['conversion_factor'] * $item['quantity']) . ' ' . 
				$uom[$stock_item['unit_of_measure']] .
				' / ' . $uom[$item['supplier_uom']] . ')';
			*/

			// If controlled, show serial numbers button
			if($stock_item['controlled']) {
				$this->display_serial_button(true, ($stock_item['serial_setup'] != bo_perp_stock::SERIAL_WHEN_NEEDED));
			} else {
				$this->display_serial_button(false);
			}

			$this->response->addAssign($uom_location, 'innerHTML', $unit_of_measure);
			
			return $this->response->getXML();
		}

		protected function display_serial_button($display = true, $required = true) {
			$button = etemplate::form_name('exec', 'new[serial_number_button]');
			$this->response->addScript("document.getElementById('$button').parentNode.style.visibility = '" . ($display ? 'visible' : 'collapse') . "'");
			$this->response->addScript("document.getElementById('$button').parentNode.style.border = '" . ($required ? '1px solid red' : 'none') . "'");
		}
	}

?>
