<?php

	/**
	*	Warranty claims from clients
	*/

	require_once( EGW_INCLUDE_ROOT . '/perp_warranty/inc/class.bo_perp_claim.inc.php');
	
	require_once( EGW_INCLUDE_ROOT . '/perp_ar/inc/class.bo_perp_client_branch.inc.php');

	class bo_perp_client_claim extends bo_perp_claim {

		public static function set_claim($claim_id, $claim) {
			if(!$GLOBALS['egw']->acl->check('client', EGW_ACL_EDIT, 'perp_warranty')) {
				throw new egw_exception_no_permission();
			}

			// We're the supplier
			$claim['supplier_id'] = 0; 

			// Make sure there's a client
			if(!$claim['client_id']) {
				if($client_ids = ExecMethod('perp_ar.bo_perp_client.get_client_by_user_account')) {
					$claim['client_id'] = current($client_ids);
				}
			}
			
			parent::set_claim($claim_id, $claim);
		}

		public static function create_order(&$claim) {
			$order =& new SalesOrder();

			//Query the client branch list with client id filter
			$query = array(
				'client_id'     =>      $claim->get_client_id(),
			);
			$branch_list = ExecMethod('perp_ar.bo_perp_client_branch.get_client_branch_list', $query);
			$branch_id = key($branch_list);
			$order->set_client_branch_id($branch_id);

			$account_list = ExecMethod('perp_ar.bo_perp_client_account.get_client_account_list', $query);
			$order->set_client_account_id(key($account_list));

			// Set ship to
			$branch = ExecMethod('perp_ar.bo_perp_client_branch.get_client_branch', $branch_id);
			if($branch['delivery_address']) {
				$order->set_ship_to_address((int)$branch['delivery_address']);
			}
			
			// Let the parent do the work, most of it is common.
			$result = parent::create_order($claim, $order);

			if(is_numeric($result) ) {
				$order_id = (int)$result;
			} else {
throw new egw_exception($result);
				return $result;
			}

			// Link claim to order
			$link_id = 'CLAIM-' . $claim->get_claim_id();
			egw_link::link('perp_warranty', $link_id, 'perp_orders', 'ORDER-' . $order_id);

			return $order_id;
		}

		public static function &enter_credit(&$claim) {
			$invoice =& new ReceivableInvoice();

			//Query the account list with client id filter
			$query = array(
				'client_id'     =>      $claim->get_client_id(),
			);
			$account_list = ExecMethod('perp_ar.bo_perp_client_account.get_client_account_list', $query);
			$invoice->set_client_account_id(key($account_list));

			parent::enter_credit($claim, $invoice);

			// Return the invoice, not the invoice ID, we can redirect or save as desired from the UI
			return $invoice;
		}
	}
?>
