<?php

	class bo_perp_client_warranty {

		// eGW category object
		static $categories;

		public static function get_client_settings($client_id) {
			return so_perp_client_warranty::get_client_settings($client_id);
		}
		public static function set_client_settings($client_id, $settings) {
			if(!$settings['warranty_category']) {
				$settings['is_exception'] = true;
				$settings['name'] = ExecMethod('perp_ar.bo_perp_client.link_title', $client_id);
				unset($settings['id']);
			} else {
				$category = self::get_category($settings['warranty_category']);
				$settings['id'] = $settings['warranty_category'];
				if($category['is_exception']) {
					// Only change the settings if it's an exception, change the category otherwise
					$settings['id'] = self::set_category($settings);
				}
			}
			return so_perp_client_warranty::set_client_category($client_id, $settings['id']);
		}

		public function get_category_list($query = array(), &$rows = array(), &$readonly = array()) {
			if(!isset($query['template'])) {
				$query['num_rows'] = -1;
			}

			$query['order'] = $query['order'] ? $query['order'] : 'cat_id';
			$query['sort'] = $query['sort'] ? $query['sort'] : 'ASC';

			$list = so_perp_client_warranty::get_category_list($query);

			if(!isset($query['template'])) {
				$rows = array();
				foreach($list as $row) {
					$rows[$row['category_id']] = $row['name'];
				}
				return $rows;
			} else {
				$rows = $list;
				$rows['delete'] = $GLOBALS['egw']->acl->check('client', EGW_ACL_DELETE, 'perp_warranty');
				return $query['count'];
			}
		}

		/**
		*	Get a single category
		*	Includes eGroupWare category info
		*	@param category_id ID of the category to get
		*/
		public function get_category($category_id) {
			if(!is_object(self::$categories)) {
				self::$categories =& CreateObject('phpgwapi.categories', -1, 'perp_warranty');
			}

			$category = array();

			// Get eGW category data
			list($category) = self::$categories->return_single($category_id);
			$category['data'] = unserialize($category['data']);

			// Get list of parents, excluding this category
			$categories = self::get_category_list();
			unset($categories[$category_id]);
			$category['options-parent'] = $categories;

			// Get pERP category data
			$perp_category = so_perp_client_warranty::get_category($category_id);

			return $category + $perp_category;
		}

		/**
		*	Set a category
		*	This will also update the eGroupWare category
		*
		*	@param category array of category information
		*/
		public function set_category($category) {
			if(!is_object(self::$categories)) {
				self::$categories =& CreateObject('phpgwapi.categories', -1, 'perp_warranty');
			}
	
			// Update eGroupWare category
			$category['id'] = $category['id'];
			$category['data'] = serialize($category['data']);
			$category['descr'] = $category['description'];
			$category['access'] = 'public';
			if($category['id']) {
				$category['id'] = self::$categories->edit($category);
			} else {
				$category['id'] = self::$categories->add($category);
			}

			// Update pERP category
			so_perp_client_warranty::set_category($category);

			return $category['id'];
		}

		public function delete_category($category_id) {
			// Check that category is empty
			if(true) {
				return lang('Could not delete, some clients use this category (%1)', implode(', ', $use));
			}
			if(!is_object(self::$categories)) {
				self::$categories =& CreateObject('phpgwapi.categories', -1, 'perp_warranty');
			}
			$this->categories->delete($category_id);
			so_perp_client_warranty::delete_category($category_id);
		}
	}
?>
