<?php


	/**
	*	General functions for dealing with warranty
	*/
	class bo_perp_warranty {

		/**
		*	Get a string to refer to an entry.  
		*	Called as a hook to participate in linking system
		*
		*	@param entry A link key, in the form of SUBLOCATION-ID
		*
		*	@return String representation of the linked entry
		*/
		public static function link_title($entry) {
			list($location, $id) = explode('-', $entry, 2);
			switch($location) {
				case 'ISSUE':
					return bo_perp_issue::link_title($id);
					break;
				case 'CLAIM':
					return bo_perp_claim::link_title($id);
					break;
				case 'CLAIM_ISSUE':
					return bo_perp_claim_issue::link_title($id);
					break;
				case 'REGISTRATION':
					return bo_perp_registration::link_title($id);
					break;
				default:
					throw new egw_exception('Unrecognised link key: ' . $entry);
					break;
			}
		}

		/**
		*	Get a list of linkable entries matching the given pattern
		*
		*	Called as a hook to participate in the linking system
		*
		*	@param query String to search for
		*
		*	@return array with key=> title pairs
		*/
		public static function link_query($pattern) {
			$list = array();
			
			$list += bo_perp_issue::link_query($pattern);

			return $list;
		}

	}
?>
