<?php

	class hook_perp_warranty {

		var $public_functions = array(
			'sidebox'	=>	True,
			'config'	=>	True,
			'search_link'	=>	True,
			'acl'	=>	True,
			'home'	=>	True,
			'admin_hook'	=>	True,
		);

		var $appname = 'perp_warranty';
		private $erp;

		public function __construct() {
			$this->erp = CreateObject('perp_api.ui_perp_api');
		}

		/*
		*  List the entries in the Admin module for this app
		*/
		public function admin_hook() {
			$file = array(
				'Site configuration'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_warranty.hook_perp_warranty.config',
				)),
				'Configure Access Permissions'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_warranty.hook_perp_warranty.acl',
				)),
				'Client Categories'	=> $GLOBALS['egw']->link('/index.php', array(
					'menuaction'	=> 'perp_warranty.ui_perp_client_warranty.category_list',
				)),
			);

			display_section($this->appname, $file);
		}

		public function preference_menu() {
			$file = array();
			$file['Preferences']            = $GLOBALS['egw']->link('/preferences/preferences.php','appname='.$this->appname);

			//Do not modify below this line
			display_section($this->appname,$this->appname,$file);
		}

		public function user_preferences() {
		}

		public function sidebox() {
			// These get run through lang
			$menu_title = $GLOBALS['egw_info']['apps'][$this->appname]['title'] . ' ' . lang('Menu');
			$menu = array();
			if($GLOBALS['egw']->acl->check('issue', EGW_ACL_READ, 'perp_warranty')) {
				$menu['Issues']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_warranty.ui_perp_issue.issue_list');
			}
			if($GLOBALS['egw']->acl->check('claim', EGW_ACL_READ, 'perp_warranty')) {
				$menu['Claims']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_warranty.ui_perp_claim.claim_list');
			}
			if($GLOBALS['egw']->acl->check('rma', EGW_ACL_READ, 'perp_warranty')) {
				$menu['RMA']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_warranty.ui_perp_rma.rma_list');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
			
				
			$menu_title = lang('Actions');
			$menu = array();
			if($GLOBALS['egw']->acl->check('issue', EGW_ACL_READ, 'perp_inventory')) {
				$menu['New Issue']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_warranty.ui_perp_issue.new_issue');
			}
			if($GLOBALS['egw']->acl->check('claim', EGW_ACL_READ, 'perp_inventory')) {
				$menu['New Claim']	=	$GLOBALS['egw']->link('/index.php','menuaction=perp_warranty.ui_perp_claim.new_claim');
			}
			if(count($menu) > 0) {
				display_sidebox($this->appname, $menu_title, $menu);
			}
		}

		public function config($content = array()) {
			// validation & correction
			//...

			$config = config::read($this->appname);

			$selects['tracker_queue'] = ExecMethod('tracker.tracker_bo.get_tracker_labels', 'tracker');

			$this->erp->config($content, $this->appname, 'perp_warranty.hook_perp_warranty.config',$selects, '', $data);
		}

		public function acl($content = array()) {
			$data = $this->erp->acl($content, $this->appname, 'acl', 'acl', $selects, $filters);
		}

		public function home($args = null) {
		}

		/*	search_link is for linking (link widget)
		*/
		public function search_link($params) {

			return array(
				'query'	=>	'perp_warranty.bo_perp_warranty.link_query',
				'title'	=>	'perp_warranty.bo_perp_warranty.link_title',
				'view'	=>	array('menuaction'=>'perp_warranty.ui_perp_warranty.link_view'),
				'view_id'	=>	'link_id',
			);

		}

		/**
		*	Participate in invoicing
		*/
		public function invoicable () {
		}
	}
?>
