<?php

	class so_perp_client_warranty {

		// eGW category object
		static $categories;
		
		/**
		*	Get the settings for a particular client
		*/
		public static function get_client_settings($client_id) {
			$where = array(
				'client_id'	=>	(int)$client_id
			);
			$join = 'JOIN perp_warranty_client_category ON
				perp_warranty_client_category.id = perp_client_warranty_category.warranty_category_id';

			$row = $GLOBALS['egw']->db->select(
				'perp_client_warranty_category',
				array(
					'client_id',
					'id AS warranty_category',
				),
				$where,
				__LINE__, __FILE__, false, 
				'', 'perp_warranty', 1,
				$join
			)->fetch();
			if($row['warranty_category']) {
				$row += self::get_category($row['warranty_category']);
			}
	
			return $row;
		}

		public static function set_client_category($client_id, $cat_id) {

			// Remove old exception if not needed
			$current = self::get_client_settings($client_id);
			if($current['is_exception'] && $current['warranty_category'] != $cat_id) {
				// Skip the check on use
				if(!is_object(self::$categories)) {
					self::$categories =& CreateObject('phpgwapi.categories', -1, 'perp_warranty');
				}
				self::$categories->delete($category_id);
				self::delete_category($current['warranty_category']);
			}
				
			$GLOBALS['egw']->db->insert(
				'perp_client_warranty_category',
				array(
					'client_id'	=>	(int)$client_id,
					'warranty_category_id'	=>	(int)$cat_id
				),
				array(
					'client_id'	=>	(int)$client_id,
				),
				__LINE__, __FILE__, 'perp_warranty'
			);
		}

		public static function get_category_list(&$query) {
			$where = array(
				'cat_appname'	=>	'perp_warranty'
			);

			$join = 'LEFT JOIN perp_warranty_client_category ON
				perp_warranty_client_category.id = egw_categories.cat_id';

			if($query['category_id']) {
				$where['id'] = $query['category_id'];
			}
			if($query['parent']) {
				$where['cat_parent'] = $query['parent'];
			}
			if($query['include_exceptions']) {
				$join .= 'LEFT JOIN perp_client_warranty_category ON
				perp_client_warranty_category.warranty_category_id = perp_warranty_client_category.id';
			} else {
				$where[] = 'NOT is_exception';
			}

			$query['count'] = $GLOBALS['egw']->db->select(
				'egw_categories',
				array('count(cat_id) as count'),
				$where,
				__LINE__, __FILE__, 0,'', 
				'perp_warranty', 1, $join
			)->fetchSingle();

			$result =& $GLOBALS['egw']->db->select(
				'egw_categories',
				array(
					'cat_id AS category_id',
					'cat_parent',
					'cat_name AS name',
					'cat_description',
					'cat_data',
				),
				$where,
				__LINE__, __FILE__, $query['start'],
				"ORDER BY {$query['order']} {$query['sort']}",
				'perp_warranty', $query['num_rows'],
				$join
			);
			$list = array();
			foreach($result as $row) {
				$row['indent'] = str_repeat('&nbsp;', $row['level'] * 3);
				$row['indented_name'] = $row['indent'] . $row['name'];
				$row['data'] = unserialize($row['cat_data']);
				if($row['data']['color']) {
					$row['color'] = '<div style="width: 100%; height: 100%; background-color:' . $row['data']['color'] . ';">&nbsp;</div>';
				}
				$list[] = $row;
			}

			return $list;
		}

		public static function get_category($category_id) {
			$row = $GLOBALS['egw']->db->select('perp_warranty_client_category', 
				array('*'),
				array('id'	=>	$category_id),
				__LINE__, __FILE__
			)->fetchRow();

			// Reformat a little to make PDI able to be easily separated
			foreach($row as $key => $value) {
				$check = explode('_', $key, 2);
				if($check[0] == 'claim' || $check[0] == 'pdi') {
					$row[$check[0]][$check[1]] = $value;
					unset($row[$key]);
				}
			}
			return is_array($row) ? $row : array();
		}

		public static function set_category($category) {
			$GLOBALS['egw']->db->insert('perp_warranty_client_category',
				array(
					'id'			=>	$category['id'],
					'name'			=>	$category['name'],
					'travel_units'		=>	$category['travel_units'],

					'claim_time_rate'	=>	$category['claim']['time_rate'],
					'claim_travel_rate'	=>	$category['claim']['travel_rate'],
					'claim_credit_rate'	=>	$category['claim']['credit_rate'],
					'pdi_time_rate'		=>	$category['pdi']['time_rate'],
					'pdi_travel_rate'	=>	$category['pdi']['travel_rate'],
					'pdi_credit_rate'	=>	$category['pdi']['credit_rate'],

					'return_to_address'	=>	$category['return_to_address'],
					'is_exception'		=>	$category['is_exception'],
				),
				array('id' => $category['id']),
				__LINE__, __FILE__,
				'perp_warranty'
			);
		}	
		
		public static function delete_category($category_id) {
			$GLOBALS['egw']->db->delete('perp_warranty_client_category',
				array('id'	=>	$category_id),
				__LINE__, __FILE__,
				'perp_warranty'
			);
		}
	}
?>
