<?php

	/**
	*	Base UI for Warranty
	*	
	*	This class handles the application menu and redirects to different link sections
	*
	*	@author Nathan Gray
	*/

	require_once( EGW_INCLUDE_ROOT . '/etemplate/inc/class.etemplate.inc.php' );

	class ui_perp_warranty {

		// Functions we allow to be called directly by URL
		public $public_functions = array(
			'index'		=>	true,
			'link_view'	=>	true,
		);

		// eTemplate object used to generate pages
		public static $template;

		// Handy debug info
		public static $debug = false;

		/**
		*	Initialize static variables
		*/
		protected static function static_init() {
			self::$template = new etemplate();
		}

		/**
		*	Main index for warranty, provides links to the sub-locations like Issues, Claims, etc.
		*
		*	@param content Array returned from the eTemplate when the user submits the form
		*/
		public static function index($content = array()) {
			if(self::$debug) {
				echo __METHOD__ . ' incoming:<br />';
				_debug_array($content);
			}

			self::static_init();

			// Deal with incoming
			if(isset($content['issue_list'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_warranty.ui_perp_issue.issue_list'));
			} elseif (isset($content['registration'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_warranty.ui_perp_registration.registration_list'));
			} elseif (isset($content['claim_list'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_warranty.ui_perp_claim.claim_list'));
			} elseif (isset($content['rma_list'])) {
				$GLOBALS['egw']->redirect_link('/index.php', array('menuaction'=>'perp_warranty.ui_perp_rma.rma_list'));
			}
				
			// Set up outgoing
			$readonly = array(
				'issue_list'	=>	!$GLOBALS['egw']->acl->check('issue', EGW_ACL_READ, 'perp_warranty'),
				'registration'	=>	!$GLOBALS['egw']->acl->check('registration', EGW_ACL_READ, 'perp_warranty'),
				'claim_list'	=>	!$GLOBALS['egw']->acl->check('claim', EGW_ACL_READ, 'perp_warranty'),
				'rma_list'	=>	!$GLOBALS['egw']->acl->check('rma', EGW_ACL_READ, 'perp_warranty'),
			);

			// Display
			self::$template->read('perp_warranty.index');
			self::$template->exec('perp_warranty.ui_perp_warranty.index', $data, $select_box_options, $readonly, $preserve);
		}

		public static function link_view() {
			$link_id = $_GET['link_id'];
			list($location, $id) = explode('-', $link_id);

			switch($location) {
				case 'ISSUE':
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'    =>      'perp_warranty.ui_perp_issue.edit',
						'issue_id'      =>      $id
					));
					break;
				case 'CLAIM':
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'    =>      'perp_warranty.ui_perp_claim.edit',
						'claim_id'      =>      $id
					));
					break;
				case 'CLAIM_ISSUE':
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'    =>      'perp_warranty.ui_perp_claim_issue.edit',
						'claim_issue_id'      =>      $id
					));
					break;
				case 'REGISTRATION':
					$GLOBALS['egw']->redirect_link('/index.php', array(
						'menuaction'    =>      'perp_warranty.ui_perp_registration.edit',
						'registration_id'      =>      $id
					));
					break;
			}
		}

	}
?>
