<?php
	require_once(EGW_INCLUDE_ROOT . '/perp_api/inc/class.perp_report.inc.php');

	require_once(EGW_INCLUDE_ROOT . '/perp_warranty/inc/class.bo_perp_rma.inc.php');

	/**
	*	Return Materials Authorization form
	*
	*	@package perp_warranty
	*	@author Nathan Gray
	*/
	class rma_form extends perp_report {
		
		/**
		*	If the line has details, hide these details from the form
		*/
		private $hide_details = array(
		);

		// Cache
		private static $units_of_measure = array();

		public function __construct(Array &$parameters = array()) {
			$GLOBALS['egw_info']['flags']['currentapp'] = 'perp_warranty';

			// Default parameters
			
			parent::__construct($parameters);

			$this->template = 'rma_form.odt';

			// If rma_id is provided, just generate the report
                        if(reg_var('rma_id')) {
				$this->parameters['rma_id'] = reg_var('rma_id');
				$parameters['generate_report'] = true;
			}
		}

		public function get_data($query = array()) {
			if(!$query['rma_id']) {
				return false;
			}

			$config = config::read('perp_warranty');

			if(!is_array($query['rma_id'])) {
				$query['rma_id'] = explode(',', $query['rma_id']);
			}

			$data = array(
				'rma'		=>	array(),
			);
			
			foreach($query['rma_id'] as $rma_id) {
				self::get_rma($data, $rma_id);
			}

			// Logo
			$config = config::read('perp_api');
			$data['images'] = array();
			$data['images'][] = array(
				'name'	=>	'company_logo',
			) + $config['company_logo'];

			if(count($query['rma_id']) == 1) {
				$this->filename = ExecMethod('perp_warranty.bo_perp_rma.link_title', $query['rma_id']);
			} else {
				$this->filename = lang('Multiple RMAs');
			}

//_debug_array($data); die();
			return $data;
		}

		public static function get_rma(&$data, $rma_id) {
			if(!self::$units_of_measure) {
				self::$units_of_measure = ExecMethod('perp_api.bo_perp_api.get_unit_of_measures');
			}

			$rma = new RMA($rma_id);
			$rma_array = $rma->toArray();

			// TBSOOo, the template engine, has issues with multibyte characters
			$rma_array['our_reference_number'] = str_replace('◄', '', $rma_array['our_reference_number']);

			$rma_array['originating_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'] . ' H:i', $rma_array['originating_date']);
			if($rma_array['actual_delivery_date']) {
				$rma_array['actual_delivery_date'] = date($GLOBALS['egw_info']['user']['preferences']['common']['dateformat'] . ' H:i', $rma_array['actual_delivery_date']);
			}

			if(!$rma_array['claim_id']) {
				$rma_array['claim_number'] = ' ~ ' . lang('Non-warranty return') . ' ~';
			} else {
				$rma_array['claim_number'] = bo_perp_claim::link_title($rma_array['claim_id']);
			}

			$rma_array['ship_from'] = ExecMethod('addressbook.addressbook_bo.read', $rma->get_ship_from_address());
			$rma_array['ship_to'] = ExecMethod('addressbook.addressbook_bo.read', $rma->get_ship_to_address());

			// Build lines, put them where they need to be
			foreach($rma->get_lines() as $rma_line) {
				$line = $rma_line->toArray();
				$stock_item = ExecMethod('perp_inventory.bo_perp_stock.get_stock_item', $line['stock_id']);
				$line['stock_num'] = $stock_item['stock_num'];
				$line['description'] = $stock_item['short_description'];
				$line['unit_of_measure'] = self::$units_of_measure[$stock_item['unit_of_measure']];
				$line['quantity_authorized'] = round($line['quantity_ordered'], $stock_item['decimal_places']);

				$data[$rma_id . '_line'][] = $line;

				$data["{$rma_id}_{$line['line_number']}_detail"] = array();

				if($rma_line->get_details()) {
					// Only show serial numbers here
					foreach($rma_line->get_details('SerialNumberDetail') as $detail) {
						$data["{$rma_id}_{$line['line_number']}_detail"][] = array(
							'detail_name'	=>	lang($detail->get_name()),
							'detail_value'	=>	$detail->get_value()
						);
					}
				}

			}

			$data['rma'][] = $rma_array;
		}
	}
?>
