<?php
/**
 * eGroupWare - Setup
 * http://www.egroupware.org
 * Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package perp_warranty
 * @subpackage setup
 * @version $Id$
 */


$phpgw_baseline = array(
	'perp_warranty_issue' => array(
		'fd' => array(
			'issue_id' => array('type' => 'auto','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '50','nullable' => False),
			'description' => array('type' => 'varchar','precision' => '255','nullable' => False),
			'expected_time_claimed' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
			'coverage' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '0'),
			'coverage_limit' => array('type' => 'int','precision' => '4'),
			'credit_calculation' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('issue_id'),
		'fk' => array(),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_issue_stock_cat' => array(
		'fd' => array(
			'issue_id' => array('type' => 'int','precision' => '4'),
			'stock_category_id' => array('type' => 'int','precision' => '4'),
			'return_parts' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '2'),
			'replace_parts' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '2'),
			'retrofits_allowed' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
			'image_required' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '1'),
			'image_description' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('issue_id','stock_category_id'),
		'fk' => array('issue_id' => 'perp_warranty_issue.issue_id','stock_category_id' => 'egw_categories.cat_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_replacement_parts' => array(
		'fd' => array(
			'issue_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'replacement_id' => array('type' => 'int','precision' => '4'),
			'quantity' => array('type' => 'float','precision' => '20','scale' => '3','nullable' => False,'default' => '1')
		),
		'pk' => array('issue_id','stock_id','replacement_id'),
		'fk' => array('issue_id' => 'perp_warranty_issue.issue_id','stock_id' => 'perp_stock.stock_id','replacement_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_issue_exception' => array(
		'fd' => array(
			'base_issue_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'exception_issue_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'return_parts' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '1'),
			'replace_parts' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '1'),
			'retrofits_allowed' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '1'),
			'image_required' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '1'),
			'image_description' => array('type' => 'varchar','precision' => '255')
		),
		'pk' => array('base_issue_id','stock_id'),
		'fk' => array('base_issue_id' => 'perp_warranty_issue.issue_id','stock_id' => 'perp_stock.stock_id','exception_issue_id' => 'perp_warranty_issue.issue_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_client_category' => array(
		'fd' => array(
			'id' => array('type' => 'auto','nullable' => False),
			'name' => array('type' => 'varchar','precision' => '50'),
			'claim_time_rate' => array('type' => 'float','precision' => '8','scale' => '2','nullable' => False,'default' => '0'),
			'claim_travel_rate' => array('type' => 'float','precision' => '8','scale' => '2','nullable' => False,'default' => '0'),
			'travel_units' => array('type' => 'varchar','precision' => '2','nullable' => False,'default' => 'km'),
			'claim_credit_rate' => array('type' => 'float','precision' => '4','scale' => '2','nullable' => False,'default' => '1'),
			'pdi_time_rate' => array('type' => 'float','precision' => '8','scale' => '2','nullable' => False,'default' => '0'),
			'pdi_travel_rate' => array('type' => 'float','precision' => '8','scale' => '2','nullable' => False,'default' => '0'),
			'pdi_credit_rate' => array('type' => 'float','precision' => '4','scale' => '2','nullable' => False,'default' => '0'),
			'return_to_address' => array('type' => 'int','precision' => '4'),
			'is_exception' => array('type' => 'bool','nullable' => False,'default' => '0')
		),
		'pk' => array('id'),
		'fk' => array('return_to_address' => 'egw_addressbook.contact_id'),
		'ix' => array(),
		'uc' => array('name')
	),
	'perp_client_warranty_category' => array(
		'fd' => array(
			'client_id' => array('type' => 'int','precision' => '4'),
			'warranty_category_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('client_id','warranty_category_id'),
		'fk' => array('client_id' => 'perp_client.client_id','warranty_category_id' => 'perp_warranty_client_category'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_client_warranty_address' => array(
		'fd' => array(
			'client_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'return_to_address' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('client_id','stock_id','return_to_address'),
		'fk' => array('client_id' => 'perp_client.client_id','stock_id' => 'perp_stock.stock_id','return_to_address' => 'egw_addressbook.client_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_stock_warranty' => array(
		'fd' => array(
			'stock_id' => array('type' => 'int','precision' => '4'),
			'registration_required' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '1'),
			'registration_time_limit' => array('type' => 'int','precision' => '4','nullable' => False,'default' => '30'),
			'manufacturer_direct' => array('type' => 'bool','nullable' => False,'default' => '0'),
			'use_pdi' => array('type' => 'bool','nullable' => False,'default' => '1'),
			'lemon_alert_cost' => array('type' => 'float','precision' => '10','scale' => '2'),
			'lemon_alert_count' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('stock_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_registration' => array(
		'fd' => array(
			'registration_id' => array('type' => 'auto','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20'),
			'owner' => array('type' => 'int','precision' => '4'),
			'start_date' => array('type' => 'date','nullable' => False),
			'end_date' => array('type' => 'date'),
			'notes' => array('type' => 'varchar','precision' => '255'),
			'registered_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'registration_date' => array('type' => 'timestamp','nullable' => False),
			'client_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('registration_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id','serial_number' => 'perp_stock_serial.serial_number','owner' => 'perp_address.address_id','registered_by' => 'egw_accounts.account_id','client_id' => 'perp_client.client_id'),
		'ix' => array(),
		'uc' => array(array('stock_id','serial_number'))
	),
	'perp_rma' => array(
		'fd' => array(
			'rma_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'claim_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('rma_id'),
		'fk' => array('rma_id' => 'perp_order.order_id','claim_id' => 'perp_warranty_claim.claim_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_rma_line' => array(
		'fd' => array(
			'rma_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'quantity_authorized' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'quantity_received' => array('type' => 'decimal','precision' => '20','scale' => '3')
		),
		'pk' => array('rma_id','stock_id'),
		'fk' => array('rma_id' => 'perp_rma.rma_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_rma_serial_number' => array(
		'fd' => array(
			'rma_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'serial_number' => array('type' => 'varchar','precision' => '20'),
			'serial_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False)
		),
		'pk' => array('rma_id','stock_id','serial_number'),
		'fk' => array('rma_id' => 'perp_rma_line.rma_id','stock_id' => 'perp_rma_line.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_claim' => array(
		'fd' => array(
			'claim_id' => array('type' => 'auto','nullable' => False),
			'registration_id' => array('type' => 'int','precision' => '4'),
			'client_id' => array('type' => 'int','precision' => '4'),
			'supplier_id' => array('type' => 'int','precision' => '4'),
			'created_date' => array('type' => 'timestamp','nullable' => False),
			'claim_date' => array('type' => 'date','nullable' => False),
			'last_modified_date' => array('type' => 'timestamp','nullable' => False),
			'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'modified_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'time_claimed' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '0'),
			'travel_claimed' => array('type' => 'int','precision' => '2','nullable' => False,'default' => '0'),
			'description' => array('type' => 'text'),
			'technician' => array('type' => 'varchar','precision' => '255'),
			'replacement_order_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('claim_id'),
		'fk' => array('registration_id' => 'perp_warranty_registration.registration_id','client_id' => 'perp_client.client_id','supplier_id' => 'perp_supplier.supplier_id','created_by' => 'egw_accounts.account_id','modified_by' => 'egw_accounts.account_id','replacement_order_id' => 'perp_order.order_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_claim_issue' => array(
		'fd' => array(
			'claim_issue_id' => array('type' => 'auto','nullable' => False),
			'claim_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'issue_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'claim_amount' => array('type' => 'decimal','precision' => '20','scale' => '2','nullable' => False,'default' => '0')
		),
		'pk' => array('claim_issue_id'),
		'fk' => array('claim_id' => 'perp_warranty_claim.claim_id','issue_id' => 'perp_warranty_issue.issue_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_claim_component' => array(
		'fd' => array(
			'claim_issue_id' => array('type' => 'int','precision' => '4'),
			'component_id' => array('type' => 'int','precision' => '4'),
			'quantity_claimed' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'return_parts' => array('type' => 'int','precision' => '1','nullable' => False),
			'replace_parts' => array('type' => 'int','precision' => '1','nullable' => False),
			'retrofits_allowed' => array('type' => 'int','precision' => '1','nullable' => False),
			'image_required' => array('type' => 'int','precision' => '1','nullable' => False),
			'coverage' => array('type' => 'int','precision' => '1','nullable' => False),
			'credit' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '0')
		),
		'pk' => array('claim_issue_id','component_id'),
		'fk' => array('claim_issue_id' => 'perp_warranty_claim_issue.claim_issue_id','component_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_claim_replacement' => array(
		'fd' => array(
			'claim_issue_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'quantity_used' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'original_stock_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('claim_issue_id','stock_id','original_stock_id'),
		'fk' => array('claim_issue_id' => 'perp_warranty_claim_issue.claim_issue_id','stock_id' => 'perp_stock.stock_id','original_stock_id' => 'perp_warranty_claim_component.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_claim_serial' => array(
		'fd' => array(
			'claim_issue_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'serial_number' => array('type' => 'varchar','precision' => '20'),
			'serial_quantity' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False,'default' => '1'),
			'sent_or_received' => array('type' => 'int','precision' => '1','nullable' => False,'default' => '0')
		),
		'pk' => array('claim_issue_id','stock_id','serial_number'),
		'fk' => array('claim_issue_id' => 'perp_warranty_claim_issue.claim_issue_id','stock_id' => 'perp_stock.stock_id'),
		'ix' => array(),
		'uc' => array()
	),
	'perp_warranty_credit' => array(
		'fd' => array(
			'invoicable_id' => array('type' => 'auto','nullable' => False),
			'claim_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'claim_issue_id' => array('type' => 'int','precision' => '4'),
			'piece_key' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('invoicable_id'),
		'fk' => array('claim_id' => 'perp_warranty_claim.claim_id','claim_issue_id' => 'perp_warranty_claim_issue.claim_issue_id'),
		'ix' => array(),
		'uc' => array()
	)
);
