<?php
/**
 * eGroupWare - Setup
 * http://www.egroupware.org
 * Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package perp_warranty
 * @subpackage setup
 * @version $Id$
 */

function perp_warranty_upgrade0_1()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_warranty_claim','claim_date',array(
		'type' => 'timestamp',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.001';
}


function perp_warranty_upgrade0_1_001()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_warranty_claim','claim_date',array(
		'type' => 'date',
		'nullable' => False
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.002';
}


function perp_warranty_upgrade0_1_002()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_warranty_issue_exception','exception_issue_id',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_issue_exception','return_parts',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '1'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_issue_exception','replace_parts',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '1'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_issue_exception','retrofits_allowed',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '1'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_issue_exception','image_required',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '1'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_issue_exception','image_description',array(
		'type' => 'varchar',
		'precision' => '255'
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.003';
}


function perp_warranty_upgrade0_1_003()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_claim_component','return_parts',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_claim_component','replace_parts',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_claim_component','retrofits_allowed',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_claim_component','image_required',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_claim_component','coverage',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_claim_component','credit',array(
		'type' => 'decimal',
		'precision' => '20',
		'scale' => '3',
		'nullable' => False,
		'default' => '0'
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.004';
}


function perp_warranty_upgrade0_1_004()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_rma','claim_id',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_rma',array(
		'fd' => array(
			'rma_id' => array('type' => 'auto','nullable' => False),
			'rma_number' => array('type' => 'varchar','precision' => '20','nullable' => False),
			'created_date' => array('type' => 'timestamp','nullable' => False),
			'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'closed_date' => array('type' => 'timestamp'),
			'claim_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('rma_id'),
		'fk' => array('created_by' => 'egw_accounts.account_id','claim_id' => 'perp_warranty_claim.claim_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.005';
}


function perp_warranty_upgrade0_1_005()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_claim_replacement','original_stock_id',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_warranty_claim_replacement',array(
		'fd' => array(
			'claim_issue_id' => array('type' => 'int','precision' => '4'),
			'stock_id' => array('type' => 'int','precision' => '4'),
			'quantity_used' => array('type' => 'decimal','precision' => '20','scale' => '3','nullable' => False),
			'original_stock_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('claim_issue_id','stock_id','original_stock_id'),
		'fk' => array('claim_issue_id' => 'perp_warranty_claim_issue.claim_issue_id','stock_id' => 'perp_stock.stock_id','original_stock_id' => 'perp_warranty_claim_component.stock_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.006';
}


function perp_warranty_upgrade0_1_006()
{
	$GLOBALS['egw_setup']->oProc->RenameColumn('perp_warranty_client_category','credit_rate','claim_credit_rate');

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.007';
}


function perp_warranty_upgrade0_1_007()
{
	$GLOBALS['egw_setup']->oProc->CreateTable('perp_warranty_credit',array(
		'fd' => array(
			'invoicable_id' => array('type' => 'auto','nullable' => False),
			'claim_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'claim_issue_id' => array('type' => 'int','precision' => '4'),
			'piece_key' => array('type' => 'int','precision' => '4','nullable' => False)
		),
		'pk' => array('invoicable_id'),
		'fk' => array('claim_id' => 'perp_warranty_claim.claim_id','claim_issue_id' => 'perp_warranty_claim_issue.claim_issue_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.008';
}


function perp_warranty_upgrade0_1_008()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_registration','registered_by',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False
	));*/
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_registration','registration_date',array(
		'type' => 'timestamp',
		'nullable' => False
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_warranty_registration',array(
		'fd' => array(
			'registration_id' => array('type' => 'auto','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20'),
			'owner' => array('type' => 'int','precision' => '4'),
			'start_date' => array('type' => 'date','nullable' => False),
			'end_date' => array('type' => 'date','nullable' => False),
			'notes' => array('type' => 'varchar','precision' => '255'),
			'registered_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'registration_date' => array('type' => 'timestamp','nullable' => False)
		),
		'pk' => array('registration_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id','serial_number' => 'perp_stock_serial.serial_number','owner' => 'perp_address.address_id','registered_by' => 'egw_accounts.account_id'),
		'ix' => array(),
		'uc' => array(array('stock_id','serial_number'))
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.009';
}


function perp_warranty_upgrade0_1_009()
{
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AddColumn('perp_warranty_registration','client_id',array(
		'type' => 'int',
		'precision' => '4'
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_warranty_registration',array(
		'fd' => array(
			'registration_id' => array('type' => 'auto','nullable' => False),
			'stock_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'serial_number' => array('type' => 'varchar','precision' => '20'),
			'owner' => array('type' => 'int','precision' => '4'),
			'start_date' => array('type' => 'date','nullable' => False),
			'end_date' => array('type' => 'date','nullable' => False),
			'notes' => array('type' => 'varchar','precision' => '255'),
			'registered_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'registration_date' => array('type' => 'timestamp','nullable' => False),
			'client_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('registration_id'),
		'fk' => array('stock_id' => 'perp_stock.stock_id','serial_number' => 'perp_stock_serial.serial_number','owner' => 'perp_address.address_id','registered_by' => 'egw_accounts.account_id','client_id' => 'perp_client.client_id'),
		'ix' => array(),
		'uc' => array(array('stock_id','serial_number'))
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.010';
}


function perp_warranty_upgrade0_1_010()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_warranty_registration','end_date',array(
		'type' => 'date'
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.011';
}


function perp_warranty_upgrade0_1_011()
{
	$GLOBALS['egw_setup']->oProc->DropColumn('perp_rma',array(
		'fd' => array(
			'rma_id' => array('type' => 'auto','nullable' => False),
			'created_date' => array('type' => 'timestamp','nullable' => False),
			'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'closed_date' => array('type' => 'timestamp'),
			'claim_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('rma_id'),
		'fk' => array('created_by' => 'egw_accounts.account_id','claim_id' => 'perp_warranty_claim.claim_id'),
		'ix' => array(),
		'uc' => array()
	),'rma_number');
	$GLOBALS['egw_setup']->oProc->DropColumn('perp_rma',array(
		'fd' => array(
			'rma_id' => array('type' => 'auto','nullable' => False),
			'created_by' => array('type' => 'int','precision' => '4','nullable' => False),
			'closed_date' => array('type' => 'timestamp'),
			'claim_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('rma_id'),
		'fk' => array('created_by' => 'egw_accounts.account_id','claim_id' => 'perp_warranty_claim.claim_id'),
		'ix' => array(),
		'uc' => array()
	),'created_date');
	$GLOBALS['egw_setup']->oProc->DropColumn('perp_rma',array(
		'fd' => array(
			'rma_id' => array('type' => 'auto','nullable' => False),
			'closed_date' => array('type' => 'timestamp'),
			'claim_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('rma_id'),
		'fk' => array('created_by' => 'egw_accounts.account_id','claim_id' => 'perp_warranty_claim.claim_id'),
		'ix' => array(),
		'uc' => array()
	),'created_by');
	$GLOBALS['egw_setup']->oProc->DropColumn('perp_rma',array(
		'fd' => array(
			'rma_id' => array('type' => 'auto','nullable' => False),
			'claim_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('rma_id'),
		'fk' => array('created_by' => 'egw_accounts.account_id','claim_id' => 'perp_warranty_claim.claim_id'),
		'ix' => array(),
		'uc' => array()
	),'closed_date');
	/* done by RefreshTable() anyway
	$GLOBALS['egw_setup']->oProc->AlterColumn('perp_rma','rma_id',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False
	));*/
	$GLOBALS['egw_setup']->oProc->RefreshTable('perp_rma',array(
		'fd' => array(
			'rma_id' => array('type' => 'int','precision' => '4','nullable' => False),
			'claim_id' => array('type' => 'int','precision' => '4')
		),
		'pk' => array('rma_id'),
		'fk' => array('rma_id' => 'perp_order.order_id','claim_id' => 'perp_warranty_claim.claim_id'),
		'ix' => array(),
		'uc' => array()
	));

	return $GLOBALS['setup_info']['perp_warranty']['currentver'] = '0.1.012';
}

