<?php

	class hook_wizard {

		var $public_functions = array(
			'sidebox'	=>	True
		);

		var $appname = 'wizard';
		var $template;

		public function hook_wizard() {
			$this->template = CreateObject('etemplate.etemplate');
		}
		
		
		/**
	     * sidebox Method
	     * this function builds an array of links to steps in the current wizard in the eGroupwares sidebox
	     * the retrieves the steps from a session variable that was set in wizard_index of class.ui_wizard.inc
		 */
		public function sidebox() {
			$wizard_config = config::read('wizard');
			$is_sidebox = $wizard_config['is_sidebox'];
			if($is_sidebox){
				//create links for sidebox by using the session sent over by  the current wizard
				$steps = $GLOBALS['egw']->session->appsession('steps', $this->appname);
				for ($i = 1; $i <= count($steps); $i++) {
					$menu[] =& $this->build_sidebox_menu($steps[$i],$i);				
				}			 
				display_sidebox($GLOBALS['egw_info']['currentapp'], $menu_title, $menu);
			}			
			
		}		
		
		
		/**
	     * build_sidebox_menu Method
	     * this function creates each link for the steps to be placed in the eGroupware sidebox
		 * @param string $step is the step class name
		 * @param integer $i is an count integer
		 */
		public function build_sidebox_menu($step,$i){			
			
			$permissions = $GLOBALS['egw']->session->appsession('permissions', $GLOBALS['egw_info']['flags']['currentapp']);
						
			$class_exploded = explode("_",$step);
			$class = (($class_exploded[2]) == 0)?'step':'sub_step';
			
			if(($class_exploded[1]) != 0){
				if(($class_exploded[2]) != 0){
					if($permissions[$step]['perms']){
						$link = '<a class="textSidebox '.$class.'"href="'.$GLOBALS['egw']->link('/index.php', array('menuaction' => ''.$GLOBALS['egw_info']['flags']['currentapp'].'.ui_'.$GLOBALS['egw_info']['flags']['currentapp'].'.index','step'=>$i)).'">'.lang($step).'</a>';
					}else{
						$link = '<span title="'.lang($permissions[$step]['reasons'][0]).'"><a class="textSidebox '.$class.'">'.lang($step).'</a></span>';
					}
			
				}else{
					$link = '<a class="textSidebox '.$class.'"href="'.$GLOBALS['egw']->link('/index.php', array('menuaction' => ''.$GLOBALS['egw_info']['flags']['currentapp'].'.ui_'.$GLOBALS['egw_info']['flags']['currentapp'].'.index','step'=>$i)).'">'.lang($step).'</a>';
				}
			}
			else{
				$link = '<a class="textSidebox '.$class.'"href="'.$GLOBALS['egw']->link('/index.php', array('menuaction' => ''.$GLOBALS['egw_info']['flags']['currentapp'].'.ui_'.$GLOBALS['egw_info']['flags']['currentapp'].'.index','step'=>$i)).'">'.lang($step).'</a>';
			}
			
			return array(
			'text' => $link,
			'no_lang' => True,
			'link' => False,
			'icon' => False,
			);
		}
	}
	
?>
