<?php
/**************************************************************************\
* Wizard                                                 				   *
* http://www.projecterp.org                                                *
* Created by John Trudel @ Bluefalls                                       *
\**************************************************************************/
	class step {
		
		protected $app = '';		
		
		//this array is the set of acl check it must pass to allow the user to complete
		protected $acls = array();
		
		//the protected variable $dependencies is the set of steps that this step needs completed to be able to work
		protected $dependencies = array();
		
		public function __construct() {
			
		}
		
		/**
		*  Parent - get_step_data function
		*  
		*/
		public function get_step_data($content = array(), &$data, &$select_box_options, &$readonly, &$preserve) {
						
			//template to be used for this step
			$data['template_name'] = 'wizard.step';
			
			//step_data to be sent to embedded template
			$data['example_text'] = lang('Perp Setup Wizard Development - Steps');
			$data['link_to_docs'] = 'http://www.projecterp.org/mediawiki/index.php/Perp_Setup_Wizard_Development#Steps';
											
			//$preserve are the variables that need to be passed through on form submit
			$preserve['current_step'] = $content['current_step'];			
		}
		
		
		/**
		*  Parent - get_permission function
		*  
		*/
		public function get_permission(){			
			
			$step_permission = array();
			$step_permission['perms'] = true;
			//$step_permission['reasons'] = lang('permission_reason');\
			return $step_permission;			
		}		
				
		/**
		*  Parent - complete_step function
		*  
		*/
		public function complete_step($content){
			
			//read current wizard config 
			$current_wizard_config = config::read($content['wizard_app_name']);
			//set $step_status_array with values from perp_setup_config
			$steps_status_array = $current_wizard_config['steps_status'];
			//set $steps_status_array[$content['step_name']] as 1 for true to show the step has been finished
			$steps_status_array[$content['step_name']] = 1;
			//save the $steps_status_array back to the current wizard config 
			config::save_value('steps_status',$steps_status_array,$content['wizard_app_name']);		
						
		}
		
			
	}
?>
